(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)















Options[turtleInterpretation] :=
{
  Iterations -> 1,
  StartPosition -> {0.,0.,0.},
  StartDirection -> Transpose[{{0,0,1},{1,0,0},{0,-1,0}}],
  
  GravityDirection -> {0.,0.,-1.},
  
  StepVariance -> 0.,
  AngleVariance -> 0.,
  LineThickness -> 0.014,
  LineHue -> 0.3,
  
  MaxNumberOfPaths -> 400,
  MaxPathLength -> 200,
  
  InterpretationTable ->
    {
      AXIOM -> List,
      
      FO -> forward,
      BA -> back,
      
      YL -> yawLeft,
      YR -> yawRight,
      
      PD -> pitchDown,
      PU -> pitchUp,
      
      RL -> rollLeft,
      RR -> rollRight,
      
      RV -> orientateToVertical,
      
      TN -> turnAround,
      
      JF -> jumpForward,
      JB -> jumpBack,
      JU -> jumpUp,
      JD -> jumpDown,
      
      N  -> north,
      E  -> east,
      S  -> south,
	     W  -> west,
	     
	     DP -> drawPoint,
	     DPLY -> drawPolygon,

      STACK[x___] :> {push,x,pop},
      SEQ[x___] :> {x},
      
      POLYGON[x___] :> ({resetPolygonPoints[],setPolygonPoint[],
                         x,
                         constructPolygon[]} /. JF[s_] :> {JF[s],setPolygonPoint[]}),
      
      CO[c_] :> setColor[c],
      CI[c_] :> incrementColor[c],
      CD[c_] :> decrementColor[c],
      
      
      TH[c_] :> setThickness[c],
      TI[c_] :> incrementThickness[c],
      TD[c_] :> decrementThickness[c],
      TS[c_] :> scaleThickness[c]
     },
     
   GraphicOptions ->
   {
     AspectRatio -> 1,
	    Axes -> True,
	    Boxed -> True,
	        (**ViewPoint->{-2.644, -0.679, 2.000},**)
	    (**PlotRange -> {{-6,0},{-5,4},{0,6}},**)
	    PlotRange -> All,
	    Background -> GrayLevel[.9],
       DisplayFunction -> $DisplayFunction
   }
	 
};




turtleInterpretation[turtleExpr_, opts___] :=
Module[
	{  
	  dim1 = MaxPathLength /. {opts} /. Options[turtleInterpretation],
    dim2 = MaxNumberOfPaths /. {opts} /. Options[turtleInterpretation],
    
    X = N[StartPosition /. {opts} /. Options[turtleInterpretation] ], 
    U = N[StartDirection /. {opts} /. Options[turtleInterpretation] ], 
    
    gravityDirection = GravityDirection /. {opts} /. Options[turtleInterpretation],
    
    interpretationTable = 
	    InterpretationTable /. {opts} /. Options[turtleInterpretation],

    currentColor = (LineHue /. {opts} /. Options[turtleInterpretation]),
    
    stepVariance = StepVariance /. {opts} /. Options[turtleInterpretation],
    angleVariance = AngleVariance /. {opts} /. Options[turtleInterpretation],
    thickN = LineThickness /. {opts} /. Options[turtleInterpretation],

    yawMatrix, pitchMatrix, rollMatrix,

	   i = 1, count = {1}, sV,aV, polygonPoints = {},
	   turtleStack = {},
  },
  
  (* --- Defining a list for entering paths --------- *)
  
  paths = Table[Null,{dim2}];
  paths[[1]] = 
    Graphics3D[{GrayLevel[1.], PointSize[.02], Point[X]}];

  (* --- Setting step and angle variance ------------ *)
  
  sV := 1. + Random[Real,{-stepVariance,stepVariance}];
  aV := 1. + Random[Real,{-angleVariance,angleVariance}];
  
  
  (* --- Turtle INTERPRETATION ----------------------- *)
  
  (* --- Attributes of the turtle function ----------- *)
  
  Attributes[turtle] = Listable;

  
  (* --- Moving back and forth ----------------------- *)
  
  turtle[forward[s_]] := paths[[++i]] 
    = Graphics3D[{Thickness[thickN], (* 2. *)
                  Hue[currentColor],
                  Line[{X,X += s sV First[Transpose@U]}]}];
  turtle[back[s_]]    := paths[[++i]] 
    = Graphics3D[{Thickness[thickN], (* 1. *)
                  Hue[currentColor],
                  Line[{X,X -= s sV First[Transpose@U]}]}];
  
  (* --- Jumping back, forth, up, and down ----------- *)
  
  turtle[jumpForward[s_]] := X += s sV First[Transpose@U];
  
  turtle[jumpBack[s_]] := X -= s sV First[Transpose@U];
  
  turtle[jumpUp[s_]] := 
    (U = U.pitchMatrix[ 90 aV Degree] // N; (* pitch up *)
     X += s sV First[Transpose@U]; (* forward *)
     U = U.pitchMatrix[-90 aV Degree] // N; (* pitch down *)
    );
    
  turtle[jumpDown[s_]] := 
    (U = U.pitchMatrix[-90 aV Degree] // N; (* pitch up *)
     X += s sV First[Transpose@U]; (* forward *)
     U = U.pitchMatrix[ 90 aV Degree] // N; (* pitch down *)
    );
    
  (* --- Drawing polygons and ------------------------ *)
  
  turtle[resetPolygonPoints[]] := (polygonPoints = {});
  turtle[setPolygonPoint[]] := (AppendTo[polygonPoints,X]);
  
  turtle[constructPolygon[]] := paths[[++i]]
    = Graphics3D[{Polygon[polygonPoints]}];

  turtle[drawPolygon[s_,c_,polyCoords_]] := 
    paths[[++i]]
    = Graphics3D[{
                  Hue[c],
                  Polygon[Map[s (X+#)&, polyCoords]]}];
    
  (* --- Drawing points ------------------------------ *)
  
  turtle[drawPoint[s_,c_]] := paths[[++i]] 
    = Graphics3D[{PointSize[.01 s],
                  Hue[c],
                  Point[X]}];
  
  (* --- Specials for plants ------------------------- *)
         
  turtle[BLOOM[b_,s_]] := paths[[++i]] 
    = TranslateShape[
        AffineShape[
          ListSurfaceOfRevolution[
            b,
            RevolutionAxis -> First[Transpose@U],
            DisplayFunction -> Identity],
          {s,s,s}
        ],
        X];
  
  (* --- A wrapper for translating and scaling ------- *)
  
  turtle[GRAPHICS[g_,s_]] := paths[[++i]] 
    = TranslateShape[AffineShape[g,{s,s,s}],X];

  (* --- Rotations: ---------------------------------- *)
  
  (* --- Yawing around the vertical axis ------------- *)
  
  turtle[yawLeft[a_]]   := U = U.yawMatrix[-a aV Degree] // N;
  turtle[yawRight[a_]]  := U = U.yawMatrix[ a aV Degree] // N;
  
  (* --- Pitching around the horizontal axis --------- *)
  
  turtle[pitchDown[a_]] := U = U.pitchMatrix[-a aV Degree] // N;
  turtle[pitchUp[a_]]   := U = U.pitchMatrix[ a aV Degree] // N;
 
  (* --- Rolling around the longitudinal axis -------- *)
  
  turtle[rollLeft[a_]]  := U = U.rollMatrix[-a aV Degree] // N;
  turtle[rollRight[a_]] := U = U.rollMatrix[ a aV Degree] // N;
  
  (* --- Rotate turtle to vertical (p.57)------------- *)
  (* --- l is the turtle lefthand side vector          *)
  (* --- v is the direction opposite to gravity        *)
  (* --- h is the turtle heading vector                *)
  (* --- u is the turtle up vector                     *)
  
  turtle[orientateToVertical[]]  := Module[{l,v,h,u},
  
    v = -gravityDirection;
    h = Transpose[U][[1]];
    l = vectorProduct[v,h];
    l = l/norm[l];
    u = vectorProduct[h,l];
    
    U = Transpose[{h,l,u}]
  ]; 

  (* --- Turning around ------------------------------ *)
  
  turtle[turnAround[]]  := U = U.yawMatrix[180 Degree] // N;
  turtle[turnAround  ]  := U = U.yawMatrix[180 Degree] // N;
  
  (* --- Color settings ------------------------------ *)
  
  turtle[setColor[c_]]  := (currentColor = c);
  
  turtle[incrementColor[c_]]  := 
    (currentColor += c; currentColor = Mod[currentColor,1]);
  turtle[decrementColor[c_]]  := 
    (currentColor -= c; currentColor = Mod[currentColor,1]);
  
  (* --- Line thickness settings --------------------- *)
    
  turtle[setThickness[c_]]  := (thickN = c);
  turtle[scaleThickness[c_]]  := 
    (thickN *= c; thickN = Mod[thickN,1]);
  
  turtle[incrementThickness[c_]]  := 
    (thickN += c; thickN = Mod[thickN,1]);
  turtle[decrementThickness[c_]]  := 
    (thickN -= c; thickN = Mod[thickN,1]);
  
  (* --- Stacking ------------------------------------ *)
  
  turtle[push]    := PrependTo[turtleStack, {X,U}];

  turtle[pop]     := ({X,U} = First[turtleStack]; 
                      (**paths[[++i]] = X; **)
                      turtleStack = Rest[turtleStack]);

				
  (* --- Rotation matrices --------------------------- *)
  
  yawMatrix[a_]   := {{ Cos[a], Sin[a], 0     },
                      {-Sin[a], Cos[a], 0     },
                      { 0     , 0     , 1     }};
                               
  pitchMatrix[a_] := {{ Cos[a], 0     ,-Sin[a]},
                      { 0     , 1     , 0     },
                      { Sin[a], 0     , Cos[a]}};
  
  rollMatrix[a_]  := {{ 1     , 0     , 0     },
                      { 0     , Cos[a],-Sin[a]},
                      { 0     , Sin[a], Cos[a]}};
  

  (* ------------------------------------------------- *)
  (* --- now start the interpretation actions ... ---- *)
  (* ------------------------------------------------- *)

  Print["Starting turtle interpretation ..."];

  (* turtleExpr is the parameter of the 
     turtleInterpretation function *)
     
  interpretationTime = 
    First[Timing[turtle[turtleExpr //. interpretationTable]]];
    
  Print["Time needed: ",interpretationTime];
  
  (**
  paths = 
    Map[Drop[#,1]&,
      Map[Take[paths[[#]], count[[#]]] &, Range[i]]
    ] // Flatten; 
  **)
  
  paths = Take[paths,i];
  
  (* ------------------------------------------------- *)
  (* --- Generating the graphics output -------------- *)
  (* ------------------------------------------------- *)
  
  Print["Generating graphics ..."];
  
  turtlePlot = 
  Show[
    {paths},
		  GraphicOptions /. {opts} /. Options[turtleInterpretation]
  ];
  
  turtlePlot
  
]; (* end module *)
												 





norm[v_] := N[Sqrt[v . v]]



e1 = {1,0,0};
e2 = {0,1,0};
e3 = {0,0,1};



vectorProduct[u_,v_] :=
 N[{Det[{u,v,e1}],Det[{u,v,e2}],Det[{u,v,e3}]}]



