(************** Content-type: application/mathematica **************

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1644701,      71727]*)
(*NotebookOutlinePosition[   1647601,      71814]*)
(*  CellTagsIndexPosition[   1647135,      71798]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Modeling Simple Tree Structures with L-Systems", "Title",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Christian Jacob, jacob@cpsc.ucalgary.ca  July 1998 / February 2001 \
\[Copyright]\
\>", "Subsubtitle"],

Cell[TextData[{
  " ",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.46102 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.193405 1.42812 0.0357029 1.42812 [
[ 0 0 0 0 ]
[ 1 1.46102 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.46102 L
0 1.46102 L
closepath
clip
newpath
p
1 g
.002 w
.83773 .0357 m
.87192 1.21206 L
s
.87192 1.21206 m
.0357 1.26444 L
s
.0357 1.26444 m
.08137 .12136 L
s
.08137 .12136 m
.83773 .0357 L
s
.92577 .31981 m
.24596 .38825 L
s
.24596 .38825 m
.22067 1.42532 L
s
.22067 1.42532 m
.9643 1.3844 L
s
.9643 1.3844 m
.92577 .31981 L
s
.83773 .0357 m
.87192 1.21206 L
s
.87192 1.21206 m
.9643 1.3844 L
s
.9643 1.3844 m
.92577 .31981 L
s
.92577 .31981 m
.83773 .0357 L
s
.08137 .12136 m
.24596 .38825 L
s
.24596 .38825 m
.22067 1.42532 L
s
.22067 1.42532 m
.0357 1.26444 L
s
.0357 1.26444 m
.08137 .12136 L
s
p
.4 g
.85752 .09956 m
.11826 .18118 L
s
P
p
.4 g
.88481 .18763 m
.16924 .26384 L
s
P
p
.4 g
.91029 .26987 m
.21695 .3412 L
s
P
p
.4 g
.71723 .04935 m
.81778 .33068 L
s
P
p
.4 g
.53272 .07025 m
.6522 .34735 L
s
P
p
.4 g
.35114 .09081 m
.48897 .36378 L
s
P
p
.4 g
.1724 .11105 m
.32803 .37999 L
s
P
P
p
1 0 .6 r
.00125 w
.43984 .66528 m
.44502 .67384 L
s
P
p
1 0 .6 r
.00125 w
.39778 .71065 m
.40315 .71902 L
s
P
p
1 0 .6 r
.00125 w
.37983 .73002 m
.36917 .75568 L
s
P
p
1 0 .6 r
.00125 w
.43984 .66528 m
.435 .67681 L
s
P
p
1 0 .6 r
.00125 w
.39778 .71065 m
.39301 .72211 L
s
P
p
1 0 .6 r
.00125 w
.44491 .65188 m
.45466 .64846 L
s
P
p
1 0 .6 r
.00177 w
.43403 .65569 m
.43984 .66528 L
s
P
p
1 0 .6 r
.00125 w
.67337 .81429 m
.67539 .84048 L
s
P
p
1 0 .6 r
.00125 w
.44491 .65188 m
.44722 .65572 L
s
P
p
1 0 .6 r
.00177 w
.39177 .70126 m
.39778 .71065 L
s
P
p
1 0 .6 r
.00125 w
.37983 .73002 m
.36427 .74599 L
s
P
p
1 0 .6 r
.00177 w
.39177 .70126 m
.37983 .73002 L
s
P
p
1 0 .6 r
.00125 w
.65798 .79294 m
.64626 .80009 L
s
P
p
1 0 .6 r
.00177 w
.43403 .65569 m
.44491 .65188 L
s
P
p
1 0 .6 r
.00125 w
.6218 .74276 m
.61021 .75011 L
s
P
p
1 0 .6 r
.00125 w
.65798 .79294 m
.65891 .80466 L
s
P
p
1 0 .6 r
.00125 w
.42413 .66362 m
.42648 .66745 L
s
P
p
1 0 .6 r
.00125 w
.41611 .67226 m
.41128 .68384 L
s
P
p
1 0 .6 r
.00125 w
.67337 .81429 m
.6871 .83199 L
s
P
p
1 0 .6 r
.00177 w
.67111 .78493 m
.67337 .81429 L
s
P
p
1 0 .6 r
.00125 w
.6218 .74276 m
.62281 .75459 L
s
P
p
1 0 .6 r
.0025 w
.42752 .64492 m
.43403 .65569 L
s
P
p
1 0 .6 r
.00125 w
.42413 .66362 m
.42197 .66878 L
s
P
p
1 0 .6 r
.00177 w
.67111 .78493 m
.65798 .79294 L
s
P
p
1 0 .6 r
.0025 w
.40516 .66902 m
.39177 .70126 L
s
P
p
1 0 .6 r
.00177 w
.4215 .65934 m
.42413 .66362 L
s
P
p
1 0 .6 r
.00125 w
.41611 .67226 m
.40918 .67937 L
s
P
p
1 0 .6 r
.00177 w
.4215 .65934 m
.41611 .67226 L
s
P
p
1 0 .6 r
.00177 w
.63479 .73452 m
.6218 .74276 L
s
P
p
1 0 .6 r
.00125 w
.62143 .72909 m
.61625 .7324 L
s
P
p
1 0 .6 r
.00125 w
.62143 .72909 m
.60944 .72422 L
s
P
p
1 0 .6 r
.00125 w
.38045 .70179 m
.37566 .71336 L
s
P
p
1 0 .6 r
.0025 w
.42752 .64492 m
.4215 .65934 L
s
P
p
1 0 .6 r
.00177 w
.63479 .73452 m
.62143 .72909 L
s
P
p
1 0 .6 r
.00125 w
.6516 .75329 m
.65255 .76515 L
s
P
p
1 0 .6 r
.02 w
.59674 .2423 m
.59783 .40145 L
s
P
p
1 g
.05 w
.59674 .2423 Mdot
P
p
1 0 .6 r
.00125 w
.38045 .70179 m
.37348 .70893 L
s
P
p
1 0 .6 r
.00177 w
.38579 .68888 m
.38045 .70179 L
s
P
p
1 0 .6 r
.0025 w
.66856 .75197 m
.67111 .78493 L
s
P
p
1 0 .6 r
.00125 w
.64471 .74373 m
.63948 .74701 L
s
P
p
1 0 .6 r
.00353 w
.42019 .63282 m
.42752 .64492 L
s
P
p
1 0 .6 r
.00125 w
.68667 .78724 m
.68755 .79905 L
s
P
p
1 0 .6 r
.00125 w
.64471 .74373 m
.64514 .74901 L
s
P
p
1 0 .6 r
.0025 w
.40516 .66902 m
.38579 .68888 L
s
P
p
1 0 .6 r
.00353 w
.42019 .63282 m
.40516 .66902 L
s
P
p
1 0 .6 r
.0025 w
.64936 .72529 m
.63479 .73452 L
s
P
p
1 0 .6 r
.00125 w
.6516 .75329 m
.65774 .76121 L
s
P
p
1 0 .6 r
.00177 w
.65054 .74006 m
.6516 .75329 L
s
P
p
1 0 .6 r
.00177 w
.65054 .74006 m
.64471 .74373 L
s
P
p
1 0 .6 r
.00177 w
.38579 .68888 m
.36832 .70678 L
s
P
p
1 0 .6 r
.00125 w
.36832 .70678 m
.35259 .72291 L
s
P
p
1 0 .6 r
.00125 w
.36832 .70678 m
.35826 .71037 L
s
P
p
1 0 .6 r
.00125 w
.76735 .85835 m
.76898 .88466 L
s
P
p
1 0 .6 r
.00125 w
.68667 .78724 m
.69281 .79517 L
s
P
p
1 0 .6 r
.00177 w
.68568 .77407 m
.68667 .78724 L
s
P
p
1 0 .6 r
.0025 w
.64936 .72529 m
.65054 .74006 L
s
P
p
1 0 .6 r
.00125 w
.75183 .83677 m
.73961 .84384 L
s
P
p
1 0 .6 r
.00125 w
.31861 .74353 m
.32441 .7519 L
s
P
p
1 0 .6 r
.00125 w
.70108 .79394 m
.71493 .81181 L
s
P
p
1 0 .6 r
.00125 w
.70108 .79394 m
.7133 .79896 L
s
P
p
1 0 .6 r
.00177 w
.68568 .77407 m
.70108 .79394 L
s
P
p
1 0 .6 r
.00125 w
.40285 .6521 m
.40527 .656 L
s
P
p
1 0 .6 r
.00125 w
.30031 .76324 m
.28979 .78922 L
s
P
p
1 0 .6 r
.0025 w
.66856 .75197 m
.68568 .77407 L
s
P
p
1 0 .6 r
.00125 w
.39475 .66083 m
.38991 .67256 L
s
P
p
1 0 .6 r
.00353 w
.6657 .71493 m
.66856 .75197 L
s
P
p
1 0 .6 r
.00125 w
.75183 .83677 m
.75259 .84854 L
s
P
p
1 0 .6 r
.00125 w
.40285 .6521 m
.40069 .65733 L
s
P
p
1 0 .6 r
.00353 w
.6657 .71493 m
.64936 .72529 L
s
P
p
1 0 .6 r
.005 w
.43709 .59214 m
.42019 .63282 L
s
P
p
1 0 .6 r
.00125 w
.31861 .74353 m
.31389 .75513 L
s
P
p
1 0 .6 r
.00177 w
.40016 .64775 m
.40285 .6521 L
s
P
p
1 0 .6 r
.00125 w
.76735 .85835 m
.78121 .87625 L
s
P
p
1 0 .6 r
.00125 w
.39475 .66083 m
.38774 .66802 L
s
P
p
1 0 .6 r
.00177 w
.40016 .64775 m
.39475 .66083 L
s
P
p
1 0 .6 r
.00177 w
.76552 .82885 m
.76735 .85835 L
s
P
p
1 0 .6 r
.00177 w
.76552 .82885 m
.75183 .83677 L
s
P
p
1 0 .6 r
.00125 w
.68722 .74584 m
.68811 .75782 L
s
P
p
1 0 .6 r
.00177 w
.31211 .73414 m
.31861 .74353 L
s
P
p
1 0 .6 r
.00125 w
.30031 .76324 m
.28444 .77951 L
s
P
p
1 0 .6 r
.00177 w
.31211 .73414 m
.30031 .76324 L
s
P
p
1 0 .6 r
.0025 w
.40619 .63316 m
.40016 .64775 L
s
P
p
1 0 .6 r
.00125 w
.68028 .73619 m
.67495 .73952 L
s
P
p
1 0 .6 r
.00125 w
.39508 .6479 m
.39292 .65315 L
s
P
p
1 0 .6 r
.00125 w
.68028 .73619 m
.68068 .74153 L
s
P
p
1 0 .6 r
.00125 w
.68722 .74584 m
.69342 .75384 L
s
P
p
1 0 .6 r
.00177 w
.68623 .73248 m
.68722 .74584 L
s
P
p
1 0 .6 r
.00125 w
.39508 .6479 m
.39196 .6511 L
s
P
p
1 0 .6 r
.00177 w
.39749 .64206 m
.39508 .6479 L
s
P
p
1 0 .6 r
.00177 w
.68623 .73248 m
.68028 .73619 L
s
P
p
1 0 .6 r
.0025 w
.40619 .63316 m
.39749 .64206 L
s
P
p
1 0 .6 r
.00353 w
.41292 .61687 m
.40619 .63316 L
s
P
p
1 0 .6 r
.00125 w
.3661 .67242 m
.36127 .68419 L
s
P
p
1 0 .6 r
.005 w
.66249 .67324 m
.6657 .71493 L
s
P
p
1 0 .6 r
.00177 w
.39749 .64206 m
.38966 .65008 L
s
P
p
1 0 .6 r
.00125 w
.38966 .65008 m
.38261 .65729 L
s
P
p
1 0 .6 r
.00125 w
.38966 .65008 m
.38518 .65163 L
s
P
p
1 0 .6 r
.0025 w
.76347 .79573 m
.76552 .82885 L
s
P
p
1 0 .6 r
.00125 w
.84515 .89483 m
.84646 .92123 L
s
P
p
1 0 .6 r
.0025 w
.68513 .71756 m
.68623 .73248 L
s
P
p
1 0 .6 r
.005 w
.43709 .59214 m
.41292 .61687 L
s
P
p
1 0 .6 r
.00707 w
.45611 .54634 m
.43709 .59214 L
s
P
p
1 0 .6 r
.00125 w
.72138 .76153 m
.7222 .77353 L
s
P
p
1 0 .6 r
.00125 w
.78155 .83132 m
.78225 .84318 L
s
P
p
1 0 .6 r
.00125 w
.69324 .73345 m
.69364 .73881 L
s
P
p
1 0 .6 r
.00125 w
.3661 .67242 m
.35903 .67965 L
s
P
p
1 0 .6 r
.00177 w
.37148 .65928 m
.3661 .67242 L
s
P
p
1 0 .6 r
.0025 w
.32533 .70151 m
.31211 .73414 L
s
P
p
1 0 .6 r
.00353 w
.41292 .61687 m
.39112 .63917 L
s
P
p
1 0 .6 r
.00125 w
.69324 .73345 m
.69601 .73701 L
s
P
p
1 0 .6 r
.00177 w
.69281 .72748 m
.69324 .73345 L
s
P
p
1 0 .6 r
.01414 w
.59783 .40145 m
.59883 .54864 L
s
P
p
1 0 .6 r
.01414 w
.59783 .40145 m
.52343 .47752 L
s
P
p
1 0 .6 r
.0025 w
.39112 .63917 m
.37148 .65928 L
s
P
p
1 0 .6 r
.0025 w
.39112 .63917 m
.37861 .64347 L
s
P
p
1 0 .6 r
.00125 w
.69972 .73641 m
.70594 .74444 L
s
P
p
1 0 .6 r
.00125 w
.72138 .76153 m
.72759 .76956 L
s
P
p
1 0 .6 r
.00125 w
.69972 .73641 m
.7052 .73862 L
s
P
p
1 0 .6 r
.00177 w
.69281 .72748 m
.69972 .73641 L
s
P
p
1 0 .6 r
.00177 w
.72046 .74814 m
.72138 .76153 L
s
P
p
1 0 .6 r
.00125 w
.78155 .83132 m
.78775 .83934 L
s
P
p
1 0 .6 r
.0025 w
.68513 .71756 m
.69281 .72748 L
s
P
p
1 0 .6 r
.00177 w
.78076 .81808 m
.78155 .83132 L
s
P
p
1 0 .6 r
.00353 w
.68389 .7009 m
.68513 .71756 L
s
P
p
1 0 .6 r
.00177 w
.37148 .65928 m
.35377 .6774 L
s
P
p
1 0 .6 r
.00125 w
.30029 .7348 m
.29557 .74651 L
s
P
p
1 0 .6 r
.00125 w
.35377 .6774 m
.33782 .69373 L
s
P
p
1 0 .6 r
.00125 w
.35377 .6774 m
.34354 .68097 L
s
P
p
1 0 .6 r
.00125 w
.73603 .76826 m
.75003 .78635 L
s
P
p
1 0 .6 r
.00125 w
.79631 .83818 m
.8103 .85625 L
s
P
p
1 0 .6 r
.00125 w
.84515 .89483 m
.85913 .91289 L
s
P
p
1 0 .6 r
.00125 w
.73603 .76826 m
.74846 .7733 L
s
P
p
1 0 .6 r
.00177 w
.72046 .74814 m
.73603 .76826 L
s
P
p
1 0 .6 r
.00125 w
.79631 .83818 m
.80885 .84334 L
s
P
p
1 0 .6 r
.00177 w
.78076 .81808 m
.79631 .83818 L
s
P
p
1 0 .6 r
.01 w
.52343 .47752 m
.45611 .54634 L
s
P
p
1 0 .6 r
.01 w
.52343 .47752 m
.48143 .49075 L
s
P
p
1 0 .6 r
.00177 w
.84369 .86522 m
.84515 .89483 L
s
P
p
1 0 .6 r
.0025 w
.70315 .72577 m
.72046 .74814 L
s
P
p
1 0 .6 r
.00125 w
.30029 .7348 m
.29318 .74208 L
s
P
p
1 0 .6 r
.00177 w
.30556 .72173 m
.30029 .7348 L
s
P
p
1 0 .6 r
.0025 w
.76347 .79573 m
.78076 .81808 L
s
P
p
1 0 .6 r
.00177 w
.37861 .64347 m
.36728 .64735 L
s
P
p
1 0 .6 r
.00177 w
.37861 .64347 m
.37073 .65153 L
s
P
p
1 0 .6 r
.0025 w
.70315 .72577 m
.71844 .73191 L
s
P
p
1 0 .6 r
.00353 w
.68389 .7009 m
.70315 .72577 L
s
P
p
1 0 .6 r
.00353 w
.76115 .7585 m
.76347 .79573 L
s
P
p
1 0 .6 r
.00125 w
.37073 .65153 m
.36363 .65879 L
s
P
p
1 0 .6 r
.00125 w
.37073 .65153 m
.3662 .65309 L
s
P
p
1 0 .6 r
.005 w
.66249 .67324 m
.68389 .7009 L
s
P
p
1 0 .6 r
.00707 w
.65886 .62624 m
.66249 .67324 L
s
P
p
1 0 .6 r
.0025 w
.32533 .70151 m
.30556 .72173 L
s
P
p
1 0 .6 r
.00353 w
.34018 .66486 m
.32533 .70151 L
s
P
p
1 0 .6 r
.00125 w
.23388 .79101 m
.22347 .81723 L
s
P
p
1 0 .6 r
.00177 w
.30556 .72173 m
.28774 .73997 L
s
P
p
1 0 .6 r
.00125 w
.72538 .74088 m
.73162 .74895 L
s
P
p
1 0 .6 r
.00125 w
.72538 .74088 m
.7309 .7431 L
s
P
p
1 0 .6 r
.00177 w
.71844 .73191 m
.72538 .74088 L
s
P
p
1 0 .6 r
.00177 w
.71844 .73191 m
.73226 .73746 L
s
P
p
1 0 .6 r
.00707 w
.45611 .54634 m
.39522 .60859 L
s
P
p
1 0 .6 r
.00125 w
.28774 .73997 m
.27169 .7564 L
s
P
p
1 0 .6 r
.00125 w
.28774 .73997 m
.27731 .7437 L
s
P
p
1 0 .6 r
.00125 w
.36728 .64735 m
.35704 .65087 L
s
P
p
1 0 .6 r
.00125 w
.36728 .64735 m
.36476 .64338 L
s
P
p
1 0 .6 r
.00125 w
.41937 .57986 m
.42179 .58396 L
s
P
p
1 0 .6 r
.00125 w
.41114 .58871 m
.4062 .60074 L
s
P
p
1 0 .6 r
.00125 w
.87879 .9106 m
.91034 .95138 L
s
P
p
1 0 .6 r
.00125 w
.87879 .9106 m
.9075 .92256 L
s
P
p
1 0 .6 r
.00177 w
.84369 .86522 m
.87879 .9106 L
s
P
p
1 0 .6 r
.00125 w
.41937 .57986 m
.41716 .58522 L
s
P
p
1 0 .6 r
.00125 w
.73226 .73746 m
.74474 .74247 L
s
P
p
1 0 .6 r
.00125 w
.73226 .73746 m
.73776 .73408 L
s
P
p
1 0 .6 r
.005 w
.39522 .60859 m
.34018 .66486 L
s
P
p
1 0 .6 r
.005 w
.39522 .60859 m
.36005 .62042 L
s
P
p
1 0 .6 r
.0025 w
.80463 .81471 m
.84369 .86522 L
s
P
p
1 0 .6 r
.00177 w
.41666 .57528 m
.41937 .57986 L
s
P
p
1 0 .6 r
.00125 w
.41114 .58871 m
.40403 .59598 L
s
P
p
1 0 .6 r
.00177 w
.41666 .57528 m
.41114 .58871 L
s
P
p
1 0 .6 r
.0025 w
.80463 .81471 m
.8398 .82906 L
s
P
p
1 0 .6 r
.00353 w
.76115 .7585 m
.80463 .81471 L
s
P
p
1 0 .6 r
.00125 w
.23388 .79101 m
.21773 .80752 L
s
P
p
1 0 .6 r
.00177 w
.24554 .76162 m
.23388 .79101 L
s
P
p
1 0 .6 r
.005 w
.71275 .69593 m
.76115 .7585 L
s
P
p
1 0 .6 r
.00353 w
.34018 .66486 m
.29045 .7157 L
s
P
p
1 0 .6 r
.0025 w
.42282 .5603 m
.41666 .57528 L
s
P
p
1 0 .6 r
.005 w
.71275 .69593 m
.75577 .71299 L
s
P
p
1 0 .6 r
.00707 w
.65886 .62624 m
.71275 .69593 L
s
P
p
1 0 .6 r
.00125 w
.41154 .57531 m
.40933 .58069 L
s
P
p
1 0 .6 r
.00125 w
.79352 .77437 m
.79421 .78649 L
s
P
p
1 0 .6 r
.0025 w
.29045 .7157 m
.24554 .76162 L
s
P
p
1 0 .6 r
.0025 w
.29045 .7157 m
.2612 .72602 L
s
P
p
1 0 .6 r
.01 w
.59883 .54864 m
.65886 .62624 L
s
P
p
1 0 .6 r
.00125 w
.41154 .57531 m
.40837 .57855 L
s
P
p
1 0 .6 r
.00177 w
.414 .56932 m
.41154 .57531 L
s
P
p
1 0 .6 r
.00125 w
.58901 1.00544 m
.60371 1.03046 L
s
P
p
1 0 .6 r
.0025 w
.42282 .5603 m
.414 .56932 L
s
P
p
1 0 .6 r
.00353 w
.4297 .54358 m
.42282 .5603 L
s
P
p
1 0 .6 r
.00125 w
.5171 1.05455 m
.53208 1.07939 L
s
P
p
1 0 .6 r
.00125 w
.38215 .60001 m
.37722 .6121 L
s
P
p
1 0 .6 r
.00177 w
.414 .56932 m
.40606 .57743 L
s
P
p
1 0 .6 r
.00125 w
.5171 1.05455 m
.50152 1.10026 L
s
P
p
1 0 .6 r
.00125 w
.8555 .84937 m
.86962 .86763 L
s
P
p
1 0 .6 r
.00707 w
.48143 .49075 m
.4429 .5029 L
s
P
p
1 0 .6 r
.00707 w
.48143 .49075 m
.45423 .51853 L
s
P
p
1 0 .6 r
.01 w
.59883 .54864 m
.59976 .68442 L
s
P
p
1 0 .6 r
.00125 w
.40606 .57743 m
.3989 .58474 L
s
P
p
1 0 .6 r
.00125 w
.40606 .57743 m
.40152 .57893 L
s
P
p
1 0 .6 r
.00125 w
.8555 .84937 m
.86827 .8546 L
s
P
p
1 0 .6 r
.00177 w
.8398 .82906 m
.8555 .84937 L
s
P
p
1 0 .6 r
.00125 w
.79352 .77437 m
.7998 .7825 L
s
P
p
1 0 .6 r
.00177 w
.24554 .76162 m
.20498 .80309 L
s
P
p
1 0 .6 r
.00177 w
.8398 .82906 m
.87175 .8421 L
s
P
p
1 0 .6 r
.00177 w
.79275 .76083 m
.79352 .77437 L
s
P
p
1 0 .6 r
.00125 w
.31248 .67687 m
.30768 .68884 L
s
P
p
1 0 .6 r
.005 w
.45423 .51853 m
.4297 .54358 L
s
P
p
1 0 .6 r
.005 w
.45423 .51853 m
.43879 .52347 L
s
P
p
1 0 .6 r
.00125 w
.58901 1.00544 m
.60994 1.00864 L
s
P
p
1 0 .6 r
.00125 w
.38215 .60001 m
.37498 .60734 L
s
P
p
1 0 .6 r
.00177 w
.38765 .58653 m
.38215 .60001 L
s
P
p
1 0 .6 r
.00353 w
.4297 .54358 m
.40758 .56617 L
s
P
p
1 0 .6 r
.00125 w
.20498 .80309 m
.16837 .84051 L
s
P
p
1 0 .6 r
.00125 w
.20498 .80309 m
.18078 .81193 L
s
P
p
1 0 .6 r
.00125 w
.80849 .7812 m
.82266 .79953 L
s
P
p
1 0 .6 r
.00125 w
.80849 .7812 m
.82121 .78633 L
s
P
p
1 0 .6 r
.00177 w
.79275 .76083 m
.80849 .7812 L
s
P
p
1 0 .6 r
.00125 w
.31248 .67687 m
.30529 .68423 L
s
P
p
1 0 .6 r
.00177 w
.31785 .66353 m
.31248 .67687 L
s
P
p
1 0 .6 r
.0025 w
.40758 .56617 m
.38765 .58653 L
s
P
p
1 0 .6 r
.0025 w
.40758 .56617 m
.39492 .57031 L
s
P
p
1 0 .6 r
.0025 w
.77524 .73818 m
.79275 .76083 L
s
P
p
1 0 .6 r
.00353 w
.36005 .62042 m
.3279 .63123 L
s
P
p
1 0 .6 r
.00353 w
.36005 .62042 m
.33786 .64309 L
s
P
p
1 0 .6 r
.00177 w
.57254 .97742 m
.58901 1.00544 L
s
P
p
1 0 .6 r
.0025 w
.77524 .73818 m
.79088 .74443 L
s
P
p
1 0 .6 r
.00353 w
.75577 .71299 m
.77524 .73818 L
s
P
p
1 0 .6 r
.00177 w
.53454 1.00337 m
.5171 1.05455 L
s
P
p
1 0 .6 r
.00177 w
.38765 .58653 m
.36968 .60488 L
s
P
p
1 0 .6 r
.00353 w
.75577 .71299 m
.79492 .72853 L
s
P
p
1 0 .6 r
.00125 w
.41759 .54863 m
.41536 .55406 L
s
P
p
1 0 .6 r
.0025 w
.33786 .64309 m
.31785 .66353 L
s
P
p
1 0 .6 r
.0025 w
.33786 .64309 m
.32498 .64747 L
s
P
p
1 0 .6 r
.00125 w
.5647 1.00026 m
.57131 1.01144 L
s
P
p
1 0 .6 r
.00125 w
.5647 1.00026 m
.55768 1.02075 L
s
P
p
1 0 .6 r
.00125 w
.36968 .60488 m
.35349 .62141 L
s
P
p
1 0 .6 r
.00125 w
.36968 .60488 m
.35932 .60833 L
s
P
p
1 0 .6 r
.00125 w
.41759 .54863 m
.4144 .55189 L
s
P
p
1 0 .6 r
.00177 w
.42007 .54258 m
.41759 .54863 L
s
P
p
1 0 .6 r
.00177 w
.31785 .66353 m
.29981 .68195 L
s
P
p
1 0 .6 r
.00353 w
.43879 .52347 m
.42479 .52794 L
s
P
p
1 0 .6 r
.00353 w
.43879 .52347 m
.42894 .53352 L
s
P
p
1 0 .6 r
.00125 w
.87175 .8421 m
.90074 .85392 L
s
P
p
1 0 .6 r
.00125 w
.87175 .8421 m
.88484 .83482 L
s
P
p
1 0 .6 r
.00125 w
.7979 .75351 m
.80421 .76168 L
s
P
p
1 0 .6 r
.0025 w
.42894 .53352 m
.42007 .54258 L
s
P
p
1 0 .6 r
.0025 w
.42894 .53352 m
.42334 .53532 L
s
P
p
1 0 .6 r
.00125 w
.7979 .75351 m
.80355 .75577 L
s
P
p
1 0 .6 r
.00177 w
.79088 .74443 m
.7979 .75351 L
s
P
p
1 0 .6 r
.00125 w
.29981 .68195 m
.28356 .69855 L
s
P
p
1 0 .6 r
.00125 w
.29981 .68195 m
.28928 .68559 L
s
P
p
1 0 .6 r
.00177 w
.79088 .74443 m
.80502 .75007 L
s
P
p
1 0 .6 r
.00177 w
.42007 .54258 m
.41208 .55073 L
s
P
p
1 0 .6 r
.00177 w
.2612 .72602 m
.23454 .73542 L
s
P
p
1 0 .6 r
.00177 w
.2612 .72602 m
.24311 .7445 L
s
P
p
1 0 .6 r
.00177 w
.57254 .97742 m
.5647 1.00026 L
s
P
p
1 0 .6 r
.00125 w
.41208 .55073 m
.40489 .55807 L
s
P
p
1 0 .6 r
.00125 w
.41208 .55073 m
.40752 .55221 L
s
P
p
1 0 .6 r
.00177 w
.39492 .57031 m
.38347 .57406 L
s
P
p
1 0 .6 r
.00177 w
.39492 .57031 m
.38693 .57848 L
s
P
p
1 0 .6 r
.00125 w
.38693 .57848 m
.37972 .58583 L
s
P
p
1 0 .6 r
.00125 w
.38693 .57848 m
.38234 .57999 L
s
P
p
1 0 .6 r
.00125 w
.24311 .7445 m
.22681 .76115 L
s
P
p
1 0 .6 r
.00125 w
.24311 .7445 m
.23243 .74829 L
s
P
p
1 0 .6 r
.00125 w
.50132 1.0238 m
.49438 1.04429 L
s
P
p
1 0 .6 r
.00177 w
.42334 .53532 m
.41828 .53695 L
s
P
p
1 0 .6 r
.00177 w
.42334 .53532 m
.41978 .53895 L
s
P
p
1 0 .6 r
.00125 w
.41978 .53895 m
.41659 .54221 L
s
P
p
1 0 .6 r
.00125 w
.41978 .53895 m
.41776 .5396 L
s
P
p
1 0 .6 r
.00177 w
.32498 .64747 m
.31332 .65143 L
s
P
p
1 0 .6 r
.00177 w
.32498 .64747 m
.31695 .65566 L
s
P
p
1 0 .6 r
.00125 w
.31695 .65566 m
.30972 .66305 L
s
P
p
1 0 .6 r
.00125 w
.31695 .65566 m
.31228 .65725 L
s
P
p
1 0 .6 r
.00125 w
.80502 .75007 m
.81779 .75517 L
s
P
p
1 0 .6 r
.00125 w
.80502 .75007 m
.81072 .74667 L
s
P
p
1 0 .6 r
.0025 w
.55408 .94602 m
.57254 .97742 L
s
P
p
1 0 .6 r
.00177 w
.53454 1.00337 m
.50132 1.0238 L
s
P
p
1 0 .6 r
.0025 w
.55408 .94602 m
.53454 1.00337 L
s
P
p
1 0 .6 r
.00125 w
.41828 .53695 m
.41372 .53841 L
s
P
p
1 0 .6 r
.00125 w
.41828 .53695 m
.41719 .53506 L
s
P
p
1 0 .6 r
.00125 w
.50132 1.0238 m
.4714 1.04219 L
s
P
p
1 0 .6 r
.0025 w
.42479 .52794 m
.41212 .532 L
s
P
p
1 0 .6 r
.0025 w
.42479 .52794 m
.42176 .52267 L
s
P
p
1 0 .6 r
.00125 w
.38347 .57406 m
.3731 .57746 L
s
P
p
1 0 .6 r
.00125 w
.38347 .57406 m
.38093 .56988 L
s
P
p
1 0 .6 r
.0025 w
.79492 .72853 m
.83051 .74265 L
s
P
p
1 0 .6 r
.0025 w
.79492 .72853 m
.81079 .71894 L
s
P
p
1 0 .6 r
.005 w
.4429 .5029 m
.40762 .51402 L
s
P
p
1 0 .6 r
.005 w
.4429 .5029 m
.43457 .48798 L
s
P
p
1 0 .6 r
.00125 w
.31332 .65143 m
.30278 .65501 L
s
P
p
1 0 .6 r
.00125 w
.31332 .65143 m
.31064 .64739 L
s
P
p
1 0 .6 r
.0025 w
.3279 .63123 m
.29856 .6411 L
s
P
p
1 0 .6 r
.0025 w
.3279 .63123 m
.32051 .61986 L
s
P
p
1 0 .6 r
.00177 w
.42176 .52267 m
.41903 .51789 L
s
P
p
1 0 .6 r
.00177 w
.42176 .52267 m
.41669 .52428 L
s
P
p
1 0 .6 r
.00177 w
.41212 .532 m
.40065 .53567 L
s
P
p
1 0 .6 r
.00177 w
.41212 .532 m
.40408 .54019 L
s
P
p
1 0 .6 r
.00125 w
.40408 .54019 m
.39685 .54757 L
s
P
p
1 0 .6 r
.00125 w
.40408 .54019 m
.39949 .54167 L
s
P
p
1 0 .6 r
.00125 w
.23454 .73542 m
.21026 .74398 L
s
P
p
1 0 .6 r
.00125 w
.23454 .73542 m
.22813 .72668 L
s
P
p
1 0 .6 r
.00125 w
.41669 .52428 m
.41211 .52574 L
s
P
p
1 0 .6 r
.00125 w
.41669 .52428 m
.41559 .52237 L
s
P
p
1 0 .6 r
.00707 w
.59976 .68442 m
.60062 .80942 L
s
P
p
1 0 .6 r
.00707 w
.59976 .68442 m
.58173 .7198 L
s
P
p
1 0 .6 r
.00125 w
.51808 .95596 m
.52482 .96731 L
s
P
p
1 0 .6 r
.00353 w
.576 .88168 m
.55408 .94602 L
s
P
p
1 0 .6 r
.00125 w
.51808 .95596 m
.51107 .97669 L
s
P
p
1 0 .6 r
.00125 w
.41903 .51789 m
.41655 .51358 L
s
P
p
1 0 .6 r
.00125 w
.41903 .51789 m
.42128 .51238 L
s
P
p
1 0 .6 r
.00125 w
.84642 .76326 m
.86073 .78179 L
s
P
p
1 0 .6 r
.00125 w
.84642 .76326 m
.85934 .76841 L
s
P
p
1 0 .6 r
.00177 w
.83051 .74265 m
.84642 .76326 L
s
P
p
1 0 .6 r
.00125 w
.40065 .53567 m
.39027 .53898 L
s
P
p
1 0 .6 r
.00125 w
.40065 .53567 m
.39813 .53138 L
s
P
p
1 0 .6 r
.00177 w
.5259 .93286 m
.51808 .95596 L
s
P
p
1 0 .6 r
.00177 w
.83051 .74265 m
.86285 .75548 L
s
P
p
1 0 .6 r
.00177 w
.81079 .71894 m
.8252 .71023 L
s
P
p
1 0 .6 r
.00177 w
.81079 .71894 m
.82508 .72458 L
s
P
p
1 0 .6 r
.00125 w
.51102 .94199 m
.5079 .95124 L
s
P
p
1 0 .6 r
.00125 w
.35934 .57134 m
.35438 .58367 L
s
P
p
1 0 .6 r
.00177 w
.5259 .93286 m
.51102 .94199 L
s
P
p
1 0 .6 r
.0025 w
.53461 .90708 m
.5259 .93286 L
s
P
p
1 0 .6 r
.00125 w
.51102 .94199 m
.49762 .95022 L
s
P
p
1 0 .6 r
.00125 w
.82508 .72458 m
.838 .72968 L
s
P
p
1 0 .6 r
.00125 w
.82508 .72458 m
.83087 .72111 L
s
P
p
1 0 .6 r
.00177 w
.32051 .61986 m
.31379 .60952 L
s
P
p
1 0 .6 r
.00177 w
.32051 .61986 m
.30874 .62378 L
s
P
p
1 0 .6 r
.00353 w
.43457 .48798 m
.42697 .47438 L
s
P
p
1 0 .6 r
.00353 w
.43457 .48798 m
.4204 .49239 L
s
P
p
1 0 .6 r
.00125 w
.46375 .95058 m
.4568 .97141 L
s
P
p
1 0 .6 r
.00125 w
.35934 .57134 m
.35205 .57877 L
s
P
p
1 0 .6 r
.00177 w
.36488 .55758 m
.35934 .57134 L
s
P
p
1 0 .6 r
.00353 w
.576 .88168 m
.53461 .90708 L
s
P
p
1 0 .6 r
.005 w
.60062 .80942 m
.576 .88168 L
s
P
p
1 0 .6 r
.00177 w
.29856 .6411 m
.27181 .65009 L
s
P
p
1 0 .6 r
.00177 w
.29856 .6411 m
.28028 .65974 L
s
P
p
1 0 .6 r
.00353 w
.40762 .51402 m
.37536 .52419 L
s
P
p
1 0 .6 r
.00353 w
.40762 .51402 m
.38514 .53693 L
s
P
p
1 0 .6 r
.0025 w
.53461 .90708 m
.49733 .92997 L
s
P
p
1 0 .6 r
.00125 w
.28028 .65974 m
.26381 .67653 L
s
P
p
1 0 .6 r
.00125 w
.28028 .65974 m
.26957 .66337 L
s
P
p
1 0 .6 r
.00177 w
.49733 .92997 m
.46375 .95058 L
s
P
p
1 0 .6 r
.00177 w
.49733 .92997 m
.47342 .92617 L
s
P
p
1 0 .6 r
.00125 w
.86285 .75548 m
.89219 .76713 L
s
P
p
1 0 .6 r
.00125 w
.86285 .75548 m
.87608 .74776 L
s
P
p
1 0 .6 r
.0025 w
.38514 .53693 m
.36488 .55758 L
s
P
p
1 0 .6 r
.0025 w
.38514 .53693 m
.37221 .54105 L
s
P
p
1 0 .6 r
.00125 w
.8252 .71023 m
.83829 .70233 L
s
P
p
1 0 .6 r
.00125 w
.8252 .71023 m
.82456 .69771 L
s
P
p
1 0 .6 r
.00125 w
.46375 .95058 m
.4335 .96915 L
s
P
p
1 0 .6 r
.00125 w
.30874 .62378 m
.29808 .62733 L
s
P
p
1 0 .6 r
.00125 w
.30874 .62378 m
.30603 .61966 L
s
P
p
1 0 .6 r
.00177 w
.36488 .55758 m
.34661 .5762 L
s
P
p
1 0 .6 r
.0025 w
.4204 .49239 m
.40757 .49638 L
s
P
p
1 0 .6 r
.0025 w
.4204 .49239 m
.41733 .48696 L
s
P
p
1 0 .6 r
.00125 w
.34661 .5762 m
.33015 .59298 L
s
P
p
1 0 .6 r
.00125 w
.34661 .5762 m
.33604 .57964 L
s
P
p
1 0 .6 r
.00125 w
.47342 .92617 m
.45182 .92275 L
s
P
p
1 0 .6 r
.00125 w
.47342 .92617 m
.45996 .93443 L
s
P
p
1 0 .6 r
.00125 w
.31379 .60952 m
.30768 .60012 L
s
P
p
1 0 .6 r
.00125 w
.31379 .60952 m
.31871 .59716 L
s
P
p
1 0 .6 r
.00177 w
.37221 .54105 m
.36052 .54478 L
s
P
p
1 0 .6 r
.00177 w
.37221 .54105 m
.36408 .54934 L
s
P
p
1 0 .6 r
.00125 w
.36408 .54934 m
.35676 .5568 L
s
P
p
1 0 .6 r
.00125 w
.36408 .54934 m
.3594 .55084 L
s
P
p
1 0 .6 r
.00177 w
.41733 .48696 m
.41455 .48205 L
s
P
p
1 0 .6 r
.00177 w
.41733 .48696 m
.41219 .48855 L
s
P
p
1 0 .6 r
.0025 w
.42697 .47438 m
.42005 .46199 L
s
P
p
1 0 .6 r
.0025 w
.42697 .47438 m
.43331 .45879 L
s
P
p
1 0 .6 r
.00177 w
.40757 .49638 m
.39595 .49999 L
s
P
p
1 0 .6 r
.00177 w
.40757 .49638 m
.39944 .50466 L
s
P
p
1 0 .6 r
.00125 w
.39944 .50466 m
.39212 .51211 L
s
P
p
1 0 .6 r
.00125 w
.39944 .50466 m
.39479 .50611 L
s
P
p
1 0 .6 r
.005 w
.60062 .80942 m
.6014 .92426 L
s
P
p
1 0 .6 r
.00125 w
.41219 .48855 m
.40755 .48999 L
s
P
p
1 0 .6 r
.00125 w
.41219 .48855 m
.41107 .48659 L
s
P
p
1 0 .6 r
.00125 w
.27181 .65009 m
.24745 .65829 L
s
P
p
1 0 .6 r
.00125 w
.27181 .65009 m
.2655 .64086 L
s
P
p
1 0 .6 r
.00125 w
.36052 .54478 m
.34993 .54816 L
s
P
p
1 0 .6 r
.00125 w
.36052 .54478 m
.3579 .54047 L
s
P
p
1 0 .6 r
.00125 w
.41455 .48205 m
.41204 .47761 L
s
P
p
1 0 .6 r
.00125 w
.41455 .48205 m
.41682 .47644 L
s
P
p
1 0 .6 r
.00177 w
.43331 .45879 m
.43904 .4447 L
s
P
p
1 0 .6 r
.00177 w
.43331 .45879 m
.43056 .4538 L
s
P
p
1 0 .6 r
.0025 w
.37536 .52419 m
.34591 .53347 L
s
P
p
1 0 .6 r
.0025 w
.37536 .52419 m
.36813 .51205 L
s
P
p
1 0 .6 r
.00125 w
.39595 .49999 m
.38545 .50326 L
s
P
p
1 0 .6 r
.00125 w
.39595 .49999 m
.3934 .49559 L
s
P
p
1 0 .6 r
.00125 w
.43904 .4447 m
.44637 .43724 L
s
P
p
1 0 .6 r
.00125 w
.43904 .4447 m
.44422 .43197 L
s
P
p
1 0 .6 r
.00125 w
.43056 .4538 m
.42807 .4493 L
s
P
p
1 0 .6 r
.00125 w
.43056 .4538 m
.43285 .44816 L
s
P
p
1 0 .6 r
.00177 w
.42005 .46199 m
.41376 .45072 L
s
P
p
1 0 .6 r
.00177 w
.42005 .46199 m
.40841 .46553 L
s
P
p
1 0 .6 r
.005 w
.58173 .7198 m
.56497 .7527 L
s
P
p
1 0 .6 r
.005 w
.58173 .7198 m
.6112 .73073 L
s
P
p
1 0 .6 r
.00125 w
.40841 .46553 m
.39787 .46873 L
s
P
p
1 0 .6 r
.00125 w
.40841 .46553 m
.40587 .46103 L
s
P
p
1 0 .6 r
.00177 w
.36813 .51205 m
.36155 .501 L
s
P
p
1 0 .6 r
.00177 w
.36813 .51205 m
.35631 .51573 L
s
P
p
1 0 .6 r
.00177 w
.34591 .53347 m
.31905 .54194 L
s
P
p
1 0 .6 r
.00177 w
.34591 .53347 m
.32739 .55231 L
s
P
p
1 0 .6 r
.00125 w
.71229 1.01995 m
.72064 1.02712 L
s
P
p
1 0 .6 r
.00125 w
.32739 .55231 m
.31071 .56928 L
s
P
p
1 0 .6 r
.00125 w
.32739 .55231 m
.31664 .55573 L
s
P
p
1 0 .6 r
.00353 w
.6014 .92426 m
.60212 1.02955 L
s
P
p
1 0 .6 r
.00353 w
.6014 .92426 m
.65079 .96693 L
s
P
p
1 0 .6 r
.00125 w
.41376 .45072 m
.40804 .44048 L
s
P
p
1 0 .6 r
.00125 w
.41376 .45072 m
.41892 .43792 L
s
P
p
1 0 .6 r
.00125 w
.35631 .51573 m
.34562 .51907 L
s
P
p
1 0 .6 r
.00125 w
.35631 .51573 m
.35365 .51132 L
s
P
p
1 0 .6 r
.00125 w
.71229 1.01995 m
.73835 1.04242 L
s
P
p
1 0 .6 r
.00125 w
.36155 .501 m
.35557 .49097 L
s
P
p
1 0 .6 r
.00125 w
.36155 .501 m
.36663 .48826 L
s
P
p
1 0 .6 r
.00177 w
.68323 .99489 m
.71229 1.01995 L
s
P
p
1 0 .6 r
.00125 w
.31905 .54194 m
.2946 .54964 L
s
P
p
1 0 .6 r
.00125 w
.31905 .54194 m
.31286 .53207 L
s
P
p
1 0 .6 r
.00177 w
.68323 .99489 m
.70126 1.01048 L
s
P
p
1 0 .6 r
.0025 w
.65079 .96693 m
.68323 .99489 L
s
P
p
1 0 .6 r
.00353 w
.6112 .73073 m
.63822 .74074 L
s
P
p
1 0 .6 r
.00353 w
.6112 .73073 m
.60468 .74396 L
s
P
p
1 0 .6 r
.00125 w
.70126 1.01048 m
.71292 1.02053 L
s
P
p
1 0 .6 r
.0025 w
.65079 .96693 m
.69594 1.00594 L
s
P
p
1 0 .6 r
.00125 w
.70126 1.01048 m
.71758 1.02458 L
s
P
p
1 0 .6 r
.00125 w
.6223 1.17854 m
.60752 1.20415 L
s
P
p
1 0 .6 r
.0025 w
.60212 1.02955 m
.60278 1.12594 L
s
P
p
1 0 .6 r
.0025 w
.60212 1.02955 m
.55773 1.06968 L
s
P
p
1 0 .6 r
.00125 w
.6223 1.17854 m
.63972 1.22552 L
s
P
p
1 0 .6 r
.00353 w
.56497 .7527 m
.54942 .7832 L
s
P
p
1 0 .6 r
.00353 w
.56497 .7527 m
.52379 .77096 L
s
P
p
1 0 .6 r
.0025 w
.60468 .74396 m
.59874 .75601 L
s
P
p
1 0 .6 r
.0025 w
.60468 .74396 m
.61547 .74801 L
s
P
p
1 0 .6 r
.00177 w
.60278 1.12594 m
.6223 1.17854 L
s
P
p
1 0 .6 r
.0025 w
.63822 .74074 m
.66294 .7499 L
s
P
p
1 0 .6 r
.0025 w
.63822 .74074 m
.66712 .73731 L
s
P
p
1 0 .6 r
.00177 w
.69594 1.00594 m
.73714 1.04155 L
s
P
p
1 0 .6 r
.00177 w
.69594 1.00594 m
.70522 1.01402 L
s
P
p
1 0 .6 r
.00177 w
.61547 .74801 m
.62525 .75169 L
s
P
p
1 0 .6 r
.00177 w
.61547 .74801 m
.61312 .75284 L
s
P
p
1 0 .6 r
.00177 w
.55773 1.06968 m
.51723 1.10628 L
s
P
p
1 0 .6 r
.00177 w
.55773 1.06968 m
.54868 1.07842 L
s
P
p
1 0 .6 r
.00177 w
.66712 .73731 m
.69323 .73421 L
s
P
p
1 0 .6 r
.00177 w
.66712 .73731 m
.67707 .74095 L
s
P
p
1 0 .6 r
.0025 w
.52379 .77096 m
.48641 .78754 L
s
P
p
1 0 .6 r
.0025 w
.52379 .77096 m
.51736 .78322 L
s
P
p
1 0 .6 r
.00125 w
.69323 .73421 m
.70638 .72832 L
s
P
p
1 0 .6 r
.00177 w
.60278 1.12594 m
.60339 1.21404 L
s
P
p
1 0 .6 r
.00125 w
.46057 .79056 m
.43739 .79327 L
s
P
p
1 0 .6 r
.00177 w
.59874 .75601 m
.59333 .76697 L
s
P
p
1 0 .6 r
.00177 w
.59874 .75601 m
.58393 .76261 L
s
P
p
1 0 .6 r
.00125 w
.61312 .75284 m
.61099 .75721 L
s
P
p
1 0 .6 r
.00125 w
.61312 .75284 m
.61703 .75432 L
s
P
p
1 0 .6 r
.00125 w
.69323 .73421 m
.71679 .73141 L
s
P
p
1 0 .6 r
.00125 w
.62525 .75169 m
.63411 .75501 L
s
P
p
1 0 .6 r
.00125 w
.62525 .75169 m
.63568 .75045 L
s
P
p
1 0 .6 r
.00125 w
.46057 .79056 m
.44702 .79656 L
s
P
p
1 0 .6 r
.00177 w
.48641 .78754 m
.46057 .79056 L
s
P
p
1 0 .6 r
.00125 w
.58393 .76261 m
.57055 .76857 L
s
P
p
1 0 .6 r
.00125 w
.58393 .76261 m
.58174 .767 L
s
P
p
1 0 .6 r
.00125 w
.67707 .74095 m
.68608 .74425 L
s
P
p
1 0 .6 r
.00125 w
.67707 .74095 m
.68754 .73971 L
s
P
p
1 0 .6 r
.00125 w
.51723 1.10628 m
.49113 1.12936 L
s
P
p
1 0 .6 r
.00125 w
.73714 1.04155 m
.76363 1.06439 L
s
P
p
1 0 .6 r
.00177 w
.48641 .78754 m
.4525 .80258 L
s
P
p
1 0 .6 r
.00125 w
.73714 1.04155 m
.7747 1.074 L
s
P
p
1 0 .6 r
.00125 w
.51723 1.10628 m
.48034 1.13962 L
s
P
p
1 0 .6 r
.00177 w
.51736 .78322 m
.51152 .79437 L
s
P
p
1 0 .6 r
.00177 w
.51736 .78322 m
.50235 .78989 L
s
P
p
1 0 .6 r
.00177 w
.66294 .7499 m
.68552 .75827 L
s
P
p
1 0 .6 r
.00177 w
.66294 .7499 m
.65784 .76088 L
s
P
p
1 0 .6 r
.00125 w
.59333 .76697 m
.58842 .77694 L
s
P
p
1 0 .6 r
.00125 w
.59333 .76697 m
.60213 .77036 L
s
P
p
1 0 .6 r
.00125 w
.70522 1.01402 m
.71371 1.02142 L
s
P
p
1 0 .6 r
.00125 w
.70522 1.01402 m
.7218 1.02835 L
s
P
p
1 0 .6 r
.00125 w
.50235 .78989 m
.4888 .79592 L
s
P
p
1 0 .6 r
.00125 w
.50235 .78989 m
.49999 .79436 L
s
P
p
1 0 .6 r
.00125 w
.54868 1.07842 m
.54042 1.08642 L
s
P
p
1 0 .6 r
.00125 w
.54868 1.07842 m
.53239 1.09315 L
s
P
p
1 0 .6 r
.00125 w
.60339 1.21404 m
.60394 1.29443 L
s
P
p
1 0 .6 r
.00125 w
.60339 1.21404 m
.61447 1.24118 L
s
P
p
1 0 .6 r
.00125 w
.4525 .80258 m
.42177 .81621 L
s
P
p
1 0 .6 r
.00125 w
.4525 .80258 m
.44693 .81272 L
s
P
p
1 0 .6 r
.0025 w
.54942 .7832 m
.53504 .81141 L
s
P
p
1 0 .6 r
.0025 w
.54942 .7832 m
.57371 .79281 L
s
P
p
1 0 .6 r
.00125 w
.51152 .79437 m
.5062 .80451 L
s
P
p
1 0 .6 r
.00125 w
.51152 .79437 m
.52012 .79785 L
s
P
p
1 0 .6 r
.00125 w
.65784 .76088 m
.6532 .77087 L
s
P
p
1 0 .6 r
.00125 w
.65784 .76088 m
.66687 .76427 L
s
P
p
1 0 .6 r
.00125 w
.68552 .75827 m
.70613 .76591 L
s
P
p
1 0 .6 r
.00125 w
.68552 .75827 m
.70936 .75547 L
s
P
p
1 0 .6 r
.00177 w
.57371 .79281 m
.59592 .8016 L
s
P
p
1 0 .6 r
.00177 w
.57371 .79281 m
.56809 .80415 L
s
P
p
1 0 .6 r
.00177 w
.53504 .81141 m
.52178 .83744 L
s
P
p
1 0 .6 r
.00177 w
.53504 .81141 m
.50069 .82682 L
s
P
p
1 0 .6 r
.00125 w
.56809 .80415 m
.56298 .81445 L
s
P
p
1 0 .6 r
.00125 w
.56809 .80415 m
.57696 .8077 L
s
P
p
1 0 .6 r
.00125 w
.59592 .8016 m
.61617 .80961 L
s
P
p
1 0 .6 r
.00125 w
.59592 .8016 m
.61989 .79883 L
s
P
p
1 0 .6 r
.00125 w
.50069 .82682 m
.46954 .84079 L
s
P
p
1 0 .6 r
.00125 w
.50069 .82682 m
.49524 .83727 L
s
P
p
1 0 .6 r
.00125 w
.52178 .83744 m
.50957 .8614 L
s
P
p
1 0 .6 r
.00125 w
.52178 .83744 m
.54174 .84577 L
s
P
p
1 g
.002 w
.83773 .0357 m
.87192 1.21206 L
s
.87192 1.21206 m
.0357 1.26444 L
s
.0357 1.26444 m
.08137 .12136 L
s
.08137 .12136 m
.83773 .0357 L
s
.83773 .0357 m
.87192 1.21206 L
s
.87192 1.21206 m
.9643 1.3844 L
s
.9643 1.3844 m
.92577 .31981 L
s
.92577 .31981 m
.83773 .0357 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    CellMargins->{{Inherited, 337}, {Inherited, Inherited}},
    Evaluatable->False,
    AspectRatioFixed->True,
    ImageSize->{163, 178},
    ImageMargins->{{0, 0}, {0, 1}},
    ImageRegion->{{0, 1}, {0, 1}},
    AnimationDisplayTime->5,
    AnimationCycleOffset->-8,
    AnimationCycleRepetitions->Infinity,
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000M=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61P00:=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000JlH900G600<0a/H09/H1000006;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaPT003O4e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001IaPT02/H00lC6aP0:aP809lH10000053Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT0
0236e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6eP8002O6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0004O62@04aP03a<K601G600?4a/H02/H202O60@00000ne/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9001K
a]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]H0eP3Fa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000=LH90003a<K601C600?4a/H05LH00lC6
aP09aP030<H002K60@00000/e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H90012a]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K4e/KFa]K6e/KF0/@0:@340<C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000SaPT04lH00lC6aP0DaP03a<K601C62/@2aP040<K602G60@00000Ne/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K61@00@<KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa/C6e/KFa]K6e/KFa]H:a00ea/C6e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001k600<0a/H02LH00lC6aP0CaP03a<K601C600?4a/@02L@;aP03
a<K600S600@0a/H09LH1000001kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2000_e/KFa]K6
e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]H02/@0BLKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K4e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@0001k600<0aP002/H00lC6aP0CaP04a<K6aP[42LH00lC6aP0DaP03a<K600O600D0a/K6000TaP40
0000>mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KF00[405g6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF
0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001k600@0a/H02/H00lC6
aP02aP[41lH00lC6aP0DaP03a<K601C600?4a/H01lH01@36a/H002?60@00000We/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KF00[40776e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K60<KFaP36e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007/H01036a/H5a0K600?4a/H04lH00lC6aP0DaP03
a<K601?600?4a/H01lH01@36a/H002?60@00001ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]H0e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/H000C402<0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007/H00`36aP02aP030<K600S600?4a/H04lH00lC6aP0CaP03a<K601?6
2/@00`36aP02aP030<K602360@00001We/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
0<KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6eP09a00be/CFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100007/H00`36aP03aP030<K600W600?4a/H04/H00lC6aP0CaP03a<K400W42lH00lC6aP05aP03
0<K600?600<0a/H07lH1000005?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6eP08a0@004?6e/KFa]K6e/KF
a]K6e/KFa]K6a<KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000MaP030<K600K600<0a/H02<H00lC6aP0BaP04a<K6aPW41lH601;600?4a/H01LH00`36aP03aP03
0<K601o60@000010e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFaP[4013Fa]K6e/KFa]K6e/KFa]K61P00@]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K600O6
00<0a/H02<H01<C6a/H:a0O600?4a/H04<H601?600?4a/H01<H00`36aP04aP030<K601k60@00000]
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KF00W402CFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/H60012e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/H0a]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001g600<0a/H02<H5a0K600?4a/H0
4/H00lC6aP0@aP@05LH00lC6aP03aP030<K600G600<0a/H07LH1000005_Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KF008o0236a<KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFaP36ePG40200a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K600W600<0a/H02<H00lC6aP0BaP03
a<K600o600DoClK6a00DaPK400<0a<@01LH00`36aP0MaP400000FmK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6
e/KFa]K6e/KFa]H00Sl03/KFa=K6e/KFa]K6e/KF2L@0;]K4e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36aP0:aP030<K600S600?4a/H04/H00lC6aP0>aP03
?do600;62l@:aP03a<K600;600<0a/H01/H00`36aP0LaP400000F=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/H3a08o1<@0@LKFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/H0a]K6e/KFa]H0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000MaP030<K600c600<0a/H02<H00lC6aP0AaP04a<K6aPW4
0lH00cm?aP03aP03a<K601;600G4a/K60009aP030<K601_60@000015e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KF00[400c6e/KF
a]K6e/KFa]H2?`0Ra]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/H0a]K6ePH001g6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100007LH00`36aP0=aP030<K600S600C4a/K62L@7aP03a<K600c6
00<oClH00lH00lC6aP0BaP03a00000H01LH00`36aP0KaP400000<mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6eP09a00Oe/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6eP02?`0@a]K6e/K4a]K6e/KFa]K6ePT002cFa=K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K600k61L@6aP03a<K6017600?4a/H02lH00cm?aP04aP03
a<H000P03LH00`36aP07aP030<K601_60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
eP02?`H003o4e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001g600<0a/H03lH00`36aP08aP03a<K6017600C4a/K62@000cm?aP0LaP03
0<K600O600<0a/H06lH1000004WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KF00H000c4003Fa]K6e/KFa]H2?`15a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000MaP030<K6013600<0a/H02<H00lC6aP02aPT04/H00cm?aP0LaP030<K600O600<0a/H0
6lH1000003OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KF00D001o40000e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o04G6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001g6
00<0a/H04/H502C600<oClH07<H00`36aP07aP030<K601_60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP02?`15a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000MaP030<K601;600<0a/H09/H00cm?aP0MaP03
0<K600K600<0a/H06lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100007<H00`36aP0CaP030<K602C600@oa/I?7/H00`36aP06aP030<K601_60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6e/KFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04lH00`36aP0@aP05
?lHoaSl03LH00co6aP02aP03ClK601c600<0a/H01lH00`36aP0JaP400000B=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/HoaP8o
05SFa]K6e/KFa]K6e/Hoa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04lH00`36aP0@aP04?dloC`c6
00<oa/H01<H00do6aP0LaP030<K600O600<0a/H06/H1000004CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP8o05cF?co6e/KFa]K6
e/KFaSo6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000LaP030<K601?600<0a/H04LH00do6C`09aP03Cco600O6
00=?a/H07<H00`36aP07aP030<K601[60@00001?e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaSo6?lKFa]K6eP03?`1@eSoFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100007<H00`36aP0CaP030<K600[600<oClH00lH01Cm??dlo00;600=??dl0
0lH00do6aP07aP03ClK601c600<0a/H01lH00`36aP0JaP400000@mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/Hoa]H00cl00mK6eP03?`1F
eSoFa]Hoe/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36aP0CaP030<K600[600<oClH00/H01Do6
Ccm?00?600E?a/K6C`0;aP03ClK601c600<0a/H01lH00`36aP0JaP400000?]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K613l00mHo?`03?`1J
e/Ho?mK6eSoFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04lH00`36aP0;aP03Ccm?00;6
00HoCcm??dl3aP03ClK600_600=?a/H07<H00`36aP07aP030<K601[60@00000me/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaSo6eP03?`04e/KFaPHo
05SFa]Hoe/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04lH00`36aP05aP0?Ccm??lHo
Ccm??dloCcm?00?600=?a/H03LH00do6aP0LaP030<K600O600<0a/H06/H1000003SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP8o00CF?co613l00mK6
?`04?`1Ia]Hoe/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF
a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001c600<0a/H04lH00`36aP05aP03
Cco600;600<oClH00lH00cm??`02aP03Cco600o600=?a/H07<H00`36aP07aP030<K601[60@00000o
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaSo6
e/KF008o00C6e/KF0cl05=Ho?lKFa]K6e/KFa]K6e/KFa]K60Sl0A=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H0
4/H00`36aP0:aP0=Cco6?dloCcm?aTo6C`0AaP03ClI?01c600<0a/H01lH00`36aP0JaP400000@]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]Ho
eSoFaPHo05[FaSo6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36aP0BaP030<K600S6
00=?a/H01<H013o6aTl2aP03?lK6013600E?a/K6C`0JaP030<K600O600<0a/H06/H1000004SFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]HoeSoFa]K6
e/Hoa]Hoe/H2?`1He/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601?600<0a/H0
1/H00do6aP02aP06?dloCcm?0/H00cm?aP0BaP03ClK600?600=?a/H05/H00`36aP07aP030<K601[6
0@000010e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFaSo6e/KFaP@o05kFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001_600<0a/H0
4lH00`36aP04aP04Ccm??`;600E??do6C`02aP04?do6CaC600<oa/H01<H00do6aP0DaP030<K600O6
00<0a/H06/H1000003[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K61Cl01LKF?mK6008o05cF?mK6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000KaP030<K601?600@0a/I?0/H00cm??`02aP0<Cco6aTloCcm??lHo5LH00co6aP04aP03Cco601G6
00<0a/H01/H00`36aP0JaP400000==K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/H4?`03e/Ho008o00?6eSl01cl00lHoaP02?`1Fe/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100006lH00`36aP0CaP0304lo00;600I?a/HoCcl2aP0=ClI??do6Ccm??lHoC`0BaP03
?lK600C600=?aTl05LH00`36aP07aP030<K601W60@00000ie/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]Hoe/KF008o00S6eSoFa]HoeP8o00?6?cl00Sl0F=K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6?lKF?mK6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006lH00`36aP0CaP040<K6C`C600DoClI??`02aP0;
ClK6?lHoCco6?dl04/H00co6aP04aP05ClK6aTl04lH00`36aP07aP030<K601W60@00000he/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H5?`07aSlo?lKF
aP03?`0Ma]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/H00Sl0?=K6?lKFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601?600<0a/H0
0lH023o6?do6ClI?1<H00cm?aP0GaP03?lK600C600=?aTl00/H00co6aP0@aP030<K600O600<0a/H0
6LH1000004;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/Hoa]HoeSoF?mK6e/H2?`0He/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl03=K6e/KFa]HoeSoFaP8o
03KFa]K6e/KFa]K6e/Hoa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
6lH00`36aP0CaP030<K600C600A?a/Ho1<H014loCclGaP03?lHo00O600<oaSl00/H01Do6Ccm?00W6
00E??lK60009aP030<K601W60@00000fe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K60Sl01mK6?coFa]H00cl08]Ho?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
eSoFa]K6e/H2?`09eSloa]Hoe/KF008o00K6e/KFa]H2?`0Ya]K60<KFa]K6e/KFaP36e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001_600<0a/H04lH02P36?dloaSo6?dl4aP07?lK6ClI??`0DaP05
Ccm??dl00lH02dloaSo6?lHoClI?00?600Y??dloaSm??dlo0/H00`36aP07aP030<K601W60@00000`
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K613l01=K6?lH3?`0R
a]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6ePDo00GF?mHoeP07?`06e/KF?mK613l0:]Ho
e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K6017600@oC`1?
0/H01So6?do6C`K600<oClH05LH05So6a/HoCco6?dloCcm??dloClI??dl3aP03Cco600?600E??do6
0009aP030<K601W60@00000]e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KF008o00W6?coFaSo6?lH00Sl01]Hoe/KFaP8o01_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]H0
0cl00mHo?`05?`03eSoF00<o00KF?mK6?lH3?`06a]HoeSl00Sl08lKFa]K6e/H0a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000KaP030<K601;600I?0<HoaSl3aP03?dlo00G600<oa/H04lH00cm?
aP02aP0@Ccm??dloaSm??lHoCcm??`C600Q?a/HoaSo6?`;600E?aP0oC`07aP030<K601W60@00001D
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]HoeP0oa]K6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl00lHoaP04?`05e/KFa]H013l01<KF?mH2?`07a]K6?lKF
aP02?`04e/KFaP8o00<0a]H00Sl08LKFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
6lH00`36aP0CaP03?do600?600<oClH06<H00dloaP02aP03?lHo00;600=??lH01<H01Co6?lHo00?6
00LoCcm??dlo00;600=??lH01<H00cl0aP08aP030<K601W60@00000`e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60Sl01=K6e/H2?`0He/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K613l08=K6?coFa]HoeSoFa]K6e/KF?mHoe/KFa]K6?lHoaSo60cl0:lKFa]K60<KFa]K6e/KF
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001_600<0a/H04LH00cm?0005aP03?lK60176
00ToCcm??dloaSl00/H00do6C`04aP03?lK600G600@oaSm?1/H01Sm?a/HoC`;600<oa/H00/H00`36
aP07aP030<K601W60@00000^e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFaP<o01P0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H2?`06aSloeSoF0cl01MK6?lKF00<o00KF?clo
e/H4?`03eSlo008o03O6e/KFaSo6eSoFa]K6?lKFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000JaP030<K600o600I??do6C`0GaP03?dlo00G600Doa/K6?`03aP06?do6Ccm?
1LH00do6C`03aP03ClK600?600E??lK6C`07aP030<K600O600<0a/H06LH1000002[Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H2?`0Ke/KF?mH0e/KFa]K6e/KFa]K6e/KFa]K6
e/KF008o00_6?lKFa]K6e/KFaP02?`0Oe/Hoa]K6eSoF?mK6e/KFaSo6e/KF?mK6e/HoaSo6eP02?`0[
a]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006/H00`36aP0=aP03
ClK600;600<oaP008<H014loaSl7aP03?lK600K600=?a/H02<H02Co6?lHoaSm??`02aP030<K600O6
00<0a/H06LH1000004oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eSoFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00[FaSo6e/KFa]K60Sl02=K6e/KFa]K6
0Sl02=K6e/KFa]K60Sl02=Hoe/Hoa]K60Sl09P36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001[600<0a/H02lH00do6aP06aP030<K601W600@oClI?0/H00cm??`06aP03Cco600O6
00=?a/H01/H02Co6?lHoCco6?`03aP05?`0oaSl01/H00`36aP0IaP400000G=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6?lKFa]K60Sl04=K6e/KFa]K6e/KFa]K6e/H2?`05eSoF?mH00Sl01lHoa]K60<H0
0cl08LKFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006/H00`36aP0DaP030<K601k6
00=?a/H01/H00co6?`0CaP03?lK600;600A?a/Ho0/H00`0oaP02aP03?lK600?600<0a/H06<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFaSo6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006/H00`36aP0DaP03
0<K602O600<oaSl04lH00cm?aP06aP04ClK600W600<0a/H06<H1000005WFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP02?`0Oa]Hoe/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFaP02?`0VeP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006/H00`36aP0DaP030<K602?600@oClI?
0/H00co6aP0AaP03?lK600K600A?aTl02LH00`36aP0HaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHo0=K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000JaP030<K601C600<0a/H08<H00dloaP02aP05?lK6aSl0
7<H014loaP09aP030<K601S60@00001Be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o02[F?mK6eSoFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6?`03?`0Qa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000JaP030<K601?600<0a/H06<H00cm?aP03aP05?lK6aSl00/H00do6aP02aP03
?lK601[600E?a/H0C`02aP03?do600?600<0a/H06<H1000004gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP04?`0<
a]K6?lKFaSo6e/KF0Sl0@lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F?mK6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001[600<0a/H04lH00`36aP0IaP03ClI?00C600<oClH0
0/H00do6aP02aP03?lHo01g600@0a/I?1/H00`36aP0HaP400000DMK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
eP02?`1?aSo6eSoFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eSoFa]K6eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006/H00`36aP0CaP030<K601S600<oClH00/H014lo
aSl3aP03?lK600?600Doa/K6?`0KaP030<K600;600=?a/H00/H00`36aP0HaP400000BMK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00Sl03<Hoa]K6e/KF?mK6eP8o04W6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000JaP030<K601?600<0a/H0
5LH014o6aSl6aP07ClI?aTo6C`04aP03?lK600?600<oClH05lH00`36aP07aP030<K601S60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/Hoa]Hoe/KF?mK6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001W600<0a/H05<H00`36
aP0SaP04ClK6?`?600<oa/H01/H00do6aP0DaP030<K600O600<0a/H06<H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6?lHoa]Hoe/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0DaP030<K6027600E??lK6
C`02aP03?dlo00[600=?a/H04/H00`36aP07aP030<K601S60@00001He/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]HoeSoFaP8o00?F?mH00Sl0@lKFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF
a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001W600<0a/H05<H00`36aP0OaP03ClI?00;6
00<oa/H00/H00dloaP0;aP03ClK6013600<0a/H01lH00`36aP0HaP400000D=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60Sl02]K6?lKFa]K6e/H2?`14e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0DaP030<K601_600A??lHo
0/H00do6aP04aP03?lHo00k600=?a/H03/H00`36aP07aP030<K601S60@00001]e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/Hoa]Hoe/KFa]K6?lKF?mK6e/KFa]K6e/KFa]K6eP02?`0ca]K6e/KFa]K6e/KFa]H0e/KF
a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000IaP030<K601C600<0a/H08<H00co6
aP03aP05?lK6aSl04LH00co6aP0;aP030<K600O600<0a/H06<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0DaP030<K601o600=?aTl00/H00co6
aP03aP03?lK6017600<oa/H02LH00`36aP08aP030<K601O60@00001Fe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6?lH2?`1:e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0DaP030<K601o600E?a/HoC`06aP03
?lK601g600<0a/H02<H00`36aP0GaP400000E=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaP8o04cFa]K6
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0001W600<0a/H05<H00`36aP0NaP04?lK6C`S600<oa/H07/H00`36aP07aP03
0<K601O60@00001Be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04kFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
6LH00`36aP0DaP030<K601g600=??lH02/H00co6aP0NaP030<K600O600<0a/H05lH1000004oFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF008o0576e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001W600<0a/H05<H00`36
aP0LaP03?lK600_600<oa/H07/H00`36aP07aP030<K601O60@00001Me/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6e/KF008o04?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000IaP030<K601C600<0a/H0:/H00cm?aP0NaP03
0<K600O600<0a/H05lH1000005gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl0@lKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001W600<0a/H05<H00`36aP0ZaP03?lHo01k600<0a/H01lH00`36aP0GaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000HaP030<K601G600<0a/H0
:/H00co6?`0NaP030<K600O600<0a/H05lH1000005gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00Sl0@lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001S600<0a/H05LH00`36aP0ZaP04?do6Cag600<0a/H01lH00`36
aP0GaP400000MmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00P002?6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006<H00`36
aP0EaP030<K602[600Doa/K6?`06aPl01lH00`36aP07aP030<K601O60@00001Je/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K63P00>]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100006<H00`36aP0EaP030<K601S63`03aP03?do601o600<0a/H0
1/H00`36aP0GaP400000?=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFaPl001;6e/KFa]K6e/KFa]K6e/KFa]H2?`13a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006<H00`36
aP0CaPh08LH00co6aP0PaP030<K600G600<0a/H05lH1000001oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KF00l007CF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000HaPL04<H00`36aP0[aP03?lK6027600<0a/H01<H00`36aP0GaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K6017600<0a/H0
:lH00co6aP0RaP030<K600C600<0a/H05/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100007LH00`36aP0?aP030<K605;600<0a/H00/H00`36aP0FaP4000007]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8008;Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H03<H00`36
aP1CaP050<K6aP006<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008/H00`36aP0:aP030<K605C600@0a/H06<H1000002?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP02001ma]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002G600<0a/H01lH00`36aP1EaP030<H001S60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H01LH00`36
aP1FaP806<H1000008SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P006=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000YaP801<H00`36aP1>aPX06<H1000006kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaQ8002;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002c6
00@0a/H0;<HB03C60@00001:e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HB0016e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000^aP802<HB05S6
0@00000_e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02@00J]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
    ImageRangeCache->{{{0, 162}, {177, 0}} -> {0, 0, 0, 0}}],
  " ",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.03357 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.00655807 1.07553 0.0268882 1.07553 [
[ 0 0 0 0 ]
[ 1 1.03357 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.03357 L
0 1.03357 L
closepath
clip
newpath
p
1 g
.002 w
.8517 .02689 m
.88114 .72344 L
s
.88114 .72344 m
.02689 .78484 L
s
.02689 .78484 m
.06986 .11778 L
s
.06986 .11778 m
.8517 .02689 L
s
.94317 .39493 m
.3086 .45352 L
s
.3086 .45352 m
.29167 1.00668 L
s
.29167 1.00668 m
.97311 .96851 L
s
.97311 .96851 m
.94317 .39493 L
s
.8517 .02689 m
.88114 .72344 L
s
.88114 .72344 m
.97311 .96851 L
s
.97311 .96851 m
.94317 .39493 L
s
.94317 .39493 m
.8517 .02689 L
s
.06986 .11778 m
.3086 .45352 L
s
.3086 .45352 m
.29167 1.00668 L
s
.29167 1.00668 m
.02689 .78484 L
s
.02689 .78484 m
.06986 .11778 L
s
p
.4 g
.85664 .04676 m
.08263 .13573 L
s
P
p
.4 g
.88238 .15031 m
.14939 .22962 L
s
P
p
.4 g
.90533 .24265 m
.20924 .31379 L
s
P
p
.4 g
.92592 .32552 m
.26321 .38968 L
s
P
p
.4 g
.68327 .04647 m
.80754 .40745 L
s
P
p
.4 g
.47605 .07056 m
.63987 .42293 L
s
P
p
.4 g
.27427 .09402 m
.47574 .43809 L
s
P
p
.4 g
.07772 .11687 m
.31504 .45293 L
s
P
P
p
1 0 .6 r
.00088 w
.46447 .6533 m
.47257 .66487 L
s
P
p
1 0 .6 r
.00088 w
.46447 .6533 m
.4868 .64436 L
s
P
p
1 0 .6 r
.00088 w
.4822 .62769 m
.49014 .63953 L
s
P
p
1 0 .6 r
.00088 w
.44314 .66875 m
.45148 .68022 L
s
P
p
1 0 .6 r
.00088 w
.4822 .62769 m
.50444 .61893 L
s
P
p
1 0 .6 r
.00088 w
.43812 .6724 m
.44651 .68384 L
s
P
p
1 0 .6 r
.00088 w
.49823 .60454 m
.52039 .59594 L
s
P
p
1 0 .6 r
.00088 w
.53447 .6717 m
.51757 .68188 L
s
P
p
1 0 .6 r
.00088 w
.43812 .6724 m
.46076 .66326 L
s
P
p
1 0 .6 r
.00088 w
.44314 .66875 m
.43235 .69415 L
s
P
p
1 0 .6 r
.00088 w
.55658 .68958 m
.53945 .69963 L
s
P
p
1 0 .6 r
.00088 w
.41656 .68801 m
.4252 .69936 L
s
P
p
1 0 .6 r
.00088 w
.56178 .69379 m
.5446 .7038 L
s
P
p
1 0 .6 r
.00088 w
.53447 .6717 m
.50771 .65997 L
s
P
p
1 0 .6 r
.00125 w
.45529 .64018 m
.46447 .6533 L
s
P
p
1 0 .6 r
.00088 w
.52224 .64435 m
.50539 .65481 L
s
P
p
1 0 .6 r
.00088 w
.4085 .69385 m
.41723 .70516 L
s
P
p
1 0 .6 r
.00088 w
.55658 .68958 m
.55923 .71567 L
s
P
p
1 0 .6 r
.00088 w
.58401 .71177 m
.5666 .72165 L
s
P
p
1 0 .6 r
.00125 w
.47319 .61426 m
.4822 .62769 L
s
P
p
1 0 .6 r
.00088 w
.56178 .69379 m
.53479 .68189 L
s
P
p
1 0 .6 r
.00088 w
.59231 .71848 m
.57481 .72831 L
s
P
p
1 0 .6 r
.00088 w
.49823 .60454 m
.52191 .5801 L
s
P
p
1 0 .6 r
.00088 w
.4085 .69385 m
.43151 .68449 L
s
P
p
1 0 .6 r
.00088 w
.41656 .68801 m
.40587 .71343 L
s
P
p
1 0 .6 r
.00088 w
.52224 .64435 m
.49545 .63273 L
s
P
p
1 0 .6 r
.00088 w
.58401 .71177 m
.58649 .73779 L
s
P
p
1 0 .6 r
.00125 w
.45529 .64018 m
.44314 .66875 L
s
P
p
1 0 .6 r
.00088 w
.3924 .70552 m
.40131 .71675 L
s
P
p
1 0 .6 r
.00125 w
.47319 .61426 m
.49823 .60454 L
s
P
p
1 0 .6 r
.00088 w
.60884 .73185 m
.59117 .74158 L
s
P
p
1 0 .6 r
.00125 w
.4286 .65941 m
.43812 .6724 L
s
P
p
1 0 .6 r
.00088 w
.61468 .73657 m
.59695 .74627 L
s
P
p
1 0 .6 r
.00088 w
.3867 .70965 m
.39568 .72085 L
s
P
p
1 0 .6 r
.00125 w
.55359 .66018 m
.53447 .6717 L
s
P
p
1 0 .6 r
.00088 w
.59231 .71848 m
.56506 .7064 L
s
P
p
1 0 .6 r
.00088 w
.60884 .73185 m
.61116 .7578 L
s
P
p
1 0 .6 r
.00088 w
.51116 .61957 m
.48434 .60804 L
s
P
p
1 0 .6 r
.00088 w
.61468 .73657 m
.61696 .76251 L
s
P
p
1 0 .6 r
.00088 w
.63967 .75678 m
.62167 .76633 L
s
P
p
1 0 .6 r
.00125 w
.55359 .66018 m
.55658 .68958 L
s
P
p
1 0 .6 r
.00088 w
.3924 .70552 m
.3818 .73095 L
s
P
p
1 0 .6 r
.00125 w
.58123 .68245 m
.56178 .69379 L
s
P
p
1 0 .6 r
.00088 w
.3867 .70965 m
.37612 .73509 L
s
P
p
1 0 .6 r
.00125 w
.54132 .63253 m
.52224 .64435 L
s
P
p
1 0 .6 r
.00125 w
.4286 .65941 m
.41656 .68801 L
s
P
p
1 0 .6 r
.00088 w
.63967 .75678 m
.64179 .78265 L
s
P
p
1 0 .6 r
.00088 w
.36225 .72737 m
.37151 .73844 L
s
P
p
1 0 .6 r
.00125 w
.58123 .68245 m
.58401 .71177 L
s
P
p
1 0 .6 r
.00177 w
.44485 .62526 m
.45529 .64018 L
s
P
p
1 0 .6 r
.00125 w
.3986 .68103 m
.4085 .69385 L
s
P
p
1 0 .6 r
.00125 w
.61212 .70735 m
.59231 .71848 L
s
P
p
1 0 .6 r
.00088 w
.51116 .61957 m
.48997 .59237 L
s
P
p
1 0 .6 r
.00125 w
.54132 .63253 m
.51116 .61957 L
s
P
p
1 0 .6 r
.00088 w
.62424 .72005 m
.60628 .72997 L
s
P
p
1 0 .6 r
.00177 w
.44485 .62526 m
.47319 .61426 L
s
P
p
1 0 .6 r
.00125 w
.60623 .7026 m
.60884 .73185 L
s
P
p
1 0 .6 r
.00088 w
.62987 .73297 m
.63206 .75909 L
s
P
p
1 0 .6 r
.00088 w
.38577 .69244 m
.39483 .7039 L
s
P
p
1 0 .6 r
.00125 w
.61212 .70735 m
.61468 .73657 L
s
P
p
1 0 .6 r
.00088 w
.36225 .72737 m
.35177 .75282 L
s
P
p
1 0 .6 r
.00125 w
.40433 .6769 m
.3924 .70552 L
s
P
p
1 0 .6 r
.00125 w
.3986 .68103 m
.3867 .70965 L
s
P
p
1 0 .6 r
.00177 w
.57529 .64712 m
.55359 .66018 L
s
P
p
1 0 .6 r
.00088 w
.64692 .73834 m
.62872 .74812 L
s
P
p
1 0 .6 r
.00088 w
.38577 .69244 m
.40925 .68298 L
s
P
p
1 0 .6 r
.00088 w
.66601 .75838 m
.64763 .76799 L
s
P
p
1 0 .6 r
.00088 w
.62424 .72005 m
.59653 .70785 L
s
P
p
1 0 .6 r
.00177 w
.41778 .64465 m
.4286 .65941 L
s
P
p
1 0 .6 r
.00088 w
.37737 .70469 m
.36677 .73034 L
s
P
p
1 0 .6 r
.00125 w
.63728 .72763 m
.63967 .75678 L
s
P
p
1 0 .6 r
.00088 w
.66097 .75807 m
.66296 .78411 L
s
P
p
1 0 .6 r
.00088 w
.64692 .73834 m
.64901 .76453 L
s
P
p
1 0 .6 r
.00088 w
.36359 .70844 m
.37291 .71979 L
s
P
p
1 0 .6 r
.00088 w
.67225 .75875 m
.65378 .76838 L
s
P
p
1 0 .6 r
.00088 w
.66601 .75838 m
.66797 .78445 L
s
P
p
1 0 .6 r
.00177 w
.60328 .66959 m
.58123 .68245 L
s
P
p
1 0 .6 r
.00177 w
.57529 .64712 m
.54132 .63253 L
s
P
p
1 0 .6 r
.00088 w
.62987 .73297 m
.65111 .76026 L
s
P
p
1 0 .6 r
.00125 w
.60623 .7026 m
.62987 .73297 L
s
P
p
1 0 .6 r
.00125 w
.37405 .69873 m
.36225 .72737 L
s
P
p
1 0 .6 r
.00088 w
.67225 .75875 m
.67417 .78488 L
s
P
p
1 0 .6 r
.00088 w
.34324 .72656 m
.35278 .73776 L
s
P
p
1 0 .6 r
.00177 w
.60328 .66959 m
.60623 .7026 L
s
P
p
1 0 .6 r
.00125 w
.40433 .6769 m
.37737 .70469 L
s
P
p
1 0 .6 r
.00177 w
.41778 .64465 m
.40433 .6769 L
s
P
p
1 0 .6 r
.00177 w
.63458 .69472 m
.61212 .70735 L
s
P
p
1 0 .6 r
.00088 w
.36359 .70844 m
.35302 .7342 L
s
P
p
1 0 .6 r
.00125 w
.64457 .70882 m
.62424 .72005 L
s
P
p
1 0 .6 r
.00177 w
.38735 .66645 m
.3986 .68103 L
s
P
p
1 0 .6 r
.00088 w
.34688 .72672 m
.33641 .75238 L
s
P
p
1 0 .6 r
.00088 w
.37737 .70469 m
.35304 .72978 L
s
P
p
1 0 .6 r
.00088 w
.66097 .75807 m
.68226 .78543 L
s
P
p
1 0 .6 r
.00088 w
.33872 .72637 m
.34833 .7376 L
s
P
p
1 0 .6 r
.0025 w
.43295 .60824 m
.44485 .62526 L
s
P
p
1 0 .6 r
.00125 w
.63728 .72763 m
.66097 .75807 L
s
P
p
1 0 .6 r
.00125 w
.37549 .67944 m
.38577 .69244 L
s
P
p
1 0 .6 r
.00177 w
.63458 .69472 m
.63728 .72763 L
s
P
p
1 0 .6 r
.00125 w
.64457 .70882 m
.64692 .73834 L
s
P
p
1 0 .6 r
.00088 w
.34324 .72656 m
.33277 .75228 L
s
P
p
1 0 .6 r
.00088 w
.66049 .72183 m
.64201 .73185 L
s
P
p
1 0 .6 r
.00125 w
.66379 .72899 m
.66601 .75838 L
s
P
p
1 0 .6 r
.00088 w
.68766 .75969 m
.68949 .78593 L
s
P
p
1 0 .6 r
.0025 w
.59995 .63227 m
.57529 .64712 L
s
P
p
1 0 .6 r
.00088 w
.69913 .76038 m
.68027 .77008 L
s
P
p
1 0 .6 r
.00088 w
.33872 .72637 m
.32825 .75215 L
s
P
p
1 0 .6 r
.00088 w
.68352 .74034 m
.66479 .75021 L
s
P
p
1 0 .6 r
.00125 w
.67008 .72931 m
.67225 .75875 L
s
P
p
1 0 .6 r
.00088 w
.69399 .76007 m
.69578 .78636 L
s
P
p
1 0 .6 r
.00125 w
.37405 .69873 m
.34688 .72672 L
s
P
p
1 0 .6 r
.00177 w
.38735 .66645 m
.37405 .69873 L
s
P
p
1 0 .6 r
.00088 w
.66049 .72183 m
.63226 .70948 L
s
P
p
1 0 .6 r
.00088 w
.35983 .69084 m
.36928 .70247 L
s
P
p
1 0 .6 r
.00125 w
.37549 .67944 m
.36359 .70844 L
s
P
p
1 0 .6 r
.00088 w
.34688 .72672 m
.32236 .75198 L
s
P
p
1 0 .6 r
.00088 w
.69913 .76038 m
.70089 .78671 L
s
P
p
1 0 .6 r
.0025 w
.43295 .60824 m
.41778 .64465 L
s
P
p
1 0 .6 r
.00088 w
.68352 .74034 m
.68539 .76681 L
s
P
p
1 0 .6 r
.0025 w
.59995 .63227 m
.60328 .66959 L
s
P
p
1 0 .6 r
.00088 w
.70924 .76099 m
.69023 .77072 L
s
P
p
1 0 .6 r
.00088 w
.35983 .69084 m
.38385 .68125 L
s
P
p
1 0 .6 r
.00125 w
.35503 .69762 m
.34324 .72656 L
s
P
p
1 0 .6 r
.00088 w
.68766 .75969 m
.70911 .78728 L
s
P
p
1 0 .6 r
.00088 w
.70924 .76099 m
.71093 .7874 L
s
P
p
1 0 .6 r
.00125 w
.66379 .72899 m
.68766 .75969 L
s
P
p
1 0 .6 r
.00177 w
.66763 .69608 m
.64457 .70882 L
s
P
p
1 0 .6 r
.00088 w
.33722 .70705 m
.34694 .71857 L
s
P
p
1 0 .6 r
.0025 w
.63153 .65751 m
.63458 .69472 L
s
P
p
1 0 .6 r
.00177 w
.6613 .69582 m
.66379 .72899 L
s
P
p
1 0 .6 r
.00088 w
.71207 .76117 m
.71374 .78759 L
s
P
p
1 0 .6 r
.00088 w
.32755 .7259 m
.31709 .75183 L
s
P
p
1 0 .6 r
.00125 w
.35051 .69736 m
.33872 .72637 L
s
P
p
1 0 .6 r
.00088 w
.69399 .76007 m
.71547 .78771 L
s
P
p
1 0 .6 r
.00088 w
.31922 .72555 m
.32913 .73689 L
s
P
p
1 0 .6 r
.00125 w
.68142 .71049 m
.66049 .72183 L
s
P
p
1 0 .6 r
.00125 w
.67008 .72931 m
.69399 .76007 L
s
P
p
1 0 .6 r
.00177 w
.66763 .69608 m
.67008 .72931 L
s
P
p
1 0 .6 r
.0025 w
.40236 .63 m
.38735 .66645 L
s
P
p
1 0 .6 r
.00177 w
.3638 .66465 m
.37549 .67944 L
s
P
p
1 0 .6 r
.00088 w
.32296 .7257 m
.3125 .7517 L
s
P
p
1 0 .6 r
.00125 w
.69714 .73071 m
.69913 .76038 L
s
P
p
1 0 .6 r
.00088 w
.72123 .76172 m
.72285 .78822 L
s
P
p
1 0 .6 r
.00088 w
.72953 .76222 m
.71022 .77199 L
s
P
p
1 0 .6 r
.00125 w
.68142 .71049 m
.68352 .74034 L
s
P
p
1 0 .6 r
.00088 w
.33722 .70705 m
.32666 .73319 L
s
P
p
1 0 .6 r
.00088 w
.31187 .72523 m
.32189 .73663 L
s
P
p
1 0 .6 r
.00353 w
.41934 .58878 m
.43295 .60824 L
s
P
p
1 0 .6 r
.00088 w
.31922 .72555 m
.30876 .75159 L
s
P
p
1 0 .6 r
.00125 w
.35503 .69762 m
.32755 .7259 L
s
P
p
1 0 .6 r
.00177 w
.36832 .665 m
.35503 .69762 L
s
P
p
1 0 .6 r
.00125 w
.34911 .67763 m
.35983 .69084 L
s
P
p
1 0 .6 r
.00088 w
.72953 .76222 m
.7311 .78879 L
s
P
p
1 0 .6 r
.00088 w
.73674 .76266 m
.71733 .77245 L
s
P
p
1 0 .6 r
.00125 w
.70732 .73123 m
.70924 .76099 L
s
P
p
1 0 .6 r
.00088 w
.73148 .76234 m
.73304 .78892 L
s
P
p
1 0 .6 r
.00353 w
.62808 .61533 m
.59995 .63227 L
s
P
p
1 0 .6 r
.00088 w
.71207 .76117 m
.73366 .78896 L
s
P
p
1 0 .6 r
.00088 w
.32755 .7259 m
.30275 .75142 L
s
P
p
1 0 .6 r
.00125 w
.68804 .73024 m
.71207 .76117 L
s
P
p
1 0 .6 r
.00125 w
.35051 .69736 m
.32296 .7257 L
s
P
p
1 0 .6 r
.00177 w
.3638 .66465 m
.35051 .69736 L
s
P
p
1 0 .6 r
.00088 w
.73674 .76266 m
.73827 .78928 L
s
P
p
1 0 .6 r
.00125 w
.68804 .73024 m
.72019 .74428 L
s
P
p
1 0 .6 r
.00177 w
.6613 .69582 m
.68804 .73024 L
s
P
p
1 0 .6 r
.00088 w
.31187 .72523 m
.30142 .75138 L
s
P
p
1 0 .6 r
.0025 w
.63153 .65751 m
.6613 .69582 L
s
P
p
1 0 .6 r
.00088 w
.32296 .7257 m
.29809 .75129 L
s
P
p
1 0 .6 r
.00088 w
.72123 .76172 m
.74288 .7896 L
s
P
p
1 0 .6 r
.00088 w
.36087 .65743 m
.37044 .66957 L
s
P
p
1 0 .6 r
.00353 w
.62808 .61533 m
.63153 .65751 L
s
P
p
1 0 .6 r
.00088 w
.30981 .72515 m
.29936 .75133 L
s
P
p
1 0 .6 r
.00125 w
.69714 .73071 m
.72123 .76172 L
s
P
p
1 0 .6 r
.00125 w
.34911 .67763 m
.33722 .70705 L
s
P
p
1 0 .6 r
.0025 w
.66486 .65848 m
.66763 .69608 L
s
P
p
1 0 .6 r
.00177 w
.6949 .6972 m
.69714 .73071 L
s
P
p
1 0 .6 r
.00088 w
.74615 .76323 m
.74762 .78992 L
s
P
p
1 0 .6 r
.0025 w
.40236 .63 m
.36832 .665 L
s
P
p
1 0 .6 r
.00353 w
.41934 .58878 m
.40236 .63 L
s
P
p
1 0 .6 r
.00125 w
.331 .69622 m
.31922 .72555 L
s
P
p
1 0 .6 r
.00177 w
.70516 .69762 m
.68142 .71049 L
s
P
p
1 0 .6 r
.00088 w
.36087 .65743 m
.38521 .64798 L
s
P
p
1 0 .6 r
.00088 w
.73148 .76234 m
.75319 .7903 L
s
P
p
1 0 .6 r
.00088 w
.29708 .72461 m
.30732 .7361 L
s
P
p
1 0 .6 r
.00125 w
.72776 .73228 m
.72953 .76222 L
s
P
p
1 0 .6 r
.00088 w
.75205 .76359 m
.75348 .79032 L
s
P
p
1 0 .6 r
.00177 w
.36832 .665 m
.33757 .69661 L
s
P
p
1 0 .6 r
.00125 w
.70732 .73123 m
.73148 .76234 L
s
P
p
1 0 .6 r
.00088 w
.30313 .72486 m
.29268 .75114 L
s
P
p
1 0 .6 r
.00088 w
.72019 .74428 m
.74194 .77229 L
s
P
p
1 0 .6 r
.00177 w
.70516 .69762 m
.70732 .73123 L
s
P
p
1 0 .6 r
.00088 w
.33794 .67373 m
.34778 .68575 L
s
P
p
1 0 .6 r
.00088 w
.72019 .74428 m
.74949 .75708 L
s
P
p
1 0 .6 r
.00125 w
.33757 .69661 m
.30981 .72515 L
s
P
p
1 0 .6 r
.00125 w
.33757 .69661 m
.30998 .70759 L
s
P
p
1 0 .6 r
.00125 w
.73502 .73265 m
.73674 .76266 L
s
P
p
1 0 .6 r
.00088 w
.75937 .76403 m
.76075 .79082 L
s
P
p
1 0 .6 r
.00125 w
.32364 .6958 m
.31187 .72523 L
s
P
p
1 0 .6 r
.00088 w
.76786 .76455 m
.74798 .77441 L
s
P
p
1 0 .6 r
.0025 w
.3788 .62772 m
.3638 .66465 L
s
P
p
1 0 .6 r
.00088 w
.29181 .72438 m
.30213 .73591 L
s
P
p
1 0 .6 r
.00088 w
.30981 .72515 m
.28475 .75091 L
s
P
p
1 0 .6 r
.00088 w
.29708 .72461 m
.28663 .75096 L
s
P
p
1 0 .6 r
.00088 w
.74615 .76323 m
.76795 .79132 L
s
P
p
1 0 .6 r
.00177 w
.33691 .6626 m
.34911 .67763 L
s
P
p
1 0 .6 r
.00088 w
.29565 .72455 m
.28521 .75092 L
s
P
p
1 0 .6 r
.00088 w
.76786 .76455 m
.76918 .7914 L
s
P
p
1 0 .6 r
.00125 w
.7219 .73198 m
.74615 .76323 L
s
P
p
1 0 .6 r
.00125 w
.331 .69622 m
.30313 .72486 L
s
P
p
1 0 .6 r
.00177 w
.34427 .66316 m
.331 .69622 L
s
P
p
1 0 .6 r
.00088 w
.33794 .67373 m
.32723 .70044 L
s
P
p
1 0 .6 r
.00125 w
.7219 .73198 m
.75462 .74618 L
s
P
p
1 0 .6 r
.00177 w
.6949 .6972 m
.7219 .73198 L
s
P
p
1 0 .6 r
.00088 w
.75205 .76359 m
.77389 .79173 L
s
P
p
1 0 .6 r
.00088 w
.31222 .69201 m
.32238 .7039 L
s
P
p
1 0 .6 r
.00088 w
.29181 .72438 m
.28137 .75081 L
s
P
p
1 0 .6 r
.0025 w
.66486 .65848 m
.6949 .6972 L
s
P
p
1 0 .6 r
.00125 w
.72776 .73228 m
.75205 .76359 L
s
P
p
1 0 .6 r
.00088 w
.30313 .72486 m
.27797 .75072 L
s
P
p
1 0 .6 r
.00125 w
.35 .64365 m
.36087 .65743 L
s
P
p
1 0 .6 r
.005 w
.62415 .56741 m
.62808 .61533 L
s
P
p
1 0 .6 r
.00353 w
.66172 .61587 m
.66486 .65848 L
s
P
p
1 0 .6 r
.00177 w
.72576 .69847 m
.72776 .73228 L
s
P
p
1 0 .6 r
.00088 w
.77745 .76513 m
.77871 .79206 L
s
P
p
1 0 .6 r
.005 w
.43859 .54204 m
.41934 .58878 L
s
P
p
1 0 .6 r
.00088 w
.75937 .76403 m
.78124 .79223 L
s
P
p
1 0 .6 r
.00125 w
.73502 .73265 m
.75937 .76403 L
s
P
p
1 0 .6 r
.00125 w
.32364 .6958 m
.29565 .72455 L
s
P
p
1 0 .6 r
.00177 w
.33691 .6626 m
.32364 .6958 L
s
P
p
1 0 .6 r
.0025 w
.70272 .6596 m
.70516 .69762 L
s
P
p
1 0 .6 r
.00177 w
.73309 .69877 m
.73502 .73265 L
s
P
p
1 0 .6 r
.00088 w
.78488 .76558 m
.78609 .79256 L
s
P
p
1 0 .6 r
.00125 w
.30883 .69493 m
.29708 .72461 L
s
P
p
1 0 .6 r
.00088 w
.28492 .72409 m
.27449 .75062 L
s
P
p
1 0 .6 r
.00088 w
.31222 .69201 m
.30162 .71874 L
s
P
p
1 0 .6 r
.00088 w
.29565 .72455 m
.27038 .7505 L
s
P
p
1 0 .6 r
.00088 w
.30998 .70759 m
.28471 .71764 L
s
P
p
1 0 .6 r
.00088 w
.30998 .70759 m
.28473 .73352 L
s
P
p
1 0 .6 r
.0025 w
.3788 .62772 m
.34427 .66316 L
s
P
p
1 0 .6 r
.00353 w
.39578 .58593 m
.3788 .62772 L
s
P
p
1 0 .6 r
.00088 w
.59521 .79266 m
.61042 .81827 L
s
P
p
1 0 .6 r
.00125 w
.76637 .73427 m
.76786 .76455 L
s
P
p
1 0 .6 r
.00088 w
.79092 .76594 m
.79209 .79298 L
s
P
p
1 0 .6 r
.00125 w
.35 .64365 m
.33794 .67373 L
s
P
p
1 0 .6 r
.00088 w
.75462 .74618 m
.77657 .77449 L
s
P
p
1 0 .6 r
.00088 w
.2806 .72391 m
.27017 .7505 L
s
P
p
1 0 .6 r
.00088 w
.75462 .74618 m
.78444 .75913 L
s
P
p
1 0 .6 r
.02 w
.57195 .29027 m
.57226 .37452 L
s
P
p
1 g
.05 w
.57195 .29027 Mdot
P
p
1 0 .6 r
.00125 w
.30356 .69463 m
.29181 .72438 L
s
P
p
1 0 .6 r
.00177 w
.34427 .66316 m
.31309 .69518 L
s
P
p
1 0 .6 r
.00088 w
.61453 .76929 m
.62965 .79507 L
s
P
p
1 0 .6 r
.00088 w
.59521 .79266 m
.58423 .82422 L
s
P
p
1 0 .6 r
.00088 w
.78114 .7383 m
.76092 .74851 L
s
P
p
1 0 .6 r
.00088 w
.77745 .76513 m
.79943 .79348 L
s
P
p
1 0 .6 r
.00088 w
.56263 .79998 m
.57807 .82562 L
s
P
p
1 0 .6 r
.00088 w
.26901 .72342 m
.27969 .73509 L
s
P
p
1 0 .6 r
.00088 w
.61453 .76929 m
.64701 .77413 L
s
P
p
1 0 .6 r
.00125 w
.75299 .73358 m
.77745 .76513 L
s
P
p
1 0 .6 r
.00125 w
.31309 .69518 m
.28492 .72409 L
s
P
p
1 0 .6 r
.00125 w
.31309 .69518 m
.2849 .70629 L
s
P
p
1 0 .6 r
.00088 w
.27524 .72368 m
.26482 .75034 L
s
P
p
1 0 .6 r
.00125 w
.75299 .73358 m
.78623 .74793 L
s
P
p
1 0 .6 r
.00177 w
.72576 .69847 m
.75299 .73358 L
s
P
p
1 0 .6 r
.00088 w
.78114 .7383 m
.78239 .76564 L
s
P
p
1 0 .6 r
.00088 w
.78488 .76558 m
.8069 .79399 L
s
P
p
1 0 .6 r
.0025 w
.69546 .65938 m
.72576 .69847 L
s
P
p
1 0 .6 r
.00088 w
.56263 .79998 m
.55174 .83159 L
s
P
p
1 0 .6 r
.00088 w
.28492 .72409 m
.2595 .75019 L
s
P
p
1 0 .6 r
.00125 w
.32417 .66191 m
.31222 .69201 L
s
P
p
1 0 .6 r
.00088 w
.78831 .74386 m
.7895 .77118 L
s
P
p
1 0 .6 r
.00125 w
.76036 .73396 m
.78488 .76558 L
s
P
p
1 0 .6 r
.00088 w
.29187 .69079 m
.30234 .70283 L
s
P
p
1 0 .6 r
.00088 w
.52623 .80817 m
.54193 .83382 L
s
P
p
1 0 .6 r
.0025 w
.3519 .62511 m
.33691 .6626 L
s
P
p
1 0 .6 r
.00125 w
.30883 .69493 m
.2806 .72391 L
s
P
p
1 0 .6 r
.00177 w
.32209 .66147 m
.30883 .69493 L
s
P
p
1 0 .6 r
.0025 w
.69546 .65938 m
.73616 .67655 L
s
P
p
1 0 .6 r
.00353 w
.66172 .61587 m
.69546 .65938 L
s
P
p
1 0 .6 r
.00125 w
.5781 .76386 m
.59521 .79266 L
s
P
p
1 0 .6 r
.00125 w
.76036 .73396 m
.79373 .74834 L
s
P
p
1 0 .6 r
.00177 w
.73309 .69877 m
.76036 .73396 L
s
P
p
1 0 .6 r
.00088 w
.79092 .76594 m
.81298 .79441 L
s
P
p
1 0 .6 r
.005 w
.62415 .56741 m
.66172 .61587 L
s
P
p
1 0 .6 r
.00088 w
.26901 .72342 m
.25859 .75017 L
s
P
p
1 0 .6 r
.005 w
.43859 .54204 m
.39578 .58593 L
s
P
p
1 0 .6 r
.00707 w
.46046 .48893 m
.43859 .54204 L
s
P
p
1 0 .6 r
.0025 w
.70272 .6596 m
.73309 .69877 L
s
P
p
1 0 .6 r
.00088 w
.53316 .80661 m
.52236 .83826 L
s
P
p
1 0 .6 r
.00125 w
.76637 .73427 m
.79092 .76594 L
s
P
p
1 0 .6 r
.00088 w
.2806 .72391 m
.25512 .75007 L
s
P
p
1 0 .6 r
.00177 w
.33764 .62796 m
.35 .64365 L
s
P
p
1 0 .6 r
.00125 w
.5781 .76386 m
.61453 .76929 L
s
P
p
1 0 .6 r
.00088 w
.29577 .69102 m
.28518 .71799 L
s
P
p
1 0 .6 r
.00088 w
.52623 .80817 m
.51545 .83983 L
s
P
p
1 0 .6 r
.00707 w
.61967 .51283 m
.62415 .56741 L
s
P
p
1 0 .6 r
.00353 w
.69995 .61649 m
.70272 .6596 L
s
P
p
1 0 .6 r
.00177 w
.76468 .70007 m
.76637 .73427 L
s
P
p
1 0 .6 r
.00088 w
.81692 .76752 m
.81792 .79475 L
s
P
p
1 0 .6 r
.00125 w
.30356 .69463 m
.27524 .72368 L
s
P
p
1 0 .6 r
.00177 w
.31682 .66107 m
.30356 .69463 L
s
P
p
1 0 .6 r
.00125 w
.54526 .77115 m
.56263 .79998 L
s
P
p
1 0 .6 r
.00353 w
.39578 .58593 m
.35707 .62561 L
s
P
p
1 0 .6 r
.00088 w
.29187 .69079 m
.28128 .71781 L
s
P
p
1 0 .6 r
.00088 w
.78623 .74793 m
.80837 .7765 L
s
P
p
1 0 .6 r
.00088 w
.4966 .81483 m
.4859 .84654 L
s
P
p
1 0 .6 r
.00088 w
.27524 .72368 m
.24968 .74991 L
s
P
p
1 0 .6 r
.00088 w
.26196 .72312 m
.25155 .74997 L
s
P
p
1 0 .6 r
.00088 w
.78623 .74793 m
.81653 .76101 L
s
P
p
1 0 .6 r
.00088 w
.53316 .80661 m
.50208 .82575 L
s
P
p
1 0 .6 r
.00125 w
.54526 .77115 m
.53316 .80661 L
s
P
p
1 0 .6 r
.00125 w
.50857 .7793 m
.52623 .80817 L
s
P
p
1 0 .6 r
.0025 w
.35707 .62561 m
.32209 .66147 L
s
P
p
1 0 .6 r
.0025 w
.35707 .62561 m
.32243 .63867 L
s
P
p
1 0 .6 r
.00125 w
.77974 .70747 m
.78114 .7383 L
s
P
p
1 0 .6 r
.00088 w
.80456 .73953 m
.80565 .76705 L
s
P
p
1 0 .6 r
.00088 w
.78831 .74386 m
.81048 .77249 L
s
P
p
1 0 .6 r
.00088 w
.49513 .78877 m
.51111 .81471 L
s
P
p
1 0 .6 r
.00088 w
.79373 .74834 m
.81592 .77698 L
s
P
p
1 0 .6 r
.00125 w
.32417 .66191 m
.29577 .69102 L
s
P
p
1 0 .6 r
.00177 w
.33764 .62796 m
.32417 .66191 L
s
P
p
1 0 .6 r
.00125 w
.76363 .712 m
.78831 .74386 L
s
P
p
1 0 .6 r
.00177 w
.55882 .73141 m
.5781 .76386 L
s
P
p
1 0 .6 r
.01414 w
.57226 .37452 m
.57254 .45197 L
s
P
p
1 0 .6 r
.01414 w
.57226 .37452 m
.51359 .43456 L
s
P
p
1 0 .6 r
.00088 w
.2849 .70629 m
.25909 .71647 L
s
P
p
1 0 .6 r
.00088 w
.2849 .70629 m
.25929 .73257 L
s
P
p
1 0 .6 r
.00088 w
.79373 .74834 m
.82414 .76146 L
s
P
p
1 0 .6 r
.00125 w
.76363 .712 m
.79725 .72634 L
s
P
p
1 0 .6 r
.00177 w
.73616 .67655 m
.76363 .712 L
s
P
p
1 0 .6 r
.00125 w
.28074 .6933 m
.26901 .72342 L
s
P
p
1 0 .6 r
.00088 w
.2565 .72289 m
.24609 .74981 L
s
P
p
1 0 .6 r
.00177 w
.32209 .66147 m
.2905 .69387 L
s
P
p
1 0 .6 r
.00088 w
.4966 .81483 m
.4654 .83403 L
s
P
p
1 0 .6 r
.00125 w
.50857 .7793 m
.4966 .81483 L
s
P
p
1 0 .6 r
.00088 w
.29577 .69102 m
.27014 .71731 L
s
P
p
1 0 .6 r
.00177 w
.73616 .67655 m
.77337 .69224 L
s
P
p
1 0 .6 r
.00088 w
.49513 .78877 m
.4844 .82072 L
s
P
p
1 0 .6 r
.00088 w
.81692 .76752 m
.83914 .79621 L
s
P
p
1 0 .6 r
.0025 w
.3519 .62511 m
.31682 .66107 L
s
P
p
1 0 .6 r
.00353 w
.36887 .58268 m
.3519 .62511 L
s
P
p
1 0 .6 r
.00088 w
.26879 .69595 m
.2796 .70804 L
s
P
p
1 0 .6 r
.00125 w
.7922 .7356 m
.81692 .76752 L
s
P
p
1 0 .6 r
.00177 w
.55882 .73141 m
.54526 .77115 L
s
P
p
1 0 .6 r
.00088 w
.47122 .79914 m
.46057 .83108 L
s
P
p
1 0 .6 r
.00125 w
.2905 .69387 m
.26196 .72312 L
s
P
p
1 0 .6 r
.00125 w
.2905 .69387 m
.26176 .7051 L
s
P
p
1 0 .6 r
.00088 w
.25205 .7227 m
.24165 .74968 L
s
P
p
1 0 .6 r
.00125 w
.7922 .7356 m
.8261 .75013 L
s
P
p
1 0 .6 r
.00177 w
.76468 .70007 m
.7922 .7356 L
s
P
p
1 0 .6 r
.01 w
.51359 .43456 m
.46046 .48893 L
s
P
p
1 0 .6 r
.01 w
.51359 .43456 m
.46303 .45126 L
s
P
p
1 0 .6 r
.00125 w
.3038 .66036 m
.29187 .69079 L
s
P
p
1 0 .6 r
.00177 w
.31682 .66107 m
.28512 .69356 L
s
P
p
1 0 .6 r
.00088 w
.46523 .79543 m
.45459 .82743 L
s
P
p
1 0 .6 r
.0025 w
.73405 .66052 m
.76468 .70007 L
s
P
p
1 0 .6 r
.00088 w
.26196 .72312 m
.2362 .74953 L
s
P
p
1 0 .6 r
.00088 w
.82827 .74601 m
.8292 .77365 L
s
P
p
1 0 .6 r
.00088 w
.26874 .68941 m
.27958 .7016 L
s
P
p
1 0 .6 r
.0025 w
.73405 .66052 m
.77557 .6779 L
s
P
p
1 0 .6 r
.00353 w
.69995 .61649 m
.73405 .66052 L
s
P
p
1 0 .6 r
.00088 w
.80456 .73953 m
.82687 .76834 L
s
P
p
1 0 .6 r
.00177 w
.522 .73948 m
.50857 .7793 L
s
P
p
1 0 .6 r
.00125 w
.47716 .7596 m
.49513 .78877 L
s
P
p
1 0 .6 r
.00125 w
.28512 .69356 m
.2565 .72289 L
s
P
p
1 0 .6 r
.00125 w
.28512 .69356 m
.25626 .70482 L
s
P
p
1 0 .6 r
.00088 w
.27506 .68978 m
.26449 .71705 L
s
P
p
1 0 .6 r
.00125 w
.77974 .70747 m
.80456 .73953 L
s
P
p
1 0 .6 r
.00088 w
.26879 .69595 m
.25825 .72318 L
s
P
p
1 0 .6 r
.005 w
.66197 .56745 m
.69995 .61649 L
s
P
p
1 0 .6 r
.00707 w
.46046 .48893 m
.41237 .53815 L
s
P
p
1 0 .6 r
.00088 w
.47122 .79914 m
.43985 .81844 L
s
P
p
1 0 .6 r
.00125 w
.48316 .76336 m
.47122 .79914 L
s
P
p
1 0 .6 r
.00088 w
.79725 .72634 m
.81959 .75519 L
s
P
p
1 0 .6 r
.00177 w
.77815 .67264 m
.77974 .70747 L
s
P
p
1 0 .6 r
.00088 w
.83097 .74091 m
.83188 .76864 L
s
P
p
1 0 .6 r
.00088 w
.2565 .72289 m
.23066 .74937 L
s
P
p
1 0 .6 r
.0025 w
.53707 .6948 m
.55882 .73141 L
s
P
p
1 0 .6 r
.00088 w
.79725 .72634 m
.8279 .73941 L
s
P
p
1 0 .6 r
.005 w
.66197 .56745 m
.7127 .58803 L
s
P
p
1 0 .6 r
.00707 w
.61967 .51283 m
.66197 .56745 L
s
P
p
1 0 .6 r
.00088 w
.26172 .70083 m
.25121 .72808 L
s
P
p
1 0 .6 r
.0025 w
.35285 .58961 m
.33764 .62796 L
s
P
p
1 0 .6 r
.00088 w
.46523 .79543 m
.43382 .81475 L
s
P
p
1 0 .6 r
.00125 w
.47716 .7596 m
.46523 .79543 L
s
P
p
1 0 .6 r
.00125 w
.28074 .6933 m
.25205 .7227 L
s
P
p
1 0 .6 r
.00177 w
.29398 .65933 m
.28074 .6933 L
s
P
p
1 0 .6 r
.01 w
.57254 .45197 m
.61967 .51283 L
s
P
p
1 0 .6 r
.00088 w
.26874 .68941 m
.25817 .71676 L
s
P
p
1 0 .6 r
.00125 w
.77337 .69224 m
.80734 .70656 L
s
P
p
1 0 .6 r
.00125 w
.77337 .69224 m
.79643 .68007 L
s
P
p
1 0 .6 r
.005 w
.41237 .53815 m
.36887 .58268 L
s
P
p
1 0 .6 r
.005 w
.41237 .53815 m
.36985 .55321 L
s
P
p
1 0 .6 r
.00088 w
.8261 .75013 m
.84848 .77905 L
s
P
p
1 0 .6 r
.00088 w
.43952 .77954 m
.42892 .81177 L
s
P
p
1 0 .6 r
.00088 w
.25205 .7227 m
.22614 .74924 L
s
P
p
1 0 .6 r
.00088 w
.8261 .75013 m
.85701 .76338 L
s
P
p
1 0 .6 r
.00177 w
.522 .73948 m
.48316 .76336 L
s
P
p
1 0 .6 r
.0025 w
.53707 .6948 m
.522 .73948 L
s
P
p
1 0 .6 r
.01 w
.57254 .45197 m
.5728 .52303 L
s
P
p
1 0 .6 r
.00125 w
.3038 .66036 m
.27506 .68978 L
s
P
p
1 0 .6 r
.00177 w
.31725 .62603 m
.3038 .66036 L
s
P
p
1 0 .6 r
.00177 w
.32243 .63867 m
.29056 .65068 L
s
P
p
1 0 .6 r
.00177 w
.32243 .63867 m
.29053 .67133 L
s
P
p
1 0 .6 r
.00125 w
.48316 .76336 m
.44815 .78487 L
s
P
p
1 0 .6 r
.00088 w
.82827 .74601 m
.85069 .77499 L
s
P
p
1 0 .6 r
.00088 w
.44815 .78487 m
.41662 .80426 L
s
P
p
1 0 .6 r
.00088 w
.44815 .78487 m
.41408 .77998 L
s
P
p
1 0 .6 r
.00353 w
.36887 .58268 m
.32953 .62294 L
s
P
p
1 0 .6 r
.00125 w
.80333 .71378 m
.82827 .74601 L
s
P
p
1 0 .6 r
.00177 w
.49052 .71942 m
.47716 .7596 L
s
P
p
1 0 .6 r
.00088 w
.27506 .68978 m
.24912 .71635 L
s
P
p
1 0 .6 r
.00088 w
.26176 .7051 m
.23544 .71539 L
s
P
p
1 0 .6 r
.00088 w
.26176 .7051 m
.2358 .73169 L
s
P
p
1 0 .6 r
.00125 w
.29053 .67133 m
.26172 .70083 L
s
P
p
1 0 .6 r
.00125 w
.29053 .67133 m
.26152 .68246 L
s
P
p
1 0 .6 r
.00125 w
.28066 .66527 m
.26879 .69595 L
s
P
p
1 0 .6 r
.00125 w
.80333 .71378 m
.83763 .7283 L
s
P
p
1 0 .6 r
.00177 w
.77557 .6779 m
.80333 .71378 L
s
P
p
1 0 .6 r
.00088 w
.23285 .72189 m
.22247 .74914 L
s
P
p
1 0 .6 r
.00088 w
.43952 .77954 m
.40792 .79895 L
s
P
p
1 0 .6 r
.00125 w
.4514 .74344 m
.43952 .77954 L
s
P
p
1 0 .6 r
.00088 w
.83097 .74091 m
.85343 .76995 L
s
P
p
1 0 .6 r
.00177 w
.77557 .6779 m
.81353 .69379 L
s
P
p
1 0 .6 r
.0025 w
.32953 .62294 m
.29398 .65933 L
s
P
p
1 0 .6 r
.0025 w
.32953 .62294 m
.29404 .63616 L
s
P
p
1 0 .6 r
.00088 w
.26172 .70083 m
.23571 .72746 L
s
P
p
1 0 .6 r
.00125 w
.80597 .7086 m
.83097 .74091 L
s
P
p
1 0 .6 r
.00125 w
.80597 .7086 m
.84036 .72312 L
s
P
p
1 0 .6 r
.00177 w
.77815 .67264 m
.80597 .7086 L
s
P
p
1 0 .6 r
.00088 w
.25162 .69498 m
.2411 .72246 L
s
P
p
1 0 .6 r
.00088 w
.25626 .70482 m
.22981 .71514 L
s
P
p
1 0 .6 r
.00088 w
.25626 .70482 m
.23021 .73148 L
s
P
p
1 0 .6 r
.00088 w
.80734 .70656 m
.82986 .73568 L
s
P
p
1 0 .6 r
.00088 w
.41063 .76167 m
.40007 .79416 L
s
P
p
1 0 .6 r
.00353 w
.554 .6446 m
.53707 .6948 L
s
P
p
1 0 .6 r
.00125 w
.28065 .6586 m
.26874 .68941 L
s
P
p
1 0 .6 r
.00088 w
.25604 .68865 m
.24548 .71618 L
s
P
p
1 0 .6 r
.0025 w
.74718 .6326 m
.77815 .67264 L
s
P
p
1 0 .6 r
.00177 w
.29398 .65933 m
.26186 .6922 L
s
P
p
1 0 .6 r
.00088 w
.80734 .70656 m
.83831 .71962 L
s
P
p
1 0 .6 r
.00088 w
.69783 .75517 m
.71051 .76618 L
s
P
p
1 0 .6 r
.00088 w
.84259 .71891 m
.84343 .74706 L
s
P
p
1 0 .6 r
.0025 w
.35285 .58961 m
.31725 .62603 L
s
P
p
1 0 .6 r
.00353 w
.37008 .5462 m
.35285 .58961 L
s
P
p
1 0 .6 r
.0025 w
.74718 .6326 m
.78929 .64995 L
s
P
p
1 0 .6 r
.00353 w
.7127 .58803 m
.74718 .6326 L
s
P
p
1 0 .6 r
.00177 w
.49052 .71942 m
.4514 .74344 L
s
P
p
1 0 .6 r
.0025 w
.50552 .67433 m
.49052 .71942 L
s
P
p
1 0 .6 r
.00088 w
.26852 .66111 m
.27949 .67375 L
s
P
p
1 0 .6 r
.00125 w
.4514 .74344 m
.41615 .76508 L
s
P
p
1 0 .6 r
.00125 w
.26186 .6922 m
.23285 .72189 L
s
P
p
1 0 .6 r
.00125 w
.26186 .6922 m
.23242 .70359 L
s
P
p
1 0 .6 r
.00088 w
.25152 .68838 m
.24097 .71598 L
s
P
p
1 0 .6 r
.00353 w
.7127 .58803 m
.75926 .60692 L
s
P
p
1 0 .6 r
.00088 w
.41615 .76508 m
.38438 .78459 L
s
P
p
1 0 .6 r
.00088 w
.41615 .76508 m
.3817 .76007 L
s
P
p
1 0 .6 r
.00177 w
.31725 .62603 m
.28509 .65893 L
s
P
p
1 0 .6 r
.00088 w
.83763 .7283 m
.86021 .7575 L
s
P
p
1 0 .6 r
.00088 w
.41063 .76167 m
.37883 .7812 L
s
P
p
1 0 .6 r
.00125 w
.42246 .72528 m
.41063 .76167 L
s
P
p
1 0 .6 r
.00088 w
.23285 .72189 m
.20666 .74869 L
s
P
p
1 0 .6 r
.00088 w
.79643 .68007 m
.8176 .6689 L
s
P
p
1 0 .6 r
.00088 w
.79643 .68007 m
.82745 .69301 L
s
P
p
1 0 .6 r
.00707 w
.5728 .52303 m
.57304 .58812 L
s
P
p
1 0 .6 r
.00707 w
.5728 .52303 m
.55815 .55085 L
s
P
p
1 0 .6 r
.00088 w
.83763 .7283 m
.8689 .74154 L
s
P
p
1 0 .6 r
.00125 w
.28066 .66527 m
.25162 .69498 L
s
P
p
1 0 .6 r
.00177 w
.29406 .63066 m
.28066 .66527 L
s
P
p
1 0 .6 r
.00125 w
.28509 .65893 m
.25604 .68865 L
s
P
p
1 0 .6 r
.00125 w
.28509 .65893 m
.25579 .67003 L
s
P
p
1 0 .6 r
.00088 w
.26852 .66111 m
.25782 .68898 L
s
P
p
1 0 .6 r
.00088 w
.84036 .72312 m
.86299 .75239 L
s
P
p
1 0 .6 r
.00125 w
.81353 .69379 m
.84819 .7083 L
s
P
p
1 0 .6 r
.00125 w
.81353 .69379 m
.83729 .68149 L
s
P
p
1 0 .6 r
.00125 w
.29056 .65068 m
.26129 .66171 L
s
P
p
1 0 .6 r
.00125 w
.29056 .65068 m
.27843 .63628 L
s
P
p
1 0 .6 r
.00707 w
.46303 .45126 m
.41595 .4668 L
s
P
p
1 0 .6 r
.00707 w
.46303 .45126 m
.41423 .5011 L
s
P
p
1 0 .6 r
.00353 w
.554 .6446 m
.50552 .67433 L
s
P
p
1 0 .6 r
.005 w
.57304 .58812 m
.554 .6446 L
s
P
p
1 0 .6 r
.00088 w
.25162 .69498 m
.22541 .7218 L
s
P
p
1 0 .6 r
.00088 w
.84036 .72312 m
.87172 .73636 L
s
P
p
1 0 .6 r
.00088 w
.26152 .68246 m
.23493 .69266 L
s
P
p
1 0 .6 r
.00088 w
.26152 .68246 m
.2353 .70928 L
s
P
p
1 0 .6 r
.00088 w
.25604 .68865 m
.22982 .71547 L
s
P
p
1 0 .6 r
.0025 w
.50552 .67433 m
.46183 .70113 L
s
P
p
1 0 .6 r
.00088 w
.23232 .69925 m
.22184 .72692 L
s
P
p
1 0 .6 r
.00125 w
.28065 .6586 m
.25152 .68838 L
s
P
p
1 0 .6 r
.00177 w
.29408 .62384 m
.28065 .6586 L
s
P
p
1 0 .6 r
.00088 w
.84259 .71891 m
.86526 .74824 L
s
P
p
1 0 .6 r
.00177 w
.46183 .70113 m
.42246 .72528 L
s
P
p
1 0 .6 r
.00177 w
.46183 .70113 m
.41932 .69453 L
s
P
p
1 0 .6 r
.00088 w
.69783 .75517 m
.72478 .77844 L
s
P
p
1 0 .6 r
.00125 w
.42246 .72528 m
.38697 .74705 L
s
P
p
1 0 .6 r
.00125 w
.81736 .68627 m
.84259 .71891 L
s
P
p
1 0 .6 r
.00353 w
.36985 .55321 m
.33051 .56715 L
s
P
p
1 0 .6 r
.00353 w
.36985 .55321 m
.33004 .59389 L
s
P
p
1 0 .6 r
.005 w
.41423 .5011 m
.37008 .5462 L
s
P
p
1 0 .6 r
.005 w
.41423 .5011 m
.37109 .51585 L
s
P
p
1 0 .6 r
.00088 w
.38697 .74705 m
.355 .76666 L
s
P
p
1 0 .6 r
.00088 w
.38697 .74705 m
.35218 .74191 L
s
P
p
1 0 .6 r
.00088 w
.25152 .68838 m
.22523 .71526 L
s
P
p
1 0 .6 r
.00125 w
.81736 .68627 m
.85216 .70078 L
s
P
p
1 0 .6 r
.00177 w
.78929 .64995 m
.81736 .68627 L
s
P
p
1 0 .6 r
.00088 w
.23219 .69388 m
.22169 .72164 L
s
P
p
1 0 .6 r
.00177 w
.78929 .64995 m
.8278 .66581 L
s
P
p
1 0 .6 r
.00177 w
.29404 .63616 m
.26138 .64833 L
s
P
p
1 0 .6 r
.00177 w
.29404 .63616 m
.26161 .66931 L
s
P
p
1 0 .6 r
.0025 w
.33004 .59389 m
.29406 .63066 L
s
P
p
1 0 .6 r
.0025 w
.33004 .59389 m
.29412 .60693 L
s
P
p
1 0 .6 r
.00125 w
.68343 .74268 m
.69783 .75517 L
s
P
p
1 0 .6 r
.00353 w
.37008 .5462 m
.33016 .58698 L
s
P
p
1 0 .6 r
.00088 w
.85576 .69396 m
.85651 .72259 L
s
P
p
1 0 .6 r
.00088 w
.23242 .70359 m
.20544 .71402 L
s
P
p
1 0 .6 r
.00088 w
.23242 .70359 m
.20603 .73057 L
s
P
p
1 0 .6 r
.0025 w
.75926 .60692 m
.80192 .62423 L
s
P
p
1 0 .6 r
.0025 w
.75926 .60692 m
.78814 .59046 L
s
P
p
1 0 .6 r
.00088 w
.84819 .7083 m
.87096 .73777 L
s
P
p
1 0 .6 r
.00125 w
.26161 .66931 m
.23232 .69925 L
s
P
p
1 0 .6 r
.00125 w
.26161 .66931 m
.23188 .68059 L
s
P
p
1 0 .6 r
.00125 w
.28056 .62972 m
.26852 .66111 L
s
P
p
1 0 .6 r
.00088 w
.23203 .68721 m
.22151 .71509 L
s
P
p
1 0 .6 r
.005 w
.57304 .58812 m
.57326 .64764 L
s
P
p
1 0 .6 r
.00177 w
.29406 .63066 m
.26155 .66388 L
s
P
p
1 0 .6 r
.00088 w
.84819 .7083 m
.8798 .72153 L
s
P
p
1 0 .6 r
.00125 w
.41932 .69453 m
.38064 .68853 L
s
P
p
1 0 .6 r
.00125 w
.41932 .69453 m
.38365 .71639 L
s
P
p
1 0 .6 r
.0025 w
.33016 .58698 m
.29408 .62384 L
s
P
p
1 0 .6 r
.0025 w
.33016 .58698 m
.29414 .59997 L
s
P
p
1 0 .6 r
.00088 w
.23232 .69925 m
.20588 .72628 L
s
P
p
1 0 .6 r
.00088 w
.38365 .71639 m
.35152 .73608 L
s
P
p
1 0 .6 r
.00088 w
.38365 .71639 m
.34867 .71109 L
s
P
p
1 0 .6 r
.00125 w
.26155 .66388 m
.23219 .69388 L
s
P
p
1 0 .6 r
.00125 w
.26155 .66388 m
.23175 .67513 L
s
P
p
1 0 .6 r
.00088 w
.25109 .65982 m
.24041 .68794 L
s
P
p
1 0 .6 r
.00088 w
.25579 .67003 m
.22894 .68021 L
s
P
p
1 0 .6 r
.00088 w
.25579 .67003 m
.22936 .69704 L
s
P
p
1 0 .6 r
.00088 w
.26826 .62887 m
.27938 .64202 L
s
P
p
1 0 .6 r
.00088 w
.85216 .70078 m
.875 .73034 L
s
P
p
1 0 .6 r
.00088 w
.57192 .82277 m
.55684 .84952 L
s
P
p
1 0 .6 r
.00177 w
.29408 .62384 m
.26148 .65714 L
s
P
p
1 0 .6 r
.00088 w
.26129 .66171 m
.23447 .67182 L
s
P
p
1 0 .6 r
.00088 w
.26129 .66171 m
.23484 .68873 L
s
P
p
1 0 .6 r
.00088 w
.85216 .70078 m
.8839 .714 L
s
P
p
1 0 .6 r
.00088 w
.23219 .69388 m
.20569 .72096 L
s
P
p
1 0 .6 r
.00088 w
.71375 .76886 m
.74088 .79228 L
s
P
p
1 0 .6 r
.00088 w
.83729 .68149 m
.85912 .67019 L
s
P
p
1 0 .6 r
.00088 w
.83729 .68149 m
.86895 .6946 L
s
P
p
1 0 .6 r
.00125 w
.26148 .65714 m
.23203 .68721 L
s
P
p
1 0 .6 r
.00125 w
.26148 .65714 m
.23159 .66836 L
s
P
p
1 0 .6 r
.00125 w
.8278 .66581 m
.86298 .6803 L
s
P
p
1 0 .6 r
.00125 w
.8278 .66581 m
.85201 .65306 L
s
P
p
1 0 .6 r
.00088 w
.27843 .63628 m
.26727 .62303 L
s
P
p
1 0 .6 r
.00088 w
.27843 .63628 m
.25169 .6462 L
s
P
p
1 0 .6 r
.00088 w
.57192 .82277 m
.58415 .85544 L
s
P
p
1 0 .6 r
.00088 w
.85576 .69396 m
.87866 .72362 L
s
P
p
1 0 .6 r
.00088 w
.38064 .68853 m
.34548 .68307 L
s
P
p
1 0 .6 r
.00088 w
.38064 .68853 m
.36331 .66092 L
s
P
p
1 0 .6 r
.00125 w
.83028 .66096 m
.85576 .69396 L
s
P
p
1 0 .6 r
.00088 w
.23203 .68721 m
.20545 .71436 L
s
P
p
1 0 .6 r
.00088 w
.71375 .76886 m
.73963 .79114 L
s
P
p
1 0 .6 r
.00125 w
.68343 .74268 m
.71375 .76886 L
s
P
p
1 0 .6 r
.00088 w
.26826 .62887 m
.25742 .65732 L
s
P
p
1 0 .6 r
.00088 w
.23165 .67069 m
.22105 .69888 L
s
P
p
1 0 .6 r
.00125 w
.28056 .62972 m
.25109 .65982 L
s
P
p
1 0 .6 r
.00177 w
.29416 .5943 m
.28056 .62972 L
s
P
p
1 0 .6 r
.00125 w
.83028 .66096 m
.86554 .67544 L
s
P
p
1 0 .6 r
.00177 w
.80192 .62423 m
.83028 .66096 L
s
P
p
1 0 .6 r
.00353 w
.57326 .64764 m
.57346 .70199 L
s
P
p
1 0 .6 r
.00353 w
.57326 .64764 m
.61154 .68061 L
s
P
p
1 0 .6 r
.00177 w
.80192 .62423 m
.84094 .64006 L
s
P
p
1 0 .6 r
.00088 w
.6025 .82931 m
.61465 .86205 L
s
P
p
1 0 .6 r
.00125 w
.26138 .64833 m
.23138 .6595 L
s
P
p
1 0 .6 r
.00125 w
.26138 .64833 m
.24872 .63368 L
s
P
p
1 0 .6 r
.00088 w
.25109 .65982 m
.22448 .68699 L
s
P
p
1 0 .6 r
.0025 w
.33051 .56715 m
.2942 .58001 L
s
P
p
1 0 .6 r
.0025 w
.33051 .56715 m
.31586 .54779 L
s
P
p
1 0 .6 r
.00125 w
.58889 .79264 m
.57192 .82277 L
s
P
p
1 0 .6 r
.00088 w
.23188 .68059 m
.20463 .69093 L
s
P
p
1 0 .6 r
.00088 w
.23188 .68059 m
.20522 .70781 L
s
P
p
1 0 .6 r
.00177 w
.64951 .71339 m
.68343 .74268 L
s
P
p
1 0 .6 r
.005 w
.41595 .4668 m
.37224 .48124 L
s
P
p
1 0 .6 r
.005 w
.41595 .4668 m
.39937 .44093 L
s
P
p
1 0 .6 r
.00088 w
.23149 .66389 m
.22086 .6922 L
s
P
p
1 0 .6 r
.00177 w
.29412 .60693 m
.26106 .61893 L
s
P
p
1 0 .6 r
.00177 w
.29412 .60693 m
.26129 .64043 L
s
P
p
1 0 .6 r
.00353 w
.37109 .51585 m
.33116 .52949 L
s
P
p
1 0 .6 r
.00353 w
.37109 .51585 m
.33068 .55705 L
s
P
p
1 0 .6 r
.00088 w
.86298 .6803 m
.886 .71014 L
s
P
p
1 0 .6 r
.00088 w
.23175 .67513 m
.20444 .68545 L
s
P
p
1 0 .6 r
.00088 w
.23175 .67513 m
.20503 .70241 L
s
P
p
1 0 .6 r
.005 w
.55815 .55085 m
.54446 .57686 L
s
P
p
1 0 .6 r
.005 w
.55815 .55085 m
.59264 .56391 L
s
P
p
1 0 .6 r
.00125 w
.26129 .64043 m
.23165 .67069 L
s
P
p
1 0 .6 r
.00125 w
.26129 .64043 m
.2312 .65157 L
s
P
p
1 0 .6 r
.00088 w
.6025 .82931 m
.63519 .84884 L
s
P
p
1 0 .6 r
.00125 w
.58889 .79264 m
.6025 .82931 L
s
P
p
1 0 .6 r
.00088 w
.23136 .65835 m
.2207 .68676 L
s
P
p
1 0 .6 r
.00088 w
.86298 .6803 m
.89506 .69351 L
s
P
p
1 0 .6 r
.00177 w
.78814 .59046 m
.81479 .57527 L
s
P
p
1 0 .6 r
.00177 w
.78814 .59046 m
.82723 .6061 L
s
P
p
1 0 .6 r
.00177 w
.29414 .59997 m
.26099 .61193 L
s
P
p
1 0 .6 r
.00177 w
.29414 .59997 m
.26122 .63356 L
s
P
p
1 0 .6 r
.0025 w
.33068 .55705 m
.29416 .5943 L
s
P
p
1 0 .6 r
.0025 w
.33068 .55705 m
.29423 .56984 L
s
P
p
1 0 .6 r
.00177 w
.64951 .71339 m
.68123 .7407 L
s
P
p
1 0 .6 r
.0025 w
.61154 .68061 m
.64951 .71339 L
s
P
p
1 0 .6 r
.00125 w
.28047 .59681 m
.26826 .62887 L
s
P
p
1 0 .6 r
.00088 w
.86554 .67544 m
.88861 .70535 L
s
P
p
1 0 .6 r
.00088 w
.23165 .67069 m
.20488 .69801 L
s
P
p
1 0 .6 r
.00088 w
.86554 .67544 m
.8977 .68865 L
s
P
p
1 0 .6 r
.00088 w
.23159 .66836 m
.2042 .67864 L
s
P
p
1 0 .6 r
.00088 w
.23159 .66836 m
.2048 .6957 L
s
P
p
1 0 .6 r
.0025 w
.57346 .70199 m
.57364 .75154 L
s
P
p
1 0 .6 r
.0025 w
.57346 .70199 m
.53869 .73281 L
s
P
p
1 0 .6 r
.00125 w
.26122 .63356 m
.23149 .66389 L
s
P
p
1 0 .6 r
.00125 w
.26122 .63356 m
.23103 .64466 L
s
P
p
1 0 .6 r
.00088 w
.7119 .76718 m
.73934 .79087 L
s
P
p
1 0 .6 r
.00177 w
.29416 .5943 m
.26116 .62796 L
s
P
p
1 0 .6 r
.00088 w
.25059 .62726 m
.23977 .65598 L
s
P
p
1 0 .6 r
.00088 w
.85201 .65306 m
.87424 .64136 L
s
P
p
1 0 .6 r
.00088 w
.85201 .65306 m
.88413 .66615 L
s
P
p
1 0 .6 r
.00125 w
.84094 .64006 m
.87659 .65452 L
s
P
p
1 0 .6 r
.00125 w
.84094 .64006 m
.86555 .6269 L
s
P
p
1 0 .6 r
.00177 w
.57364 .75154 m
.58889 .79264 L
s
P
p
1 0 .6 r
.00088 w
.23149 .66389 m
.20464 .69128 L
s
P
p
1 0 .6 r
.00125 w
.26116 .62796 m
.23136 .65835 L
s
P
p
1 0 .6 r
.00125 w
.26116 .62796 m
.2309 .63903 L
s
P
p
1 0 .6 r
.0025 w
.61154 .68061 m
.64663 .71082 L
s
P
p
1 0 .6 r
.00088 w
.7119 .76718 m
.73806 .78971 L
s
P
p
1 0 .6 r
.00125 w
.68123 .7407 m
.7119 .76718 L
s
P
p
1 0 .6 r
.00088 w
.23103 .64438 m
.22031 .67305 L
s
P
p
1 0 .6 r
.00088 w
.23138 .6595 m
.20388 .66975 L
s
P
p
1 0 .6 r
.00088 w
.23138 .6595 m
.20449 .68694 L
s
P
p
1 0 .6 r
.00088 w
.23136 .65835 m
.20445 .68579 L
s
P
p
1 0 .6 r
.00125 w
.82723 .6061 m
.86295 .62039 L
s
P
p
1 0 .6 r
.00125 w
.82723 .6061 m
.85181 .59251 L
s
P
p
1 0 .6 r
.00088 w
.24872 .63368 m
.23705 .6202 L
s
P
p
1 0 .6 r
.00088 w
.24872 .63368 m
.2213 .64373 L
s
P
p
1 0 .6 r
.00125 w
.28047 .59681 m
.25059 .62726 L
s
P
p
1 0 .6 r
.00177 w
.29425 .56063 m
.28047 .59681 L
s
P
p
1 0 .6 r
.00125 w
.26106 .61893 m
.23069 .62996 L
s
P
p
1 0 .6 r
.00125 w
.26106 .61893 m
.24824 .60374 L
s
P
p
1 0 .6 r
.00177 w
.57364 .75154 m
.5738 .79667 L
s
P
p
1 0 .6 r
.00125 w
.68123 .7407 m
.7102 .76564 L
s
P
p
1 0 .6 r
.00177 w
.2942 .58001 m
.26077 .59185 L
s
P
p
1 0 .6 r
.00177 w
.2942 .58001 m
.26101 .61383 L
s
P
p
1 0 .6 r
.00088 w
.2312 .65157 m
.2036 .66178 L
s
P
p
1 0 .6 r
.00088 w
.2312 .65157 m
.20421 .67908 L
s
P
p
1 0 .6 r
.00088 w
.23079 .63445 m
.22004 .66331 L
s
P
p
1 0 .6 r
.00088 w
.87659 .65452 m
.89985 .6847 L
s
P
p
1 0 .6 r
.00088 w
.25059 .62726 m
.22362 .65476 L
s
P
p
1 0 .6 r
.00177 w
.53869 .73281 m
.50691 .76098 L
s
P
p
1 0 .6 r
.00177 w
.53869 .73281 m
.52762 .7424 L
s
P
p
1 0 .6 r
.00088 w
.87659 .65452 m
.9091 .66772 L
s
P
p
1 0 .6 r
.00125 w
.26101 .61383 m
.23103 .64438 L
s
P
p
1 0 .6 r
.00125 w
.26101 .61383 m
.23057 .62483 L
s
P
p
1 0 .6 r
.00088 w
.47658 .78807 m
.44947 .81228 L
s
P
p
1 0 .6 r
.00125 w
.26099 .61193 m
.23052 .62292 L
s
P
p
1 0 .6 r
.00125 w
.26099 .61193 m
.24812 .59661 L
s
P
p
1 0 .6 r
.00177 w
.31586 .54779 m
.30229 .52986 L
s
P
p
1 0 .6 r
.00177 w
.31586 .54779 m
.28256 .55931 L
s
P
p
1 0 .6 r
.0025 w
.33116 .52949 m
.29431 .54209 L
s
P
p
1 0 .6 r
.0025 w
.33116 .52949 m
.3163 .50925 L
s
P
p
1 0 .6 r
.00088 w
.23103 .64466 m
.20336 .65483 L
s
P
p
1 0 .6 r
.00088 w
.23103 .64466 m
.20397 .67224 L
s
P
p
1 0 .6 r
.00353 w
.37224 .48124 m
.33178 .4946 L
s
P
p
1 0 .6 r
.00353 w
.37224 .48124 m
.33128 .52293 L
s
P
p
1 0 .6 r
.00088 w
.23103 .64438 m
.20396 .67196 L
s
P
p
1 0 .6 r
.00125 w
.81479 .57527 m
.83933 .56128 L
s
P
p
1 0 .6 r
.00125 w
.81479 .57527 m
.81358 .54139 L
s
P
p
1 0 .6 r
.00177 w
.29423 .56984 m
.26066 .58162 L
s
P
p
1 0 .6 r
.00177 w
.29423 .56984 m
.2609 .60379 L
s
P
p
1 0 .6 r
.00177 w
.64663 .71082 m
.67873 .73845 L
s
P
p
1 0 .6 r
.00177 w
.64663 .71082 m
.65735 .71996 L
s
P
p
1 0 .6 r
.00088 w
.23058 .62544 m
.21979 .65447 L
s
P
p
1 0 .6 r
.00088 w
.47658 .78807 m
.45041 .81127 L
s
P
p
1 0 .6 r
.00125 w
.50691 .76098 m
.47658 .78807 L
s
P
p
1 0 .6 r
.00125 w
.5738 .79667 m
.57395 .83773 L
s
P
p
1 0 .6 r
.00125 w
.5738 .79667 m
.58208 .81675 L
s
P
p
1 0 .6 r
.00088 w
.86555 .6269 m
.88815 .61481 L
s
P
p
1 0 .6 r
.00088 w
.86555 .6269 m
.89811 .63996 L
s
P
p
1 0 .6 r
.00088 w
.86295 .62039 m
.88633 .65073 L
s
P
p
1 0 .6 r
.00088 w
.2309 .63903 m
.20316 .64918 L
s
P
p
1 0 .6 r
.00088 w
.2309 .63903 m
.20377 .66667 L
s
P
p
1 0 .6 r
.0025 w
.33128 .52293 m
.29425 .56063 L
s
P
p
1 0 .6 r
.0025 w
.33128 .52293 m
.29432 .53548 L
s
P
p
1 0 .6 r
.00125 w
.2609 .60379 m
.23079 .63445 L
s
P
p
1 0 .6 r
.00125 w
.2609 .60379 m
.23033 .61473 L
s
P
p
1 0 .6 r
.00088 w
.36426 .62836 m
.34587 .61988 L
s
P
p
1 0 .6 r
.00088 w
.70979 .76528 m
.73758 .78927 L
s
P
p
1 0 .6 r
.00088 w
.86295 .62039 m
.89552 .63342 L
s
P
p
1 0 .6 r
.00088 w
.7102 .76564 m
.73662 .78839 L
s
P
p
1 0 .6 r
.00088 w
.7102 .76564 m
.71963 .7737 L
s
P
p
1 0 .6 r
.00353 w
.39937 .44093 m
.38392 .41681 L
s
P
p
1 0 .6 r
.00353 w
.39937 .44093 m
.35913 .4538 L
s
P
p
1 0 .6 r
.00353 w
.59264 .56391 m
.6247 .57605 L
s
P
p
1 0 .6 r
.00353 w
.59264 .56391 m
.5807 .5879 L
s
P
p
1 0 .6 r
.00088 w
.23079 .63445 m
.20361 .66213 L
s
P
p
1 0 .6 r
.00177 w
.29425 .56063 m
.2608 .59468 L
s
P
p
1 0 .6 r
.00353 w
.54446 .57686 m
.53169 .60109 L
s
P
p
1 0 .6 r
.00353 w
.54446 .57686 m
.49544 .59857 L
s
P
p
1 0 .6 r
.00125 w
.50691 .76098 m
.47791 .78669 L
s
P
p
1 0 .6 r
.00088 w
.70979 .76528 m
.73627 .78808 L
s
P
p
1 0 .6 r
.00125 w
.67873 .73845 m
.70979 .76528 L
s
P
p
1 0 .6 r
.00088 w
.57395 .83773 m
.55085 .86833 L
s
P
p
1 0 .6 r
.00088 w
.23069 .62996 m
.20284 .64006 L
s
P
p
1 0 .6 r
.00088 w
.23069 .62996 m
.20346 .65768 L
s
P
p
1 0 .6 r
.00125 w
.2608 .59468 m
.23058 .62544 L
s
P
p
1 0 .6 r
.00125 w
.2608 .59468 m
.23011 .60558 L
s
P
p
1 0 .6 r
.00088 w
.85181 .59251 m
.87438 .58002 L
s
P
p
1 0 .6 r
.00088 w
.85181 .59251 m
.88443 .60541 L
s
P
p
1 0 .6 r
.00088 w
.57395 .83773 m
.57409 .87504 L
s
P
p
1 0 .6 r
.00125 w
.26077 .59185 m
.23005 .60273 L
s
P
p
1 0 .6 r
.00125 w
.26077 .59185 m
.24779 .57615 L
s
P
p
1 0 .6 r
.00088 w
.23058 .62544 m
.2033 .65321 L
s
P
p
1 0 .6 r
.00088 w
.23057 .62483 m
.20265 .63491 L
s
P
p
1 0 .6 r
.00088 w
.23057 .62483 m
.20328 .65261 L
s
P
p
1 0 .6 r
.00088 w
.81358 .54139 m
.81248 .51042 L
s
P
p
1 0 .6 r
.00088 w
.81358 .54139 m
.83582 .52837 L
s
P
p
1 0 .6 r
.00088 w
.24824 .60374 m
.23642 .58975 L
s
P
p
1 0 .6 r
.00088 w
.24824 .60374 m
.22047 .61364 L
s
P
p
1 0 .6 r
.00088 w
.23015 .60732 m
.21928 .63668 L
s
P
p
1 0 .6 r
.00125 w
.67873 .73845 m
.70805 .7637 L
s
P
p
1 0 .6 r
.00088 w
.23052 .62292 m
.20259 .63299 L
s
P
p
1 0 .6 r
.00088 w
.23052 .62292 m
.20321 .65072 L
s
P
p
1 0 .6 r
.00088 w
.36426 .62836 m
.32785 .63254 L
s
P
p
1 0 .6 r
.00125 w
.28256 .55931 m
.25197 .5699 L
s
P
p
1 0 .6 r
.00125 w
.28256 .55931 m
.26982 .54316 L
s
P
p
1 0 .6 r
.00088 w
.83933 .56128 m
.86187 .54842 L
s
P
p
1 0 .6 r
.00088 w
.83933 .56128 m
.87201 .57403 L
s
P
p
1 0 .6 r
.00088 w
.23 .60087 m
.2191 .63035 L
s
P
p
1 0 .6 r
.00088 w
.24812 .59661 m
.23627 .5825 L
s
P
p
1 0 .6 r
.00088 w
.24812 .59661 m
.22028 .60647 L
s
P
p
1 0 .6 r
.00125 w
.26066 .58162 m
.2298 .59244 L
s
P
p
1 0 .6 r
.00125 w
.26066 .58162 m
.24762 .56573 L
s
P
p
1 0 .6 r
.00177 w
.29431 .54209 m
.26035 .55369 L
s
P
p
1 0 .6 r
.00177 w
.29431 .54209 m
.2606 .57636 L
s
P
p
1 0 .6 r
.00088 w
.47791 .78669 m
.45147 .81013 L
s
P
p
1 0 .6 r
.00088 w
.47791 .78669 m
.46811 .79519 L
s
P
p
1 0 .6 r
.00088 w
.23033 .61473 m
.2023 .62477 L
s
P
p
1 0 .6 r
.00088 w
.23033 .61473 m
.20293 .64261 L
s
P
p
1 0 .6 r
.00125 w
.52762 .7424 m
.51738 .75127 L
s
P
p
1 0 .6 r
.00125 w
.52762 .7424 m
.49855 .76817 L
s
P
p
1 0 .6 r
.00125 w
.405 .62367 m
.36426 .62836 L
s
P
p
1 0 .6 r
.00125 w
.30229 .52986 m
.28976 .5133 L
s
P
p
1 0 .6 r
.00125 w
.30229 .52986 m
.31506 .49626 L
s
P
p
1 0 .6 r
.0025 w
.49544 .59857 m
.45065 .61842 L
s
P
p
1 0 .6 r
.0025 w
.49544 .59857 m
.48313 .62086 L
s
P
p
1 0 .6 r
.0025 w
.33178 .4946 m
.2944 .50694 L
s
P
p
1 0 .6 r
.0025 w
.33178 .4946 m
.31671 .47354 L
s
P
p
1 0 .6 r
.00125 w
.2606 .57636 m
.23015 .60732 L
s
P
p
1 0 .6 r
.00125 w
.2606 .57636 m
.22968 .58716 L
s
P
p
1 0 .6 r
.00088 w
.58208 .81675 m
.58971 .83526 L
s
P
p
1 0 .6 r
.00088 w
.58208 .81675 m
.61417 .83194 L
s
P
p
1 0 .6 r
.00177 w
.29432 .53548 m
.26028 .54704 L
s
P
p
1 0 .6 r
.00177 w
.29432 .53548 m
.26053 .56984 L
s
P
p
1 0 .6 r
.00177 w
.3163 .50925 m
.30252 .49051 L
s
P
p
1 0 .6 r
.00177 w
.3163 .50925 m
.28249 .52053 L
s
P
p
1 0 .6 r
.00088 w
.23015 .60732 m
.20267 .63528 L
s
P
p
1 0 .6 r
.00125 w
.65735 .71996 m
.66727 .72843 L
s
P
p
1 0 .6 r
.00125 w
.65735 .71996 m
.68672 .74525 L
s
P
p
1 0 .6 r
.00088 w
.70805 .7637 m
.73479 .78673 L
s
P
p
1 0 .6 r
.00088 w
.70805 .7637 m
.71758 .77184 L
s
P
p
1 0 .6 r
.00088 w
.23011 .60558 m
.20197 .61557 L
s
P
p
1 0 .6 r
.00088 w
.23011 .60558 m
.20261 .63355 L
s
P
p
1 0 .6 r
.00125 w
.26053 .56984 m
.23 .60087 L
s
P
p
1 0 .6 r
.00125 w
.26053 .56984 m
.22953 .5806 L
s
P
p
1 0 .6 r
.00125 w
.405 .62367 m
.36812 .63992 L
s
P
p
1 0 .6 r
.00177 w
.45065 .61842 m
.405 .62367 L
s
P
p
1 0 .6 r
.00088 w
.75879 .54855 m
.78993 .5344 L
s
P
p
1 0 .6 r
.0025 w
.35913 .4538 m
.32196 .46568 L
s
P
p
1 0 .6 r
.0025 w
.35913 .4538 m
.34443 .43202 L
s
P
p
1 0 .6 r
.00088 w
.23005 .60273 m
.20187 .6127 L
s
P
p
1 0 .6 r
.00088 w
.23005 .60273 m
.20251 .63073 L
s
P
p
1 0 .6 r
.00088 w
.23 .60087 m
.20244 .62889 L
s
P
p
1 0 .6 r
.00088 w
.36812 .63992 m
.33134 .64411 L
s
P
p
1 0 .6 r
.00088 w
.49855 .76817 m
.47205 .79166 L
s
P
p
1 0 .6 r
.00088 w
.49855 .76817 m
.48893 .7765 L
s
P
p
1 0 .6 r
.0025 w
.6247 .57605 m
.65442 .58731 L
s
P
p
1 0 .6 r
.0025 w
.6247 .57605 m
.67663 .56997 L
s
P
p
1 0 .6 r
.00088 w
.24779 .57615 m
.23584 .56168 L
s
P
p
1 0 .6 r
.00088 w
.24779 .57615 m
.21971 .58591 L
s
P
p
1 0 .6 r
.00088 w
.25197 .5699 m
.2239 .57961 L
s
P
p
1 0 .6 r
.00088 w
.25197 .5699 m
.22438 .59793 L
s
P
p
1 0 .6 r
.0025 w
.38392 .41681 m
.36956 .39439 L
s
P
p
1 0 .6 r
.0025 w
.38392 .41681 m
.40061 .37387 L
s
P
p
1 0 .6 r
.00088 w
.31506 .49626 m
.32672 .46558 L
s
P
p
1 0 .6 r
.00088 w
.31506 .49626 m
.30385 .48088 L
s
P
p
1 0 .6 r
.0025 w
.5807 .5879 m
.56961 .61019 L
s
P
p
1 0 .6 r
.0025 w
.5807 .5879 m
.60983 .59934 L
s
P
p
1 0 .6 r
.00177 w
.45065 .61842 m
.40976 .63653 L
s
P
p
1 0 .6 r
.00088 w
.2298 .59244 m
.20151 .60237 L
s
P
p
1 0 .6 r
.00088 w
.2298 .59244 m
.20215 .62055 L
s
P
p
1 0 .6 r
.0025 w
.53169 .60109 m
.51984 .62361 L
s
P
p
1 0 .6 r
.0025 w
.53169 .60109 m
.56017 .61273 L
s
P
p
1 0 .6 r
.00088 w
.36812 .63992 m
.33455 .65471 L
s
P
p
1 0 .6 r
.00088 w
.75879 .54855 m
.79718 .54401 L
s
P
p
1 0 .6 r
.00125 w
.7238 .56445 m
.75879 .54855 L
s
P
p
1 0 .6 r
.00088 w
.22935 .57297 m
.21833 .60298 L
s
P
p
1 0 .6 r
.00088 w
.26982 .54316 m
.25808 .52828 L
s
P
p
1 0 .6 r
.00088 w
.26982 .54316 m
.24185 .55265 L
s
P
p
1 0 .6 r
.00125 w
.26035 .55369 m
.22914 .56435 L
s
P
p
1 0 .6 r
.00125 w
.26035 .55369 m
.24717 .53726 L
s
P
p
1 0 .6 r
.00088 w
.68672 .74525 m
.71351 .76832 L
s
P
p
1 0 .6 r
.00088 w
.68672 .74525 m
.69606 .75322 L
s
P
p
1 0 .6 r
.00088 w
.22968 .58716 m
.20132 .59706 L
s
P
p
1 0 .6 r
.00088 w
.22968 .58716 m
.20196 .61531 L
s
P
p
1 0 .6 r
.00088 w
.24762 .56573 m
.23562 .55109 L
s
P
p
1 0 .6 r
.00088 w
.24762 .56573 m
.21942 .57544 L
s
P
p
1 0 .6 r
.00177 w
.67663 .56997 m
.7238 .56445 L
s
P
p
1 0 .6 r
.00177 w
.67663 .56997 m
.70414 .58006 L
s
P
p
1 0 .6 r
.00088 w
.28976 .5133 m
.27821 .49804 L
s
P
p
1 0 .6 r
.00088 w
.28976 .5133 m
.26189 .52255 L
s
P
p
1 0 .6 r
.00125 w
.26028 .54704 m
.22899 .55767 L
s
P
p
1 0 .6 r
.00125 w
.26028 .54704 m
.24706 .53049 L
s
P
p
1 0 .6 r
.00088 w
.51738 .75127 m
.50793 .75945 L
s
P
p
1 0 .6 r
.00088 w
.51738 .75127 m
.53071 .73918 L
s
P
p
1 0 .6 r
.00177 w
.2944 .50694 m
.25997 .51831 L
s
P
p
1 0 .6 r
.00177 w
.2944 .50694 m
.26022 .54164 L
s
P
p
1 0 .6 r
.00125 w
.28249 .52053 m
.25141 .53089 L
s
P
p
1 0 .6 r
.00125 w
.28249 .52053 m
.26954 .50363 L
s
P
p
1 0 .6 r
.00088 w
.25676 .53181 m
.24551 .56221 L
s
P
p
1 0 .6 r
.00088 w
.22953 .5806 m
.20109 .59047 L
s
P
p
1 0 .6 r
.00088 w
.22953 .5806 m
.20173 .60882 L
s
P
p
1 0 .6 r
.00125 w
.40976 .63653 m
.3725 .65304 L
s
P
p
1 0 .6 r
.00125 w
.40976 .63653 m
.39861 .65526 L
s
P
p
1 0 .6 r
.00125 w
.26022 .54164 m
.22935 .57297 L
s
P
p
1 0 .6 r
.00125 w
.26022 .54164 m
.22886 .55223 L
s
P
p
1 0 .6 r
.00125 w
.7238 .56445 m
.76659 .55944 L
s
P
p
1 0 .6 r
.00177 w
.48313 .62086 m
.47173 .6415 L
s
P
p
1 0 .6 r
.00177 w
.48313 .62086 m
.44215 .63913 L
s
P
p
1 0 .6 r
.00125 w
.30252 .49051 m
.2898 .47319 L
s
P
p
1 0 .6 r
.00125 w
.30252 .49051 m
.3155 .45607 L
s
P
p
1 0 .6 r
.00177 w
.31671 .47354 m
.30274 .45402 L
s
P
p
1 0 .6 r
.00177 w
.31671 .47354 m
.28242 .48457 L
s
P
p
1 0 .6 r
.00088 w
.66727 .72843 m
.67643 .73624 L
s
P
p
1 0 .6 r
.00088 w
.66727 .72843 m
.65326 .71626 L
s
P
p
1 0 .6 r
.00088 w
.22935 .57297 m
.20147 .60127 L
s
P
p
1 0 .6 r
.00177 w
.32196 .46568 m
.28771 .47662 L
s
P
p
1 0 .6 r
.00177 w
.32196 .46568 m
.2877 .50042 L
s
P
p
1 0 .6 r
.00088 w
.3725 .65304 m
.3353 .65723 L
s
P
p
1 0 .6 r
.00177 w
.40061 .37387 m
.41589 .33453 L
s
P
p
1 0 .6 r
.00177 w
.40061 .37387 m
.38781 .35293 L
s
P
p
1 0 .6 r
.00125 w
.2877 .50042 m
.25676 .53181 L
s
P
p
1 0 .6 r
.00125 w
.2877 .50042 m
.2565 .51064 L
s
P
p
1 0 .6 r
.00088 w
.76659 .55944 m
.80539 .5549 L
s
P
p
1 0 .6 r
.00088 w
.76659 .55944 m
.78994 .56755 L
s
P
p
1 0 .6 r
.00177 w
.34443 .43202 m
.3308 .41184 L
s
P
p
1 0 .6 r
.00177 w
.34443 .43202 m
.31033 .44262 L
s
P
p
1 0 .6 r
.00088 w
.22914 .56435 m
.20051 .57414 L
s
P
p
1 0 .6 r
.00088 w
.22914 .56435 m
.20117 .59274 L
s
P
p
1 0 .6 r
.00088 w
.25676 .53181 m
.22882 .56014 L
s
P
p
1 0 .6 r
.00088 w
.3725 .65304 m
.33858 .66806 L
s
P
p
1 0 .6 r
.00177 w
.65442 .58731 m
.6819 .59771 L
s
P
p
1 0 .6 r
.00177 w
.65442 .58731 m
.64535 .60759 L
s
P
p
1 0 .6 r
.00177 w
.60983 .59934 m
.63677 .60991 L
s
P
p
1 0 .6 r
.00177 w
.60983 .59934 m
.60013 .61981 L
s
P
p
1 0 .6 r
.00088 w
.44672 .30332 m
.47438 .27533 L
s
P
p
1 0 .6 r
.00125 w
.44215 .63913 m
.40479 .65578 L
s
P
p
1 0 .6 r
.00125 w
.44215 .63913 m
.43132 .65804 L
s
P
p
1 0 .6 r
.00088 w
.24717 .53726 m
.23501 .52212 L
s
P
p
1 0 .6 r
.00088 w
.24717 .53726 m
.21863 .54682 L
s
P
p
1 0 .6 r
.00088 w
.22899 .55767 m
.20027 .56742 L
s
P
p
1 0 .6 r
.00088 w
.22899 .55767 m
.20093 .58612 L
s
P
p
1 0 .6 r
.00177 w
.56961 .61019 m
.55934 .63084 L
s
P
p
1 0 .6 r
.00177 w
.56961 .61019 m
.5289 .62852 L
s
P
p
1 0 .6 r
.00177 w
.36956 .39439 m
.35624 .37361 L
s
P
p
1 0 .6 r
.00177 w
.36956 .39439 m
.33562 .4046 L
s
P
p
1 0 .6 r
.00088 w
.25141 .53089 m
.22289 .5404 L
s
P
p
1 0 .6 r
.00088 w
.25141 .53089 m
.22338 .55931 L
s
P
p
1 0 .6 r
.00177 w
.56017 .61273 m
.58649 .6235 L
s
P
p
1 0 .6 r
.00177 w
.56017 .61273 m
.54975 .63343 L
s
P
p
1 0 .6 r
.00088 w
.3155 .45607 m
.32735 .42462 L
s
P
p
1 0 .6 r
.00088 w
.3155 .45607 m
.30412 .43999 L
s
P
p
1 0 .6 r
.00088 w
.44672 .30332 m
.45949 .27079 L
s
P
p
1 0 .6 r
.00125 w
.41589 .33453 m
.44672 .30332 L
s
P
p
1 0 .6 r
.00125 w
.70414 .58006 m
.7295 .58936 L
s
P
p
1 0 .6 r
.00125 w
.70414 .58006 m
.74722 .57507 L
s
P
p
1 0 .6 r
.00125 w
.25997 .51831 m
.22831 .52877 L
s
P
p
1 0 .6 r
.00125 w
.25997 .51831 m
.24659 .5012 L
s
P
p
1 0 .6 r
.00177 w
.51984 .62361 m
.50885 .64448 L
s
P
p
1 0 .6 r
.00177 w
.51984 .62361 m
.47873 .64207 L
s
P
p
1 0 .6 r
.00088 w
.40479 .65578 m
.36718 .66 L
s
P
p
1 0 .6 r
.00088 w
.22886 .55223 m
.20008 .56195 L
s
P
p
1 0 .6 r
.00088 w
.22886 .55223 m
.20074 .58073 L
s
P
p
1 0 .6 r
.00088 w
.24706 .53049 m
.23487 .51523 L
s
P
p
1 0 .6 r
.00088 w
.24706 .53049 m
.21844 .54001 L
s
P
p
1 0 .6 r
.00125 w
.41589 .33453 m
.42988 .29854 L
s
P
p
1 0 .6 r
.00088 w
.26954 .50363 m
.25761 .48806 L
s
P
p
1 0 .6 r
.00088 w
.26954 .50363 m
.24112 .51291 L
s
P
p
1 0 .6 r
.00088 w
.39861 .65526 m
.38834 .67252 L
s
P
p
1 0 .6 r
.00088 w
.39861 .65526 m
.36462 .67039 L
s
P
p
1 0 .6 r
.00125 w
.28242 .48457 m
.25089 .49471 L
s
P
p
1 0 .6 r
.00125 w
.28242 .48457 m
.26929 .46697 L
s
P
p
1 0 .6 r
.00125 w
.28771 .47662 m
.25621 .48669 L
s
P
p
1 0 .6 r
.00125 w
.28771 .47662 m
.27463 .45891 L
s
P
p
1 0 .6 r
.00088 w
.74722 .57507 m
.78628 .57054 L
s
P
p
1 0 .6 r
.00088 w
.74722 .57507 m
.77057 .58341 L
s
P
p
1 0 .6 r
.00088 w
.2898 .47319 m
.27806 .45722 L
s
P
p
1 0 .6 r
.00088 w
.2898 .47319 m
.26149 .48221 L
s
P
p
1 0 .6 r
.00088 w
.40479 .65578 m
.37077 .67095 L
s
P
p
1 0 .6 r
.00088 w
.2565 .51064 m
.22787 .52001 L
s
P
p
1 0 .6 r
.00088 w
.2565 .51064 m
.22832 .53918 L
s
P
p
1 0 .6 r
.00125 w
.47173 .6415 m
.4612 .66058 L
s
P
p
1 0 .6 r
.00125 w
.47173 .6415 m
.49451 .65158 L
s
P
p
1 0 .6 r
.00125 w
.5289 .62852 m
.49179 .64524 L
s
P
p
1 0 .6 r
.00125 w
.5289 .62852 m
.51909 .64744 L
s
P
p
1 0 .6 r
.00125 w
.30274 .45402 m
.28983 .43598 L
s
P
p
1 0 .6 r
.00125 w
.30274 .45402 m
.31591 .4188 L
s
P
p
1 0 .6 r
.00125 w
.31033 .44262 m
.27896 .45237 L
s
P
p
1 0 .6 r
.00125 w
.31033 .44262 m
.2975 .42442 L
s
P
p
1 0 .6 r
.00125 w
.38781 .35293 m
.37598 .33356 L
s
P
p
1 0 .6 r
.00125 w
.38781 .35293 m
.40165 .31688 L
s
P
p
1 0 .6 r
.00125 w
.47873 .64207 m
.44126 .65889 L
s
P
p
1 0 .6 r
.00125 w
.47873 .64207 m
.46827 .66118 L
s
P
p
1 0 .6 r
.00088 w
.49179 .64524 m
.4536 .64952 L
s
P
p
1 0 .6 r
.00088 w
.42988 .29854 m
.44265 .26566 L
s
P
p
1 0 .6 r
.00088 w
.42988 .29854 m
.41971 .28046 L
s
P
p
1 0 .6 r
.00125 w
.6819 .59771 m
.70725 .60731 L
s
P
p
1 0 .6 r
.00125 w
.6819 .59771 m
.72531 .59274 L
s
P
p
1 0 .6 r
.00088 w
.44126 .65889 m
.4032 .66313 L
s
P
p
1 0 .6 r
.00125 w
.3308 .41184 m
.31821 .39319 L
s
P
p
1 0 .6 r
.00125 w
.3308 .41184 m
.34424 .37616 L
s
P
p
1 0 .6 r
.00088 w
.22831 .52877 m
.19925 .53837 L
s
P
p
1 0 .6 r
.00088 w
.22831 .52877 m
.19992 .55751 L
s
P
p
1 0 .6 r
.00125 w
.33562 .4046 m
.30442 .41399 L
s
P
p
1 0 .6 r
.00125 w
.33562 .4046 m
.32308 .38584 L
s
P
p
1 0 .6 r
.00125 w
.64535 .60759 m
.63697 .62634 L
s
P
p
1 0 .6 r
.00125 w
.64535 .60759 m
.67029 .61732 L
s
P
p
1 0 .6 r
.00088 w
.43132 .65804 m
.42133 .67547 L
s
P
p
1 0 .6 r
.00088 w
.43132 .65804 m
.39723 .67331 L
s
P
p
1 0 .6 r
.00125 w
.63677 .60991 m
.66161 .61967 L
s
P
p
1 0 .6 r
.00125 w
.63677 .60991 m
.68005 .60498 L
s
P
p
1 0 .6 r
.00088 w
.7295 .58936 m
.75284 .59792 L
s
P
p
1 0 .6 r
.00088 w
.7295 .58936 m
.72293 .60602 L
s
P
p
1 0 .6 r
.00125 w
.60013 .61981 m
.59116 .63874 L
s
P
p
1 0 .6 r
.00125 w
.60013 .61981 m
.62457 .62969 L
s
P
p
1 0 .6 r
.00088 w
.49179 .64524 m
.458 .66045 L
s
P
p
1 0 .6 r
.00125 w
.58649 .6235 m
.61078 .63343 L
s
P
p
1 0 .6 r
.00125 w
.58649 .6235 m
.62964 .61862 L
s
P
p
1 0 .6 r
.00088 w
.24659 .5012 m
.23425 .48542 L
s
P
p
1 0 .6 r
.00088 w
.24659 .5012 m
.21763 .51056 L
s
P
p
1 0 .6 r
.00125 w
.55934 .63084 m
.54984 .64992 L
s
P
p
1 0 .6 r
.00125 w
.55934 .63084 m
.58332 .64086 L
s
P
p
1 0 .6 r
.00125 w
.54975 .63343 m
.54013 .65255 L
s
P
p
1 0 .6 r
.00125 w
.54975 .63343 m
.57363 .64348 L
s
P
p
1 0 .6 r
.00088 w
.44126 .65889 m
.40715 .6742 L
s
P
p
1 0 .6 r
.00125 w
.35624 .37361 m
.34393 .35439 L
s
P
p
1 0 .6 r
.00125 w
.35624 .37361 m
.36992 .3375 L
s
P
p
1 0 .6 r
.00088 w
.25089 .49471 m
.22195 .50402 L
s
P
p
1 0 .6 r
.00088 w
.25089 .49471 m
.22246 .52348 L
s
P
p
1 0 .6 r
.00088 w
.72531 .59274 m
.76467 .58824 L
s
P
p
1 0 .6 r
.00088 w
.72531 .59274 m
.74865 .60135 L
s
P
p
1 0 .6 r
.00088 w
.31591 .4188 m
.32793 .38663 L
s
P
p
1 0 .6 r
.00088 w
.31591 .4188 m
.30436 .40205 L
s
P
p
1 0 .6 r
.00088 w
.25621 .48669 m
.2273 .49593 L
s
P
p
1 0 .6 r
.00088 w
.25621 .48669 m
.22776 .51547 L
s
P
p
1 0 .6 r
.00125 w
.50885 .64448 m
.49869 .66377 L
s
P
p
1 0 .6 r
.00125 w
.50885 .64448 m
.53226 .65468 L
s
P
p
1 0 .6 r
.00088 w
.68005 .60498 m
.7193 .60051 L
s
P
p
1 0 .6 r
.00088 w
.68005 .60498 m
.70294 .61373 L
s
P
p
1 0 .6 r
.00088 w
.40165 .31688 m
.4143 .28395 L
s
P
p
1 0 .6 r
.00088 w
.40165 .31688 m
.3911 .29892 L
s
P
p
1 0 .6 r
.00088 w
.26929 .46697 m
.25717 .45074 L
s
P
p
1 0 .6 r
.00088 w
.26929 .46697 m
.24045 .47604 L
s
P
p
1 0 .6 r
.00088 w
.62964 .61862 m
.66876 .61419 L
s
P
p
1 0 .6 r
.00088 w
.62964 .61862 m
.65202 .62753 L
s
P
p
1 0 .6 r
.00088 w
.27463 .45891 m
.26257 .44257 L
s
P
p
1 0 .6 r
.00088 w
.27463 .45891 m
.24582 .46791 L
s
P
p
1 0 .6 r
.00088 w
.49451 .65158 m
.51546 .66085 L
s
P
p
1 0 .6 r
.00088 w
.49451 .65158 m
.48519 .66904 L
s
P
p
1 0 .6 r
.00088 w
.27896 .45237 m
.25018 .46132 L
s
P
p
1 0 .6 r
.00088 w
.27896 .45237 m
.25047 .48118 L
s
P
p
1 0 .6 r
.00088 w
.34424 .37616 m
.35651 .34356 L
s
P
p
1 0 .6 r
.00088 w
.34424 .37616 m
.33298 .35884 L
s
P
p
1 0 .6 r
.00088 w
.4612 .66058 m
.45148 .67817 L
s
P
p
1 0 .6 r
.00088 w
.4612 .66058 m
.42703 .67598 L
s
P
p
1 0 .6 r
.00088 w
.51909 .64744 m
.51004 .66488 L
s
P
p
1 0 .6 r
.00088 w
.51909 .64744 m
.48523 .66277 L
s
P
p
1 0 .6 r
.00088 w
.28983 .43598 m
.27793 .41934 L
s
P
p
1 0 .6 r
.00088 w
.28983 .43598 m
.26111 .44478 L
s
P
p
1 0 .6 r
.00088 w
.46827 .66118 m
.45862 .67881 L
s
P
p
1 0 .6 r
.00088 w
.46827 .66118 m
.43408 .67661 L
s
P
p
1 0 .6 r
.00088 w
.2975 .42442 m
.28567 .40762 L
s
P
p
1 0 .6 r
.00088 w
.2975 .42442 m
.26882 .43312 L
s
P
p
1 0 .6 r
.00088 w
.37598 .33356 m
.36507 .3157 L
s
P
p
1 0 .6 r
.00088 w
.37598 .33356 m
.34804 .34142 L
s
P
p
1 0 .6 r
.00088 w
.30442 .41399 m
.27577 .4226 L
s
P
p
1 0 .6 r
.00088 w
.30442 .41399 m
.27586 .44284 L
s
P
p
1 0 .6 r
.00088 w
.36992 .3375 m
.38242 .30451 L
s
P
p
1 0 .6 r
.00088 w
.36992 .3375 m
.35893 .31967 L
s
P
p
1 0 .6 r
.00088 w
.70725 .60731 m
.73058 .61615 L
s
P
p
1 0 .6 r
.00088 w
.70725 .60731 m
.70035 .62434 L
s
P
p
1 0 .6 r
.00088 w
.67029 .61732 m
.69325 .62627 L
s
P
p
1 0 .6 r
.00088 w
.67029 .61732 m
.66296 .63448 L
s
P
p
1 0 .6 r
.00088 w
.66161 .61967 m
.68448 .62864 L
s
P
p
1 0 .6 r
.00088 w
.66161 .61967 m
.65418 .63686 L
s
P
p
1 0 .6 r
.00088 w
.31821 .39319 m
.30659 .37598 L
s
P
p
1 0 .6 r
.00088 w
.31821 .39319 m
.28964 .40162 L
s
P
p
1 0 .6 r
.00088 w
.63697 .62634 m
.62924 .64362 L
s
P
p
1 0 .6 r
.00088 w
.63697 .62634 m
.6036 .64163 L
s
P
p
1 0 .6 r
.00088 w
.32308 .38584 m
.31151 .36853 L
s
P
p
1 0 .6 r
.00088 w
.32308 .38584 m
.29454 .39421 L
s
P
p
1 0 .6 r
.00088 w
.62457 .62969 m
.64706 .63879 L
s
P
p
1 0 .6 r
.00088 w
.62457 .62969 m
.6167 .64702 L
s
P
p
1 0 .6 r
.00088 w
.61078 .63343 m
.63313 .64257 L
s
P
p
1 0 .6 r
.00088 w
.61078 .63343 m
.60274 .65081 L
s
P
p
1 0 .6 r
.00088 w
.59116 .63874 m
.58289 .65619 L
s
P
p
1 0 .6 r
.00088 w
.59116 .63874 m
.5575 .65411 L
s
P
p
1 0 .6 r
.00088 w
.58332 .64086 m
.60539 .65009 L
s
P
p
1 0 .6 r
.00088 w
.58332 .64086 m
.57496 .65834 L
s
P
p
1 0 .6 r
.00088 w
.57363 .64348 m
.59561 .65274 L
s
P
p
1 0 .6 r
.00088 w
.57363 .64348 m
.56515 .661 L
s
P
p
1 0 .6 r
.00088 w
.54984 .64992 m
.54108 .66752 L
s
P
p
1 0 .6 r
.00088 w
.54984 .64992 m
.5159 .66538 L
s
P
p
1 0 .6 r
.00088 w
.54013 .65255 m
.53126 .67019 L
s
P
p
1 0 .6 r
.00088 w
.54013 .65255 m
.50613 .66803 L
s
P
p
1 0 .6 r
.00088 w
.53226 .65468 m
.55382 .66407 L
s
P
p
1 0 .6 r
.00088 w
.53226 .65468 m
.5233 .67235 L
s
P
p
1 0 .6 r
.00088 w
.34393 .35439 m
.33258 .33667 L
s
P
p
1 0 .6 r
.00088 w
.34393 .35439 m
.3155 .36249 L
s
P
p
1 0 .6 r
.00088 w
.49869 .66377 m
.48933 .68156 L
s
P
p
1 0 .6 r
.00088 w
.49869 .66377 m
.46442 .67933 L
s
P
p
1 g
.002 w
.8517 .02689 m
.88114 .72344 L
s
.88114 .72344 m
.02689 .78484 L
s
.02689 .78484 m
.06986 .11778 L
s
.06986 .11778 m
.8517 .02689 L
s
.8517 .02689 m
.88114 .72344 L
s
.88114 .72344 m
.97311 .96851 L
s
.97311 .96851 m
.94317 .39493 L
s
.94317 .39493 m
.8517 .02689 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
    Evaluatable->False,
    AspectRatioFixed->True,
    ImageSize->{163, 178},
    ImageMargins->{{0, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    AnimationDisplayTime->5,
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
0025aPD06<H1000007cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K62@007LKFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040001caPT0
3LH00`36aP0FaP400000J]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H9000Ca]K6e/KFa]K6e/KFa]K6e/KFaP03a08001O6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
HLH900C600?4a/H03<H9a0?60P0GaP400000F=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000C
a]K6e/KFa]K6e/KFa]K4e/KFaP09a00<a]K6e/KFa]K6e/KF0P005lKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040001?aPT04lH9a1G60P0GaP400000A]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000Ca]K6e/KFa]K6e/KFa]K6e/KF
aP09a00ga]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP010000?LH900O600?4a/H02LH9a0k600?4a/H05/H00`36000FaP400000==K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000Ca]K6e/KFa]K6e/KFa]K6e/K4
aP09a019a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP010000:lH901?62L@PaP03a<K601K600<0aP005/H1000002;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62@004lK4a]K6e/KFa]K6e/KFa]K6e/H02L@0FlKF
a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001W62@0:aP03a<K600K62L@AaP03a<K601o6
00?4a/H05/H00`36000EaP4000004=K6e/KFa]K6e/KFa]K6e/H9000Ca]K6e/KFa]K6e/KFa]K6e/KF
aP09a01]a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
2lH501?62L@2aP03a<K601o600?4a/H07lH00lC6aP0EaP030<H001G60@00000Je/KFa]K6e/KFa]H0
a<KFa]K6e/KFa]K6e/H9a01oa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP0100002lH20004a<K6aPW45LH00lC6aP0OaP03a<K601k6
00?4a/H05LH01036aP0DaP4000003MK6e/KFa]K6e/KF0=H01<@0TLKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0000_600@0aP348LH00lC6aP0OaP03a<K601k600?4a/H05<H01036aP0DaP400000X]K6
e/KFa]K6e/KF0=K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000;aP060<K6aP348<H00lC6
aP0OaP03a<K601k600?4a/H04/H00l@0a002a0030<K601760@00001oe/KFa]K6e/KFa]H0e/KF0=K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6eP0:a00IaP36e/H0
a]K6e/KFa]K6e/KFa]K6e/KFaP0100002lH00`36aP02aP030<C601o600?4a/H07lH00lC6aP0MaP_4
2lH01@36a/H001?60@00001/e/KFa]K6e/KFaP36e/KFa]H0a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K62/@0;=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60@0000[6
00<0a/H01LH00`34aP0OaP03a<K601k600?4a/H02/H:a0W600?4a/H04/H00`36aP02aP030<K60136
0@00001He/KFa]K6e/KFaP36e/KFa]K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFaP[4043Fa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60@0000[600<0a/H01/H00`34
aP0OaP03a<K601K62/@NaP03a<K6017600<0a/H00/H00`36aP0@aP400000A=K6e/KFa]K6e/H0a]K6
e/KFa]K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K62/@0E=K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFaP36e/KFa]K6e/KFa]K6e/KFaP40000:aP030<K600O600<0a/@07lH01<C6a/H:a1;600?4a/H0
7LH00lC6aP0AaP030<K600?600<0a/H03lH10000037Fa]K6e/KFa]K60<KFa]K6e/KFa]H0a<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00W406SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6
e/KFa]K6e/KFaP40000:aP030<K600W600<0a<H03/H:a0K600?4a/H07LH00lC6aP0MaP03a<K60136
00<0a/H01<H00`36aP0>aP4000007MK6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a/C6e/KF00[407_6e/KF
a]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0
0@0000[600<0a/H02/H00`34a003a1_600?4a/H07LH00lC6aP0MaP03a<K600o600<0a/H01<H00`36
aP0>aP400000X]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP34e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP40000:aP03
0<K600_600<0a/@07lH00lC6aP0LaP03a<K601g600?4a/H03/H00`36aP05aP030<K600g60@00002=
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eP3Fa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6eP3F00G40100a]K6e/KFa]K6e/KFa]K60@0000[600<0a/H03LH00`34
aP0NaP03a<K601c600?4a/H07<H00lC6aP07aPS400<0a<H01<H00`36aP0=aP400000N=K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6eP34a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP_401o6e/KF
a]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K600400009aP030<K600o600<0a/@07/H00lC6aP08aP03
?lK6017600?4a/H04<H:a0;600?4a/H03/H00`36aP05aP030<K600c60@00001Ke/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFaP34e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]Ho
e/Hoa]K6e/KFa]K6e/KFa]K6eP040005a]K6e/H02/@0==K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/H100002LH00`36aP0AaP030<C601g600?4a/H01/H01do6
a/I?aTl03<H00l@0000400C45lH00lC6aP0=aP030<K600G600<0a/H03<H1000004oFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KF?mK6
?lKF?mHoe/KF00[42000@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6eP3F
a]K6e/KF0=K6e/KFa]K6e/KFa]K600400009aP030<K601;600<0a/@07LH00lC6aP02aP04?lK4C`;4
00<oCl@00l@:aPP06/H00lC6aP0=aP030<K600K600<0a/H02lH1000003_Fa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0<C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP07a00G?l@o?mK6eSoFa]K6
e/KFa]K6e/KFa]H02000@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6eP3F
a]K6e/KFaP36e/KFa]K6e/KFa]K600400009aP030<K601?600<0a/@03/H;a0C600@oa<I?0/H013o6
aTl@aPP06lH00lC6aP0<aP030<K600K600<0a/H02lH1000002KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36a<KFaP[402[Fa]K6e/KFa]K6e/KF?mHoa<Hoa]HoeSoFa]K6e/KFa]K6e/KFa]K6
e/H60012e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K60@0000W600<0a/H05LH5a1G600<oaSl00/H01dloa/I?aTl05<H40003a<K601_6
00?4a/H02lH00`36aP07aP030<K600[60@00000je/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o00O6e/KF?mK6008o01GFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00cl0A=K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K60@0000W600<0a/H05/H00`36a00EaP03ClI?00C600@oa<I?5/H01Cm?
?lK401g600?4a/H02lH00`36aP03aPC400<0a<H02/H1000003_Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP34a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0Na]K6?lKF?mK6e/KFa]K6e/KF
a]K6e/KFa]K6e/KF0cl0:=K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/H5a003
0<C400?40176e/KF0=K6e/KFa]K6e/KFaP0100002LH00`36aP0HaP030<C600k600Poa/K6?dloC`;6
00Doa/K6?`0GaP03?dlo00;600?4a/H06<H;a0G600<0a/H02<H00`36aP09aP400000>=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KF?mK60Sl08MHoeSoF?mK6
?lK4a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`0Be/KFa=K6e/KFa]K6e/KFa]K62l@09lKFa/C6e/KF
a]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFaP0100002LH00`36aP0IaP030<K400k600E?a/Ho
C`03aP07ClK6aTo6a00FaP03?dlo00?600C4a/K62l@?aP03a<K600W600<0a/H02<H00`36aP09aP40
0000=MK6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KF00@o
02;6?lKFaSo6eSoFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KF0cl7a00ma]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K4e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFaP0100002<H00`36aP0KaP03
0<K400[600PoCco6?do6C`C600<oaSl01<H00lC6aP07aP_400<oCcl01<H00lC6aP0JaP03a<K600W6
00<0a/H02LH00`36aP08aP400000>=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa=K6e/KFa]K6?lKFaSo60Sl02mK6e/KF?mHoe/KF00_400_Fa]K6e/KFa]K6eP03?`14e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K6
e/H100002<H00`36aP0MaP030<C600K600<oClH00lH00co6?`06a003ClC400;40/H00lC6aP0AaP03
?dlo00G600?4a/H06/H00lC6aP08aP030<K600W600<0a/H02<H1000002oFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<K4a]K6eP02a003?l@o00?402@oa3oFa]K6e/Hoa]K6e/KF
a=K6e/KFa]K6e/KFa]K6e/KFa]H3?`14e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/H100002<H00`36aP0NaP030<C400?40lH01Dlo
Ccm?00?600=?a/H00lH00do6aP05aP03a<K600o600=??dl01lH00lC6aP0JaP03a<K600S600<0a/H0
2LH00`36aP07aP400000;mK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
a<KF00Po00?6e/H00Sl07MK6eSoFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KF00@o03K6e/KFa]K6a<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFaP36e/KFa]H60009a]K6e/KFa]K60040
0008aP030<K601o60180a/C6Ccm??lHoCcm??dloaSl3aP03?lK600O600?4a/H03<H01DloCcm?00S6
00?4a/H06LH00lC6aP05aPX01LH00`36aP07aP400000==K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/@oa]Hoe/H3?`0Pa]K6e/Hoa]Hoe/KFa]K6e/KFa/C6e/KFa]K6e/KF
a]H3?`0TeSloa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K610000l@00004000Ia]K60<KF
a]K6e/KFa]K60<KFa]K6e/KFaP0100002<H00`36aP0QaP0:0<I?aTloCcm??`O600<oClH02/H00lC6
aP09aP03Ccm?00;600<oClH02<H00lC6aP0;aPX03/H00`36aP09aP030<K600O60@00000]e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00@o02C6eSoF?mK6e/KFa]K6?lKF
a]K6e/KFa]K6e/CFa]K6e/KFa]H3?`03e/KF008o00g6e/KFa]K6e/K4a]K600X002kFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K60@0000S600<0a/H08LH01DloCcm?00;6
00@oaSm?1lH00do6aP0;aP03a<K600G600=??dl01<H013m?a/H80003a00002;600<0a/H02LH00`36
aP07aP400000:mK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H013l01/Ho
aSo6eP<o01_Fa]K6e/KF?mK6e/KFa]K6e/KFa/C6e/KFa]H00cl5008o0P00@lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFaP36e/KFa]K6e/H00@0000S6
00<0a/H08LH034loC`36?dloCco6?`O600<oa/H02LH20008a00003m??dl6aP03?do602k600<0a/H0
2LH00`36aP07aP400000:]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o
00C6eSoF0Sl03<Hoa]K6?lKFa]K6eP8o2P000lKF?`06?`07e/KFa]K6eP02?`15a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K60040
0008aP030<K601k600<oClH00/H024loCcm?aTo60`0023l004loC`1?2LH00dloC`03aP03ClK600S6
00<oClH0;/H00`36aP09aP030<K600O60@00000[e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]HoeP03?`06e/KF?`0o0P000mK6eP03?`0;e/KFa]Hoe/KFa]H013l04<KFa]Hoe/KF
a]K6e/KFa]H2?`15a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa]K6e/KF0=K6e/KFa]K600400007aP030<K601k600I??dloCcl3aP03?lHo00;600=??dl0
2LH01Do6Ccm?00;600<oa/H00/H00do6aP0;aP03Cco602g600<0a/H02/H00`36aP06aP4000009mK6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP05?`05eSloa]H01Cl02mK6e/KFa]K6
e/KF00<o05kFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K60@0000O600<0a/H07<H03dlo
Cco6?dloCcm?04loC`09aP03Ccm?00K600<oa/H00/H00do6aP0=aP04ClK6?bc600<0a/H02/H00`36
aP06aP400000:]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaP<o00?6eSl0
1Cl01LKFa]K600@o06CFa]K6e/KFaSo6e/KF?mK6e/KFa]K6e/KFa]K6e/Hoa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K60@0000O6
00<0a/H06lH043o6aTloaSm??do6Cco6?dl2aP05?dloaSl02LH00co6aP02aP03ClK600o600E?a/K6
C`0[aP030<K600[600<0a/H01/H1000002GFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00Ho00K6e/KF?mH6?`0Ba]K6?lKFa]K6e/KFaSo6e/KF0Sl0ElKFa]K6e/KFa]K6e/KFa]K6?lKF
a]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3F
a]K6e/KFaP0100001lH00`36aP0JaP07Ccm??do6C`02aP07?do6aSm??`05aP03?lK600K600=??lH0
0lH00dloaP0AaP03ClK600?600=?a/H09lH00`36aP0:aP030<K600K60@00000Se/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H03Sl03P0o?mK6e/Hoa]K6e/KF13l0GlKFa]HoeSoFa]K6e/KF
a]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa]K6e/KF0=K6e/KFa]K600400007aP030<K601W6014oaSm??dloaSm??dloaP1??`03aP03
?lK600?600DoClK6?`04aP04ClK6?a;600=?a/H01LH00do6aP0LaP03?lK600K600<0a/H02/H00`36
aP06aP4000009=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPTo00?6?cl00Sl02=Ho
e/Hoa]K60cl0ILKFaSo6e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFaSo6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K600400007aP03
0<K601[600i?aTloClI??dloCco6?`;600Q??lHoCco6?`?600<oa/H00/H01Do6a/I?01?600=?a/H0
1LH00dloaP0LaP03?lK600O600<0a/H02LH00`36aP06aP4000008]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H9?`05aSo6e/H01cl0ClKFaSo6e/Hoa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KF
a]K6e/Hoa]K6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/H00Sl06]K6e/KF0=K6
e/KFa]K6e/KF0=K6e/KFa]K60@0000O600<0a/H05/H034loa/I??dloCcm??`;600I??dloCcl5aP05
?lK6aSl00lH00cm?aP03aP03?lK6017600<oClH01/H014o6aSlFaP03Cco600;600<oCcl01lH00`36
aP09aP030<K600K60@00000Se/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H03Sl03@0o
a]K6e/Hoa]K6?lH00cl06/Hoa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KF0Sl07/KFa]K6e/KF?mK6?lKF
a]K6e/KFa]K6e/KFa]K6ePLo023F?mK6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFaP400006aP03
0<K601W6019??lK6Ccm??dloCcm??lHoCcl3aP07?lK6aSm??`03aP03?lK600;600=??lH04/H00cm?
aP07aP04?lK6Ca3600DoCcm??`05aP03?lK600C600A??lH02lH00`36aP06aP4000008mK6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF00Po00?6?cl013l02=Hoe/Hoa]K60Sl02MK6e/Hoa]K6
eP02?`0Ca]K6e/KFa]K6e/KFa]K6e/KFaP03?`0Ja]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]H2?`06
a]K6e/KF1Cl01=K6e/H2?`0He/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K60@0000K600<0a/H05lH02Dlo
Ccm??dloC`03aP06Ccm??lH00/H024loaSm??dlo0lH00co6aP02aP03ClI?01?600I?aTloCcl5aP03
?lK600;600=?a/H02LH02Do6aSm??dloC`04aP07?lK6Ccm??`03aP030<K600W600<0a/H01/H10000
023Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPdo00C6eSoF1Sl0:LHo?co6e/Hoa]K6eSoF
?mK6e/KFa]K6e/KFa]K6e/KFa]Hoe/Hoa]K6008o00WFa]Hoe/KFa]H00Sl01<KFa]H8?`0:a]K6e/KF
?mK6eP<o00CFa]K60cl05@3Fa]K6e/KFa]K6eP3Fa]K6e/KFaP0100001/H00`36aP0GaP0<Ccm??dlo
Ccm??dlo0/H01TloCcm??`?600@oClI?0/H00co6aP02aP04ClK6?a?600@oa/I?0lH01To6Ccm??`?6
00PoCcm??dloC`G600Y??dloCcm??dlo0/H00dloaP08aP030<K600[600<0a/H01LH10000023Fa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQ4o00D0?lKFaP02?`0Oe/HoaSo6e/KF?mK6?lKFa]K6
e/KFa]K6e/KFaSo6eP02?`0<a]K6?lKF?mK6e/KF13l01/KFaSo6ePLo02cFa]K6eSoFa]K6eSoFa]K6
e/KFa]K6?`3Fa]K6e/KFa]K6e/H0a]K6e/KFaP400006aP030<K601O6019??dloCcm??dloCcm??dlo
aSl2aP03Ccm?00;600<oaSl01<H01Do6a/I?00k600HoCcm?aTl3aP04ClK6?`G600ToaSo6?dloaSl0
0lH01Cm?aTlo00K600E?a/K6C`09aP04Cco600c600<0a/H01LH10000023Fa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaPlo00?6?cl013l00mK6eP03?`03e/KF008o0136eSoFa]K6e/KFa]K6eSoF
0cl02]K6eSoFa]K6?lH3?`0;a]K6eSoFaSo6?lH00cl00lKFaP0:?`03e/Ho00<o00KFa]K6e/H4?`0F
eP3Fa]K6e/KFa]K6e/H0a]K6e/KFaP400006aP030<K601O601E??dloClI??dloCco6?dloClI??dl0
0lH014loaSl2aP03Cco600;600<oClH02LH01Sm??dloC`;600<oa/H00/H00do6C`02aP05?dloaSl0
0/H00dloaP03aP0<Ccm??lHoaSm??dlo0lH00co6aP02aP03Ccm?00;600<oa/H00/H00dl0C`0;aP03
0<K600G60@00000Pe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HD?`03e/KF008o01?6?lKF
?mHoe/Hoa]Hoe/KFa]K600Ho00CFa]K60Sl00mK6eP03?`06e/KFaSo60cl01<KF?mH;?`03e/Ho008o
00[6?lKFa]K6e/KF0cl06]K6e/KF0=Hoe/KFa]K6e/KFaP36e/KFa]K60@0000K600<0a/H05lH04dlo
Ccm??dloCcm??dloCcl0?dl00lH02DloClI?aTo6C`03aP05ClK6aTl00lH024loaSm??lHo1<H01do6
Cco6?dl01LH02Do6aSo6?dloC`05aP06ClI??dlo1LH00cm??`0:aP03Cco600;600<0a/H02/H00`36
aP05aP4000008=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K63cl01/Ho?mK6eP<o00gFaSlo
e/Hoa]K6?lKF00Do00GF?co6eP03?`06e/KF?mK61Sl01MK6eSoF00/o00?Fa]H00Sl02lKF?co6e/KF
a]K600<o00g6e/KFa]K6e/Hoa]H0008o01;Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36aP0GaP0A
Ccm??dloCcm??dloCcm??dl00lH01dloaSm??dl00lH03DloCcm??dloCco6?dl00/H02cm?aTloCcm?
aTlo00;600m??do6Ccm??dloaSo6?dl00/H01cm??dloaSl01LH00co6aP07aP03?do600O600<oC`00
3<H00`36aP05aP4000008=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K63Sl00mHo0004?`03
aSo600Po00?F?mH00cl01=K6?lH3?`03aSlo00<o00K6?cloa]H4?`04a]K6eP8o00?6?cl00Sl00mHo
?`02?`03aSo600<o0136e/KFaSo6e/KFa]K6eSoF0cl01MK6e/KF008o01D0?cloa]K6e/KFa]K60<KF
a]K6e/H00@0000K600<0a/H05lH06TloCcm??dloCcm??dloCcm?aTloaSm??dlo0/H02Dloa/I??do6
C`03aP03Cco600;6014oCcm??dloaSm??dloClI??`02aP0>Ccm??dloaSo6?lHoaSl3aP03?lHo00G6
00<oClH01/H044o6a/I??lHoClI?04loCcl8aP030<K600G60@00000Re/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/HoaPho00<0?cl02Sl02LKF?co6?lHoaP02?`04eSoFaP8o00?F?cl01Cl00mK6
eP04?`04aSloeP8o01S6?cloaSo6eSoFaSo6eSoFaSo6e/KF?mH2?`0;a]K6e/KF?mK6e/H00cl05lHo
0=K6eSoFa]K6e/KFaP36e/KFa]K600400005aP030<K601S6031??dloCcm??dloClI??do6Ccm??lHo
Ccm??do6Ccm?aTloaSm??lHoaSm??dloCcl2aP03Ccm?00?600m??lHoCcm??dloaSo6?dl01<H013o6
aTl2aP04?lK6C`G600E?a/HoC`05aP03ClK600C600@oC`1?2lH00`36aP05aP4000008=K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K64Cl00lHoaP0:?`04eSloaP<o00?6?lH01Sl00mK6?`02?`03
aSlo00do01c6e/Hoa]K6eSoFa]HoeSoFa]Hoe/KFa]Hoe/KF0cl01mK6eSoFa]H00cl05]H0?coFa]K6
e/KFa]K60<KFa]K6e/H100001LH00`36aP0HaP0/Ccm??dloCcm??dloCcm??`0oaSm?aTloCcm??dlo
Ccm??do6Ccm??dloCcl3aP0C?dloCcm??dloCco6?dloCco6?`04aP03ClK600;600<oa/H00/H00dlo
aP03aP03Cco600?600e?a/K6ClI??do6Ccm?00?600M??`36Ccm?00O600<0a/H01LH10000023Fa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQ8o00CF?co60cl00lHo?`04?`03eSlo00<o00?F?cl0
13l00lHo?`0:?`06e/Hoa]K60Sl03]K6e/Hoa]K6eSoFa]K61Cl00lHoaP03?`0:a]Hoe/KF?mK6ePDo
01SFa]K603oFa]Hoe/KFa]K60<KFa]K6e/H100001LH00`36aP0IaP0G?dloCcm??dloCcm??dloClI?
?do6Ccl00/H084loClI?aTloClI?aTloCcm?aTloClI?aTo6Ccm?aTlo0/H01To6a/I??`C600=??lH0
0/H00cm?aP03aP07?do6aSm??`03aP04?do6C`?600=??dl00/H01Cm??dlo00;600<0aTl02LH00`36
aP05aP4000008MK6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0>?`03aSlo008o00?F?cl0
13l02LHo?mHoeSoFaP04?`07eSlo?mK6eP03?`0?e/Hoa]K6?lHoaSo6eSoF008o00k6e/HoaSo6eSoF
?mK6eP<o00?Fa]H00cl00mK6eP02?`03aSlo008o00CFa]K60Sl06=Ho?cl0aSo6e/KFa]K6e/H0a]K6
e/KFaP400005aP030<K601W602PoCcm??dloCcm??dloClI??dloCcm??dloClI??do6Ccm?aTloaSm?
1LH01TloaSo6?`;600U??do6ClI??dl00/H01So6?do6C`;600Hoa/I?aTl3aP03Ccm?00;600XoaSm?
?dloCcm?0/H01Sm??dloC`;600LoCcl0?dlo00W600<0a/H01<H10000027Fa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H03Cl00mHo?`03?`05eSlo?mH02Cl05MHoe/Hoa]K6e/KF?mK6eSoFa]K6
eP04?`0:aSo6?lKFaSo6eP8o00g6e/HoaSo6eSoFaSo6008o00OFaSloe/KF008o00G6?cloaP04?`03
eSlo00<o01@0?cloe/KFa]K6e/KF0=K6e/KFaP400005aP030<K601W602LoCcm??dloCco6?dloCcl0
?dloCcm??dloCcm?aTloCcm??dloCcl00lH00cm?aP02aP03ClK600C600PoClI??do6C`?600E?a/Ho
C`04aP03?do600;600=??dl00/H01Sm?a/HoC`?600=??dl00/H033m??do6Ccm?aTlo00;600<oa/H0
1lH00`36aP04aP4000008MK6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0I?`05eSlo?mH0
13l01LHoa]K600<o00c6e/KFaSo6e/KFa]H4?`0;aSo6?lKFaSo6?lH00Sl00mHo?`02?`08a]Ho?lHo
a]H2?`09a]HoeSoFaSo6008o00CFa]K60cl06LHo?mK60<KFa]K6e/KFa]K6eP3Fa]K6e/H00@0000G6
00<0a/H06LH08cm??dloCcm??dloCcm??dloCcm??dloCcm??lHoCcm?aTlo00C600=?a/H01LH00do6
aP03aP0>ClI?aTloClI?aTloCcl2aP03Ccm?00;600PoCcm?aTloC`;600<oCcl00/H01DloClI?00;6
00HoCcm?aTl2aP07?dloCcl0?`0;aP030<K600C60@00000Qe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF014o00CF?co60cl00lHo?`04?`06eSoFa]K60Sl05=K6e/KFa]Hoe/KFa]K6?lHoaSo6
0cl00lHo?`03?`03aSlo00Lo00K6?lHoa]H4?`03a]Ho00<o00?6e/H01Sl00mHo?`03?`0D03oFa]K6
e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0IaP0P?dloCco6?dloCcm??dloCcm??dloCcm??dloCcm?
aTl4aP03?lK600K600=??lH01<H02co6a/HoaSm?aTlo00;6015??dloaSm?aTloCcm?aTo6C`02aP0B
?lHoaSo6?do6Ccm?aTloCcm?200<aP030<K600C60@00000Qe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o00?F?cl063l01<KFa]H2?`0Ca]K6e/KFa]HoeSoFa]K6eSoFaP02?`03e/Ho008o
00?6e/H00Sl00mHoeP03?`08eSloaSo6?lH2?`03eSoF008o3P06?`0EaP36e/KFa]K6e/KFa]H0e/KF
a]K600400005aP030<K601W601doa/I??dloCcm??dloCcm??dloCcm??dloCcm??`03aP04?do6C`K6
00@oClI?1/H00co6?`02aP03ClI?00;600DoaSm??`02aP03Ccm?00;63P005cm??dloClI??lHoCcm?
?dloCcm??lH000_600<0a/H01<H1000002?Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP02?`03aSlo01Do01K6eSloa]Hoe/KFa]K6?lKFaSo6e/KF13l01lKFaSo6?lH03@0;?`05eSlo?mH0
13l00lHoaP02?`06eSloaSo613l05=H0e/KFa]K6e/KFa]H0e/KFa]K60@0000C600<0a/H06lH064o6
Ccm??dloCcm??dloCcm??dloCco6?`?600<oClH00lH00co6aP02aP03Cco600?600=?aP003@02aP0]
Ccm??lHoCcm??lHoCcm??dloCcm??dloClI??dloCcm??dloClI?aTloClI?00;600<0a/H02LH00`36
aP04aP4000009=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaQ<o00C6?lKF0Sl01LKF
a]K600h00Sl05=Ho?lKFa]Hoe/Hoa]K6e/KF?mK60cl01LHo?co600Do00?6?cl03Sl01]Ho?coFaP8o
01KFa]K60<KFa]K6e/KFa]H0e/KFa]K60@0000C600<0a/H0:LH01036a/H>0004ClI??`;600=?a/H0
0/H00co6?`02aP03Cco600C600@oa/I?1/H02So6aTloaSm??dl2aP0M?dloCco6?dloCcm??do6Ccm?
?dloClI??dloaSl01<H00`36aP08aP030<K600C60@00000Ve/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H>000=e/KFa]Hoe/KFa]K6eP03?`09e/KFaSo6e/KF008o00?6eSl00Sl02=K6
e/Hoa]K61Cl00lKF?`02?`03eSoF00@o00?6eSl02Sl00mHo?`0>?`0Ga]K6e/H0a]K6e/KFa]K6eP3F
a]K6e/H00@0000C600<0a/H04/H=00[600<0a/H03<H013m??dl5aP09ClK6?do6ClI?00;600<oa/H0
0/H01To6a/I??`?602XoCcm??dloCco6?do6Ccm??dloCcm??dloCcm??lHoCcm??dloClI?aTl6aP03
0<K600O600<0a/H01<H1000000_Fa]K60<KFa]K6eP0>000Ua]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa]K6e/KFaP02?`09eSoFa]K6eSoF008o01c6?coF?mK6?lKFa]K6?lKFaSo6?lKFa]Hoe/KF
0Sl00lKF?`02?`03eSlo018o01o6?lHoa]Hoe/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K600400004aPL0
9LH00`36aP0:aP0<?do6aSo6?dloCcm?0lH014loCcl2aP03ClK600;600<oaSl00/H014o6Ccl4aP04
ClK6?`?601/oCco6?dloCco6?dloaSm??dloCcm??do6Ccl03<H00`36aP06aP030<K600C60@000014
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]Hoe/H4?`03e/KF00<o013FaSo6?lKFa]Hoe/HoaSo60Sl03]K6e/KF?mK6e/KFa]K61Sl00mHo
?`0<?`0OaSo6?lKFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFaP0100001lH00`36aP0VaP030<K600g6
00M?a/HoaSm?00?600=??dl00lH014loaSl3aP06?lK6ClI?0/H00cm?aP04aP03ClK600o600=?a/H0
0/H023m??dloCcm?0/H00co6aP08aP030<K600K600<0a/H01<H1000004SFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/HoaSo6?lH5?`0>
a]HoeSoFaSo6?lKFa]H2?`15a]Ho?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K600400009aP030<K602C600<0a/H04<H02So6aTloaSm?
aTl2aP03?lHo00?600<oClH00lH01cm??dloCcl0<LH00`36aP06aP030<K600?60@00000:e/KFa]K6
e/KFaP8003WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]H00Sl00lHo?`02?`03e/KF008o00?6?cl00cl01LKFaSo6008o04CF?cloe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFaP40000<aP03
0<K6027600<0a/H05<H043o6aTloaSm?aTo6ClI??dl3aP09ClI??dloClI?037600<0a/H01LH00`36
aP03aP400000BmK6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeP02?`07a]HoeSoFaP03?`05a]K6?lH00cl0@lHo?co6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/H0
0@0000k600<0a/H07lH00`36aP0GaP03Cco600;600<oa/H00/H01TloaSo6?`;600Q?a/HoaSm??c76
00<0a/H01<H00`36aP03aP400000DmK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF008o00K6e/KFa]H3?`05
eSoF?mH00Sl0?LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F
a]K6e/H0a]K6e/H00@0001360P0NaP030<K601_600=?a/H02/H00cm??`04aP04ClK6?bo600<0a/H0
1<H00`36aP03aP400000F]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP@o04CFa]K6?lKFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFaP40
000CaP030<K601[600<0a/H09lH01Do6ClI?00?600=?a/H0<LH00`36aP03aP030<K600?60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF?mK6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K60@0001G600<0a/H06<H00`36
aP0VaP05?lK6aSl0>LH00`36aP02aP030<K600?60@00000Fe/KFa]K6e/KFa]K6e/KFa]K6e/KFaP80
08[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/H0a]K6e/H100006<H00`36aP0DaP030<K606K600D0a/K60005aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFaP40000JaP030<K601;600<0a/H0
I/H01@36a/H000G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60<KFa]K6
0@0001c600<0a/H04<H00`36aP1WaP040<K600G60@00000Me/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00P00PlKFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KF0=K60<KFa]K60040000OaP030<K600g600<0a/H0J<H01036aP04aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFaP40000QaP030<K600_600<0a/H0
JLH00`360004aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFaP40
000SaP802/H00`36aP1YaP030<H000C60@00002Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60P001=K6e/H100009/H00`36aP06aP030<K606[60P04aP400000W=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8000CFa]K60@0002S600<0a/H01<H00`36aP1RaPX01<H10000
02WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02001Fa]K6eP3Fa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]HC000>e/KFa]K6e/KFa]K6e/H10000:lH01@36a/H003o64P0QaP400000GMK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0B000ca]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000]aP030<H001[64`15aP400000;]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H20008e/KFa]K6e/HB001He/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000_aPT0J/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
\
\>"],
    ImageRangeCache->{{{0, 162}, {177, 0}} -> {0, 0, 0, 0}}],
  " ",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.57418 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.245763 1.52904 0.038226 1.52904 [
[ 0 0 0 0 ]
[ 1 1.57418 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.57418 L
0 1.57418 L
closepath
clip
newpath
p
1 g
.002 w
.83123 .03823 m
.86467 1.32309 L
s
.86467 1.32309 m
.03823 1.37454 L
s
.03823 1.37454 m
.08331 .12246 L
s
.08331 .12246 m
.83123 .03823 L
s
.92317 .32153 m
.2445 .39019 L
s
.2445 .39019 m
.21908 1.53596 L
s
.21908 1.53596 m
.96177 1.49486 L
s
.96177 1.49486 m
.92317 .32153 L
s
.83123 .03823 m
.86467 1.32309 L
s
.86467 1.32309 m
.96177 1.49486 L
s
.96177 1.49486 m
.92317 .32153 L
s
.92317 .32153 m
.83123 .03823 L
s
.08331 .12246 m
.2445 .39019 L
s
.2445 .39019 m
.21908 1.53596 L
s
.21908 1.53596 m
.03823 1.37454 L
s
.03823 1.37454 m
.08331 .12246 L
s
p
.4 g
.84436 .07869 m
.10628 .1606 L
s
P
p
.4 g
.87598 .17611 m
.16165 .25257 L
s
P
p
.4 g
.90549 .26706 m
.21344 .3386 L
s
P
p
.4 g
.69284 .05381 m
.79788 .3342 L
s
P
p
.4 g
.49187 .07645 m
.61572 .35263 L
s
P
p
.4 g
.29406 .09872 m
.43613 .3708 L
s
P
p
.4 g
.09933 .12066 m
.25907 .38871 L
s
P
P
p
1 0 .6 r
.00125 w
.43888 .81045 m
.44583 .82149 L
s
P
p
1 0 .6 r
.00125 w
.4183 .85192 m
.42536 .86274 L
s
P
p
1 0 .6 r
.00125 w
.4183 .85192 m
.41663 .88034 L
s
P
p
1 0 .6 r
.00125 w
.43888 .81045 m
.44933 .80801 L
s
P
p
1 0 .6 r
.00125 w
.4299 .81748 m
.43415 .82416 L
s
P
p
1 0 .6 r
.00125 w
.4299 .81748 m
.42885 .83484 L
s
P
p
1 0 .6 r
.00177 w
.43108 .79806 m
.43888 .81045 L
s
P
p
1 0 .6 r
.00177 w
.42018 .82 m
.4183 .85192 L
s
P
p
1 0 .6 r
.00125 w
.40973 .85084 m
.40874 .86814 L
s
P
p
1 0 .6 r
.00177 w
.43108 .79806 m
.4299 .81748 L
s
P
p
1 0 .6 r
.00125 w
.37805 .9017 m
.38537 .91234 L
s
P
p
1 0 .6 r
.00125 w
.37805 .9017 m
.37656 .93008 L
s
P
p
1 0 .6 r
.00125 w
.40973 .85084 m
.40036 .87851 L
s
P
p
1 0 .6 r
.00177 w
.42018 .82 m
.40973 .85084 L
s
P
p
1 0 .6 r
.0025 w
.42229 .78412 m
.43108 .79806 L
s
P
p
1 0 .6 r
.0025 w
.42229 .78412 m
.42018 .82 L
s
P
p
1 0 .6 r
.00125 w
.40924 .82386 m
.41359 .83057 L
s
P
p
1 0 .6 r
.00125 w
.40924 .82386 m
.40824 .84134 L
s
P
p
1 0 .6 r
.00177 w
.37971 .86983 m
.37805 .9017 L
s
P
p
1 0 .6 r
.00125 w
.36926 .90081 m
.36838 .91809 L
s
P
p
1 0 .6 r
.00125 w
.345 .94257 m
.34368 .97091 L
s
P
p
1 0 .6 r
.00177 w
.41035 .80432 m
.40924 .82386 L
s
P
p
1 0 .6 r
.00125 w
.36926 .90081 m
.35987 .92862 L
s
P
p
1 0 .6 r
.00125 w
.40399 .82314 m
.40339 .83375 L
s
P
p
1 0 .6 r
.00125 w
.38936 .84829 m
.38843 .86576 L
s
P
p
1 0 .6 r
.00125 w
.345 .94257 m
.32953 .98847 L
s
P
p
1 0 .6 r
.00125 w
.40399 .82314 m
.39827 .84005 L
s
P
p
1 0 .6 r
.00177 w
.37971 .86983 m
.36926 .90081 L
s
P
p
1 0 .6 r
.00125 w
.38936 .84829 m
.37993 .87622 L
s
P
p
1 0 .6 r
.00353 w
.42467 .74372 m
.42229 .78412 L
s
P
p
1 0 .6 r
.00177 w
.41035 .80432 m
.40399 .82314 L
s
P
p
1 0 .6 r
.0025 w
.4116 .78244 m
.41035 .80432 L
s
P
p
1 0 .6 r
.0025 w
.38159 .83399 m
.37971 .86983 L
s
P
p
1 0 .6 r
.00177 w
.39988 .81716 m
.38936 .84829 L
s
P
p
1 0 .6 r
.00177 w
.36228 .89129 m
.345 .94257 L
s
P
p
1 0 .6 r
.00177 w
.39988 .81716 m
.38676 .83959 L
s
P
p
1 0 .6 r
.0025 w
.4116 .78244 m
.39988 .81716 L
s
P
p
1 0 .6 r
.00125 w
.38676 .83959 m
.38104 .85656 L
s
P
p
1 0 .6 r
.02 w
.55218 .23718 m
.55266 .41248 L
s
P
p
1 g
.05 w
.55218 .23718 Mdot
P
p
1 0 .6 r
.00125 w
.38676 .83959 m
.37493 .85983 L
s
P
p
1 0 .6 r
.00177 w
.36228 .89129 m
.34048 .9286 L
s
P
p
1 0 .6 r
.0025 w
.38159 .83399 m
.36228 .89129 L
s
P
p
1 0 .6 r
.00125 w
.34048 .9286 m
.33108 .95655 L
s
P
p
1 0 .6 r
.00353 w
.42467 .74372 m
.4116 .78244 L
s
P
p
1 0 .6 r
.00125 w
.34048 .9286 m
.32079 .9623 L
s
P
p
1 0 .6 r
.00125 w
.35389 .88227 m
.35305 .89978 L
s
P
p
1 0 .6 r
.005 w
.42736 .69815 m
.42467 .74372 L
s
P
p
1 0 .6 r
.00125 w
.39076 .79998 m
.39522 .80685 L
s
P
p
1 0 .6 r
.00125 w
.39076 .79998 m
.38981 .81775 L
s
P
p
1 0 .6 r
.00353 w
.40318 .76989 m
.38159 .83399 L
s
P
p
1 0 .6 r
.00125 w
.35389 .88227 m
.34443 .91038 L
s
P
p
1 0 .6 r
.00125 w
.65322 .99831 m
.64396 1.0264 L
s
P
p
1 0 .6 r
.00125 w
.31775 .93484 m
.32554 .9455 L
s
P
p
1 0 .6 r
.00125 w
.65322 .99831 m
.63712 1.00747 L
s
P
p
1 0 .6 r
.00125 w
.31775 .93484 m
.31655 .96359 L
s
P
p
1 0 .6 r
.00177 w
.36443 .85093 m
.35389 .88227 L
s
P
p
1 0 .6 r
.00177 w
.39182 .7801 m
.39076 .79998 L
s
P
p
1 0 .6 r
.00125 w
.3854 .79919 m
.38483 .80998 L
s
P
p
1 0 .6 r
.00125 w
.37057 .82463 m
.36967 .84239 L
s
P
p
1 0 .6 r
.00353 w
.40318 .76989 m
.37618 .81598 L
s
P
p
1 0 .6 r
.005 w
.42736 .69815 m
.40318 .76989 L
s
P
p
1 0 .6 r
.00177 w
.36443 .85093 m
.35116 .87359 L
s
P
p
1 0 .6 r
.0025 w
.37618 .81598 m
.36443 .85093 L
s
P
p
1 0 .6 r
.00125 w
.35116 .87359 m
.34542 .89067 L
s
P
p
1 0 .6 r
.00125 w
.3854 .79919 m
.37963 .81633 L
s
P
p
1 0 .6 r
.00125 w
.37057 .82463 m
.36104 .85295 L
s
P
p
1 0 .6 r
.00125 w
.35116 .87359 m
.33919 .89403 L
s
P
p
1 0 .6 r
.00177 w
.39182 .7801 m
.3854 .79919 L
s
P
p
1 0 .6 r
.0025 w
.37618 .81598 m
.35177 .85765 L
s
P
p
1 0 .6 r
.00125 w
.6893 1.04406 m
.67983 1.07204 L
s
P
p
1 0 .6 r
.0025 w
.39302 .75785 m
.39182 .7801 L
s
P
p
1 0 .6 r
.00177 w
.38118 .79306 m
.37057 .82463 L
s
P
p
1 0 .6 r
.00177 w
.66361 .96677 m
.65322 .99831 L
s
P
p
1 0 .6 r
.00125 w
.66765 .99897 m
.66197 1.01606 L
s
P
p
1 0 .6 r
.00177 w
.3191 .90254 m
.31775 .93484 L
s
P
p
1 0 .6 r
.00707 w
.45444 .61779 m
.42736 .69815 L
s
P
p
1 0 .6 r
.00125 w
.6893 1.04406 m
.69521 1.09161 L
s
P
p
1 0 .6 r
.00177 w
.35177 .85765 m
.3297 .89531 L
s
P
p
1 0 .6 r
.00177 w
.35177 .85765 m
.3326 .87686 L
s
P
p
1 0 .6 r
.00125 w
.30854 .93407 m
.30784 .95158 L
s
P
p
1 0 .6 r
.00125 w
.28369 .97671 m
.28265 1.00543 L
s
P
p
1 0 .6 r
.00177 w
.38118 .79306 m
.36787 .81575 L
s
P
p
1 0 .6 r
.0025 w
.39302 .75785 m
.38118 .79306 L
s
P
p
1 0 .6 r
.00125 w
.66765 .99897 m
.67126 1.02784 L
s
P
p
1 0 .6 r
.00125 w
.3297 .89531 m
.32021 .92362 L
s
P
p
1 0 .6 r
.00125 w
.36787 .81575 m
.3621 .83295 L
s
P
p
1 0 .6 r
.00125 w
.36787 .81575 m
.35587 .83622 L
s
P
p
1 0 .6 r
.00125 w
.37612 .78723 m
.37556 .79811 L
s
P
p
1 0 .6 r
.00125 w
.30854 .93407 m
.29907 .96236 L
s
P
p
1 0 .6 r
.00125 w
.3297 .89531 m
.30977 .92933 L
s
P
p
1 0 .6 r
.00353 w
.40622 .71858 m
.39302 .75785 L
s
P
p
1 0 .6 r
.00177 w
.66361 .96677 m
.66765 .99897 L
s
P
p
1 0 .6 r
.01414 w
.55266 .41248 m
.5531 .57461 L
s
P
p
1 0 .6 r
.01414 w
.55266 .41248 m
.4848 .52768 L
s
P
p
1 0 .6 r
.00125 w
.37612 .78723 m
.37032 .80449 L
s
P
p
1 0 .6 r
.00125 w
.28369 .97671 m
.26808 1.02342 L
s
P
p
1 0 .6 r
.00177 w
.6827 .99086 m
.6893 1.04406 L
s
P
p
1 0 .6 r
.00177 w
.3191 .90254 m
.30854 .93407 L
s
P
p
1 0 .6 r
.00177 w
.38257 .76801 m
.37612 .78723 L
s
P
p
1 0 .6 r
.00707 w
.45444 .61779 m
.42096 .67474 L
s
P
p
1 0 .6 r
.01 w
.4848 .52768 m
.45444 .61779 L
s
P
p
1 0 .6 r
.00353 w
.40622 .71858 m
.38976 .7466 L
s
P
p
1 0 .6 r
.005 w
.42096 .67474 m
.40622 .71858 L
s
P
p
1 0 .6 r
.00125 w
.3326 .87686 m
.31521 .89429 L
s
P
p
1 0 .6 r
.00125 w
.3326 .87686 m
.32053 .89745 L
s
P
p
1 0 .6 r
.0025 w
.6753 .93131 m
.66361 .96677 L
s
P
p
1 0 .6 r
.00177 w
.38257 .76801 m
.37449 .78177 L
s
P
p
1 0 .6 r
.0025 w
.38976 .7466 m
.38257 .76801 L
s
P
p
1 0 .6 r
.00125 w
.37449 .78177 m
.37098 .79224 L
s
P
p
1 0 .6 r
.00125 w
.34069 .84028 m
.33988 .85816 L
s
P
p
1 0 .6 r
.0025 w
.32062 .86621 m
.3191 .90254 L
s
P
p
1 0 .6 r
.00125 w
.37449 .78177 m
.36721 .79417 L
s
P
p
1 0 .6 r
.00177 w
.30113 .92453 m
.28369 .97671 L
s
P
p
1 0 .6 r
.00125 w
.70223 1.03116 m
.7058 1.06011 L
s
P
p
1 0 .6 r
.0025 w
.38976 .7466 m
.3749 .7719 L
s
P
p
1 0 .6 r
.00125 w
.34069 .84028 m
.33112 .86885 L
s
P
p
1 0 .6 r
.00177 w
.6827 .99086 m
.70223 1.03116 L
s
P
p
1 0 .6 r
.0025 w
.6753 .93131 m
.6827 .99086 L
s
P
p
1 0 .6 r
.005 w
.42096 .67474 m
.39065 .72629 L
s
P
p
1 0 .6 r
.00177 w
.3749 .7719 m
.3615 .79472 L
s
P
p
1 0 .6 r
.00177 w
.3749 .7719 m
.36331 .78335 L
s
P
p
1 0 .6 r
.00125 w
.3615 .79472 m
.35569 .81206 L
s
P
p
1 0 .6 r
.00125 w
.70223 1.03116 m
.71983 1.06748 L
s
P
p
1 0 .6 r
.00177 w
.35135 .80843 m
.34069 .84028 L
s
P
p
1 0 .6 r
.00125 w
.3615 .79472 m
.34941 .8153 L
s
P
p
1 0 .6 r
.00177 w
.30113 .92453 m
.27878 .96263 L
s
P
p
1 0 .6 r
.0025 w
.32062 .86621 m
.30113 .92453 L
s
P
p
1 0 .6 r
.00125 w
.69979 .98349 m
.69396 1.00077 L
s
P
p
1 0 .6 r
.01 w
.4848 .52768 m
.42302 .63256 L
s
P
p
1 0 .6 r
.00125 w
.27878 .96263 m
.26929 .99107 L
s
P
p
1 0 .6 r
.00353 w
.39065 .72629 m
.36324 .77291 L
s
P
p
1 0 .6 r
.00353 w
.39065 .72629 m
.36696 .74953 L
s
P
p
1 0 .6 r
.00125 w
.69979 .98349 m
.70337 1.01265 L
s
P
p
1 0 .6 r
.00125 w
.36331 .78335 m
.35282 .79371 L
s
P
p
1 0 .6 r
.00125 w
.36331 .78335 m
.35599 .79581 L
s
P
p
1 0 .6 r
.00177 w
.35135 .80843 m
.33788 .83136 L
s
P
p
1 0 .6 r
.0025 w
.36324 .77291 m
.35135 .80843 L
s
P
p
1 0 .6 r
.00125 w
.33788 .83136 m
.33208 .84871 L
s
P
p
1 0 .6 r
.00125 w
.27878 .96263 m
.2586 .99705 L
s
P
p
1 0 .6 r
.00353 w
.66701 .8646 m
.6753 .93131 L
s
P
p
1 0 .6 r
.00125 w
.29224 .91551 m
.29158 .93326 L
s
P
p
1 0 .6 r
.00125 w
.75681 1.07939 m
.74687 1.10755 L
s
P
p
1 0 .6 r
.00125 w
.33788 .83136 m
.32574 .85204 L
s
P
p
1 0 .6 r
.00177 w
.69578 .95095 m
.69979 .98349 L
s
P
p
1 0 .6 r
.00353 w
.34243 .80097 m
.32062 .86621 L
s
P
p
1 0 .6 r
.0025 w
.36324 .77291 m
.33846 .81507 L
s
P
p
1 0 .6 r
.00125 w
.29224 .91551 m
.28269 .94413 L
s
P
p
1 0 .6 r
.00125 w
.75681 1.07939 m
.76258 1.12744 L
s
P
p
1 0 .6 r
.00125 w
.70768 .97547 m
.70985 .99318 L
s
P
p
1 0 .6 r
.00177 w
.69578 .95095 m
.70768 .97547 L
s
P
p
1 0 .6 r
.0025 w
.69132 .91464 m
.69578 .95095 L
s
P
p
1 0 .6 r
.00177 w
.30288 .88361 m
.29224 .91551 L
s
P
p
1 0 .6 r
.00177 w
.33846 .81507 m
.31606 .85317 L
s
P
p
1 0 .6 r
.00177 w
.33846 .81507 m
.31897 .83436 L
s
P
p
1 0 .6 r
.00707 w
.42302 .63256 m
.36684 .72794 L
s
P
p
1 0 .6 r
.00707 w
.42302 .63256 m
.37451 .67945 L
s
P
p
1 0 .6 r
.00125 w
.70768 .97547 m
.7184 .99756 L
s
P
p
1 0 .6 r
.00125 w
.31606 .85317 m
.30646 .88194 L
s
P
p
1 0 .6 r
.0025 w
.36696 .74953 m
.34541 .77067 L
s
P
p
1 0 .6 r
.0025 w
.36696 .74953 m
.35194 .77506 L
s
P
p
1 0 .6 r
.00353 w
.66701 .8646 m
.69132 .91464 L
s
P
p
1 0 .6 r
.005 w
.65772 .78977 m
.66701 .8646 L
s
P
p
1 0 .6 r
.00353 w
.34243 .80097 m
.31474 .84804 L
s
P
p
1 0 .6 r
.005 w
.36684 .72794 m
.34243 .80097 L
s
P
p
1 0 .6 r
.01 w
.5531 .57461 m
.55351 .72419 L
s
P
p
1 0 .6 r
.01 w
.5531 .57461 m
.60805 .68762 L
s
P
p
1 0 .6 r
.00177 w
.30288 .88361 m
.28928 .90676 L
s
P
p
1 0 .6 r
.0025 w
.31474 .84804 m
.30288 .88361 L
s
P
p
1 0 .6 r
.00125 w
.28928 .90676 m
.28348 .92414 L
s
P
p
1 0 .6 r
.00125 w
.73299 1.00045 m
.73654 1.02976 L
s
P
p
1 0 .6 r
.00125 w
.31606 .85317 m
.29583 .88759 L
s
P
p
1 0 .6 r
.00177 w
.75036 1.02563 m
.75681 1.07939 L
s
P
p
1 0 .6 r
.0025 w
.69132 .91464 m
.71323 .95977 L
s
P
p
1 0 .6 r
.00177 w
.35194 .77506 m
.33838 .79809 L
s
P
p
1 0 .6 r
.00177 w
.35194 .77506 m
.34017 .78663 L
s
P
p
1 0 .6 r
.00125 w
.23225 1.00535 m
.23147 1.03438 L
s
P
p
1 0 .6 r
.00125 w
.33838 .79809 m
.33254 .81558 L
s
P
p
1 0 .6 r
.00125 w
.28928 .90676 m
.27701 .92764 L
s
P
p
1 0 .6 r
.00177 w
.71323 .95977 m
.73299 1.00045 L
s
P
p
1 0 .6 r
.00177 w
.71323 .95977 m
.73591 .98191 L
s
P
p
1 0 .6 r
.00125 w
.33838 .79809 m
.32616 .81887 L
s
P
p
1 0 .6 r
.0025 w
.31474 .84804 m
.28971 .8906 L
s
P
p
1 0 .6 r
.00125 w
.73299 1.00045 m
.7508 1.03712 L
s
P
p
1 0 .6 r
.00707 w
.60805 .68762 m
.65772 .78977 L
s
P
p
1 0 .6 r
.00707 w
.60805 .68762 m
.66466 .74147 L
s
P
p
1 0 .6 r
.00125 w
.31897 .83436 m
.30127 .85186 L
s
P
p
1 0 .6 r
.00125 w
.31897 .83436 m
.30671 .8552 L
s
P
p
1 0 .6 r
.00125 w
.7702 1.06648 m
.77368 1.09574 L
s
P
p
1 0 .6 r
.00125 w
.34017 .78663 m
.32954 .79709 L
s
P
p
1 0 .6 r
.00125 w
.34017 .78663 m
.33277 .7992 L
s
P
p
1 0 .6 r
.00125 w
.23225 1.00535 m
.21652 1.05273 L
s
P
p
1 0 .6 r
.005 w
.36684 .72794 m
.31579 .81459 L
s
P
p
1 0 .6 r
.00177 w
.75036 1.02563 m
.7702 1.06648 L
s
P
p
1 0 .6 r
.0025 w
.74313 .96545 m
.75036 1.02563 L
s
P
p
1 0 .6 r
.00177 w
.34541 .77067 m
.32583 .78987 L
s
P
p
1 0 .6 r
.00177 w
.34541 .77067 m
.33268 .77336 L
s
P
p
1 0 .6 r
.00177 w
.28971 .8906 m
.26709 .92907 L
s
P
p
1 0 .6 r
.00177 w
.28971 .8906 m
.26989 .91034 L
s
P
p
1 0 .6 r
.005 w
.65772 .78977 m
.7026 .88208 L
s
P
p
1 0 .6 r
.00125 w
.26709 .92907 m
.25751 .95789 L
s
P
p
1 0 .6 r
.00125 w
.73591 .98191 m
.75646 1.00196 L
s
P
p
1 0 .6 r
.00125 w
.73591 .98191 m
.74671 1.00413 L
s
P
p
1 0 .6 r
.00125 w
.7702 1.06648 m
.78808 1.10329 L
s
P
p
1 0 .6 r
.00125 w
.72505 .91815 m
.71908 .93585 L
s
P
p
1 0 .6 r
.00177 w
.24982 .95242 m
.23225 1.00535 L
s
P
p
1 0 .6 r
.00125 w
.26709 .92907 m
.24666 .96382 L
s
P
p
1 0 .6 r
.00125 w
.72505 .91815 m
.72864 .9478 L
s
P
p
1 0 .6 r
.00353 w
.7026 .88208 m
.74313 .96545 L
s
P
p
1 0 .6 r
.00353 w
.7026 .88208 m
.7492 .92712 L
s
P
p
1 0 .6 r
.00125 w
.5998 1.11704 m
.62736 1.14163 L
s
P
p
1 0 .6 r
.00125 w
.58469 1.14273 m
.59874 1.19031 L
s
P
p
1 0 .6 r
.00125 w
.81277 1.10868 m
.81842 1.15714 L
s
P
p
1 0 .6 r
.00125 w
.29268 .84807 m
.29201 .86626 L
s
P
p
1 0 .6 r
.00353 w
.31579 .81459 m
.26946 .89325 L
s
P
p
1 0 .6 r
.00353 w
.31579 .81459 m
.27524 .85451 L
s
P
p
1 0 .6 r
.0025 w
.74313 .96545 m
.77973 1.04073 L
s
P
p
1 0 .6 r
.00177 w
.72106 .88507 m
.72505 .91815 L
s
P
p
1 0 .6 r
.00125 w
.5998 1.11704 m
.60828 1.14589 L
s
P
p
1 0 .6 r
.00125 w
.32583 .78987 m
.30806 .8073 L
s
P
p
1 0 .6 r
.00125 w
.32583 .78987 m
.31351 .81078 L
s
P
p
1 0 .6 r
.00125 w
.26989 .91034 m
.2519 .92824 L
s
P
p
1 0 .6 r
.00125 w
.26989 .91034 m
.25751 .93137 L
s
P
p
1 0 .6 r
.00177 w
.24982 .95242 m
.22701 .99119 L
s
P
p
1 0 .6 r
.0025 w
.26946 .89325 m
.24982 .95242 L
s
P
p
1 0 .6 r
.00125 w
.33268 .77336 m
.32113 .7758 L
s
P
p
1 0 .6 r
.00125 w
.33268 .77336 m
.32196 .78385 L
s
P
p
1 0 .6 r
.00125 w
.22701 .99119 m
.21745 1.02004 L
s
P
p
1 0 .6 r
.00125 w
.29268 .84807 m
.28301 .87716 L
s
P
p
1 0 .6 r
.00177 w
.77973 1.04073 m
.81277 1.10868 L
s
P
p
1 0 .6 r
.00177 w
.77973 1.04073 m
.81798 1.07816 L
s
P
p
1 0 .6 r
.00125 w
.58469 1.14273 m
.57598 1.18239 L
s
P
p
1 0 .6 r
.005 w
.37451 .67945 m
.32992 .72255 L
s
P
p
1 0 .6 r
.005 w
.37451 .67945 m
.34352 .73197 L
s
P
p
1 0 .6 r
.00125 w
.73312 .90986 m
.73528 .92787 L
s
P
p
1 0 .6 r
.00177 w
.56898 1.08955 m
.5998 1.11704 L
s
P
p
1 0 .6 r
.00177 w
.56898 1.08955 m
.58469 1.14273 L
s
P
p
1 0 .6 r
.00177 w
.72106 .88507 m
.73312 .90986 L
s
P
p
1 0 .6 r
.0025 w
.7166 .84815 m
.72106 .88507 L
s
P
p
1 0 .6 r
.005 w
.66466 .74147 m
.71642 .79071 L
s
P
p
1 0 .6 r
.005 w
.66466 .74147 m
.69197 .79756 L
s
P
p
1 0 .6 r
.00125 w
.22701 .99119 m
.20641 1.02621 L
s
P
p
1 0 .6 r
.00125 w
.73312 .90986 m
.74398 .93219 L
s
P
p
1 0 .6 r
.00125 w
.81277 1.10868 m
.84258 1.16999 L
s
P
p
1 0 .6 r
.00177 w
.30346 .81564 m
.29268 .84807 L
s
P
p
1 0 .6 r
.00125 w
.51012 1.18956 m
.52444 1.2372 L
s
P
p
1 0 .6 r
.00353 w
.69197 .79756 m
.7166 .84815 L
s
P
p
1 0 .6 r
.00353 w
.69197 .79756 m
.7202 .82454 L
s
P
p
1 0 .6 r
.00707 w
.55351 .72419 m
.55389 .86191 L
s
P
p
1 0 .6 r
.00707 w
.55351 .72419 m
.53648 .79573 L
s
P
p
1 0 .6 r
.0025 w
.26946 .89325 m
.22744 .96458 L
s
P
p
1 0 .6 r
.00353 w
.34352 .73197 m
.31548 .77948 L
s
P
p
1 0 .6 r
.00353 w
.34352 .73197 m
.31912 .75568 L
s
P
p
1 0 .6 r
.00125 w
.55022 1.11176 m
.55882 1.14074 L
s
P
p
1 0 .6 r
.00125 w
.75883 .9349 m
.76237 .96471 L
s
P
p
1 0 .6 r
.0025 w
.7166 .84815 m
.73881 .89377 L
s
P
p
1 0 .6 r
.00177 w
.30346 .81564 m
.28968 .83901 L
s
P
p
1 0 .6 r
.0025 w
.31548 .77948 m
.30346 .81564 L
s
P
p
1 0 .6 r
.00125 w
.7915 1.01403 m
.79498 1.04369 L
s
P
p
1 0 .6 r
.0025 w
.7492 .92712 m
.79169 .96818 L
s
P
p
1 0 .6 r
.0025 w
.7492 .92712 m
.77145 .97283 L
s
P
p
1 0 .6 r
.00125 w
.28968 .83901 m
.28382 .85667 L
s
P
p
1 0 .6 r
.0025 w
.55142 1.03007 m
.56898 1.08955 L
s
P
p
1 0 .6 r
.00125 w
.55022 1.11176 m
.54495 1.13586 L
s
P
p
1 0 .6 r
.00125 w
.51012 1.18956 m
.50143 1.22935 L
s
P
p
1 0 .6 r
.00177 w
.73881 .89377 m
.75883 .9349 L
s
P
p
1 0 .6 r
.00177 w
.73881 .89377 m
.76186 .91597 L
s
P
p
1 0 .6 r
.00177 w
.77145 .97283 m
.7915 1.01403 L
s
P
p
1 0 .6 r
.00177 w
.77145 .97283 m
.79461 .99529 L
s
P
p
1 0 .6 r
.00125 w
.28968 .83901 m
.27726 .86008 L
s
P
p
1 0 .6 r
.00177 w
.54063 1.07945 m
.55022 1.11176 L
s
P
p
1 0 .6 r
.00125 w
.53094 1.12381 m
.52223 1.16368 L
s
P
p
1 0 .6 r
.00177 w
.49412 1.1363 m
.51012 1.18956 L
s
P
p
1 0 .6 r
.00125 w
.75883 .9349 m
.77688 .97198 L
s
P
p
1 0 .6 r
.0025 w
.31548 .77948 m
.29013 .82244 L
s
P
p
1 0 .6 r
.00125 w
.7915 1.01403 m
.80958 1.05118 L
s
P
p
1 0 .6 r
.00125 w
.47814 1.20964 m
.4638 1.27548 L
s
P
p
1 0 .6 r
.00125 w
.81798 1.07816 m
.85277 1.11219 L
s
P
p
1 0 .6 r
.00125 w
.81798 1.07816 m
.83609 1.11536 L
s
P
p
1 0 .6 r
.00125 w
.53094 1.12381 m
.51053 1.14854 L
s
P
p
1 0 .6 r
.00177 w
.54063 1.07945 m
.53094 1.12381 L
s
P
p
1 0 .6 r
.00177 w
.22744 .96458 m
.18936 1.02924 L
s
P
p
1 0 .6 r
.00177 w
.22744 .96458 m
.19373 .99822 L
s
P
p
1 0 .6 r
.00125 w
.74581 .87712 m
.74797 .89527 L
s
P
p
1 0 .6 r
.0025 w
.7202 .82454 m
.7458 .84901 L
s
P
p
1 0 .6 r
.0025 w
.7202 .82454 m
.73367 .8522 L
s
P
p
1 0 .6 r
.0025 w
.55142 1.03007 m
.54063 1.07945 L
s
P
p
1 0 .6 r
.00125 w
.47814 1.20964 m
.44428 1.25068 L
s
P
p
1 0 .6 r
.00177 w
.49412 1.1363 m
.47814 1.20964 L
s
P
p
1 0 .6 r
.00125 w
.18936 1.02924 m
.17353 1.07717 L
s
P
p
1 0 .6 r
.00177 w
.73367 .8522 m
.74581 .87712 L
s
P
p
1 0 .6 r
.00177 w
.73367 .8522 m
.74762 .86556 L
s
P
p
1 0 .6 r
.00353 w
.53176 .96349 m
.55142 1.03007 L
s
P
p
1 0 .6 r
.00125 w
.74581 .87712 m
.75675 .89957 L
s
P
p
1 0 .6 r
.00177 w
.29013 .82244 m
.26722 .86127 L
s
P
p
1 0 .6 r
.00177 w
.29013 .82244 m
.27005 .84212 L
s
P
p
1 0 .6 r
.0025 w
.27524 .85451 m
.2381 .89106 L
s
P
p
1 0 .6 r
.0025 w
.27524 .85451 m
.24974 .89773 L
s
P
p
1 0 .6 r
.00125 w
.76186 .91597 m
.78273 .93607 L
s
P
p
1 0 .6 r
.00125 w
.76186 .91597 m
.7728 .93844 L
s
P
p
1 0 .6 r
.00125 w
.79461 .99529 m
.81559 1.01564 L
s
P
p
1 0 .6 r
.00125 w
.79461 .99529 m
.80557 1.0178 L
s
P
p
1 0 .6 r
.00125 w
.26722 .86127 m
.25751 .89056 L
s
P
p
1 0 .6 r
.0025 w
.51192 1.05458 m
.49412 1.1363 L
s
P
p
1 0 .6 r
.0025 w
.31912 .75568 m
.29693 .77725 L
s
P
p
1 0 .6 r
.0025 w
.31912 .75568 m
.30375 .78169 L
s
P
p
1 0 .6 r
.00353 w
.71642 .79071 m
.76368 .83566 L
s
P
p
1 0 .6 r
.00353 w
.71642 .79071 m
.75519 .80008 L
s
P
p
1 0 .6 r
.00125 w
.74762 .86556 m
.76023 .87763 L
s
P
p
1 0 .6 r
.00125 w
.74762 .86556 m
.75425 .87915 L
s
P
p
1 0 .6 r
.00125 w
.18936 1.02924 m
.15487 1.08779 L
s
P
p
1 0 .6 r
.00125 w
.46036 1.14973 m
.45166 1.18976 L
s
P
p
1 0 .6 r
.00125 w
.26722 .86127 m
.24651 .89634 L
s
P
p
1 0 .6 r
.0025 w
.51192 1.05458 m
.47004 1.10518 L
s
P
p
1 0 .6 r
.00353 w
.53176 .96349 m
.51192 1.05458 L
s
P
p
1 0 .6 r
.00177 w
.79169 .96818 m
.83038 1.00556 L
s
P
p
1 0 .6 r
.00177 w
.79169 .96818 m
.82357 .97694 L
s
P
p
1 0 .6 r
.00177 w
.30375 .78169 m
.28989 .80516 L
s
P
p
1 0 .6 r
.00177 w
.30375 .78169 m
.29164 .79349 L
s
P
p
1 0 .6 r
.00177 w
.24974 .89773 m
.22669 .9368 L
s
P
p
1 0 .6 r
.00177 w
.24974 .89773 m
.22943 .9178 L
s
P
p
1 0 .6 r
.00125 w
.28989 .80516 m
.28398 .82298 L
s
P
p
1 0 .6 r
.00177 w
.7458 .84901 m
.76901 .87118 L
s
P
p
1 0 .6 r
.00177 w
.7458 .84901 m
.76486 .85382 L
s
P
p
1 0 .6 r
.00125 w
.22669 .9368 m
.21703 .96604 L
s
P
p
1 0 .6 r
.00353 w
.32992 .72255 m
.28901 .7621 L
s
P
p
1 0 .6 r
.00353 w
.32992 .72255 m
.30326 .72767 L
s
P
p
1 0 .6 r
.00125 w
.46036 1.14973 m
.4398 1.17459 L
s
P
p
1 0 .6 r
.00177 w
.47004 1.10518 m
.46036 1.14973 L
s
P
p
1 0 .6 r
.00125 w
.28989 .80516 m
.27738 .82634 L
s
P
p
1 0 .6 r
.00177 w
.47004 1.10518 m
.43224 1.15084 L
s
P
p
1 0 .6 r
.005 w
.55389 .86191 m
.53176 .96349 L
s
P
p
1 0 .6 r
.00125 w
.22669 .9368 m
.20587 .97209 L
s
P
p
1 0 .6 r
.00125 w
.27005 .84212 m
.25183 .85999 L
s
P
p
1 0 .6 r
.00125 w
.27005 .84212 m
.25751 .86336 L
s
P
p
1 0 .6 r
.00125 w
.43224 1.15084 m
.39814 1.19205 L
s
P
p
1 0 .6 r
.00125 w
.43224 1.15084 m
.39497 1.16617 L
s
P
p
1 0 .6 r
.00125 w
.29164 .79349 m
.28068 .80417 L
s
P
p
1 0 .6 r
.00125 w
.29164 .79349 m
.28407 .80631 L
s
P
p
1 0 .6 r
.005 w
.55389 .86191 m
.55423 .98843 L
s
P
p
1 0 .6 r
.00177 w
.29693 .77725 m
.27676 .79684 L
s
P
p
1 0 .6 r
.00177 w
.29693 .77725 m
.28373 .78001 L
s
P
p
1 0 .6 r
.00125 w
.76901 .87118 m
.79003 .89127 L
s
P
p
1 0 .6 r
.00125 w
.76901 .87118 m
.78002 .89376 L
s
P
p
1 0 .6 r
.00125 w
.19373 .99822 m
.16297 1.02893 L
s
P
p
1 0 .6 r
.00125 w
.19373 .99822 m
.17282 1.03369 L
s
P
p
1 0 .6 r
.00125 w
.76486 .85382 m
.78214 .85818 L
s
P
p
1 0 .6 r
.00125 w
.76486 .85382 m
.77756 .86593 L
s
P
p
1 0 .6 r
.00125 w
.22943 .9178 m
.21101 .93601 L
s
P
p
1 0 .6 r
.00125 w
.22943 .9178 m
.21682 .93916 L
s
P
p
1 0 .6 r
.00125 w
.83038 1.00556 m
.86556 1.03957 L
s
P
p
1 0 .6 r
.00125 w
.83038 1.00556 m
.84866 1.04307 L
s
P
p
1 0 .6 r
.00125 w
.80652 .92346 m
.81001 .95365 L
s
P
p
1 0 .6 r
.0025 w
.76368 .83566 m
.80677 .87665 L
s
P
p
1 0 .6 r
.0025 w
.76368 .83566 m
.78621 .88183 L
s
P
p
1 0 .6 r
.00177 w
.2381 .89106 m
.20415 .92448 L
s
P
p
1 0 .6 r
.00177 w
.2381 .89106 m
.21568 .89658 L
s
P
p
1 0 .6 r
.00125 w
.82357 .97694 m
.85262 .98492 L
s
P
p
1 0 .6 r
.00125 w
.82357 .97694 m
.84481 .9974 L
s
P
p
1 0 .6 r
.00177 w
.78621 .88183 m
.80652 .92346 L
s
P
p
1 0 .6 r
.00177 w
.78621 .88183 m
.8097 .90426 L
s
P
p
1 0 .6 r
.0025 w
.75519 .80008 m
.79062 .80865 L
s
P
p
1 0 .6 r
.0025 w
.75519 .80008 m
.78119 .82471 L
s
P
p
1 0 .6 r
.00125 w
.80652 .92346 m
.82483 .96098 L
s
P
p
1 0 .6 r
.00125 w
.27676 .79684 m
.25846 .81463 L
s
P
p
1 0 .6 r
.00125 w
.27676 .79684 m
.26415 .81815 L
s
P
p
1 0 .6 r
.00125 w
.28373 .78001 m
.27174 .78253 L
s
P
p
1 0 .6 r
.00125 w
.28373 .78001 m
.27269 .79072 L
s
P
p
1 0 .6 r
.0025 w
.28901 .7621 m
.25154 .79832 L
s
P
p
1 0 .6 r
.0025 w
.28901 .7621 m
.26324 .80563 L
s
P
p
1 0 .6 r
.005 w
.53648 .79573 m
.52064 .86227 L
s
P
p
1 0 .6 r
.005 w
.53648 .79573 m
.48644 .84492 L
s
P
p
1 0 .6 r
.00125 w
.8097 .90426 m
.83098 .92458 L
s
P
p
1 0 .6 r
.00125 w
.8097 .90426 m
.8208 .927 L
s
P
p
1 0 .6 r
.0025 w
.30326 .72767 m
.27881 .73237 L
s
P
p
1 0 .6 r
.0025 w
.30326 .72767 m
.28072 .74935 L
s
P
p
1 0 .6 r
.00177 w
.78119 .82471 m
.80476 .84704 L
s
P
p
1 0 .6 r
.00177 w
.78119 .82471 m
.80059 .82948 L
s
P
p
1 0 .6 r
.00177 w
.26324 .80563 m
.23995 .84498 L
s
P
p
1 0 .6 r
.00177 w
.26324 .80563 m
.24276 .82552 L
s
P
p
1 0 .6 r
.00177 w
.80677 .87665 m
.84601 .91398 L
s
P
p
1 0 .6 r
.00177 w
.80677 .87665 m
.83914 .88491 L
s
P
p
1 0 .6 r
.00125 w
.23995 .84498 m
.23015 .87472 L
s
P
p
1 0 .6 r
.00353 w
.55423 .98843 m
.55455 1.10445 L
s
P
p
1 0 .6 r
.00353 w
.55423 .98843 m
.59893 1.06028 L
s
P
p
1 0 .6 r
.00125 w
.20415 .92448 m
.17315 .95498 L
s
P
p
1 0 .6 r
.00125 w
.20415 .92448 m
.18305 .96015 L
s
P
p
1 0 .6 r
.00125 w
.23995 .84498 m
.2189 .88052 L
s
P
p
1 0 .6 r
.00125 w
.21568 .89658 m
.1952 .90162 L
s
P
p
1 0 .6 r
.00125 w
.21568 .89658 m
.19702 .91488 L
s
P
p
1 0 .6 r
.00125 w
.80476 .84704 m
.82611 .86727 L
s
P
p
1 0 .6 r
.00125 w
.80476 .84704 m
.81591 .86985 L
s
P
p
1 0 .6 r
.00177 w
.79062 .80865 m
.82296 .81646 L
s
P
p
1 0 .6 r
.00177 w
.79062 .80865 m
.81039 .79676 L
s
P
p
1 0 .6 r
.00125 w
.80059 .82948 m
.81819 .8338 L
s
P
p
1 0 .6 r
.00125 w
.80059 .82948 m
.8135 .84168 L
s
P
p
1 0 .6 r
.00177 w
.28072 .74935 m
.26025 .76905 L
s
P
p
1 0 .6 r
.00177 w
.28072 .74935 m
.26729 .75202 L
s
P
p
1 0 .6 r
.00125 w
.24276 .82552 m
.22416 .84357 L
s
P
p
1 0 .6 r
.00125 w
.24276 .82552 m
.23001 .84704 L
s
P
p
1 0 .6 r
.00125 w
.84601 .91398 m
.88171 .94793 L
s
P
p
1 0 .6 r
.00125 w
.84601 .91398 m
.86453 .95187 L
s
P
p
1 0 .6 r
.00177 w
.25154 .79832 m
.21728 .83144 L
s
P
p
1 0 .6 r
.00177 w
.25154 .79832 m
.22897 .80315 L
s
P
p
1 0 .6 r
.00353 w
.48644 .84492 m
.44069 .8899 L
s
P
p
1 0 .6 r
.00353 w
.48644 .84492 m
.47738 .88162 L
s
P
p
1 0 .6 r
.00125 w
.83914 .88491 m
.86864 .89243 L
s
P
p
1 0 .6 r
.00125 w
.83914 .88491 m
.86069 .90534 L
s
P
p
1 0 .6 r
.00177 w
.27881 .73237 m
.25642 .73666 L
s
P
p
1 0 .6 r
.00177 w
.27881 .73237 m
.26931 .71841 L
s
P
p
1 0 .6 r
.00125 w
.26025 .76905 m
.24166 .78694 L
s
P
p
1 0 .6 r
.00125 w
.26025 .76905 m
.24747 .79059 L
s
P
p
1 0 .6 r
.00125 w
.81039 .79676 m
.82838 .78595 L
s
P
p
1 0 .6 r
.00125 w
.81039 .79676 m
.82812 .80098 L
s
P
p
1 0 .6 r
.00125 w
.26729 .75202 m
.25508 .75444 L
s
P
p
1 0 .6 r
.00125 w
.26729 .75202 m
.25608 .76278 L
s
P
p
1 0 .6 r
.00125 w
.82296 .81646 m
.85244 .82359 L
s
P
p
1 0 .6 r
.00125 w
.82296 .81646 m
.84451 .83674 L
s
P
p
1 0 .6 r
.0025 w
.55455 1.10445 m
.55484 1.21066 L
s
P
p
1 0 .6 r
.0025 w
.55455 1.10445 m
.5139 1.17118 L
s
P
p
1 0 .6 r
.0025 w
.59893 1.06028 m
.63987 1.1261 L
s
P
p
1 0 .6 r
.0025 w
.59893 1.06028 m
.61401 1.09435 L
s
P
p
1 0 .6 r
.00125 w
.21728 .83144 m
.186 .86168 L
s
P
p
1 0 .6 r
.00125 w
.21728 .83144 m
.19595 .86737 L
s
P
p
1 0 .6 r
.00353 w
.52064 .86227 m
.50595 .92397 L
s
P
p
1 0 .6 r
.00353 w
.52064 .86227 m
.54692 .89954 L
s
P
p
1 0 .6 r
.00125 w
.26931 .71841 m
.26065 .7057 L
s
P
p
1 0 .6 r
.00125 w
.26931 .71841 m
.25705 .7207 L
s
P
p
1 0 .6 r
.0025 w
.44069 .8899 m
.39892 .93097 L
s
P
p
1 0 .6 r
.0025 w
.44069 .8899 m
.39324 .91155 L
s
P
p
1 0 .6 r
.00125 w
.22897 .80315 m
.20833 .80756 L
s
P
p
1 0 .6 r
.00125 w
.22897 .80315 m
.21013 .82129 L
s
P
p
1 0 .6 r
.00125 w
.35041 .93108 m
.31916 .93461 L
s
P
p
1 0 .6 r
.0025 w
.47738 .88162 m
.46908 .91518 L
s
P
p
1 0 .6 r
.0025 w
.47738 .88162 m
.4523 .90638 L
s
P
p
1 0 .6 r
.00177 w
.39324 .91155 m
.35041 .93108 L
s
P
p
1 0 .6 r
.00177 w
.39324 .91155 m
.37035 .93395 L
s
P
p
1 0 .6 r
.00125 w
.25642 .73666 m
.23596 .74059 L
s
P
p
1 0 .6 r
.00125 w
.25642 .73666 m
.23768 .75455 L
s
P
p
1 0 .6 r
.00125 w
.57289 1.28604 m
.5891 1.35372 L
s
P
p
1 0 .6 r
.00125 w
.35041 .93108 m
.31177 .9487 L
s
P
p
1 0 .6 r
.00125 w
.57289 1.28604 m
.6083 1.32807 L
s
P
p
1 0 .6 r
.00177 w
.55484 1.21066 m
.57289 1.28604 L
s
P
p
1 0 .6 r
.00125 w
.47868 1.22088 m
.44698 1.26558 L
s
P
p
1 0 .6 r
.00125 w
.47868 1.22088 m
.45838 1.25417 L
s
P
p
1 0 .6 r
.00177 w
.5139 1.17118 m
.47868 1.22088 L
s
P
p
1 0 .6 r
.00177 w
.55484 1.21066 m
.55511 1.30774 L
s
P
p
1 0 .6 r
.00177 w
.5139 1.17118 m
.47675 1.23218 L
s
P
p
1 0 .6 r
.00125 w
.37035 .93395 m
.34961 .95426 L
s
P
p
1 0 .6 r
.00125 w
.37035 .93395 m
.34695 .94463 L
s
P
p
1 0 .6 r
.00177 w
.4523 .90638 m
.42955 .92885 L
s
P
p
1 0 .6 r
.00177 w
.4523 .90638 m
.44768 .92478 L
s
P
p
1 0 .6 r
.00177 w
.63987 1.1261 m
.67731 1.1863 L
s
P
p
1 0 .6 r
.00177 w
.63987 1.1261 m
.67599 1.17534 L
s
P
p
1 0 .6 r
.00125 w
.67599 1.17534 m
.7085 1.21967 L
s
P
p
1 0 .6 r
.00125 w
.67599 1.17534 m
.69645 1.20821 L
s
P
p
1 0 .6 r
.00177 w
.39892 .93097 m
.36082 .96842 L
s
P
p
1 0 .6 r
.00177 w
.39892 .93097 m
.39086 .96169 L
s
P
p
1 0 .6 r
.00177 w
.61401 1.09435 m
.62787 1.12568 L
s
P
p
1 0 .6 r
.00177 w
.61401 1.09435 m
.63653 1.13061 L
s
P
p
1 0 .6 r
.00177 w
.46908 .91518 m
.46151 .94585 L
s
P
p
1 0 .6 r
.00177 w
.46908 .91518 m
.4817 .93381 L
s
P
p
1 0 .6 r
.00125 w
.42955 .92885 m
.40893 .94922 L
s
P
p
1 0 .6 r
.00125 w
.42955 .92885 m
.4061 .93957 L
s
P
p
1 0 .6 r
.00125 w
.44768 .92478 m
.44348 .94146 L
s
P
p
1 0 .6 r
.00125 w
.44768 .92478 m
.43525 .93708 L
s
P
p
1 0 .6 r
.0025 w
.54692 .89954 m
.57111 .93384 L
s
P
p
1 0 .6 r
.0025 w
.54692 .89954 m
.53909 .9336 L
s
P
p
1 0 .6 r
.00125 w
.55511 1.30774 m
.55535 1.39633 L
s
P
p
1 0 .6 r
.00125 w
.55511 1.30774 m
.56478 1.3577 L
s
P
p
1 0 .6 r
.00125 w
.47675 1.23218 m
.44284 1.28785 L
s
P
p
1 0 .6 r
.00125 w
.47675 1.23218 m
.46318 1.2619 L
s
P
p
1 0 .6 r
.00125 w
.63653 1.13061 m
.65699 1.16354 L
s
P
p
1 0 .6 r
.00125 w
.63653 1.13061 m
.64421 1.14787 L
s
P
p
1 0 .6 r
.00125 w
.67731 1.1863 m
.71151 1.24127 L
s
P
p
1 0 .6 r
.00125 w
.67731 1.1863 m
.69043 1.21546 L
s
P
p
1 0 .6 r
.00125 w
.36082 .96842 m
.32614 1.00253 L
s
P
p
1 0 .6 r
.00125 w
.36082 .96842 m
.3218 .98627 L
s
P
p
1 0 .6 r
.00125 w
.39086 .96169 m
.38351 .98971 L
s
P
p
1 0 .6 r
.00125 w
.39086 .96169 m
.37 .98227 L
s
P
p
1 0 .6 r
.0025 w
.50595 .92397 m
.49236 .98105 L
s
P
p
1 0 .6 r
.0025 w
.50595 .92397 m
.46403 .96587 L
s
P
p
1 0 .6 r
.00125 w
.4817 .93381 m
.49319 .95076 L
s
P
p
1 0 .6 r
.00125 w
.4817 .93381 m
.47762 .95062 L
s
P
p
1 0 .6 r
.00125 w
.46151 .94585 m
.4546 .97382 L
s
P
p
1 0 .6 r
.00125 w
.46151 .94585 m
.44085 .96641 L
s
P
p
1 0 .6 r
.00125 w
.62787 1.12568 m
.64059 1.15443 L
s
P
p
1 0 .6 r
.00125 w
.62787 1.12568 m
.62438 1.13115 L
s
P
p
1 0 .6 r
.00177 w
.53909 .9336 m
.53193 .96473 L
s
P
p
1 0 .6 r
.00177 w
.53909 .9336 m
.55225 .95254 L
s
P
p
1 0 .6 r
.00177 w
.46403 .96587 m
.4258 1.00408 L
s
P
p
1 0 .6 r
.00177 w
.46403 .96587 m
.45632 .99728 L
s
P
p
1 0 .6 r
.00177 w
.57111 .93384 m
.59332 .96534 L
s
P
p
1 0 .6 r
.00177 w
.57111 .93384 m
.60786 .94495 L
s
P
p
1 0 .6 r
.00125 w
.55225 .95254 m
.56423 .96976 L
s
P
p
1 0 .6 r
.00125 w
.55225 .95254 m
.5484 .9696 L
s
P
p
1 0 .6 r
.00125 w
.53193 .96473 m
.5254 .99312 L
s
P
p
1 0 .6 r
.00125 w
.53193 .96473 m
.5113 .98558 L
s
P
p
1 0 .6 r
.00177 w
.49236 .98105 m
.47982 1.03373 L
s
P
p
1 0 .6 r
.00177 w
.49236 .98105 m
.51392 1.01318 L
s
P
p
1 0 .6 r
.00125 w
.4258 1.00408 m
.39097 1.03888 L
s
P
p
1 0 .6 r
.00125 w
.4258 1.00408 m
.38628 1.02223 L
s
P
p
1 0 .6 r
.00125 w
.60786 .94495 m
.6413 .95506 L
s
P
p
1 0 .6 r
.00125 w
.60786 .94495 m
.62016 .96219 L
s
P
p
1 0 .6 r
.00125 w
.45632 .99728 m
.44929 1.02594 L
s
P
p
1 0 .6 r
.00125 w
.45632 .99728 m
.43539 1.01828 L
s
P
p
1 0 .6 r
.00125 w
.59332 .96534 m
.61369 .99423 L
s
P
p
1 0 .6 r
.00125 w
.59332 .96534 m
.58716 .99389 L
s
P
p
1 0 .6 r
.00125 w
.51392 1.01318 m
.53369 1.04264 L
s
P
p
1 0 .6 r
.00125 w
.51392 1.01318 m
.5072 1.04219 L
s
P
p
1 0 .6 r
.00125 w
.47982 1.03373 m
.46827 1.08223 L
s
P
p
1 0 .6 r
.00125 w
.47982 1.03373 m
.44489 1.06912 L
s
P
p
1 g
.002 w
.83123 .03823 m
.86467 1.32309 L
s
.86467 1.32309 m
.03823 1.37454 L
s
.03823 1.37454 m
.08331 .12246 L
s
.08331 .12246 m
.83123 .03823 L
s
.83123 .03823 m
.86467 1.32309 L
s
.86467 1.32309 m
.96177 1.49486 L
s
.96177 1.49486 m
.92317 .32153 L
s
.92317 .32153 m
.83123 .03823 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    CellMargins->{{Inherited, 334}, {Inherited, Inherited}},
    Evaluatable->False,
    AspectRatioFixed->True,
    ImageSize->{163, 178},
    ImageMargins->{{0, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    AnimationDisplayTime->5,
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000LMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00H002_6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001XaPT01LH00`36aP0YaP400000GmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00T003[Fa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0005G62P07aP03a<K600g60P0ZaP400000C=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000N
a]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KF0l@2000Ze/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0004?62@04aP03a<K601C600C4a/K62<@3aP80:/H1000003WFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02P007lKF
a]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/H02L@0=lKFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003362@000lC6aP0EaP03a<K600K62<@6aP03
a<K600_600<0aP00:LH1000002OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
2@008]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H8a018e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;6
1@0CaP03a<K600c62/@FaP03a<K600[600@0a/H0:<H10000047Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6eP08a01Ia]K6e/KFa]K6a<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0002;60P000lC6aP0BaPS44/H00lC6aP0CaP03a<K600[600@0a/H0
:<H10000033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a=K6e/KFa]K6e/H9a01Y
a]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KF
aP36e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000RaP040<H0a0;6
2<@<aP03a<K601G600?4a/H04lH00lC6aP09aP050<K6aP009lH1000002CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<H4a01je/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H01@36aP3401K600?4a/H05LH00lC6aP0CaP03
a<K600S600<0a<@00/@00`36aP0TaP400000K]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa=K62<@0;036e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002;600<0a/H00/H00`34aP0DaP03a<K601G600?4a/H03<H9a0S600<0a/H00/H00`36
aP0TaP400000G=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP34a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K62L@0?LKFa]K6e/K4a]K6e/KF
a]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002;600<0a/H0
0lH00`34aP0DaP03a<K601762L@@aP03a<K600S600<0a/H00/H00`36aP0SaP400000B]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K62L@00lKF0002001:e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6eP3Fa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36aP04aP030<C601C62/@:aPD0
5<H00lC6aP07aP030<K600;600<0a/H08lH1000003SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/H0a=K6e/KFa]K6e/KFaP[401;Fa]K6e/KFa]K6e/KFa]K6e/H50019a]K6e/KF
a]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100008/H00`36aP05aP030<C600;62L@9aP03a<K601361@0EaP03a<K600K600<0a/H0
0lH00`36aP0RaP400000:]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaPG4
02K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6eP<004[Fa=K6e/KFa]K6e/KFa]K6
e/KFa]K6a<KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000QaP030<K600O600<0a<H05<H00lC6aP0@aP05?do6a/@05LH00lC6aP05aP030<K600C600<0a/H0
8LH1000005GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP34e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KF008o02;6e/K4a]K6e/KFa]K6e/KFa]K6e/KF
a]K4e/KFa]K6eP3F1L@09036e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP03
0<K600W600<0a<H04lH00lC6aP0?aP03?do600;600?4a/H04/H8a0030<C600C600<0a/H08LH10000
05GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KF008o00o6e/KFa=K6e/KFa]K6e/H02L@0<lK4a]K6e/KF
0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008LH00`36aP0:aP03
0<C601?600?4a/H03/H00cm?aP03aP_42/H00lC6aP04aP030<K600G600<0a/H08<H1000005;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K60l@2?`K404G6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6eP3Fa]K6e/KF
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00027600<0a/H02lH00`34aP0DaP03
a<K400W40lH00cm?aP04aP03a<K601;600?4a/H00lH00`36aP06aP030<K601o60@00000oe/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KF00W4
00gFa]K6e/KFa]K6e/KF008o02C6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6eP3Fa]H6000Q
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000QaP030<K600c600<0a<H00/H:a0S6
00?4a/H02lH00cm?aP05aP03a<K601360P000l@0000600G600<0a/H07lH10000033Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H5a00Pa]K6e/KFa]K6e/KFa]K6e/KF
a=K6e/KFa]K6e/KFa]H2?`0>a]K6e/KFa=K6e/KFa]H;000be/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0=aP030<C601C600?4a/H02/H00cm?
aP02aP@000?40000100BaP030<K600K600<0a/H07lH1000004oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP34e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KF00H0
0Sl30018e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H03lH00`34aP0>aPD000?400000`06aP03?do601o6
00<0a/H01/H00`36aP0OaP400000>MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6eP34a]K6eP0;000Ae/KFa]K6e/KFa]K6e/KFa]H00Sl0BlKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP0100008LH00`36aP0@aP030<@000807<H00cm?aP0OaP030<K600K600<0a/H07lH1000005GFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o04_6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F
a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00027600<0a/H04<H00`36
aP0NaP03?do601o600<0a/H01/H00`36aP0OaP400000EMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0Sl0BlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100008LH00`36aP0@aP030<K601k600<oClH07lH00`36aP06aP03
0<K601o60@00001Ee/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`1;a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000QaP030<K6013600<0a/H07/H00cm?aP0OaP030<K600K600<0a/H07lH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0@aP030<K601g600=?aTl0
8<H00`36aP06aP030<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00027600<0a/H04<H00`36aP0KaP05ClK6aTl08<H00`36aP07aP030<K601k60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H04<H00`36
aP0JaP03?lK600;600=?a/H07/H00`36aP07aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H04LH00`36aP0IaP03ClK600?600=?a/H0
7/H00`36aP07aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00023600<0a/H04LH00`36aP0HaP03?lK600C600=?a/H07lH00`36aP06aP030<K601k6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H0
4LH00`36aP0GaP03ClK600G600=?a/H07lH00`36aP06aP030<K601k60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H04LH00`36aP0FaP03?do600K6
00=?a/H07lH00`36aP06aP030<K601k60@00001<e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o05CFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008<H00`36aP0@aP030<K601K600=??lH01lH00do6aP0OaP030<K600K6
00<0a/H07/H1000004_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl02LKFa]K6e/KFaP02?`1:e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008<H00`36aP0@aP030<K601G600<oClH02<H00dloaP0OaP030<K600K600<0a/H07/H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6?lKFa]K6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0@aP03
0<K601?600<oaSl02/H00do6C`0OaP030<K600K600<0a/H07/H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHo
e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0@aP030<K6017600@oClI?2lH01Do6
a/I?01g600<0a/H01/H00`36aP0NaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/HoaSo6?lKFa]K6e/KFa]K6?lKFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000PaP030<K6013600<0a/H03lH01So6?lHoC`c600Doa/K6?`0LaP030<K600K6
00<0a/H07/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFaSo6?lKF?mK6e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
8<H00`36aP0@aP030<K600g600Loa/I?aTlo00g600<oa/H00/H00do6aP0IaP030<K600K600<0a/H0
7/H1000004SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/Hoa]Hoe/H2?`1He/KFa]K6e/KFa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP03
0<K6013600<0a/H02lH023m?a/HoaSm?3/H00co6aP03aP03?lK601S600<0a/H01/H00`36aP0NaP40
0000@=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/H2?`04e/HoaP<o01C6e/KFa]K6e/KFa]K6eSoFa]K6eP8o04?6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000PaP03
0<K6013600@0a/I?2<H01Co6?lHo00;600=??dl03/H00co6aP04aP03Cco601O600<0a/H01/H00`36
aP0NaP400000=]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
eP3FaP8o00gFa]K6e/HoaSo6eSoF008o05_6?lKFa]K6e/KFa]K6e/KF?mK6e/KFaSo6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000PaP030<K6013600/0aSo6?lHoCcm??`02aP09ClI?aTo6Ccm?00k600<oa/H01LH00co6?`0FaP03
0<K600K600<0a/H07/H1000003CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]H01Cl01LHoaSo6008o00CFaSo60Sl0G=Ho?lKFa]K6e/KFa]K6e/KF?mK6e/KFa]Ho
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00023600<0a/H04<H00cm?aP03aP0@?lHoaSo6?lHoaSm??lHoC`k600<oa/H01/H01Do6
aSm?01?600<0a/H01/H00`36aP0NaP400000=MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6eSoF00@o00O6?lHoaSo600<o00C6?coF0Sl03LKFa]K6e/KFa]K6e/H0
0Sl0B]K6e/KFa]K6?lKF?mHoe/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H04LH01`36?lHoaSl00/H03Dloa/I??dloClI?aTl0
3LH00dloaP07aP07ClK6aTo6C`0AaP030<K600K600<0a/H07/H1000003GFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H0eP02?`06aSloeSoF23l04LHo?co6e/KF
a]K6e/KFa]K6008o04[Fa]K6e/KFa]Hoe/Hoa]Hoe/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K6017601H0Cco6?dloClI??dloCcm?
?do6Ccm?3LH00dloaP08aP05?lK6aSl00/H00do6aP0=aP030<K600O600<0a/H07LH1000003?Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H00Sl01lHo?co6?lH0
2Sl08mHo?lKFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/Hoa]Hoe/KF00<o00SFa]K6e/KFaP8o02cFaP36
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K6017601L0Cco6
?lHoaSm??dloCcm??dloClI??`0;aP03?lHo00[600E?a/K6C`03aP06ClI??dlo0/H00dloC`03aP03
0<K600O600<0a/H07LH10000033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/H5?`03aSlo00lo00g6?coF?mK6e/KFa]K6008o00cF?mK6e/KFa]K6e/H2?`0<e/Ho?mK6
eSoFaSo613l0;]Hoe/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
7lH00`36aP0?aP0J?lHoaSm?aTloClI??dloClI??dloClI??dl8aP05?lHoaSl02/H00dloaP02aP03
?do600;600A?a/Ho1<H01DloCcl000W600<0a/H07LH1000003;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/HoaP@o00?F?cl023l00lHo?`03?`0YaSlo?lKFa]K6e/Ho
aSo6eSoFa]K6e/KFa]K6?lHoa]HoeSoFa]Hoe/H00Sl0<=K6eSoFaP36e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K600k600E??dl0C`03aP0BCcm??dloCco6?dlo
Ccm??dlo1lH013o6aTl2aP03?lK600W600<oClH00/H00dloC`03aP0;ClK6?dloClI?aP002LH00`36
aP0MaP400000<mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF?mHo
eP02?`03a]Ho008o00?F?cl02cl08]K6e/KFa]K6?lKFaSo6eSoFa]K6e/KFa]K6eSoF?mK6?lH2?`0f
e/Ho?mK6?lHoa]Ho0<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o6
00<0a/H03<H01To6ClI??`;6019??dloCcm??dloaSo6?do6Ccl7aP05?lK6aSl00lH00co6aP09aP03
?lHo00?600PoaSm??lHoC`;600<oa/H00lH00`36aP06aP030<K601g60@00000ee/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF?mHoe/KF?mH01Cl00mHo?`02?`03aSlo00<o
00W6?coFa]K6e/H00Sl07]K6eSoFa]Hoe/KFa]K6e/KFa]HoeSoFa]HoeSoFaP@o033F?co6e/KF0=K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH00`36aP0<aP0KClK6aTl0
aSm??dloaSm?aTloCcm??dloCcm?00C600<oaSl00lH01Co6a/Ho00_600@oa/I?0/H03Cm?aTloaSm?
aTo6Ccl00lH00`36aP06aP030<K601g60@00000ee/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/Ho0=H00Sl00lHoaP03?`05aSlo?lH00Sl03mHoeSoFa]K6?lHoa]K6
eP02?`0Da]Hoe/KFa]K6e/KFa]Hoe/Hoa]H2?`03aSlo00<o00?6eSl00Sl0;=K6eP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03lH01Co604lo00;600a?aTlo
Ccm??dloaSl7aP04?lHoC`?600I?a/HoCcl;aP0:?do6aSm??do6C`?600Y??lK6ClI??dl02<H00`36
aP0MaP400000<=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaPHo
00?F?mH02cl01MK6e/KF008o00[6?lHoa]K6?lKF0cl04mK6e/KFa]K6e/KF?mHoeSoF?mH00cl00mK6
?`02?`0_a]Hoe/Ho03o6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001o6
00<0a/H03<H01dloaSo604l00/H03Cm??lHoCco6?dloCcl00/H00dloC`02aP03?lHo00C600I?a/K6
Ccl<aP0:Cco6aTloCco6?`C600E??do6C`02aP030<K600K600<0a/H07LH1000003KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6?lHoa]Hoe/H5?`04aSo6eP8o00?6?cl0
0Sl04=Hoe/KF?mHoe/KF?mK6e/H2?`0Be/KFa]K6e/KFa]K6?lHoaSo60cl01LHoa]K6008o02kF?mHo
eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH03So6
aTloaSm??dloClI?0lH01dloCcm?aTl00lH014loaSl3aP07?lK6aSo6?`0<aP03ClI?00;600HoCcm?
?dl4aP07?do6Ccm?0008aP030<K601g60@00000ae/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]HoeP03?`05eSlo?mH013l00lHo?`02?`06eSoF?mK613l01=Ho?lH2?`05
e/KF?mH00cl03=K6e/KFa]K6e/HoaP8o00?FaSl00cl0==Hoe/KF?mHoe/Ho0=K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH00`36aP0<aP0TClI??dl0Ccm?aTloaSm??dlo
aSm?aTloCco6?do6ClI??lHo0lH023o6?do6Ccm?1lH01do6aSo6?dl00/H013m??dl2aP03?do600;6
00=?04l01lH00`36aP0MaP400000;MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6eP02?`05a]K6?`000Sl01MK6?coF00Lo00?F?mH00Sl02LKFa]K6?lHoaP02?`03e/KF00<o
00GF?mK6eP03?`0:e/KFaSo6eSoFaP8o00OFaSloe/KF008o02g6e/Ho0=Hoe/KFa]K60<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001o600<0a/H02/H00dloaP02aP05?lHoCcl00lH033m?
aTloCcm?aTo6C`K600<oCcl00/H024o6a/I?aTlo0/H014o6aSl2aP05ClK6?dl00/H01Cm?a/Ho00;6
00=??dl00/H00cm?aP03aP030<K600K600<0a/H07LH10000033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H3?`0;aSo6e/HoaSo6?lH013l02=K6?lKFa]K60cl02LKF
aSo6e/HoaP02?`0?e/KF?mK6?lKFa]HoeSoF00<o00CFaSo60Sl0<]Ho?coF?mK6eP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH01Co6?dlo00C600=?a/H0
0/H013m??dl2aP03?do600G600<oClH00/H02Do6aSm?aTloC`02aP03?lK600G600XoaSo6?dloClI?
0/H02cm?aTo6Ccm??lH000S600<0a/H07LH10000033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/H2?`0503oFa]H00Sl00lKFaP02?`04eSoFaP8o00kFa]K6e/HoaSo6
e/HoaP<o01;6eSoFaSo6?lKFa]K6eSoF?mH2?`03aSlo008o03CF?mHoeSoF?mK6?`3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH01Co6?dlo00;600=??dl0
1<H00cm?aP03aP03?lK600?600@oa/I?0lH024o6aSo6?lHo0/H014o6aSl4aP0<Cco6?lHoCcm??dlo
0/H01do6ClI?aTl00/H00`36aP06aP030<K601g60@00000ge/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaSo6?lHoa]HoeP02?`0>a]K6eSoFa]K6e/KFa]H2?`0Ha]Ho?lKF
?mHoeSoF?mHoe/KFa]K6e/KF0cl01mHo?coF?mH013l0<lHoaSo6eSoF?mH0e/KFa]K6e/H0a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007/H00`36aP0<aP06?dloaSm?1<H00cm?aP0;aP03
?dlo00;600=?aTl00/H02So6aTloaSo6?dl7aP08ClI??lHoCcl3aP06?lHoClI?0/H01co6aTloaP00
2<H00`36aP0MaP400000;=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
0Sl00mHo?`02?`0Oa]K6?lKFa]K6e/KFa]K6e/HoaSo6eSoF?mK6eSoFaP02?`0?e/Ho?mHoe/KFa]K6
eSoF00@o00C6e/KF13l01<KF?mH2?`0]aSo6?`3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000NaP030<K600[600DoaSm??`02aP05ClK6aTl03/H00co6aP03aP04?lK6C`?6
00Q??lK6Cco6?`O600Loa/I?aTlo00?600LoCco6?lHo00G600<oaP002<H00`36aP0MaP400000<MK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6?lHoa]H00Sl07/KFa]K6e/KF
a]K6e/KFa]K6?lKFa]K6e/KFaSo6eP<o01;FaSloe/Hoa]K6e/KFa]K6e/H2?`0je/KFa]HoeSoFaSo6
e/KF?mH0?lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K600c6
00Hoa/K6?`0JaP0;?do6aSm?aTo6Ccl00/H00do6aP09aP03Ccm?00C600HoClI?aTl5aP03C`3600O6
00<0a/H07LH1000005KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]Ho
e/KF?`36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6?lKFaP8o01GFa]Hoe/KFa]K6e/KFaSo6
?lKFa]H00Sl0<lHo?mHoe/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP0100007/H00`36aP0;aP03Cco600?600<0a/H05/H00co6?`04aP06ClK6?lHo1<H00do6aP06aP04
?do6C`C600HoaSo6?dl6aP030<K600O600<0a/H07<H1000002_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KF008o02C6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoF
a]H2?`0Ba]HoeSoFa]K6?lKFa]K6e/KF0Sl0>lKF?mK6eSoF?mHoeSoFa]K6eP3Fa]K6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000NaP030<K600[600<oClH01<H00`36aP0HaP05
?lK6Ccl00lH013o6?dl3aP03Cco600O600=?a/H01<H023o6?do6ClI?1<H00`36aP07aP030<K601c6
0@00001Ge/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6?lKFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6eSoF00<o01GFa]Hoe/KFa]K6e/Hoa]K6e/KF?mH0
0Sl00lKF?`02?`0/e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
7/H00`36aP0AaP030<K601W600A?a/Ho0lH01So6?do6C`;600<oClH03<H01DloaSm?00;600@oaSm?
0/H00`36aP07aP030<K601c60@00001Fe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6?lH2?`0LeSoF?mHo
eSoFa]K6e/KFa]K6e/HoaSo6eSoFaP8o02cF?mH0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000NaP030<K6017600<0a/H06<H01Co6a/Ho00;600I?aTloaSl2aP04ClI??`k6
00=?a/H00lH01To6ClI?00W600<0a/H07<H1000004cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl02=K6?lKFaSo6
0Sl01=Hoe/H2?`0FeSloa]K6e/KFa]K6e/KFaSo6e/KFaP8o02cFa]H0e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K6017600<0a/H05/H00cm?aP02aP08ClK6aTlo
Ccl2aP07ClK6?dloC`0CaP03Cco600;600<0a/H01lH00`36aP0LaP400000DmK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lHoa]K6?lKF008o00[6eSoFaSo6eSoF0cl0@=K6e/KFa]K6e/KFa]K6e/KFaSo6?lKF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0AaP030<K601?600E??lK6
C`03aP05Ccm??dl00/H013o6aTl5aP03Ccm?017600=?aTl00/H00`36aP07aP030<K601c60@000016
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFaP8o01;F?mK6?lKF?mHoeSoFa]Hoe/H2?`16e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
?lHoa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K60176
00<0a/H04<H013o6aTl2aP08?do6aSo6?dl4aP05?lHoaSl01lH00co6aP0AaP04?lK600S600<0a/H0
7<H1000004[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6eSoFaP8o01OFa]Hoe/Hoa]K6eSoF?mHoe/KFa]K6eP02?`0ma]K6e/KF
a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
7/H00`36aP0AaP030<K6017600=?a/H00/H023o6a/HoaSm?1<H00co6aP02aP03ClK600G600=??lH0
4lH00`36aP06aP030<K601c60@00001?e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6eP04?`0Aa]K6eSoFa]K6e/KF
a]K6e/H00cl0>lKFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000NaP030<K6017600<0a/H06LH01Do6ClI?00C600<oa/H02lH00cm??`0BaP03
0<K600K600<0a/H07<H1000004kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0FeSloa]K6eSoFa]K6e/KFa]K6
e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001k600<0a/H04LH00`36aP0HaP07?dloaSo6?`03aP03?lK600c600=?aTl04LH00`36
aP06aP030<K601c60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6?lKF?mHoe/KF?mK6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001k600<0a/H04LH00`36aP0FaP04?lHoC`C600Hoa/K6?dl?aP03ClK600o600<0a/H01/H00`36
aP0LaP400000C=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lH2?`09e/KFa]K6e/KF008o04W6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000MaP030<K601;600<0a/H05lH00dloaP08aP03?do6023600<0a/H01/H00`36aP0LaP400000BmK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP02?`0:a]K6e/KFa]K6eP8o04W6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000MaP030<K601;6
00<0a/H05/H00cm?aP09aP03?lHo023600<0a/H01/H00`36aP0LaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K601;600<0a/H08/H00co6?`0PaP03
0<K600K600<0a/H07<H1000005WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeP02?`17a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001g600<0a/H04/H00`36aP0RaP05?lK6Ccl07/H00`36aP06aP030<K601c60@00001b
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K62@009lKF
a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007LH00`36aP0BaP030<K602;6
00@oa/I?0/H00co6aP03aPl02<H00`36aP06aP030<K601c60@00001Ce/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H04000?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007LH00`36aP0AaP030<K601363`04aP05?do6aSl07lH00`36aP05aP03
0<K601c60@00000de/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
eP3FaQ0001?Fa]K6e/KFa]K6e/KFa]K6e/KF008o04W6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000MaP030<K600G6
3`0SaP03?lK602;600<0a/H01LH00`36aP0KaP4000007MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00P007g6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007lH00`36aP0?aP030<K602?600<oa/H08lH00`36aP04aP030<K601_6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H0
3LH00`36aP1:aP030<K600?600<0a/H06lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008lH00`36aP0;aP030<K604_600<0a/H00/H00`36aP0KaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000UaP030<K600W600<0a/H0
C<H01@36a/H001g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002O60P08aP030<K604g600@0a/H07LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000:/H00`36aP04aP030<K604k600<0aP007LH1000008?Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP02000Ma]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002c600<0a/H00/H00`36aP1?aP80
7LH1000007[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP/001g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000;/H01036aP0caQD0
:<H10000053Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQD003g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000`aP802LHE05;60@00000ae/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0:001Wa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
    ImageRangeCache->{{{0, 162}, {177, 0}} -> {0, 0, 0, 0}}]
}], "Text"],

Cell[CellGroupData[{

Cell[TextData[StyleBox[ButtonBox["Introduction",
  ButtonData:>"Introduction",
  ButtonStyle->"Hyperlink"],
  FontColor->GrayLevel[1]]], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
This notebook provides examples of bracketed L-systems with which \
we model branching structures. In combination with a 3D turtle \
interpretation, growth characteristics of simple tree structures can be \
modelled.\
\>", "Text",
  CellTags->"Introduction"]
}, Closed]],

Cell[CellGroupData[{

Cell["External packages ", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Directory of Notebook Packages", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "Note",
  StyleBox[": Evaluate the following cells to load the definitions needed to \
perform any calculations in this notebook.",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"],

Cell[TextData[{
  "For setting the ",
  StyleBox["Evolvica Directory",
    FontWeight->"Bold"],
  StyleBox[" ",
    FontSlant->"Italic"],
  "please refer to the ",
  ButtonBox["IEC Notebook",
    ButtonData:>{
      FrontEnd`FileName[ {"..", "..", "..", "IEC-Evolvica.nb"}], 
      "Setting EVOLVICA Directory"},
    ButtonStyle->"Hyperlink"],
  "."
}], "Text"],

Cell[BoxData[
    \(SetDirectory[\[IndentingNewLine]ToFileName[{EvolvicaDirectory, \
\[IndentingNewLine]"\<EvolutionPrograms\>", "\<L-Systems\>", "\<Trees\>", \
"\<Packages\>"}]]\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Loading External Notebooks and Packages", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Get[\"kLSystems.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Get[\"TurtleInterpretation.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "Modeling of ",
  StyleBox[ButtonBox["simple trees",
    ButtonData:>"Modeling of trees",
    ButtonStyle->"Hyperlink"],
    FontColor->GrayLevel[1]]
}], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  "Parametrized ",
  ButtonBox["L-system",
    ButtonData:>"L-system",
    ButtonStyle->"Hyperlink"]
}], "Subsection",
  CellTags->"Modeling of trees"],

Cell[CellGroupData[{

Cell["Program", "Subsubsection",
  CellTags->"L-system"],

Cell[BoxData[
    \(plantAxiom[]\  := \ \n\ \ AXIOM[\ A[1, 0.02]\ ]; \n\ \ \n
    plantRules[r1_, r2_, a0_, a2_, d_, wr_]\  := \ \n
      LRULES[\n\ \ 
        LRule[LEFT[], \ PRED[\ A[l_, w_]\ ], \ RIGHT[], \n\ \ \ \ 
          SUCC[\ \ \n\ \ \ \ \ \ TH[w], FO[l], STACK[PD[a0], B[l*r2, w*wr]], 
            \n\ \ \ \ \ \ RR[d], A[l*r1, w*wr]\n\ \ \ \ ]\n\ \ ], \n\ \ \n\ \ 
        LRule[LEFT[], \ PRED[\ B[l_, w_]\ ], \ RIGHT[], \n\ \ \ \ 
          SUCC[\ \ \n\ \ \ \ \ \ TH[w], FO[l], STACK[YR[a2], C[l*r2, w*wr]], 
            \n\ \ \ \ \ \ C[l*r1, w*wr]\n\ \ \ \ ]\n\ \ ], \n\ \ \n\ \ 
        LRule[LEFT[], \ PRED[\ C[l_, w_]\ ], \ RIGHT[], \n\ \ \ \ 
          SUCC[\ \ \n\ \ \ \ \ \ TH[w], FO[l], STACK[YL[a2], B[l*r2, w*wr]], 
            \n\ \ \ \ \ \ B[l*r1, w*wr]\n\ \ \ \ ]\n\ \ ]\n]; \n\n
    plantLSystem[r1_, r2_, a0_, a2_, d_, wr_]\  := \ 
      LSystem[\n\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ 
        plantAxiom[], \n\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ 
        plantRules[r1, r2, a0, a2, d, wr]]; \n\nplantSkipPatterns\  = \ {}; 
    \)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  ButtonBox["Example",
    ButtonData:>"Example A",
    ButtonStyle->"Hyperlink"],
  " (a)"
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  ButtonBox["Parameters",
    ButtonData:>"Example A: parameters",
    ButtonStyle->"Hyperlink"],
  " and L-system interpretation"
}], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"Example A"],

Cell["\<\
r1 = 0.9;   (* contraction ratio for the trunk  *)
r2 = 0.6;   (* contraction ratio for branches   *)

a0 = 45;    (* branching angle from the trunk   *)
a2 = 45;    (* branching angle for lateral axes *)

d  = 137.5; (* divergence angle                 *)
wr = 0.707; (* width decrease rate              *)\
\>", "Input",
  AspectRatioFixed->True,
  CellTags->"Example A: parameters"]
}, Closed]],

Cell[CellGroupData[{

Cell["L-system and turtle interpretation", "Subsubsection"],

Cell[TextData[
"plants = runKLSystem[\n            plantLSystem[r1,r2,a0,a2,d,wr],9,\n       \
     SkipPatterns -> plantSkipPatterns];"], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  "Map[\n    turtleInterpretation[#,\n      StartDirection -> \
Transpose[{{0,0,1},{1,0,0},{0,-1,0}}],\n      MaxNumberOfPaths -> 4000,\n     \
 LineThickness -> 0.05,\n      LineHue -> 0.9,\n      GraphicOptions ->\n     \
 {\n        AspectRatio -> Automatic,\n\t      Axes -> False,\n\t      Boxed \
-> True, BoxStyle -> GrayLevel[1],\n\t      ViewPoint -> {-3.6,-0.8,1.5},\n\t \
     FaceGrids -> {{0,0,-1}},\n\t      PlotRange -> All,\n\t      Background \
-> GrayLevel[0.9],",
  StyleBox["\n    ",
    FontFamily->"Times"],
  "      DisplayFunction -> $DisplayFunction\n      }]&,Drop[plants,1]\n  ];"
}], "Input",
  AspectRatioFixed->True],

Cell[TextData[
"Starting turtle interpretation ...\nTime needed: 0.0333333 Second\n\
Generating graphics ...\nStarting turtle interpretation ...\nTime needed: \
0.133333 Second\nGenerating graphics ...\nStarting turtle interpretation ...\n\
Time needed: 0.266667 Second\nGenerating graphics ...\nStarting turtle \
interpretation ...\nTime needed: 0.566667 Second\nGenerating graphics ...\n\
Starting turtle interpretation ...\nTime needed: 1.23333 Second\nGenerating \
graphics ...\nStarting turtle interpretation ...\nTime needed: 2.41667 Second\
\nGenerating graphics ...\nStarting turtle interpretation ...\nTime needed: \
4.86667 Second\nGenerating graphics ...\nStarting turtle interpretation ...\n\
Time needed: 10.3 Second\nGenerating graphics ...\nStarting turtle \
interpretation ...\nTime needed: 20.15 Second\nGenerating graphics ..."], 
  "Print",
  Evaluatable->False,
  CellOpen->False,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Graphics", "Subsubsection"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.09277 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0217706 1.13101 0.0282753 1.13101 [
[ 0 0 0 0 ]
[ 1 1.09277 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.09277 L
0 1.09277 L
closepath
clip
newpath
p
1 g
.002 w
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
.07914 .12169 m
.85581 .02828 L
s
.93606 .38326 m
.3047 .44368 L
s
.3047 .44368 m
.28397 1.06449 L
s
.28397 1.06449 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.93606 .38326 m
.85581 .02828 L
s
.07914 .12169 m
.3047 .44368 L
s
.3047 .44368 m
.28397 1.06449 L
s
.28397 1.06449 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
p
.4 g
.85819 .03878 m
.08575 .13112 L
s
P
p
.4 g
.88047 .13735 m
.14794 .2199 L
s
P
p
.4 g
.90039 .22549 m
.20386 .29973 L
s
P
p
.4 g
.91832 .30477 m
.25442 .3719 L
s
P
p
.4 g
.93452 .37646 m
.30034 .43745 L
s
P
p
.4 g
.83632 .03062 m
.92038 .38476 L
s
P
p
.4 g
.64418 .05373 m
.76534 .39959 L
s
P
p
.4 g
.45698 .07625 m
.61352 .41412 L
s
P
p
.4 g
.27454 .09819 m
.4648 .42836 L
s
P
p
.4 g
.09668 .11958 m
.31911 .4423 L
s
P
P
p
1 0 .6 r
.02 w
.54374 .27855 m
.54374 .93876 L
s
P
p
1 g
.05 w
.54374 .27855 Mdot
P
p
1 g
.002 w
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
.07914 .12169 m
.85581 .02828 L
s
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.93606 .38326 m
.85581 .02828 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 337}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.705172,
  AnimationCycleOffset->1,
  AnimationCycleRepetitions->Infinity,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/QP00`40o`000?l0003oXoooo`000:;X
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>@1oooo002Ri>CT0Oooo`000:;Xj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo002Ri>CT0Oooo`0008KXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@5oooo01OTi>CXj>STi>CXj>STi>CXj>STi>CXj>ST
i>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@00Oooo`00ONCTi0Woool0
1NCTi6IVI^CTi>CTi?ooo`0Gi>CT0Oooo`0007GXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>P02?ooo`0:i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX0fIV
IP0HooooIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CT0Oooo`00KNCTi0Soool9i>CT2FIVIP03i>CTIVIVi>CT00;ooolFi>CT0Ooo
o`0006CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>@9oooo00WTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@026IVIP0<j>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTIVIVi>CT0_ooo`0Fj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT0Oooo`00G>CTi0Soool4i>CT00=VIVKTi>CT
i>@00nCTi0QVIVHBi>CT00AVIVKTi>CooooooolFi>CT0Oooo`0005?Xj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>P02Oooo`09j>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX00UVIVH07>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi6IVI^CTi0;oool0
5^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi07oool004_Ti>@8oooo2^CTi0QVIVH4i>CT00=VIVKTi>CTi>@07NCTi003IVIVoooooooo
01KTi>@1oooo0000@nSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj008oooo00WTi>CXj>STi>CXj>STi>CXj>ST
i>CXj>STi>@02FIVIP15i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXIVIVj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXIVIVooooi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT007oool003[Ti>@9oooo1nCT
i003IVIVi>CTIVIV00MVIVHFi>CT00=VIVKTi>CTi>@07>CTi004IVIVooooi>CToooo5NCTi07oool0
000bj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT2?ooo`0:j>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CT26IVIP1Fj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTIVIVi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXIVIVooooi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT0Oooo`00:NCTi0Woool9i>CT2FIVIPOTi>@0
0fIVI^CTi>CTi00Li>CT00=VIVKTi>CTi>@07NCTi003ooooi>CToooo01GTi>@1oooo00008NSXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj008oooo00[Ti>CXj>STi>AVIVKTi>CXj>ST
i>CXj>STi>CXj>P8IVIV06OTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>ST
i>CXj>STi>AVIVKTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>ST
i>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>QVIVKXj>STi>CXj>STi>CXj>ST
i>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>ST
i>CXj>STi>CXj>STi>AVIVKooooXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>ST
i>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@00Oooo`006NCTi0Soool9i>CT2FIVIQWTi>@00fIVI^CT
i>CTi00Li>CT00=VIVKTi>CTi>@07>CTi004IVIVooooi>CToooo5>CTi07oool0000@j>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT2Oooo`09i>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CT00QVIVH0N>SXj>CTi>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi6IVI_ooonSXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi07oool000cTi>@4oooo2^CTi0QVIVH<i>CT00=VIVKTi>CTi>@07>CT
i003IVIVi>CTi>CT01cTi>@00fIVI^CTi>CTi00Li>CT00?ooooTi>Coool05>CTi07oool0000Aj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SXIVIVj>SX00UVIVH0R>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj6IV
I^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i6IVI^CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj?ooonSXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi07oool000cTi>@00oooofIV
IVIVIP02IVIV7^CTi003IVIVi>CTi>CT01cTi>@00fIVI^CTi>CTi00Ki>CT00=VIVKTi>CTi>@07>CT
i004ooooi>CTi>CToooo4nCTi07oool00029j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTooooi>CTooooi>CTj>SXIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTIVIVi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXIVIVj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SX009VIVH05oooofIVIVIVI_ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi001oooo000<i>CT00?ooooTi>Coool00^CT
i003IVIVi>CTi>CT01cTi>@00fIVI^CTi>CTi00Li>CT00=VIVKTi>CTi>@06nCTi003IVIVi>CTi>CT
013Ti>@9IVIV0^CTi004ooooi>CTi>CToooo4nCTi07oool0001gj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTooooi>CTj>SXooooj>SXi>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX00UVIVH08^SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj?ooofIVI^CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi07oool000cTi>@01OooonCTi>CTi>CTi?ooo`02i>CT00=V
IVKTi>CTi>@06nCTi003IVIVi>CTi>CT01cTi>@00fIVI^CTi>CTi00Ki>CT2FIVIQCTi>@01OooofIV
I^CTi>CTi?ooo`0Bi>CT0Oooo`0006GXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>Co
oooTi>CXj>STi>CXj>SooooXj>STi>AVIVKTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>AVIVKTi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>AVIVKTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>P02VIVIP0ci>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXoooo
IVIVi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CT007oool000cTi>@00oooonCTi>CTi002i>CT00CooooTi>CTi>AVIVHNi>CT00=VIVKTi>CT
i>@06nCTi003IVIVi>CTi>CT00STi>@9IVIV2NCTi003IVIVi>CTi>CT01[Ti>@01OooofIVI^CTi>CT
i?ooo`0Bi>CT0Oooo`00057Xj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CX
j>STi>CXj>STi>CooooTi>CXj>QVIVKXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>QVIVKXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>P02fIVIP16j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXIVIVj>SX
ooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT0Ooo
o`002nCTi003ooooi>CTi>CT00GTi>@01?ooonCTi>CTi6IVIQgTi>@00fIVI^CTi>CTi00Bi>CT2VIV
IQcTi>@00fIVI^CTi>CTi00Ii>CT00GooooTi>AVIVKTi>Coool04^CTi07oool00010j>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTIVIV
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CT2FIVIP1Ii>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXIVIVj>SXi>CTooooi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT007oool000_Ti>@00oooonCTi>CTi006
i>CT00CooooTi>CTi>AVIVHMi>CT00=VIVKTi>AVIVH026IVIQ;Ti>@00fIVI^CTi>CTi00Ki>CT00=V
IVKTi>CTi>@06>CTi003ooooi>CTIVIV00;Ti>@00oooonCTi>CTi00?i>CT0Oooo`0002kXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooX
j>STi>AVIVKTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>@9IVIV06_Ti>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>ST
i>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>QVIVKXj>STi>CXj>STi>CXj>ST
i>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>ST
i>CXj>STi>AVIVKTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>ST
i>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>AVIVKTi>CooooTi>CXj>STi>CXj>ST
i>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@00Oooo`002nCTi003ooooi>CTi>CT
00STi>@00oooonCTi6IVIP0<i>CT2FIVIPSTi>@00fIVI^CTi>CTi00Ji>CT00=VIVKTi>CTi>@06^CT
i003IVIVi>CTi>CT01STi>@01_ooonCTi>CTi6IVI^CTi?oooa7Ti>@1oooo00007>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCT
i>SXj6IVI^SXj>CTi0UVIVH0ONCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi6IVI^CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi6IVI^CTi>SXj?ooonSXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi001oooo000;i>CT00?ooooTi>CTi>@02NCT
i0EVIVHKi>CT00=VIVKTi>CTi>@06^CTi003IVIVi>CTi>CT01[Ti>@00fIVI^CTi>CTi00Gi>CT00Co
oooTi>CTi>AVIVH2i>CT00?ooooTi>CTi>@03^CTi07oool0002<j>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTIVIV
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXIVIVj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXoooo1FIVIP0Aooooj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT007oool000_Ti>@00oooonCTi>CTi00:
i>CT00CooooTi>CTi>AVIVHLi>CT00=VIVKTi>CTi>@06^CTi003IVIVi>CTi>CT01[Ti>@00fIVI^CT
i>CTi00>i>CT2FIVIP06ooooi>CTi>CTIVIVi>CToooo4>CTi07oool0001jj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
ooooj>SXi>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CT2FIVIP0Oi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SXIVIVj>SXi>CTooooi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT007oool000_Ti>@00oooonCTi>CTi00<i>CT00Co
oooTi>CTi>AVIVHKi>CT00=VIVKTi>CTi>@06^CTi003IVIVi>CTi>CT01OTi>@:IVIV4^CTi004oooo
i>CTi>CTIVIV0^CTi003ooooi>CTi>CT00gTi>@1oooo0000InSXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?oo
onSXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi6IVI^CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj6IV
I^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj009IVIV03;Xj>STi>CX
j>QVIVKXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>AVIVKTi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo000;i>CT00?ooooTi>CTi>@03NCTi004ooooi>CTi>CT
IVIV7>CTi003IVIVi>CTi>CT01STi>@4oooo1>CTi0UVIVH<i>CT00=VIVKTi>CTi>@05^CTi007oooo
i>CTi>CTi>CTIVIVi>CToooo00oTi>@1oooo0000ENSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCT
i>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi6IVIP06oooo0fIVIP14j>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
IVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTIVIVi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CT0Oooo`002^CTi003ooooi>CTi>CT013Ti>@00oooonCTi6IVIP0L
i>CT00=VIVKTi>CTi>@03>CTi0UVIVH8oooo6>CTi003IVIVi>CTi>CT01GTi>@01OooonCTi>CTi>CT
i6IVIP02i>CT00?ooooTi>CTi>@03>CTi07oool00012j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
ooooj>SXi>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTIVIVi>CTj>SXi>CTj>SXi>CT2FIVIP09i>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT00Soool0A^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi6IVI^CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCT
i>SXj>CTi>SXj6IVI^SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i07oool000[Ti>@00oooonCTi>CTi00Ai>CT00CooooTi>CTi>AVIVHFi>CT2VIVIQ;Ti>@8oooo6>CT
i003IVIVi>CTi>CT01GTi>@00oooonCTi>CTi002i>CT00=VIVKTi>Coool03^CTi07oool0000_j>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SX00UVIVH07>SXj>CTi>SXj>CTi>SXj>CTi6IVI^CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi0Soool0A^SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj6IVI^SXj?ooonSXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi07oool000[Ti>@00oooonCTi>CTi00Ci>CT00?ooooTi>AV
IVH00nCTi0UVIVH?i>CT00=VIVKTi>CTi>@05>CTi0KooolJi>CT00=VIVKTi>CTi>@05>CTi003oooo
i>CTi>CT00;Ti>@016IVI^CTi>CTi?ooo`gTi>@1oooo00008NSXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi?ooo`05IVIV033Xj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>QVIVKXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@4oooo04QVIVKTi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>QVIVKXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>AVIVKTi>CooooTi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo000:i>CT00?ooooTi>CTi>@05>CTi003oooo
i>CTIVIV01_Ti>@00fIVI^CTi>CTi00Ei>CT00Gb28Co0?ob28CTi>AVIVH06^CTi003IVIVi>CTi>CT
01?Ti>@00oooonCTi>CTi005IVIV00?ooooTi>CTi>@02nCTi07oool0001Gj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTIVIV
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SX00?b28@0:nSXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi6IVI^CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj007IVIV01KooomVIVIVIVKTi>CXj>STi>AVIVKTi>CooooTi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo000:i>CT00?ooooTi>CTi>@05NCT
i004ooooi>CTi>CTIVIV6^CTi003IVIVi>CTi>CT01CTi>@00o88Q?l0oo88Q002i>CT00=VIVKTi>CT
i>@05nCTi003IVIVi>CTi>CT00?Ti>@9IVIV1nCTi003ooooi>CTi>CT00?Ti>@00fIVI^CTi?ooo`0=
i>CT0Oooo`0005OXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooX
j>STi>AVIVKTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>QVIVKXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>P00o88Q00Hj>SXi>CTIVIVi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT2VIVIP0Vj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTj>SX
i>CTIVIVi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT0Oooo`002^CT
i003ooooi>CTi>CT01OTi>@00oooonCTi6IVIP0Ki>CT00=VIVKTi>CTi>@04^CTi003lPR4o`3olPR4
00;Ti>@00fIVI^CTi>CTi009i>CT2VIVIPGTi>@00fIVI^CTi>CTi00Bi>CT00?ooooTi>CTi>@01>CT
i003IVIVi>CToooo00cTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj?ooonSXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi6IVI^CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR400?Xj>STi>CX
j>P02fIVIP0jj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXIVIVj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CToooo
i>CTj>SXi>CTj>SXi>CTj>SXIVIVj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CT0Oooo`002^CTi003ooooi>CTi>CT01STi>@01?ooonCTi>CTi6IVIQ[Ti>@00fIVI^CTi>CTi00?
i>CT0VIVIP03lPR4o`3olPR400AVIVHJi>CT00=VIVKTi>CTi>@04NCTi003ooooi>CTi>CT00CTi>@0
0fIVI^CTi?ooo`0<i>CT0Oooo`0004_Xj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CooooTi>AVIVKTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>QVIVKXj>STi>CXj>STi>CX
j>STi>CXj>P02VIVIP03i>CTj>SXlPR400;b28@0B>SXj>CTi>SXj>CTi6IVI^CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i6IVI^CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i?ooonCTi>SXj>CTi>SXj>CTi>SXj6IVI^SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi07oool000[Ti>@00oooonCTi>CTi00Ji>CT00?ooooTi>AVIVH05nCTi0YVIVH<i>CT00?b
28Co0?ob28@01>CTi003IVIVi>CTi>CT01OTi>@00fIVI^CTi>CTi00Ai>CT00?ooooTi>CTi>@01NCT
i003IVIVi>CToooo00_Ti>@1oooo0000>>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi6IVI^CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi0UVIVH05^CTi>SXj>CTi6IVI^CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj0?b28@0B>SXj>CTi>SXj>CTi>SXj6IVI^SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi6IVI^CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi07oool000WTi>@00oooonCTi>CTi00Li>CT00?ooooTi>AVIVH00nCTi0YVIVH=i>CT00=V
IVKTi>CTi>@03nCTi003lPR4o`3olPR400GTi>@00fIVI^CTi>CTi00Gi>CT00=VIVKTi>CTi>@04NCT
i003ooooi>CTi>CT00CTi>@00fIVI^CTi?ooo`0;i>CT0Oooo`0002WXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>P01FIVIP0Yj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTIVIVi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX00?b28@0
>>SXj>CTi>SXj>CTi>SXj>CTi6IVI^CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj6IVI^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi0AVIVH03?ooofIV
I^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi07oool000WTi>@00oooonCTi>CTi00Ni>CT00?o
oooTi>AVIVH06NCTi003IVIVi>CTi>CT00kTi>@00o88Q?l0oo88Q006i>CT00=VIVKTi>CTi>@05nCT
i003IVIVi>CTi>CT00_Ti>@5IVIV00?ooomVIVIVIVH00VIVIP?Ti>@00fIVI^CTi?ooo`0:i>CT0Ooo
o`0005OXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CooooTi>AVIVKTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>QVIVKXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>P00o88Q00Sj>SXi>CTj>SXi>CTj>SXi>CTj>SXIVIVj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTIVIVi>CTj>SX00]VIVH02NSXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj004oooo00eV
IVKooooooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@00Oooo`002NCTi003ooooi>CTi>CT
01oTi>@00oooonCTi6IVIP0Ii>CT00=VIVKTi>CTi>@03NCTi003lPR4o`3olPR400OTi>@00fIVI^CT
i>CTi00?i>CT2VIVIPWTi>@;oooo1^CTi003ooooi>CTi>CT00STi>@1oooo0000EnSXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i?ooonCTi6IVI^CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi6IVI^CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj003lPR400oXj>STi>CXj>STi>CXj>STi>CXj>QVIVKXj>STi>CXj>STi>CXj>STi>CX
j>P02VIVIP09i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXIVIV00[oool07>SXj>CTi>SXj>CTi>SXj>CT
i>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi07oool000WTi>@00oooonCTi>CTi00Pi>CT00CooooTi>CTi>AVIVHHi>CT00=VIVKTi>CT
i>@03>CTi003lPR4o`3olPR400CTi>@;IVIV1^CTi0cooolBi>CT00?ooooTi>CTi>@01nCTi003oooo
i>CTi>CT00STi>@1oooo0000E>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj6IVI^SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj6IV
I^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi0=VIVH3lPR416IVIP06j>SXi>CTj>SXi>CTIVIV
i>CT2oooo`0ci>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT007oool000WTi>@00oooonCT
i>CTi00Ri>CT00?ooooTi>AVIVH06NCTi0YVIVH3i>CT00?b28Co0?ob28@02Oooo`03IVIVi>CTi>CT
02OTi>@00oooonCTi>CTi007i>CT00?ooooTi>CTi>@02>CTi07oool0000oj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXooooj>SXIVIVj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX00aVIVH0
0nCTi>SXj?ooo`09oooo0o88Q018j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT0Ooo
o`002NCTi003ooooi>CTi>CT02?Ti>@00oooonCTi6IVIP03i>CT2VIVIP?Ti>@9oooo00=VIVKooooT
i>@02NCTi003lPR4o`3olPR403?Ti>@00oooonCTi>CTi007i>CT00?ooooTi>CTi>@02>CTi07oool0
000`j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT1FIVIP03i>CTj>SXoooo00[oool05NSXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0009i>CT00?ooooTi>CTi>@09NCT
i0;oool016IVI_ooooooooooob3Ti>@00o88Q?l0oo88Q00ci>CT00?ooooTi>CTi>@01nCTi003oooo
i>CTi>CT00STi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0008i>CT00?ooooTi>CTi>@09^CTi003ooooi>CTi>CT
02?Ti>@00o88Q?l0oo88Q00ci>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT00OTi>@1oooo0000
EnSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>@1oooo0008i>CT00?ooooTi>CTi>@09^CTi003ooooi>CTi>CT02?Ti>@00o88Q?l0oo88Q00c
i>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT00OTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0008i>CT00?o
oooTi>CTi>@09^CTi003ooooi>CTi>CT02?Ti>@00o88Q?l0oo88Q00ci>CT00?ooooTi>CTi>@02>CT
i003ooooi>CTi>CT00OTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>Co
oooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0008i>CT00?ooooTi>CTi>@09^CTi003oooo
i>CTi>CT02?Ti>@00o88Q?l0oo88Q00di>CT00?ooooTi>CTi>@01nCTi003ooooi>CTi>CT00OTi>@1
oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>@1oooo0008i>CT00?ooooTi>CTi>@09^CTi003ooooi>CTi>CT02?Ti>@00o88Q?l0
oo88Q00di>CT00?ooooTi>CTi>@01nCTi003ooooi>CTi>CT00OTi>@1oooo0000EnSXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0008
i>CT00?ooooTi>CTi>@09^CTi003ooooi>CTi>CT02?Ti>@00o88Q?l0oo88Q00di>CT00?ooooTi>CT
i>@01nCTi003ooooi>CTi>CT00OTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?oo
onSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0008i>CT00?ooooTi>CTi>@09^CT
i003ooooi>CTi>CT02?Ti>@00o88Q?l0oo88Q00di>CT00?ooooTi>CTi>@01nCTi003ooooi>CTi>CT
00OTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>@1oooo0008i>CT00?ooooTi>CTi>@09^CTi003ooooi>CTi>CT02?Ti>@0
0o88Q?l0oo88Q00di>CT00?ooooTi>CTi>@01nCTi003ooooi>CTi>CT00OTi>@1oooo0000EnSXj>CT
i>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>Co
oooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@1
oooo0007i>CT00?ooooTi>CTi>@09^CTi003ooooi>CTi>CT02CTi>@00o88Q?l0oo88Q00di>CT00?o
oooTi>CTi>@02>CTi003ooooi>CTi>CT00KTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi>SXj?oo
onSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003
lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0007i>CT00?ooooTi>CT
i>@09^CTi003ooooi>CTi>CT02CTi>@00o88Q?l0oo88Q00di>CT00?ooooTi>CTi>@02>CTi003oooo
i>CTi>CT00KTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooX
j>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0007i>CT00?ooooTi>CTi>@09^CTi003ooooi>CTi>CT
02CTi>@00o88Q?l0oo88Q00di>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT00KTi>@1oooo0000
EnSXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CX
j>STi>@1oooo0007i>CT00?ooooTi>CTi>@09^CTi003ooooi>CTi>CT02CTi>@00o88Q?l0oo88Q00d
i>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT00KTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CT
i>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0007i>CT00?o
oooTi>CTi>@09^CTi003ooooi>CTi>CT02CTi>@00o88Q?l0oo88Q00di>CT00?ooooTi>CTi>@02>CT
i003ooooi>CTi>CT00KTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0007i>CT00?ooooTi>CTi>@09^CTi003oooo
i>CTi>CT02CTi>@00o88Q?l0oo88Q00di>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT00KTi>@1
oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CX
j>STi>CXj>STi>@1oooo0007i>CT00?ooooTi>CTi>@09^CTi003ooooi>CTi>CT02CTi>@00o88Q?l0
oo88Q00ei>CT00?ooooTi>CTi>@01nCTi003ooooi>CTi>CT00KTi>@1oooo0000EnSXj>CTi>SXj>CT
i>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0006
i>CT00?ooooTi>CTi>@09nCTi003ooooi>CTi>CT02CTi>@00o88Q?l0oo88Q00ei>CT00?ooooTi>CT
i>@01nCTi003ooooi>CTi>CT00KTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0006i>CT00?ooooTi>CTi>@09nCT
i003ooooi>CTi>CT02CTi>@00o88Q?l0oo88Q00ei>CT00?ooooTi>CTi>@01nCTi003ooooi>CTi>CT
00KTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CX
j>STi>CXj>STi>CXj>STi>@1oooo0006i>CT00?ooooTi>CTi>@09nCTi003ooooi>CTi>CT02CTi>@0
0o88Q?l0oo88Q00ei>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT00GTi>@1oooo0000EnSXj>CT
i>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>@1
oooo0006i>CT00?ooooTi>CTi>@09nCTi003ooooi>CTi>CT02CTi>@00o88Q?l0oo88Q00ei>CT00?o
oooTi>CTi>@02>CTi003ooooi>CTi>CT00GTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi?ooonCT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003
lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>@1oooo0006i>CT00?ooooTi>CT
i>@09nCTi003ooooi>CTi>CT02CTi>@00o88Q?l0oo88Q00ei>CT00?ooooTi>CTi>@02>CTi003oooo
i>CTi>CT00GTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>Co
oooTi>CXj>STi>CXj>STi>CXj>STi>@1oooo0006i>CT00?ooooTi>CTi>@09nCTi003ooooi>CTi>CT
02CTi>@00o88Q?l0oo88Q00ei>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT00GTi>@1oooo0000
EnSXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CX
j>STi>@1oooo0006i>CT00?ooooTi>CTi>@09nCTi003ooooi>CTi>CT02CTi>@00o88Q?l0oo88Q00e
i>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT00GTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj>CT
i?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>@1oooo0006i>CT00?o
oooTi>CTi>@09nCTi003ooooi>CTi>CT02CTi>@00o88Q?l0oo88Q00ei>CT00?ooooTi>CTi>@02>CT
i003ooooi>CTi>CT00GTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>@1oooo0005i>CT00?ooooTi>CTi>@0:>CTi003oooo
i>CTi>CT02CTi>@00o88Q?l0oo88Q00ei>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT00GTi>@1
oooo0000EnSXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CX
j>STi>CXj>STi>@1oooo0005i>CT00?ooooTi>CTi>@0:>CTi003ooooi>CTi>CT02CTi>@00o88Q?l0
oo88Q00fi>CT00?ooooTi>CTi>@01nCTi003ooooi>CTi>CT00GTi>@1oooo0000EnSXj>CTi>SXj>CT
i>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>Co
oooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>@1oooo0005
i>CT00?ooooTi>CTi>@09nCTi003ooooi>CTi>CT02GTi>@00o88Q?l0oo88Q00fi>CT00?ooooTi>CT
i>@01nCTi003ooooi>CTi>CT00GTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>@1oooo0005i>CT00?ooooTi>CTi>@09nCT
i003ooooi>CTi>CT02GTi>@00o88Q?l0oo88Q00fi>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT
00CTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooX
j>STi>CXj>STi>CXj>STi>@1oooo0005i>CT00?ooooTi>CTi>@09nCTi003ooooi>CTi>CT02GTi>@0
0o88Q?l0oo88Q00fi>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT00CTi>@1oooo0000EnSXj>CT
i>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj003lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>@1
oooo0005i>CT00?ooooTi>CTi>@09nCTi003ooooi>CTi>CT02GTi>@00o88Q?l0oo88Q00fi>CT00?o
oooTi>CTi>@02>CTi003ooooi>CTi>CT00CTi>@1oooo0000EnSXj>CTi>SXj>CTi>SXj?ooonSXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?oo
onSXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj003
lPR404SXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CooooTi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>@1oooo0005i>CT00?ooooTi>CT
i>@09nCTi003ooooi>CTi>CT02GTi>@00o88Q?l0oo88Q00^i>CT2Oooo`[Ti>@00oooonCTi>CTi004
i>CT0Oooo`0005OXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>P00o88Q00Oj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SX00ooool06^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi07oool000CTi>@00oooonCTi>CTi00X
i>CT00?ooooTi>CTi>@09NCTi003lPR4o`3olPR400oTi>@@oooo6>CTi003ooooi>CTi>CT00OTi>@0
0oooonCTi>CTi004i>CT0Oooo`0005OXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>P00o88Q0ooool0>NCTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi001oooo0004i>CT00?o
oooTi>CTi>@0:>CTi003ooooi>CTi>CT01STi>@@oooo=nCTi003ooooi>CTi>CT00OTi>@00oooonCT
i>CTi004i>CT0Oooo`0003[Xj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>@@oooo00gXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>P00o88
Q018j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CT0Oooo`001>CTi003ooooi>CTi>CT
02CTi>@?oooo7NCTi003lPR4o`3olPR403STi>@00oooonCTi>CTi006i>CT00?ooooTi>CTi>@01>CT
i07oool0000Kj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX013oool0;>CTi>SXj>CTi>SXj?ooonSXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj0?b28@0B>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi07oool000CTi>@00oooonCTi>CTi005i>CT3ooo
oaCTi>@00oooonCTi>CTi00Ui>CT00?b28Co0?ob28@0>NCTi003ooooi>CTi>CT00GTi>@00oooonCT
i>CTi004i>CT0Oooo`0000CXj>STi>CXj>STi>@8oooo04_Xj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>P00o88Q018j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SX
i>CT0Oooo`001^CTi003ooooi>CTi>CT02KTi>@00oooonCTi>CTi00Ui>CT00?b28Co0?ob28@0>^CT
i003ooooi>CTi>CT00GTi>@00oooonCTi>CTi003i>CT0Oooo`0005OXj>STi>CXj>STi>CXj>STi>CX
j>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>SooooXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>P00o88Q018j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTj>SXi>CT0Oooo`002>CTi0;ooolU
i>CT00?ooooTi>CTi>@09NCTi003lPR4o`3olPR403[Ti>@00oooonCTi>CTi005i>CT00?ooooTi>CT
i>@00nCTi07oool0001Gj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX00?b28@0B>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CT
i?ooonCTi>SXj>CTi>SXj>CTi07oool000_Ti>@00oooonCTi>CTi00Qi>CT00?ooooTi>CTi>@09NCT
i003lPR4o`3olPR403_Ti>@00oooonCTi>CTi004i>CT00?ooooTi>CTi>@00nCTi07oool0000<j>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT0_ooo`19j>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SX00?b28@0B>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CT
i07oool000kTi>@00oooonCTi>CTi00Ni>CT00?ooooTi>CTi>@09NCTi003lPR4o`3olPR403cTi>@0
0oooonCTi>CTi003i>CT00?ooooTi>CTi>@00nCTi07oool0001Gj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
ooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
00?b28@0B>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi07oool0013Ti>@00oooonCT
i>CTi00Li>CT00?ooooTi>CTi>@09NCTi003lPR4o`3olPR403gTi>@00oooonCTi>CTi002i>CT00?o
oooTi>CTi>@00nCTi07oool0000Aj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SX00;oool0A>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj0?b28@0B>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj?ooonSXj>CT
i>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi07oool001?Ti>@00oooonCTi>CTi00Ii>CT00?ooooTi>CT
i>@09NCTi003lPR4o`3olPR403gTi>@00oooonCTi>CTi002i>CT00?ooooTi>CTi>@00nCTi07oool0
001Gj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX00?b28@0B>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi?ooonCTi>SXj>CT
i>SXj>CTi07oool001GTi>@2oooo6>CTi003ooooi>CTi>CT02GTi>@00o88Q?l0oo88Q00ni>CT00Go
oooTi>CTi>CTi>Coool01NCTi07oool0002Rj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTooooi>CTj>SXi>CTooooi>CTj>SXi>CTj>SXi>CT0Oooo`006>CTi003ooooi>CTi>CT01CTi>@0
0oooonCTi>CTi01Wi>CT00CooooTi>CTi>Coool5i>CT0Oooo`0001WXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>P00_oo
o`27i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
ooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTooooi>CTj>SXi>CTj>SXi>CT007oool001_Ti>@0
0oooonCTi>CTi00@i>CT00?ooooTi>CTi>@0J>CTi004ooooi>CTi>CToooo1NCTi07oool0002Rj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SXooooj>SXi>CTj>SX
i>CT0Oooo`007NCTi0;oool?i>CT00?ooooTi>CTi>@0JNCTi004ooooi>CTi>CToooo1>CTi07oool0
002Rj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXooooj>SXooooj>SX
i>CTj>SXi>CT0Oooo`008>CTi003ooooi>CTi>CT00_Ti>@00oooonCTi>CTi01Zi>CT00?ooooTi>Co
ool01>CTi07oool0000Qj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX00;oool0
OnCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j?ooonSXj?ooonSXj>CTi>SXj>CTi001oooo000Si>CT00?ooooTi>CTi>@02>CTi003ooooi>CTi>CT
06_Ti>@2oooo1>CTi07oool0002Lj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CT0_ooo`04j>SXi>CTj>SXi>CT0Oooo`009NCTi003ooooi>CTi>CT00KTi>@00oooonCT
i>CTi01[i>CT0_ooo`CTi>@1oooo00009^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi0;oool0K>SXj>CTi>SXj>CTi>SXj>CTi?ooonCTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi0[oool01>SXj>CT
i>SXj>CTi07oool002STi>@00oooonCTi>CTi003i>CT00?ooooTi>CTi>@0D>CTi1?oool>i>CT0Ooo
o`0006oXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>SooooXj>STi>CXj>STi>CooooTi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>P04_ooo`0Qi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT
j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT007oool002[Ti>@2oooo0^CTi003ooooi>CTi>CT02_Ti>@C
oooo<nCTi07oool0001:j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTooooi>CTooooi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT4_oo
o`16j>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SX
i>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CTj>SXi>CT0Oooo`00;NCTi0;oool8i>CT4ooooeSTi>@1
oooo0000;^SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CT
i>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi0Woool0JnCTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SX
j>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi>SXj>CTi001oooo002R
i>CT0Oooo`000:;Xj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>@1oooo002Ri>CT0Oooo`000:;Xj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CX
j>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>CXj>STi>@1oooo0000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0191726, -0.0250049, \
0.00545875, 0.00545875}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 2.93441 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.897014 2.84278 0.0710694 2.84278 [
[ 0 0 0 0 ]
[ 1 2.93441 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 2.93441 L
0 2.93441 L
closepath
clip
newpath
p
1 g
.002 w
.65401 .07107 m
.66784 2.47992 L
s
.66784 2.47992 m
.07107 2.51735 L
s
.07107 2.51735 m
.11426 .13227 L
s
.11426 .13227 m
.65401 .07107 L
s
.89417 .65637 m
.40997 .70506 L
s
.40997 .70506 m
.39934 2.86334 L
s
.39934 2.86334 m
.92893 2.83423 L
s
.92893 2.83423 m
.89417 .65637 L
s
.65401 .07107 m
.66784 2.47992 L
s
.66784 2.47992 m
.92893 2.83423 L
s
.92893 2.83423 m
.89417 .65637 L
s
.89417 .65637 m
.65401 .07107 L
s
.11426 .13227 m
.40997 .70506 L
s
.40997 .70506 m
.39934 2.86334 L
s
.39934 2.86334 m
.07107 2.51735 L
s
.07107 2.51735 m
.11426 .13227 L
s
p
.4 g
.66041 .08666 m
.12213 .1475 L
s
P
p
.4 g
.72239 .23771 m
.19838 .29521 L
s
P
p
.4 g
.78098 .38051 m
.27051 .43492 L
s
P
p
.4 g
.83646 .51571 m
.33885 .56728 L
s
P
p
.4 g
.88906 .64391 m
.40367 .69286 L
s
P
p
.4 g
.64102 .07254 m
.88253 .65754 L
s
P
p
.4 g
.51885 .08639 m
.77303 .66855 L
s
P
p
.4 g
.3973 .10018 m
.66403 .67951 L
s
P
p
.4 g
.27638 .11389 m
.55553 .69042 L
s
P
p
.4 g
.15607 .12753 m
.44752 .70129 L
s
P
P
p
1 0 .6 r
.02 w
.76923 .43144 m
.78094 1.52836 L
s
P
p
1 g
.05 w
.76923 .43144 Mdot
P
p
1 0 .6 r
.01414 w
.78094 1.52836 m
.79247 2.60929 L
s
P
p
1 0 .6 r
.01414 w
.78094 1.52836 m
.26536 2.06363 L
s
P
p
1 g
.002 w
.65401 .07107 m
.66784 2.47992 L
s
.66784 2.47992 m
.07107 2.51735 L
s
.07107 2.51735 m
.11426 .13227 L
s
.11426 .13227 m
.65401 .07107 L
s
.65401 .07107 m
.66784 2.47992 L
s
.66784 2.47992 m
.92893 2.83423 L
s
.92893 2.83423 m
.89417 .65637 L
s
.89417 .65637 m
.65401 .07107 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 337}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.705172,
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000EMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H01P00AlKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001:aP/01L@00`36aP15aP400000?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0;00_400G6e/KFaP020016e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000iaPH03<@8aP03a<K600C60P16aP400000>]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP05a00Ka]K6e/K4a]K6e/KFa=K6e/KFa]K4e/KF
a]K6008004KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0003W60P02aP03a<K600C600?4a/H01<H00lC6aP06aP03a<K600?6
00<0a000ALH1000003WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H00P00IlKFa=K6e/KFa]K4e/KFa]K6a<KFa]K6e/K4a]K6e/H0a036e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@0003W600<0aP000/H00lC6aP04aP03a<K600C600?4a/H01LH00lC6aP03aP040<K404C60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0
e/K4a]K6e/KFa/C6e/KFa]K4e/KFa]K6e/CFa]K60<K40=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003W600@0a/H00/H00lC6
aP04aP03a<K600C600?4a/H01LH00lC6aP02aP040<K604C60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60<KFa=K6e/KFa]K4e/KFa]K6
a<KFa]K6e/K4a]K40003a0140<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>LH01@36a/H000;600?4a/H01<H00lC6aP04aP_4
00?60<H00/H00`36aP11aP400000@mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0e/K4a]H03<@0DlKFa]K6e/KFa=K60<KFa/@0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000iaP030<K600;61L@5aP03a<K600C600?4a/H01LH01<C6aP03aP03a03604760@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K4
e/KFa]K6e/CFa]K6e/CFa]K6e/KFa=K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003W600<0a/H00lH01036a/@6aP03
a<K600C600?4a/H01LH00lC60004aP03a03604360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF0=K6a<KFa]K6e/K4a]K6e/K4a]K6
e/KFa/C60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0003W600<0a/H01<H01036a/@6aP03a<K600C600?4a/H01LH00l@0
aP04aP03a03603o60@00001Me/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/CFa]K6e/KFa=K6e/KFa=K6e/KFa]K40<KF00C40440e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP010000>LH00`36aP05aP040<K6a0K600?4a/H01<H01<C6a/H4a0030<C400C600<0a/H0?/H10000
04kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6eP3Fa/C6e/KFa]K6a<H8a01<e/KFaP36e/KFa]K40<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000iaP030<K600K600D0a/K4
aP07a0G600?4a/H01<H00`36aP03aP<0?lH1000004?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF00C401W6e/KFa/C6e/KFa]K4e/KF
a]K60<CFa]K600@003kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000iaP030<K600O600<0a/@01lH00lC6aP04aP03a<K600?600<0a<H0
0lH403k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/H0a/C6e/KFa]K4e/KFa]K6a<KFa]K60<K4a]K6eSoF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003W6
00<0a/H02<H00`36a007aP03a<K600C600?4a/H00/H00`36a004aP04?lK603g60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KF0=K4e/KFa]K6a<KFa]K6e/CFa]K60<KFa=K6eSoFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003W600<0a/H02LH00`36a007aP03
a<K600C600G4a/K60002aP05a<K6a3l00l@00`36aP0jaP400000E]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a/C6e/KFa]K4
e/KFa]K61<@00`34a003a012eSoFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003W600<0a/H02/H00`36a003aP_40lH01@36a/K400;6
00Doa/K6000laP400000AmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF00G405KFa]K6a<KFa]K6e/CFaP36e/K4a]Hoe/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000iaP030<K600_600<0a/@01lH00lC6aP03aP04a<K600C600?4aSl01<H00`36aP0iaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFaP36a<KFa]K6e/CFa]K6e/K4aP36e/KFa=Hoe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000iaP030<K600c600<0a/@0
1lH00lC6aP03aP03a<H000G600?4?lH01<H00`36aP0haP400000HmK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/CFa]K6
e/K4a]K6e/KFa036e/KFa/@oeP04a00k0<C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003W600<0a/H03LH00`36a007aP03a<K600?600?40<@0
1L@00co4000503W60@00001@e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a/C6e/H9a0P0044o0<KFa]K60<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000>LH00`36
aP0>aP030<C400?410000l@000020003aP3600G600<oa/H01<H00`36aP0gaP400000BmK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6eP02001Ea000e/KFa]K6e/KFaP36e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000>LH00`36aP0?aP030<K600c6
00<0a/H01<H00co6aP04aP030<K603O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
0<KFa]K6eSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0003S600<0a/H04<H00`36aP0<aP030<K600C600<oa/H01<H00`36aP0gaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP36e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000haP030<K60136
00<0a/H03<H00`36aP04aP03?lK600C600<0a/H0=lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/H0a]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000><H00`36aP0@aP030<K600c600<0a/H01<H00co6aP04aP03
0<K603O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6eSoFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003S6
00<0a/H04<H00`36aP0<aP030<K600C600<oa/H01<H00`36aP0gaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFaP36e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000haP030<K6013600<0a/H03<H00`36aP04aP03
?lK600C600<0a/H0=lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KF?mK6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000><H00`36aP0@aP030<K600c600<0a/H01<H00co6aP04aP030<K603O60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6eSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003S600<0a/H04<H00`36aP0<aP03
0<K600C600<oa/H01<H00`36aP0gaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP36
e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000haP030<K6013600<0a/H03<H00`36aP04aP03?lK600C600<0a/H0=lH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000><H00`36aP0@aP03
0<K600c600<0a/H01<H00co6aP04aP030<K603O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K60<KFa]K6eSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0003S600<0a/H04<H00`36aP0<aP030<K600C600<oa/H01<H00`36
aP0gaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP36e/KFa]Hoe/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000haP03
0<K6013600<0a/H03<H00`36aP04aP03?lK600C600<0a/H0=lH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/H0a]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000><H00`36aP0@aP030<K600c600<0a/H01<H00co6
aP04aP030<K603O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6eSoFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0003S600<0a/H04<H00`36aP0<aP030<K600C600<oa/H01<H00`36aP0gaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP36e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000haP030<K6013600<0a/H03<H00`36
aP04aP03?lK600C600<0a/H0=lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6
e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000><H00`36aP0@aP030<K600c600<0a/H01<H00co6aP05aP030<K603K60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003S600<0a/H04<H00`36
aP0<aP030<K600C600<oa/H01LH00`36aP0faP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFaP36e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000haP030<K6013600<0a/H03LH00`36aP03aP03?lK600G600<0a/H0
=/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000><H00`36
aP0@aP030<K600g600<0a/H00lH00co6aP05aP030<K603K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003S600<0a/H04<H00`36aP0=aP030<K600?600<oa/H0
1LH00`36aP0faP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]Hoe/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000haP030<K6013600<0a/H03LH00`36aP03aP03?lK600G600<0a/H0=/H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000><H00`36aP0@aP030<K600g600<0a/H0
0lH00co6aP05aP030<K603K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6
eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003S600<0a/H04<H00`36aP0=aP030<K600?600<oa/H01LH00`36aP0faP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000haP030<K6013600<0a/H0
3LH00`36aP03aP03?lK600G600<0a/H0=/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000><H00`36aP0@aP030<K600g600<0a/H00lH00co6aP05aP030<K603K6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003S600<0a/H0
4<H00`36aP0=aP030<K600?600<oa/H01LH00`36aP0faP400000H=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]H0e/KFaP8o043Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003S600<0a/H04<H00`36aP0=aP070<K6aSo6?`07aP03
0<K603K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3FaSo6eSoFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003S6
00<0a/H04<H00`36aP0=aP030<Ho00?600<oa/H01LH00`36aP0faP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]H0?lKFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000haP030<K6013600<0a/H03LH00`36aP03aP03
?lK600G600<0a/H0=/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/Ho0=K6e/KF?mK6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000><H00`36aP0@aP030<K600_600<oaP001LH00co6aP05aP030<K603K60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFaSo6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003S600<0a/H04<H00`36aP09aP05
?lK6aP001LH00co6aP05aP030<K603K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/Hoa]K6
eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0003S600<0a/H04<H00`36aP07aP03?lK600?600<0a/H00lH00co6aP05aP03
0<K603K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6?lKFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003S6
00<0a/H04<H00`36aP05aP03?lK600G600<0a/H00lH00co6aP05aP030<K603K60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFaSo6e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003S600<0a/H03lH00`36aP04aP03
?lK600O600<0a/H00lH00co6aP05aP030<K603K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/Hoa]K6
e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0003S600<0a/H03lH00`36aP02aP03?lK600W600<0a/H00lH00co6
aP05aP030<K603K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6?lKFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0003S600<0a/H03lH01036aSl=aP030<K600?600<oa/H01LH00`36aP0faP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K60<Hoa]K6e/KFa]K6e/KFa]H0e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000haP030<K600o600<0?lH03/H00`36
aP03aP03?lK600G600<0a/H0=/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KF0=K6
e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000=lH00`36aP0?aP03?`3600o600<0a/H00lH00co6aP05aP030<K603K60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6?lH0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003O600<0a/H03LH013o6
aP0@aP030<K600?600<oa/H01LH00`36aP0faP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/Hoa]K60<KFa]K6e/KFa]K6
e/KFa]H0e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000gaP030<K600_600<oa/H00/H00`36aP0>aP030<K600?600<oa/H0
1LH00`36aP0faP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6?lKFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFa]Hoe/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000gaP030<K600W600<oa/H01<H00`36aP0>aP030<K600?600<oa/H01LH00`36aP0faP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000gaP030<K6013600<0a/H0
3/H00`36aP04aP03ClK600C600<0a/H0=/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KF0=K6e/KFaSo6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000=lH00`36aP0@aP030<K600k600<0a/H01<H00do6aP04aP030<K603K6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/Hoa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003O600<0a/H0
4<H00`36aP0>aP030<K600C600=?a/H01<H00`36aP0faP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6?lKFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000gaP030<K6013600<0a/H03/H00`36aP04aP03ClK600C6
00<0a/H0=/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6e/KFaSo6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
=lH00`36aP0@aP030<K600k600<0a/H01<H00do6aP04aP030<K603K60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/Hoa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003O600<0a/H04<H00`36aP0>aP030<K600C6
00=?a/H01<H00`36aP0faP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
?lKFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000gaP030<K6013600<0a/H03/H00`36aP04aP03ClK600C600<0a/H0=/H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=lH00`36aP0@aP030<K600k6
00<0a/H01<H00do6aP05aP030<K603G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0003O600<0a/H04<H00`36aP0>aP030<K600C600=?a/H01LH00`36aP0eaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6?lKFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000gaP030<K60136
00<0a/H03/H00`36aP04aP03ClK600G600<0a/H0=LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KF0=K6e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=lH00`36aP0@aP030<K600k600<0a/H01<H00do6aP05aP03
0<K603G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/Hoa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003O6
00<0a/H04<H00`36aP0>aP030<K600C600=?a/H01LH00`36aP0eaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6?lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000gaP030<K6013600<0a/H01LH:00K600=?a/H0
1LH00`36aP0eaP400000@=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/HB001@e/KFa]K6e/KF0=K6e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=lH900[600<0a/H0
3lH00`36aP03aP03ClK600G600<0a/H0=LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]H0e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000><H00`36aP0?aP030<K6017600D0a/K6C`07aP030<K603G60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003[600<0a/H03LH00`36
aP0BaP040<K6C`O600<0a/H0=LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/H0aSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000?<H00`36aP0;aP030<K601?600<0aTl01lH00`36aP0eaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000naP030<K600W600<0a/H05LH00`36
aP05aP030<K603G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@00043600<0a/H01lH00`36aP0FaP030<K600C600<0a/H0=LH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000@LH00`36aP06aP030<K601S600<0a/H00/H00`36
aP0eaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP400013aP03
0<K600C600<0a/H06LH01@36a/H003O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0004G600<0a/H00/H00`36aP0KaP030<H003O60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0004O600@0a/H07/H203O60@00001Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000ga]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000BLH200O64010aP400000B]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K62000D=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@000001\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.019043, -0.0250051, 
  0.00583188, 0.00583188}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 2.13409 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.526087 2.06286 0.0196602 2.06286 [
[ 0 0 0 0 ]
[ 1 2.13409 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 2.13409 L
0 2.13409 L
closepath
clip
newpath
p
1 g
.002 w
.84616 .05157 m
.88117 1.93394 L
s
.88117 1.93394 m
.05157 1.98373 L
s
.05157 1.98373 m
.09302 .13361 L
s
.09302 .13361 m
.84616 .05157 L
s
.90882 .22182 m
.1845 .2974 L
s
.1845 .2974 m
.15365 2.08252 L
s
.15365 2.08252 m
.94843 2.03703 L
s
.94843 2.03703 m
.90882 .22182 L
s
.84616 .05157 m
.88117 1.93394 L
s
.88117 1.93394 m
.94843 2.03703 L
s
.94843 2.03703 m
.90882 .22182 L
s
.90882 .22182 m
.84616 .05157 L
s
.09302 .13361 m
.1845 .2974 L
s
.1845 .2974 m
.15365 2.08252 L
s
.15365 2.08252 m
.05157 1.98373 L
s
.05157 1.98373 m
.09302 .13361 L
s
p
.4 g
.85429 .07367 m
.10489 .15486 L
s
P
p
.4 g
.87794 .13792 m
.1394 .21665 L
s
P
p
.4 g
.90087 .20022 m
.17288 .27661 L
s
P
p
.4 g
.8067 .05587 m
.87091 .22577 L
s
P
p
.4 g
.63962 .07407 m
.7103 .24253 L
s
P
p
.4 g
.47398 .09211 m
.55102 .25915 L
s
P
p
.4 g
.30976 .11 m
.39306 .27564 L
s
P
p
.4 g
.14696 .12774 m
.2364 .29198 L
s
P
P
p
1 0 .6 r
.02 w
.67583 .19942 m
.68146 .80937 L
s
P
p
1 g
.05 w
.67583 .19942 Mdot
P
p
1 0 .6 r
.01414 w
.68146 .80937 m
.68686 1.39383 L
s
P
p
1 0 .6 r
.01414 w
.68146 .80937 m
.39545 1.10432 L
s
P
p
1 0 .6 r
.01 w
.39545 1.10432 m
.1348 1.37311 L
s
P
p
1 0 .6 r
.01 w
.39545 1.10432 m
.22894 1.16791 L
s
P
p
1 0 .6 r
.01 w
.68686 1.39383 m
.92046 1.69405 L
s
P
p
1 0 .6 r
.01 w
.68686 1.39383 m
.692 1.95133 L
s
P
p
1 g
.002 w
.84616 .05157 m
.88117 1.93394 L
s
.88117 1.93394 m
.05157 1.98373 L
s
.05157 1.98373 m
.09302 .13361 L
s
.09302 .13361 m
.84616 .05157 L
s
.84616 .05157 m
.88117 1.93394 L
s
.88117 1.93394 m
.94843 2.03703 L
s
.94843 2.03703 m
.90882 .22182 L
s
.90882 .22182 m
.84616 .05157 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 337}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.705172,
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000JMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP05000de/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40001PaPT000G6a<K6000daP400000EmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP090009e/KFa]K6e/KF00C40P00<lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP010000C/H900G600?4a/@02/@2aP04a<H003?60@000015e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00T0
00K4a]K6e/H:a00?e/KFa]K6e/KFa]K6e/CF008003?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003c62@05aP[42LH00lC6aP0<aP04a03603;60@00000c
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00T000?Fa]H0
2l@0F=K6e/KFa=K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/K40=H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;lH40003a<K400W40lH00lC6aP0;aP03
a<K600_600?4a/H02/H2a0040<@0a3760@00000`e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H01L@0;<KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KF
a]K6a<KF2/@0=lKF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0002o60P03aP03a<K600c600?4a/H02lH00lC6aP03aP[43<H01036aP0aaP400000;mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008001_6e/KFa=K6e/KF
a]K6e/KFa]K4e/KFa]K6e/H02l@0BlKFa]K6e/KFa=K6e/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000;lH00`360004aP03a<K600W6
2/@6aP03a<K600[60P0<aP050<C6aP00<<H1000003SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/K4aP[401cFa]K4e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
10003=K6e/KFa]K6e/KF00?40340a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000_aP040<K600G43LH00lC6aP0;aP03a<K600S610000lK4a008a0050<C6aP00
<<H1000005WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0
e/KFa=K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/CFa]K6eP06a0800/@02/KFa]K6e/KFa]H2000c
a0000<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000_aP05
0<K6aP001<H00lC6aP0;aP03a<K600G62l@6aP04?lK4aP/01<H00`36aP0]aP400000A=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6a<KFa]K6e/KFa]K6
2/@02mK6e/KFa/C6e/KF00H004<o0034a]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000_aP030<K600;600<0a/H00/H;a0?600?4a/H0
1LH60004a00000K600<oa/H02lH00`36aP02aP030<K602g60@00000ee/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H01/@02/KFa]K6e/KFa]H30003a00000@0
05?6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000;lH00`36aP03aP030<K600;600?40000200JaP03
?lK600_600<0a/H00/H00`36aP0]aP400000=]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFaPD006O4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]Hoe/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000_aP030<K600C600<0a/H09/H00co6aP0;aP030<K600;600<0a/H0;LH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KF0=K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;lH00`36aP04aP03
0<K602K600<oa/H02lH00`36aP02aP030<K602g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002o600<0a/H01<H00`36aP0VaP03?lK600_600<0a/H00/H00`36
aP0]aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]H0
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000^aP03
0<K600G600<0a/H09/H00co6aP0<aP050<K6aP00;lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;/H00`36aP05aP030<K602K600<oa/H03<H01@36a/H002o6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/H0a]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002k600<0a/H0
1LH00`36aP0VaP03?lK600c600D0a/K6000_aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000^aP030<K600G600<0a/H09/H00co6aP0<aP050<K6aP00;lH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFaP36e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;/H00`36aP05aP03
0<K602K600<oa/H03<H00`36aP02aP030<K602c60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002k600<0a/H01LH00`36aP0VaP03?lK600c600<0a/H00/H00`36
aP0/aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
0<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000^aP03
0<K600G600<0a/H09lH00do6aP0;aP030<K600;600<0a/H0;<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;/H00`36aP05aP030<K602O600=?a/H02lH00`36
aP02aP030<K602c60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002k600<0a/H01LH00`36aP0WaP03ClK600_600<0a/H00/H00`36aP0/aP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000^aP030<K600G600<0a/H09lH00do6
aP0;aP030<K600;600<0a/H0;<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000;/H00`36aP05aP030<K602O600=?a/H02lH00`36aP02aP030<K602c60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002k600<0a/H01LH00`36
aP0WaP03ClK600_600<0a/H00/H00`36aP0/aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000^aP030<K600G600<0a/H09lH00do6aP0;aP030<K600;600<0a/H0
;<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFaP36
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;/H00`36
aP05aP030<K602O600=?a/H02lH00`36aP02aP030<K602c60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002k600<0a/H01LH00`36aP0WaP03ClK600_600<0a/H0
0/H00`36aP0/aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000^aP030<K600G600<0a/H09lH00do6aP0;aP030<K600;600<0a/H0;<H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;/H00`36aP04aP030<K602S600=?a/H0
2lH00`36aP02aP030<K602c60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002k600<0a/H01<H00`36aP0XaP03ClK600_600<0a/H00/H00`36aP0/aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000^aP030<K600C600<0a/H0
:<H00do6aP0;aP030<K600;600<0a/H0;<H1000005oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP02?`11a]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0002g600<0a/H01LH00`36aP0VaP03ClI?00g600<0a/H00/H00`36
aP0/aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6
0<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP03
0<K600G600<0a/H09<H01Do6a/I?00g600<0a/H00/H00`36aP0/aP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFaSo6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP030<K600G600<0a/H08/H00do6aP03aP03
ClK600_600<0a/H00/H00`36aP0/aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFaSo6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000]aP030<K600G600<0a/H08<H00do6aP05aP03ClK600_600<0a/H00lH00`36
aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
0<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP03
0<K600G600<0a/H07/H00do6aP07aP03ClK600_600<0a/H00lH00`36aP0[aP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP030<K600G600<0a/H07<H00do6
aP09aP03ClK600_600<0a/H00lH00`36aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000]aP030<K600G600<0a/H06/H00do6aP0;aP03ClK600_600<0a/H0
0lH00`36aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000]aP030<K600G600<0a/H06<H00do6aP0=aP03ClK600c600<0a/H00/H00`36aP0[aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP030<K600G600<0a/H0
5/H00do6aP0?aP03ClK600c600<0a/H00/H00`36aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP030<K600G600<0a/H05<H00do6aP0AaP03ClK600c6
00<0a/H00/H00`36aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000]aP030<K600G600<0a/H04/H00do6aP0CaP03ClK600c600<0a/H00/H00`36aP0[aP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3Fa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP030<K600G6
00<0a/H03lH00cm?aP0FaP03ClK600c600<0a/H00/H00`36aP0[aP400000A=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K613l0F]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP030<K600G600<0a/H02LH00cm??`02aP03
ClK601O600=?a/H03<H00`36aP02aP030<K602_60@00000ne/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/H3?`1Qa]K6eSoFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP010000;LH00`36aP05aP030<K600?600<oCcl01/H00do6aP0IaP03
ClK600c600<0a/H00/H00`36aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/Hoa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000]aP030<K600G600<0a/H02/H00do6aP0KaP03ClK600c600<0a/H00/H00`36
aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KF0=K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP03
0<K600G600<0a/H02<H00do6aP0MaP03ClK600c600<0a/H00/H00`36aP0[aP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6eSoFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP030<K600G600<0a/H01/H00do6
aP0OaP03ClK600c600<0a/H00/H00`36aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000]aP030<K600G600<0a/H01<H00do6aP0QaP03ClK600c600<0a/H0
0/H00`36aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KF0=K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000]aP030<K600G600<0a/H00/H00do6aP0SaP03ClK600c600<0a/H00/H00`36aP0[aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6eSoFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aP030<K600G600@0a/I?
9lH00do6aP0<aP030<K600;600<0a/H0:lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3F?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000;<H00`36aP06aP0304o602S600=?a/H03<H00`36aP02aP030<K602_6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002c600<0a/H0
1LH00dl0aP0YaP03ClK600c600<0a/H00/H00`36aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eSoF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000/aP030<K600?600A?a/H0:/H00do6aP0<aP030<K600?6
00<0a/H0:/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6
e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
;<H00`36aP06aP030<K602S600=?a/H03<H00`36aP03aP030<K602[60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002c600<0a/H01/H00`36aP0XaP03Cco600c6
00<0a/H00lH00`36aP0ZaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
?lKFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000/aP030<K600K600<0a/H0:<H014o6aSl;aP030<K600?600<0a/H0:/H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;<H00`36aP06aP030<K602S6
00E?a/K6C`0:aP030<K600?600<0a/H0:/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6eSoFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000;<H00`36aP06aP030<K602S600=?a/H00lH00do6aP06aP030<K600?6
00<0a/H0:/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/Hoa]K6
e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
;<H00`36aP06aP030<K602S600=?a/H01<H00co6aP05aP030<K600?600<0a/H0:/H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFaSo6e/KFa]H0e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;<H00`36aP06aP030<K602S6
00=?a/H01/H00co6aP03aP030<K600?600<0a/H0:/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6?lKFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;<H00`36aP06aP030<K602S600=?a/H01lH00do6aP02aP03
0<K600?600<0a/H0:/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6
e/KFa]K6eSoFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000;<H00`36aP06aP030<K602S600=?a/H02LH014o6aP05aP030<K602[60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6eSoF0=K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002c600<0a/H01/H00`36aP0XaP03
ClK600[600<oaP001LH00`36aP0ZaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6?`3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000/aP030<K600K600<0a/H0:<H00do6aP0<aP03?`3600?600<0a/H0:/H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K60<KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;<H00`36aP05aP03
0<K602W600=?a/H03LH00`36aP02aP030<K602[60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFaP0oe/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002c600<0a/H01LH00`36aP0YaP03ClK600g600<0aTl00/H00`36
aP0ZaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/H0a]HoeP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000/aP03
0<K600G600<0a/H0:LH00do6aP0=aP030<K600;600<0a/H0:/H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;<H00`36aP05aP030<K602W600=?a/H03LH00`36
aP02aP030<K602[60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002c600<0a/H01LH00`36aP0YaP03ClK600g600<0a/H00/H00`36aP0ZaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000[aP030<K600K600<0a/H0:LH00do6
aP0=aP030<K600;600<0a/H0:/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000:lH00`36aP06aP030<K602W600=?a/H03LH00`36aP02aP030<K602[60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFaP36e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002_600<0a/H01/H00`36
aP0YaP03ClK600g600<0a/H00lH00`36aP0YaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000[aP030<K600K600<0a/H0:LH00do6aP0=aP030<K600?600<0a/H0
:LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6
0<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:lH00`36
aP06aP030<K602W600=?a/H03LH00`36aP03aP030<K602W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002_600<0a/H01/H00`36aP0YaP03ClK600g600<0a/H0
0lH00`36aP0YaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000[aP030<K600K600<0a/H0:LH00do6aP0=aP030<K600?600<0a/H0:LH1000006OFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KF00X00376e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000[aP030<K600K600<0a/H07lHA00W600<0a/H0
0lH00`36aP0YaP400000AMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP0A001<e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000[aP030<K600K6
4@0]aP050<K6aP00:lH1000002_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00X006g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000]aP030<K600C600<0a/H0?<H01036aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000_aP030<K600;600<0a/H0?/H202_60@00001^e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000[a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000<LH01036aP0XaQ40=<H1000004gFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP0@0015a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000caP801lHA05G60@00000de/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPP006KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0239763, -0.00953573, 
  0.00584486, 0.00584486}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.81086 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.353136 1.72672 0.0409716 1.72672 [
[ 0 0 0 0 ]
[ 1 1.81086 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.81086 L
0 1.81086 L
closepath
clip
newpath
p
1 g
.002 w
.84163 .04317 m
.87622 1.59163 L
s
.87622 1.59163 m
.04317 1.64232 L
s
.04317 1.64232 m
.08625 .1265 L
s
.08625 .1265 m
.84163 .04317 L
s
.91728 .26115 m
.20673 .33441 L
s
.20673 .33441 m
.17798 1.76769 L
s
.17798 1.76769 m
.95683 1.72369 L
s
.95683 1.72369 m
.91728 .26115 L
s
.84163 .04317 m
.87622 1.59163 L
s
.87622 1.59163 m
.95683 1.72369 L
s
.95683 1.72369 m
.91728 .26115 L
s
.91728 .26115 m
.84163 .04317 L
s
.08625 .1265 m
.20673 .33441 L
s
.20673 .33441 m
.17798 1.76769 L
s
.17798 1.76769 m
.04317 1.64232 L
s
.04317 1.64232 m
.08625 .1265 L
s
p
.4 g
.84232 .04516 m
.08735 .12839 L
s
P
p
.4 g
.86085 .09856 m
.11683 .17927 L
s
P
p
.4 g
.87882 .15034 m
.14544 .22864 L
s
P
p
.4 g
.89626 .20057 m
.17321 .27657 L
s
P
p
.4 g
.91317 .24931 m
.20018 .32311 L
s
P
p
.4 g
.80797 .04688 m
.88566 .26441 L
s
P
p
.4 g
.59116 .0708 m
.68192 .28541 L
s
P
p
.4 g
.37733 .09439 m
.48079 .30615 L
s
P
p
.4 g
.16642 .11765 m
.28225 .32662 L
s
P
P
p
1 0 .6 r
.02 w
.63604 .20875 m
.6393 .59687 L
s
P
p
1 g
.05 w
.63604 .20875 Mdot
P
p
1 0 .6 r
.00707 w
.29217 .9536 m
.24742 1.06127 L
s
P
p
1 0 .6 r
.01414 w
.6393 .59687 m
.64237 .96376 L
s
P
p
1 0 .6 r
.01414 w
.6393 .59687 m
.45745 .78375 L
s
P
p
1 0 .6 r
.01 w
.45745 .78375 m
.29217 .9536 L
s
P
p
1 0 .6 r
.01 w
.45745 .78375 m
.35283 .82095 L
s
P
p
1 0 .6 r
.00707 w
.79021 1.15421 m
.79781 1.26357 L
s
P
p
1 0 .6 r
.00707 w
.29217 .9536 m
.14211 1.10783 L
s
P
p
1 0 .6 r
.00707 w
.79021 1.15421 m
.92267 1.32487 L
s
P
p
1 0 .6 r
.01 w
.64237 .96376 m
.79021 1.15421 L
s
P
p
1 0 .6 r
.00707 w
.35283 .82095 m
.25533 .85561 L
s
P
p
1 0 .6 r
.00707 w
.35283 .82095 m
.28549 .89002 L
s
P
p
1 0 .6 r
.01 w
.64237 .96376 m
.64527 1.30924 L
s
P
p
1 0 .6 r
.00707 w
.64527 1.30924 m
.64799 1.6334 L
s
P
p
1 0 .6 r
.00707 w
.64527 1.30924 m
.6006 1.4145 L
s
P
p
1 g
.002 w
.84163 .04317 m
.87622 1.59163 L
s
.87622 1.59163 m
.04317 1.64232 L
s
.04317 1.64232 m
.08625 .1265 L
s
.08625 .1265 m
.84163 .04317 L
s
.84163 .04317 m
.87622 1.59163 L
s
.87622 1.59163 m
.95683 1.72369 L
s
.95683 1.72369 m
.91728 .26115 L
s
.91728 .26115 m
.84163 .04317 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 337}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.705172,
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000KMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H01P00;lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001TaPT00/H01<C6aP0_aP400000FmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=H02@003]K6e/KFa]K6e/KFa/C60P00;]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000D/H901G600C4aP00;/H1000004SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H:000Pe/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6a<H2000^e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000oaPT04/H00lC6aP0BaP?400<0a000;LH1000003KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000Wa]K6e/KFa=K6e/KF
a]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K600W403?6e/@0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002g62@0@aP03a<K601;600?4a/@02<@;aP04a03602g6
0@00000Xe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPD002O6e/K4a]K6e/KF
a]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/H02L@0ALKFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000:<H00`36aP06aP03
a<K601?600C4a/K62L@8aP03a<K601?600@0a/H0;<H1000002SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60P006=K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFaPW402S6e/KFa]K6e/KF
a]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/H00/@0;@34a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP010000:<H00`360007aP03a<K600C62L@6aP03a<K601;600?4a/H0
2LH9a0050<C6aP00:lH10000033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<H0a]K6e/H9a00Wa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa=K600W403W6e/KF
a]K6e/H0a=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002S6
00<0a/H01L@3aP03a<K601?600?4a/H02lH9a1;600D0a<K6000[aP400000C]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFaPW404_6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/H0a/C6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002S600D0a/K60007aP03a<K600k62L@?aP804lH00`34
a002a0030<K602S60@00000le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KF0=K6e/KFa]K4e/KFa]K62L@05lKFa]K6a<KFa]K6e/KFa]K6e/KFa]K600@000[Fa]K6e/KFa]K6
2<@0<036a<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000XaP03
0<K600;600<0a/H00lH9a0o600?4a/H03/H40003a/C400O42<H01036a/@2aP030<K602O60@00000^
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaPG402G6e/K4a]K6e/KF
a]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K600G40P02a011a]K6e/KFa]K6e/KFa]K6e/H0a]K4e/H0
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002S600<0a/H00lH00`36
aP05aP03a<K601?600C4a/K62<@6aP03ClK4017600@0a/K40/H00`36aP0WaP400000AmK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KF00W402CFa]K6e/KFa]K6e/KFaSo6e/CFa]K6e/KFa]K6e/KFa]K60<H5a00Y0=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002S600<0a/H01LH00`36aP04aP03a<K600C6
2L@6aP03a<K600k600A?a/K42<H8a0050<@00<@00`0XaP400000=MK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KF00W402;Fa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFaSo62/@:000^e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000XaP030<K600K61<@4aP03a<K601;600?4a/H01LH8a005Cl@00<@01`08aP030<K600C6
00<0a/H09/H1000004cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KF0=K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K62/@80014?`3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:<H00`36aP07aP03
0<K600G600?4a/H01LH:a004aP00a0H02<H00do6aP0AaP030<K600C600<0a/H09/H1000003SFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFaP[400?F0000
2000ELKFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002O600<0a/H02LH5a004aP00a0L06lH00do6
aP0BaP030<K600?600<0a/H09/H1000003CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K61@00JLKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Ho
a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100009lH00`36aP0:aP030<K602O600=?a/H04/H00`36aP03aP030<K602K60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H02/H00`36
aP0WaP03ClK601;600<0a/H00lH00`36aP0VaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000WaP030<K600[600<0a/H09lH00do6aP0BaP030<K600?600<0a/H0
9/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009lH00`36
aP0:aP030<K602O600=?a/H04/H00`36aP03aP030<K602K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H02/H00`36aP0WaP03ClK601;600<0a/H0
0lH00`36aP0VaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000WaP030<K600[600<0a/H09lH00do6aP0BaP030<K600?600<0a/H09/H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009lH00`36aP0:aP030<K602O600=?a/H0
4/H00`36aP04aP030<K602G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002O600<0a/H02/H00`36aP0WaP03ClK601;600<0a/H01<H00`36aP0UaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000WaP030<K600[600<0a/H0
9lH00do6aP0BaP030<K600C600<0a/H09LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100009lH00`36aP0:aP030<K602O600=?a/H04/H00`36aP04aP030<K602G6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H0
2/H00`36aP0WaP03ClK601;600<0a/H01<H00`36aP0UaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000WaP030<K600[600<0a/H09lH00do6aP0BaP030<K600C6
00<0a/H09LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
9lH00`36aP09aP030<K602S600=?a/H04/H00`36aP04aP030<K602G60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H02LH00`36aP0WaP03?do601?6
00<0a/H01<H00`36aP0UaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000WaP030<K600W600<0a/H09LH013o6aTlDaP030<K600C600<0a/H09LH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009lH00`36aP09aP030<K602?6
00<oa/H00/H00do6aP0BaP030<K600C600<0a/H09LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100009lH00`36aP09aP030<K6027600<oa/H01<H00do6aP0BaP03
0<K600C600<0a/H09LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100009lH00`36aP09aP030<K601o600<oa/H01/H00do6aP0BaP030<K600C600<0a/H09LH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36aP0:aP03
0<K601g600<oa/H02<H00do6aP0BaP030<K600C600<0a/H09LH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36aP0:aP030<K601_600<oa/H02/H00do6
aP0BaP030<K600C600<0a/H09LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100009/H00`36aP0:aP030<K601W600<oa/H03<H00do6aP0BaP030<K600C600<0a/H0
9LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36
aP0:aP030<K601O600<oa/H03/H00do6aP0BaP030<K600C600<0a/H09LH1000004_Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00Sl0ELKFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002K600<0a/H02/H00`36aP0BaP05
Ccm?aTl04LH00do6aP0BaP030<K600C600<0a/H09LH1000004KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60Sl0F]K6eSoFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000VaP030<K600[600<0a/H03LH00cm??`04aP03ClK60176
00=?a/H04/H00`36aP04aP030<K602G60@000011e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H00Sl0GlKFa]K6eSoFa]K6e/KFa]K6e/KF
a]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000VaP030<K600[600<0a/H02<H014loCcl6aP03ClK601?600=?a/H0
4lH00`36aP04aP030<K602C60@00000ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]H00cl0I=K6?lKFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100009/H00`36aP0:aP030<K600?600<oClH00lH00co6aP04aP03ClK601G600=?a/H0
4lH00`36aP04aP030<K602C60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002K600<0a/H02/H00`36aP07aP03?lK600C600=?a/H05lH00do6aP0CaP030<K600C6
00<0a/H09<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]H0e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
9/H00`36aP0:aP030<K600c600=?a/H06LH00do6aP0CaP030<K600C600<0a/H09<H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36aP0:aP030<K600[6
00=?a/H06lH00do6aP0CaP030<K600C600<0a/H09<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36aP0:aP030<K600S600=?a/H07LH00do6aP0CaP03
0<K600C600<0a/H09<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]H0e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100009/H00`36aP0:aP030<K600K600=?a/H07lH00do6aP0CaP030<K600C600<0a/H09<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36aP0:aP03
0<K600G600<oa/H08<H00do6aP0CaP030<K600C600<0a/H09<H1000003[Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K60Sl08]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`12e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002K600<0a/H02/H00`36aP03aP03?lHo02;6
00=?aTl04lH00`36aP04aP030<K602C60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002K600<0a/H02/H01@36a/Ho00;600=?a/H08LH01Do6a/I?017600<0a/H0
1<H00`36aP0TaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6eP3FaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6eSoFa]K6
e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000VaP030<K600[600<0aSl00lH00co6aP0RaP03ClK600;600<oa/H03/H00`36aP04aP030<K602C6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF03o6
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFaSo6e/KFa]K6e/KFa]K6
e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002K600<0a/H0
2LH00`0oaP03aP03ClK602?600=?a/H01<H00co6aP0<aP030<K600C600<0a/H09<H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/Hoa]K6e/KFa]K6e/KFaP36e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009LH00`36aP09aP03?`3602[6
00=?a/H01/H00co6aP0:aP030<K600C600<0a/H09<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/HoaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFaSo6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100009LH00`36aP07aP04?lK602_600=?a/H01lH00do6aP09aP03
0<K600C600<0a/H09<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6?lKFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]Hoe/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100009LH00`36aP0:aP030<K602W600=?a/H02LH00do6aP07aP030<K600C600<0a/H09<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6eSoFa]K6e/KFaP36
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009LH00`36aP0:aP03
0<K602[600<oa/H02/H00do6aP05aP030<K600C600<0a/H09<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KF?mK6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009LH00`36aP0:aP030<K602[600<oa/H02lH00co6
aP04aP030<K600C600<0a/H09<H1000006gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KF008o03?6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0002G600<0a/H02/H00`36aP0ZaP03?lK600_600<oaSl01<H00`36aP05aP03
0<K602?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6
eSoFaSo6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G6
00<0a/H02/H00`36aP0ZaP03?lK600_600@oa/I?0lH00`36aP05aP030<K602?60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/Hoa]Hoe/H0a]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H02/H00`36aP0ZaP03
?lK600c600M?a/K6ClH000O600<0a/H08lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6e/KFa]K6e/KFaSo6e/KF?`36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100009LH00`36aP0:aP030<K602[600<oa/H03<H00do6aP03aP030<K600G6
00<0a/H08lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6
e/KFaSo6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
9LH00`36aP0:aP030<K602[600<oa/H03<H00do6aP03aP0303o600G600<0a/H08lH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFaP36?lKFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009LH00`36aP0:aP030<K602[6
00<oa/H04/H01036aSl4aP030<K602?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/H0a]Hoe/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002G600<0a/H02/H00`36aP0ZaP03?lK601;600D0a/K6C`03aP030<K602?6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6eSoFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H0
2/H00`36aP0YaP03Cco601?600<0a/H00lH00do6000UaP400000G]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H2?`12e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H02/H00`36aP0XaP03?lHo01G600<0a/H0
1<H00`36aP0SaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000UaP030<K600[600<0a/H09lH014o6aSlEaP030<K600C600<0a/H08lH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009LH00`36aP0:aP030<K602O600A?a/Ho
5LH00`36aP04aP030<K602?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002G600<0a/H02/H00`36aP0VaP05?lK6aSl05LH00`36aP04aP030<K602?60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H02/H00`36
aP0ZaP03?lK601?600<0a/H01<H00`36aP0SaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000UaP030<K600[600<0a/H0:/H00co6aP0CaP030<K600C600<0a/H0
8lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36
aP0;aP030<K602[600<oa/H04lH00`36aP04aP030<K602?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002C600<0a/H02lH00`36aP0ZaP03?lK601?600<0a/H0
1<H00`36aP0SaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000TaP030<K600_600<0a/H0:/H00co6aP0CaP030<K600C600<0a/H08lH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36aP0;aP030<K602[600<oa/H0
4lH00`36aP04aP030<K602?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002C600<0a/H02/H00`36aP0[aP03?lK601?600<0a/H01LH00`36aP0RaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000TaP030<K600[600<0a/H0
:lH00co6aP0CaP030<K600G600<0a/H08/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100009<H00`36aP0:aP030<K602_600<oa/H02lH900O600<0a/H08/H10000
05gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H04000=LKFa]K6e/KF0=K6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000TaP030<K600[600<0a/H06<HA00;6
00<oa/H05<H00`36aP04aP030<K602;60@00000le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K64000E]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002C600<0a/H01LH@02?600<oa/H05LH00`36aP03aP030<K602;60@00000Te/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62000M]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36aP08aP030<K604C600<0a/H00/H00`36
aP0RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000XaP03
0<K600K600<0a/H0A/H01036aP0TaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000ZaP030<K600C600<0a/H0AlH00`36000TaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000/aP030<K600;600<0a/H0B<H202C60@00001d
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H:000T
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002k600@0a/H0;lHC02k60@00001>
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K64`00@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000`aP802LHC05C60@00000ae/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0:001Wa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0141477, -0.0237332, 
  0.00592508, 0.00592508}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.65876 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.282371 1.59097 0.0397742 1.59097 [
[ 0 0 0 0 ]
[ 1 1.65876 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.65876 L
0 1.65876 L
closepath
clip
newpath
p
1 g
.002 w
.84172 .03977 m
.87636 1.43198 L
s
.87636 1.43198 m
.03977 1.48331 L
s
.03977 1.48331 m
.08368 .12403 L
s
.08368 .12403 m
.84172 .03977 L
s
.92084 .27703 m
.21716 .34908 L
s
.21716 .34908 m
.18935 1.61899 L
s
.18935 1.61899 m
.96023 1.57577 L
s
.96023 1.57577 m
.92084 .27703 L
s
.84172 .03977 m
.87636 1.43198 L
s
.87636 1.43198 m
.96023 1.57577 L
s
.96023 1.57577 m
.92084 .27703 L
s
.92084 .27703 m
.84172 .03977 L
s
.08368 .12403 m
.21716 .34908 L
s
.21716 .34908 m
.18935 1.61899 L
s
.18935 1.61899 m
.03977 1.48331 L
s
.03977 1.48331 m
.08368 .12403 L
s
p
.4 g
.8541 .07689 m
.10453 .15918 L
s
P
p
.4 g
.88038 .15567 m
.14882 .23385 L
s
P
p
.4 g
.90534 .23052 m
.19095 .30489 L
s
P
p
.4 g
.73034 .05216 m
.81763 .2876 L
s
P
p
.4 g
.56704 .07031 m
.66619 .3031 L
s
P
p
.4 g
.40563 .08825 m
.51638 .31844 L
s
P
p
.4 g
.2461 .10598 m
.36817 .33362 L
s
P
p
.4 g
.08841 .12351 m
.22155 .34863 L
s
P
P
p
1 0 .6 r
.02 w
.61567 .21296 m
.6179 .50271 L
s
P
p
1 g
.05 w
.61567 .21296 Mdot
P
p
1 0 .6 r
.005 w
.3252 .84972 m
.29533 .92171 L
s
P
p
1 0 .6 r
.005 w
.73604 .99953 m
.74136 1.07278 L
s
P
p
1 0 .6 r
.005 w
.3252 .84972 m
.28105 .89507 L
s
P
p
1 0 .6 r
.00707 w
.35905 .76816 m
.3252 .84972 L
s
P
p
1 0 .6 r
.01414 w
.6179 .50271 m
.61998 .77443 L
s
P
p
1 0 .6 r
.01414 w
.6179 .50271 m
.48219 .64188 L
s
P
p
1 0 .6 r
.01 w
.48219 .64188 m
.35905 .76816 L
s
P
p
1 0 .6 r
.01 w
.48219 .64188 m
.40463 .66823 L
s
P
p
1 0 .6 r
.005 w
.73604 .99953 m
.77509 1.04985 L
s
P
p
1 0 .6 r
.00707 w
.72999 .91635 m
.73604 .99953 L
s
P
p
1 0 .6 r
.00707 w
.35905 .76816 m
.2474 .88266 L
s
P
p
1 0 .6 r
.005 w
.2474 .88266 m
.14624 .9864 L
s
P
p
1 0 .6 r
.005 w
.2474 .88266 m
.18135 .90711 L
s
P
p
1 0 .6 r
.005 w
.82865 1.04362 m
.91714 1.15778 L
s
P
p
1 0 .6 r
.005 w
.82865 1.04362 m
.90845 1.07745 L
s
P
p
1 0 .6 r
.00707 w
.72999 .91635 m
.82865 1.04362 L
s
P
p
1 0 .6 r
.01 w
.61998 .77443 m
.72999 .91635 L
s
P
p
1 0 .6 r
.00707 w
.40463 .66823 m
.33276 .69264 L
s
P
p
1 0 .6 r
.00707 w
.40463 .66823 m
.35461 .71944 L
s
P
p
1 0 .6 r
.01 w
.61998 .77443 m
.62192 1.02838 L
s
P
p
1 0 .6 r
.005 w
.35461 .71944 m
.30945 .76567 L
s
P
p
1 0 .6 r
.005 w
.35461 .71944 m
.32577 .72943 L
s
P
p
1 0 .6 r
.005 w
.33276 .69264 m
.26633 .71521 L
s
P
p
1 0 .6 r
.005 w
.33276 .69264 m
.31643 .66668 L
s
P
p
1 0 .6 r
.00707 w
.62192 1.02838 m
.62374 1.26498 L
s
P
p
1 0 .6 r
.00707 w
.62192 1.02838 m
.58869 1.1015 L
s
P
p
1 0 .6 r
.005 w
.62374 1.26498 m
.57805 1.39563 L
s
P
p
1 0 .6 r
.005 w
.62374 1.26498 m
.62542 1.48476 L
s
P
p
1 0 .6 r
.005 w
.58869 1.1015 m
.55724 1.17071 L
s
P
p
1 0 .6 r
.005 w
.58869 1.1015 m
.64391 1.12649 L
s
P
p
1 g
.002 w
.84172 .03977 m
.87636 1.43198 L
s
.87636 1.43198 m
.03977 1.48331 L
s
.03977 1.48331 m
.08368 .12403 L
s
.08368 .12403 m
.84172 .03977 L
s
.84172 .03977 m
.87636 1.43198 L
s
.87636 1.43198 m
.96023 1.57577 L
s
.96023 1.57577 m
.92084 .27703 L
s
.92084 .27703 m
.84172 .03977 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 337}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.705172,
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000LMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00D002cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40001XaPT01<H00`36aP0ZaP400000GmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00T003[Fa=K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0005K62@0;aP03a<K600S60P0[aP400000CMK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00T0
01_Fa/C6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]H01<@2000[a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP010000A<H900c600?4a/H02lH:a0C60P0[aP400000>mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00T001WFa/C6
e/KFa]K6e/KFa]K6e/KFa]K4e/KF00[403_6e/KFa=K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000</H900c600?4a/H02LH:a0k600?4a/H01lH00`36
000ZaP400000:MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00T001OFa]K4
e/KFa]K6e/KFa]K6e/KFa]K4eP0:a01?a]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6eP3F
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100009<H500g600?4a/H0
1/H:a17600?4a/H03lH00lC6aP06aP040<K602W60@00000ee/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KFa]H02/@0HlKFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KF
a]K4e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100009<H20003a<K600;62/@2aP03a<K600o600?4a/H03lH00lC6aP0>aP03
a<K600K600@0a/H0:LH1000002CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H200G4
04_6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF
a]K6e/KFa]K4e/KFa]K6a0000l@0:@3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000TaP040<H0a13600?4a/H03lH00lC6aP0?aP03a<K600_62/@00lH0aP02aP030<K602K6
0@00001Qe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF0<C6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/K4a]K6eP09a00he/KFa/C6e/KFa]H0
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H01@36aP340136
00?4a/H03lH00lC6aP09aP[43LH00lC6aP04aP030<K600;600<0a/H09LH1000004gFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<CFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K4eP0:a005a]K6e/H00`00@lKFa]K6e/KFa]K6e/KFa/C6e/KFa]H0e/KFaP36e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002C600H0a/K60<@@aP03a<K600K62/@>aPD0
3lH00lC6aP03aP030<K600;600<0a/H09LH1000003[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6eP34a]K6e/KFa]K6e/KFa]K62L@06<KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6ePD0
04;Fa]K6e/KFa]K6e/KFa]K4e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100009<H00`36aP03aP030<C600?62/@00lK4aP0@aP03a<K600_61@0?aP03a<K600C6
00<0a/H00/H00`36aP0TaP400000:mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFaP001L@0;=K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K60`006<CF
a]K6e/KFa]K6e/KFa]K6a<KFa]K600C402L0a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0002C600<0a/H01<H00`34aP0>aP03a<K600o600?4a/H02lH014loa/@>aPS400<0a/H0
0lH00`36aP0SaP400000G=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0
a<KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K60Sl01]K4e/KFaP[4
03CFa/C6e/KFaP36e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002C6
00<0a/H01LH00`34aP0>aP03a<K600o600?4a/H02LH00lA??`06a0g600?4a/H00/H00`36aP03aP03
0<K602?60@00001Ae/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a=K6
e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/CF00[404O6?coFa/C6e/KFa]K6e/KFa]K6e/KF
a=K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008lH00`36
aP07aP030<C600k600?4a/H01lH9a0_600=??lH00/H00lC6aP0=aP03a<K600;600<0aP001@0TaP40
0000?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a=K6e/KFa]K6
e/KFa]K62/@05=K6e/KFa]K6a<KFa]K6e/KFa]K60Sl04MK6e/CFa]K6e/KFa]K6e/KF00<000?40000
0`00:]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000SaP030<K600S6
00<0a<H01<H9a0;600?4a/H03/H00lC6aP08aP03Cco600;600?4a/H00/H900O600<0a/H01<H00`36
aP0RaP400000<=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF00G4
02O6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/H00Sl40010a0000=K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000SaP03
0<K600W600<0a<H03lH00lC6aP0>aP03a00000L000=??lH05lH00`36aP04aP030<K602;60@000019
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6eP0:0009a]K6e/KFa]K6008o04CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000SaP030<K600_600<0a<H0
3<H20003a00000@04lH00dloaP0GaP030<K600C600<0a/H08/H1000003OFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0<C6e/KF00T001cFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60Sl0A=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H03<H00`34000202G600=??lH05lH00`36
aP04aP030<K602;60@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008lH00`36aP0<aP030<K602O600=??lH05lH00`36aP04aP030<K602;60@00001Le/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0<aP030<K602O6
00=??lH05lH00`36aP04aP030<K602;60@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008lH00`36aP0<aP030<K602O600=??lH05lH00`36aP04aP030<K602;6
0@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36
aP0<aP030<K602O600=??lH05lH00`36aP05aP030<K602760@00001Le/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0<aP030<K602O600=??lH05lH00`36
aP05aP030<K602760@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008lH00`36aP0<aP030<K602O600=??lH05lH00`36aP05aP030<K602760@00001Le/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0<aP030<K602O6
00=??lH05lH00`36aP05aP030<K602760@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008lH00`36aP0<aP030<K602O600=??lH05lH00`36aP05aP030<K60276
0@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36
aP0<aP030<K602O600=??lH05lH00`36aP05aP030<K602760@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H03LH00`36aP0UaP04ClK6?aS600<0a/H0
1LH00`36aP0QaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000RaP030<K600g600<0a/H08lH00do6aP02aP03?lK601K600<0a/H01LH00`36aP0QaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000RaP030<K600c600<0a/H0
8/H00do6aP04aP03?lK601O600<0a/H01<H00`36aP0QaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000RaP030<K600c600<0a/H08<H00do6aP06aP03?lK601O6
00<0a/H01<H00`36aP0QaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6eSoFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000RaP030<K600c600<0a/H07/H00do6aP08aP03?lK601O600<0a/H01<H00`36aP0QaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000RaP030<K600c6
00<0a/H07<H00do6aP0:aP03?lK601O600<0a/H01<H00`36aP0QaP400000C]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP8o05;Fa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H03<H00`36aP0GaP03?dlo00o6
00<oa/H05lH00`36aP04aP030<K602760@000018e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl0ElHoa]K6e/KFa]K6e/KF
a]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100008/H00`36aP0<aP030<K600W600<oa/H01<H014loCcl3aP03?lK600o6
00<oa/H05lH00`36aP04aP030<K602760@000011e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/Hoa]H00cl0G]Hoe/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008/H00`36aP0<aP030<K600[600=??dl00lH00do6aP02aP03?lK60176
00<oa/H05lH00`36aP05aP030<K602360@00000ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H00cl0I=K6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008/H00`36aP0<aP030<K600G600<oClH01/H00do6aP02aP03?lK601?6
00<oa/H05lH00`36aP05aP030<K602360@000010e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6eP3Fa]K6e/Hoa]K6e/KFaP8o063Fa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008/H00`36aP0<aP030<K600[600=??dl01<H00co6aP0EaP03?lK601O6
00<0a/H01LH00`36aP0PaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000RaP030<K600c600<0a/H02/H00do6aP02aP03?lK601O600<oa/H05lH00`36aP05aP03
0<K602360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;6
00<0a/H03<H00`36aP08aP03ClK600;600<oa/H06LH00co6aP0GaP030<K600G600<0a/H08<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36aP0<aP03
0<K600c600=?a/H06/H00co6aP0GaP030<K600G600<0a/H08<H1000003oFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H00Sl07<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]H2?`13a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008/H00`36aP0<aP030<K600[600=?aTl0
7<H00co6?`0GaP030<K600G600<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008LH00`36aP0=aP030<K600S600A?a/Ho7LH01Co6a/Ho01G600<0a/H0
1LH00`36aP0PaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]Hoe/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000QaP030<K600g600<0a/H01lH013o6aTlNaP03?lK600;600=?a/H04/H00`36aP05aP030<K60236
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H0
3LH00`36aP05aP06?lK6aSm?7/H00co6aP04aP03ClK6013600<0a/H01LH00`36aP0PaP400000?=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6?lKFaP8o
06CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H03LH00`36
aP03aP07?lK6aSo6?`0OaP03?lK600G600<oa/H03lH00`36aP05aP030<K602360@00000de/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3FaP<o06_6e/Hoa]Hoe/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KF0=K6e/KF
a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008LH00`36aP0=aP05?dloaSl0
0lH013o6aTlPaP03?lK600O600<oa/H03LH00`36aP05aP030<K602360@00000_e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H00Sl0L@3FaSo6e/KFa]K6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000QaP030<K600g600<0aSl02<H00do6
aP0OaP03ClK600S600<oa/H03<H00`36aP04aP030<K602360@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP0oa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H03LH00co6aP0ZaP03ClK600S600<oClH0
3<H00`36aP05aP030<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6?`3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00027600<0a/H02lH00co6000/aP03ClK600S600@oa/I?2lH00`36aP05aP030<K601o6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaSo6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFaSo6eSoFa]K6
e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H0
2LH01Co6a/H002c600=?a/H02LH014o6aSl:aP030<K600G600<0a/H07lH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaSo6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/H0a]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP07aP03?lK600;600<0a/H0
:lH00do6aP09aP03ClK600;600<oa/H01/H00`36aP05aP030<K601o60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFaSo6e/KFaSo6e/KFa]K60<KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H03<H00`36aP0[aP03ClK600W6
00=?a/H00lH00do6aP05aP030<K600G600<0a/H07lH1000006[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K60Sl0=]K6e/KF?mK6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600c600<0a/H0:lH00do6aP09aP03ClI?00G6
00=?a/H00lH00`36aP05aP030<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KFaSo6?lKFa]K6eSoFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@00027600<0a/H03<H00`36aP0ZaP03?do600[600A?a/Ho1/H01Dloa/H000O6
00<0a/H07lH1000005gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl05lKFa]K6e/KF
a]K6?lKFaSo6e/KFaSo6008o02X0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008LH00`36aP0<aP030<K602W600=?aTl02lH00do6aP08aP07?lK603m??`04aP030<K601o6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFaSo60<KFaSo6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H0
3LH00`36aP0XaP04?lK6CaS600<o0<H01/H00`36aP0OaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?`36e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600g600<0a/H09lH01Dloa/I?01W600<0a/H0
1LH00`36aP0OaP400000G=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo60cl0@lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H0?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@00023600<0a/H03LH00`36aP0VaP03?lK600;600=??lH05lH00`36C`05aP030<K601o60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<Hoa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H03LH00`36
aP0UaP03ClK600?600=?a/H05lH01036aSl4aP030<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFaSo6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H03LH00`36aP0UaP03ClK600?600=?a/H0
5lH00`36aP02aP04?lK602760@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00023600<0a/H03LH00`36aP0[aP03ClK601O600<0a/H01LH00`36aP0OaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600g600<0a/H0
:lH00do6aP0GaP030<K600K600<0a/H07/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008<H00`36aP0=aP030<K602_600=?a/H05lH00`36aP06aP030<K601k6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H0
3LH00`36aP0[aP03ClK601O600<0a/H01/H00`36aP0NaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600g600<0a/H0:lH00do6aP0GaP030<K600K6
00<0a/H07/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
8<H00`36aP0=aP030<K602_600=?a/H06<H00`36aP05aP030<K601k60@00001Me/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o04?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000PaP030<K600g600<0a/H0:/H00cm?
aP0IaP030<K600G600<0a/H07/H1000005gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0Sl0@lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@00023600<0a/H03LH00`36aP0YaP03ClI?01[600<0a/H01LH00`36aP0NaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600g6
00<0a/H0:LH00do6C`0JaP030<K600G600<0a/H07/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0=aP030<K602S600@oa/I?6/H00`36aP05aP03
0<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o6
00<0a/H03/H00`36aP0WaP05ClK6aTl06/H00`36aP05aP030<K601k60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03/H00`36aP0WaP05ClK6aTl0
6/H00`36aP05aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001o600<0a/H03/H00`36aP0[aP03ClK601S600<0a/H01LH00`36aP0NaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K600g600<0a/H0
;<H00do6aP0HaP030<K600G600<0a/H07/H1000007;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/H8000Xe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000OaP030<K600g600<0a/H0;<H00do6aP02aPl01lH00`36aP05aP030<K601k6
0@00001De/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K63`00?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF
a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007lH00`36aP0=aP030<K601?6
3`0:aP03ClK601W600<0a/H01LH00`36aP0MaP400000=]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFaPl005g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001o600<0a/H01LH?02S600=?a/H06lH00`36aP03aP030<K601g60@00000Oe/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP08001ka]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000QaP030<K600_600<0a/H0BlH00`36
aP02aP030<K601g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002?600<0a/H02LH00`36aP1<aP050<K6aP007lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100009LH00`36aP07aP030<K604g600@0a/H07lH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009lH200K600<0a/H0C/H00`36
000OaP400000PMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP02000Oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
:/H00`36aP02aP030<K604o60P0OaP400000N=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP/001o6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000/aP040<K603?65@0ZaP400000C]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQD003o6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002k6
0P09aQD0E<H1000002oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP0:001Ya]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040002RaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP400000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0146262, -0.0250052, 
  0.00589051, 0.00589051}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.57485 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.244609 1.5205 0.0380126 1.5205 [
[ 0 0 0 0 ]
[ 1 1.57485 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.57485 L
0 1.57485 L
closepath
clip
newpath
p
1 g
.002 w
.84047 .03801 m
.87498 1.34047 L
s
.87498 1.34047 m
.03801 1.39219 L
s
.03801 1.39219 m
.08254 .1228 L
s
.08254 .1228 m
.84047 .03801 L
s
.92286 .2919 m
.227 .36273 L
s
.227 .36273 m
.20008 1.53683 L
s
.20008 1.53683 m
.96199 1.49439 L
s
.96199 1.49439 m
.92286 .2919 L
s
.84047 .03801 m
.87498 1.34047 L
s
.87498 1.34047 m
.96199 1.49439 L
s
.96199 1.49439 m
.92286 .2919 L
s
.92286 .2919 m
.84047 .03801 L
s
.08254 .1228 m
.227 .36273 L
s
.227 .36273 m
.20008 1.53683 L
s
.20008 1.53683 m
.03801 1.39219 L
s
.03801 1.39219 m
.08254 .1228 L
s
p
.4 g
.83942 .03477 m
.0807 .11974 L
s
P
p
.4 g
.86111 .10162 m
.11866 .18279 L
s
P
p
.4 g
.88183 .16547 m
.15497 .2431 L
s
P
p
.4 g
.90165 .22652 m
.18974 .30083 L
s
P
p
.4 g
.92061 .28496 m
.22305 .35616 L
s
P
p
.4 g
.82087 .04021 m
.90491 .29373 L
s
P
p
.4 g
.55285 .07019 m
.65921 .31874 L
s
P
p
.4 g
.29029 .09956 m
.41809 .34328 L
s
P
P
p
1 0 .6 r
.02 w
.60641 .22183 m
.60812 .45649 L
s
P
p
1 g
.05 w
.60641 .22183 Mdot
P
p
1 0 .6 r
.00353 w
.3466 .79658 m
.3578 .81335 L
s
P
p
1 0 .6 r
.00353 w
.3466 .79658 m
.32491 .84885 L
s
P
p
1 0 .6 r
.00353 w
.70817 .91845 m
.71214 .9717 L
s
P
p
1 0 .6 r
.00353 w
.70817 .91845 m
.6839 .9326 L
s
P
p
1 0 .6 r
.005 w
.37106 .73762 m
.3466 .79658 L
s
P
p
1 0 .6 r
.00353 w
.33534 .77425 m
.32561 .79786 L
s
P
p
1 0 .6 r
.005 w
.70369 .85829 m
.70817 .91845 L
s
P
p
1 0 .6 r
.005 w
.37106 .73762 m
.33534 .77425 L
s
P
p
1 0 .6 r
.00707 w
.39871 .67098 m
.37106 .73762 L
s
P
p
1 0 .6 r
.00353 w
.33534 .77425 m
.30312 .8073 L
s
P
p
1 0 .6 r
.01414 w
.60812 .45649 m
.60972 .67539 L
s
P
p
1 0 .6 r
.01414 w
.60812 .45649 m
.49828 .569 L
s
P
p
1 0 .6 r
.00353 w
.73529 .89906 m
.73698 .92309 L
s
P
p
1 0 .6 r
.01 w
.49828 .569 m
.39871 .67098 L
s
P
p
1 0 .6 r
.01 w
.49828 .569 m
.43578 .58962 L
s
P
p
1 0 .6 r
.00353 w
.73529 .89906 m
.7637 .93571 L
s
P
p
1 0 .6 r
.00353 w
.84992 .98552 m
.85281 1.03908 L
s
P
p
1 0 .6 r
.005 w
.70369 .85829 m
.73529 .89906 L
s
P
p
1 0 .6 r
.00707 w
.69861 .79015 m
.70369 .85829 L
s
P
p
1 0 .6 r
.00353 w
.22688 .84697 m
.20557 .90007 L
s
P
p
1 0 .6 r
.00707 w
.39871 .67098 m
.30852 .76335 L
s
P
p
1 0 .6 r
.005 w
.30852 .76335 m
.22688 .84697 L
s
P
p
1 0 .6 r
.005 w
.30852 .76335 m
.25564 .78223 L
s
P
p
1 0 .6 r
.00353 w
.84992 .98552 m
.91416 1.06847 L
s
P
p
1 0 .6 r
.005 w
.77835 .89312 m
.84992 .98552 L
s
P
p
1 0 .6 r
.00353 w
.22688 .84697 m
.15301 .92263 L
s
P
p
1 0 .6 r
.005 w
.77835 .89312 m
.84253 .91965 L
s
P
p
1 0 .6 r
.00707 w
.69861 .79015 m
.77835 .89312 L
s
P
p
1 0 .6 r
.01 w
.60972 .67539 m
.69861 .79015 L
s
P
p
1 0 .6 r
.00353 w
.359 .66815 m
.349 .69259 L
s
P
p
1 0 .6 r
.00707 w
.43578 .58962 m
.3781 .60866 L
s
P
p
1 0 .6 r
.00707 w
.43578 .58962 m
.39542 .6309 L
s
P
p
1 0 .6 r
.01 w
.60972 .67539 m
.61121 .87896 L
s
P
p
1 0 .6 r
.005 w
.39542 .6309 m
.359 .66815 L
s
P
p
1 0 .6 r
.005 w
.39542 .6309 m
.37229 .63867 L
s
P
p
1 0 .6 r
.00353 w
.359 .66815 m
.32615 .70176 L
s
P
p
1 0 .6 r
.00353 w
.25564 .78223 m
.20706 .79957 L
s
P
p
1 0 .6 r
.00353 w
.25564 .78223 m
.22263 .81601 L
s
P
p
1 0 .6 r
.00353 w
.84253 .91965 m
.87136 .95691 L
s
P
p
1 0 .6 r
.00353 w
.84253 .91965 m
.90115 .94388 L
s
P
p
1 0 .6 r
.00353 w
.37229 .63867 m
.35128 .64573 L
s
P
p
1 0 .6 r
.00353 w
.37229 .63867 m
.35765 .65364 L
s
P
p
1 0 .6 r
.005 w
.3781 .60866 m
.32497 .62619 L
s
P
p
1 0 .6 r
.005 w
.3781 .60866 m
.36523 .58723 L
s
P
p
1 0 .6 r
.00707 w
.61121 .87896 m
.61258 1.06775 L
s
P
p
1 0 .6 r
.00707 w
.61121 .87896 m
.5844 .9354 L
s
P
p
1 0 .6 r
.00353 w
.57585 1.17388 m
.54326 1.26805 L
s
P
p
1 0 .6 r
.00353 w
.36523 .58723 m
.35344 .56762 L
s
P
p
1 0 .6 r
.00353 w
.36523 .58723 m
.34387 .59417 L
s
P
p
1 0 .6 r
.00353 w
.57585 1.17388 m
.51418 1.21187 L
s
P
p
1 0 .6 r
.005 w
.61258 1.06775 m
.57585 1.17388 L
s
P
p
1 0 .6 r
.00353 w
.32497 .62619 m
.27614 .6423 L
s
P
p
1 0 .6 r
.00353 w
.32497 .62619 m
.2914 .66044 L
s
P
p
1 0 .6 r
.005 w
.61258 1.06775 m
.61386 1.24237 L
s
P
p
1 0 .6 r
.005 w
.5844 .9354 m
.55919 .98846 L
s
P
p
1 0 .6 r
.005 w
.5844 .9354 m
.62862 .954 L
s
P
p
1 0 .6 r
.00353 w
.61386 1.24237 m
.61503 1.4035 L
s
P
p
1 0 .6 r
.00353 w
.61386 1.24237 m
.6881 1.30917 L
s
P
p
1 0 .6 r
.00353 w
.62862 .954 m
.66941 .97115 L
s
P
p
1 0 .6 r
.00353 w
.62862 .954 m
.61891 .97539 L
s
P
p
1 0 .6 r
.00353 w
.55919 .98846 m
.53559 1.03816 L
s
P
p
1 0 .6 r
.00353 w
.55919 .98846 m
.49715 1.01711 L
s
P
p
1 g
.002 w
.84047 .03801 m
.87498 1.34047 L
s
.87498 1.34047 m
.03801 1.39219 L
s
.03801 1.39219 m
.08254 .1228 L
s
.08254 .1228 m
.84047 .03801 L
s
.84047 .03801 m
.87498 1.34047 L
s
.87498 1.34047 m
.96199 1.49439 L
s
.96199 1.49439 m
.92286 .2919 L
s
.92286 .2919 m
.84047 .03801 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 337}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.705172,
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40001caPG4:/H1000006[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K62<@6000Ze/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0006762<@900?600?4aP00:/H1000005WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP06a0X003W6e/KFa]K6e/KFa]K4eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0005361/@901O600?40000:LH1000004SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H4a0X00274a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/@00P00:LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000oaPC42@0;aP03a<K601c600?40000:LH1000003KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H4a0T005o6e/KFa]K6e/KFa]K6e/KF
a]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP010000;/H2a0X07/H00lC6aP0IaP?400<0a000:<H1000002GFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00;42@00>mK6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KF00W402kFa]H0eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600?400000`0CaP03a<K601_600?4a/H0
1lH9a0c600@0a<H09lH1000005WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP09a010e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0<C60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000RaP805lH00lC6aP0AaP_47LH01034aP0WaP4000008]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H2000Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFaPW405?6e/KFa]K6e/KF
a/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K4eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100008/H00`36000GaP[45<H00lC6aP0JaP050<K4aP009/H1000003CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K62L@0>lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H000?402L0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002;600@0a/H01LH9a0W600?4a/H0
6lH00lC6aP0@aPW400H0a/K4aP0UaP4000009]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K61L@0>/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CF
a]K6e/KFa]H9a00de/KFa]K6e/KF0=K6a<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000RaP050<K6aP005lH00lC6aP0KaPW44/H01P36a/C602G60@00001Ce/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6
e/KFa]K6e/KFa]H02/@0ALKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6a<KF0=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008/H00`36aP03aP030<K601C600?4a/H02<H9a0S6
0`0JaP060<K6a<H09<H10000047Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4eP09a00@e/KFa]K6e/KFa]K6e/KFaPD004?6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60<KFa=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000RaP030<K600C600<0a/H03<H9a1W61@0IaP030<C400?400<0a/H08LH1000002oFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6eP09a00Re/KFa]K6e/KFa=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaPD00136e/KFa]K6e/KFa]K6e/KF2L@0:P36e/K4aP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000RaP030<K600G61L@BaP03a<K601O60`000lC6aP04aP[4
2LH01`36a/K4aP008lH1000005_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o2<@0?LKF
a]K6e/KFa]K6e/KFa]K6e/H0a]K6a<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@00027600<0a/H01lH00`36aP0DaP03a<K600c62/@01Cm?a/K401S600<0a/H00/H00lC6000RaP40
0000AmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KF00[400[6e/KFa]K6e/KF0Sl0ALKFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP36e/KFa=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008LH00`36aP08aP03
0<K600k62/@DaP03?do600;600?4a/H05LH00`36aP02aP04a<K602760@00000ce/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KF00[401k6e/KFa]K6a<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]H2?`0Na]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF1L@08P36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0:aPG44LH00lC6aP0DaP03?do600?6
00?4a/H03LH7a0030<C400?600?4aP008LH1000005_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KF008o00[6e/KFa=K6e/KF2/@0<LKFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@00027600<0a/H02lH00`36aP0CaP03a<K601?600<oCl@02L@00`36aP0>aP03
0<K600G600<0a/H07lH1000005CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/H7a08o04D0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@00027600<0a/H03<H00`36aP0CaP04a<K6aP[41lH00cm?aP0JaP030<K600G600<0a/H07lH10000
043Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K62/@04MK6e/KFa]K6e/KFa]K6e/KF00<o04CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600g600<0a/H0
0/H:a0030<K601W600=??lH06LH00`36aP05aP030<K601o60@00000ae/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP05a00V0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0>aP030<K602O600=??lH06LH00`36
aP05aP030<K601o60@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008LH00`36aP0>aP030<K602O600=??lH06LH00`36aP05aP030<K601o60@00001Le/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0>aP030<K602O6
00=??lH06LH00`36aP05aP030<K601o60@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008LH00`36aP0>aP030<K602O600=??lH06LH00`36aP05aP030<K601o6
0@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36
aP0>aP030<K602O600=??lH06LH00`36aP05aP030<K601o60@00001Le/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0>aP030<K602O600=??lH06LH00`36
aP06aP030<K601k60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`14e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008LH00`36aP0>aP030<K602G600A?a/Ho6/H00`36aP06aP030<K601k60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H03/H00`36aP0SaP03
ClK600;600<oa/H06<H00`36aP06aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H03lH00`36aP0QaP03ClK600C600<oa/H06<H00`36
aP06aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@00023600<0a/H03lH00`36aP0OaP03ClK600K600<oa/H06<H00`36aP06aP030<K601k60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H03lH00`36
aP0MaP03ClK600S600<oa/H06LH00`36aP05aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H03/H00`36aP0<aP03ClK600c600<oClH0
2lH00co6aP0IaP030<K600G600<0a/H07/H1000004cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K60cl0DlHoa]K6e/KF
a]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000PaP030<K600k600<0a/H03<H00dloaP07aP03Cco600;600<oa/H0
2lH00co6aP0IaP030<K600G600<0a/H07/H1000004SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]HoeSoFa]K6e/H2?`1He/KFaSo6e/KFa]K6
e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600k600<0a/H03/H01do6aSm??dl01<H00co6aP0=aP03
?lK601W600<0a/H01LH00`36aP0NaP400000@]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP<o05g6eSoFa]K6?lKFa]K6e/KFa]K6e/KF
a]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@00023600<0a/H03/H00`36aP0;aP03?dlo00C600=?a/H00/H00co6aP0?aP03
?lK601W600<0a/H01LH00`36aP0NaP400000?=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP<o00G6e/KFaP02?`1Le/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008<H00`36aP0>aP030<K600G600@oCcm?1<H01Cm??lHo00?600<oa/H0
4LH00co6aP0IaP030<K600G600<0a/H07/H1000003OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6e/KF008o06W6eSoFa]K6?lHoaSo6e/Hoa]K6e/KFa]K6e/KF
a]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@00023600<0a/H03/H00`36aP06aP03ClK600C600<oaSl00lH00co6
aP0CaP03?lK601W600<0a/H01LH00`36aP0NaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eSoFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600k600<0a/H03<H00dloaP02aP03?lK601G600<oa/H0
6LH00`36aP05aP030<K601k60@000014e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF?mHoe/H2?`1Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100008<H00`36aP0>aP030<K600[600=?aTl00/H00cm?aP0GaP03?do601W600<0a/H0
1LH00`36aP0NaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]Hoe/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000PaP030<K600k600<0a/H03LH00co6?`0IaP04?lK6CaS600<0a/H01LH00`36aP0NaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600k600<0a/H0
2lH01Co6a/Ho01W600Doa/K6?`0GaP030<K600G600<0a/H07/H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0>aP030<K600W600<oa/H00/H00do6
aP0HaP03?lK600?600<oa/H04lH00`36aP05aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03lH00`36aP06aP03Cco600?600=??lH0
6/H00co6aP04aP03ClK601;600<0a/H01/H00`36aP0MaP400000=mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H00cl01MHoe/KF008o0676e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000OaP030<K600o600H0a/I??dl3aP07ClK6?do6
C`0LaP03?lK600K600=?a/H04<H00`36aP06aP030<K601g60@00000ae/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP04?`1]a]K6eSoFaSo6?lHoa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007lH00`36aP0>aP04C`36?`C600Q?a/HoaSo6?ag6
00<oa/H01lH00co6aP0?aP030<K600K600<0a/H07LH1000003oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF03o6e/KF?mK6?lKFa]H00Sl09/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KF0Sl0>LKFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007lH00`36aP0?aP03?lK600;600=?a/H01LH014o6
aSlKaP03?lK600O600<oaSl03lH00`36aP06aP030<K601g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]Hoe/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03lH01036aTl9aP03ClK601c600<oa/H0
1lH013o6aTl>aP030<K600K600<0a/H07LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=Hoe/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100007lH00`36aP0?aP0304o600W600<oa/H07LH00co6aP07aP03?lK600;6
00=?a/H02/H00`36aP06aP030<K601g60@00000ae/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6eP02?`1_a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KF?mK6e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000OaP030<K600k600=??lH0:/H00co6aP07aP03?lK600?600<oa/H0
2/H00`36aP05aP030<K601g60@00001We/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFa]K6eP02?`0ia]K6e/Hoa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000OaP030<K600c600A?aTl0:lH00co6aP07aP03?lHo00G600<oa/H02<H00`36
aP05aP030<K601g60@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KF?mK6?`3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0Be/KFa]K6
e/KFaSo6?lKFa]K60Sl0<=K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000OaP030<K600[600I?a/HoaP0ZaP03Cco600W600A?a/Ho1<H01Do6Ccm?00G600<0a/H0
1LH00`36aP0MaP400000MMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]Ho
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFa]K6e/KFa]K6
?lKF?mK6e/KF?mK6eP02?`0[a]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP0100007lH00`36aP08aP03ClK600C600<0a/H09lH00co6?`09aP06?do6aSm?1LH00do6aP02aP04
?do600O600<0a/H07LH1000006GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6
eP02?`0kaSo6e/KF?mK6e/KF?mK6eSoF?`0oe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001o600<0a/H03lH00`36aP0VaP04Cco6?`[600=?a/H00lH00do6aP03aP0:ClK6aTo6
0<I??`C600<0a/H07LH1000005cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaP<o04?6e/KF
a]K6e/Hoa]K6e/KFa]K6e/Hoa]K6eSl0a]K6?lKFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000OaP030<K600k600<0a/H09/H023o6a/HoaSm?1lH00do6aP0:aP03?lK600;600<0a/H0
1LH00`36aP0MaP400000HMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoF?mH00cl0?]K6
e/Hoa]K6e/KFa]K6e/KFaSo6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001o600<0a/H03/H00`36aP0UaP03ClK600;600<oClH01<H01Do6a/I?00k600@oa/H01lH00`36
aP0MaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6eSoFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP03
0<K600k600<0a/H08lH00dloaP04aP03?lK601S600=?aP001lH00`36aP0MaP400000DmK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00<o02;F?mK6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0:036
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH00`36aP0>aP030<K601k6
00<oClH00/H00do6aP04aP03?lK601S600=?aP001lH00`36aP0MaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6?lKFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo60<KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K600o600<0a/H08lH00do6aP04aP03
?lK601S600A?aP0o1/H00`36aP0MaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo60<Hoa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000NaP030<K600o600<0a/H0:/H00co6aP0JaP040<K6?`G600<0a/H07<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36eSoFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0?aP03
0<K602[600<oa/H06/H01@36a/I?00C600<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF?mK6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0?aP030<K602[600<oa/H06/H00`36aP06aP03
0<K601c60@00001Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
7/H00`36aP0?aP030<K602W600=??lH06lH00`36aP06aP030<K601c60@00001Le/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0?aP030<K602S600<oaSl0
7<H00`36aP06aP030<K601c60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001k600<0a/H03lH00`36aP0XaP03?lHo01c600<0a/H01/H00`36aP0LaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K600o600<0a/H0
9lH014o6aSlLaP030<K600K600<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100007/H00`36aP0?aP030<K602G600=??lH00/H00co6aP0JaP030<K600K6
00<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
7/H00`36aP0?aP030<K602;600@oClI?1<H00co6aP0KaP030<K600G600<0a/H07<H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0?aP030<K60236
00<oa/H00/H00do6aP02aP03?lK601_600<0a/H01LH00`36aP0LaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6eSoFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K600o600<0a/H09<H00co6aP03aP03
?lK601_600<0a/H01LH00`36aP0LaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000NaP030<K600o600<0a/H08lH00do6aP04aP03?do601_600<0a/H01LH00`36
aP0LaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6eSoF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP03
0<K600o600<0a/H08lH00do6aP04aP04?lK6Ca[600<0a/H01LH00`36aP0LaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6eSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K6013600<0a/H0:/H00co6
aP02aP03ClK601K600<0a/H01LH00`36aP0LaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K6013600<0a/H0:/H00co6aP04aP03ClK601C600<0a/H0
1LH00`36aP0LaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000MaP030<K6013600<0a/H0:/H00co6aP06aP03ClK601;600<0a/H01LH00`36aP0LaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K6013600<0a/H0
:/H00co6aP0KaP030<K600G600<0a/H07<H1000007?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF00T002KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000MaP030<K600o600<0a/H0:lH00co6aP03aQ002<H00`36aP06aP030<K601_6
0@00001De/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K63`00?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007LH00`36aP0?aP030<K601;6
4009aP03?lK601c600<0a/H01LH00`36aP0KaP400000==K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/H@001Ne/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000MaP030<K600G63`0YaP03?lK601g600<0a/H01<H00`36aP0KaP4000007MK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00P007g6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007lH00`36aP0=aP030<K602_600<oa/H0
7/H00`36aP03aP030<K601_60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00027600<0a/H02lH00`36aP1>aP050<K6aP007LH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP09aP030<K604o600@0a/H07LH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009LH00`36aP07aP03
0<K6053600<0aP007LH1000002KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP80
07[Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000XaP030<K600C600<0a/H0DLH201g60@000023e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P007LKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000ZaP030<K600;600<0a/H0B/H901g60@00001[e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H04@009]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002c600@0a/H0:/HA03O60@000019e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP0A0018e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002k60P08aQ40FLH1000002oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP09001Ze/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP400000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0157236, -0.0250052, 
  0.00585172, 0.00585172}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.52234 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.22105 1.47772 0.036943 1.47772 [
[ 0 0 0 0 ]
[ 1 1.52234 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.52234 L
0 1.52234 L
closepath
clip
newpath
p
1 g
.002 w
.83899 .03694 m
.87333 1.28126 L
s
.87333 1.28126 m
.03694 1.33325 L
s
.03694 1.33325 m
.08197 .12208 L
s
.08197 .12208 m
.83899 .03694 L
s
.92418 .30472 m
.23554 .37448 L
s
.23554 .37448 m
.20935 1.4854 L
s
.20935 1.4854 m
.96306 1.44364 L
s
.96306 1.44364 m
.92418 .30472 L
s
.83899 .03694 m
.87333 1.28126 L
s
.87333 1.28126 m
.96306 1.44364 L
s
.96306 1.44364 m
.92418 .30472 L
s
.92418 .30472 m
.83899 .03694 L
s
.08197 .12208 m
.23554 .37448 L
s
.23554 .37448 m
.20935 1.4854 L
s
.20935 1.4854 m
.03694 1.33325 L
s
.03694 1.33325 m
.08197 .12208 L
s
p
.4 g
.8478 .06463 m
.09781 .14811 L
s
P
p
.4 g
.88309 .17557 m
.16136 .25256 L
s
P
p
.4 g
.91566 .27793 m
.22014 .34917 L
s
P
p
.4 g
.77311 .04435 m
.86441 .31077 L
s
P
p
.4 g
.54348 .07018 m
.65585 .3319 L
s
P
p
.4 g
.31809 .09552 m
.45077 .35268 L
s
P
p
.4 g
.09681 .12041 m
.24907 .37311 L
s
P
P
p
1 0 .6 r
.0025 w
.38985 .73546 m
.39818 .74849 L
s
P
p
1 0 .6 r
.0025 w
.36183 .76569 m
.34526 .80562 L
s
P
p
1 0 .6 r
.0025 w
.38985 .73546 m
.38239 .75333 L
s
P
p
1 0 .6 r
.02 w
.60181 .23116 m
.60322 .43091 L
s
P
p
1 g
.05 w
.60181 .23116 Mdot
P
p
1 0 .6 r
.0025 w
.69187 .87007 m
.69495 .91076 L
s
P
p
1 0 .6 r
.00353 w
.38046 .72079 m
.38985 .73546 L
s
P
p
1 0 .6 r
.0025 w
.36183 .76569 m
.33752 .79064 L
s
P
p
1 0 .6 r
.00353 w
.38046 .72079 m
.36183 .76569 L
s
P
p
1 0 .6 r
.0025 w
.6678 .83669 m
.64949 .84777 L
s
P
p
1 0 .6 r
.0025 w
.6678 .83669 m
.66925 .85495 L
s
P
p
1 0 .6 r
.0025 w
.69187 .87007 m
.71332 .89772 L
s
P
p
1 0 .6 r
.00353 w
.6884 .82423 m
.69187 .87007 L
s
P
p
1 0 .6 r
.00353 w
.6884 .82423 m
.6678 .83669 L
s
P
p
1 0 .6 r
.005 w
.40146 .67022 m
.38046 .72079 L
s
P
p
1 0 .6 r
.0025 w
.36272 .72159 m
.35525 .73972 L
s
P
p
1 0 .6 r
.0025 w
.36272 .72159 m
.3518 .73279 L
s
P
p
1 0 .6 r
.00353 w
.37108 .70134 m
.36272 .72159 L
s
P
p
1 0 .6 r
.005 w
.68449 .77253 m
.6884 .82423 L
s
P
p
1 0 .6 r
.0025 w
.81134 .92636 m
.81369 .96728 L
s
P
p
1 0 .6 r
.0025 w
.71286 .8279 m
.71419 .84638 L
s
P
p
1 0 .6 r
.005 w
.40146 .67022 m
.37108 .70134 L
s
P
p
1 0 .6 r
.00707 w
.42514 .61317 m
.40146 .67022 L
s
P
p
1 0 .6 r
.0025 w
.26085 .80806 m
.24453 .84855 L
s
P
p
1 0 .6 r
.00353 w
.37108 .70134 m
.34368 .72941 L
s
P
p
1 0 .6 r
.01414 w
.60322 .43091 m
.60454 .61654 L
s
P
p
1 0 .6 r
.01414 w
.60322 .43091 m
.50978 .52655 L
s
P
p
1 0 .6 r
.0025 w
.34368 .72941 m
.31898 .75472 L
s
P
p
1 0 .6 r
.0025 w
.34368 .72941 m
.32784 .73505 L
s
P
p
1 0 .6 r
.0025 w
.71286 .8279 m
.7225 .84034 L
s
P
p
1 0 .6 r
.00353 w
.71137 .80724 m
.71286 .8279 L
s
P
p
1 0 .6 r
.01 w
.50978 .52655 m
.42514 .61317 L
s
P
p
1 0 .6 r
.01 w
.50978 .52655 m
.45679 .54369 L
s
P
p
1 0 .6 r
.0025 w
.73555 .83845 m
.75729 .86651 L
s
P
p
1 0 .6 r
.0025 w
.81134 .92636 m
.83304 .95439 L
s
P
p
1 0 .6 r
.0025 w
.73555 .83845 m
.75483 .84639 L
s
P
p
1 0 .6 r
.00353 w
.71137 .80724 m
.73555 .83845 L
s
P
p
1 0 .6 r
.00353 w
.80868 .88028 m
.81134 .92636 L
s
P
p
1 0 .6 r
.005 w
.68449 .77253 m
.71137 .80724 L
s
P
p
1 0 .6 r
.00707 w
.68006 .71411 m
.68449 .77253 L
s
P
p
1 0 .6 r
.0025 w
.26085 .80806 m
.23596 .83356 L
s
P
p
1 0 .6 r
.00353 w
.27921 .76252 m
.26085 .80806 L
s
P
p
1 0 .6 r
.00707 w
.42514 .61317 m
.34852 .69158 L
s
P
p
1 0 .6 r
.005 w
.34852 .69158 m
.27921 .76252 L
s
P
p
1 0 .6 r
.005 w
.34852 .69158 m
.30389 .70711 L
s
P
p
1 0 .6 r
.0025 w
.86332 .95086 m
.91239 1.01425 L
s
P
p
1 0 .6 r
.0025 w
.86332 .95086 m
.90783 .96952 L
s
P
p
1 0 .6 r
.00353 w
.80868 .88028 m
.86332 .95086 L
s
P
p
1 0 .6 r
.005 w
.74784 .80167 m
.80868 .88028 L
s
P
p
1 0 .6 r
.00353 w
.27921 .76252 m
.21653 .82666 L
s
P
p
1 0 .6 r
.0025 w
.38305 .63119 m
.37539 .64988 L
s
P
p
1 0 .6 r
.005 w
.74784 .80167 m
.80219 .82375 L
s
P
p
1 0 .6 r
.00707 w
.68006 .71411 m
.74784 .80167 L
s
P
p
1 0 .6 r
.0025 w
.21653 .82666 m
.15989 .88463 L
s
P
p
1 0 .6 r
.0025 w
.21653 .82666 m
.17924 .84034 L
s
P
p
1 0 .6 r
.01 w
.60454 .61654 m
.68006 .71411 L
s
P
p
1 0 .6 r
.0025 w
.38305 .63119 m
.37194 .64255 L
s
P
p
1 0 .6 r
.00353 w
.39162 .6103 m
.38305 .63119 L
s
P
p
1 0 .6 r
.00707 w
.45679 .54369 m
.40801 .55947 L
s
P
p
1 0 .6 r
.00707 w
.45679 .54369 m
.42253 .57871 L
s
P
p
1 0 .6 r
.01 w
.60454 .61654 m
.60576 .78857 L
s
P
p
1 0 .6 r
.005 w
.42253 .57871 m
.39162 .6103 L
s
P
p
1 0 .6 r
.005 w
.42253 .57871 m
.40297 .58514 L
s
P
p
1 0 .6 r
.00353 w
.39162 .6103 m
.36374 .63879 L
s
P
p
1 0 .6 r
.0025 w
.36374 .63879 m
.33861 .66448 L
s
P
p
1 0 .6 r
.0025 w
.36374 .63879 m
.34768 .64422 L
s
P
p
1 0 .6 r
.0025 w
.82669 .85542 m
.84871 .8839 L
s
P
p
1 0 .6 r
.00353 w
.30389 .70711 m
.26297 .72135 L
s
P
p
1 0 .6 r
.00353 w
.30389 .70711 m
.27589 .73574 L
s
P
p
1 0 .6 r
.0025 w
.82669 .85542 m
.84649 .86352 L
s
P
p
1 0 .6 r
.00353 w
.80219 .82375 m
.82669 .85542 L
s
P
p
1 0 .6 r
.00353 w
.80219 .82375 m
.85175 .84388 L
s
P
p
1 0 .6 r
.0025 w
.27589 .73574 m
.25065 .76155 L
s
P
p
1 0 .6 r
.0025 w
.27589 .73574 m
.2595 .74151 L
s
P
p
1 0 .6 r
.00353 w
.40297 .58514 m
.38523 .59098 L
s
P
p
1 0 .6 r
.00353 w
.40297 .58514 m
.39056 .59783 L
s
P
p
1 0 .6 r
.0025 w
.39056 .59783 m
.37937 .60925 L
s
P
p
1 0 .6 r
.0025 w
.39056 .59783 m
.38345 .60018 L
s
P
p
1 0 .6 r
.0025 w
.54814 1.11852 m
.57144 1.15736 L
s
P
p
1 0 .6 r
.0025 w
.54814 1.11852 m
.52354 1.19009 L
s
P
p
1 0 .6 r
.0025 w
.38523 .59098 m
.36914 .59627 L
s
P
p
1 0 .6 r
.0025 w
.38523 .59098 m
.38132 .58447 L
s
P
p
1 0 .6 r
.0025 w
.85175 .84388 m
.8969 .86222 L
s
P
p
1 0 .6 r
.0025 w
.85175 .84388 m
.87202 .83231 L
s
P
p
1 0 .6 r
.005 w
.40801 .55947 m
.3632 .57397 L
s
P
p
1 0 .6 r
.005 w
.40801 .55947 m
.39728 .54102 L
s
P
p
1 0 .6 r
.0025 w
.26297 .72135 m
.22553 .73439 L
s
P
p
1 0 .6 r
.0025 w
.26297 .72135 m
.25332 .70748 L
s
P
p
1 0 .6 r
.00707 w
.60576 .78857 m
.60689 .9476 L
s
P
p
1 0 .6 r
.00707 w
.60576 .78857 m
.58302 .83502 L
s
P
p
1 0 .6 r
.00353 w
.57579 1.0381 m
.54814 1.11852 L
s
P
p
1 0 .6 r
.0025 w
.52353 1.07024 m
.51255 1.10246 L
s
P
p
1 0 .6 r
.00353 w
.39728 .54102 m
.38746 .52416 L
s
P
p
1 0 .6 r
.00353 w
.39728 .54102 m
.37927 .54676 L
s
P
p
1 0 .6 r
.00353 w
.57579 1.0381 m
.52353 1.07024 L
s
P
p
1 0 .6 r
.005 w
.60689 .9476 m
.57579 1.0381 L
s
P
p
1 0 .6 r
.00353 w
.3632 .57397 m
.32211 .58727 L
s
P
p
1 0 .6 r
.00353 w
.3632 .57397 m
.33478 .60295 L
s
P
p
1 0 .6 r
.0025 w
.52353 1.07024 m
.47645 1.0992 L
s
P
p
1 0 .6 r
.0025 w
.33478 .60295 m
.30916 .62909 L
s
P
p
1 0 .6 r
.0025 w
.33478 .60295 m
.31832 .60835 L
s
P
p
1 0 .6 r
.0025 w
.37927 .54676 m
.36294 .55197 L
s
P
p
1 0 .6 r
.0025 w
.37927 .54676 m
.37529 .54004 L
s
P
p
1 0 .6 r
.0025 w
.38746 .52416 m
.37851 .50877 L
s
P
p
1 0 .6 r
.0025 w
.38746 .52416 m
.39539 .50457 L
s
P
p
1 0 .6 r
.005 w
.60689 .9476 m
.60793 1.09425 L
s
P
p
1 0 .6 r
.0025 w
.32211 .58727 m
.28449 .59944 L
s
P
p
1 0 .6 r
.0025 w
.32211 .58727 m
.31269 .57225 L
s
P
p
1 0 .6 r
.005 w
.58302 .83502 m
.56175 .87847 L
s
P
p
1 0 .6 r
.005 w
.58302 .83502 m
.62038 .84991 L
s
P
p
1 0 .6 r
.00353 w
.60793 1.09425 m
.60889 1.2292 L
s
P
p
1 0 .6 r
.00353 w
.60793 1.09425 m
.6706 1.14966 L
s
P
p
1 0 .6 r
.0025 w
.6706 1.14966 m
.71167 1.18472 L
s
P
p
1 0 .6 r
.00353 w
.62038 .84991 m
.65474 .86361 L
s
P
p
1 0 .6 r
.00353 w
.62038 .84991 m
.61215 .86741 L
s
P
p
1 0 .6 r
.0025 w
.6706 1.14966 m
.72805 1.20045 L
s
P
p
1 0 .6 r
.0025 w
.60889 1.2292 m
.60977 1.35314 L
s
P
p
1 0 .6 r
.0025 w
.60889 1.2292 m
.55254 1.28146 L
s
P
p
1 0 .6 r
.00353 w
.56175 .87847 m
.54192 .91898 L
s
P
p
1 0 .6 r
.00353 w
.56175 .87847 m
.50944 .90221 L
s
P
p
1 0 .6 r
.0025 w
.61215 .86741 m
.60463 .88338 L
s
P
p
1 0 .6 r
.0025 w
.61215 .86741 m
.62588 .87297 L
s
P
p
1 0 .6 r
.0025 w
.65474 .86361 m
.68629 .87618 L
s
P
p
1 0 .6 r
.0025 w
.65474 .86361 m
.69148 .85945 L
s
P
p
1 0 .6 r
.0025 w
.50944 .90221 m
.46187 .92379 L
s
P
p
1 0 .6 r
.0025 w
.50944 .90221 m
.50119 .9185 L
s
P
p
1 0 .6 r
.0025 w
.54192 .91898 m
.52347 .95665 L
s
P
p
1 0 .6 r
.0025 w
.54192 .91898 m
.57282 .93227 L
s
P
p
1 g
.002 w
.83899 .03694 m
.87333 1.28126 L
s
.87333 1.28126 m
.03694 1.33325 L
s
.03694 1.33325 m
.08197 .12208 L
s
.08197 .12208 m
.83899 .03694 L
s
.83899 .03694 m
.87333 1.28126 L
s
.87333 1.28126 m
.96306 1.44364 L
s
.96306 1.44364 m
.92418 .30472 L
s
.92418 .30472 m
.83899 .03694 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 337}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.705172,
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000M=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61@00:LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001[aPT01<H00`36aP0WaP400000H]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K62@00=lKFa]K6a<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0005W62@0?aP04a<K6aP?40P0XaP400000D=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
2@004lKFa]K6e/KFa]K6e/KFa]K6e/H02L@00lKFaP02000Xe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP400018aPP01/H00lC6aP0:aPW41LH00lC6aP04aP80:<H1000003oFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
2@004mK6e/KFa]K6e/KFa]K6e/CFa]H02<@0?lKFa]K6e/KFa]K6e/KFa/C6e/KFaP360<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000=/H901?62L@GaP03a<K600?600<0aP00
9lH1000002gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02@004mK6
e/KFa=K6e/KFa]K6e/KFa]H02L@0D=K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6
0<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600?4aP00200?aP04
a<K6aPW43lH00lC6aP0HaP03a<K600;600@0a/H09/H10000023Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP@001CFa]K6e/KFa]K6e/KFa]K6e/KFaPS406;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000PaP040<K6a0_62L@5aP03a<K601W600?4a/H05lH00lC6aP02aP04
0<K602K60@00000Pe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H20004e/CFaPW407?6e/KF
a]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/K4a]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000PaP03
0<K400?46<H00lC6aP0IaP03a<K601O600G4a/K60003aP030<K602?60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K60<KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600H0a/H0a/@IaP03a<K601W600?4a/H0
5lH01<C6aP04aP030<K602;60@00001ie/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K60004a00U0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100008<H01`36a/H0a/@06LH00lC6aP0HaP03a<K601762L@00`36aP02aP030<K602;6
0@00001Ve/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K62L@0<lKFa]K6e/K4
aP36e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008<H00`36aP02aP03
0<K401W600?4a/H06<H:a13600C4a/H01<H00`36aP0QaP400000DmK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K60<K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6
e/KF00W404KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H01<H00`36a00HaP03a<K600G62L@8aP<06LH00lC6
0005aP030<K602360@000010e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP[4013Fa]K6e/KFa]K6e/KFa]K61@00@lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/CF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@000236
00<0a/H01LH00`36a00<aPW40lH00lC6aP0DaPD06LH00l@0aP04aP030<K602360@00000^e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36a<KFaPW402?6e/KFa]K6e/KFa]K6a<KF
a]K6e/KFa]K6e/KFa]K6e/KFaP050013a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/@0e/KFa]K60<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007lH00`36aP07aPG45/H00lC6aP0DaP<0
00?6a<H05lH00l@0aP05aP030<K601o60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
eP02?`15a]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000OaP030<K600S600<0a/@06<H00lC6aP0CaP03?do600;600?4a/H0
5/H00`36aP05aP030<K601k60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6eP34a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0O
a]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP05a00Q0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000OaP030<K600W600<0a/@06<H00lC6aP0BaP03?do600?600?4a/H03/H7a003
0<C400G600<0a/H07/H1000005_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFaP36a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KF008o00_6e/KF
a=K6e/KFaP0:a00`e/KFa]K6eP34a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001o600<0a/H02lH00`34aP0HaP03a<K6013600<oClH02/@AaP040<C6aPH07lH1000005?Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6eP08a08o01K4e/KFa/C6e/KFa]K6e/KFa]K6e/KF20009l@0a]K6e/H0
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007lH00`36aP0<aP030<C601S62/@8aP03
?do600C600?4a/H01<H:00K600<0a/H01/H00`36aP0MaP400000?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0<C6e/KFa]K6e/KFa]K6eP0;a00Ae/KFa]K6e/KFa]K6
e/KFa]H00Sl00lKF00030003a00000<003W6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001o600<0a/H03LH00`34aP03aP[42lH00lC6aP08aPH0
00@oCcl06/H00`36aP06aP030<K601g60@00000`e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K61L@05/KFa]K6e/KFa]K6e/KFa]K6e/KFa/@:0007a]K6e/KFaP02?`14
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100007lH00`36aP0>aP030<K400k62P000lC6aP0>aP03Cco601[600<0a/H01/H00`36
aP0MaP400000=mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0
a<KFa]H02P006lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP02?`14e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH00`36
aP0@aP030<@000809LH00dloaP0JaP030<K600K600<0a/H07LH1000005cFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8o04CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K6013600<0a/H09lH00dloaP0JaP03
0<K600K600<0a/H07LH1000005cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000OaP030<K6013600<0a/H09lH00dloaP0JaP030<K600K600<0a/H07LH1000005cFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K6013600<0a/H0
9lH00dloaP0JaP030<K600K600<0a/H07LH1000005cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP8o04CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K6013600<0a/H09lH00dloaP0JaP030<K600K600<0a/H0
7LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH00`36
aP0@aP030<K602G600A?a/Ho6lH00`36aP07aP030<K601c60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H04<H00`36aP0SaP03ClK600;600<oa/H0
6LH00`36aP07aP030<K601c60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001k600<0a/H04LH00`36aP0QaP03ClK600C600<oa/H06LH00`36aP07aP030<K601c6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001k600<0a/H0
4LH00`36aP0=aP03ClI?00o600=?a/H01/H00co6aP0JaP030<K600K600<0a/H07<H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KF?mK6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0AaP030<K600o6
00=?a/H02LH00dloC`0:aP03?lK601[600<0a/H01/H00`36aP0LaP400000A=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaSo60Sl01mK6
e/KFa]H00cl0D]Hoe/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0AaP030<K600g600A??lHo
1<H00dloC`03aP03ClK600[600<oa/H06/H00`36aP06aP030<K601c60@000016e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]Hoe/KFaPDo
05O6e/KF?mK6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001k600<0a/H04<H00`36aP0@aP03Ccm?00;6
00<oa/H00/H00do6aP0<aP03?lK601[600<0a/H01/H00`36aP0LaP400000@=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF?mK6e/H4?`1Ne/KFaSo6
e/KF?mK6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K6013600<0a/H01lH01So6?dloC`;6
00Doa/I??`04aP03ClK600k600<oa/H06/H00`36aP06aP030<K601c60@00000je/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP<o00G6eSoFaP05?`1K
a]K6eSoFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007/H00`36aP0@aP030<K600?600<oCcl0
1<H024o6aSo6?dlo1<H00do6aP0@aP03?lK601[600<0a/H01/H00`36aP0LaP400000>mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF00<o06CFa]K6
?lHoa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001k600<0a/H04<H00`36aP08aP03
ClK600G600E?a/K6C`0DaP03?lK601[600<0a/H01/H00`36aP0LaP400000AmK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF?mK6e/KFa]Hoe/KF008o
05W6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007/H00`36aP0@aP030<K600K600=?a/H0
1LH01Tloa/I??aG600<oClH06/H00`36aP06aP030<K601c60@00000oe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF00Do05kF?mHoe/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001k600<0a/H04<H00`36aP0<aP07ClI?aTo6C`0FaP03
?lHo01[600<0a/H01/H00`36aP0LaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eSoFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000NaP030<K6013600<0a/H02/H01Do6a/I?00;600<oa/H05LH01Co6a/Ho01S6
00<0a/H01/H00`36aP0LaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000NaP030<K6013600<0a/H03<H01Do6a/I?01S600<oa/H00/H00do6aP0EaP030<K600K6
00<0a/H07<H1000003kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFaP8o00?Fa]H00Sl0GLKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eSoF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP0100007/H00`36aP0@aP030<K600O600@oCcm?0/H013m?aTlHaP03?lK600?600<oa/H05<H00`36
aP06aP030<K601c60@00000he/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6eP3FaSo6e/H3?`07a]Hoe/HoaP02?`1Ne/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000NaP030<K6013600P0a/I??dloC`?600Q?a/HoaSo6?aW600<oa/H01LH00co6aP0BaP03
0<K600K600<0a/H07<H1000003;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KF008o00WFa]Hoe/KF?mH00Sl0HlHo?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF
a]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100007LH00`36aP0AaP03?lK600;600m?a/K6ClI??lHoClI?aTl06<H00co6aP05aP03
?do601;600<0a/H01lH00`36aP0KaP400000=MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KF008o06_6eSoFaSo6e/HoaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eSoFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007LH00`36aP0AaP050<K6aSl00/H014o6aSl5aP05?lHoaSl05lH00co6
aP06aP03ClI?017600<0a/H01lH00`36aP0KaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H0e/Hoa]Hoe/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K6017600<0a/H00lH00co6aP06aP03ClK601[600<oa/H0
1/H014o6aSl@aP030<K600O600<0a/H06lH1000003oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/Hoa]K6e/KFa]H00Sl0HLKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]Hoe/KFa]K6e/Hoa]K6?lKFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001g600<0a/H04LH01P36a/HoC`O600=?aTl07<H00co6aP06aP03
Cco600;600<oa/H03<H00`36aP07aP030<K601_60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3FaSo6?lKFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6e/KFa]K6?lHoa]K6?lKFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001g600<0a/H04LH01@36?lHo00W600<oa/H06/H00dloaP07aP04
ClK6?`?600<oCcl02/H00`36aP07aP030<K601_60@00000de/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP0oaP8o02KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP8o01;Fa]K6e/KFaSo6eSoFa]Hoe/H3?`0_a]K6e/KFaP36e/KFa]K6e/H0a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001g600<0a/H04LH013o6?dlVaP03?lHo00S600E?a/Ho
C`03aP03ClK600;600<oCcl01LH00`36aP06aP030<K601_60@00000^e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP<o03@0?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]HoeSoFa]K6e/KF0Sl03lKF?mHoe/KF?mK6e/HoaP02?`0Ze/KF03o6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001g600<0a/H02lH013m??dl2aP040<K6CbG6
00A??dlo1LH013m?aTl2aP05?do6Ccl00/H00do6aP02aP07?lK6ClI?0008aP030<K601_60@00001M
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF?mK6eP3F?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF00<o01WFaSo6?lHoa]Hoe/HoaSo6eSoFa]Ho
e/KF008o02L0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001g600<0a/H0
3<H00do6aP02aP030<K602G600Toa/K6?do6Ccl00/H014loCcl5aP05?lK6aSl01<H00dloC`02aP04
04loC`G600<0a/H06lH1000005gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KF?mK6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]H00Sl00lKF
aP03?`0ma]Hoe/KFa]K6?lKFaSo6e/KF?mHoeP3Fa]Hoe/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100007LH00`36aP0:aP03ClK600C600<0a/H09LH01co6a/HoCcl01LH00cm??`0;aP03
?lK600;600A?a/H02<H00`36aP0KaP400000EmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`19
a]K6eSoFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6?lKFa]HoeP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007LH00`36aP0AaP030<K6023600E??do6C`04aP03?lK600O600<oClH0
2/H00do6aP04aP030<K600K600<0a/H06lH10000057Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl08=K6
eSoFa]K6eSoFa]K6e/KFa]HoeSoFa]K6e/KFa]K60Sl0;=K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001g600<0a/H04LH00`36aP0KaP04?do6C`?600=?a/H01<H00co6
aP07aP03?lK600_600<oClH00lH00`36aP06aP030<K601_60@00001=e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0Sl01/KF?mK6eP8o04_6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFa]H0e/KFa]K6e/H0
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001g600<0a/H04LH00`36aP0HaP03ClK600K6
00@oaSm?1<H00co6aP0EaP04?lK6C`;600<0a/H01/H00`36aP0KaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]HoeP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K6013600<0a/H08LH00do6aP06aP03
?lK601G600<oClH00/H00dl0aP07aP030<K601_60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KF03o6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001g600<0a/H04<H00`36aP0PaP03?lK600O600<oa/H05LH00co6
aP03aP050<HoCcl01<H00`36aP0KaP400000G=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0Sl0A=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF03o6e/Hoa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0001g600<0a/H04<H00`36aP0YaP03Cco601c600<0aSl01/H00`36aP0KaP40
0000G=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0A=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6?lKFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H0
4LH00`36aP0XaP03?lHo01g600@0a/I?1LH00`36aP0KaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]Hoe/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000LaP030<K6017600<0a/H09lH014o6aSlMaP030<K600;6
00E?a/K6000MaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000LaP030<K6017600<0a/H09lH014o6aSlMaP030<K600O600<0a/H06/H1000005SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60Sl0B=K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000LaP030<K6017600<0a/H09<H00co6
?`03aP03?lK601_600<0a/H01lH00`36aP0JaP400000EMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0Sl0BlKF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100007<H00`36aP0AaP030<K6027600E?a/K6C`04aP03?lK601_6
00<0a/H01lH00`36aP0JaP400000D]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`1>e/KFaSo6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001c600<0a/H04LH00`36aP0MaP04Cco6?`C600=?a/H00/H00co6aP0KaP030<K600O6
00<0a/H06/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
7<H00`36aP0AaP030<K601_600E?a/K6C`04aP03?lK600?600<oClH06lH00`36aP07aP030<K601[6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KF?mK6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H0
4LH00`36aP0SaP03ClK600C600@oa/I?6/H00`36aP07aP030<K601[60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04LH00`36aP0SaP03ClK600C6
00<oa/H00/H00do6aP0GaP030<K600K600<0a/H06/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mHoe/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36aP0AaP030<K602;600@oa/I?1<H00co6aP04aP03
Cco601G600<0a/H01/H00`36aP0JaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6
eSoFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000LaP030<K6017600<0a/H08LH00do6aP06aP03?lK600O600<oa/H04/H00`36
aP06aP030<K601[60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF?mK6e/KFa]K6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001c600<0a/H04LH00`36aP0QaP03ClK600K600<oa/H02LH00co6aP0@aP030<K600K600<0a/H0
6/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36
aP0AaP030<K602[600<oa/H02lH00co6aP0>aP030<K600K600<0a/H06/H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36aP0AaP030<K602[600<oa/H0
7<H00`36aP06aP030<K601[60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001_600<0a/H04/H00`36aP0YaP03Cco601g600<0a/H01/H00`36aP0JaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601;600<0a/H0
9lH014o6aSlNaP030<K600K600<0a/H06/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100006lH00`36aP0BaP030<K602G600=?a/H00/H00co6aP0LaP030<K600K6
00<0a/H06/H1000007GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H020009LKFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001_6
00<0a/H04/H00`36aP0ZaP03?lK600O63P07aP030<K600K600<0a/H06/H1000005WFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP0>000ka]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001_600<0a/H04LH00`36aP0IaPh01<H00co6aP0MaP03
0<K600K600<0a/H06LH1000003kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaPd005O6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001_6
00<0a/H04LH?01o600<oa/H07/H00`36aP05aP030<K601W60@00000Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFaPh007;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100006lH700g600<0a/H0:lH00co6aP0OaP030<K600C600<0a/H06LH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0>aP03
0<K602_600<oa/H08<H00`36aP03aP030<K601W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H03<H00`36aP1@aP050<K6aP006lH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H200_600<0a/H0DLH01036
aP0KaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000UaP03
0<K600O600<0a/H0D/H00`36000KaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000WaP030<K600G600<0a/H0DlH201_60@00000Xe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8005_Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0080
01_6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002[600<0a/H00/H00`36aP1;aPX06lH10000
06cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HA000Ua]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000;<H01036aP0ZaQ80=/H1000004WFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF014004SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;/H200S64@1IaP400000;mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00T006[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@000001\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0164977, -0.0250052, 
  0.00582037, 0.00582037}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.48669 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.204995 1.44883 0.0362207 1.44883 [
[ 0 0 0 0 ]
[ 1 1.48669 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.48669 L
0 1.48669 L
closepath
clip
newpath
p
1 g
.002 w
.83819 .03622 m
.87244 1.24103 L
s
.87244 1.24103 m
.03622 1.29324 L
s
.03622 1.29324 m
.08161 .12164 L
s
.08161 .12164 m
.83819 .03622 L
s
.9251 .31347 m
.24153 .38248 L
s
.24153 .38248 m
.21586 1.45047 L
s
.21586 1.45047 m
.96378 1.40919 L
s
.96378 1.40919 m
.9251 .31347 L
s
.83819 .03622 m
.87244 1.24103 L
s
.87244 1.24103 m
.96378 1.40919 L
s
.96378 1.40919 m
.9251 .31347 L
s
.9251 .31347 m
.83819 .03622 L
s
.08161 .12164 m
.24153 .38248 L
s
.24153 .38248 m
.21586 1.45047 L
s
.21586 1.45047 m
.03622 1.29324 L
s
.03622 1.29324 m
.08161 .12164 L
s
p
.4 g
.85346 .08493 m
.10963 .16734 L
s
P
p
.4 g
.88406 .18254 m
.16588 .25909 L
s
P
p
.4 g
.91248 .27322 m
.21825 .34451 L
s
P
p
.4 g
.74063 .04724 m
.8372 .32235 L
s
P
p
.4 g
.5372 .0702 m
.65369 .34087 L
s
P
p
.4 g
.33722 .09278 m
.47297 .35911 L
s
P
p
.4 g
.1406 .11498 m
.29499 .37708 L
s
P
P
p
1 0 .6 r
.00177 w
.41899 .69449 m
.42546 .70493 L
s
P
p
1 0 .6 r
.00177 w
.37226 .74489 m
.37898 .75509 L
s
P
p
1 0 .6 r
.00177 w
.37226 .74489 m
.35914 .7765 L
s
P
p
1 0 .6 r
.00177 w
.41899 .69449 m
.43104 .69019 L
s
P
p
1 0 .6 r
.00177 w
.68104 .83753 m
.6835 .86977 L
s
P
p
1 0 .6 r
.0025 w
.41172 .68276 m
.41899 .69449 L
s
P
p
1 0 .6 r
.00177 w
.68104 .83753 m
.6665 .8462 L
s
P
p
1 0 .6 r
.0025 w
.38699 .70942 m
.37226 .74489 L
s
P
p
1 0 .6 r
.00177 w
.4051 .69862 m
.40803 .70328 L
s
P
p
1 0 .6 r
.00177 w
.4051 .69862 m
.39917 .71284 L
s
P
p
1 0 .6 r
.00177 w
.6409 .78186 m
.62652 .79079 L
s
P
p
1 0 .6 r
.0025 w
.41172 .68276 m
.4051 .69862 L
s
P
p
1 0 .6 r
.00177 w
.6409 .78186 m
.62611 .77578 L
s
P
p
1 0 .6 r
.02 w
.59881 .23761 m
.60004 .41372 L
s
P
p
1 g
.05 w
.59881 .23761 Mdot
P
p
1 0 .6 r
.00177 w
.36556 .73141 m
.35969 .7456 L
s
P
p
1 0 .6 r
.0025 w
.67827 .80132 m
.68104 .83753 L
s
P
p
1 0 .6 r
.00353 w
.40354 .66957 m
.41172 .68276 L
s
P
p
1 0 .6 r
.0025 w
.38699 .70942 m
.36556 .73141 L
s
P
p
1 0 .6 r
.00353 w
.40354 .66957 m
.38699 .70942 L
s
P
p
1 0 .6 r
.0025 w
.65703 .77183 m
.6409 .78186 L
s
P
p
1 0 .6 r
.00177 w
.65832 .78807 m
.65948 .80261 L
s
P
p
1 0 .6 r
.00177 w
.65832 .78807 m
.65186 .79205 L
s
P
p
1 0 .6 r
.00177 w
.36556 .73141 m
.34624 .75122 L
s
P
p
1 0 .6 r
.00177 w
.6972 .82574 m
.69826 .84021 L
s
P
p
1 0 .6 r
.0025 w
.65703 .77183 m
.65832 .78807 L
s
P
p
1 0 .6 r
.00177 w
.6972 .82574 m
.71422 .8477 L
s
P
p
1 0 .6 r
.0025 w
.67827 .80132 m
.6972 .82574 L
s
P
p
1 0 .6 r
.00353 w
.67515 .76058 m
.67827 .80132 L
s
P
p
1 0 .6 r
.00353 w
.67515 .76058 m
.65703 .77183 L
s
P
p
1 0 .6 r
.005 w
.42215 .62473 m
.40354 .66957 L
s
P
p
1 0 .6 r
.00177 w
.38134 .68616 m
.38435 .6909 L
s
P
p
1 0 .6 r
.00177 w
.38134 .68616 m
.37539 .70056 L
s
P
p
1 0 .6 r
.00177 w
.78561 .88667 m
.78756 .91907 L
s
P
p
1 0 .6 r
.00177 w
.78561 .88667 m
.7704 .89522 L
s
P
p
1 0 .6 r
.00177 w
.28382 .78192 m
.29113 .79211 L
s
P
p
1 0 .6 r
.00177 w
.28382 .78192 m
.27088 .81393 L
s
P
p
1 0 .6 r
.0025 w
.38798 .67008 m
.38134 .68616 L
s
P
p
1 0 .6 r
.00177 w
.69787 .78004 m
.69895 .79474 L
s
P
p
1 0 .6 r
.00177 w
.37835 .67994 m
.3757 .68638 L
s
P
p
1 0 .6 r
.00177 w
.69787 .78004 m
.69127 .78408 L
s
P
p
1 0 .6 r
.0025 w
.38798 .67008 m
.37835 .67994 L
s
P
p
1 0 .6 r
.00353 w
.39539 .65213 m
.38798 .67008 L
s
P
p
1 0 .6 r
.005 w
.67163 .71468 m
.67515 .76058 L
s
P
p
1 0 .6 r
.00177 w
.37835 .67994 m
.36968 .68882 L
s
P
p
1 0 .6 r
.0025 w
.78342 .85027 m
.78561 .88667 L
s
P
p
1 0 .6 r
.0025 w
.69667 .76363 m
.69787 .78004 L
s
P
p
1 0 .6 r
.005 w
.42215 .62473 m
.39539 .65213 L
s
P
p
1 0 .6 r
.00707 w
.44313 .57422 m
.42215 .62473 L
s
P
p
1 0 .6 r
.00177 w
.3495 .69912 m
.34358 .71359 L
s
P
p
1 0 .6 r
.0025 w
.29835 .74598 m
.28382 .78192 L
s
P
p
1 0 .6 r
.00353 w
.39539 .65213 m
.37126 .67684 L
s
P
p
1 0 .6 r
.00177 w
.70517 .7746 m
.70565 .78117 L
s
P
p
1 0 .6 r
.01414 w
.60004 .41372 m
.60117 .57694 L
s
P
p
1 0 .6 r
.01414 w
.60004 .41372 m
.51768 .49796 L
s
P
p
1 0 .6 r
.0025 w
.37126 .67684 m
.3495 .69912 L
s
P
p
1 0 .6 r
.0025 w
.37126 .67684 m
.35735 .68169 L
s
P
p
1 0 .6 r
.00177 w
.70517 .7746 m
.71282 .78448 L
s
P
p
1 0 .6 r
.00177 w
.7358 .79755 m
.73679 .81228 L
s
P
p
1 0 .6 r
.0025 w
.69667 .76363 m
.70517 .7746 L
s
P
p
1 0 .6 r
.00177 w
.80256 .87499 m
.80339 .88954 L
s
P
p
1 0 .6 r
.00353 w
.69533 .74529 m
.69667 .76363 L
s
P
p
1 0 .6 r
.00177 w
.3495 .69912 m
.32989 .7192 L
s
P
p
1 0 .6 r
.00177 w
.7358 .79755 m
.75304 .81981 L
s
P
p
1 0 .6 r
.00177 w
.80256 .87499 m
.81977 .89722 L
s
P
p
1 0 .6 r
.01 w
.51768 .49796 m
.44313 .57422 L
s
P
p
1 0 .6 r
.01 w
.51768 .49796 m
.4711 .51281 L
s
P
p
1 0 .6 r
.00177 w
.87234 .92742 m
.87385 .95994 L
s
P
p
1 0 .6 r
.0025 w
.71664 .77281 m
.7358 .79755 L
s
P
p
1 0 .6 r
.00177 w
.27644 .76841 m
.27066 .78279 L
s
P
p
1 0 .6 r
.0025 w
.78342 .85027 m
.80256 .87499 L
s
P
p
1 0 .6 r
.00177 w
.35735 .68169 m
.34477 .68608 L
s
P
p
1 0 .6 r
.00177 w
.35735 .68169 m
.34862 .69063 L
s
P
p
1 0 .6 r
.0025 w
.71664 .77281 m
.7336 .77969 L
s
P
p
1 0 .6 r
.00353 w
.69533 .74529 m
.71664 .77281 L
s
P
p
1 0 .6 r
.00353 w
.78096 .80931 m
.78342 .85027 L
s
P
p
1 0 .6 r
.005 w
.67163 .71468 m
.69533 .74529 L
s
P
p
1 0 .6 r
.00707 w
.66767 .66289 m
.67163 .71468 L
s
P
p
1 0 .6 r
.0025 w
.29835 .74598 m
.27644 .76841 L
s
P
p
1 0 .6 r
.00353 w
.31468 .7056 m
.29835 .74598 L
s
P
p
1 0 .6 r
.00177 w
.27644 .76841 m
.2567 .78862 L
s
P
p
1 0 .6 r
.00177 w
.7336 .77969 m
.74128 .78961 L
s
P
p
1 0 .6 r
.00177 w
.7336 .77969 m
.74892 .78591 L
s
P
p
1 0 .6 r
.00707 w
.44313 .57422 m
.37567 .64321 L
s
P
p
1 0 .6 r
.00177 w
.87234 .92742 m
.91119 .97764 L
s
P
p
1 0 .6 r
.005 w
.37567 .64321 m
.31468 .7056 L
s
P
p
1 0 .6 r
.005 w
.37567 .64321 m
.33657 .65656 L
s
P
p
1 0 .6 r
.0025 w
.8291 .87153 m
.87234 .92742 L
s
P
p
1 0 .6 r
.00177 w
.39939 .60639 m
.40241 .6114 L
s
P
p
1 0 .6 r
.00177 w
.39939 .60639 m
.3933 .6212 L
s
P
p
1 0 .6 r
.0025 w
.8291 .87153 m
.86816 .88766 L
s
P
p
1 0 .6 r
.00353 w
.78096 .80931 m
.8291 .87153 L
s
P
p
1 0 .6 r
.00177 w
.20974 .81293 m
.19696 .84529 L
s
P
p
1 0 .6 r
.005 w
.72736 .74004 m
.78096 .80931 L
s
P
p
1 0 .6 r
.00353 w
.31468 .7056 m
.25955 .76199 L
s
P
p
1 0 .6 r
.0025 w
.40618 .58985 m
.39939 .60639 L
s
P
p
1 0 .6 r
.005 w
.72736 .74004 m
.7751 .75918 L
s
P
p
1 0 .6 r
.00707 w
.66767 .66289 m
.72736 .74004 L
s
P
p
1 0 .6 r
.0025 w
.25955 .76199 m
.20974 .81293 L
s
P
p
1 0 .6 r
.0025 w
.25955 .76199 m
.22696 .77368 L
s
P
p
1 0 .6 r
.01 w
.60117 .57694 m
.66767 .66289 L
s
P
p
1 0 .6 r
.00177 w
.3964 .59985 m
.39369 .60646 L
s
P
p
1 0 .6 r
.0025 w
.40618 .58985 m
.3964 .59985 L
s
P
p
1 0 .6 r
.00353 w
.41376 .57139 m
.40618 .58985 L
s
P
p
1 0 .6 r
.00177 w
.3964 .59985 m
.38759 .60885 L
s
P
p
1 0 .6 r
.00707 w
.4711 .51281 m
.42831 .52646 L
s
P
p
1 0 .6 r
.00707 w
.4711 .51281 m
.44095 .54361 L
s
P
p
1 0 .6 r
.01 w
.60117 .57694 m
.60222 .72782 L
s
P
p
1 0 .6 r
.00177 w
.86816 .88766 m
.88554 .91013 L
s
P
p
1 0 .6 r
.00177 w
.20974 .81293 m
.16475 .85894 L
s
P
p
1 0 .6 r
.00177 w
.86816 .88766 m
.90366 .90231 L
s
P
p
1 0 .6 r
.00177 w
.81606 .81216 m
.81688 .82705 L
s
P
p
1 0 .6 r
.005 w
.44095 .54361 m
.41376 .57139 L
s
P
p
1 0 .6 r
.005 w
.44095 .54361 m
.4238 .54916 L
s
P
p
1 0 .6 r
.00177 w
.36714 .61902 m
.36108 .63391 L
s
P
p
1 0 .6 r
.00353 w
.41376 .57139 m
.38924 .59644 L
s
P
p
1 0 .6 r
.00177 w
.81606 .81216 m
.83351 .83472 L
s
P
p
1 0 .6 r
.00177 w
.28976 .70439 m
.28386 .71911 L
s
P
p
1 0 .6 r
.0025 w
.38924 .59644 m
.36714 .61902 L
s
P
p
1 0 .6 r
.0025 w
.38924 .59644 m
.37517 .60111 L
s
P
p
1 0 .6 r
.0025 w
.79667 .78707 m
.81606 .81216 L
s
P
p
1 0 .6 r
.00353 w
.33657 .65656 m
.30078 .66878 L
s
P
p
1 0 .6 r
.00353 w
.33657 .65656 m
.31195 .68171 L
s
P
p
1 0 .6 r
.00177 w
.57204 1.05246 m
.59029 1.08324 L
s
P
p
1 0 .6 r
.0025 w
.79667 .78707 m
.81404 .79408 L
s
P
p
1 0 .6 r
.00353 w
.7751 .75918 m
.79667 .78707 L
s
P
p
1 0 .6 r
.00177 w
.52991 1.08123 m
.5106 1.13769 L
s
P
p
1 0 .6 r
.00177 w
.36714 .61902 m
.34721 .63938 L
s
P
p
1 0 .6 r
.00353 w
.7751 .75918 m
.81859 .77661 L
s
P
p
1 0 .6 r
.0025 w
.31195 .68171 m
.28976 .70439 L
s
P
p
1 0 .6 r
.0025 w
.31195 .68171 m
.29761 .68666 L
s
P
p
1 0 .6 r
.00177 w
.40304 .57036 m
.40031 .57704 L
s
P
p
1 0 .6 r
.00177 w
.28976 .70439 m
.26976 .72483 L
s
P
p
1 0 .6 r
.00353 w
.4238 .54916 m
.40824 .5542 L
s
P
p
1 0 .6 r
.00353 w
.4238 .54916 m
.41288 .56032 L
s
P
p
1 0 .6 r
.0025 w
.41288 .56032 m
.40304 .57036 L
s
P
p
1 0 .6 r
.0025 w
.41288 .56032 m
.40665 .56234 L
s
P
p
1 0 .6 r
.00177 w
.81404 .79408 m
.82182 .80414 L
s
P
p
1 0 .6 r
.00177 w
.81404 .79408 m
.82975 .80042 L
s
P
p
1 0 .6 r
.00177 w
.40304 .57036 m
.39419 .5794 L
s
P
p
1 0 .6 r
.00177 w
.22696 .77368 m
.19722 .78435 L
s
P
p
1 0 .6 r
.00177 w
.22696 .77368 m
.20689 .79419 L
s
P
p
1 0 .6 r
.00177 w
.57204 1.05246 m
.56335 1.07766 L
s
P
p
1 0 .6 r
.00177 w
.37517 .60111 m
.36242 .60534 L
s
P
p
1 0 .6 r
.00177 w
.37517 .60111 m
.3663 .61017 L
s
P
p
1 0 .6 r
.00177 w
.40665 .56234 m
.40103 .56417 L
s
P
p
1 0 .6 r
.00177 w
.40665 .56234 m
.40271 .56636 L
s
P
p
1 0 .6 r
.00177 w
.29761 .68666 m
.28463 .69114 L
s
P
p
1 0 .6 r
.00177 w
.29761 .68666 m
.28871 .69576 L
s
P
p
1 0 .6 r
.0025 w
.55156 1.01792 m
.57204 1.05246 L
s
P
p
1 0 .6 r
.00177 w
.52991 1.08123 m
.49308 1.1039 L
s
P
p
1 0 .6 r
.0025 w
.55156 1.01792 m
.52991 1.08123 L
s
P
p
1 0 .6 r
.0025 w
.40824 .5542 m
.39415 .55876 L
s
P
p
1 0 .6 r
.0025 w
.40824 .5542 m
.40485 .5484 L
s
P
p
1 0 .6 r
.0025 w
.81859 .77661 m
.85816 .79247 L
s
P
p
1 0 .6 r
.0025 w
.81859 .77661 m
.83628 .76618 L
s
P
p
1 0 .6 r
.005 w
.42831 .52646 m
.38906 .53897 L
s
P
p
1 0 .6 r
.005 w
.42831 .52646 m
.41898 .51005 L
s
P
p
1 0 .6 r
.0025 w
.30078 .66878 m
.26807 .67995 L
s
P
p
1 0 .6 r
.0025 w
.30078 .66878 m
.29246 .65635 L
s
P
p
1 0 .6 r
.00177 w
.40485 .5484 m
.40178 .54316 L
s
P
p
1 0 .6 r
.00177 w
.40485 .5484 m
.39921 .55022 L
s
P
p
1 0 .6 r
.00177 w
.39415 .55876 m
.38139 .56289 L
s
P
p
1 0 .6 r
.00177 w
.39415 .55876 m
.38523 .56786 L
s
P
p
1 0 .6 r
.00707 w
.60222 .72782 m
.60319 .86696 L
s
P
p
1 0 .6 r
.00707 w
.60222 .72782 m
.58223 .76774 L
s
P
p
1 0 .6 r
.00353 w
.57587 .94684 m
.55156 1.01792 L
s
P
p
1 0 .6 r
.00177 w
.85816 .79247 m
.87579 .81531 L
s
P
p
1 0 .6 r
.00177 w
.52029 1.00353 m
.51163 1.02905 L
s
P
p
1 0 .6 r
.00177 w
.85816 .79247 m
.89412 .80689 L
s
P
p
1 0 .6 r
.00177 w
.83628 .76618 m
.85236 .75669 L
s
P
p
1 0 .6 r
.00177 w
.83628 .76618 m
.85218 .77251 L
s
P
p
1 0 .6 r
.00177 w
.52029 1.00353 m
.50378 1.01368 L
s
P
p
1 0 .6 r
.0025 w
.52995 .97506 m
.52029 1.00353 L
s
P
p
1 0 .6 r
.00177 w
.29246 .65635 m
.28488 .64503 L
s
P
p
1 0 .6 r
.00177 w
.29246 .65635 m
.27933 .66078 L
s
P
p
1 0 .6 r
.00353 w
.41898 .51005 m
.41047 .49508 L
s
P
p
1 0 .6 r
.00353 w
.41898 .51005 m
.40321 .51501 L
s
P
p
1 0 .6 r
.00177 w
.34161 .58734 m
.33551 .60255 L
s
P
p
1 0 .6 r
.00353 w
.57587 .94684 m
.52995 .97506 L
s
P
p
1 0 .6 r
.005 w
.60319 .86696 m
.57587 .94684 L
s
P
p
1 0 .6 r
.00177 w
.26807 .67995 m
.23823 .69013 L
s
P
p
1 0 .6 r
.00177 w
.26807 .67995 m
.24778 .70065 L
s
P
p
1 0 .6 r
.00353 w
.38906 .53897 m
.35313 .55042 L
s
P
p
1 0 .6 r
.00353 w
.38906 .53897 m
.36411 .56441 L
s
P
p
1 0 .6 r
.0025 w
.52995 .97506 m
.48858 1.00047 L
s
P
p
1 0 .6 r
.00177 w
.48858 1.00047 m
.45132 1.02336 L
s
P
p
1 0 .6 r
.00177 w
.48858 1.00047 m
.46204 .99639 L
s
P
p
1 0 .6 r
.0025 w
.36411 .56441 m
.34161 .58734 L
s
P
p
1 0 .6 r
.0025 w
.36411 .56441 m
.34971 .56906 L
s
P
p
1 0 .6 r
.00177 w
.34161 .58734 m
.32133 .60802 L
s
P
p
1 0 .6 r
.0025 w
.40321 .51501 m
.38893 .5195 L
s
P
p
1 0 .6 r
.0025 w
.40321 .51501 m
.39977 .50903 L
s
P
p
1 0 .6 r
.00177 w
.34971 .56906 m
.33667 .57326 L
s
P
p
1 0 .6 r
.00177 w
.34971 .56906 m
.34068 .57826 L
s
P
p
1 0 .6 r
.00177 w
.39977 .50903 m
.39665 .50363 L
s
P
p
1 0 .6 r
.00177 w
.39977 .50903 m
.39405 .51082 L
s
P
p
1 0 .6 r
.0025 w
.41047 .49508 m
.40271 .48143 L
s
P
p
1 0 .6 r
.0025 w
.41047 .49508 m
.41747 .47782 L
s
P
p
1 0 .6 r
.00177 w
.38893 .5195 m
.37599 .52357 L
s
P
p
1 0 .6 r
.00177 w
.38893 .5195 m
.3799 .52869 L
s
P
p
1 0 .6 r
.005 w
.60319 .86696 m
.60408 .99499 L
s
P
p
1 0 .6 r
.00177 w
.41747 .47782 m
.4238 .46221 L
s
P
p
1 0 .6 r
.00177 w
.41747 .47782 m
.41439 .47232 L
s
P
p
1 0 .6 r
.0025 w
.35313 .55042 m
.32029 .56089 L
s
P
p
1 0 .6 r
.0025 w
.35313 .55042 m
.345 .53707 L
s
P
p
1 0 .6 r
.00177 w
.40271 .48143 m
.39564 .469 L
s
P
p
1 0 .6 r
.00177 w
.40271 .48143 m
.38973 .48541 L
s
P
p
1 0 .6 r
.005 w
.58223 .76774 m
.56359 .80497 L
s
P
p
1 0 .6 r
.005 w
.58223 .76774 m
.61498 .78028 L
s
P
p
1 0 .6 r
.00177 w
.345 .53707 m
.33759 .52491 L
s
P
p
1 0 .6 r
.00177 w
.345 .53707 m
.33182 .54123 L
s
P
p
1 0 .6 r
.00177 w
.32029 .56089 m
.29032 .57045 L
s
P
p
1 0 .6 r
.00177 w
.32029 .56089 m
.29972 .58183 L
s
P
p
1 0 .6 r
.00353 w
.60408 .99499 m
.6049 1.11257 L
s
P
p
1 0 .6 r
.00353 w
.60408 .99499 m
.65899 1.04292 L
s
P
p
1 0 .6 r
.00177 w
.69502 1.07385 m
.7273 1.10155 L
s
P
p
1 0 .6 r
.00177 w
.69502 1.07385 m
.71509 1.09136 L
s
P
p
1 0 .6 r
.0025 w
.65899 1.04292 m
.69502 1.07385 L
s
P
p
1 0 .6 r
.00353 w
.61498 .78028 m
.64505 .79178 L
s
P
p
1 0 .6 r
.00353 w
.61498 .78028 m
.60775 .79526 L
s
P
p
1 0 .6 r
.0025 w
.65899 1.04292 m
.70925 1.08678 L
s
P
p
1 0 .6 r
.0025 w
.6049 1.11257 m
.60565 1.22036 L
s
P
p
1 0 .6 r
.0025 w
.6049 1.11257 m
.55553 1.1577 L
s
P
p
1 0 .6 r
.00353 w
.56359 .80497 m
.54626 .83956 L
s
P
p
1 0 .6 r
.00353 w
.56359 .80497 m
.51779 .82548 L
s
P
p
1 0 .6 r
.0025 w
.60775 .79526 m
.60115 .80891 L
s
P
p
1 0 .6 r
.0025 w
.60775 .79526 m
.61976 .79992 L
s
P
p
1 0 .6 r
.00177 w
.60565 1.22036 m
.62734 1.27852 L
s
P
p
1 0 .6 r
.0025 w
.64505 .79178 m
.6726 .80233 L
s
P
p
1 0 .6 r
.0025 w
.64505 .79178 m
.67721 .78805 L
s
P
p
1 0 .6 r
.00177 w
.70925 1.08678 m
.75517 1.12686 L
s
P
p
1 0 .6 r
.00177 w
.70925 1.08678 m
.71967 1.09635 L
s
P
p
1 0 .6 r
.00177 w
.61976 .79992 m
.63065 .80415 L
s
P
p
1 0 .6 r
.00177 w
.61976 .79992 m
.61715 .8054 L
s
P
p
1 0 .6 r
.00177 w
.55553 1.1577 m
.51045 1.1989 L
s
P
p
1 0 .6 r
.00177 w
.55553 1.1577 m
.54545 1.16804 L
s
P
p
1 0 .6 r
.00177 w
.67721 .78805 m
.70626 .78467 L
s
P
p
1 0 .6 r
.00177 w
.67721 .78805 m
.68831 .79224 L
s
P
p
1 0 .6 r
.0025 w
.51779 .82548 m
.47617 .84412 L
s
P
p
1 0 .6 r
.0025 w
.51779 .82548 m
.5106 .83939 L
s
P
p
1 0 .6 r
.00177 w
.60565 1.22036 m
.60633 1.31899 L
s
P
p
1 0 .6 r
.00177 w
.60115 .80891 m
.59514 .82135 L
s
P
p
1 0 .6 r
.00177 w
.60115 .80891 m
.58467 .81633 L
s
P
p
1 0 .6 r
.00177 w
.47617 .84412 m
.44744 .84741 L
s
P
p
1 0 .6 r
.00177 w
.47617 .84412 m
.4384 .86104 L
s
P
p
1 0 .6 r
.00177 w
.5106 .83939 m
.50406 .85205 L
s
P
p
1 0 .6 r
.00177 w
.5106 .83939 m
.49388 .8469 L
s
P
p
1 0 .6 r
.00177 w
.6726 .80233 m
.69781 .81197 L
s
P
p
1 0 .6 r
.00177 w
.6726 .80233 m
.66696 .81479 L
s
P
p
1 0 .6 r
.0025 w
.54626 .83956 m
.5302 .87163 L
s
P
p
1 0 .6 r
.0025 w
.54626 .83956 m
.5733 .85066 L
s
P
p
1 0 .6 r
.00177 w
.5733 .85066 m
.59804 .86081 L
s
P
p
1 0 .6 r
.00177 w
.5733 .85066 m
.56703 .86355 L
s
P
p
1 0 .6 r
.00177 w
.5302 .87163 m
.51536 .90128 L
s
P
p
1 0 .6 r
.00177 w
.5302 .87163 m
.49189 .88901 L
s
P
p
1 g
.002 w
.83819 .03622 m
.87244 1.24103 L
s
.87244 1.24103 m
.03622 1.29324 L
s
.03622 1.29324 m
.08161 .12164 L
s
.08161 .12164 m
.83819 .03622 L
s
.83819 .03622 m
.87244 1.24103 L
s
.87244 1.24103 m
.96378 1.40919 L
s
.96378 1.40919 m
.9251 .31347 L
s
.9251 .31347 m
.83819 .03622 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 337}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.705172,
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000MMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP05000Xe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40001/aPT01<H00`36aP0VaP400000HmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP09000fe/CFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0005[62@0;aP03a<K600S60P0WaP400000DMK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP09000Oe/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6eP02000Wa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K600400018aPT01<H00lC6aP0FaP03a<K600S60P0WaP400000?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP09000^e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFaP?402T0a03F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000=/H901O600?4a/H04lH:a0?6
00<0aP009/H1000002gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
2@00;=K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K62/@0=]K6e/CFa]K6
e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000TaPT04LH00lC6
aP0FaP_43/H00lC6aP06aP040<K602G60@00000Oe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP05000Ze/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K62/@0B]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001o600<0a/H01LH00lC6aP0EaP03a<K600?62L@:aP03a<K601G600?4a/H01/H01036
aP0UaP4000007mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P006/KFa]K6e/CFa]K6e/KF
a]K6e/KFa]K6e/KF2/@0GLKFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a=K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007lH00`36
0006aP03a<K600K62/@5aP03a<K601K600?4a/H05LH00lC6aP05aP050<K6aP009<H1000002OFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]H02/@0LLKFa]K6e/KFa]K6e/KFa/C6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6eP3Fa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000OaP030<K600G40/H00lC6aP0EaP03
a<K601K600?4a/H05LH00lC6aP04aP050<K6aP009<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K60<KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH01@36a/H000K600?4a/H05LH00lC6aP0EaP03a<K601K6
00?4a/H00lH00`34a002a0030<K602760@00001`e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K60<KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6e/KFaPW402T0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100007lH00`36aP02aP030<K600G600?4a/H05<H00lC6aP0EaP03a<K600S62/@3aP03
a<K600C600<0a/H00/H00`36aP0PaP400000G=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]H0e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
2/@0?=K6e/KFa]K6e/KFa]K6a<KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000OaP030<K600?600<0a/H01LH00lC6aP0DaP03a<K600c62/@GaP03a<K600?600<0a/H0
0/H00`36aP0PaP400000B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K62L@02<KFa]K6e/KF0`00A=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001k6
00<0a/H01/H00`36aP04aP03a<K601362L@@aPD05/H00lC6aP02aP030<K600?600<0a/H07lH10000
03OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6a<KFa]K6e/KF00[4
01W6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K600D004?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/H0
a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000NaP030<K600O600<0a/H0
0lH9a0o600?4a/H04LH501O600G4a/K60005aP030<K601o60@00000Ye/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H01L@0;MK6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6eP030014a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFaP36e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP08aP030<K600C600?4a/H05<H00lC6
aP0AaP05?do6a/@05/H01LC6a/H000K600<0a/H07/H1000005_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6
e/KFa]K6e/KF008o0236e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFaP36ePC40240a<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001k600<0a/H02LH00`36aP04aP03a<K601C600?4a/H0
4<H00cm?aP02aP03a<K601761/@00`34a005aP030<K601g60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]K6eP02?`0>a]K6a<KFa]K6e/KFa]H9a00^e/KFa=K60<KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K600_600<0a/H00lH00lC6aP0DaP03a<K600o6
00<oClH00lH:a0g600?4aP001lH00`36aP0MaP400000F=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K60<KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/H3a08o1L@0@=K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4aP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100007/H00`36aP0<aP030<K600C600?4a/H04lH00lC6aP02aPW40lH00cm?
aP03aP03a<K601C600?4aP000lH601k60@000016e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KF0=K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFaPW400c6e/KFa]K6e/KFa]H2?`0G
a]K6e/K4a]K6e/KFa]K6e/KFa]K6e/H01@000l@00002000Te/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0001k600<0a/H03LH00`36aP04aP03a<K600G62L@5aP03a<K600g600<oClH0
1<H00lC6aP05aPX01/H00`36aP06aP030<K601c60@00000de/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFaPW401k6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KF
a]H2?`03a]K600<000?400001000>=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001k600<0a/H03/H5a0;600?4a/H04lH00lC6aP06aPH000<oC`00
0P0JaP030<K600K600<0a/H07<H1000004_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]H00P000l@000050006a]K6e/KF
0Sl0ALKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007/H00`36aP0?aP030<K600C600?4a/H01lH:013600<oClH07<H00`36
aP06aP030<K601c60@00000ie/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6eP3400P001[6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP8o04G6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@0001k600<0a/H04LH502C600<oClH07<H00`36aP06aP030<K601c60@00001Ke/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP02?`15a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF
a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000NaP030<K6017600<0a/H09/H00cm?
aP0LaP030<K600K600<0a/H07<H1000005_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o
04G6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001k600<0a/H04LH00`36aP0VaP03?do601c600<0a/H01/H00`36aP0LaP40
0000FmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl0ALKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007LH00`36
aP0BaP030<K602K600<oClH07<H00`36aP07aP030<K601_60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001g600<0a/H04/H00`36aP0TaP04?lK6Cag600<0a/H0
1lH00`36aP0KaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000MaP030<K601;600<0a/H03lH014o6aSl?aP03?lK600;600=?a/H06lH00`36aP07aP030<K601_6
0@000016e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/HoaP8o05[Fa]K6e/KFa]K6e/KFaSo6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36
aP0BaP030<K600k600DoCco6?`0=aP03?lK600C600=?a/H06lH00`36aP07aP030<K601_60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6?lKFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001g600<0a/H04/H00`36
aP0?aP03ClI?00_600=??lH02<H00co6aP0KaP030<K600K600<0a/H06lH1000004CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP@o
00OFa]K6e/KF00@o04o6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF
a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000MaP030<K601;600<0a/H03/H01Cm?
?lHo00?600@oCcm?0/H00co6aP09aP03?lK601_600<0a/H01/H00`36aP0KaP400000AmK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]Hoe/KFaSo6
e/KF00Do05KFa]K6?lKFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K601;600<0a/H02<H00cm?
aP04aP03Ccm?00?600=?a/H00/H00co6aP0;aP03?lK601_600<0a/H01/H00`36aP0KaP400000@MK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaSo6
?lKF00<o00CF?mK60Sl0F=K6e/Hoa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36aP0BaP03
0<K600S600HoCcm?aTl2aP05?dloaSl00lH00co6aP0=aP03?lK601_600<0a/H01/H00`36aP0KaP40
0000>]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/H3?`06a]K6eSoF13l0FlHoa]K6?lKFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001g600<0a/H0
4LH00`36aP04aP04Cco6?`;600Y??do6Cco6?lHo0lH00co6aP0?aP03?lK601_600<0a/H01/H00`36
aP0KaP400000?MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/Hoa]H00cl01=K6e/H3?`1Ka]K6?lKFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
7LH00`36aP0AaP030<K600G600<oa/H00/H00do6aP04aP06?do6aSm?4/H00co6aP0KaP030<K600K6
00<0a/H06lH1000003gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KF008o00G6e/KFaP02?`0Ge/Ho?mK6e/KFa]K6e/KFa]K6e/KFa]H00Sl0@lKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001g600<0a/H04LH00`36aP08aP03Cco600;600ToCcm??lHoaSl04lH00co6?`0KaP03
0<K600K600<0a/H06lH10000043Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6eSoFa]K61cl0FlHoa]K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@0001c600<0a/H04/H00`36aP0=aP05?lK6Ccl00/H00do6aP0BaP04?lK6Ca[600<0a/H01/H00`36
aP0KaP400000@=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/H2?`1Pe/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c6
00<0a/H04/H00`36aP0;aP05?do6aSl00/H00dloaP0DaP03?lK600;600=?a/H05/H00`36aP06aP03
0<K601_60@000011e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6eSoFa]K6e/Hoa]H00Sl0GlKF?co6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/Hoa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000LaP030<K601;600<0a/H00lH00co6aP04aP04Ccm??`;600=?aTl05/H00co6aP03aP03?lK601G6
00<0a/H01lH00`36aP0JaP400000=]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFaP<o00?6eSl00Sl01MK6?lKF008o05g6?lKFa]K6e/KFa]K6e/KFa]K6e/KF
a]Hoe/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001c600<0a/H04/H00`36aP03aP06?dloClI?0/H01co6aTloaSl05lH00co6
aP04aP03ClK601C600<0a/H01lH00`36aP0JaP400000==K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/H3?`0:a]K6eSoFaSo6eP<o023F?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36aP0BaP0404loC`?600=??dl00/H02Sm??dloClI?
aTlFaP03?lK600C600=?aTl05<H00`36aP07aP030<K601[60@00000ge/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6eP02?`07a]K6?lHoaP05?`1MaSlo?lKF
a]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000LaP030<K601;600<0ClH00lH01Co6a/Ho00;6
00]??lK6ClI??do6C`0DaP03?lK600G600@oa/I?4/H00`36aP07aP030<K601[60@00000me/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eSoFaSo6eP02?`04
a]K6eP8o05g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KF
a]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001c600<0a/H04/H00`36
aP02aP07Cco6?do6C`05aP03Cco601S600<oa/H01LH01Co6a/Ho017600<0a/H01lH00`36aP0JaP40
0000>=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF?mK6
0Sl01mK6e/KFa]H00Sl08/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]H2?`0ka]K6?lKF
a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001c6
00<0a/H04/H00`36aP03aP03?lHo00K600=?aTl06/H00co6aP05aP03?lHo00?600<oa/H03LH00`36
aP07aP030<K601[60@00000oe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6?lHoa]K6e/KF00<o01[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o00kFa]K6
e/KF?mK6?lKFaP8o03CFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001c600<0a/H04/H01@36a/Ho00;600=?a/H00lH01Do6aSm?01S600<oaSl01lH013o6
aTl3aP05ClI??dl02/H00`36aP07aP030<K601[60@00000ce/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6eP3F008o02o6eSloa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6eSoF?mK6e/KFaP02?`0;e/Ho?mK6eSoFa]H00Sl0;lKFa]K6e/Ho0=K6e/KFa]K6eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000LaP030<K601;600<oCcl00/H00dloaP07aP03
ClK601O600A??dlo1LH00co6?`02aP03Cco600?600Q?a/K6Ccm??`;600A??dl02LH00`36aP0JaP40
0000;]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H3?`0403o6eP<o
02GFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF00@o00O6?coF?mK600Ho00SF?mK6
eSoFaP8o02[Fa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36
aP0=aP06Cco6?lHo0/H014loaSlQaP0G?lK6aSm?aTloaSm??dloCcm?aTo6Ccl01<H024loa/I??dl0
2LH00`36aP0JaP400000=mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/HoaSl0e/KFa]H00Sl09<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eP8o00?6?lH0
0cl04LHo?co6e/KF?mK6?lKFaSo6008o02[Fa]Ho0<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100007<H00`36aP0@aP03?lH000C600=?a/H07/H00cm?aP03aP04?dloC`;600DoaSm?
?`05aP05?lK6aSl00lH013o6?dl2aP04?`0oC`K600<0a/H06/H1000005GFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6?lKF0=K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF008o00G6?lKFaP02?`07e/KFa]K6eP02?`06aSo6e/KF0Sl0<lKFaSo6e/Hoa]K6e/H0
a]Hoe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006lH00`36aP0@aP04ClK602;6
00A?a/Ho0lH00cm??`06aP04ClI??`O600@oa/I?0lH00do6aP03aP0303o600K600<0a/H06/H10000
05;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]Hoe/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl07]K6eSoFa]K6eSoFa]K6e/KFaSo6?lKFa]K6e/KFaP8o
02kFaSloe/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001_600<0a/H0
3/H00dloaP02aP030<K601_600@oCcm?0lH00dloaP04aP03?lK600G600DoClI??`08aP03ClI?00?6
00E?a/K60008aP030<K601[60@00000[e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6eP02?`0Ma]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H01Cl0DlHoaSo6e/HoaSo6e/KF
?mK6e/KFaSo6?lHoaSo6e/KFa]K6?lKF?mK6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000KaP030<K600c600=?a/H01<H00`36aP0FaP03Ccm?00C600Doa/K6?`03aP05
?dloaSl02<H00do6aP09aP05ClK6aTl01LH00`36aP06aP030<K601[60@00001Le/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6eSoFaSo6e/H2?`0De/KFa]K6e/Hoa]K6e/KFa]K6e/H2?`0^e/KF?mK6e/H0a]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601?600<0a/H07lH00cm?
aP07aP03?lK600K600=?a/H02LH00do6C`03aP05Cco6aP002LH00`36aP0IaP400000DMK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP02?`0WaSo6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFaSo6008o
02H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601?600<0a/H0
7<H014o6aSl8aP03Cco601?600E??lHoC`02aP05?lK603l02<H00`36aP0IaP400000G=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K60Sl08=K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFa]Hoe/HoaP36
0cl08LKFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006lH00`36aP0CaP030<K601k6
00=?a/H01lH00dloaP0DaP03?lK600G600<o03l00lH00co6aP02aP030<K601W60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF?`36
?lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001_600<0a/H04/H00`36aP0XaP03
?lHo01G600<oa/H01/H00`36aP07aP030<K601W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0oe/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001_600<0a/H04/H00`36aP0WaP04ClK6?ak600<0?lH01lH00`36
aP0IaP400000FMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o02;6eSoFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00Sl08lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000KaP030<K601;600<0a/H09LH00do6C`02aP03?lK601c600@0?lHo1/H00`36aP0IaP400000E]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0B]Hoe/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP0oeSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001_600<0a/H04/H00`36
aP0RaP05?lK6aSl00lH00co6aP0LaP050<K6aTl01LH00`36aP0IaP400000DmK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF008o04g6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eSoF
a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006lH00`36aP0BaP030<K601k600@oClI?
0lH00do6aP02aP03?lK601c600<0a/H01lH00`36aP0IaP400000C=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`1C
aSo6eSoFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001[600<0a/H04lH00`36aP0KaP06Cco6aTlo1<H00do6
aP02aP03?do601c600<0a/H01lH00`36aP0IaP400000C=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`1De/KF?mHo
e/KF?mK6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001[600<0a/H04lH00`36aP0HaP03?lK600C600=?a/H00/H00co6
aP03aP04?lK6Ca_600<0a/H01lH00`36aP0IaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6
eSoFa]K6eSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000JaP030<K601?600<0a/H08lH00do6C`04aP03?lK600;600=?a/H0
5lH00`36aP07aP030<K601W60@00001Se/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KF?mK6
e/KF008o03g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000JaP030<K601?600<0a/H08/H01Co6a/Ho00?600<oa/H01LH00cm?aP0DaP03
0<K600O600<0a/H06LH1000006KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]Hoe/KFa]K6
e/H2?`0je/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000JaP030<K601?600<0a/H08/H01So6aTo6C`;600<oa/H01lH00cm?aP0BaP030<K600O6
00<0a/H06LH1000005?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0Ca]K6?lKF?mHoe/KFa]K6e/KF
aP02?`0he/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100006/H00`36aP0CaP030<K601o600=?aTl02<H00co6aP09aP03?do6013600<0a/H02<H00`36
aP0HaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6eSoFa]K6e/KFa]K6e/KF?mK6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000JaP03
0<K601?600<0a/H07LH014o6aSl9aP03?lK600c600=?a/H03/H00`36aP07aP030<K601S60@00001L
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006/H00`36aP0CaP03
0<K6023600<oa/H01LH00co6?`0@aP03ClK600c600<0a/H01lH00`36aP0HaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000JaP030<K601?600<0a/H07lH00do6
aP04aP05?lK6aSl07lH00`36aP07aP030<K601S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001[600<0a/H04lH00`36aP0TaP03?lK600?600<oa/H07LH00`36
aP07aP030<K601S60@00001Fe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`1:e/KFa]Hoe/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100006/H00`36aP0CaP030<K602;600<oClH01LH00co6aP0MaP030<K600O600<0a/H06<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006/H00`36aP0CaP03
0<K6023600<oa/H01lH00co6aP0MaP030<K600O600<0a/H06<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0DaP030<K602[600<oa/H07LH00`36
aP07aP030<K601S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001W600<0a/H05<H00`36aP0ZaP03?lK601g600<0a/H01lH00`36aP0HaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000IaP030<K601C600<0a/H0:/H00cm?
aP0EaPT02LH00`36aP0HaP400000GMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`05
a]K6e/H04@00;LKFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
6LH00`36aP0DaP030<K602364@0JaP030<K600K600<0a/H06<H1000004?Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF010004o6e/KF
a]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000IaP030<K601C600<0aP00400JaP03?lHo01o600<0a/H01LH00`36
aP0HaP4000008MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP0A001`e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000IaPP03/H00`36aP0[aP03
?lK6023600<0a/H01<H00`36aP0HaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000LaP030<K6013600<0a/H0:lH00co6aP0QaP030<K600C600<0a/H05lH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0>aP03
0<K602_600<oa/H08/H00`36aP03aP030<K601O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002360P0=aP030<K6057600<0a/H00/H00`36aP0GaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000SaP030<K600W600<0a/H0
D/H01@36a/H001W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002G600<0a/H01lH00`36aP1DaP030<H001W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H01LH00`36aP1EaP806LH1000002SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P00GMK6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP02000Ia]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000:/H00`36aP02aP030<K604g6
2P0IaP400000KMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
4P008lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000/aP040<K602_64P0eaP40
0000B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K64@00AlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000^aP802<HB05S60@00000_e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02@00J]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0170058, -0.0250051, 
  0.00579741, 0.00579741}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.46102 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.193405 1.42812 0.0357029 1.42812 [
[ 0 0 0 0 ]
[ 1 1.46102 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.46102 L
0 1.46102 L
closepath
clip
newpath
p
1 g
.002 w
.83773 .0357 m
.87192 1.21206 L
s
.87192 1.21206 m
.0357 1.26444 L
s
.0357 1.26444 m
.08137 .12136 L
s
.08137 .12136 m
.83773 .0357 L
s
.92577 .31981 m
.24596 .38825 L
s
.24596 .38825 m
.22067 1.42532 L
s
.22067 1.42532 m
.9643 1.3844 L
s
.9643 1.3844 m
.92577 .31981 L
s
.83773 .0357 m
.87192 1.21206 L
s
.87192 1.21206 m
.9643 1.3844 L
s
.9643 1.3844 m
.92577 .31981 L
s
.92577 .31981 m
.83773 .0357 L
s
.08137 .12136 m
.24596 .38825 L
s
.24596 .38825 m
.22067 1.42532 L
s
.22067 1.42532 m
.0357 1.26444 L
s
.0357 1.26444 m
.08137 .12136 L
s
p
.4 g
.85752 .09956 m
.11826 .18118 L
s
P
p
.4 g
.88481 .18763 m
.16924 .26384 L
s
P
p
.4 g
.91029 .26987 m
.21695 .3412 L
s
P
p
.4 g
.71723 .04935 m
.81778 .33068 L
s
P
p
.4 g
.53272 .07025 m
.6522 .34735 L
s
P
p
.4 g
.35114 .09081 m
.48897 .36378 L
s
P
p
.4 g
.1724 .11105 m
.32803 .37999 L
s
P
P
p
1 0 .6 r
.00125 w
.43984 .66528 m
.44502 .67384 L
s
P
p
1 0 .6 r
.00125 w
.39778 .71065 m
.40315 .71902 L
s
P
p
1 0 .6 r
.00125 w
.37983 .73002 m
.36917 .75568 L
s
P
p
1 0 .6 r
.00125 w
.43984 .66528 m
.435 .67681 L
s
P
p
1 0 .6 r
.00125 w
.39778 .71065 m
.39301 .72211 L
s
P
p
1 0 .6 r
.00125 w
.44491 .65188 m
.45466 .64846 L
s
P
p
1 0 .6 r
.00177 w
.43403 .65569 m
.43984 .66528 L
s
P
p
1 0 .6 r
.00125 w
.67337 .81429 m
.67539 .84048 L
s
P
p
1 0 .6 r
.00125 w
.44491 .65188 m
.44722 .65572 L
s
P
p
1 0 .6 r
.00177 w
.39177 .70126 m
.39778 .71065 L
s
P
p
1 0 .6 r
.00125 w
.37983 .73002 m
.36427 .74599 L
s
P
p
1 0 .6 r
.00177 w
.39177 .70126 m
.37983 .73002 L
s
P
p
1 0 .6 r
.00125 w
.65798 .79294 m
.64626 .80009 L
s
P
p
1 0 .6 r
.00177 w
.43403 .65569 m
.44491 .65188 L
s
P
p
1 0 .6 r
.00125 w
.6218 .74276 m
.61021 .75011 L
s
P
p
1 0 .6 r
.00125 w
.65798 .79294 m
.65891 .80466 L
s
P
p
1 0 .6 r
.00125 w
.42413 .66362 m
.42648 .66745 L
s
P
p
1 0 .6 r
.00125 w
.41611 .67226 m
.41128 .68384 L
s
P
p
1 0 .6 r
.00125 w
.67337 .81429 m
.6871 .83199 L
s
P
p
1 0 .6 r
.00177 w
.67111 .78493 m
.67337 .81429 L
s
P
p
1 0 .6 r
.00125 w
.6218 .74276 m
.62281 .75459 L
s
P
p
1 0 .6 r
.0025 w
.42752 .64492 m
.43403 .65569 L
s
P
p
1 0 .6 r
.00125 w
.42413 .66362 m
.42197 .66878 L
s
P
p
1 0 .6 r
.00177 w
.67111 .78493 m
.65798 .79294 L
s
P
p
1 0 .6 r
.0025 w
.40516 .66902 m
.39177 .70126 L
s
P
p
1 0 .6 r
.00177 w
.4215 .65934 m
.42413 .66362 L
s
P
p
1 0 .6 r
.00125 w
.41611 .67226 m
.40918 .67937 L
s
P
p
1 0 .6 r
.00177 w
.4215 .65934 m
.41611 .67226 L
s
P
p
1 0 .6 r
.00177 w
.63479 .73452 m
.6218 .74276 L
s
P
p
1 0 .6 r
.00125 w
.62143 .72909 m
.61625 .7324 L
s
P
p
1 0 .6 r
.00125 w
.62143 .72909 m
.60944 .72422 L
s
P
p
1 0 .6 r
.00125 w
.38045 .70179 m
.37566 .71336 L
s
P
p
1 0 .6 r
.0025 w
.42752 .64492 m
.4215 .65934 L
s
P
p
1 0 .6 r
.00177 w
.63479 .73452 m
.62143 .72909 L
s
P
p
1 0 .6 r
.00125 w
.6516 .75329 m
.65255 .76515 L
s
P
p
1 0 .6 r
.02 w
.59674 .2423 m
.59783 .40145 L
s
P
p
1 g
.05 w
.59674 .2423 Mdot
P
p
1 0 .6 r
.00125 w
.38045 .70179 m
.37348 .70893 L
s
P
p
1 0 .6 r
.00177 w
.38579 .68888 m
.38045 .70179 L
s
P
p
1 0 .6 r
.0025 w
.66856 .75197 m
.67111 .78493 L
s
P
p
1 0 .6 r
.00125 w
.64471 .74373 m
.63948 .74701 L
s
P
p
1 0 .6 r
.00353 w
.42019 .63282 m
.42752 .64492 L
s
P
p
1 0 .6 r
.00125 w
.68667 .78724 m
.68755 .79905 L
s
P
p
1 0 .6 r
.00125 w
.64471 .74373 m
.64514 .74901 L
s
P
p
1 0 .6 r
.0025 w
.40516 .66902 m
.38579 .68888 L
s
P
p
1 0 .6 r
.00353 w
.42019 .63282 m
.40516 .66902 L
s
P
p
1 0 .6 r
.0025 w
.64936 .72529 m
.63479 .73452 L
s
P
p
1 0 .6 r
.00125 w
.6516 .75329 m
.65774 .76121 L
s
P
p
1 0 .6 r
.00177 w
.65054 .74006 m
.6516 .75329 L
s
P
p
1 0 .6 r
.00177 w
.65054 .74006 m
.64471 .74373 L
s
P
p
1 0 .6 r
.00177 w
.38579 .68888 m
.36832 .70678 L
s
P
p
1 0 .6 r
.00125 w
.36832 .70678 m
.35259 .72291 L
s
P
p
1 0 .6 r
.00125 w
.36832 .70678 m
.35826 .71037 L
s
P
p
1 0 .6 r
.00125 w
.76735 .85835 m
.76898 .88466 L
s
P
p
1 0 .6 r
.00125 w
.68667 .78724 m
.69281 .79517 L
s
P
p
1 0 .6 r
.00177 w
.68568 .77407 m
.68667 .78724 L
s
P
p
1 0 .6 r
.0025 w
.64936 .72529 m
.65054 .74006 L
s
P
p
1 0 .6 r
.00125 w
.75183 .83677 m
.73961 .84384 L
s
P
p
1 0 .6 r
.00125 w
.31861 .74353 m
.32441 .7519 L
s
P
p
1 0 .6 r
.00125 w
.70108 .79394 m
.71493 .81181 L
s
P
p
1 0 .6 r
.00125 w
.70108 .79394 m
.7133 .79896 L
s
P
p
1 0 .6 r
.00177 w
.68568 .77407 m
.70108 .79394 L
s
P
p
1 0 .6 r
.00125 w
.40285 .6521 m
.40527 .656 L
s
P
p
1 0 .6 r
.00125 w
.30031 .76324 m
.28979 .78922 L
s
P
p
1 0 .6 r
.0025 w
.66856 .75197 m
.68568 .77407 L
s
P
p
1 0 .6 r
.00125 w
.39475 .66083 m
.38991 .67256 L
s
P
p
1 0 .6 r
.00353 w
.6657 .71493 m
.66856 .75197 L
s
P
p
1 0 .6 r
.00125 w
.75183 .83677 m
.75259 .84854 L
s
P
p
1 0 .6 r
.00125 w
.40285 .6521 m
.40069 .65733 L
s
P
p
1 0 .6 r
.00353 w
.6657 .71493 m
.64936 .72529 L
s
P
p
1 0 .6 r
.005 w
.43709 .59214 m
.42019 .63282 L
s
P
p
1 0 .6 r
.00125 w
.31861 .74353 m
.31389 .75513 L
s
P
p
1 0 .6 r
.00177 w
.40016 .64775 m
.40285 .6521 L
s
P
p
1 0 .6 r
.00125 w
.76735 .85835 m
.78121 .87625 L
s
P
p
1 0 .6 r
.00125 w
.39475 .66083 m
.38774 .66802 L
s
P
p
1 0 .6 r
.00177 w
.40016 .64775 m
.39475 .66083 L
s
P
p
1 0 .6 r
.00177 w
.76552 .82885 m
.76735 .85835 L
s
P
p
1 0 .6 r
.00177 w
.76552 .82885 m
.75183 .83677 L
s
P
p
1 0 .6 r
.00125 w
.68722 .74584 m
.68811 .75782 L
s
P
p
1 0 .6 r
.00177 w
.31211 .73414 m
.31861 .74353 L
s
P
p
1 0 .6 r
.00125 w
.30031 .76324 m
.28444 .77951 L
s
P
p
1 0 .6 r
.00177 w
.31211 .73414 m
.30031 .76324 L
s
P
p
1 0 .6 r
.0025 w
.40619 .63316 m
.40016 .64775 L
s
P
p
1 0 .6 r
.00125 w
.68028 .73619 m
.67495 .73952 L
s
P
p
1 0 .6 r
.00125 w
.39508 .6479 m
.39292 .65315 L
s
P
p
1 0 .6 r
.00125 w
.68028 .73619 m
.68068 .74153 L
s
P
p
1 0 .6 r
.00125 w
.68722 .74584 m
.69342 .75384 L
s
P
p
1 0 .6 r
.00177 w
.68623 .73248 m
.68722 .74584 L
s
P
p
1 0 .6 r
.00125 w
.39508 .6479 m
.39196 .6511 L
s
P
p
1 0 .6 r
.00177 w
.39749 .64206 m
.39508 .6479 L
s
P
p
1 0 .6 r
.00177 w
.68623 .73248 m
.68028 .73619 L
s
P
p
1 0 .6 r
.0025 w
.40619 .63316 m
.39749 .64206 L
s
P
p
1 0 .6 r
.00353 w
.41292 .61687 m
.40619 .63316 L
s
P
p
1 0 .6 r
.00125 w
.3661 .67242 m
.36127 .68419 L
s
P
p
1 0 .6 r
.005 w
.66249 .67324 m
.6657 .71493 L
s
P
p
1 0 .6 r
.00177 w
.39749 .64206 m
.38966 .65008 L
s
P
p
1 0 .6 r
.00125 w
.38966 .65008 m
.38261 .65729 L
s
P
p
1 0 .6 r
.00125 w
.38966 .65008 m
.38518 .65163 L
s
P
p
1 0 .6 r
.0025 w
.76347 .79573 m
.76552 .82885 L
s
P
p
1 0 .6 r
.00125 w
.84515 .89483 m
.84646 .92123 L
s
P
p
1 0 .6 r
.0025 w
.68513 .71756 m
.68623 .73248 L
s
P
p
1 0 .6 r
.005 w
.43709 .59214 m
.41292 .61687 L
s
P
p
1 0 .6 r
.00707 w
.45611 .54634 m
.43709 .59214 L
s
P
p
1 0 .6 r
.00125 w
.72138 .76153 m
.7222 .77353 L
s
P
p
1 0 .6 r
.00125 w
.78155 .83132 m
.78225 .84318 L
s
P
p
1 0 .6 r
.00125 w
.69324 .73345 m
.69364 .73881 L
s
P
p
1 0 .6 r
.00125 w
.3661 .67242 m
.35903 .67965 L
s
P
p
1 0 .6 r
.00177 w
.37148 .65928 m
.3661 .67242 L
s
P
p
1 0 .6 r
.0025 w
.32533 .70151 m
.31211 .73414 L
s
P
p
1 0 .6 r
.00353 w
.41292 .61687 m
.39112 .63917 L
s
P
p
1 0 .6 r
.00125 w
.69324 .73345 m
.69601 .73701 L
s
P
p
1 0 .6 r
.00177 w
.69281 .72748 m
.69324 .73345 L
s
P
p
1 0 .6 r
.01414 w
.59783 .40145 m
.59883 .54864 L
s
P
p
1 0 .6 r
.01414 w
.59783 .40145 m
.52343 .47752 L
s
P
p
1 0 .6 r
.0025 w
.39112 .63917 m
.37148 .65928 L
s
P
p
1 0 .6 r
.0025 w
.39112 .63917 m
.37861 .64347 L
s
P
p
1 0 .6 r
.00125 w
.69972 .73641 m
.70594 .74444 L
s
P
p
1 0 .6 r
.00125 w
.72138 .76153 m
.72759 .76956 L
s
P
p
1 0 .6 r
.00125 w
.69972 .73641 m
.7052 .73862 L
s
P
p
1 0 .6 r
.00177 w
.69281 .72748 m
.69972 .73641 L
s
P
p
1 0 .6 r
.00177 w
.72046 .74814 m
.72138 .76153 L
s
P
p
1 0 .6 r
.00125 w
.78155 .83132 m
.78775 .83934 L
s
P
p
1 0 .6 r
.0025 w
.68513 .71756 m
.69281 .72748 L
s
P
p
1 0 .6 r
.00177 w
.78076 .81808 m
.78155 .83132 L
s
P
p
1 0 .6 r
.00353 w
.68389 .7009 m
.68513 .71756 L
s
P
p
1 0 .6 r
.00177 w
.37148 .65928 m
.35377 .6774 L
s
P
p
1 0 .6 r
.00125 w
.30029 .7348 m
.29557 .74651 L
s
P
p
1 0 .6 r
.00125 w
.35377 .6774 m
.33782 .69373 L
s
P
p
1 0 .6 r
.00125 w
.35377 .6774 m
.34354 .68097 L
s
P
p
1 0 .6 r
.00125 w
.73603 .76826 m
.75003 .78635 L
s
P
p
1 0 .6 r
.00125 w
.79631 .83818 m
.8103 .85625 L
s
P
p
1 0 .6 r
.00125 w
.84515 .89483 m
.85913 .91289 L
s
P
p
1 0 .6 r
.00125 w
.73603 .76826 m
.74846 .7733 L
s
P
p
1 0 .6 r
.00177 w
.72046 .74814 m
.73603 .76826 L
s
P
p
1 0 .6 r
.00125 w
.79631 .83818 m
.80885 .84334 L
s
P
p
1 0 .6 r
.00177 w
.78076 .81808 m
.79631 .83818 L
s
P
p
1 0 .6 r
.01 w
.52343 .47752 m
.45611 .54634 L
s
P
p
1 0 .6 r
.01 w
.52343 .47752 m
.48143 .49075 L
s
P
p
1 0 .6 r
.00177 w
.84369 .86522 m
.84515 .89483 L
s
P
p
1 0 .6 r
.0025 w
.70315 .72577 m
.72046 .74814 L
s
P
p
1 0 .6 r
.00125 w
.30029 .7348 m
.29318 .74208 L
s
P
p
1 0 .6 r
.00177 w
.30556 .72173 m
.30029 .7348 L
s
P
p
1 0 .6 r
.0025 w
.76347 .79573 m
.78076 .81808 L
s
P
p
1 0 .6 r
.00177 w
.37861 .64347 m
.36728 .64735 L
s
P
p
1 0 .6 r
.00177 w
.37861 .64347 m
.37073 .65153 L
s
P
p
1 0 .6 r
.0025 w
.70315 .72577 m
.71844 .73191 L
s
P
p
1 0 .6 r
.00353 w
.68389 .7009 m
.70315 .72577 L
s
P
p
1 0 .6 r
.00353 w
.76115 .7585 m
.76347 .79573 L
s
P
p
1 0 .6 r
.00125 w
.37073 .65153 m
.36363 .65879 L
s
P
p
1 0 .6 r
.00125 w
.37073 .65153 m
.3662 .65309 L
s
P
p
1 0 .6 r
.005 w
.66249 .67324 m
.68389 .7009 L
s
P
p
1 0 .6 r
.00707 w
.65886 .62624 m
.66249 .67324 L
s
P
p
1 0 .6 r
.0025 w
.32533 .70151 m
.30556 .72173 L
s
P
p
1 0 .6 r
.00353 w
.34018 .66486 m
.32533 .70151 L
s
P
p
1 0 .6 r
.00125 w
.23388 .79101 m
.22347 .81723 L
s
P
p
1 0 .6 r
.00177 w
.30556 .72173 m
.28774 .73997 L
s
P
p
1 0 .6 r
.00125 w
.72538 .74088 m
.73162 .74895 L
s
P
p
1 0 .6 r
.00125 w
.72538 .74088 m
.7309 .7431 L
s
P
p
1 0 .6 r
.00177 w
.71844 .73191 m
.72538 .74088 L
s
P
p
1 0 .6 r
.00177 w
.71844 .73191 m
.73226 .73746 L
s
P
p
1 0 .6 r
.00707 w
.45611 .54634 m
.39522 .60859 L
s
P
p
1 0 .6 r
.00125 w
.28774 .73997 m
.27169 .7564 L
s
P
p
1 0 .6 r
.00125 w
.28774 .73997 m
.27731 .7437 L
s
P
p
1 0 .6 r
.00125 w
.36728 .64735 m
.35704 .65087 L
s
P
p
1 0 .6 r
.00125 w
.36728 .64735 m
.36476 .64338 L
s
P
p
1 0 .6 r
.00125 w
.41937 .57986 m
.42179 .58396 L
s
P
p
1 0 .6 r
.00125 w
.41114 .58871 m
.4062 .60074 L
s
P
p
1 0 .6 r
.00125 w
.87879 .9106 m
.91034 .95138 L
s
P
p
1 0 .6 r
.00125 w
.87879 .9106 m
.9075 .92256 L
s
P
p
1 0 .6 r
.00177 w
.84369 .86522 m
.87879 .9106 L
s
P
p
1 0 .6 r
.00125 w
.41937 .57986 m
.41716 .58522 L
s
P
p
1 0 .6 r
.00125 w
.73226 .73746 m
.74474 .74247 L
s
P
p
1 0 .6 r
.00125 w
.73226 .73746 m
.73776 .73408 L
s
P
p
1 0 .6 r
.005 w
.39522 .60859 m
.34018 .66486 L
s
P
p
1 0 .6 r
.005 w
.39522 .60859 m
.36005 .62042 L
s
P
p
1 0 .6 r
.0025 w
.80463 .81471 m
.84369 .86522 L
s
P
p
1 0 .6 r
.00177 w
.41666 .57528 m
.41937 .57986 L
s
P
p
1 0 .6 r
.00125 w
.41114 .58871 m
.40403 .59598 L
s
P
p
1 0 .6 r
.00177 w
.41666 .57528 m
.41114 .58871 L
s
P
p
1 0 .6 r
.0025 w
.80463 .81471 m
.8398 .82906 L
s
P
p
1 0 .6 r
.00353 w
.76115 .7585 m
.80463 .81471 L
s
P
p
1 0 .6 r
.00125 w
.23388 .79101 m
.21773 .80752 L
s
P
p
1 0 .6 r
.00177 w
.24554 .76162 m
.23388 .79101 L
s
P
p
1 0 .6 r
.005 w
.71275 .69593 m
.76115 .7585 L
s
P
p
1 0 .6 r
.00353 w
.34018 .66486 m
.29045 .7157 L
s
P
p
1 0 .6 r
.0025 w
.42282 .5603 m
.41666 .57528 L
s
P
p
1 0 .6 r
.005 w
.71275 .69593 m
.75577 .71299 L
s
P
p
1 0 .6 r
.00707 w
.65886 .62624 m
.71275 .69593 L
s
P
p
1 0 .6 r
.00125 w
.41154 .57531 m
.40933 .58069 L
s
P
p
1 0 .6 r
.00125 w
.79352 .77437 m
.79421 .78649 L
s
P
p
1 0 .6 r
.0025 w
.29045 .7157 m
.24554 .76162 L
s
P
p
1 0 .6 r
.0025 w
.29045 .7157 m
.2612 .72602 L
s
P
p
1 0 .6 r
.01 w
.59883 .54864 m
.65886 .62624 L
s
P
p
1 0 .6 r
.00125 w
.41154 .57531 m
.40837 .57855 L
s
P
p
1 0 .6 r
.00177 w
.414 .56932 m
.41154 .57531 L
s
P
p
1 0 .6 r
.00125 w
.58901 1.00544 m
.60371 1.03046 L
s
P
p
1 0 .6 r
.0025 w
.42282 .5603 m
.414 .56932 L
s
P
p
1 0 .6 r
.00353 w
.4297 .54358 m
.42282 .5603 L
s
P
p
1 0 .6 r
.00125 w
.5171 1.05455 m
.53208 1.07939 L
s
P
p
1 0 .6 r
.00125 w
.38215 .60001 m
.37722 .6121 L
s
P
p
1 0 .6 r
.00177 w
.414 .56932 m
.40606 .57743 L
s
P
p
1 0 .6 r
.00125 w
.5171 1.05455 m
.50152 1.10026 L
s
P
p
1 0 .6 r
.00125 w
.8555 .84937 m
.86962 .86763 L
s
P
p
1 0 .6 r
.00707 w
.48143 .49075 m
.4429 .5029 L
s
P
p
1 0 .6 r
.00707 w
.48143 .49075 m
.45423 .51853 L
s
P
p
1 0 .6 r
.01 w
.59883 .54864 m
.59976 .68442 L
s
P
p
1 0 .6 r
.00125 w
.40606 .57743 m
.3989 .58474 L
s
P
p
1 0 .6 r
.00125 w
.40606 .57743 m
.40152 .57893 L
s
P
p
1 0 .6 r
.00125 w
.8555 .84937 m
.86827 .8546 L
s
P
p
1 0 .6 r
.00177 w
.8398 .82906 m
.8555 .84937 L
s
P
p
1 0 .6 r
.00125 w
.79352 .77437 m
.7998 .7825 L
s
P
p
1 0 .6 r
.00177 w
.24554 .76162 m
.20498 .80309 L
s
P
p
1 0 .6 r
.00177 w
.8398 .82906 m
.87175 .8421 L
s
P
p
1 0 .6 r
.00177 w
.79275 .76083 m
.79352 .77437 L
s
P
p
1 0 .6 r
.00125 w
.31248 .67687 m
.30768 .68884 L
s
P
p
1 0 .6 r
.005 w
.45423 .51853 m
.4297 .54358 L
s
P
p
1 0 .6 r
.005 w
.45423 .51853 m
.43879 .52347 L
s
P
p
1 0 .6 r
.00125 w
.58901 1.00544 m
.60994 1.00864 L
s
P
p
1 0 .6 r
.00125 w
.38215 .60001 m
.37498 .60734 L
s
P
p
1 0 .6 r
.00177 w
.38765 .58653 m
.38215 .60001 L
s
P
p
1 0 .6 r
.00353 w
.4297 .54358 m
.40758 .56617 L
s
P
p
1 0 .6 r
.00125 w
.20498 .80309 m
.16837 .84051 L
s
P
p
1 0 .6 r
.00125 w
.20498 .80309 m
.18078 .81193 L
s
P
p
1 0 .6 r
.00125 w
.80849 .7812 m
.82266 .79953 L
s
P
p
1 0 .6 r
.00125 w
.80849 .7812 m
.82121 .78633 L
s
P
p
1 0 .6 r
.00177 w
.79275 .76083 m
.80849 .7812 L
s
P
p
1 0 .6 r
.00125 w
.31248 .67687 m
.30529 .68423 L
s
P
p
1 0 .6 r
.00177 w
.31785 .66353 m
.31248 .67687 L
s
P
p
1 0 .6 r
.0025 w
.40758 .56617 m
.38765 .58653 L
s
P
p
1 0 .6 r
.0025 w
.40758 .56617 m
.39492 .57031 L
s
P
p
1 0 .6 r
.0025 w
.77524 .73818 m
.79275 .76083 L
s
P
p
1 0 .6 r
.00353 w
.36005 .62042 m
.3279 .63123 L
s
P
p
1 0 .6 r
.00353 w
.36005 .62042 m
.33786 .64309 L
s
P
p
1 0 .6 r
.00177 w
.57254 .97742 m
.58901 1.00544 L
s
P
p
1 0 .6 r
.0025 w
.77524 .73818 m
.79088 .74443 L
s
P
p
1 0 .6 r
.00353 w
.75577 .71299 m
.77524 .73818 L
s
P
p
1 0 .6 r
.00177 w
.53454 1.00337 m
.5171 1.05455 L
s
P
p
1 0 .6 r
.00177 w
.38765 .58653 m
.36968 .60488 L
s
P
p
1 0 .6 r
.00353 w
.75577 .71299 m
.79492 .72853 L
s
P
p
1 0 .6 r
.00125 w
.41759 .54863 m
.41536 .55406 L
s
P
p
1 0 .6 r
.0025 w
.33786 .64309 m
.31785 .66353 L
s
P
p
1 0 .6 r
.0025 w
.33786 .64309 m
.32498 .64747 L
s
P
p
1 0 .6 r
.00125 w
.5647 1.00026 m
.57131 1.01144 L
s
P
p
1 0 .6 r
.00125 w
.5647 1.00026 m
.55768 1.02075 L
s
P
p
1 0 .6 r
.00125 w
.36968 .60488 m
.35349 .62141 L
s
P
p
1 0 .6 r
.00125 w
.36968 .60488 m
.35932 .60833 L
s
P
p
1 0 .6 r
.00125 w
.41759 .54863 m
.4144 .55189 L
s
P
p
1 0 .6 r
.00177 w
.42007 .54258 m
.41759 .54863 L
s
P
p
1 0 .6 r
.00177 w
.31785 .66353 m
.29981 .68195 L
s
P
p
1 0 .6 r
.00353 w
.43879 .52347 m
.42479 .52794 L
s
P
p
1 0 .6 r
.00353 w
.43879 .52347 m
.42894 .53352 L
s
P
p
1 0 .6 r
.00125 w
.87175 .8421 m
.90074 .85392 L
s
P
p
1 0 .6 r
.00125 w
.87175 .8421 m
.88484 .83482 L
s
P
p
1 0 .6 r
.00125 w
.7979 .75351 m
.80421 .76168 L
s
P
p
1 0 .6 r
.0025 w
.42894 .53352 m
.42007 .54258 L
s
P
p
1 0 .6 r
.0025 w
.42894 .53352 m
.42334 .53532 L
s
P
p
1 0 .6 r
.00125 w
.7979 .75351 m
.80355 .75577 L
s
P
p
1 0 .6 r
.00177 w
.79088 .74443 m
.7979 .75351 L
s
P
p
1 0 .6 r
.00125 w
.29981 .68195 m
.28356 .69855 L
s
P
p
1 0 .6 r
.00125 w
.29981 .68195 m
.28928 .68559 L
s
P
p
1 0 .6 r
.00177 w
.79088 .74443 m
.80502 .75007 L
s
P
p
1 0 .6 r
.00177 w
.42007 .54258 m
.41208 .55073 L
s
P
p
1 0 .6 r
.00177 w
.2612 .72602 m
.23454 .73542 L
s
P
p
1 0 .6 r
.00177 w
.2612 .72602 m
.24311 .7445 L
s
P
p
1 0 .6 r
.00177 w
.57254 .97742 m
.5647 1.00026 L
s
P
p
1 0 .6 r
.00125 w
.41208 .55073 m
.40489 .55807 L
s
P
p
1 0 .6 r
.00125 w
.41208 .55073 m
.40752 .55221 L
s
P
p
1 0 .6 r
.00177 w
.39492 .57031 m
.38347 .57406 L
s
P
p
1 0 .6 r
.00177 w
.39492 .57031 m
.38693 .57848 L
s
P
p
1 0 .6 r
.00125 w
.38693 .57848 m
.37972 .58583 L
s
P
p
1 0 .6 r
.00125 w
.38693 .57848 m
.38234 .57999 L
s
P
p
1 0 .6 r
.00125 w
.24311 .7445 m
.22681 .76115 L
s
P
p
1 0 .6 r
.00125 w
.24311 .7445 m
.23243 .74829 L
s
P
p
1 0 .6 r
.00125 w
.50132 1.0238 m
.49438 1.04429 L
s
P
p
1 0 .6 r
.00177 w
.42334 .53532 m
.41828 .53695 L
s
P
p
1 0 .6 r
.00177 w
.42334 .53532 m
.41978 .53895 L
s
P
p
1 0 .6 r
.00125 w
.41978 .53895 m
.41659 .54221 L
s
P
p
1 0 .6 r
.00125 w
.41978 .53895 m
.41776 .5396 L
s
P
p
1 0 .6 r
.00177 w
.32498 .64747 m
.31332 .65143 L
s
P
p
1 0 .6 r
.00177 w
.32498 .64747 m
.31695 .65566 L
s
P
p
1 0 .6 r
.00125 w
.31695 .65566 m
.30972 .66305 L
s
P
p
1 0 .6 r
.00125 w
.31695 .65566 m
.31228 .65725 L
s
P
p
1 0 .6 r
.00125 w
.80502 .75007 m
.81779 .75517 L
s
P
p
1 0 .6 r
.00125 w
.80502 .75007 m
.81072 .74667 L
s
P
p
1 0 .6 r
.0025 w
.55408 .94602 m
.57254 .97742 L
s
P
p
1 0 .6 r
.00177 w
.53454 1.00337 m
.50132 1.0238 L
s
P
p
1 0 .6 r
.0025 w
.55408 .94602 m
.53454 1.00337 L
s
P
p
1 0 .6 r
.00125 w
.41828 .53695 m
.41372 .53841 L
s
P
p
1 0 .6 r
.00125 w
.41828 .53695 m
.41719 .53506 L
s
P
p
1 0 .6 r
.00125 w
.50132 1.0238 m
.4714 1.04219 L
s
P
p
1 0 .6 r
.0025 w
.42479 .52794 m
.41212 .532 L
s
P
p
1 0 .6 r
.0025 w
.42479 .52794 m
.42176 .52267 L
s
P
p
1 0 .6 r
.00125 w
.38347 .57406 m
.3731 .57746 L
s
P
p
1 0 .6 r
.00125 w
.38347 .57406 m
.38093 .56988 L
s
P
p
1 0 .6 r
.0025 w
.79492 .72853 m
.83051 .74265 L
s
P
p
1 0 .6 r
.0025 w
.79492 .72853 m
.81079 .71894 L
s
P
p
1 0 .6 r
.005 w
.4429 .5029 m
.40762 .51402 L
s
P
p
1 0 .6 r
.005 w
.4429 .5029 m
.43457 .48798 L
s
P
p
1 0 .6 r
.00125 w
.31332 .65143 m
.30278 .65501 L
s
P
p
1 0 .6 r
.00125 w
.31332 .65143 m
.31064 .64739 L
s
P
p
1 0 .6 r
.0025 w
.3279 .63123 m
.29856 .6411 L
s
P
p
1 0 .6 r
.0025 w
.3279 .63123 m
.32051 .61986 L
s
P
p
1 0 .6 r
.00177 w
.42176 .52267 m
.41903 .51789 L
s
P
p
1 0 .6 r
.00177 w
.42176 .52267 m
.41669 .52428 L
s
P
p
1 0 .6 r
.00177 w
.41212 .532 m
.40065 .53567 L
s
P
p
1 0 .6 r
.00177 w
.41212 .532 m
.40408 .54019 L
s
P
p
1 0 .6 r
.00125 w
.40408 .54019 m
.39685 .54757 L
s
P
p
1 0 .6 r
.00125 w
.40408 .54019 m
.39949 .54167 L
s
P
p
1 0 .6 r
.00125 w
.23454 .73542 m
.21026 .74398 L
s
P
p
1 0 .6 r
.00125 w
.23454 .73542 m
.22813 .72668 L
s
P
p
1 0 .6 r
.00125 w
.41669 .52428 m
.41211 .52574 L
s
P
p
1 0 .6 r
.00125 w
.41669 .52428 m
.41559 .52237 L
s
P
p
1 0 .6 r
.00707 w
.59976 .68442 m
.60062 .80942 L
s
P
p
1 0 .6 r
.00707 w
.59976 .68442 m
.58173 .7198 L
s
P
p
1 0 .6 r
.00125 w
.51808 .95596 m
.52482 .96731 L
s
P
p
1 0 .6 r
.00353 w
.576 .88168 m
.55408 .94602 L
s
P
p
1 0 .6 r
.00125 w
.51808 .95596 m
.51107 .97669 L
s
P
p
1 0 .6 r
.00125 w
.41903 .51789 m
.41655 .51358 L
s
P
p
1 0 .6 r
.00125 w
.41903 .51789 m
.42128 .51238 L
s
P
p
1 0 .6 r
.00125 w
.84642 .76326 m
.86073 .78179 L
s
P
p
1 0 .6 r
.00125 w
.84642 .76326 m
.85934 .76841 L
s
P
p
1 0 .6 r
.00177 w
.83051 .74265 m
.84642 .76326 L
s
P
p
1 0 .6 r
.00125 w
.40065 .53567 m
.39027 .53898 L
s
P
p
1 0 .6 r
.00125 w
.40065 .53567 m
.39813 .53138 L
s
P
p
1 0 .6 r
.00177 w
.5259 .93286 m
.51808 .95596 L
s
P
p
1 0 .6 r
.00177 w
.83051 .74265 m
.86285 .75548 L
s
P
p
1 0 .6 r
.00177 w
.81079 .71894 m
.8252 .71023 L
s
P
p
1 0 .6 r
.00177 w
.81079 .71894 m
.82508 .72458 L
s
P
p
1 0 .6 r
.00125 w
.51102 .94199 m
.5079 .95124 L
s
P
p
1 0 .6 r
.00125 w
.35934 .57134 m
.35438 .58367 L
s
P
p
1 0 .6 r
.00177 w
.5259 .93286 m
.51102 .94199 L
s
P
p
1 0 .6 r
.0025 w
.53461 .90708 m
.5259 .93286 L
s
P
p
1 0 .6 r
.00125 w
.51102 .94199 m
.49762 .95022 L
s
P
p
1 0 .6 r
.00125 w
.82508 .72458 m
.838 .72968 L
s
P
p
1 0 .6 r
.00125 w
.82508 .72458 m
.83087 .72111 L
s
P
p
1 0 .6 r
.00177 w
.32051 .61986 m
.31379 .60952 L
s
P
p
1 0 .6 r
.00177 w
.32051 .61986 m
.30874 .62378 L
s
P
p
1 0 .6 r
.00353 w
.43457 .48798 m
.42697 .47438 L
s
P
p
1 0 .6 r
.00353 w
.43457 .48798 m
.4204 .49239 L
s
P
p
1 0 .6 r
.00125 w
.46375 .95058 m
.4568 .97141 L
s
P
p
1 0 .6 r
.00125 w
.35934 .57134 m
.35205 .57877 L
s
P
p
1 0 .6 r
.00177 w
.36488 .55758 m
.35934 .57134 L
s
P
p
1 0 .6 r
.00353 w
.576 .88168 m
.53461 .90708 L
s
P
p
1 0 .6 r
.005 w
.60062 .80942 m
.576 .88168 L
s
P
p
1 0 .6 r
.00177 w
.29856 .6411 m
.27181 .65009 L
s
P
p
1 0 .6 r
.00177 w
.29856 .6411 m
.28028 .65974 L
s
P
p
1 0 .6 r
.00353 w
.40762 .51402 m
.37536 .52419 L
s
P
p
1 0 .6 r
.00353 w
.40762 .51402 m
.38514 .53693 L
s
P
p
1 0 .6 r
.0025 w
.53461 .90708 m
.49733 .92997 L
s
P
p
1 0 .6 r
.00125 w
.28028 .65974 m
.26381 .67653 L
s
P
p
1 0 .6 r
.00125 w
.28028 .65974 m
.26957 .66337 L
s
P
p
1 0 .6 r
.00177 w
.49733 .92997 m
.46375 .95058 L
s
P
p
1 0 .6 r
.00177 w
.49733 .92997 m
.47342 .92617 L
s
P
p
1 0 .6 r
.00125 w
.86285 .75548 m
.89219 .76713 L
s
P
p
1 0 .6 r
.00125 w
.86285 .75548 m
.87608 .74776 L
s
P
p
1 0 .6 r
.0025 w
.38514 .53693 m
.36488 .55758 L
s
P
p
1 0 .6 r
.0025 w
.38514 .53693 m
.37221 .54105 L
s
P
p
1 0 .6 r
.00125 w
.8252 .71023 m
.83829 .70233 L
s
P
p
1 0 .6 r
.00125 w
.8252 .71023 m
.82456 .69771 L
s
P
p
1 0 .6 r
.00125 w
.46375 .95058 m
.4335 .96915 L
s
P
p
1 0 .6 r
.00125 w
.30874 .62378 m
.29808 .62733 L
s
P
p
1 0 .6 r
.00125 w
.30874 .62378 m
.30603 .61966 L
s
P
p
1 0 .6 r
.00177 w
.36488 .55758 m
.34661 .5762 L
s
P
p
1 0 .6 r
.0025 w
.4204 .49239 m
.40757 .49638 L
s
P
p
1 0 .6 r
.0025 w
.4204 .49239 m
.41733 .48696 L
s
P
p
1 0 .6 r
.00125 w
.34661 .5762 m
.33015 .59298 L
s
P
p
1 0 .6 r
.00125 w
.34661 .5762 m
.33604 .57964 L
s
P
p
1 0 .6 r
.00125 w
.47342 .92617 m
.45182 .92275 L
s
P
p
1 0 .6 r
.00125 w
.47342 .92617 m
.45996 .93443 L
s
P
p
1 0 .6 r
.00125 w
.31379 .60952 m
.30768 .60012 L
s
P
p
1 0 .6 r
.00125 w
.31379 .60952 m
.31871 .59716 L
s
P
p
1 0 .6 r
.00177 w
.37221 .54105 m
.36052 .54478 L
s
P
p
1 0 .6 r
.00177 w
.37221 .54105 m
.36408 .54934 L
s
P
p
1 0 .6 r
.00125 w
.36408 .54934 m
.35676 .5568 L
s
P
p
1 0 .6 r
.00125 w
.36408 .54934 m
.3594 .55084 L
s
P
p
1 0 .6 r
.00177 w
.41733 .48696 m
.41455 .48205 L
s
P
p
1 0 .6 r
.00177 w
.41733 .48696 m
.41219 .48855 L
s
P
p
1 0 .6 r
.0025 w
.42697 .47438 m
.42005 .46199 L
s
P
p
1 0 .6 r
.0025 w
.42697 .47438 m
.43331 .45879 L
s
P
p
1 0 .6 r
.00177 w
.40757 .49638 m
.39595 .49999 L
s
P
p
1 0 .6 r
.00177 w
.40757 .49638 m
.39944 .50466 L
s
P
p
1 0 .6 r
.00125 w
.39944 .50466 m
.39212 .51211 L
s
P
p
1 0 .6 r
.00125 w
.39944 .50466 m
.39479 .50611 L
s
P
p
1 0 .6 r
.005 w
.60062 .80942 m
.6014 .92426 L
s
P
p
1 0 .6 r
.00125 w
.41219 .48855 m
.40755 .48999 L
s
P
p
1 0 .6 r
.00125 w
.41219 .48855 m
.41107 .48659 L
s
P
p
1 0 .6 r
.00125 w
.27181 .65009 m
.24745 .65829 L
s
P
p
1 0 .6 r
.00125 w
.27181 .65009 m
.2655 .64086 L
s
P
p
1 0 .6 r
.00125 w
.36052 .54478 m
.34993 .54816 L
s
P
p
1 0 .6 r
.00125 w
.36052 .54478 m
.3579 .54047 L
s
P
p
1 0 .6 r
.00125 w
.41455 .48205 m
.41204 .47761 L
s
P
p
1 0 .6 r
.00125 w
.41455 .48205 m
.41682 .47644 L
s
P
p
1 0 .6 r
.00177 w
.43331 .45879 m
.43904 .4447 L
s
P
p
1 0 .6 r
.00177 w
.43331 .45879 m
.43056 .4538 L
s
P
p
1 0 .6 r
.0025 w
.37536 .52419 m
.34591 .53347 L
s
P
p
1 0 .6 r
.0025 w
.37536 .52419 m
.36813 .51205 L
s
P
p
1 0 .6 r
.00125 w
.39595 .49999 m
.38545 .50326 L
s
P
p
1 0 .6 r
.00125 w
.39595 .49999 m
.3934 .49559 L
s
P
p
1 0 .6 r
.00125 w
.43904 .4447 m
.44637 .43724 L
s
P
p
1 0 .6 r
.00125 w
.43904 .4447 m
.44422 .43197 L
s
P
p
1 0 .6 r
.00125 w
.43056 .4538 m
.42807 .4493 L
s
P
p
1 0 .6 r
.00125 w
.43056 .4538 m
.43285 .44816 L
s
P
p
1 0 .6 r
.00177 w
.42005 .46199 m
.41376 .45072 L
s
P
p
1 0 .6 r
.00177 w
.42005 .46199 m
.40841 .46553 L
s
P
p
1 0 .6 r
.005 w
.58173 .7198 m
.56497 .7527 L
s
P
p
1 0 .6 r
.005 w
.58173 .7198 m
.6112 .73073 L
s
P
p
1 0 .6 r
.00125 w
.40841 .46553 m
.39787 .46873 L
s
P
p
1 0 .6 r
.00125 w
.40841 .46553 m
.40587 .46103 L
s
P
p
1 0 .6 r
.00177 w
.36813 .51205 m
.36155 .501 L
s
P
p
1 0 .6 r
.00177 w
.36813 .51205 m
.35631 .51573 L
s
P
p
1 0 .6 r
.00177 w
.34591 .53347 m
.31905 .54194 L
s
P
p
1 0 .6 r
.00177 w
.34591 .53347 m
.32739 .55231 L
s
P
p
1 0 .6 r
.00125 w
.71229 1.01995 m
.72064 1.02712 L
s
P
p
1 0 .6 r
.00125 w
.32739 .55231 m
.31071 .56928 L
s
P
p
1 0 .6 r
.00125 w
.32739 .55231 m
.31664 .55573 L
s
P
p
1 0 .6 r
.00353 w
.6014 .92426 m
.60212 1.02955 L
s
P
p
1 0 .6 r
.00353 w
.6014 .92426 m
.65079 .96693 L
s
P
p
1 0 .6 r
.00125 w
.41376 .45072 m
.40804 .44048 L
s
P
p
1 0 .6 r
.00125 w
.41376 .45072 m
.41892 .43792 L
s
P
p
1 0 .6 r
.00125 w
.35631 .51573 m
.34562 .51907 L
s
P
p
1 0 .6 r
.00125 w
.35631 .51573 m
.35365 .51132 L
s
P
p
1 0 .6 r
.00125 w
.71229 1.01995 m
.73835 1.04242 L
s
P
p
1 0 .6 r
.00125 w
.36155 .501 m
.35557 .49097 L
s
P
p
1 0 .6 r
.00125 w
.36155 .501 m
.36663 .48826 L
s
P
p
1 0 .6 r
.00177 w
.68323 .99489 m
.71229 1.01995 L
s
P
p
1 0 .6 r
.00125 w
.31905 .54194 m
.2946 .54964 L
s
P
p
1 0 .6 r
.00125 w
.31905 .54194 m
.31286 .53207 L
s
P
p
1 0 .6 r
.00177 w
.68323 .99489 m
.70126 1.01048 L
s
P
p
1 0 .6 r
.0025 w
.65079 .96693 m
.68323 .99489 L
s
P
p
1 0 .6 r
.00353 w
.6112 .73073 m
.63822 .74074 L
s
P
p
1 0 .6 r
.00353 w
.6112 .73073 m
.60468 .74396 L
s
P
p
1 0 .6 r
.00125 w
.70126 1.01048 m
.71292 1.02053 L
s
P
p
1 0 .6 r
.0025 w
.65079 .96693 m
.69594 1.00594 L
s
P
p
1 0 .6 r
.00125 w
.70126 1.01048 m
.71758 1.02458 L
s
P
p
1 0 .6 r
.00125 w
.6223 1.17854 m
.60752 1.20415 L
s
P
p
1 0 .6 r
.0025 w
.60212 1.02955 m
.60278 1.12594 L
s
P
p
1 0 .6 r
.0025 w
.60212 1.02955 m
.55773 1.06968 L
s
P
p
1 0 .6 r
.00125 w
.6223 1.17854 m
.63972 1.22552 L
s
P
p
1 0 .6 r
.00353 w
.56497 .7527 m
.54942 .7832 L
s
P
p
1 0 .6 r
.00353 w
.56497 .7527 m
.52379 .77096 L
s
P
p
1 0 .6 r
.0025 w
.60468 .74396 m
.59874 .75601 L
s
P
p
1 0 .6 r
.0025 w
.60468 .74396 m
.61547 .74801 L
s
P
p
1 0 .6 r
.00177 w
.60278 1.12594 m
.6223 1.17854 L
s
P
p
1 0 .6 r
.0025 w
.63822 .74074 m
.66294 .7499 L
s
P
p
1 0 .6 r
.0025 w
.63822 .74074 m
.66712 .73731 L
s
P
p
1 0 .6 r
.00177 w
.69594 1.00594 m
.73714 1.04155 L
s
P
p
1 0 .6 r
.00177 w
.69594 1.00594 m
.70522 1.01402 L
s
P
p
1 0 .6 r
.00177 w
.61547 .74801 m
.62525 .75169 L
s
P
p
1 0 .6 r
.00177 w
.61547 .74801 m
.61312 .75284 L
s
P
p
1 0 .6 r
.00177 w
.55773 1.06968 m
.51723 1.10628 L
s
P
p
1 0 .6 r
.00177 w
.55773 1.06968 m
.54868 1.07842 L
s
P
p
1 0 .6 r
.00177 w
.66712 .73731 m
.69323 .73421 L
s
P
p
1 0 .6 r
.00177 w
.66712 .73731 m
.67707 .74095 L
s
P
p
1 0 .6 r
.0025 w
.52379 .77096 m
.48641 .78754 L
s
P
p
1 0 .6 r
.0025 w
.52379 .77096 m
.51736 .78322 L
s
P
p
1 0 .6 r
.00125 w
.69323 .73421 m
.70638 .72832 L
s
P
p
1 0 .6 r
.00177 w
.60278 1.12594 m
.60339 1.21404 L
s
P
p
1 0 .6 r
.00125 w
.46057 .79056 m
.43739 .79327 L
s
P
p
1 0 .6 r
.00177 w
.59874 .75601 m
.59333 .76697 L
s
P
p
1 0 .6 r
.00177 w
.59874 .75601 m
.58393 .76261 L
s
P
p
1 0 .6 r
.00125 w
.61312 .75284 m
.61099 .75721 L
s
P
p
1 0 .6 r
.00125 w
.61312 .75284 m
.61703 .75432 L
s
P
p
1 0 .6 r
.00125 w
.69323 .73421 m
.71679 .73141 L
s
P
p
1 0 .6 r
.00125 w
.62525 .75169 m
.63411 .75501 L
s
P
p
1 0 .6 r
.00125 w
.62525 .75169 m
.63568 .75045 L
s
P
p
1 0 .6 r
.00125 w
.46057 .79056 m
.44702 .79656 L
s
P
p
1 0 .6 r
.00177 w
.48641 .78754 m
.46057 .79056 L
s
P
p
1 0 .6 r
.00125 w
.58393 .76261 m
.57055 .76857 L
s
P
p
1 0 .6 r
.00125 w
.58393 .76261 m
.58174 .767 L
s
P
p
1 0 .6 r
.00125 w
.67707 .74095 m
.68608 .74425 L
s
P
p
1 0 .6 r
.00125 w
.67707 .74095 m
.68754 .73971 L
s
P
p
1 0 .6 r
.00125 w
.51723 1.10628 m
.49113 1.12936 L
s
P
p
1 0 .6 r
.00125 w
.73714 1.04155 m
.76363 1.06439 L
s
P
p
1 0 .6 r
.00177 w
.48641 .78754 m
.4525 .80258 L
s
P
p
1 0 .6 r
.00125 w
.73714 1.04155 m
.7747 1.074 L
s
P
p
1 0 .6 r
.00125 w
.51723 1.10628 m
.48034 1.13962 L
s
P
p
1 0 .6 r
.00177 w
.51736 .78322 m
.51152 .79437 L
s
P
p
1 0 .6 r
.00177 w
.51736 .78322 m
.50235 .78989 L
s
P
p
1 0 .6 r
.00177 w
.66294 .7499 m
.68552 .75827 L
s
P
p
1 0 .6 r
.00177 w
.66294 .7499 m
.65784 .76088 L
s
P
p
1 0 .6 r
.00125 w
.59333 .76697 m
.58842 .77694 L
s
P
p
1 0 .6 r
.00125 w
.59333 .76697 m
.60213 .77036 L
s
P
p
1 0 .6 r
.00125 w
.70522 1.01402 m
.71371 1.02142 L
s
P
p
1 0 .6 r
.00125 w
.70522 1.01402 m
.7218 1.02835 L
s
P
p
1 0 .6 r
.00125 w
.50235 .78989 m
.4888 .79592 L
s
P
p
1 0 .6 r
.00125 w
.50235 .78989 m
.49999 .79436 L
s
P
p
1 0 .6 r
.00125 w
.54868 1.07842 m
.54042 1.08642 L
s
P
p
1 0 .6 r
.00125 w
.54868 1.07842 m
.53239 1.09315 L
s
P
p
1 0 .6 r
.00125 w
.60339 1.21404 m
.60394 1.29443 L
s
P
p
1 0 .6 r
.00125 w
.60339 1.21404 m
.61447 1.24118 L
s
P
p
1 0 .6 r
.00125 w
.4525 .80258 m
.42177 .81621 L
s
P
p
1 0 .6 r
.00125 w
.4525 .80258 m
.44693 .81272 L
s
P
p
1 0 .6 r
.0025 w
.54942 .7832 m
.53504 .81141 L
s
P
p
1 0 .6 r
.0025 w
.54942 .7832 m
.57371 .79281 L
s
P
p
1 0 .6 r
.00125 w
.51152 .79437 m
.5062 .80451 L
s
P
p
1 0 .6 r
.00125 w
.51152 .79437 m
.52012 .79785 L
s
P
p
1 0 .6 r
.00125 w
.65784 .76088 m
.6532 .77087 L
s
P
p
1 0 .6 r
.00125 w
.65784 .76088 m
.66687 .76427 L
s
P
p
1 0 .6 r
.00125 w
.68552 .75827 m
.70613 .76591 L
s
P
p
1 0 .6 r
.00125 w
.68552 .75827 m
.70936 .75547 L
s
P
p
1 0 .6 r
.00177 w
.57371 .79281 m
.59592 .8016 L
s
P
p
1 0 .6 r
.00177 w
.57371 .79281 m
.56809 .80415 L
s
P
p
1 0 .6 r
.00177 w
.53504 .81141 m
.52178 .83744 L
s
P
p
1 0 .6 r
.00177 w
.53504 .81141 m
.50069 .82682 L
s
P
p
1 0 .6 r
.00125 w
.56809 .80415 m
.56298 .81445 L
s
P
p
1 0 .6 r
.00125 w
.56809 .80415 m
.57696 .8077 L
s
P
p
1 0 .6 r
.00125 w
.59592 .8016 m
.61617 .80961 L
s
P
p
1 0 .6 r
.00125 w
.59592 .8016 m
.61989 .79883 L
s
P
p
1 0 .6 r
.00125 w
.50069 .82682 m
.46954 .84079 L
s
P
p
1 0 .6 r
.00125 w
.50069 .82682 m
.49524 .83727 L
s
P
p
1 0 .6 r
.00125 w
.52178 .83744 m
.50957 .8614 L
s
P
p
1 0 .6 r
.00125 w
.52178 .83744 m
.54174 .84577 L
s
P
p
1 g
.002 w
.83773 .0357 m
.87192 1.21206 L
s
.87192 1.21206 m
.0357 1.26444 L
s
.0357 1.26444 m
.08137 .12136 L
s
.08137 .12136 m
.83773 .0357 L
s
.83773 .0357 m
.87192 1.21206 L
s
.87192 1.21206 m
.9643 1.3844 L
s
.9643 1.3844 m
.92577 .31981 L
s
.92577 .31981 m
.83773 .0357 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 337}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->5,
  AnimationCycleOffset->-8,
  AnimationCycleRepetitions->Infinity,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000M=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61P00:=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000JlH900G600<0a/H09/H1000006;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaPT003O4e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001IaPT02/H00lC6aP0:aP809lH10000053Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT0
0236e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6eP8002O6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0004O62@04aP03a<K601G600?4a/H02/H202O60@00000ne/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9001K
a]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]H0eP3Fa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000=LH90003a<K601C600?4a/H05LH00lC6
aP09aP030<H002K60@00000/e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H90012a]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K4e/KFa]K6e/KF0/@0:@340<C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000SaPT04lH00lC6aP0DaP03a<K601C62/@2aP040<K602G60@00000Ne/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K61@00@<KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa/C6e/KFa]K6e/KFa]H:a00ea/C6e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001k600<0a/H02LH00lC6aP0CaP03a<K601C600?4a/@02L@;aP03
a<K600S600@0a/H09LH1000001kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2000_e/KFa]K6
e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]H02/@0BLKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K4e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@0001k600<0aP002/H00lC6aP0CaP04a<K6aP[42LH00lC6aP0DaP03a<K600O600D0a/K6000TaP40
0000>mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KF00[405g6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF
0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001k600@0a/H02/H00lC6
aP02aP[41lH00lC6aP0DaP03a<K601C600?4a/H01lH01@36a/H002?60@00000We/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KF00[40776e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K60<KFaP36e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007/H01036a/H5a0K600?4a/H04lH00lC6aP0DaP03
a<K601?600?4a/H01lH01@36a/H002?60@00001ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]H0e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/H000C402<0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007/H00`36aP02aP030<K600S600?4a/H04lH00lC6aP0CaP03a<K601?6
2/@00`36aP02aP030<K602360@00001We/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
0<KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6eP09a00be/CFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100007/H00`36aP03aP030<K600W600?4a/H04/H00lC6aP0CaP03a<K400W42lH00lC6aP05aP03
0<K600?600<0a/H07lH1000005?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6eP08a0@004?6e/KFa]K6e/KF
a]K6e/KFa]K6a<KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000MaP030<K600K600<0a/H02<H00lC6aP0BaP04a<K6aPW41lH601;600?4a/H01LH00`36aP03aP03
0<K601o60@000010e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFaP[4013Fa]K6e/KFa]K6e/KFa]K61P00@]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K600O6
00<0a/H02<H01<C6a/H:a0O600?4a/H04<H601?600?4a/H01<H00`36aP04aP030<K601k60@00000]
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KF00W402CFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/H60012e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/H0a]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001g600<0a/H02<H5a0K600?4a/H0
4/H00lC6aP0@aP@05LH00lC6aP03aP030<K600G600<0a/H07LH1000005_Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KF008o0236a<KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFaP36ePG40200a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K600W600<0a/H02<H00lC6aP0BaP03
a<K600o600DoClK6a00DaPK400<0a<@01LH00`36aP0MaP400000FmK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6
e/KFa]K6e/KFa]H00Sl03/KFa=K6e/KFa]K6e/KF2L@0;]K4e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36aP0:aP030<K600S600?4a/H04/H00lC6aP0>aP03
?do600;62l@:aP03a<K600;600<0a/H01/H00`36aP0LaP400000F=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/H3a08o1<@0@LKFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/H0a]K6e/KFa]H0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000MaP030<K600c600<0a/H02<H00lC6aP0AaP04a<K6aPW4
0lH00cm?aP03aP03a<K601;600G4a/K60009aP030<K601_60@000015e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KF00[400c6e/KF
a]K6e/KFa]H2?`0Ra]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/H0a]K6ePH001g6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100007LH00`36aP0=aP030<K600S600C4a/K62L@7aP03a<K600c6
00<oClH00lH00lC6aP0BaP03a00000H01LH00`36aP0KaP400000<mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6eP09a00Oe/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6eP02?`0@a]K6e/K4a]K6e/KFa]K6ePT002cFa=K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K600k61L@6aP03a<K6017600?4a/H02lH00cm?aP04aP03
a<H000P03LH00`36aP07aP030<K601_60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
eP02?`H003o4e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001g600<0a/H03lH00`36aP08aP03a<K6017600C4a/K62@000cm?aP0LaP03
0<K600O600<0a/H06lH1000004WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KF00H000c4003Fa]K6e/KFa]H2?`15a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000MaP030<K6013600<0a/H02<H00lC6aP02aPT04/H00cm?aP0LaP030<K600O600<0a/H0
6lH1000003OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KF00D001o40000e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o04G6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001g6
00<0a/H04/H502C600<oClH07<H00`36aP07aP030<K601_60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP02?`15a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000MaP030<K601;600<0a/H09/H00cm?aP0MaP03
0<K600K600<0a/H06lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100007<H00`36aP0CaP030<K602C600@oa/I?7/H00`36aP06aP030<K601_60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6e/KFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04lH00`36aP0@aP05
?lHoaSl03LH00co6aP02aP03ClK601c600<0a/H01lH00`36aP0JaP400000B=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/HoaP8o
05SFa]K6e/KFa]K6e/Hoa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04lH00`36aP0@aP04?dloC`c6
00<oa/H01<H00do6aP0LaP030<K600O600<0a/H06/H1000004CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP8o05cF?co6e/KFa]K6
e/KFaSo6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000LaP030<K601?600<0a/H04LH00do6C`09aP03Cco600O6
00=?a/H07<H00`36aP07aP030<K601[60@00001?e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaSo6?lKFa]K6eP03?`1@eSoFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100007<H00`36aP0CaP030<K600[600<oClH00lH01Cm??dlo00;600=??dl0
0lH00do6aP07aP03ClK601c600<0a/H01lH00`36aP0JaP400000@mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/Hoa]H00cl00mK6eP03?`1F
eSoFa]Hoe/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36aP0CaP030<K600[600<oClH00/H01Do6
Ccm?00?600E?a/K6C`0;aP03ClK601c600<0a/H01lH00`36aP0JaP400000?]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K613l00mHo?`03?`1J
e/Ho?mK6eSoFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04lH00`36aP0;aP03Ccm?00;6
00HoCcm??dl3aP03ClK600_600=?a/H07<H00`36aP07aP030<K601[60@00000me/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaSo6eP03?`04e/KFaPHo
05SFa]Hoe/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04lH00`36aP05aP0?Ccm??lHo
Ccm??dloCcm?00?600=?a/H03LH00do6aP0LaP030<K600O600<0a/H06/H1000003SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP8o00CF?co613l00mK6
?`04?`1Ia]Hoe/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF
a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001c600<0a/H04lH00`36aP05aP03
Cco600;600<oClH00lH00cm??`02aP03Cco600o600=?a/H07<H00`36aP07aP030<K601[60@00000o
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaSo6
e/KF008o00C6e/KF0cl05=Ho?lKFa]K6e/KFa]K6e/KFa]K60Sl0A=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H0
4/H00`36aP0:aP0=Cco6?dloCcm?aTo6C`0AaP03ClI?01c600<0a/H01lH00`36aP0JaP400000@]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]Ho
eSoFaPHo05[FaSo6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36aP0BaP030<K600S6
00=?a/H01<H013o6aTl2aP03?lK6013600E?a/K6C`0JaP030<K600O600<0a/H06/H1000004SFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]HoeSoFa]K6
e/Hoa]Hoe/H2?`1He/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601?600<0a/H0
1/H00do6aP02aP06?dloCcm?0/H00cm?aP0BaP03ClK600?600=?a/H05/H00`36aP07aP030<K601[6
0@000010e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFaSo6e/KFaP@o05kFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001_600<0a/H0
4lH00`36aP04aP04Ccm??`;600E??do6C`02aP04?do6CaC600<oa/H01<H00do6aP0DaP030<K600O6
00<0a/H06/H1000003[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K61Cl01LKF?mK6008o05cF?mK6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000KaP030<K601?600@0a/I?0/H00cm??`02aP0<Cco6aTloCcm??lHo5LH00co6aP04aP03Cco601G6
00<0a/H01/H00`36aP0JaP400000==K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/H4?`03e/Ho008o00?6eSl01cl00lHoaP02?`1Fe/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100006lH00`36aP0CaP0304lo00;600I?a/HoCcl2aP0=ClI??do6Ccm??lHoC`0BaP03
?lK600C600=?aTl05LH00`36aP07aP030<K601W60@00000ie/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]Hoe/KF008o00S6eSoFa]HoeP8o00?6?cl00Sl0F=K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6?lKF?mK6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006lH00`36aP0CaP040<K6C`C600DoClI??`02aP0;
ClK6?lHoCco6?dl04/H00co6aP04aP05ClK6aTl04lH00`36aP07aP030<K601W60@00000he/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H5?`07aSlo?lKF
aP03?`0Ma]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/H00Sl0?=K6?lKFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601?600<0a/H0
0lH023o6?do6ClI?1<H00cm?aP0GaP03?lK600C600=?aTl00/H00co6aP0@aP030<K600O600<0a/H0
6LH1000004;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/Hoa]HoeSoF?mK6e/H2?`0He/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl03=K6e/KFa]HoeSoFaP8o
03KFa]K6e/KFa]K6e/Hoa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
6lH00`36aP0CaP030<K600C600A?a/Ho1<H014loCclGaP03?lHo00O600<oaSl00/H01Do6Ccm?00W6
00E??lK60009aP030<K601W60@00000fe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K60Sl01mK6?coFa]H00cl08]Ho?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
eSoFa]K6e/H2?`09eSloa]Hoe/KF008o00K6e/KFa]H2?`0Ya]K60<KFa]K6e/KFaP36e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001_600<0a/H04lH02P36?dloaSo6?dl4aP07?lK6ClI??`0DaP05
Ccm??dl00lH02dloaSo6?lHoClI?00?600Y??dloaSm??dlo0/H00`36aP07aP030<K601W60@00000`
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K613l01=K6?lH3?`0R
a]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6ePDo00GF?mHoeP07?`06e/KF?mK613l0:]Ho
e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K6017600@oC`1?
0/H01So6?do6C`K600<oClH05LH05So6a/HoCco6?dloCcm??dloClI??dl3aP03Cco600?600E??do6
0009aP030<K601W60@00000]e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KF008o00W6?coFaSo6?lH00Sl01]Hoe/KFaP8o01_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]H0
0cl00mHo?`05?`03eSoF00<o00KF?mK6?lH3?`06a]HoeSl00Sl08lKFa]K6e/H0a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000KaP030<K601;600I?0<HoaSl3aP03?dlo00G600<oa/H04lH00cm?
aP02aP0@Ccm??dloaSm??lHoCcm??`C600Q?a/HoaSo6?`;600E?aP0oC`07aP030<K601W60@00001D
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]HoeP0oa]K6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl00lHoaP04?`05e/KFa]H013l01<KF?mH2?`07a]K6?lKF
aP02?`04e/KFaP8o00<0a]H00Sl08LKFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
6lH00`36aP0CaP03?do600?600<oClH06<H00dloaP02aP03?lHo00;600=??lH01<H01Co6?lHo00?6
00LoCcm??dlo00;600=??lH01<H00cl0aP08aP030<K601W60@00000`e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60Sl01=K6e/H2?`0He/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K613l08=K6?coFa]HoeSoFa]K6e/KF?mHoe/KFa]K6?lHoaSo60cl0:lKFa]K60<KFa]K6e/KF
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001_600<0a/H04LH00cm?0005aP03?lK60176
00ToCcm??dloaSl00/H00do6C`04aP03?lK600G600@oaSm?1/H01Sm?a/HoC`;600<oa/H00/H00`36
aP07aP030<K601W60@00000^e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFaP<o01P0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H2?`06aSloeSoF0cl01MK6?lKF00<o00KF?clo
e/H4?`03eSlo008o03O6e/KFaSo6eSoFa]K6?lKFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000JaP030<K600o600I??do6C`0GaP03?dlo00G600Doa/K6?`03aP06?do6Ccm?
1LH00do6C`03aP03ClK600?600E??lK6C`07aP030<K600O600<0a/H06LH1000002[Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H2?`0Ke/KF?mH0e/KFa]K6e/KFa]K6e/KFa]K6
e/KF008o00_6?lKFa]K6e/KFaP02?`0Oe/Hoa]K6eSoF?mK6e/KFaSo6e/KF?mK6e/HoaSo6eP02?`0[
a]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006/H00`36aP0=aP03
ClK600;600<oaP008<H014loaSl7aP03?lK600K600=?a/H02<H02Co6?lHoaSm??`02aP030<K600O6
00<0a/H06LH1000004oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eSoFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00[FaSo6e/KFa]K60Sl02=K6e/KFa]K6
0Sl02=K6e/KFa]K60Sl02=Hoe/Hoa]K60Sl09P36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001[600<0a/H02lH00do6aP06aP030<K601W600@oClI?0/H00cm??`06aP03Cco600O6
00=?a/H01/H02Co6?lHoCco6?`03aP05?`0oaSl01/H00`36aP0IaP400000G=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6?lKFa]K60Sl04=K6e/KFa]K6e/KFa]K6e/H2?`05eSoF?mH00Sl01lHoa]K60<H0
0cl08LKFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006/H00`36aP0DaP030<K601k6
00=?a/H01/H00co6?`0CaP03?lK600;600A?a/Ho0/H00`0oaP02aP03?lK600?600<0a/H06<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFaSo6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006/H00`36aP0DaP03
0<K602O600<oaSl04lH00cm?aP06aP04ClK600W600<0a/H06<H1000005WFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP02?`0Oa]Hoe/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFaP02?`0VeP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006/H00`36aP0DaP030<K602?600@oClI?
0/H00co6aP0AaP03?lK600K600A?aTl02LH00`36aP0HaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHo0=K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000JaP030<K601C600<0a/H08<H00dloaP02aP05?lK6aSl0
7<H014loaP09aP030<K601S60@00001Be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o02[F?mK6eSoFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6?`03?`0Qa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000JaP030<K601?600<0a/H06<H00cm?aP03aP05?lK6aSl00/H00do6aP02aP03
?lK601[600E?a/H0C`02aP03?do600?600<0a/H06<H1000004gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP04?`0<
a]K6?lKFaSo6e/KF0Sl0@lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F?mK6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001[600<0a/H04lH00`36aP0IaP03ClI?00C600<oClH0
0/H00do6aP02aP03?lHo01g600@0a/I?1/H00`36aP0HaP400000DMK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
eP02?`1?aSo6eSoFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eSoFa]K6eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006/H00`36aP0CaP030<K601S600<oClH00/H014lo
aSl3aP03?lK600?600Doa/K6?`0KaP030<K600;600=?a/H00/H00`36aP0HaP400000BMK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00Sl03<Hoa]K6e/KF?mK6eP8o04W6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000JaP030<K601?600<0a/H0
5LH014o6aSl6aP07ClI?aTo6C`04aP03?lK600?600<oClH05lH00`36aP07aP030<K601S60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/Hoa]Hoe/KF?mK6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001W600<0a/H05<H00`36
aP0SaP04ClK6?`?600<oa/H01/H00do6aP0DaP030<K600O600<0a/H06<H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6?lHoa]Hoe/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0DaP030<K6027600E??lK6
C`02aP03?dlo00[600=?a/H04/H00`36aP07aP030<K601S60@00001He/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]HoeSoFaP8o00?F?mH00Sl0@lKFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF
a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001W600<0a/H05<H00`36aP0OaP03ClI?00;6
00<oa/H00/H00dloaP0;aP03ClK6013600<0a/H01lH00`36aP0HaP400000D=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60Sl02]K6?lKFa]K6e/H2?`14e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0DaP030<K601_600A??lHo
0/H00do6aP04aP03?lHo00k600=?a/H03/H00`36aP07aP030<K601S60@00001]e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/Hoa]Hoe/KFa]K6?lKF?mK6e/KFa]K6e/KFa]K6eP02?`0ca]K6e/KFa]K6e/KFa]H0e/KF
a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000IaP030<K601C600<0a/H08<H00co6
aP03aP05?lK6aSl04LH00co6aP0;aP030<K600O600<0a/H06<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0DaP030<K601o600=?aTl00/H00co6
aP03aP03?lK6017600<oa/H02LH00`36aP08aP030<K601O60@00001Fe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6?lH2?`1:e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0DaP030<K601o600E?a/HoC`06aP03
?lK601g600<0a/H02<H00`36aP0GaP400000E=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaP8o04cFa]K6
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0001W600<0a/H05<H00`36aP0NaP04?lK6C`S600<oa/H07/H00`36aP07aP03
0<K601O60@00001Be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04kFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
6LH00`36aP0DaP030<K601g600=??lH02/H00co6aP0NaP030<K600O600<0a/H05lH1000004oFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF008o0576e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001W600<0a/H05<H00`36
aP0LaP03?lK600_600<oa/H07/H00`36aP07aP030<K601O60@00001Me/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6e/KF008o04?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000IaP030<K601C600<0a/H0:/H00cm?aP0NaP03
0<K600O600<0a/H05lH1000005gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl0@lKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001W600<0a/H05<H00`36aP0ZaP03?lHo01k600<0a/H01lH00`36aP0GaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000HaP030<K601G600<0a/H0
:/H00co6?`0NaP030<K600O600<0a/H05lH1000005gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00Sl0@lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001S600<0a/H05LH00`36aP0ZaP04?do6Cag600<0a/H01lH00`36
aP0GaP400000MmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00P002?6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006<H00`36
aP0EaP030<K602[600Doa/K6?`06aPl01lH00`36aP07aP030<K601O60@00001Je/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K63P00>]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100006<H00`36aP0EaP030<K601S63`03aP03?do601o600<0a/H0
1/H00`36aP0GaP400000?=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFaPl001;6e/KFa]K6e/KFa]K6e/KFa]H2?`13a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006<H00`36
aP0CaPh08LH00co6aP0PaP030<K600G600<0a/H05lH1000001oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KF00l007CF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000HaPL04<H00`36aP0[aP03?lK6027600<0a/H01<H00`36aP0GaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K6017600<0a/H0
:lH00co6aP0RaP030<K600C600<0a/H05/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100007LH00`36aP0?aP030<K605;600<0a/H00/H00`36aP0FaP4000007]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8008;Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H03<H00`36
aP1CaP050<K6aP006<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008/H00`36aP0:aP030<K605C600@0a/H06<H1000002?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP02001ma]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002G600<0a/H01lH00`36aP1EaP030<H001S60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H01LH00`36
aP1FaP806<H1000008SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P006=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000YaP801<H00`36aP1>aPX06<H1000006kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaQ8002;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002c6
00@0a/H0;<HB03C60@00001:e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HB0016e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000^aP802<HB05S6
0@00000_e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02@00J]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0173626, -0.025005, \
0.00577993, 0.00577993}}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  ButtonBox["Example",
    ButtonData:>"Example B",
    ButtonStyle->"Hyperlink"],
  " (b)"
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  ButtonBox["Parameters",
    ButtonData:>"Example B: parameters",
    ButtonStyle->"Hyperlink"],
  " and L-system interpretation"
}], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"Example B"],

Cell["\<\
r1 = 0.9;   (* contraction ratio for the trunk  *)
r2 = 0.9;   (* contraction ratio for branches   *)

a0 = 45;    (* branching angle from the trunk   *)
a2 = 45;    (* branching angle for lateral axes *)

d  = 137.5; (* divergence angle                 *)
wr = 0.707; (* width decrease rate              *)\
\>", "Input",
  AspectRatioFixed->True,
  CellTags->"Example B: parameters"]
}, Closed]],

Cell[CellGroupData[{

Cell["L-system and turtle interpretation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
plants = runKLSystem[
            plantLSystem[r1,r2,a0,a2,d,wr],10,
            SkipPatterns -> plantSkipPatterns];\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  "Map[\n    turtleInterpretation[#,\n      StartDirection -> \
Transpose[{{0,0,1},{1,0,0},{0,-1,0}}],\n      MaxNumberOfPaths -> 4000,\n     \
 LineThickness -> 0.05,\n      LineHue -> 0.9,\n      GraphicOptions ->\n     \
 {\n        AspectRatio -> Automatic,\n\t      Axes -> False,\n\t      Boxed \
-> True, BoxStyle -> GrayLevel[1],\n\t      ViewPoint -> {-3.6,-0.8,1.5},\n\t \
     FaceGrids -> {{0,0,-1}},\n\t      PlotRange -> All,\n\t      Background \
-> GrayLevel[0.9],",
  StyleBox["\n    ",
    FontFamily->"Times"],
  "      DisplayFunction -> $DisplayFunction\n      }]&,Drop[plants,1]\n  ];"
}], "Input",
  AspectRatioFixed->True],

Cell[TextData[
"Starting turtle interpretation ...\nTime needed: 0.0666667 Second\n\
Generating graphics ...\nStarting turtle interpretation ...\nTime needed: \
0.15 Second\nGenerating graphics ...\nStarting turtle interpretation ...\n\
Time needed: 0.283333 Second\nGenerating graphics ...\nStarting turtle \
interpretation ...\nTime needed: 0.6 Second\nGenerating graphics ...\n\
Starting turtle interpretation ...\nTime needed: 1.18333 Second\nGenerating \
graphics ...\nStarting turtle interpretation ...\nTime needed: 2.51667 Second\
\nGenerating graphics ...\nStarting turtle interpretation ...\nTime needed: \
4.91667 Second\nGenerating graphics ...\nStarting turtle interpretation ...\n\
Time needed: 10.25 Second\nGenerating graphics ...\nStarting turtle \
interpretation ...\nTime needed: 20.6 Second\nGenerating graphics ...\n\
Starting turtle interpretation ...\nTime needed: 42.3667 Second\nGenerating \
graphics ..."], "Print",
  Evaluatable->False,
  CellOpen->False,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Graphics", "Subsubsection"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.09277 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0217706 1.13101 0.0282753 1.13101 [
[ 0 0 0 0 ]
[ 1 1.09277 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.09277 L
0 1.09277 L
closepath
clip
newpath
p
1 g
.002 w
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
.07914 .12169 m
.85581 .02828 L
s
.93606 .38326 m
.3047 .44368 L
s
.3047 .44368 m
.28397 1.06449 L
s
.28397 1.06449 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.93606 .38326 m
.85581 .02828 L
s
.07914 .12169 m
.3047 .44368 L
s
.3047 .44368 m
.28397 1.06449 L
s
.28397 1.06449 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
p
.4 g
.85819 .03878 m
.08575 .13112 L
s
P
p
.4 g
.88047 .13735 m
.14794 .2199 L
s
P
p
.4 g
.90039 .22549 m
.20386 .29973 L
s
P
p
.4 g
.91832 .30477 m
.25442 .3719 L
s
P
p
.4 g
.93452 .37646 m
.30034 .43745 L
s
P
p
.4 g
.83632 .03062 m
.92038 .38476 L
s
P
p
.4 g
.64418 .05373 m
.76534 .39959 L
s
P
p
.4 g
.45698 .07625 m
.61352 .41412 L
s
P
p
.4 g
.27454 .09819 m
.4648 .42836 L
s
P
p
.4 g
.09668 .11958 m
.31911 .4423 L
s
P
P
p
1 0 .6 r
.02 w
.54374 .27855 m
.54374 .93876 L
s
P
p
1 g
.05 w
.54374 .27855 Mdot
P
p
1 g
.002 w
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
.07914 .12169 m
.85581 .02828 L
s
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.93606 .38326 m
.85581 .02828 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->1.1858,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000Q]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61@005lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001maPT000G6a<K6000GaP400000MMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP08000:a]K6e/KFa]K6eP?401P0a=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000KLH800W62L@00lK4aP0201K60@00001Te/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT000W6e/KFa]K6e/H02<@03=K6e/KFa]K6e/K4aP8001KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0005c62004aP03a<K600?62<@BaP04a<H001K60@00001Ce/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H02@002MK6e/KFa]K6eP09a00Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4aP8001KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0004_6200:aPS41<H00lC6aP0MaP03a00001K6
0@000013e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP080009a]K6e/KFa]K600W404G6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/@0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003[62@07aP03a<K400O4
5/H00lC6aP0LaP04a03601G60@00000be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H8000:e/KFa]K6e/KFaPS405KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa0360<KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000YaPT02LH9a0O600?4a/H07<H00lC6aP0MaP030<H001G60@00000Qe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00P000[6e/K4a]K6e/KF2<@0IlKFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K40=H0e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001W62009aPW46LH00lC6aP0LaP03a<K601c600C40<H05<H10000
013Fa]K6e/KFa]K6e/KFa]K62@002LKFa]K6e/KFaP08a01he/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a03F0=K6e/KFa]K6e/KFa]K6e/KFa]K60@0000c6100:aPS43<H00lC6aP0LaP03
a<K601c600?4a/H07<H00`36000DaP4000004MK6e/KFa]K6e/KFaP36e/CF00W408SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6
e/KFa]K60@0000c600<0a<@00/@NaP03a<K601c600?4a/H06lH00lC6aP0LaP040<K601?60@000029
e/KFa]K6e/KFa]K60<H0a]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H00/@05`34a036e/KFa]K6e/KFa]K6e/KFa]K60040000<aP030<H000;6
00?4a/H07<H00lC6aP0LaP03a<K601_600?4a/H04<H9a0;600@0a/H04lH1000007OFa]K6e/KFa]K6
e/H0a]H0e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6eP09a00Re/KFa]K6
e/KFa]H0a<H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000<aP050<K6aP000/H00lC6aP0KaP03a<K601c6
00?4a/H06lH9a1C600D0a<K6000BaP400000IMK6e/KFa]K6e/KFaP36e/KF0=K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KF00[403?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0<C6eP3Fa]K6e/KFa]K6e/KF
a]K6e/H00@0000c600<0a/H00/H01036a/@NaP03a<K601_600?4a/H02<H9a0W600?4a/H06/H01@34
a/H001;60@00001Ae/KFa]K6e/KFa]H0e/KFa]K60<KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00_404KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa=H0e/KFa]K6e/KFa]K6e/KFa]K60@0000_600<0a/H0
1LH01036a/@MaP03a<K601;62/@LaP03a<K601W600D0a/C6000BaP400000@=K6e/KFa]K6e/KF0=K6
e/KFa]H0e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/H9a01Ia]K6e/KF
a]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
0=K4e/H0a]K6e/KFa]K6e/KFa]K6e/H00@0000_600<0a/H01/H01036a/@MaP03a<K400S44/H00lC6
aP0KaP03a<K601S600<0a/@00/H00`36aP0?aP400000;]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/H9a01[a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6a<H0a]K6e/KF
a]K6e/KFa]K6e/H00@0000_600<0a/H02<H00`36a00<aPW42<H00lC6aP0JaP03a<K601[600?4a/H0
6<H01P36a/C601760@00000Le/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/CFaPW407g6e/KFa]K6e/KF
a]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/K4a]H0e/KFa]K6e/KFa]K6e/KFaP010000
2lH00`36aP09aPG46lH00lC6aP0JaP03a<K601[600?4a/H05lH01036a/@2aP030<K600k60@00002<
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP05a00A0=K6e/KFa]K6e/KFa]K6e/H00@0000_600<0a/H02/H01036
a/@LaP03a<K601[600?4a/H06/H00lC6aP0>aPW400H0a/K4aP0@aP400000N]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]H0e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K62L@07lKFa]K6e/KF
aP36e/CFaP36e/KFa]K6e/KFa]K6e/H00@0000_600<0a/H03<H01036a/@KaP03a<K601[600?4a/H0
5lH:a1;600@0a/K40/H00`36aP0=aP400000ImK6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]H02L@0<]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6a<H0a]K6e/KFa]K6
e/KFa]K60@0000_600<0a/H03LH01036a/@LaP03a<K601S61004aPW43<H00lC6aP0FaP070<K6a/C6
000?aP400000EMK6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/@01P03a014e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/K4aP36e/KFa]K6e/KFa]K6e/H100002/H00`36
aP0@aP030<K401c600?4a/H03<H9a0P06<H00lC6aP0EaP050<K6a/@00/H00`36aP0<aP400000@]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFaPW400W6e/KFa]K6e/H02000A]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa=H0e/KFa]K6e/KFa]K6e/H100002/H00`36aP0AaP040<K6a1K62/@BaPP0
6<H00lC6aP0EaP030<K600;600?4aP003/H1000002oFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K4e/KFa]K6e/KFa]K6eP09a00Le/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFaPP004KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/CF0=K6e/KFa]K6
e/KFa]K60@0000[600<0a/H04lH00`36a003aPW43lH00lC6aP0DaPH06/H00lC6aP0DaP030<K600;6
00C4a/H03LH10000027Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP001L@0<=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP@004S4a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa/C60<KFa]K6e/KFa]K6e/H10000
2/H00`36aP0DaP030<K401_600?4a/H05LH01Cm??lK401[600?4a/H04lH00`36aP05a0030<K600_6
0@00001Ge/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o02_Fa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KF00O401H0a<C6e/K4aP36e/KFa]K6e/KFa]K60@0000[600<0a/H0
5LH01036a/@JaP03a<K601C600<oCcl00/H00lC6aP0GaP03a<K600?62L@7aP030<K600?600?4aP00
3LH1000005OFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa/C6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl06=K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFaP[402KFa]K6e/KFa]K6e/KFa]K60<KFa]K6a<KF0=K6e/KFa]K6e/KFaP40000:aP030<K601O6
00<0a/@06lH00lC6aP0BaP03?dlo00;600?4a/H02LH:a0G600?4a/H04/H00`36aP04aP03a<H000c6
0@00001Ge/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00?Fa]H02l@0>]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K4eP3Fa]K6e/KFa]K6e/H100002/H00`36aP0HaP04
0<K6a1[600?4a/H03lH2a003?dlo00C46/H00lC6aP0AaP030<K600C600?4aP003<H1000004_Fa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]H02/@00lKF?`02?`18e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa=K60<KFa]K6e/KFa]K60@0000[600<0a/H06/H00`36a00GaP[4
3<H00cm??`04aP03a<K601O600?4a/H04LH00`36aP05aP03a<H000_60@00000he/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6a<KFa]K6e/KFa]K6e/H9a00Fa]K6a<KFa]K6e/KF
a]K6e/KFa]K6eP<o04SFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6a<H0a]K6e/KFa]K6e/H100002LH00`36aP0LaP030<K400?62/@=aP03a<K600o6
00<oCcl01LH00lC6aP0GaP03a<K6017600<0a/H01<H00lC6000;aP400000:MK6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00G402WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6eP03?`0he/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/H4a00<0<CFa]K6e/KFa]K60@0000W600<0a/H07/H00`36a00IaP03a<K600k6
00<oCcl01/H00lC6aP0GaP03a<K600_61L@00`34a002a0?600?4aP002/H1000005OFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]H00cl08mK6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KF00_4
00WFa]K6eP3Fa]H010003L@00=K6e/KFa]K6e/H00@0000W600<0a/H07lH00`36a00IaP03a<K600g6
00<oCcl01lH00lC6aP0?aP[42LH;00K600<0a/H02<H1000005OFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6
e/KFa]H00cl03mK6e/KFa]K4e/KFa]K6eP0:a009a]K6e/KFa]K400X001cFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K60@0000W600<0a/H08<H01036a/@HaP03a<K600c600<oCcl01<H;a0K6300BaP03
0<K600O600<0a/H02<H1000005CFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/H3a0<o1<@01]K6e/K4aP/0
03?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/H00@0000W6
00<0a/H08/H00`36a00IaP[40lH00cm??`090003a<K602O600<0a/H01lH00`36aP08aP400000?mK6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K4e/KFa]K6e/KFa]K6
eP0<a003a]H000T00cl0B=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFaP400009aP030<K602?600<0a/@00lH:a0?62@000l@0
aP09aP03?dlo03?600<0a/H01lH00`36aP08aP400000<=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPG400?6eP002P005MK6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`18
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K60@0000W600<0a/H09LH20004a000023600<oCcl0<lH00`36aP07aP030<K600S6
0@00001Ge/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36
aP0VaP030<K602?600<oCcl0<lH00`36aP08aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?600<oCcl0<lH00`36
aP08aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6
e/H100002<H00`36aP0VaP030<K602?600<oCcl0<lH00`36aP08aP030<K600O60@00001Ge/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?6
00<oCcl0=<H00`36aP07aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?600<oCcl0=<H00`36aP07aP030<K600O6
0@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36
aP0VaP030<K602?600<oCcl0=<H00`36aP07aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?600<oCcl0=<H00`36
aP07aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6
e/H100002<H00`36aP0VaP030<K602?600<oCcl0=<H00`36aP07aP030<K600O60@00001Ge/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/H100001lH00`36aP0VaP030<K602C6
00<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C600<oCcl0=<H00`36aP08aP030<K600K6
0@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36
aP0VaP030<K602C600<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C600<oCcl0=<H00`36
aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6
e/H100001lH00`36aP0VaP030<K602C600<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C6
00<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C600<oCcl0=LH00`36aP07aP030<K600K6
0@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/H100001/H00`36
aP0WaP030<K602C600<oCcl0=LH00`36aP07aP030<K600K60@00001Ge/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36
aP07aP030<K600K60@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6
e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36aP0WaP030<K602C6
00<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K60<KFa]K6e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G6
0@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36
aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36
aP08aP030<K600G60@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6
e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001LH00`36aP0XaP030<K602C6
00<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K60<KFa]K6e/H100001LH00`36aP0XaP030<K602C600<oCcl0=/H00`36aP07aP030<K600G6
0@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/H100001LH00`36
aP0WaP030<K602G600<oCcl0=/H00`36aP07aP030<K600G60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0WaP030<K602G600<oCcl0=/H00`36
aP08aP030<K600C60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6
e/H100001LH00`36aP0WaP030<K602G600<oCcl0=/H00`36aP08aP030<K600C60@00001Ge/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0WaP030<K602G6
00<oCcl0=/H00`36aP08aP030<K600C60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0WaP030<K602G600<oCcl0;/H900[600<0a/H01<H10000
05OFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl07mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H03`006]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K60@0000C600<0a/H0:<H00`36aP0UaP03
?dlo00o6400HaP030<K600O600<0a/H01<H1000005OFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0cl?000ia]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KF
a]K600400004aP030<K602S600<0a/H06<H@03O600<0a/H01lH00`36aP04aP400000>]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H@000=e/KFa]K6
e/KFa]K6eP03?`18e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K60@0000C600<0a/H09<H?01g600<oCcl0><H00`36aP06aP03
0<K600C60@00000Ke/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF010002c6e/KF0=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/H100001<H00`36aP05aPl0
5<H00`36aP0UaP03?dlo03W600<0a/H01LH00`36aP04aP4000001=K6e/H8001;e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6eP3Fa]K6e/H100001/H00`36aP0VaP030<K602G600<oCcl0>/H00`36aP05aP03
0<K600?60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/H10000
2<H202G600<0a/H09LH00cm??`0jaP030<K600G600<0a/H00lH1000005OFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H00cl0B=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFaP40000;aP030<K6027600<0a/H09LH00cm??`0kaP03
0<K600C600<0a/H00lH1000000cFa]K6e/KFa]K6e/H20019e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`18e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
0<KFa]K60@0000k600<0a/H07/H00`36aP0UaP03?dlo03c600<0a/H00lH00`36aP03aP400000EmK6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`18e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K60@00013600<0a/H07<H00`36
aP0UaP03?dlo03g600<0a/H00/H00`36aP03aP4000004MK6e/KFa]K6e/KFa]K6e/KF008004C6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eP<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/H0a]K6e/H100004lH00`36aP0IaP030<K602G600<oCcl0?LH00`36aP02aP03
0<K600?60@00001Ge/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/H10000
5LH201S600<0a/H09LH00cm??`0naP050<K6aP001LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/H0a]K6e/H100006<H00`36aP0DaP030<K606O600@0a/H01LH1000001WFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008008O6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/H00@0001_600<0a/H04<H00`36
aP1XaP040<K600G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6
0@0001g60P0?aP030<K606W600@0a/H01<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3F0=K6e/H100008<H00`36aP0;aP030<K606[600<0aP001<H10000027Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P00OlKFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/H00@0002?600<0a/H02<H00`36aP1[aP80
1<H1000009cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H20004e/KFaP40000UaP03
0<K600K600<0a/H0JlH200C60@00000Ve/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H2001/e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62P001=K6
e/H10000:<H00`36aP03aP030<K605364`0>aP400000KmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0B000Qa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000ZaP800/H00`36aP0[aQ<0<lH1000004[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQ8004KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002g60P08aQ<0F<H1000002kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K62@00JlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP400000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0191726, -0.0250049, 
  0.00545875, 0.00545875}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 2.30664 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.596332 2.2405 0.0560124 2.2405 [
[ 0 0 0 0 ]
[ 1 2.30664 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 2.30664 L
0 2.30664 L
closepath
clip
newpath
p
1 g
.002 w
.7317 .05601 m
.75393 1.9387 L
s
.75393 1.9387 m
.05601 1.98247 L
s
.05601 1.98247 m
.10047 .12758 L
s
.10047 .12758 m
.7317 .05601 L
s
.9078 .51481 m
.34155 .57176 L
s
.34155 .57176 m
.32464 2.25063 L
s
.32464 2.25063 m
.94399 2.21658 L
s
.94399 2.21658 m
.9078 .51481 L
s
.7317 .05601 m
.75393 1.9387 L
s
.75393 1.9387 m
.94399 2.21658 L
s
.94399 2.21658 m
.9078 .51481 L
s
.9078 .51481 m
.7317 .05601 L
s
.10047 .12758 m
.34155 .57176 L
s
.34155 .57176 m
.32464 2.25063 L
s
.32464 2.25063 m
.05601 1.98247 L
s
.05601 1.98247 m
.10047 .12758 L
s
p
.4 g
.73639 .06823 m
.10688 .13939 L
s
P
p
.4 g
.78185 .18667 m
.16903 .25391 L
s
P
p
.4 g
.82482 .29861 m
.22783 .36224 L
s
P
p
.4 g
.86549 .40458 m
.28355 .46489 L
s
P
p
.4 g
.90406 .50505 m
.33641 .56229 L
s
P
p
.4 g
.71642 .05775 m
.89412 .51619 L
s
P
p
.4 g
.52537 .07941 m
.72294 .5334 L
s
P
p
.4 g
.33628 .10085 m
.55333 .55046 L
s
P
p
.4 g
.14911 .12207 m
.38525 .56736 L
s
P
P
p
1 0 .6 r
.02 w
.811 .33891 m
.82476 1.19593 L
s
P
p
1 g
.05 w
.811 .33891 Mdot
P
p
1 0 .6 r
.01414 w
.82476 1.19593 m
.83833 2.04066 L
s
P
p
1 0 .6 r
.01414 w
.82476 1.19593 m
.21873 1.82651 L
s
P
p
1 g
.002 w
.7317 .05601 m
.75393 1.9387 L
s
.75393 1.9387 m
.05601 1.98247 L
s
.05601 1.98247 m
.10047 .12758 L
s
.10047 .12758 m
.7317 .05601 L
s
.7317 .05601 m
.75393 1.9387 L
s
.75393 1.9387 m
.94399 2.21658 L
s
.94399 2.21658 m
.9078 .51481 L
s
.9078 .51481 m
.7317 .05601 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->1.1858,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000GMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP06000oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001DaPT000?6a<@00/@00`34aP0maP400000B]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62P0:a004
e/KFaP8003kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP400010aPX02/@>aP80?/H1000003OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00T000?Fa<@01l@06=K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFaP8003kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000baPD02/@4aP03a<K600_600?4a/H03<H00`34000maP400000<mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60004a01[a]K6e/KFa]K6e/KF
a]K4e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFaP340<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003;60P03aP03a<K600c600?4a/H0
2lH00lC6aP0;aP040<K403c60@00000be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H2001^e/KFa=K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6
e/KFaP36a03Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000</H00`360003aP03a<K600c600?4a/H02lH00lC6aP0:aP040<K403c60@00001S
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/K4a]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/@000?403`0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H01036aP03aP03
a<K600c600?4a/H02lH00lC6a008a006aP36a/@0>lH1000004kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K4e/KFa]K6e/KFa]K6e/K4a]K6e/H:a01:
e/KFa]K6e/KFaP36e/K40=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000</H01@36a/H000?600?4a/H02<H9a0W600?4a/H02<H01P36a/K403[6
0@00000ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
eP3Fa]H02/@0GLKFa]K4e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K60<KFa/@0e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000</H00`36aP02aPG4
3/H00lC6aP0;aP03a<K600O600<0a/H00/H00l@0aP0haP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa/C6e/KFa]K6e/KFa]K6a<KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K60<KFa]K40<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000baP030<K600?600D0a/K6a00>aP03a<K600_600?4a/H0
1/H00`36aP03aP03a03603O60@00001Ue/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/CFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K4e/KFa]K6
e/H0a]H01<@0>@3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP010000</H00`36aP04aP050<K6a/@03/H00lC6aP0;aP03a<K400G400<0a<@00lH00l@0
aP0gaP400000DmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/H0a]K6a<KFa]K6e/KFa]K6e/K4a]K6e/KF00W404KFa]K6e/H0a]K6e/KFa036e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003;600<0a/H0
1LH01@36a/K400_62L@8aP03a<K600C600<0a/H00/H403O60@000011e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa=H02L@07MK6e/CFa]K6
e/KFa]K6e/KFa=K6e/KFaP36e/KF00<003S40=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000baP030<K600K600<0a<@00l@<aP03a<K600c600?4a/H0
0lH00`36aP02aP<000?40<H0=LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6a<KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa/C6
e/KFaP36e/KFaSo6a03Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000<LH00`36aP08aP050<K6a/@03LH00lC6aP0<aP03a<K600;600<0a/H00lH01Do6
a/@003G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6eP3Fa]K4e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa=K6e/H0a]K6e/Hoa]K4
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000376
00<0a/H02LH01@36a/K400g600?4a/H03<H01LC6a/H000C600?4Cl@00l@00`36aP0baP400000G=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
0<KFa/C6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K61/@00`34a002a00kaSo6e/K40=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00037600<0a/H02/H01@36
a/K400g63<@2aP05a<K6aP001LH01To6a/K403C60@000016e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/CFaPc4053Fa]K6e/KFa]K6
e/KFa=K60<KFa]K6?lKFa]K40<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000aaP030<K600c61/@;aP03a<K600_600C4a/H01LH00do6aP02aP03a03603;6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFaP36e/K4a]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6a<H0a]K6e/Hoa]K6e/K40=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00037600<0a/H0
3LH01@36a/K400c600?4a/H02lH00lC60005aP03ClK600?600?40<H0<LH1000006cFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K4
e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa036e/KFaSo6e/H3a00c0<C6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000aaP030<K600k600D0a/K6a00<aP03
a<K600_600?40<@01<@014o4a<@30003a03603360@00001Je/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K60<KFa/C6e/KFa]K6e/KFa]K6
a<KFa]K62<@6000j?`00a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000aaP030<K600o600D0a/K6a009aPW41P03aP030<K600;600=?a/H01LH00`36
aP0_aP400000AmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]H0e/KF00[41000CLCFa]K6e/KFa]K6e/KF0=K6e/Hoa]K6e/KFaP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000aaP030<K60136
1L@00`36aP0GaP030<K600;600=?a/H01LH00`36aP0_aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6?lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000aaP030<K6013600<0a/H07<H00`36aP02aP03ClK600G6
00<0a/H0;lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaSo6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
<LH00`36aP0@aP030<K601c600<0a/H00/H00do6aP05aP030<K602o60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00037600<0a/H04<H00`36aP0LaP030<K600;6
00=?a/H01LH00`36aP0_aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6?lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000aaP030<K6013600<0a/H07<H00`36aP02aP03ClK600G600<0a/H0;lH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<LH00`36aP0@aP030<K601c6
00<0a/H00/H00do6aP05aP030<K602o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@00037600<0a/H04<H00`36aP0LaP030<K600;600=?a/H01LH00`36aP0_aP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6?lKFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000aaP030<K60136
00<0a/H07<H00`36aP02aP03ClK600G600<0a/H0;lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<LH00`36aP0@aP030<K601c600<0a/H00lH00co6aP04aP03
0<K602o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF?mK6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000376
00<0a/H04<H00`36aP0LaP030<K600?600<oa/H01<H00`36aP0_aP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000aaP030<K6013600<0a/H07<H00`36aP03aP03
?lK600G600<0a/H0;/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000<<H00`36aP0AaP030<K601c600<0a/H00lH00co6aP05aP030<K602k60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00033600<0a/H04LH00`36aP0LaP03
0<K600?600<oa/H01LH00`36aP0^aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000`aP030<K6017600<0a/H07<H00`36aP03aP03?lK600G600<0a/H0;/H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]Hoe/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<<H00`36aP0AaP03
0<K601c600<0a/H00lH00co6aP05aP030<K602k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@00033600<0a/H04LH00`36aP0LaP030<K600?600<oa/H01LH00`36
aP0^aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000`aP03
0<K6017600<0a/H07<H00`36aP03aP03?lK600G600<0a/H0;/H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<<H00`36aP0AaP030<K601c600<0a/H00lH00co6
aP05aP030<K602k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@00033600<0a/H04LH00`36aP0LaP030<K600?600<oa/H01LH00`36aP0^aP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000`aP030<K6017600<0a/H07<H00`36
aP03aP03?lK600G600<0a/H0;/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000<<H00`36aP0AaP030<K601c600<0a/H00lH00co6aP05aP030<K602k60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00033600<0a/H04LH00`36
aP0LaP030<K600?600<oa/H01LH00`36aP0^aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000`aP030<K6017600<0a/H07<H00`36aP03aP03?lK600G600<0a/H0
;/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]Hoe/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<<H00`36
aP0AaP030<K601c600<0a/H00lH00co6aP05aP030<K602k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00033600<0a/H04LH00`36aP0LaP030<K600?600<oa/H0
1LH00`36aP0^aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000`aP030<K6017600<0a/H07<H00`36aP02aP03Cco600K600<0a/H0;/H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF?mHoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<<H00`36aP0AaP030<K601c600@0a/I?
0/H00co6aP05aP030<K602k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=Hoe/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00033600<0a/H04LH00`36aP0LaP0304o600?600<oa/H01LH00`36aP0^aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000_aP030<K601;600<0a/H0
6lH00dl0aP04aP03?lK600G600<0a/H0;/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mH0e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000;lH00`36aP0BaP030<K601W600A?a/H01LH00co6aP05aP030<K602k6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF0=K6e/KF?mK6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002o600<0a/H0
4/H00`36aP0GaP03ClK600;600<0a/H00lH00co6aP05aP030<K602k60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002o600<0a/H04/H00`36aP0EaP03ClK600C6
00<0a/H00lH00co6aP06aP030<K602g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KF0=K6e/KF?mK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002o600<0a/H04/H00`36aP0CaP03ClK600K600<0a/H00lH00co6aP06aP03
0<K602g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF0=K6e/KF?mK6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002o6
00<0a/H04LH00`36aP0CaP03?lK600O600<0a/H00lH00co6aP06aP030<K602g60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002o600<0a/H04LH00`36aP0AaP03
?lK600W600<0a/H00lH00co6aP06aP030<K602g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002o600<0a/H04LH00`36aP0?aP03?lK600c600<0a/H00/H00co6
aP06aP030<K602g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFaP36
e/KF?mK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002o600<0a/H04LH00`36aP0=aP03?lK600k600<0a/H00/H00co6aP06aP030<K602g60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFaP36e/KF?mK6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002o600<0a/H04LH00`36
aP0;aP03?lK6013600<0a/H00/H00co6aP06aP030<K602g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF?mK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002o600<0a/H04LH00`36aP09aP03?lK601;600<0a/H0
0/H00co6aP06aP030<K602g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KF?mK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002o600<0a/H04LH00`36aP07aP03?lK601C600<0a/H00/H00co6aP06aP030<K602g6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF?mK6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002o600<0a/H0
4LH00`36aP05aP03?lK601K600<0a/H00/H00co6aP06aP030<K602g60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002o600<0a/H04LH00`36aP04aP03ClK601O6
00<0a/H00lH00do6aP05aP030<K602g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002o600<0a/H04LH00`36aP02aP03ClK601W600<0a/H00lH00do6aP05aP03
0<K602g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaSo6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002o6
00<0a/H04LH01036aTlMaP030<K600?600=?a/H01LH00`36aP0]aP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H0eSoFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000_aP030<K6017600<0ClH07/H00`36aP03aP03
ClK600G600<0a/H0;LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6?lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000;lH00`36aP0@aP03C`3601o600<0a/H00lH00do6aP05aP030<K602g60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]Ho
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002k600<0a/H03lH014o6aP0PaP03
0<K600?600=?a/H01LH00`36aP0]aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eSoFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000^aP030<K600g600=?a/H00/H00`36aP0NaP030<K600?600=?a/H01LH00`36
aP0]aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]Hoe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/Hoa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000^aP03
0<K600_600=?a/H01<H00`36aP0NaP030<K600?600=?a/H01LH00`36aP0]aP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF?mK6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000^aP030<K601;600<0a/H07/H00`36
aP03aP03ClK600G600<0a/H0;LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6?lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000;/H00`36aP0BaP030<K601k600<0a/H00lH00do6aP05aP030<K602g60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaSo6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002k600<0a/H04/H00`36
aP0NaP030<K600?600=?a/H01LH00`36aP0]aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000^aP030<K601;600<0a/H07/H00`36aP03aP03ClK600G600<0a/H0
;LH1000005gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02000?LKFa]K6?lKFa]K6e/H0
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002k600<0a/H0
4/H00`36aP0:aPd01lH00`36aP03aP03ClK600K600<0a/H0;<H1000004;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H>001Be/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/Hoa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000^aP030<K600C63@000lH0aP0QaP050<K6aTl02<H00`36aP0/aP40
0000;]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H7001]a]K6e/KF
a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/Hoa]K6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000<<H00`36aP0@aP03
0<K6027600@0a/I?2<H00`36aP0/aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<Hoa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000baP030<K600k600<0a/H08/H00`36C`08aP030<K602c60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF03o6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003C600<0a/H03<H00`36aP0TaP03
0<K600K600<0a/H0;<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000=/H00`36aP0:aP030<K602G600<0a/H01LH00`36aP0/aP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000haP030<K600S600<0a/H09lH00`36aP03aP03
0<K602c60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003[6
00<0a/H01/H00`36aP0XaP030<K600;600<0a/H0;<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000?<H00`36aP04aP030<K602W600D0a/K6000^aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000naP030<K600;600<0a/H0
:lH00`36000^aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
0010aP040<K602k60P0^aP400000ImK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H03@00;]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
@/H200_6600kaP400000@mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H03000DlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040002RaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP400000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0181836, -0.0250051, 
  0.00581656, 0.00581656}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.54112 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.227359 1.47904 0.0369761 1.47904 [
[ 0 0 0 0 ]
[ 1 1.54112 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.54112 L
0 1.54112 L
closepath
clip
newpath
p
1 g
.002 w
.85381 .03698 m
.88985 1.32867 L
s
.88985 1.32867 m
.03698 1.38095 L
s
.03698 1.38095 m
.08097 .12281 L
s
.08097 .12281 m
.85381 .03698 L
s
.92323 .2536 m
.20485 .32721 L
s
.20485 .32721 m
.176 1.50415 L
s
.176 1.50415 m
.96302 1.45999 L
s
.96302 1.45999 m
.92323 .2536 L
s
.85381 .03698 m
.88985 1.32867 L
s
.88985 1.32867 m
.96302 1.45999 L
s
.96302 1.45999 m
.92323 .2536 L
s
.92323 .2536 m
.85381 .03698 L
s
.08097 .12281 m
.20485 .32721 L
s
.20485 .32721 m
.176 1.50415 L
s
.176 1.50415 m
.03698 1.38095 L
s
.03698 1.38095 m
.08097 .12281 L
s
p
.4 g
.86096 .05929 m
.0937 .14382 L
s
P
p
.4 g
.87894 .11537 m
.12574 .19668 L
s
P
p
.4 g
.89622 .16931 m
.15658 .24756 L
s
P
p
.4 g
.91285 .22121 m
.18629 .29659 L
s
P
p
.4 g
.64026 .06069 m
.72505 .2739 L
s
P
p
.4 g
.41358 .08587 m
.51442 .29549 L
s
P
p
.4 g
.19085 .11061 m
.30719 .31672 L
s
P
P
p
1 0 .6 r
.02 w
.69243 .21764 m
.69836 .62595 L
s
P
p
1 g
.05 w
.69243 .21764 Mdot
P
p
1 0 .6 r
.01414 w
.69836 .62595 m
.70403 1.01708 L
s
P
p
1 0 .6 r
.01414 w
.69836 .62595 m
.41121 .92288 L
s
P
p
1 0 .6 r
.01 w
.41121 .92288 m
.1479 1.19516 L
s
P
p
1 0 .6 r
.01 w
.41121 .92288 m
.15076 1.02783 L
s
P
p
1 0 .6 r
.01 w
.70403 1.01708 m
.93766 1.31769 L
s
P
p
1 0 .6 r
.01 w
.70403 1.01708 m
.70944 1.39005 L
s
P
p
1 g
.002 w
.85381 .03698 m
.88985 1.32867 L
s
.88985 1.32867 m
.03698 1.38095 L
s
.03698 1.38095 m
.08097 .12281 L
s
.08097 .12281 m
.85381 .03698 L
s
.85381 .03698 m
.88985 1.32867 L
s
.88985 1.32867 m
.96302 1.45999 L
s
.96302 1.45999 m
.92323 .2536 L
s
.92323 .2536 m
.85381 .03698 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->1.1858,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000MMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP05000Xe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40001/aPT01<H00`36aP0VaP400000HmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4eP09000:e/KFa]K6e/KFaP?402T0a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP010000F/H900[62L@3aP809lH10000057Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
2@002]K6e/KFa]K6a<H9a00<a]K6e/KFa]K6e/KF0P009lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP010000AlH00l@0000700[62L@EaP809lH1000003oFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02@002]K6e/KFa]K6
e/H9a017a]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0003K62@09aP03a<K400O44LH00lC6aP0CaP030<H002K60@00000]
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00T000_Fa]K6e/KFa]K6
eP09a01He/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000TaPT000?4a/H02<H9a0S600?4a/H0
5lH00lC6aP0AaP;400@0a<@09LH10000023Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP@0
00[Fa]K6e/KFa]K62/@0=]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFaPW402_6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000PaP030<K600?62L@KaP03a<K601O62/@;aP040<K602G60@00000Pe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H200C403GFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6eP0:a00ma]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100008<H00`36000<aP03a<K601S600?4a/H01<H:a0[600?4a/H0
4LH01@36a/H002C60@000017e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02/@0DLKFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KF
a]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
8<H01036aP0=aP03a<K600[62L@4aP03a<K601S600?4a/H04<H00`34a002a0030<K602760@00000d
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/CFaP[403;Fa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFaPW402T0e/KFaP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008<H01@36a/H000K62L@HaP03a<K601O6
2/@9aP030<K600;600<0a/H08LH1000002KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KF00G403;6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6ePW4
03cFa=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008<H00`36aP03aP030<K600[600?4a/H05lH00lC6aP03aP[42<H301;600<0a/H00/H00`36
aP0PaP400000B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K62L@04LKFa]K6e/KFa]K6e/KFa]K600D003W6e/KFa]K6e/KF
a]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00023600<0a/H0
1<H00`36aP0:aP03a<K600[62L@4aP03a<K601?61@0AaP030<C400?400<0a/H07lH1000003OFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6a<KF00[402?6e/KF
a]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFaP050009a]K6e/KFa]K600S402P0a]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H01LH00`36aP03aPW46<H00lC6
aP0CaP<02/@8aP030<K600?600<0a/H07lH1000002WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6eP05a00ae/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6
e/KFa]K6eP07a08o0/@0>=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0001o600<0a/H01lH00`36aP0:aP03a<K601O600?4a/H00lH9a0O600A??lK4
4<H00`36000502360@00001=e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
0<KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02L@04=K6e/KFa]K6e/KFa]K6e/H2?`0:
e/CFa]K6e/KFaPX002KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP03
0<K600W600<0a/H02LH00lC6aP09aP[41<H00lC6aP0BaP05Ccl00<@01`08aP030<K600C600<0a/H0
7/H1000003[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa/C62L@06/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KF2@02?`0je/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K600[600<0a/H0
0/H9a1S600?400002009aP03Cco6017600<0a/H01<H00`36aP0NaP400000;=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K61L@06<KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6ePX0
01?6e/KFa]K6e/KFa]K6e/KFa]K6008o03[Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H02lH00`36aP09aP03a<K600;62`0MaP03
Cco6017600<0a/H01<H00`36aP0NaP400000==K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/H0a]K6e/H6000/a0000=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H2?`0je/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000OaP030<K600g61@0baP03Cco6017600<0a/H01<H00`36aP0NaP400000I]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH00`36
aP0daP03Cco6017600<0a/H01<H00`36aP0NaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH00`36aP0daP03Cco6017600<0a/H01<H00`36
aP0NaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o6
00<0a/H03LH00`36aP0daP03Cco6017600<0a/H01<H00`36aP0NaP400000I]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH00`36aP0daP03Cco60176
00<0a/H01LH00`36aP0MaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001o600<0a/H03LH00`36aP0daP03Cco6017600<0a/H01LH00`36aP0MaP400000I]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH00`36
aP0daP03Cco6017600<0a/H01LH00`36aP0MaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH00`36aP0daP03Cco6017600<0a/H01LH00`36
aP0MaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o6
00<0a/H03LH00`36aP0daP03Cco6017600<0a/H01LH00`36aP0MaP400000I]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03<H00`36aP0eaP03Cco60176
00<0a/H01LH00`36aP0MaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001o600<0a/H03<H00`36aP0eaP03Cco6017600<0a/H01LH00`36aP0MaP400000I]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001k600<0a/H03LH00`36
aP0eaP03Cco6017600<0a/H01LH00`36aP0MaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001k600<0a/H03LH00`36aP0eaP03Cco601;600<0a/H01<H00`36
aP0MaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001k6
00<0a/H03LH00`36aP0eaP03Cco601;600<0a/H01<H00`36aP0MaP400000I]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001k600<0a/H03LH00`36aP0eaP03Cco601;6
00<0a/H01<H00`36aP0MaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001k600<0a/H03LH00`36aP0eaP03Cco601;600<0a/H01<H00`36aP0MaP400000I]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001k600<0a/H03LH00`36
aP0eaP03Cco601;600<0a/H01<H00`36aP0MaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001k600<0a/H03LH00`36aP0eaP03Cco601;600<0a/H01LH00`36
aP0LaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03[Fa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001k6
00<0a/H03LH00`36aP0eaP03Cco601;600<0a/H01LH00`36aP0LaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K600g600<0a/H0<lH014o6aSlCaP03
0<K600G600<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100007/H00`36aP0=aP030<K6037600=?a/H00/H00co6aP0AaP030<K600G600<0a/H07<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0=aP03
0<K602o600=?a/H01<H00co6aP0AaP030<K600G600<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0=aP030<K602g600=?a/H01/H00co6
aP0AaP030<K600G600<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100007/H00`36aP0=aP030<K602_600=?a/H02<H00co6aP0AaP030<K600G600<0a/H0
7<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36
aP0=aP030<K602W600=?a/H02/H00co6aP0AaP030<K600G600<0a/H07<H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36aP0>aP030<K602O600=?a/H0
3<H00co6aP0AaP030<K600G600<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100007LH00`36aP0=aP030<K602K600=?a/H03/H00co6aP0AaP030<K600G6
00<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
7LH00`36aP0=aP030<K602C600=?a/H04<H00co6aP0AaP030<K600G600<0a/H07<H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36aP0=aP030<K602;6
00=?a/H04/H00co6aP0AaP030<K600G600<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36aP0=aP030<K6023600=?a/H05LH00do6aP0@aP03
0<K600G600<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100007LH00`36aP0=aP030<K601k600=?a/H05lH00do6aP0AaP030<K600C600<0a/H07<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36aP0=aP03
0<K601c600=?a/H06LH00do6aP0AaP030<K600G600<0a/H06lH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36aP0=aP030<K601[600=?a/H06lH00do6
aP0AaP030<K600G600<0a/H06lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100007LH00`36aP0=aP030<K601S600=?a/H07LH00do6aP0AaP030<K600G600<0a/H0
6lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36
aP0=aP030<K601G600<oClH08<H00do6aP0AaP030<K600G600<0a/H06lH1000004?Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o
05g6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K60<KF
a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001g600<0a/H03LH00`36aP0@aP03
Ccm?00;600<oa/H08<H00do6aP0AaP030<K600G600<0a/H06lH1000003kFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP8o06;Fa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K600g600<0a/H03<H00dloaP04aP03
?lK602;600=?a/H04LH00`36aP05aP030<K601_60@00000ie/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF00<o06KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100007LH00`36aP0=aP030<K600O600<oClH01lH00co6aP0TaP03
ClK6017600<0a/H01LH00`36aP0KaP400000=MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KF008o06_6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007LH00`36aP0=aP030<K600;600=??dl02/H00co6aP0VaP03ClK60176
00<0a/H01LH00`36aP0KaP400000<=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6eP3FaP8o073Fa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001g600<0a/H03LH00`1??`0=aP03?lK602S600=?a/H04LH00`36aP05aP030<K601_6
0@00000[e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eP03?`1de/KFa]K6
e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36
aP0:aP05?do6aP003LH00co6aP0ZaP03ClK6017600<0a/H01LH00`36aP0KaP400000J=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/Hoa]K6eP3Fa]K6e/KFa]K6e/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0>=K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H03/H00`36aP09aP03
?lK602c600=?aTl04LH00`36aP05aP030<K601_60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H03/H00`36aP07aP03?lK602k600A?a/Ho4<H00`36
aP05aP030<K601_60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6?lKFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001c600<0a/H03LH00`36aP07aP03ClK602o600=?a/H00/H00co6aP0<aP030<K600G600<0a/H0
6lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFaSo6
e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36
aP0=aP030<K600G600=?a/H0<LH00do6aP04aP03?lK600[600<0a/H01LH00`36aP0KaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6eSoFa]K6e/KFa]K6
e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000LaP030<K600g600<0a/H0
0lH00do6aP0caP03ClK600G600=?a/H02LH00`36aP06aP030<K601[60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]Hoe/KFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H03LH01@36a/I?03O600=?a/H0
1lH00do6aP07aP030<K600K600<0a/H06/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFaP36eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/Hoa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100007<H00`36aP0=aP030<I?03W600=?a/H02<H00co6aP06aP030<K600K6
00<0a/H06/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP0o
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFaSo6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
7<H00`36aP0=aP03ClK603W600=?a/H02/H00co6aP04aP030<K600K600<0a/H06/H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF?`36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6?lKFa]K6
eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36aP0;aP03ClH003_6
00=?a/H02lH00do6aP04aP030<K600G600<0a/H06/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6eSoFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eSoFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100007<H00`36aP09aP05ClK6aP00>lH00do6aP0=aP03ClK600;6
00<0a/H01LH00`36aP0JaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]Hoe/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000LaP030<K600g600<0a/H0>/H00co6aP0=aP05?lK6aP001lH00`36aP0JaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6
?lKF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000LaP030<K600g600<0a/H0
>/H00co6aP0?aP03?lH000O600<0a/H06/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6?`3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100007<H00`36aP0=aP030<K603[600<oa/H04<H00dl0aP06aP030<K601[6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001_600<0a/H0
3/H00`36aP0jaP03?lK6017600<0ClH01LH00`36aP0JaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KF0=Hoe/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K600k600<0a/H0>/H00co6aP0AaP040<K6C`C6
00<0a/H06/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6eP3FaSo6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
6lH00`36aP0>aP030<K603[600<oa/H04LH01@36a/Ho00?600<0a/H06/H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
?lKF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006lH00`36aP0>aP030<K603[600<oa/H0
4LH00`36aP03aP03?lH001c60@00001ee/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6e/KFa]K6e/KF00T002CFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100006lH00`36aP0>aP030<K603G64@08aP030<K600G600<0a/H06/H1000005CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H@000ne/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100006lH00`36aP0>aP030<K601G6400EaP03?lK601?600<0a/H0
1<H00`36aP0IaP400000<mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0
e/KFa]K6eP0A001Ne/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K600G6
400faP03?lK601C600<0a/H00lH00`36aP0IaP4000006mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP08001oa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007LH00`36aP0;aP030<K603_600<oa/H05LH00`36aP02aP030<K601W6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H0
2LH00`36aP1DaP050<K6aP006lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100008LH00`36aP07aP030<K605G600@0a/H06lH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH200K600<0a/H0ElH201_60@000025e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP02000Ka]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000VaP030<K600;600<0a/H0
ClH:01_60@00001[e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
4P009LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002S600@0a/H0;<HC03O6
0@000016e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaQ8004[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000ZaP802<HB05c60@00000[e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP09001^e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0149378, -0.0250053, 
  0.00588691, 0.00588691}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.33255 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.134119 1.3181 0.0329525 1.3181 [
[ 0 0 0 0 ]
[ 1 1.33255 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.33255 L
0 1.33255 L
closepath
clip
newpath
p
1 g
.002 w
.84313 .03295 m
.87795 1.07929 L
s
.87795 1.07929 m
.03295 1.13289 L
s
.03295 1.13289 m
.07968 .12041 L
s
.07968 .12041 m
.84313 .03295 L
s
.92895 .32994 m
.25603 .397 L
s
.25603 .397 m
.23158 1.2996 L
s
.23158 1.2996 m
.96705 1.25957 L
s
.96705 1.25957 m
.92895 .32994 L
s
.84313 .03295 m
.87795 1.07929 L
s
.87795 1.07929 m
.96705 1.25957 L
s
.96705 1.25957 m
.92895 .32994 L
s
.92895 .32994 m
.84313 .03295 L
s
.07968 .12041 m
.25603 .397 L
s
.25603 .397 m
.23158 1.2996 L
s
.23158 1.2996 m
.03295 1.13289 L
s
.03295 1.13289 m
.07968 .12041 L
s
p
.4 g
.84934 .05444 m
.09238 .14034 L
s
P
p
.4 g
.8705 .12769 m
.13575 .20836 L
s
P
p
.4 g
.89038 .19647 m
.17657 .27238 L
s
P
p
.4 g
.90908 .26118 m
.21506 .33274 L
s
P
p
.4 g
.9267 .32217 m
.2514 .38974 L
s
P
p
.4 g
.58768 .06222 m
.7045 .35231 L
s
P
p
.4 g
.30036 .09513 m
.4512 .37755 L
s
P
P
p
1 0 .6 r
.02 w
.65223 .24293 m
.65552 .49528 L
s
P
p
1 g
.05 w
.65223 .24293 Mdot
P
p
1 0 .6 r
.00707 w
.31614 .84482 m
.25319 .99735 L
s
P
p
1 0 .6 r
.00707 w
.80242 .91925 m
.81046 1.07436 L
s
P
p
1 0 .6 r
.01414 w
.65552 .49528 m
.65863 .73381 L
s
P
p
1 0 .6 r
.01414 w
.65552 .49528 m
.47814 .67797 L
s
P
p
1 0 .6 r
.01 w
.47814 .67797 m
.31614 .84482 L
s
P
p
1 0 .6 r
.01 w
.47814 .67797 m
.32062 .73652 L
s
P
p
1 0 .6 r
.00707 w
.31614 .84482 m
.16838 .997 L
s
P
p
1 0 .6 r
.00707 w
.80242 .91925 m
.93098 1.08505 L
s
P
p
1 0 .6 r
.01 w
.65863 .73381 m
.80242 .91925 L
s
P
p
1 0 .6 r
.01 w
.65863 .73381 m
.66156 .9584 L
s
P
p
1 0 .6 r
.00707 w
.66156 .9584 m
.6643 1.1691 L
s
P
p
1 0 .6 r
.00707 w
.66156 .9584 m
.61969 1.06281 L
s
P
p
1 0 .6 r
.00707 w
.32062 .73652 m
.16698 .79363 L
s
P
p
1 0 .6 r
.00707 w
.32062 .73652 m
.16767 .89338 L
s
P
p
1 g
.002 w
.84313 .03295 m
.87795 1.07929 L
s
.87795 1.07929 m
.03295 1.13289 L
s
.03295 1.13289 m
.07968 .12041 L
s
.07968 .12041 m
.84313 .03295 L
s
.84313 .03295 m
.87795 1.07929 L
s
.87795 1.07929 m
.96705 1.25957 L
s
.96705 1.25957 m
.92895 .32994 L
s
.92895 .32994 m
.84313 .03295 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->1.1858,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000NMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H01P008lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001`aPT01LH00`36aP0QaP400000ImK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H02@00<]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0005k62@0CaPC40P0RaP400000EMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
2@004mK6e/KFa]K6e/KFa]K6e/KFa]H02L@01=K6e/H2000Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40001;aPX01lH00lC6aP09aPW43LH202;60@000012e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62@005<KFa]K6e/KF
a]K6e/KFa]K6e/CF2L@0>]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000>LH901C62L@OaP030<H002760@00000`e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62@004lKFa]K6e/KFa]K6e/KFa]K6e/H02/@0C=K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100009lH900K600?4a/H02/H9a1;600?4a/H07LH00`36000QaP4000007]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT001?6e/KFa]K6e/KFa]K6e/KFa=K600W405o6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006LH501?62L@UaP03a<K601c600@0a/H0
8<H1000002SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K62L@0C/KFa]K6e/K4
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K600;40240a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001W60P04aPW4
4<H00lC6aP0UaP03a<K601;62L@01@36a/H001o60@00000Je/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP05a01=a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/K4a]K6e/KFa]K6e/H02L@0;LKFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100006LH00`36000MaP03a<K602C600?4a/H02L@CaP040<K601o60@00001J
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62L@0?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006LH01036aP0MaP03a<K601C6
2L@7aP03a<K601_600D0a/K6000NaP400000B=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFaPW40576e/KFa]K6e/KFa]K6e/KF
a/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001W600<0a/H00/H00`36aP0KaP03a<K600W46/H00lC6aP0JaP050<K6aP007/H10000
03KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9a01S
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000IaP030<K600?600<0a/H0
2lH9a0O600?4a/H08lH00lC6aP0IaP030<K600;600<0a/H06lH1000002CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFaP36e/H9a01Ca]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP001<@07P36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000HaP030<K600G61<@JaP03a<K602?600?4a/H03lH9a003
0<K600;600<0a/H06lH1000006cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/H:a00/e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
6<H00`36aP06aP030<K601_600?4a/H08LH9a1?600<0a/H00lH00`36aP0JaP400000F]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPW41000>lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000HaP030<K600S600<0a/H06/H00lC6aP0=aP[4
2<H601O600<0a/H00lH00`36aP0JaP400000AmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KF00W401;Fa]K6e/KFa]K6e/KFa]K6
e/H6000je/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000HaP030<K600W600<0a/H05/H:a1_61P0GaP030<K600C600<0a/H06LH1000003CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K62L@09LKFa]K4e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H01P006]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
1<@07034e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006<H00`36aP0:aP030<K600?62L@>aP03
a<K601k610000lC6aP0?aPK400<0a<@01LH00`36aP0HaP4000009]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K61L@0>LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP02?`0:e/K4a]K6e/KFaPW402W6e/KFa]H0e/KFa]K6eP3Fa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100006<H00`36aP0;aP030<K601[600?4a/H07/H00dloaP09a0o6
00<0a/H01LH00`36aP0HaP400000G]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H6a08o
03c4a/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100006<H00`36aP0=aP030<K601W600?4a/H03LH:a0K600=??lH00/H00lC6aP0CaP030<K600K6
00<0a/H05lH1000004_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]H02L@04=K6e/KFa]K6e/KFa]K6e/H2?`0le/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001S6
00<0a/H03/H00`36aP0FaPW46LH00dloaP03aP03a<K601;600<0a/H01/H00`36aP0GaP400000>MK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP09a00R
e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o01kFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/H5a00I0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100006<H00`36aP0?aP030<K600?6
2L@=aP03a<K601_600=??lH01<H00lC6aP0<aPG400<0a<@00/@601S60@00000[e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP05a00de/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o00[Fa]K6e/CFa]K62/@:000Ne/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001O600<0a/H04LH00`36aP0IaP03a<K601[600=??l@02L@:00G6
00<0a/H01lH00`36aP0FaP400000G=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K62<@2?`H0
03K40000e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
5lH00`36aP0CaP030<K601S600?4a/H01lH:a0P000=??lH06LH00`36aP06aP030<K601K60@000018
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K62/@00mH000070008e/KFa]K6e/H2?`0le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001O600<0a/H05<H00`36aP0=aP[4
00?6a000200AaP03Cco601W600<0a/H01/H00`36aP0FaP400000==K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H:a003eP0000P001_6a<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00Sl0?=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000GaP030<K601G61L@00lH0000802G600=??lH06LH00`36aP06aP03
0<K601K60@00000`e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
1@00;lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6008o03cFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
5lH00`36aP0FaP030<K6037600=??lH06LH00`36aP06aP030<K601K60@00001Te/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100005lH00`36aP0FaP030<K6037600=??lH0
6LH00`36aP07aP030<K601G60@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100005lH00`36aP0FaP030<K6037600=??lH06LH00`36aP07aP030<K601G60@00001T
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100005lH00`36aP0FaP03
0<K6037600=??lH06LH00`36aP07aP030<K601G60@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100005lH00`36aP0FaP030<K6037600=??lH06LH00`36aP07aP03
0<K601G60@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
5lH00`36aP0FaP030<K6037600=??lH06LH00`36aP07aP030<K601G60@00001Te/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100005/H00`36aP0GaP030<K6037600=??lH0
6LH00`36aP07aP030<K601G60@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100005/H00`36aP0GaP030<K6037600=??lH06LH00`36aP07aP030<K601G60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001K600<0a/H05lH00`36
aP0_aP04ClK6?a[600<0a/H01lH00`36aP0EaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000FaP030<K601O600<0a/H0;LH00do6aP02aP03?lK601S600<0a/H0
1lH00`36aP0EaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000FaP030<K601K600<0a/H0;<H00do6aP04aP03?lK601S600<0a/H01lH00`36aP0EaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000FaP030<K601K600<0a/H0
:/H00do6aP06aP03?lK601W600<0a/H01lH00`36aP0DaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000FaP030<K601K600<0a/H0:<H00do6aP08aP03?lK601W6
00<0a/H01lH00`36aP0DaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000FaP030<K601K600<0a/H09lH00co6aP09aP03?lK601W600<0a/H01lH00`36aP0DaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000FaP030<K601K6
00<0a/H09LH00co6aP0;aP03?lK601W600<0a/H01lH00`36aP0DaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000EaP030<K601O600<0a/H08lH00co6aP0>aP03
ClK601S600<0a/H01lH00`36aP0DaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000EaP030<K601O600<0a/H08LH00co6aP0@aP03ClK601S600<0a/H01lH00`36
aP0DaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000EaP03
0<K601O600<0a/H07lH00co6aP0BaP03ClK601S600<0a/H01lH00`36aP0DaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000EaP030<K601O600<0a/H07LH00co6
aP0DaP03ClK601S600<0a/H01lH00`36aP0DaP400000CMK6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o05?6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100005LH00`36aP0GaP030<K601S600A??dlo6<H00do6aP0HaP03
0<K600O600<0a/H05<H1000004OFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`1He/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000EaP030<K601O600<0a/H04/H00dloC`04aP03?lK601S600=?a/H06<H00`36aP07aP03
0<K601C60@000011e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]H00cl0G]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
5LH00`36aP0GaP030<K600c600=??dl02<H00co6aP0JaP03ClK601S600<0a/H01lH00`36aP0DaP40
0000>mK6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KF00<o06CFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001G600<0a/H0
5lH00`36aP06aP03Ccm?00c600<oa/H07<H00do6aP0HaP030<K600S600<0a/H04lH1000003GFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP04?`1Ya]K6e/KF
a]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000EaP030<K601O600H0a/I?
?dl2aP03?lK600_600<oa/H07/H00dloaP0HaP030<K600S600<0a/H04lH10000033Fa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`1`e/KFaSo6e/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000EaP030<K601G600<oCcl01LH00co6
aP0;aP03?lK6023600A?a/Ho5lH00`36aP08aP030<K601?60@00000[e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`1ea]H0e/KFaSo6e/KFa]K6e/KFa]K6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF
a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000DaP030<K6017600=??dl01<H01@36a/Ho00g6
00<oa/H08/H01Do6a/I?01O600<0a/H01lH00`36aP0CaP4000009MK6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]H00cl0N]K6e/KFa]H0e/Hoa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001C600<0a/H03LH00do6aP08aP030<Ho00g600<oa/H0
9<H00do6aP03aP03ClK601?600<0a/H01lH00`36aP0CaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF03o6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000DaP030<K601S600<oa/H02lH00co6aP0VaP03ClK600C6
00<oa/H04/H00`36aP07aP030<K601?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSl0e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0001C600<0a/H05/H00co6000;aP03?lK602S600=?a/H01/H00co6aP0@aP03
0<K600O600<0a/H04lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6eP3Fa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/H100005<H00`36aP0DaP05?lK6aP002LH00co6aP0ZaP03ClK600O600=?a/H03lH00`36aP07aP03
0<K601?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]H0
e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001C6
00<0a/H04/H00co6aP02aP030<K600K600<oClH0;<H00do6aP09aP03ClK600g600<0a/H01lH00`36
aP0CaP400000=]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/H0a]K6
e/KFaP8o06[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6eSoFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001C6
00<0a/H04<H00co6aP04aP030<K600C600<oaSl0;/H00do6aP0:aP03?lK600c600<0a/H01lH00`36
aP0CaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/H0a]K6
e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP40000DaP03
0<K600k600<oa/H01/H00`36aP02aP04?lK6Cbo600=?a/H03<H00co6aP0:aP030<K600S600<0a/H0
4/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K60<KFaSo6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H100005<H00`36
aP0GaP040<K6?`?600<oa/H0;/H00do6aP0=aP03ClK600W600<0a/H02<H00`36aP0BaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aSo6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP40000DaP030<K601O600<0?lH0
1<H00co6aP0^aP03ClK600o600=?a/H01lH00`36aP08aP030<K601;60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFaP36
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60@0001?600<0a/H05lH00cl0aP04aP03ClK602o6
00=?a/H04<H00co6aP06aP030<K600S600<0a/H04/H1000007WFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo60<KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KF008o02O6e/KFa]K60<KFa]K6e/KF
a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001?600<0a/H05LH013o6aP04aP03?lK6033600=?a/H0
4<H00co6?`06aP030<K600S600<0a/H04/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K60<KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KF?mK6?lKFa]K60<KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/H100004lH00`36aP0CaP03?lK600;600D0a/K6C`0caP03ClK6013600@oa/I?
1LH00`36aP08aP030<K601;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFaP36e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6eSoFa]Hoe/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001?600<0a/H04LH00co6aP04aP040<K6?c?600<oClH04LH00co6aP02aP05ClK6aP00
2/H00`36aP0BaP400000IMK6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/H0a]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o
03_6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]Hoe/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF
aP0100004lH00`36aP0?aP03?lK600K600@0a/Ho</H00do6C`0BaP03?lK600C600A?a/H02LH00`36
aP0BaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/H0aSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6?lKF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP40000CaP03
0<K601S600<0a/H0<lH00do6C`0CaP03ClK600C600<oaP002LH00`36aP0BaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/Ho0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP40000CaP030<K601S600<0a/H0</H013o6
aTlCaP03ClK600K600<0a/H01lH00`36aP0BaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFaP40000CaP030<K601S600<0a/H0<LH01Do6a/I?01?600=?a/H01/H00`1?
aP08aP030<K601760@00002Re/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
?lKFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]H0eSoFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
0@0001?600<0a/H06<H00`36aP0`aP03?lK600;600=?a/H04LH00do6aP06aP040<K6C`O600<0a/H0
4LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/Hoa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6eP3Fa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H100004/H00`36
aP0IaP030<K602o600=?a/H00lH00do6aP0AaP03ClK600K600D0a/K6?`06aP030<K601760@00002R
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/KFa]H0e/KFaSo6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60@0001;600<0a/H06LH00`36
aP0eaP03ClK601;62@05aP03?lK600;600<0a/H04LH1000006_Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6eP0@000Wa]K6e/KFa]H0e/KFa]K6?lKFaP36e/KFa]K6e/KF
a]K6e/KFa]K60040000BaP030<K601W600<0a/H0:/H@01W600<0a/H01lH00`36aP0AaP400000B]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K64@00AlKFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF
a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60040000BaP030<K601W600<0a/H02LH@01c600=?a/H0
7<H00`36aP06aP030<K601760@00000Ze/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K64000J=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60@0001;6
00<0a/H01LH@00C600<0a/H0=LH00do6aP0MaP030<K600G600<0a/H04LH1000001;Fa]K6e/KFa]K6
e/KFa]K6e/H80028e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000DaP030<K601O600<0a/H0=LH00do6aP0NaP03
0<K600C600<0a/H04LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/H100005/H00`36aP0DaP030<K603K600=?a/H07lH00`36aP03aP030<K601760@00000Ge/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H00P00RLKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60040000IaP030<K6017600<0a/H0
=/H00do6aP0PaP030<K600;600<0a/H04LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/H100006lH00`36aP0?aP030<K605[600D0a/K6000CaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP40000MaP803/H00`36aP1KaP050<K6aP00
4/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36
aP0:aP030<K605c600@0a/H04/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K6
e/KFa]K6e/H100008/H200W600<0a/H0GLH00`36000BaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3F0=K6e/KFa]K6e/KFa]K6e/KFaP40000UaP030<K600G600<0a/H0G/H201;60@00002>e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8001;Fa]K6e/KFa]K6e/KFa]K6e/H100009lH00`36aP03aP030<K605G6
2`0BaP400000:=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H20018e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K64`007LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000ZaP040<K60336500`aP40
0000B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K65000A=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002c60P09aQ<0F<H1000002gFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02P00JlKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP400000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0184371, -0.0250051, 
  0.00571171, 0.00571171}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.19463 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0702241 1.20973 0.0302432 1.20973 [
[ 0 0 0 0 ]
[ 1 1.19463 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.19463 L
0 1.19463 L
closepath
clip
newpath
p
1 g
.002 w
.84721 .03024 m
.88248 .92466 L
s
.88248 .92466 m
.03024 .98023 L
s
.03024 .98023 m
.0791 .12044 L
s
.0791 .12044 m
.84721 .03024 L
s
.93291 .3626 m
.28342 .42598 L
s
.28342 .42598 m
.26113 1.16439 L
s
.26113 1.16439 m
.96976 1.1267 L
s
.96976 1.1267 m
.93291 .3626 L
s
.84721 .03024 m
.88248 .92466 L
s
.88248 .92466 m
.96976 1.1267 L
s
.96976 1.1267 m
.93291 .3626 L
s
.93291 .3626 m
.84721 .03024 L
s
.0791 .12044 m
.28342 .42598 L
s
.28342 .42598 m
.26113 1.16439 L
s
.26113 1.16439 m
.03024 .98023 L
s
.03024 .98023 m
.0791 .12044 L
s
p
.4 g
.87047 .12043 m
.13425 .20291 L
s
P
p
.4 g
.89594 .21923 m
.19491 .29362 L
s
P
p
.4 g
.91893 .30838 m
.24988 .37583 L
s
P
p
.4 g
.75137 .0415 m
.8524 .37046 L
s
P
p
.4 g
.54047 .06626 m
.67469 .3878 L
s
P
p
.4 g
.33471 .09043 m
.50062 .40478 L
s
P
p
.4 g
.13391 .11401 m
.33008 .42143 L
s
P
P
p
1 0 .6 r
.005 w
.72684 .84594 m
.73265 .94061 L
s
P
p
1 0 .6 r
.005 w
.33841 .79246 m
.30014 .88565 L
s
P
p
1 0 .6 r
.02 w
.61687 .26643 m
.61864 .44212 L
s
P
p
1 g
.05 w
.61687 .26643 Mdot
P
p
1 0 .6 r
.005 w
.72684 .84594 m
.8052 .94684 L
s
P
p
1 0 .6 r
.005 w
.33841 .79246 m
.24827 .88533 L
s
P
p
1 0 .6 r
.00707 w
.38281 .68434 m
.33841 .79246 L
s
P
p
1 0 .6 r
.00707 w
.72007 .73559 m
.72684 .84594 L
s
P
p
1 0 .6 r
.01414 w
.61864 .44212 m
.6203 .60684 L
s
P
p
1 0 .6 r
.01414 w
.61864 .44212 m
.49524 .56887 L
s
P
p
1 0 .6 r
.01 w
.49524 .56887 m
.38281 .68434 L
s
P
p
1 0 .6 r
.01 w
.49524 .56887 m
.38655 .60735 L
s
P
p
1 0 .6 r
.005 w
.80937 .85084 m
.88935 .95406 L
s
P
p
1 0 .6 r
.00707 w
.38281 .68434 m
.2805 .78943 L
s
P
p
1 0 .6 r
.005 w
.80937 .85084 m
.9208 .89917 L
s
P
p
1 0 .6 r
.00707 w
.72007 .73559 m
.80937 .85084 L
s
P
p
1 0 .6 r
.01 w
.6203 .60684 m
.72007 .73559 L
s
P
p
1 0 .6 r
.005 w
.2805 .78943 m
.18749 .88495 L
s
P
p
1 0 .6 r
.005 w
.2805 .78943 m
.18592 .82704 L
s
P
p
1 0 .6 r
.01 w
.6203 .60684 m
.62185 .76075 L
s
P
p
1 0 .6 r
.00707 w
.62185 .76075 m
.62329 .90411 L
s
P
p
1 0 .6 r
.00707 w
.62185 .76075 m
.59211 .82835 L
s
P
p
1 0 .6 r
.00707 w
.38655 .60735 m
.28201 .64437 L
s
P
p
1 0 .6 r
.00707 w
.38655 .60735 m
.28127 .71509 L
s
P
p
1 0 .6 r
.005 w
.62329 .90411 m
.58171 1.02216 L
s
P
p
1 0 .6 r
.005 w
.28127 .71509 m
.18554 .81305 L
s
P
p
1 0 .6 r
.005 w
.28127 .71509 m
.18387 .75164 L
s
P
p
1 0 .6 r
.005 w
.62329 .90411 m
.62463 1.03725 L
s
P
p
1 0 .6 r
.005 w
.28201 .64437 m
.18193 .67981 L
s
P
p
1 0 .6 r
.005 w
.28201 .64437 m
.24096 .59131 L
s
P
p
1 0 .6 r
.005 w
.59211 .82835 m
.56323 .89399 L
s
P
p
1 0 .6 r
.005 w
.59211 .82835 m
.67019 .86458 L
s
P
p
1 g
.002 w
.84721 .03024 m
.88248 .92466 L
s
.88248 .92466 m
.03024 .98023 L
s
.03024 .98023 m
.0791 .12044 L
s
.0791 .12044 m
.84721 .03024 L
s
.84721 .03024 m
.88248 .92466 L
s
.88248 .92466 m
.96976 1.1267 L
s
.96976 1.1267 m
.93291 .3626 L
s
.93291 .3626 m
.84721 .03024 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->1.1858,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000P=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61@007LKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001gaPT01<H00`36aP0KaP400000K]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62@00:lKFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0006G62@08aP03a<K600_60P0LaP400000GMK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP08000Oa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFaP02000Le/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40001DaPT06/H00lC6aP0:aP807<H1000004_Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H02@00<=K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFaP80
01cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0004;62@0<aP03a<K601g600?4a/H02/H00`36
000KaP400000>MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP09001Pe/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6a<KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000376200NaP03
a<K601k600?4a/H02LH00`36000KaP400000:=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H9001aa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001o62@0AaP03a<K601c600?4a/H07/H00lC6aP08aP040<K601[60@00000Fe/KFa]K6
e/KFa]K6e/KFa]K6e/KFaPT008?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF
aP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100004/H400C600?4a/H07LH00lC6aP0LaP03
a<K601g600?4a/H01lH01L@0a<@001[60@00001je/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9a00Oa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100004/H200S600?4a/H07<H00lC6aP0LaP03a<K601G62L@:aP040<K601W60@00001Z
e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFaPS4033Fa]K6e/KFa/C6
e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100004/H00`360008aP03a<K601c6
00?4a/H07<H00lC6aP03aPW44LH00lC6aP07aP040<K601W60@00001Ie/KFa]K6e/KFa]K6e/KFa]K6
0<KF0=K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H02<@0@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6eP3Fa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000BaP050<K6aP001lH00lC6aP0LaP03a<K601362L@3aP03
a<K601c600?4a/H01lH01@36a/H001S60@000018e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K62<@0D]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100004/H00`36aP02aP030<K600G600?4a/H07<H00lC6a007a1C600?4a/H07LH00lC6
aP06aP050<K6aP006<H1000003OFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6e/KFa/C6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00W406;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000AaP030<K600C600<0a/H01/H00lC6aP0;aPS42<H00lC6aP0KaP03a<K601c600?4a/H01/H00`36
aP02aP030<K601G60@00000We/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa=K6e/KF00S4
07?6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000AaP030<K600K600@0a/K62L@IaP03a<K601_600?4a/H07<H00lC6aP05aP030<K600?600<0a/H0
5<H1000001[Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaPC408CFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100004LH00`36
aP07aP030<K600G600?4a/H07<H00lC6aP0JaP03a<K601c600?4a/H01<H00`36aP03aP030<K601C6
0@000026e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6eP05a00G0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00017600<0a/H0
2<H00`36aP05aP03a<K601c600?4a/H06/H00lC6aP0JaPS400<0a/H01<H00`36aP0CaP400000LmK6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]H02/@09LKF
a=K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00017600<0a/H02LH00`36aP06aP03
a<K601_600?4a/H06/H00lC6aP06aPW43<H00lC6aP03aP030<K600C600<0a/H04lH10000067Fa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K400<01/@0>=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@00017600<0a/H02lH00`36aP05aP03
a<K601_600?4a/H03lH9a0D06lH00lC6aP02aP030<K600G600<0a/H04/H1000004kFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/H9a008a]K6e/KFa]H7000le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6eP3Fa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60@00017600<0a/H03<H00`36aP05aP03a<K601W62/@AaPL0
6/H00lC6aP02aP030<K600G600<0a/H04/H1000003_Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6eP09a00Ke/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00L003cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/H100004LH00`36aP0=aP030<K600G600?4a/H01LH:a0c600?4a/H05/H501c600G4a/K6
0008aP030<K601760@00000Xe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP36e/KFaPW4
0336e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H3000na<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H10000
4LH00`36aP0?aPG40lH00lC6aP0JaP03a<K601K600@oClK47<H01LC6a/H000S600<0a/H04LH10000
067Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o03o6a<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6a<KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H00@00013600<0a/H0
4LH00`36aP05aP03a<K601[600?4a/H05LH01Cm?a/K401c600G4a/K60003aPG400<0a/H04<H10000
067Fa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o01g6e/CFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP06a00L0<C4a=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP40000@aP030<K601;6
00<0a/H01LH00lC6aP0JaP03a<K601C600<oClH00/H00lC6aP0=aP[40lH01<C6aP08aP030<K60136
0@00001Qe/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa/C6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`09a]K6a<KFa]K600[4
02cFa]K6e/KFa]K6e/KFa=K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP40000@aP030<K601C6
00<0a/H01<H00lC6aP0JaP03a<K601?600<oCl@02<@GaP04a<K600W600<0a/H03lH1000005SFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K62L@2?`0oa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6a<H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60040000@aP030<K601G600<0a/H01LH00lC6
aP0IaP03a<K400W42LH00cm?aP03aP03a<K601[600?4aP002LH00`36aP0?aP400000A=K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6
2/@04mK6e/KFa]K6e/KFa]K6e/KFa]H00Sl0?lKFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a/C60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP0100004<H00`36aP0FaP030<K600G600?4a/H0
1/H:a0W600?4a/H04LH00cm?aP04aP03a<K601[600?40<H01<H601360@00000`e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K62/@09mK6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6eP02?`0Oa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP030003
a00000@001KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K60@00013600<0a/H05lH00`34a003a0;600?4a/H0
6/H00lC6aP0?aP03?do600G600?4a/H03LH900C600<0a/H02<H00`36aP0>aP400000HMK6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]H00Sl03<KFa]K6e/CFa]K6ePX002W6e/KFa]K6e/KF
a]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP0100004<H00`36aP0IaP030<K600G600?4a/H0
6LH00lC6aP0>aP04?do6aPD000?400000P0GaP030<K600S600<0a/H03/H1000005cFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFaPD00Sl2000ma]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP0100004<H00`36aP0JaP030<K600G600?4a/H0
6LH00l@0000800G600<oClH08/H00`36aP08aP030<K600k60@000018e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K62P003mK6
e/KFa]K6e/KFa]K6eP02?`0oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF
a]K6eP3Fa]K6e/KFa]K6e/KFa]K60040000@aP030<K601_600<0a/H01LH00lC6aP06aPT06LH00cm?
aP0RaP030<K600S600<0a/H03/H1000003GFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6eP020003a00000D002;6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KF0Sl0?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFaP0100004<H00`36aP0MaPD0;<H00cm?aP0RaP030<K600S600<0a/H03/H10000
067Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o03o6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H00@0000o600<0a/H0
7/H00`36aP0^aP03?do602;600<0a/H02LH00`36aP0=aP400000HMK6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H00Sl0?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF
a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP0100003lH00`36aP0NaP030<K602g600=??dl08lH00`36
aP09aP030<K600g60@00001Oe/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H013l0?lKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
aP0100003lH00`36aP0NaP030<K602_600E??dloC`0SaP030<K600W600<0a/H03LH1000005gFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl0@]Ho?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP40000?aP030<K601k600<0a/H0
:LH00dloC`02aP03?do602?600<0a/H02<H00`36aP0=aP400000FmK6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H00cl00mK6eP02?`0oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60040000?aP030<K601k600<0a/H09lH00dloC`04aP03
?do602?600<0a/H02<H00`36aP0=aP400000FMK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
00GFa]K6eP02?`0oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0
a]K6e/KFa]K6e/KFa]K60040000?aP030<K601k600<0a/H09LH00dloC`06aP03?do602?600<0a/H0
2<H00`36aP0=aP400000EmK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`07e/KFa]K6eP02?`0o
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF
a]K60040000?aP030<K601k600<0a/H08lH00dloC`08aP03?do602?600<0a/H02<H00`36aP0=aP40
0000EMK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl02MK6e/KFa]K6eP02?`0oa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60040000?aP03
0<K601k600<0a/H08LH00dloC`0:aP03?do602?600<0a/H02<H00`36aP0=aP400000DmK6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00<o00_Fa]K6e/KFa]K6eP02?`0oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60040000?aP030<K601k600<0a/H0
7lH00dloC`0<aP03?do602?600<0a/H02<H00`36aP0=aP400000DMK6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP03?`0=e/KFa]K6e/KFa]K6eP02?`0oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60040000>aP030<K601k600<0a/H07/H00dloC`0>aP03
?do602?600<0a/H02<H00`36aP0=aP400000C]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP@o00oFa]K6e/KFa]K6
e/KFa]H00Sl0?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KF
a]K6e/KFa]K6e/KFaP0100003/H00`36aP0NaP030<K601W600HoCco6?dl@aP03?do602?600<0a/H0
2<H00`36aP0=aP400000B=K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o01K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KF0Sl0?lKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
aP0100003/H00`36aP0IaP03ClK600;600<0a/H04lH00cm??`05aP03?lK6017600<oClH08lH00`36
aP08aP030<K600g60@000012e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]H0e/KFa]K6e/KFa]K6e/KFa]K60cl07<KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]H2?`0o
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF
a]K60040000>aP030<K601[600Doa/K6000?aP03?dlo00W600<oa/H04lH00cm?aP0SaP030<K600W6
00<0a/H03<H1000003cFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
eP3Fa]K6e/KFa]K6e/H4?`0Qe/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o03o6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0
0@0000k600<0a/H07<H00co60009aP03?dlo00;600=?a/H02<H00co6aP0FaP03Cco602;600<0a/H0
2LH00`36aP0<aP400000=mK6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoF0=K6e/KFa]H00Sl0JLKFa]Hoe/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHo
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF
aP0100003/H00`36aP0MaP03C`3600?600=??dl01LH00do6aP08aP03?lK601S600A?a/Ho8LH00`36
aP09aP030<K600c60@00000ae/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]HoeP03?`1^e/KFa]K6eSoFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/H100003/H00`36aP0NaP03?do600S600=?a/H02<H00co6aP0JaP05ClK6aTl08<H00`36aP09aP03
0<K600c60@00000/e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`1c
0=K6e/KFa]K6eSoFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Hoe/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP010000
3/H00`36aP0HaP03?dlo00?600<0a/H01/H00do6aP08aP03?lK601c600=?a/H00lH00do6aP0MaP03
0<K600S600<0a/H03<H1000002KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o
07W6e/KFa]H0e/KFa]K6eSoFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Ho
a]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KF
a]K60040000>aP030<K601;600<oCcl02LH00`36aP04aP03ClK600S600<oa/H07/H00do6aP05aP03
ClK601_600<0a/H02<H00`36aP0<aP4000008MK6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
eP02?`1oa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6?lKFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3F
a]K6e/KFa]K6e/KFaP0100003LH00`36aP0OaP030<K600;600=?a/H02<H00co6aP0QaP03?lK600G6
00<oa/H06/H00`36aP08aP030<K600c60@00000ne/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KF?mK6e/KFa]K6e/H2?`1Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/H100003LH00`36aP0OaP040<K6C`[600<oClH08lH00co6aP07aP03?lK601S6
00<0a/H02<H00`36aP0<aP400000X]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=Hoe/KFa]K6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFaP40000=aP030<K601o600<oClH02LH013o6aTlTaP03?lK600S600=?a/H05lH00`36aP08aP03
0<K600c60@00000/e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`1c
03o6e/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF
a]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP010000
3LH00`36aP0JaP03Cco600;600<oa/H01lH01Co6a/Ho02G600<oa/H02/H00do6aP0EaP030<K600S6
00<0a/H03<H1000002SFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0N=K6
e/Ho0=K6e/KFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP40
000=aP030<K601G600<oCcl01LH00co60007aP03?lK600;600=?a/H09<H00co6aP0;aP03?lK601C6
00<0a/H02<H00`36aP0<aP4000008mK6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o
04c6e/KFa]K6?lKF0=K6e/KFaSo6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eSoFa]K6e/KFa]K6e/KF0Sl0;lKFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFaP36e/KF
a]K6e/KFa]K60040000=aP030<K601;600=?a/H01/H01Co6a/H000G600<oa/H00lH00co6aP0UaP03
?lK600_600<oaSl05<H00`36aP09aP030<K600_60@00002Re/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]H0e/KFaSo6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K60@0000g600<0a/H06LH00co6aP03aP050<K6aSl01lH00co6aP0UaP03
?lK600_600@oa/I?4lH00`36aP09aP030<K600_60@00001Re/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]H0e/Hoa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H2?`0ne/KFa]K6e/KFa]K6eSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/H100003LH00`36aP0GaP03?lK600G600<0aSl02<H00do6aP0UaP03
Cco600c600<oa/H00/H00do6aP0?aP030<K600W600<0a/H02lH1000002oFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6eP02?`1aa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KF
a]K60<KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H00@0000g600<0a/H05LH00co6aP04aP05Ccm?04l0
2<H00co6aP0UaP03?lHo00k600=?a/H00/H00co6aP0>aP030<K600W600<0a/H02lH1000002[Fa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/H2?`0<e/H0?mK6e/KFa]K60Sl0J=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF?mK6e/KFa]K6e/KFa]K6?lKFa]K6
?lKFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60@0000c600<0a/H05<H00co6
aP02aP03Cco600?600=?a/H01/H00cm?aP0VaP04ClK6?`k600=?a/H01<H00co6aP0<aP030<K600W6
00<0a/H02lH1000002GFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF00<o07[Fa]K6
eSl0a]K6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]K6
e/KFa]K6e/KFaSo6e/KFa]Hoe/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP40
000<aP030<K601C600<oClH01/H00do60006aP03?lHo02O600Doa/K6?`0>aP03ClK600G600=?a/H0
2lH00`36aP09aP030<K600_60@00001Ne/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6eSoFaP36e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o
04;Fa]Hoe/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]Hoe/KFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/H100003<H00`36aP0KaP05ClK6aP001<H01Co6a/Ho02K600I?aTloaSl>aP03ClK600K6
00<oa/H02/H00`36aP09aP030<K600_60@00001Re/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFaP36e/Hoa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/H2?`0ne/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6?lKFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/H100003<H00`36aP0IaP03ClK600?600@0a/Ho1<H00do6aP0TaP03?lK600?6
00<oCcl03<H00do6aP08aP03?lK600W600<0a/H02<H00`36aP0;aP400000I]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/H0aSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eSoFaP8o01KFa]K6e/KFa]K6?lKFa]K6e/KFa]K60Sl08]K6
e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H100003<H00`36aP0GaP03ClK600G600<0?lH0
1<H00co6aP0TaP03ClK600C600<oa/H00/H00dloaP07aP03Cco600W600E?aTloC`06aP030<K600S6
00<0a/H02lH1000008?Fa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
?lKFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]Hoe/KFa]K6
?lKFa]K6e/HoaSo6e/KFa]K6e/KF?mK6eP02?`0Ma]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H0
0@0000c600<0a/H05LH00do6aP06aP03?`3600C600=?a/H09<H00co6aP05aP03?lK600c600A?a/Ho
2/H00do6aP02aP05?dloaP002/H00`36aP0;aP400000X]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6e/KFa]K6?lH0a]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6eSoFa]K6e/KFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6eSoFa]K6e/Ho0=K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFaP40000<aP030<K601?600=?a/H01/H013o6aP04aP03?lK602G600<oa/H0
1LH00co6aP0<aP05ClK6aTl02lH00do6aP04aP0304lo00S600<0a/H02lH1000008cFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/Hoa]K6eSoFa]K6e/KFa]K6
?lKFa]K6eP3FaP<o01?6e/KFaP36e/KFa]K6e/KFa]K60040000<aP030<K601o600<0a/H0</H00co6
aP0=aP03?lK600;600=?a/H02<H00co6aP03aP030<K600?600<oa/H00lH00`36aP0:aP400000X]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]Hoe/KFa]Ho
e/KFa]K6e/KFaSo6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP40000<aP030<K601o600<0a/H0
<LH00dloaP0>aP03?lK600C600=?a/H02<H01Co6a/H000_600<0a/H02/H1000006;Fa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o01kFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6?lKFa]K6
e/H8000He/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60@0000_600<0a/H08<H00`36aP0aaP03Cco600k6
00<o00003004aP04ClK600_600<0a/H02/H1000006KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mHoe/H>000^e/KFa]K6e/Hoa]K6e/KFa]K6eSoFaP36e/KFa]K6e/KF0=K6e/KFa]K6
e/KFaP40000;aP030<K6023600<0a/H09lH>00g600<oa/H01lH00co6aP08aP03ClH000[600<0a/H0
2/H1000004[Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPh004[Fa]K6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KF?mH0e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP40000;aP030<K6023600<0a/H0
2lH>01K600A?a/Ho9/H00dl0aP08aP030<K600[60@00000^e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPh006KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/H100002lH00`36aP0BaPl0<LH014o6aSlXaP030<K600K600<0a/H02/H1000001;Fa]K6
e/KFa]K6eP3Fa]K6e/H>0022e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFaP40000;aPL07<H00`36aP0^aP05?lK6aSl0:LH00`36
aP05aP030<K600[60@00002Re/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6
0@0000k600<0a/H07LH00`36aP0]aP03ClK600;600<oa/H0:<H00`36aP04aP030<K600[60@00002R
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K60@0001360P0LaP030<K602g6
00=?a/H00/H00co6aP0XaP030<K600C600<0a/H02/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6eP3Fa]K6e/KFa]K6e/H100004lH00`36aP0HaP030<K602c600<oa/H00lH00co6aP0YaP03
0<K600?600<0a/H02/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6
e/H100005LH201O600<0a/H0</H00co6aP0ZaP030<K600;600<0a/H02/H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/H100006<H00`36aP0BaP030<K6067600D0a/K6
000<aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFaP40000JaP80
4LH00`36aP1RaP050<K6aP002lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6
e/KFa]K6e/H100007LH00`36aP0=aP030<K606?600@0a/H02lH1000001kFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H20022e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFaP40000PaP030<K600[600<0a/H0I<H00`36000;aP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFaP40000RaP030<K600S6
00<0a/H0I<H00`36000;aP4000008mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0080
0736e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0P002lKF
a]K6e/KFa]K60040000UaP030<K600G600<0a/H0ILH200_60@00002=e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00X000_6e/KFa]K6e/KFaP0100009lH00`36aP03aP030<K604c64@0EaP400000:=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H20010e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQ8002KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000ZaP040<K602_64@0haP400000AmK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0180
04W6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000/aP802<HA05_60@00000]e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00T006cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0194453, -0.0250049, 
  0.00557925, 0.00557925}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.12611 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0378107 1.15776 0.0289441 1.15776 [
[ 0 0 0 0 ]
[ 1 1.12611 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.12611 L
0 1.12611 L
closepath
clip
newpath
p
1 g
.002 w
.85185 .02894 m
.88765 .84749 L
s
.88765 .84749 m
.02894 .90453 L
s
.02894 .90453 m
.07921 .1212 L
s
.07921 .1212 m
.85185 .02894 L
s
.93506 .37957 m
.29946 .44075 L
s
.29946 .44075 m
.27836 1.09716 L
s
.27836 1.09716 m
.97106 1.06086 L
s
.97106 1.06086 m
.93506 .37957 L
s
.85185 .02894 m
.88765 .84749 L
s
.88765 .84749 m
.97106 1.06086 L
s
.97106 1.06086 m
.93506 .37957 L
s
.93506 .37957 m
.85185 .02894 L
s
.07921 .1212 m
.29946 .44075 L
s
.29946 .44075 m
.27836 1.09716 L
s
.27836 1.09716 m
.02894 .90453 L
s
.02894 .90453 m
.07921 .1212 L
s
p
.4 g
.86149 .06955 m
.1045 .1579 L
s
P
p
.4 g
.88166 .15455 m
.15763 .23498 L
s
P
p
.4 g
.90002 .23192 m
.2062 .30545 L
s
P
p
.4 g
.9168 .30264 m
.25078 .37012 L
s
P
p
.4 g
.9322 .36755 m
.29184 .42969 L
s
P
p
.4 g
.85724 .0283 m
.93944 .37914 L
s
P
p
.4 g
.68553 .0488 m
.79925 .39264 L
s
P
p
.4 g
.51758 .06886 m
.66156 .40589 L
s
P
p
.4 g
.35327 .08848 m
.5263 .41891 L
s
P
p
.4 g
.19249 .10768 m
.39341 .43171 L
s
P
P
p
1 0 .6 r
.00353 w
.35196 .76634 m
.37559 .79435 L
s
P
p
1 0 .6 r
.00353 w
.69208 .80957 m
.64513 .83352 L
s
P
p
1 0 .6 r
.00353 w
.69208 .80957 m
.6965 .87522 L
s
P
p
1 0 .6 r
.00353 w
.35196 .76634 m
.32549 .83101 L
s
P
p
1 0 .6 r
.005 w
.68699 .73389 m
.69208 .80957 L
s
P
p
1 0 .6 r
.00353 w
.74851 .81315 m
.75202 .87989 L
s
P
p
1 0 .6 r
.005 w
.38237 .69205 m
.35196 .76634 L
s
P
p
1 0 .6 r
.00353 w
.31179 .76461 m
.28538 .83071 L
s
P
p
1 0 .6 r
.02 w
.60091 .27943 m
.60203 .4171 L
s
P
p
1 g
.05 w
.60091 .27943 Mdot
P
p
1 0 .6 r
.00353 w
.74851 .81315 m
.80366 .88423 L
s
P
p
1 0 .6 r
.005 w
.68699 .73389 m
.74851 .81315 L
s
P
p
1 0 .6 r
.005 w
.38237 .69205 m
.31179 .76461 L
s
P
p
1 0 .6 r
.00707 w
.41746 .60634 m
.38237 .69205 L
s
P
p
1 0 .6 r
.00707 w
.68109 .64621 m
.68699 .73389 L
s
P
p
1 0 .6 r
.00353 w
.81359 .81729 m
.81602 .88527 L
s
P
p
1 0 .6 r
.00353 w
.31179 .76461 m
.24778 .83042 L
s
P
p
1 0 .6 r
.01414 w
.60203 .4171 m
.60308 .5455 L
s
P
p
1 0 .6 r
.01414 w
.60203 .4171 m
.50538 .5162 L
s
P
p
1 0 .6 r
.00353 w
.26504 .76261 m
.23874 .83036 L
s
P
p
1 0 .6 r
.01 w
.50538 .5162 m
.41746 .60634 L
s
P
p
1 0 .6 r
.01 w
.50538 .5162 m
.42071 .54521 L
s
P
p
1 0 .6 r
.00353 w
.81359 .81729 m
.86974 .88978 L
s
P
p
1 0 .6 r
.005 w
.75096 .73643 m
.81359 .81729 L
s
P
p
1 0 .6 r
.00707 w
.41746 .60634 m
.33757 .68825 L
s
P
p
1 0 .6 r
.005 w
.75096 .73643 m
.83719 .77296 L
s
P
p
1 0 .6 r
.00707 w
.68109 .64621 m
.75096 .73643 L
s
P
p
1 0 .6 r
.01 w
.60308 .5455 m
.68109 .64621 L
s
P
p
1 0 .6 r
.005 w
.33757 .68825 m
.26504 .76261 L
s
P
p
1 0 .6 r
.005 w
.33757 .68825 m
.26456 .71608 L
s
P
p
1 0 .6 r
.01 w
.60308 .5455 m
.60405 .66487 L
s
P
p
1 0 .6 r
.00353 w
.26504 .76261 m
.19925 .83006 L
s
P
p
1 0 .6 r
.00353 w
.57273 .86833 m
.54434 .9501 L
s
P
p
1 0 .6 r
.00353 w
.26445 .70489 m
.23751 .77529 L
s
P
p
1 0 .6 r
.00353 w
.83719 .77296 m
.89439 .84695 L
s
P
p
1 0 .6 r
.00353 w
.83719 .77296 m
.91742 .80695 L
s
P
p
1 0 .6 r
.00707 w
.60405 .66487 m
.60495 .77555 L
s
P
p
1 0 .6 r
.00707 w
.60405 .66487 m
.58046 .71534 L
s
P
p
1 0 .6 r
.00707 w
.42071 .54521 m
.33999 .57286 L
s
P
p
1 0 .6 r
.00707 w
.42071 .54521 m
.33881 .6289 L
s
P
p
1 0 .6 r
.00353 w
.57273 .86833 m
.49171 .9183 L
s
P
p
1 0 .6 r
.005 w
.60495 .77555 m
.57273 .86833 L
s
P
p
1 0 .6 r
.00353 w
.26456 .71608 m
.19571 .74234 L
s
P
p
1 0 .6 r
.00353 w
.26456 .71608 m
.19742 .78474 L
s
P
p
1 0 .6 r
.005 w
.33881 .6289 m
.26445 .70489 L
s
P
p
1 0 .6 r
.005 w
.33881 .6289 m
.26395 .65595 L
s
P
p
1 0 .6 r
.00353 w
.26445 .70489 m
.19698 .77384 L
s
P
p
1 0 .6 r
.005 w
.60495 .77555 m
.60578 .8779 L
s
P
p
1 0 .6 r
.00353 w
.60578 .8779 m
.60655 .97232 L
s
P
p
1 0 .6 r
.00353 w
.60578 .8779 m
.67145 .93701 L
s
P
p
1 0 .6 r
.005 w
.33999 .57286 m
.26337 .59911 L
s
P
p
1 0 .6 r
.005 w
.33999 .57286 m
.30917 .53053 L
s
P
p
1 0 .6 r
.00353 w
.26395 .65595 m
.19326 .6815 L
s
P
p
1 0 .6 r
.00353 w
.26395 .65595 m
.19506 .72616 L
s
P
p
1 0 .6 r
.005 w
.58046 .71534 m
.55779 .76383 L
s
P
p
1 0 .6 r
.005 w
.58046 .71534 m
.64033 .74131 L
s
P
p
1 0 .6 r
.00353 w
.26337 .59911 m
.19094 .62393 L
s
P
p
1 0 .6 r
.00353 w
.26337 .59911 m
.19283 .67078 L
s
P
p
1 0 .6 r
.00353 w
.30917 .53053 m
.27968 .49001 L
s
P
p
1 0 .6 r
.00353 w
.30917 .53053 m
.23737 .55386 L
s
P
p
1 0 .6 r
.00353 w
.64033 .74131 m
.69734 .76605 L
s
P
p
1 0 .6 r
.00353 w
.64033 .74131 m
.62115 .78691 L
s
P
p
1 0 .6 r
.00353 w
.55779 .76383 m
.53611 .81021 L
s
P
p
1 0 .6 r
.00353 w
.55779 .76383 m
.47344 .80335 L
s
P
p
1 g
.002 w
.85185 .02894 m
.88765 .84749 L
s
.88765 .84749 m
.02894 .90453 L
s
.02894 .90453 m
.07921 .1212 L
s
.07921 .1212 m
.85185 .02894 L
s
.85185 .02894 m
.88765 .84749 L
s
.88765 .84749 m
.97106 1.06086 L
s
.97106 1.06086 m
.93506 .37957 L
s
.93506 .37957 m
.85185 .02894 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->1.1858,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000Q=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPD001W4e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001laPP01<H00`34aP0GaP400000M=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K620009]K6e/KFa]K6e/KFaP34e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0006c6200DaP8000?4a/H05LH1000006?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H02@007=K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2000Ha<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0005_6200<aP03a<K601K60P000lC6aP0EaP400000DmK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00P002[6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KF
a]H3a08001S4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000BlH80003a<K601W600?4a/H02/H9a0?6
00@0aP345/H1000004?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00P002W6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6a<KFaP08a00Ve/KFa]K6e/KFa]K60<H0a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>LH00lC6
0007017600?4a/H05<H9a1C600@0aP345/H1000003?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02000:<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KF
a]K6e/KFa]H8a00ga]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP34e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP010000:/H900O600?4a/H06<H00lC6aP02aPW43/H00lC6aP0DaP040<H0a1K60@00000R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4aPP002SFa]K6e/KFa]K6e/KFa]K6a<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K62<@0B=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]H0a<KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000JaPP06LH00lC6aP0;aPW41<H00lC6
aP0HaP03a<K601C600D0a/H0a00EaP4000004]K6e/KFa]K6e/KFa]K6e/KFaPP002OFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]H02<@0FLKFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP34a]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000>aP@04<H00lC6aP0CaPW45/H00lC6aP0HaP03a<K601C600@0aP345LH10000033Fa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/H8a01Ze/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K60<CFa]K6e/KFa]K6e/KFa]K6e/KFaP40000>aP804lH01<C6a/H9a0g600?4a/H0
6<H00lC6aP0HaP03a<K601?600D0a/H0a00DaP4000007mK6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6
e/KFa]H02<@0NlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60<CFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100003/H00`360005aPW41LH00lC6aP0GaP03a<K601O600?4a/H06<H00lC6
aP0CaP050<K60<@05<H1000001;Fa]K6e/KFa]K6e/KFaP36eP04a01ae/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]H00/@06@34a<@0a<KFa]K6e/KFa]K6e/KF
a]K6e/H00@0000k600D0a/K6000BaP03a<K601O600?4a/H05lH00lC6aP0HaP03a<K600O62L@2aP06
0<K6aP344lH1000007CFa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP[402CFa]K6e/KFa]K6eP3Fa]H0a<KFa]K6e/KFa]K6e/KFa]K6e/H100003/H00`36
aP02aP030<K6017600?4a/H05/H00lC6aP0GaP03a<K600k62L@00lK4aP0BaP060<K6aP344lH10000
06;Fa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFaPW403O6e/KFa]K6e/KFa=K6e/KF
a]K6e/KFa]K6e/KFa]H0e/KFaP34e/KFa]K6e/KFa]K6e/KFa]K60040000=aP030<K600G600<0a/H0
4<H00lC6aP0FaP03a<K601C62/@CaP03a<K6017600<0a/H00/H00`34aP0AaP400000CmK6e/KFa]K6
e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]H02L@0B]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFaP34e/KFa]K6e/KFa]K6e/KFa]K60@0000g600<0a/H01/H00`36aP0@aP03a<K601K6
00?4a/H02/@=aP03a<K601O600?4a/H04<H00`36aP02aP030<C601760@00000le/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K62L@0GLKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KF
0=K6e/KF0<C6e/KFa]K6e/KFa]K6e/KFaP0100003LH00`36aP07aP030<K6013600?4a/H01/H9a0S6
00?4a/H05/H00lC6aP0GaP03a<K600o600<0a/H00lH00`34aP0@aP400000:MK6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF00[406o6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6eP3F
a]K6eP34a]K6e/KFa]K6e/KFa]K6e/H00@0000g600<0a/H02LH00`36aP04aPW40lH00lC6aP0FaP03
a<K601K600?4a/H05/H00lC6aP0?aP030<K600?600<0a<H04<H1000001_Fa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFaP001L@0J]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6
eP05a00C0<C6e/KFa]K6e/KFa]K6e/KFaP0100003LH00`36aP0:aP030<K6013600?4a/H05/H00lC6
aP0FaP03a<K601K600?4a/H01/H8a0030<K600C600<0a<H03lH1000007SFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9a00Qa]K6e/KFa]H0e/KF
a]K60<CFa]K6e/KFa]K6e/KFa]K60040000=aP030<K600c600<0a/H03lH00lC6aP0FaP03a<K601G6
00?4a/H03LH9a003a/C600k600<0a/H01<H00`34aP0?aP400000I]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa/C6e/KFaPW403?6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0
a=K6e/KFa]K6e/KFa]K6e/H00@0000g600<0a/H03LH00`36aP0?aP03a<K601K600?4a/H04/H2a0<0
1<@CaP03a<K600g600<0a/H01LH00`34aP0>aP400000E=K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFaPW4
00?600000`00?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0a<KF
a]K6e/KFa]K6e/KFaP0100003<H00`36aP0?aP030<K6013600?4a/H05LH00lC6a008a0W61`0FaP03
a<K600c600<0a/H01LH00`34aP0>aP400000@]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFaPW401;6e/KFa]K6e/KFa]K6e/KFa]H7000n
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0<C6e/KFa]K6e/KFa]K6
e/H100003<H00`36aP0AaP030<K600o600?4a/H01<H9a0S600?4a/H04<H701O600?4a/H03<H00`36
aP05aP030<C600g60@00000`e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K62L@09LKFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/H01@00?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFaP36e/KFa]K60<CFa]K6e/KFa]K6e/KFaP010000
3<H00`36aP0BaP030<K600?62L@3aP03a<K601G600?4a/H04LH30003a/C601K600?4a/H03<H00`36
aP05a0030<C600g60@00000Re/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaPG403S6e/KF
a]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6eP<o02;Fa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K61/@06034a<KFa]K60<CFa]K6e/KFa]K6e/KFaP40
000<aP030<K601C600<0a/H03/H00lC6aP0EaP03a<K6013600<oCcl00/H00lC6aP0CaP[41/H00`36
aP06aP030<C600c60@00001Oe/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]H00cl03mK6
a<KFa]K6e/KFa]K6eP09a00Xe/K4a]K6e/KFa]K6e/KFaP36e/KFa]K6eP34a]K6e/KFa]K6e/KFaP40
000<aP030<K601G600<0a/H03lH00lC6aP0DaP03a<K600o600<oCcl00lH00lC6a009a0c600?4a/H0
2/H00`36aP06aP030<C600c60@00001Me/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KF00;4
0cl5a00ka]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/H0a]K6e/KFa]H0a<KFa]K6e/KF
a]K6e/H00@0000c600<0a/H05/H00`36aP0?aP03a<K601C600?4a/H00lH9a0;600<oCcl00lH00lC6
aP0EaP03a<K600[600<0a/H01/H00`34aP0<aP400000B]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K62/@02mK6e/KFa]K6
e/KF00@o03o6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/H0a]K6e/KFa]K60<CF
a]K6e/KFa]K6e/H00@0000c600<0a/H06<H00`36aP0>aP03a<K600K62L@5aP03a<K600g600@oCcm?
0lH00lC6aP0EaP03a<K600W600<0a/H01lH00`34aP0;aP400000=mK6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H02/@07lKFa]K6e/KFa]K6e/KFa/C6e/KF
a]K6e/KFa]K6e/H00cl0?lKFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFaP36e/KF
a]K6e/H0a=K6e/KFa]K6e/KFaP0100003<H00`36aP0IaP030<K600?62L@2aP03a<K601C600?4a/H0
3LH00dloC`04aP03a<K601G600?4a/H02<H00`36aP02aPG400<0a<H02lH1000002WFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP05a00be/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/H3?`0Ra]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CF
a]K6ePG400<0a<@00/@04lKFa]K6eP34a]K6e/KFa]K6e/H00@0000_600<0a/H07<H00`36aP0>aP03
a<K601C600?4a/H02lH00dloC`05aP03a<K601362/@5aP030<K600?61P000lC6aP09aP400000H=K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFaP<o00k6e/KFa/C6e/KFa]K6eP[400_6e/KF
a/C6e/KFaP0:000Be/KFa]H0e/KFa]K6e/KFa]K60@0000_600<0a/H07LH00`36aP0>aP03a<K601C6
00?4a/H02/H00dloC`04aP[42lH40003a00000<01<H00`36aP08aP030<K600[60@00001Me/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF00?40cl4a00;a]K4e/KFa]K6e/H02P009]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60@0000_600<0a/H07/H00`36aP0>aP03a<K601?6
2/@3aP03Ccm?00G60P000l@0000501S600<0a/H02<H00`36aP0:aP400000BMK6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]H0
2/@02lK4a]K6e/KFa]K600800cl5000je/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP40000;aP030<K6023600<0a/H03LH;a0_600<0a0001`02aP03
Ccm?02O600<0a/H02<H00`36aP0:aP400000=MK6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KF00_400[Fa]K6e/KFa]K62P002mK6e/KFa]K6e/KF00@o03o6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0
0@0000_600<0a/H08LH00`34a003a0_600?400001`0DaP04Ccm??bS600<0a/H02<H00`36aP0:aP40
0000=]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaPX0
01gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP05?`10e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP40000;aP030<K602?61@0VaP06
Ccm?aTlo:LH00`36aP08aP030<K600W60@00001Ke/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP03?`14e/Ho?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/H0a]K6e/KFa]K6e/H100002lH00`36aP0SaP030<K602K600=??dl00lH00dloaP0XaP030<K600S6
00<0a/H02LH1000005WFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`04e/KFaP8o043Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6
0@0000_600<0a/H08lH00`36aP0TaP03Ccm?00G600=??lH0:<H00`36aP08aP030<K600W60@00001G
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00KFa]K6e/H2?`10e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFaP40000:aP030<K602C6
00<0a/H08/H00dloC`07aP03Cco602S600<0a/H02<H00`36aP09aP400000EMK6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H00cl02=K6e/KFa]K60Sl0@=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/H100002/H00`36aP0QaP04ClK602;600=??dl0
2LH00dloaP0XaP030<K600S600<0a/H02LH1000005?Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`0:
e/KFa]K6e/KFaP8o043Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K60<KFa]K6e/KFa]K60@0000[600<0a/H08/H00co6000PaP03Ccm?00_600=??lH0:<H00`36
aP08aP030<K600W60@00001Ae/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?`3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00cFa]K6e/KFa]K6e/H2?`10
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6
e/KFaP40000:aP030<K602C600<oa/H06lH013m??dl=aP03Cco602S600<0a/H02<H00`36aP09aP40
0000C=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`0AaSloe/KFa]K6e/KFa]K6e/H00Sl0@=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/H100002/H00`36
aP0TaP0304lo01G600<oCcl01<H00do6aP0=aP03Cco602S600<0a/H02<H00`36aP09aP400000;mK6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o01CF?mK6e/KFa]K6
e/KFa]K6e/KFaP<o01O6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFaP02?`10e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFaP40000:aP030<K601o6
00=??dl00/H01036aTl>aP03?dlo00S600=?a/H03lH00dloaP0XaP030<K600S600<0a/H02LH10000
02WFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`0De/KFa]H0e/Hoa]K6
e/KFa]K6e/H4?`0Le/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFaP8o043Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K60@0000[600<0a/H0
6/H00cm?aP06aP030<K600;600<oa/H01LH00cm??`02aP03ClK600O600=?a/H04/H00cm?aP0WaP03
0<K600W600<0a/H02<H1000003_Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/Hoa]K6eP02?`1Ua]K6eSoFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF
?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KF
a]K6e/H00@0000W600<0a/H09<H00`36aP03aP05ClI??dl01LH00do6aP07aP03ClK601C600@oa/I?
9/H00`36aP09aP030<K600S60@00000fe/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K60Sl0J]K6e/KFa]Hoe/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6
e/KFa]K6e/H100002LH00`36aP0TaP060<K6?dlo2<H00do6aP07aP03ClK601K600Doa/K6?`0UaP03
0<K600W600<0a/H02<H10000033Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H3?`1_a]K6e/KFa]K6eSoFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF
a]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KF
a]K600400009aP030<K6027600@oCcl02lH00do6aP07aP03ClK601S600<oa/H00lH00co6aP0QaP03
0<K600W600<0a/H02<H1000002[Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H3?`1ea]K60<KFa]K6e/KFa]Hoe/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF
a]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KF
a]K600400009aP030<K601_600@oCcm?1LH00`36aP07aP03ClK600O600=?a/H06/H00co6aP04aP03
ClK6027600<0a/H02<H00`36aP08aP4000009=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP<o01c6eSoFa]K6e/H0a]K6e/KFa]Hoe/KFa]K6e/KF0Sl0GLKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]Hoe/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF
a]H0e/KFa]K6e/KFaP0100002LH00`36aP0EaP03?dlo00C600=?a/H01LH00`36aP05aP03ClK600O6
00=??lH07<H00co6aP06aP03ClK601o600<0a/H02<H00`36aP08aP400000=]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6eSoFa]K6e/KFaP36e/KFaP8o06[Fa]K6e/KFa]HoeSoFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K60@0000W600<0a/H06/H00do6aP07aP070<K6?dlo
C`09aP03ClI?01k600<oa/H01lH00co6aP0NaP030<K600S600<0a/H02<H10000037Fa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/H0008o06o6eSoFa]K6e/KFa]Hoe/Ho
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/H00@0000W600<0a/H06<H00do6aP08aP03
?do600;600=?a/H01lH014o6aSlOaP03?lK600W600<oa/H07<H00`36aP08aP030<K600S60@00000/
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/H3?`1caP36eSoFa]K6e/KF
a]Hoe/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]Hoe/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFaP0100002LH00`36aP0FaP03
ClK600G600=??lH00lH00`36C`09aP03ClK600;600<oa/H07LH00co6aP09aP03?do601c600<0a/H0
2<H00`36aP08aP4000009mK6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eP03?`1h
eSoFa]K603oFa]K6e/KFa]Hoe/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6
0@0000S600<0a/H05LH01do6a/I??dl00lH00do6aP03aP03ClK600O600=?a/H00lH00do6aP0NaP03
?lK600W600@oa/I?6lH00`36aP09aP030<K600O60@00000Qe/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o03cFa]K6eSoFa]K6eSl0a]K6e/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H2?`10e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K60<KFa]K6e/KFaP400008aP030<K601G600=?a/H01LH00do6aP03aP03ClH000O6
00=?a/H01<H00co6aP0NaP03Cco600[600Doa/K6?`0JaP030<K600W600<0a/H01lH1000003KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]Hoe/H0a]K6e/H2?`1Ze/KFa]K6
?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]Hoe/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/KFaP400008aP030<K601_600=?a/H0
0lH01Do6a/H000;600@oCcm?1lH00do6aP0NaP03?lHo00c600=?a/H00/H00co6aP0FaP030<K600W6
00<0a/H01lH10000033Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF?mK6
e/H3?`1_a]Hoe/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KF
a]K6e/Hoa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K60040
0008aP030<K601W600=?a/H01<H01So6?dlo00?600=?a/H01LH00dloaP0OaP04ClK6?`c600=?a/H0
0lH00do6aP0EaP030<K600W600<0a/H01lH1000002[Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6e/H3?`0`a]K60<KF?mK6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KF0Sl0@lKF?mK6e/KFa]K6e/KFaSo6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF
a]K6e/KFaP36e/KFa]K6e/H00@0000S600<0a/H05lH00do6aP02aP05?dloCcl01<H00`36C`07aP03
ClI?023600DoaSm??`0<aP03ClK600G600=?a/H04lH00`36aP09aP030<K600O60@00000Ue/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eP02?`0jaSo6?lKFa]K603oFa]K6e/KF?mK6?lKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6eP<o03kFa]K6e/KFa]K6?lKFa]K6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/KFaP400008aP030<K601O600=??dl0
0/H00co6?`06aP03ClK600G600A?a/Ho8<H00do6aP02aP06?lK6Ccm?1lH00do6aP07aP03Cco60176
00<0a/H02LH00`36aP07aP400000:=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
?lH2?`0me/KFa]Ho0<KFa]K6eSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6
eSoFa]K6eP02?`0Aa]K6e/Hoa]K6e/KFa]K6?lH00cl09LKFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF
aP36e/KFa]K6e/H00@0000S600<0a/H06/H01Co6?lHo00C600=?aP001LH01Do6a/I?023600<oa/H0
0lH00co6aP03aP04?lHoC`?600=??lH02<H01So6a/HoC`g600<0a/H02LH00`36aP07aP400000JmK6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6?lHoa]K6eSoFaP36e/KF?mK6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]Hoe/KFaSo6e/KF00@o0136?lKFa]K6e/KF
aSo6e/KF0Sl08LKFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/KFaP0100002<H00`36aP0HaP03
?lHo00;600E?a/K6C`03aP050<K6aTl01LH00do6aP0NaP03?lK600?600<oa/H00/H00do6aP05aP04
Cco6?`W600<oa/H00lH00cm??`08aP030<K600W600<0a/H01lH1000002_Fa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6?lKF008o02c6e/H0a]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6eP8o02W6e/KFa]Hoe/KF?mK6e/KFa]K6?lHoaSo6e/KFa]K6eSoFa]K6e/KF
aP02?`0Le/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/KFaP400007aP030<K601O600<oaSl00lH01Co6
aTlo00?600D0a/I??`05aP03?do601[600E??do6C`06aP05?lK6aSl02<H00do6aP02aP03?lK600K6
00=?a/H01lH00dloaP04aP030<K600S600<0a/H01lH10000037Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6eSoF?mK6eP3F008o0276e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00Sl0<]K6eSoFa]K6e/KF?mK6eSoFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6eSoFa]K6e/KFaSo6
0cl05lKF0=K6e/KFa]K6e/KF0=K6e/KFa]K600400007aP030<K601O600<oa/H01<H00do6C`04aP04
04o6C`G600E?a/K6C`0EaP03Cco600C600<oa/H01<H01Dloa/I?00[600<oa/H00/H00do6aP07aP03
ClK600K600Loa/K6?dl000_600<0a/H01/H1000004oFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/Hoa]K6eSoFaSo6e/KFaSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KF00<o00kFa]K6
e/Hoa]K6e/KFaP8o043Fa]K6e/KFa]K6e/KF?mK6e/KF?mK6e/KFa]K6eSoFa]K6e/KFaSo6e/KF03o6
e/KFa]K6e/KF0=K6e/KFa]K60@0000O600<0a/H07<H014o6aSl4aP04C`36?`G600<oa/H04lH00cm?
aP07aP03?lK600K600=??lH03<H00co6aP04aP03ClK600K600<oa/H01/H00do6aP02aP050<HoCcl0
1lH00`36aP06aP400000X]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6
eSoF0=Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6eSoFa]K6e/KF?mHoe/KFa]K6
e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6?lKFa]K6e/KF?mK6eP3Fa]K6?lKFa]K6eP3Fa]K6e/KFaP40
0007aP030<K601[600=?a/H00/H013o6aTl2aP0304o600C600=?a/H07LH00do6aP06aP03?lHo00c6
00=??lH01lH00do6aP06aP03?lK600K600A?a/H02lH00`36aP06aP400000K=K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/Hoa]Hoe/KF03o6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFaP8o03CF?mK6e/KFa]K6?lKFa]K6e/KFaSo6
e/KFa]K6?lKF0=K6e/KFa]K6e/KF0=K6e/KFa]K60@0000O600<0a/H06<H00do6aP03aP03ClI?00C6
00<0ClH01<H00do6aP0UaP04ClK6?`S600=??lH00/H00co6aP06aP03Cco600O600=?a/H01/H00co6
000;aP030<K600K60@00001Xe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF?mHo
e/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6
e/H2?`0He/KFa]Hoe/KFa]K6e/HoaSo6e/KFa]K60Sl07]K6e/KFa]K6?`3Fa]K6e/KFa]K6eP3Fa]K6
e/KFaP400007aP030<K602G600<0a/H0;<H014o6aSl5aP03?lK600G600<oa/H01/H014o6aSl6aP03
ClI?00O600=?0<H02/H00`36aP06aP400000X]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]Hoe/KFa]K6e/KFa]K6eSoFa]K6e/KFaSo6eSoFa]K6e/Hoa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6
eP3Fa]K6e/KFaP400007aP030<K602G600<0a/H0:lH01Co6a/Ho00g600<oa/H01/H01Do6a/I?00G6
00A?a/K620000do6aP08aP030<K600K60@00001ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6eSoFa]K6e/KFa]K6e/KF?mK6e/KFa]H03`007=Hoe/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6
e/H100001/H00`36aP0VaP030<K602[600=?a/H00/H00co6aP04aPl000?6ClH00lH00co6aP02aP03
ClK600;600<oa/H01<H00`36aP08aP030<K600K60@00001Ie/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H03`00>]K6e/KFa]Hoe/KFa]K6e/Hoa]K6e/Hoa]K6?lKFa]K6?lKFa]K60<KFa]K6e/KFa]H0
e/KFa]K6e/H100001/H00`36aP0VaP030<K601S63`001<I?aTl4aP03?lK600_600<oa/H01/H00do6
aP04aP04?lK6C`K600<oa/H00/H00`36aP08aP030<K600K60@00000ke/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H03`003]K6e/KFa]K6e/KFa]K6
0Sl01mHoe/KFa]H00Sl0?lKFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6?lHoa]K6e/KFaSo6e/KF
0=K6e/KFa]K6eP3Fa]K6e/KFaP0100001/H00`36aP0SaPl06lH00dloaP02aP03?lK600?600<oaSl0
7/H00do6aP06aP05?lK6aP002LH00`36aP06aP4000007MK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00l007KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eSoFa]K6
eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36
e/KFa]K60@0000K600<0a/H01LH?01;600<0a/H08LH00cm?aP04aP03ClK600C600Doa/K6?`0ZaP03
0<K600O600<0a/H01LH1000000KFa]K6e/H80013e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`1?a]K6e/KFaSo6e/KFa]Hoe/KF
aSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KF
aP0100002<H00`36aP0TaP030<K601k600=?a/H01/H00co6aP05aP03?lK600?600<oa/H09lH00`36
aP06aP030<K600G60@00002Re/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]Hoe/KFa]K6eSoFa]K6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6
0@0000[60P0SaP030<K602O600<oa/H01LH00co6aP05aP03?lK602K600<0a/H01LH00`36aP05aP40
0000X]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]Hoe/KFa]K6e/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFaP40000=aP030<K601o6
00<0a/H09/H00do6aP06aP03?lK600O600<oa/H09LH00`36aP04aP030<K600G60@00000>e/KFa]K6
e/KFa]K6e/H2002Be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/H100004<H00`36aP0LaP030<K602G6
00<oa/H01lH00co6aP0`aP030<K600?600<0a/H01LH100000:;Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K60<KFa]K6e/H100004/H201_600<0a/H0;lH00co6aP0`aP030<K600?600<0a/H0
1LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/H100005LH00`36
aP0GaP030<K606?600<0a/H00/H00`36aP05aP4000005]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2002:
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFaP36e/KFa]K60@0001S600<0a/H05<H00`36aP1TaP050<K6aP001lH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60<KFa]K6e/H100006/H201;600<0a/H0I/H01036
aP07aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFaP40000MaP03
0<K600k600<0a/H0IlH01036aP06aP4000007]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP80
08;Fa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]H0e/KFa]K60@00023600<0a/H02lH00`36aP1XaP030<H000K60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K60@0002;60P0:aP030<K606W60P06aP400000V]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H20006e/KFa]K60@0002G600<0a/H01/H00`36
aP1YaP801/H1000002KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8006[Fa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62P001]K6e/KFaP40000XaP03
0<K600?600<0a/H0ClHB01360@00001^e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/HB000Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000ZaP80
0/H00`36aP0ZaQ<0=<H1000004WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF018004O6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000;LH200S6
4P1IaP400000;]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9001[
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@000:;60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000001\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0194056, -0.0250049, 
  0.00549532, 0.00549532}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.08722 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0192382 1.12636 0.0281591 1.12636 [
[ 0 0 0 0 ]
[ 1 1.08722 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.08722 L
0 1.08722 L
closepath
clip
newpath
p
1 g
.002 w
.85375 .02816 m
.88841 .79953 L
s
.88841 .79953 m
.02816 .85803 L
s
.02816 .85803 m
.07738 .12088 L
s
.07738 .12088 m
.85375 .02816 L
s
.9374 .3879 m
.30649 .44783 L
s
.30649 .44783 m
.28665 1.05906 L
s
.28665 1.05906 m
.97184 1.02281 L
s
.97184 1.02281 m
.9374 .3879 L
s
.85375 .02816 m
.88841 .79953 L
s
.88841 .79953 m
.97184 1.02281 L
s
.97184 1.02281 m
.9374 .3879 L
s
.9374 .3879 m
.85375 .02816 L
s
.07738 .12088 m
.30649 .44783 L
s
.30649 .44783 m
.28665 1.05906 L
s
.28665 1.05906 m
.02816 .85803 L
s
.02816 .85803 m
.07738 .12088 L
s
p
.4 g
.87142 .10414 m
.12538 .18938 L
s
P
p
.4 g
.90258 .23815 m
.21055 .31091 L
s
P
p
.4 g
.92924 .3528 m
.28393 .41564 L
s
P
p
.4 g
.78925 .03586 m
.88549 .39283 L
s
P
p
.4 g
.50256 .0701 m
.65364 .41485 L
s
P
p
.4 g
.22664 .10306 m
.42881 .43621 L
s
P
P
p
1 0 .6 r
.0025 w
.40068 .72035 m
.41752 .74171 L
s
P
p
1 0 .6 r
.0025 w
.62832 .75332 m
.59432 .77179 L
s
P
p
1 0 .6 r
.0025 w
.40068 .72035 m
.38051 .76875 L
s
P
p
1 0 .6 r
.0025 w
.62832 .75332 m
.63244 .80273 L
s
P
p
1 0 .6 r
.0025 w
.67159 .78824 m
.67516 .83742 L
s
P
p
1 0 .6 r
.0025 w
.35855 .75084 m
.33872 .79929 L
s
P
p
1 0 .6 r
.00353 w
.38117 .69561 m
.40068 .72035 L
s
P
p
1 0 .6 r
.00353 w
.66752 .73202 m
.62832 .75332 L
s
P
p
1 0 .6 r
.0025 w
.67159 .78824 m
.71216 .84039 L
s
P
p
1 0 .6 r
.00353 w
.66752 .73202 m
.67159 .78824 L
s
P
p
1 0 .6 r
.0025 w
.71798 .79122 m
.72097 .8411 L
s
P
p
1 0 .6 r
.0025 w
.35855 .75084 m
.31188 .79895 L
s
P
p
1 0 .6 r
.00353 w
.38117 .69561 m
.35855 .75084 L
s
P
p
1 0 .6 r
.0025 w
.32526 .74952 m
.30546 .79887 L
s
P
p
1 0 .6 r
.0025 w
.71798 .79122 m
.7591 .84416 L
s
P
p
1 0 .6 r
.005 w
.66285 .66752 m
.66752 .73202 L
s
P
p
1 0 .6 r
.00353 w
.71456 .73418 m
.71798 .79122 L
s
P
p
1 0 .6 r
.005 w
.40703 .63245 m
.38117 .69561 L
s
P
p
1 0 .6 r
.0025 w
.7712 .79464 m
.77351 .84531 L
s
P
p
1 0 .6 r
.0025 w
.32526 .74952 m
.27761 .79853 L
s
P
p
1 0 .6 r
.00353 w
.34784 .69322 m
.32526 .74952 L
s
P
p
1 0 .6 r
.02 w
.59068 .28578 m
.59143 .40148 L
s
P
p
1 g
.05 w
.59068 .28578 Mdot
P
p
1 0 .6 r
.0025 w
.76095 .79398 m
.80258 .84764 L
s
P
p
1 0 .6 r
.0025 w
.28678 .74799 m
.26704 .7984 L
s
P
p
1 0 .6 r
.0025 w
.76095 .79398 m
.81809 .81905 L
s
P
p
1 0 .6 r
.00353 w
.71456 .73418 m
.76095 .79398 L
s
P
p
1 0 .6 r
.005 w
.66285 .66752 m
.71456 .73418 L
s
P
p
1 0 .6 r
.005 w
.40703 .63245 m
.34784 .69322 L
s
P
p
1 0 .6 r
.00707 w
.43672 .55995 m
.40703 .63245 L
s
P
p
1 0 .6 r
.0025 w
.7712 .79464 m
.81295 .84847 L
s
P
p
1 0 .6 r
.00707 w
.65747 .59323 m
.66285 .66752 L
s
P
p
1 0 .6 r
.00353 w
.76855 .73666 m
.7712 .79464 L
s
P
p
1 0 .6 r
.00353 w
.34784 .69322 m
.29421 .74828 L
s
P
p
1 0 .6 r
.0025 w
.29421 .74828 m
.24566 .79813 L
s
P
p
1 0 .6 r
.0025 w
.29421 .74828 m
.24492 .76807 L
s
P
p
1 0 .6 r
.01414 w
.59143 .40148 m
.59214 .50886 L
s
P
p
1 0 .6 r
.01414 w
.59143 .40148 m
.51036 .48452 L
s
P
p
1 0 .6 r
.0025 w
.28678 .74799 m
.238 .79804 L
s
P
p
1 0 .6 r
.00353 w
.30929 .69046 m
.28678 .74799 L
s
P
p
1 0 .6 r
.01 w
.51036 .48452 m
.43672 .55995 L
s
P
p
1 0 .6 r
.01 w
.51036 .48452 m
.43971 .50827 L
s
P
p
1 0 .6 r
.0025 w
.81565 .79749 m
.85793 .85208 L
s
P
p
1 0 .6 r
.0025 w
.81565 .79749 m
.87447 .82305 L
s
P
p
1 0 .6 r
.00353 w
.76855 .73666 m
.81565 .79749 L
s
P
p
1 0 .6 r
.005 w
.71603 .66885 m
.76855 .73666 L
s
P
p
1 0 .6 r
.00707 w
.43672 .55995 m
.36989 .6284 L
s
P
p
1 0 .6 r
.0025 w
.54294 .84691 m
.57303 .89612 L
s
P
p
1 0 .6 r
.005 w
.71603 .66885 m
.78759 .69865 L
s
P
p
1 0 .6 r
.00707 w
.65747 .59323 m
.71603 .66885 L
s
P
p
1 0 .6 r
.0025 w
.28652 .7007 m
.26637 .75278 L
s
P
p
1 0 .6 r
.01 w
.59214 .50886 m
.65747 .59323 L
s
P
p
1 0 .6 r
.005 w
.36989 .6284 m
.30929 .69046 L
s
P
p
1 0 .6 r
.005 w
.36989 .6284 m
.30948 .65075 L
s
P
p
1 0 .6 r
.0025 w
.54294 .84691 m
.52199 .90794 L
s
P
p
1 0 .6 r
.01 w
.59214 .50886 m
.59279 .60826 L
s
P
p
1 0 .6 r
.00353 w
.30929 .69046 m
.25438 .7467 L
s
P
p
1 0 .6 r
.0025 w
.25438 .7467 m
.20466 .79763 L
s
P
p
1 0 .6 r
.0025 w
.25438 .7467 m
.20332 .7669 L
s
P
p
1 0 .6 r
.00353 w
.56661 .77799 m
.54294 .84691 L
s
P
p
1 0 .6 r
.0025 w
.83546 .76057 m
.87842 .81613 L
s
P
p
1 0 .6 r
.0025 w
.28652 .7007 m
.2367 .75169 L
s
P
p
1 0 .6 r
.00353 w
.30953 .64123 m
.28652 .7007 L
s
P
p
1 0 .6 r
.0025 w
.83546 .76057 m
.89553 .7861 L
s
P
p
1 0 .6 r
.00353 w
.78759 .69865 m
.83546 .76057 L
s
P
p
1 0 .6 r
.0025 w
.49898 .81962 m
.47816 .88145 L
s
P
p
1 0 .6 r
.00353 w
.78759 .69865 m
.85387 .72625 L
s
P
p
1 0 .6 r
.00707 w
.59279 .60826 m
.59338 .70003 L
s
P
p
1 0 .6 r
.00707 w
.59279 .60826 m
.57282 .64907 L
s
P
p
1 0 .6 r
.00707 w
.43971 .50827 m
.37289 .53073 L
s
P
p
1 0 .6 r
.00707 w
.43971 .50827 m
.37144 .578 L
s
P
p
1 0 .6 r
.00353 w
.56661 .77799 m
.49898 .81962 L
s
P
p
1 0 .6 r
.005 w
.59338 .70003 m
.56661 .77799 L
s
P
p
1 0 .6 r
.0025 w
.49898 .81962 m
.43798 .85716 L
s
P
p
1 0 .6 r
.00353 w
.30948 .65075 m
.25288 .6717 L
s
P
p
1 0 .6 r
.00353 w
.30948 .65075 m
.25361 .70785 L
s
P
p
1 0 .6 r
.005 w
.37144 .578 m
.30953 .64123 L
s
P
p
1 0 .6 r
.005 w
.37144 .578 m
.30972 .59976 L
s
P
p
1 0 .6 r
.0025 w
.25361 .70785 m
.203 .75956 L
s
P
p
1 0 .6 r
.0025 w
.25361 .70785 m
.20162 .72773 L
s
P
p
1 0 .6 r
.00353 w
.30953 .64123 m
.25342 .69854 L
s
P
p
1 0 .6 r
.0025 w
.85387 .72625 m
.9151 .75175 L
s
P
p
1 0 .6 r
.0025 w
.85387 .72625 m
.89655 .70492 L
s
P
p
1 0 .6 r
.005 w
.59338 .70003 m
.59394 .78457 L
s
P
p
1 0 .6 r
.0025 w
.25342 .69854 m
.20261 .75044 L
s
P
p
1 0 .6 r
.0025 w
.25342 .69854 m
.20121 .71834 L
s
P
p
1 0 .6 r
.00353 w
.59394 .78457 m
.59445 .86229 L
s
P
p
1 0 .6 r
.00353 w
.59394 .78457 m
.64826 .83267 L
s
P
p
1 0 .6 r
.0025 w
.25288 .6717 m
.20002 .69126 L
s
P
p
1 0 .6 r
.0025 w
.25288 .6717 m
.23021 .64603 L
s
P
p
1 0 .6 r
.005 w
.37289 .53073 m
.30995 .55189 L
s
P
p
1 0 .6 r
.005 w
.37289 .53073 m
.34805 .49495 L
s
P
p
1 0 .6 r
.00353 w
.30972 .59976 m
.25185 .62016 L
s
P
p
1 0 .6 r
.00353 w
.30972 .59976 m
.25261 .65796 L
s
P
p
1 0 .6 r
.005 w
.57282 .64907 m
.55381 .68791 L
s
P
p
1 0 .6 r
.005 w
.57282 .64907 m
.62213 .66938 L
s
P
p
1 0 .6 r
.0025 w
.25261 .65796 m
.20087 .71067 L
s
P
p
1 0 .6 r
.0025 w
.25261 .65796 m
.19942 .67739 L
s
P
p
1 0 .6 r
.0025 w
.64826 .83267 m
.70148 .87807 L
s
P
p
1 0 .6 r
.0025 w
.59445 .86229 m
.59491 .93361 L
s
P
p
1 0 .6 r
.0025 w
.59445 .86229 m
.54555 .90757 L
s
P
p
1 0 .6 r
.0025 w
.64826 .83267 m
.69847 .87713 L
s
P
p
1 0 .6 r
.0025 w
.25185 .62016 m
.19775 .63923 L
s
P
p
1 0 .6 r
.0025 w
.25185 .62016 m
.22863 .59273 L
s
P
p
1 0 .6 r
.00353 w
.30995 .55189 m
.25088 .57174 L
s
P
p
1 0 .6 r
.00353 w
.30995 .55189 m
.25167 .61111 L
s
P
p
1 0 .6 r
.0025 w
.25167 .61111 m
.19887 .66476 L
s
P
p
1 0 .6 r
.0025 w
.25167 .61111 m
.19736 .63009 L
s
P
p
1 0 .6 r
.00353 w
.34805 .49495 m
.32449 .46102 L
s
P
p
1 0 .6 r
.00353 w
.34805 .49495 m
.28943 .51376 L
s
P
p
1 0 .6 r
.00353 w
.62213 .66938 m
.66869 .68857 L
s
P
p
1 0 .6 r
.00353 w
.62213 .66938 m
.60587 .70566 L
s
P
p
1 0 .6 r
.00353 w
.55381 .68791 m
.53579 .72473 L
s
P
p
1 0 .6 r
.00353 w
.55381 .68791 m
.48409 .71988 L
s
P
p
1 0 .6 r
.0025 w
.48409 .71988 m
.41989 .74931 L
s
P
p
1 0 .6 r
.0025 w
.48409 .71988 m
.46612 .75407 L
s
P
p
1 0 .6 r
.0025 w
.25088 .57174 m
.19562 .59032 L
s
P
p
1 0 .6 r
.0025 w
.25088 .57174 m
.22715 .5426 L
s
P
p
1 0 .6 r
.0025 w
.28943 .51376 m
.23458 .53135 L
s
P
p
1 0 .6 r
.0025 w
.28943 .51376 m
.26646 .4831 L
s
P
p
1 0 .6 r
.0025 w
.66869 .68857 m
.7125 .70662 L
s
P
p
1 0 .6 r
.0025 w
.66869 .68857 m
.74343 .68047 L
s
P
p
1 0 .6 r
.0025 w
.32449 .46102 m
.30223 .42896 L
s
P
p
1 0 .6 r
.0025 w
.32449 .46102 m
.34752 .39948 L
s
P
p
1 0 .6 r
.0025 w
.60587 .70566 m
.59051 .73991 L
s
P
p
1 0 .6 r
.0025 w
.60587 .70566 m
.6484 .72411 L
s
P
p
1 0 .6 r
.0025 w
.53579 .72473 m
.51878 .75949 L
s
P
p
1 0 .6 r
.0025 w
.53579 .72473 m
.57691 .74363 L
s
P
p
1 g
.002 w
.85375 .02816 m
.88841 .79953 L
s
.88841 .79953 m
.02816 .85803 L
s
.02816 .85803 m
.07738 .12088 L
s
.07738 .12088 m
.85375 .02816 L
s
.85375 .02816 m
.88841 .79953 L
s
.88841 .79953 m
.97184 1.02281 L
s
.97184 1.02281 m
.9374 .3879 L
s
.9374 .3879 m
.85375 .02816 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->1.1858,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000Q]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61@005lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001naPP01<H00`36aP0EaP400000M]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H8000Te/CFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0006k62009aP03a<K600S60P0FaP400000ImK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H01`007=K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/H2000F
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40001OaPP06LH00lC6aP07aP805/H1000005OFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H02000:lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KF
a]K6e/H00P005]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000ClH802W600?4a/H01lH201K60@000017
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H02000DlKFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa=K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000oaPP02lH00lC6aP0/aP03
a<K600K600<0aP005LH1000003OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00P006?6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@0002o6200LaP03a<K602_600?4a/H01/H00`36000EaP400000:=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H7001ca]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFaP36eP3F
a]K6e/KFa]K6e/KFa]K6e/KFaP0100008<H802_600?4a/H0;<H00lC6aP04aP;400<0a0005<H10000
01SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H8001Pe/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K62L@06LKF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/H00@000136200=aP03a<K602c600?4a/H0
8<H9a0;600?4a/H01/H00`36000DaP4000003=K6e/KFa]K6e/KFaP@005oFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP08a00[a]K6e/KFa]K6e/KFa=K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KF
a]K6e/KFaP0100003<H00`36aP0GaP03a<K602c600?4a/H03/H9a1C600?4a/H01LH01036aP0CaP40
00003=K6e/KFa]K6e/KFaP8004oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KF00W403cFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/H100003<H00`36000HaP03
a<K602_62<@WaP03a<K600C600@0a/H04lH1000004cFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62L@0CLK4a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6eP3FaP36e/KFa]K6e/KF
a]K6e/KFa]K60040000<aP040<K601W600?4a/H06<H8a0_600?4a/H0:/H00lC6aP04aP050<K6aP00
4/H1000003_Fa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6eP09a01Ne/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP40000<aP030<K600;6
00<0a/H05/H00lC6aP05aPW47LH00lC6aP0ZaP03a<K600?600D0a/K6000BaP400000:]K6e/KFa]K6
e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPS4073Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6eP3Fa]H0e/KFa]K6e/KFa]K6e/KFa]K60@0000_600<0a/H01<H00`36aP0<aPW400?6a<H0
;<H00lC6aP0YaP03a<K600?600D0a/K6000BaP4000006=K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFaPW4
0876e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KF0=K6e/H0a]K6e/KF
a]K6e/KFa]K6e/H00@0000_600<0a/H01LH00`34a002a1C600?4a/H0:/H00lC6aP0ZaP03a<K600;6
00<0a/H00/H00`36aP0?aP400000X]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]H0e/KFaP36e/KFa]K6e/KFa]K6
e/KFaP40000;aP030<K600O600<0a/H05LH00lC6aP0ZaP03a<K602W600?4a/H00/H00`36aP02aP03
0<K600o60@00002Re/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K60@0000_6
00<0a/H02<H00`36aP0FaP03a<K602W600?4a/H0:LH01LC6a/H000G600<0a/H03/H100000:;Fa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/H100002lH00`36aP0:aP030<K601G6
00?4a/H0:LH00lC6aP0XaP05a<K6aP001LH00`36aP0>aP400000X]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]H0
e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP40000;aP030<K600_600<0a/H05LH00lC6aP0YaP03a<K602S6
00G4a/H0aP05a0030<K600g60@000023e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02<@05`34a]K6e/H0a]K6e/KFa]K6e/KF
a]K60040000;aP030<K600g600<0a/H05<H00lC6aP0YaP03a<K601S62/@6aP03a<H000K600<0a/H0
3LH1000006kFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFaP_4
02W6e/KFa]K6e/KFa]K6e/KFa=K60<KFa]K60<KFa]K6e/KFa]K6e/KFaP0100002/H00`36aP0?aP03
0<K601G600?4a/H09lH400;62/@KaP04a<K600G600<0a/H03LH1000005[Fa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H3a0H003o4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CF
aP36e/KFa]H0e/KFa]K6e/KFa]K6e/H00@0000[600<0a/H04<H00`36aP0EaP03a<K601S62/@2aPP0
9/H00lC60006aP030<K600c60@000016e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFaP[400cFa]K6e/KFa]K6e/H8000ne/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4aP36e/KFa]H0e/KFa]K6e/KFa]K6e/H10000
2/H00`36aP0BaP030<K601C600?4a/H00/H;a1K6200VaP03a<H000K600<0a/H03<H10000037Fa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF00[40276e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H02000?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6a<H0a]K6e/KFaP36e/KFa]K6e/KFa]K60@0000[600<0a/H04lH00`36aP04aP[41/H00lC6
aP0SaPH0:<H00l@0aP06aP030<K600_60@00000Re/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00G403O6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K600@00434a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/@0a]K6e/KFaP36
e/KFa]K6e/KFa]K60@0000[600<0a/H05LH00`36aP0CaP03a<K602?600E??do6a00XaP03a03600K6
00<0a/H02lH1000005kFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl0@LK4a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K60040
000:aP030<K601K600<0a/H05<H00lC6aP0QaP03Ccm?00;600?4a/H09/H00`36aP06aP030<K600[6
0@00001Ne/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o0476e/CFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFaP0100002/H00`36
aP0HaP030<K601?600?4a/H08<H00dloC`03aP03a<K602G600<0a/H01/H00`36aP0:aP400000G]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`11a]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP34e/KFa]K6eP3Fa]K6e/KFa]K6e/H00@0000[600<0a/H06LH00`36
aP0CaP03a<K601o600=??dl01<H00lC6aP0TaP030<C600;61L@00`36aP09aP400000G]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`0Ua]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP06a0030<C400;40176e/KFaP36e/KFa]K6e/KFaP0100002LH00`36aP0KaP030<K601?6
00?4a/H07/H00dloC`04aP03a<K601C62/@6aP030<C600O600<0a/H02LH1000005kFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl04<KFa]K6a<KFa]K6e/KFa]H;a00Ve/KFa]K6e/KFa]K6
e/KFaP36a<KFa]K6e/H0a]K6e/KFa]K6e/H100002LH00`36aP0MaP030<K601?600?4a/H07<H00dlo
C`05aP_46lH00`36a007aP030<K600W60@00001Le/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H2a0<o1l@0>]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KF0=K6
e/KFa]K6e/H100002LH00`36aP0NaP030<K601?600?4a/H03lH:a0;600=??dl01/H00lC6aP0RaP05
0<K6a<H01`0:aP400000AmK6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KF00_400cFa]K6e/KFa]K6e/H3?`0Ua]K6e/KFa/C6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP09000Ca036e/KFa]H0e/KFa]K6e/KFaP0100002LH00`36
aP0PaP030<K600W600=?a/H00/H:a1O600=??dl01lH00lC6aP0@aP/01/H00`36aP08aP030<K600S6
0@00000be/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H6a003
?lC400;40236e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP@o00k6e/KFa]K6a<KFa]K6eP`0
02O6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/H00@0000W600<0a/H08LH5a0G6
00<oa/H02<H00lC6aP0GaP04Ccm??`C61@000l@0000301k600<0a/H01lH00`36aP08aP400000FMK6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]Hoe/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KF00801Cl4000ne/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/H100002LH00`36aP0SaP0304o600G6
00<oa/H02LH00lC6aP07aP`000O6Ccm?aTlo02g600<0a/H01lH00`36aP08aP400000@]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF03o6e/KFaSo6e/KFa]K6e/KFaP80
00?400001P003<KFa]K6e/KFa]K6eP<o04KFaSloe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K60@0000W600<0a/H09<H00`0oaP03aP03
C`0000T00lH00lC6aP0@aP03Ccm?00?600=??lH0;<H00`36aP07aP030<K600S60@00000ce/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0o0080028o0<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0cl01=K6e/H2?`12e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K60@0000S600<0a/H09/H01@1?
a/Ho023600=??dl01LH00dloaP0/aP030<K600S600<0a/H01lH1000005GFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o00KFa]K6e/H2?`12e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K60@0000S600<0a/H09/H01036aTlOaP03Ccm?00O6
00=??lH0;<H00`36aP08aP030<K600O60@00001Ce/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3FaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl02=K6
e/KFa]K60Sl0@]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K60<KFa]K6e/KFaP400008aP030<K602K600D0a/K6?`0LaP03Ccm?00W600=??lH0;<H00`36
aP08aP030<K600O60@00001Ae/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6eP3Fa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00[Fa]K6e/KFa]K60Sl0@]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6
e/KFaP400008aP030<K6023600<oa/H00lH00`36aP03aP03?lK601C600E??dloC`0;aP03Cco602c6
00<0a/H02<H00`36aP07aP400000=]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]H0e/KFaP<o01;6e/KFa]K6e/KFa]K6e/KFa]H3?`0@e/KF?mK6e/KFa]K6e/KFaP8o
04;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36
e/KFa]K6e/H100002<H00`36aP0RaP09?lK6aP36?dlo00;600=?a/H03LH00dloC`05aP03ClK600_6
00=??lH0;<H00`36aP08aP030<K600O60@00000`e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK60cl04lKFa]K6eSoFa]K6e/KFa]K6e/H00Sl05]K6e/KFa]Hoe/KFa]K6
e/KFa]K6e/H2?`12e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/H0a]K6e/KFa]K60@0000S600<0a/H08/H01Cm??lH000S600=?a/H01/H01Cm??lHo00K6
00=?a/H03LH00dloaP0/aP030<K600S600<0a/H01lH1000002[Fa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`0Ca]K6eP3Fa]K6e/KFaSo6e/KFaP03?`0La]K6?lKFa]K6eSoF
a]K6e/KFa]K6e/KFa]K6eP8o0476e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFaP0100002<H00`36aP0LaP03?dlo00O600<0a/H01lH01Co6
?dlo00G600<oa/H01<H00do6aP0@aP03?lHo02_600<0a/H02<H00`36aP07aP400000>]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]H0e/KFa]K6e/H3?`1Ua]K6e/KF
aSo6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H00@0000S600<0a/H09/H00`36aP03aP03
?dlo00W600<oa/H01<H00do6aP0BaP05?lK6aSl0:LH00`36aP08aP030<K600O60@00000de/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6eP3FaP<o06_6e/KFa]K6e/KF
aSo6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFaP0100001lH00`36aP0JaP03ClK600[6
00<oCcl03LH00co6aP04aP03ClK601C600<oa/H00/H00do6aP0VaP030<K600S600<0a/H01lH10000
02kFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K613l0L=K6e/KFa]K6
e/KFa]K6?lKFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36aP0LaP03
ClK600?600E??lK6C`0>aP03?lK600C600=?a/H05lH00do6aP03aP03ClK602C600<0a/H02LH00`36
aP06aP400000:MK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF00<o01WFa]Ho
0<KFa]K6e/KFa]K6e/Hoa]K6e/KF008o05_6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6?lKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K60040
0007aP030<K601g600<oClH01<H00do6000<aP03?lK600C600=??lH06LH00do6aP04aP03?lK602C6
00<0a/H02<H00`36aP06aP4000009=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o
01?6e/KFa]Hoe/H0a]K6e/KFa]K600<o06G6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aSo6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3F
a]K6e/KFaP0100001lH00`36aP0GaP03?dlo00S600E?a/K60006aP05?dloaSl01/H00do6C`0KaP03
ClK600K600<oa/H08/H00`36aP08aP030<K600K60@00000Oe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP02?`0Ca]K6eSoFa]K6eSoFa]K60<KFaP03?`1[a]K6?lKFa]K6eSoFaSo6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60<KFa]K6e/KFa]H0e/KFa]K6e/H00@0000O600<0a/H06lH00co6aP02aP03ClK600?600A??dlo
1LH00co6aP04aP04ClK6?ac600=?a/H01lH00do6aP0QaP030<K600S600<0a/H01/H1000002gFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]H00cl0>P0oe/KFa]K6?lKFa]K6
eSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/H2?`0fe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K60@0000O600<0a/H07LH01Sm?
aTloC`?600=?a/H01<H00co6aP04aP03ClK600;600<oa/H06/H00do6aP07aP03ClI?027600<0a/H0
2<H00`36aP06aP4000009=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPHo03GFa]K6
eSl0a]K6e/Hoa]K6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`11a]K6e/KF
a]K6?lKF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H0
0@0000O600<0a/H05lH01cm??dloCcl01/H00do60004aP03?lK600C600=?a/H00lH00do6aP0JaP03
?do600S600A?a/Ho8<H00`36aP08aP030<K600K60@00000Oe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP05?`0Fe/Hoa]K6e/KF?mK60<KFaSo6e/KFaP8o06KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]H0e/KFa]K6e/H100001/H00`36aP0GaP03ClK600;600<oa/H01<H01Do6a/H000;6
00Toa/K6?dloaSl01LH00co6aP0IaP04?lK6C`[600Doa/K6?`0NaP030<K600S600<0a/H01/H10000
03CFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/H0aSo60cl0JlKF
aSo6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6?lKFa]K6e/KFa]Hoe/KFaSo6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K600400006aP030<K601[6
00<oaSl01<H00do6aP03aP0403m??`G600<oa/H00lH00cm?aP0JaP05Cco6aTl02/H00co6aP02aP03
ClK601_600<0a/H02<H00`36aP06aP400000;]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]Hoe/KF?mK6e/H5?`0[a]K6e/Hoa]K6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Ho
aP03?`11a]K6e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF
a]H0e/KFa]K6e/H00@0000K600<0a/H06<H00co6aP02aP03Ccm?00?600I??lHo03l5aP03?lK600?6
00<oaSl06lH00co6aP02aP04Ccm??`O600<oa/H01<H00do6aP0IaP030<K600W600<0a/H01LH10000
02CFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/H4?`0leSlo?mK6?lHoa]K6e/Hoa]K6
e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/Hoa]K60Sl03MK6e/KF?mK6e/KFa]H0
0Sl0;LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFaP0100001/H00`36
aP0HaP03?dlo00;600=??dl01<H013o6?dl4aP03?lK600?600Doa/K6?`0JaP03ClK600?600U?a/K6
ClI??dl00/H00co6aP05aP05?lHoCcl05/H00`36aP09aP030<K600G60@00000Te/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K60cl0@/KFa]K6?lHoaSo6e/Hoa]K6e/Hoa]K6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFaSo6eSoFa]K6eP@o00G6e/KFaP08?`0Xe/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFaP400006aP030<K601S600@oCcm?1/H01So6?lHo00;6
00<oa/H00lH00co6aP02aP03ClK601O600=??lH01LH014o6aSl7aP07?dloCcm??`03aP03?lK600;6
00=??lH04LH00`36aP09aP030<K600G60@00001Fe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]Hoe/KFa]K6?lHoa]Ho0<Hoa]K6e/Hoa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0F
eSoFa]K6e/Hoa]Hoe/KFa]K6eSoFaP<o00_6e/KFaSo6e/KFaP03?`0Sa]K6e/KFa]K6e/KFa]K60<KF
a]K6e/KFa]K60<KFa]K6e/H00@0000K600<0a/H06LH00do6aP03aP04Cco6?`;600E?aP0oC`04aP03
?do600?600<oa/H05<H01Dloa/I?00O600=?aTl02<H013o6aTl2aP03?do600?600<oa/H01LH00cm?
aP0<aP030<K600W600<0a/H01LH1000002GFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KF00@o00O6?lKFaSo6008o00CFa]K60Sl0:]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
?lKFa]K6e/HoaP8o01gFa]K6e/KFaSo6eSoFa]Hoe/KFaSo6e/KFa]HoeP02?`0=a]K6e/KFa]K6e/H0
aP02?`0@e/KFa]K6e/H0a]K6e/KFaP400006aP030<K601O600E?aTloC`02aP03?dlo00?600DoaSl0
?`03aP03?lHo00C600=?aTl04/H00cm?aP03aP03?lK600G600PoClI?aTloC`G600E?a/K6C`07aP03
ClK600G600I?a/HoCcl8aP0303o600W600<0a/H01LH10000023Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP8o00?Fa]H00cl01=K6e/H3?`0PaSo6e/HoaSo6e/KFaSo6eSoFa]K6e/KFa]K6e/KF
a]H2?`0>a]K6e/KF?mK6e/KFa]H3?`05e/KFa]H00Sl07LKFaSo6e/Hoa]K6e/KFa]Hoe/KFa]K6eSoF
a]K6008o01[Fa]K6eSl0a]K6e/KFa]K6e/H0a]K6e/KFaP400006aP030<K601W600E??dloC`04aP03
?lHo00;600A?a/Ho0/H00do6aP03aP05ClK6aTl03<H00cm?aP06aP03Cco600K600<oCcl01lH013o6
aTl4aP03?lK600K600=?a/H01LH00do6aP03aP05Cco6?dl00/H00`36aP08aP030<K600G60@00000P
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0Ne/Ho?mK6e/HoaSo6e/HoaSo6e/Hoa]K6
eSoFa]K60Sl02=K6e/KFa]K60cl02lHoa]K6e/KFaSo600<o02o6e/HoaSo6e/KFa]K6e/KFaSo6e/KF
aSo6e/KFa]K6eSoFa]K6e/KF?mK6e/KFaP02?`0Fe/KF0=K6e/KFa]K6e/H0a]K6e/KFaP400005aP03
0<K601_600<oClH00lH013o6?dl2aP03?`0o00?600<oa/H00lH01Co6a/Ho00;600=?a/H00lH00dlo
aP02aP03?lK600G600<oa/H00lH01Sm?aTo6C`[600<oClH01LH00co6aP06aP03ClK600C600<oa/H0
1/H014loC`0:aP030<K600G60@00000Re/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o
00_Fa]K6?lHoaSo6eP02?`0Da]K6eSoFa]K6eSoFa]Hoe/KF?mH3?`0Ge/KFaSo6e/KFa]K6eSoFa]K6
e/KF?mH00Sl01lKFa]K6e/H00cl0=lHoa]K6e/KF?mK6e/KFa]K6?lKFa]K6e/Hoa]K6e/KFa]K6eP0o
a]K6e/KFa]K60<KFa]K6e/H00@0000G600<0a/H06LH00cm?aP03aP05?dloaSl00/H00dlo0003aP03
ClK600?600E?a/K6C`05aP03ClK600G600=?a/H01/H00co6aP05aP04?lK6C`G600=??lH00lH00do6
aP04aP03?do600K600=??lH01/H00co6aP07aP050<HoCcl01/H00`36aP05aP4000008=K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl00mK6eP04?`03a]Ho00<o00C60<KF0Sl01<KFa]H2?`0Y
a]K6?lKFa]K6e/KFa]K6eSoFa]K6e/KFaSo6e/KFa]K6eSoFaSo6e/H00Sl0?=K6e/KFaSo6e/KFa]Ho
eSoFa]K6e/HoaSo6e/KFa]K6?lKFa]K6e/KF0=K6e/Hoa]K6e/H0a]K6e/KFaP400005aP030<K601S6
00E?aTloC`02aP09?dloClI??lH000;600=??lH00lH00do6C`03aP03ClK601?600=?a/H01LH02To6
a/I?aTloaSl6aP03ClK600C600@oa/I?1LH014o6aSl7aP03?do600G600<0a/H02<H00`36aP05aP40
00008=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl01=K6e/H2?`03e/KF00<o03;F0=Ho
eSoFa]HoeSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFaP8o02OFa]Hoe/KFa]K6
?lKFa]K6e/Hoa]Hoe/KFaSo6e/Hoa]K6e/KF?mH00cl05]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/H10000
1LH00`36aP0MaP03?lK600;600M??lHoaP1?00;600@oa/I?0/H00co6aP0PaP05ClK6aTl01<H00co6
aP04aP03ClK600G600A?a/Ho1<H01Do6a/I?00O600Q?a/K6Cco600_600<0a/H01<H1000002WFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6eP02?`0_aSo6eSoFaSo6eSoFaSo6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00Sl0A]K6e/Hoa]K6eSoFa]K6e/Hoa]K6e/KFaSo6
e/Hoa]K6?lKFa]Hoe/KFa]K6eSoFa]K6?`0oa]K6e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0KaP03
?lK600;600Q??lK6ClI?00;600=?aTl00/H00co6aP0OaP03?lHo00C600=??lH00lH00do6aP03aP03
ClK600G600=?a/H00/H013o6aTl5aP03ClK600G600=?a/H00/H00`36?`09aP030<K600C60@00000W
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KF008o00?6e/H00Sl01=H0e/H2?`0S
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl0BLHoa]K6e/HoaSo6e/Hoa]K6e/Ho
a]K6e/KFaSo6e/KFaSo6?lKFa]K6eSoFa]K6e/KF?mK6eP3Fa]K6e/KFa]K6eP3Fa]K6e/H00@0000G6
00<0a/H06LH00co6aP02aP03Cco600;600PoClK60<HoC`?600=?a/H07<H00cm?aP02aP03ClK600?6
00A?a/Ho0/H00do6aP03aP03ClK600G600=?a/H01<H00cm?aP06aP04Cco6aPP02lH00`36aP04aP40
0000K=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFaSo6e/KFaSo6e/HoaSo6e/KFaP8o00KFa]K6
e/H2?`04e/KFaPh001[Fa]K6?lKF0=K6e/KFa]K6e/KF0=K6e/KFaP400005aP030<K602O600<0a/H0
8<H00dloaP04aP03?lK600C600=?a/H00/H00co6aP04aPh00/H01TloaSm??`?600Hoa/I??dl2aP04
?lK600[600<0a/H01<H1000005kFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6eSoFa]K63P0043o6
eSoFa]K6?lHoa]K6e/H3?`03a]K6008o00OFaSo6e/KF008o01G6?lH0a]K6e/KFa]K6eP3Fa]K6e/H0
0@0000C600<0a/H0:<H00`36aP0MaP03?`0000`00/H00do6aP04aP03?lK600?600@oa/I?0lH014o6
aSl4aP04ClI??`C600=?aTl01/H013o6aP0:aP030<K600C60@000013e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP0=000_?lKFa]K6
e/Hoa]K6e/KFaSo6e/KFa]K6?lKFa]Hoe/KF?mK6?lKFaSo6e/KF?mH00Sl08LKFa]K6eSoFa]K6e/KF
a]H0e/KFa]K6e/KF0=K6e/KFaP0100001<H00`36aP0XaP030<K600?63P09aP05ClK6aTl01lH00do6
aP05aP03ClK600K600DoClK6?`04aP03ClI?00?600=?a/H00/H01Co6aTlo00K600=?a/H01/H00`36
aP07aP030<K600C60@00000We/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00h0
01G6e/KFa]K6e/KFa]K6e/KFa]K6e/H00Sl09mK6eSoFa]K6e/KFaSo6e/KFa]K6?lKFa]K6e/KFa]Ho
eSoFa]K6eP02?`0<a]K6eSoFa]Hoe/KF0Sl07lKFa]K6?lKFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/H0
0@0000C600<0a/H04/H>00S600<0a/H05/H00dloaP04aP03?lK600G600<oa/H01/H00do6aP09aP03
ClK600_600A?a/Ho1<H00dloaP04aP03?lK600K600<0a/H01/H00`36aP04aP4000002mK6e/H0a]K6
e/KF00h008W6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF
a]Hoe/KFa]K6eSoFa]K6e/KFaSo6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aSo6e/KFa]K60<KFa]K6e/KF0=K6e/KFaP0100001<H702C600<0a/H05<H00do6aP05aP03ClK600K6
00<oClH01/H00do6aP0;aP03ClK602;600<0a/H01LH00`36aP04aP400000GmK6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6?lKF?mK6e/KF008o0476e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFaP0100001lH00`36aP0UaP030<K601c600=?a/H0
1LH014o6aSl4aP03ClI?00o600=?a/H08<H00`36aP06aP030<K600?60@00002Re/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/Hoa]K6?lKF?mK6?lKFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K60@0000W60P0TaP030<K601_600<oa/H01LH00co6
aP02aP03ClI?00?600=?a/H0<LH00`36aP05aP030<K600?60@00002Re/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K60<KFa]K60@0000c600<0a/H08<H00`36aP0SaP03?lK600;600=?aTl0
0lH00do6aP0baP030<K600C600<0a/H00lH1000000gFa]K6e/KFa]K6e/KF008009?6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Ho
a]K6eSoFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eP3Fa]K6e/H0a]K6e/H00@0000o600<0a/H07LH00`36aP0RaP05ClK6aTl01lH00do6aP0caP03
0<K600?600<0a/H00lH100000:;Fa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6
e/H100004LH00`36aP0KaP030<K602k600=?a/H0<lH00`36aP03aP030<K600?60@00000Be/KFa]K6
e/KFa]K6e/KFa]K60P00S]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/H100005<H00`36aP0HaP030<K602k6
00=?a/H0=<H00`36aP02aP030<K600?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K60<KFa]K60@0001K600<0a/H05/H00`36aP1VaP050<K6aP001LH1000001OFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP020029a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/H00@0001W600<0a/H04lH00`36aP1WaP04
0<K600G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60<KFa]K60@0001_6
0P0AaP030<K606S600@0a/H01LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KF0=K6e/H100007/H00`36aP0=aP030<K606W600@0a/H01<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/H100008<H200c600<0a/H0J/H00`360004aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFaP40000SaP030<K600S600<0a/H0
JlH200C60@00002Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P001=K6e/H10000
9LH200O600<0a/H0JlH200C60@00002De/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPX000CFa]K6
0@0002S600<0a/H00lH00`36aP1@aQ<03/H1000002WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP020014a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HB000Qa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000[aP040<K602g64`0caP400000B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K64P00A]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
;LH200S64`1HaP400000;]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H9001[a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@000:;6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000001\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0170755, -0.0273899, 
  0.0054804, 0.0054804}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.06334 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.00781786 1.10387 0.0275966 1.10387 [
[ 0 0 0 0 ]
[ 1 1.06334 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.06334 L
0 1.06334 L
closepath
clip
newpath
p
1 g
.002 w
.85288 .0276 m
.88513 .76554 L
s
.88513 .76554 m
.0276 .82538 L
s
.0276 .82538 m
.07397 .11949 L
s
.07397 .11949 m
.85288 .0276 L
s
.94002 .39109 m
.3074 .45042 L
s
.3074 .45042 m
.2889 1.03575 L
s
.2889 1.03575 m
.9724 .99861 L
s
.9724 .99861 m
.94002 .39109 L
s
.85288 .0276 m
.88513 .76554 L
s
.88513 .76554 m
.9724 .99861 L
s
.9724 .99861 m
.94002 .39109 L
s
.94002 .39109 m
.85288 .0276 L
s
.07397 .11949 m
.3074 .45042 L
s
.3074 .45042 m
.2889 1.03575 L
s
.2889 1.03575 m
.0276 .82538 L
s
.0276 .82538 m
.07397 .11949 L
s
p
.4 g
.87631 .12533 m
.13627 .20781 L
s
P
p
.4 g
.90385 .2402 m
.20992 .31222 L
s
P
p
.4 g
.92793 .34064 m
.27472 .40408 L
s
P
p
.4 g
.74191 .04069 m
.85068 .39947 L
s
P
p
.4 g
.49075 .07032 m
.64752 .41852 L
s
P
p
.4 g
.24773 .09899 m
.44965 .43708 L
s
P
P
p
1 0 .6 r
.00177 w
.42957 .69025 m
.44231 .70731 L
s
P
p
1 0 .6 r
.00177 w
.42957 .69025 m
.46367 .67648 L
s
P
p
1 0 .6 r
.00177 w
.58592 .71667 m
.55981 .73154 L
s
P
p
1 0 .6 r
.00177 w
.39697 .71386 m
.41027 .73068 L
s
P
p
1 0 .6 r
.00177 w
.61955 .74384 m
.59291 .7584 L
s
P
p
1 0 .6 r
.00177 w
.58592 .71667 m
.54515 .6987 L
s
P
p
1 0 .6 r
.00177 w
.61955 .74384 m
.6229 .78274 L
s
P
p
1 0 .6 r
.00177 w
.39697 .71386 m
.38108 .75197 L
s
P
p
1 0 .6 r
.00177 w
.65721 .77426 m
.62996 .78848 L
s
P
p
1 0 .6 r
.00177 w
.36024 .74046 m
.37419 .757 L
s
P
p
1 0 .6 r
.0025 w
.41497 .67068 m
.42957 .69025 L
s
P
p
1 0 .6 r
.00177 w
.65721 .77426 m
.66019 .81301 L
s
P
p
1 0 .6 r
.0025 w
.61575 .69966 m
.58592 .71667 L
s
P
p
1 0 .6 r
.00177 w
.36024 .74046 m
.34457 .77861 L
s
P
p
1 0 .6 r
.0025 w
.41497 .67068 m
.39697 .71386 L
s
P
p
1 0 .6 r
.0025 w
.61575 .69966 m
.61955 .74384 L
s
P
p
1 0 .6 r
.00177 w
.69731 .77677 m
.66918 .79113 L
s
P
p
1 0 .6 r
.0025 w
.65383 .73026 m
.65721 .77426 L
s
P
p
1 0 .6 r
.00177 w
.68961 .77629 m
.69229 .81541 L
s
P
p
1 0 .6 r
.00177 w
.69731 .77677 m
.69992 .81599 L
s
P
p
1 0 .6 r
.0025 w
.37798 .69724 m
.36024 .74046 L
s
P
p
1 0 .6 r
.00177 w
.33137 .73928 m
.34598 .7561 L
s
P
p
1 0 .6 r
.00353 w
.39814 .64813 m
.41497 .67068 L
s
P
p
1 0 .6 r
.00177 w
.33692 .73951 m
.32128 .77815 L
s
P
p
1 0 .6 r
.00353 w
.64998 .68016 m
.61575 .69966 L
s
P
p
1 0 .6 r
.00177 w
.33137 .73928 m
.31573 .77804 L
s
P
p
1 0 .6 r
.00177 w
.68961 .77629 m
.72175 .81762 L
s
P
p
1 0 .6 r
.0025 w
.65383 .73026 m
.68961 .77629 L
s
P
p
1 0 .6 r
.00353 w
.64998 .68016 m
.65383 .73026 L
s
P
p
1 0 .6 r
.0025 w
.69436 .73222 m
.69731 .77677 L
s
P
p
1 0 .6 r
.00177 w
.73056 .77885 m
.73284 .81845 L
s
P
p
1 0 .6 r
.0025 w
.37798 .69724 m
.33692 .73951 L
s
P
p
1 0 .6 r
.00353 w
.39814 .64813 m
.37798 .69724 L
s
P
p
1 0 .6 r
.00177 w
.7431 .77963 m
.71393 .79416 L
s
P
p
1 0 .6 r
.00177 w
.33692 .73951 m
.2998 .77772 L
s
P
p
1 0 .6 r
.00177 w
.7431 .77963 m
.74526 .81938 L
s
P
p
1 0 .6 r
.0025 w
.3491 .69535 m
.33137 .73928 L
s
P
p
1 0 .6 r
.00177 w
.2982 .73792 m
.31359 .75506 L
s
P
p
1 0 .6 r
.00177 w
.3073 .73829 m
.29169 .77756 L
s
P
p
1 0 .6 r
.00177 w
.73056 .77885 m
.76307 .82072 L
s
P
p
1 0 .6 r
.0025 w
.69436 .73222 m
.73056 .77885 L
s
P
p
1 0 .6 r
.005 w
.64558 .62294 m
.64998 .68016 L
s
P
p
1 0 .6 r
.00353 w
.69099 .68149 m
.69436 .73222 L
s
P
p
1 0 .6 r
.00177 w
.76833 .78121 m
.77024 .82126 L
s
P
p
1 0 .6 r
.005 w
.42111 .5922 m
.39814 .64813 L
s
P
p
1 0 .6 r
.00177 w
.2982 .73792 m
.2826 .77738 L
s
P
p
1 0 .6 r
.0025 w
.74065 .73447 m
.7431 .77963 L
s
P
p
1 0 .6 r
.00177 w
.77732 .78177 m
.77915 .82192 L
s
P
p
1 0 .6 r
.0025 w
.3491 .69535 m
.3073 .73829 L
s
P
p
1 0 .6 r
.00353 w
.36924 .64542 m
.3491 .69535 L
s
P
p
1 0 .6 r
.02 w
.58234 .28783 m
.58287 .38954 L
s
P
p
1 g
.05 w
.58234 .28783 Mdot
P
p
1 0 .6 r
.00177 w
.3073 .73829 m
.26952 .77713 L
s
P
p
1 0 .6 r
.00177 w
.76833 .78121 m
.80119 .82357 L
s
P
p
1 0 .6 r
.0025 w
.73175 .73404 m
.76833 .78121 L
s
P
p
1 0 .6 r
.0025 w
.31589 .69317 m
.2982 .73792 L
s
P
p
1 0 .6 r
.00177 w
.27982 .73717 m
.26424 .77702 L
s
P
p
1 0 .6 r
.0025 w
.73175 .73404 m
.78147 .75547 L
s
P
p
1 0 .6 r
.00353 w
.69099 .68149 m
.73175 .73404 L
s
P
p
1 0 .6 r
.00177 w
.77732 .78177 m
.81026 .82425 L
s
P
p
1 0 .6 r
.005 w
.64558 .62294 m
.69099 .68149 L
s
P
p
1 0 .6 r
.005 w
.42111 .5922 m
.36924 .64542 L
s
P
p
1 0 .6 r
.00707 w
.44735 .5283 m
.42111 .5922 L
s
P
p
1 0 .6 r
.0025 w
.74065 .73447 m
.77732 .78177 L
s
P
p
1 0 .6 r
.00177 w
.29828 .69703 m
.31395 .71512 L
s
P
p
1 0 .6 r
.00707 w
.64054 .55736 m
.64558 .62294 L
s
P
p
1 0 .6 r
.00353 w
.73785 .68301 m
.74065 .73447 L
s
P
p
1 0 .6 r
.00177 w
.81622 .78421 m
.81765 .82481 L
s
P
p
1 0 .6 r
.00177 w
.27325 .7369 m
.25769 .77689 L
s
P
p
1 0 .6 r
.00353 w
.36924 .64542 m
.32229 .69359 L
s
P
p
1 0 .6 r
.0025 w
.32229 .69359 m
.27982 .73717 L
s
P
p
1 0 .6 r
.0025 w
.32229 .69359 m
.27966 .71024 L
s
P
p
1 0 .6 r
.00177 w
.29828 .69703 m
.2824 .7376 L
s
P
p
1 0 .6 r
.00177 w
.56667 .82252 m
.58994 .8611 L
s
P
p
1 0 .6 r
.01414 w
.58287 .38954 m
.58336 .48352 L
s
P
p
1 0 .6 r
.01414 w
.58287 .38954 m
.51181 .4623 L
s
P
p
1 0 .6 r
.00177 w
.78147 .75547 m
.81469 .79835 L
s
P
p
1 0 .6 r
.00177 w
.27982 .73717 m
.24142 .77657 L
s
P
p
1 0 .6 r
.00177 w
.78147 .75547 m
.82711 .77514 L
s
P
p
1 0 .6 r
.0025 w
.31589 .69317 m
.27325 .7369 L
s
P
p
1 0 .6 r
.00353 w
.336 .64231 m
.31589 .69317 L
s
P
p
1 0 .6 r
.00177 w
.56667 .82252 m
.55019 .87022 L
s
P
p
1 0 .6 r
.00177 w
.81622 .78421 m
.84951 .8272 L
s
P
p
1 0 .6 r
.01 w
.51181 .4623 m
.44735 .5283 L
s
P
p
1 0 .6 r
.01 w
.51181 .4623 m
.45019 .48284 L
s
P
p
1 0 .6 r
.00177 w
.27325 .7369 m
.2347 .77644 L
s
P
p
1 0 .6 r
.0025 w
.77915 .73634 m
.81622 .78421 L
s
P
p
1 0 .6 r
.0025 w
.77915 .73634 m
.83012 .75811 L
s
P
p
1 0 .6 r
.00353 w
.73785 .68301 m
.77915 .73634 L
s
P
p
1 0 .6 r
.00177 w
.522 .83261 m
.50571 .88042 L
s
P
p
1 0 .6 r
.005 w
.69183 .62359 m
.73785 .68301 L
s
P
p
1 0 .6 r
.00707 w
.44735 .5283 m
.38892 .58812 L
s
P
p
1 0 .6 r
.00177 w
.83342 .75191 m
.83468 .79344 L
s
P
p
1 0 .6 r
.0025 w
.54031 .77882 m
.56667 .82252 L
s
P
p
1 0 .6 r
.005 w
.69183 .62359 m
.75396 .64916 L
s
P
p
1 0 .6 r
.00707 w
.64054 .55736 m
.69183 .62359 L
s
P
p
1 0 .6 r
.0025 w
.3163 .65101 m
.29828 .69703 L
s
P
p
1 0 .6 r
.00177 w
.24475 .73573 m
.22923 .77633 L
s
P
p
1 0 .6 r
.01 w
.58336 .48352 m
.64054 .55736 L
s
P
p
1 0 .6 r
.005 w
.38892 .58812 m
.336 .64231 L
s
P
p
1 0 .6 r
.005 w
.38892 .58812 m
.33664 .60709 L
s
P
p
1 0 .6 r
.00177 w
.522 .83261 m
.47482 .86167 L
s
P
p
1 0 .6 r
.0025 w
.54031 .77882 m
.522 .83261 L
s
P
p
1 0 .6 r
.01 w
.58336 .48352 m
.58381 .57016 L
s
P
p
1 0 .6 r
.00177 w
.27288 .69544 m
.25704 .73657 L
s
P
p
1 0 .6 r
.00177 w
.27966 .71024 m
.24022 .72563 L
s
P
p
1 0 .6 r
.00177 w
.27966 .71024 m
.24079 .75005 L
s
P
p
1 0 .6 r
.00353 w
.336 .64231 m
.28809 .69136 L
s
P
p
1 0 .6 r
.00177 w
.48371 .80889 m
.46752 .85723 L
s
P
p
1 0 .6 r
.00177 w
.83012 .75811 m
.86378 .80163 L
s
P
p
1 0 .6 r
.00177 w
.83012 .75811 m
.87691 .77811 L
s
P
p
1 0 .6 r
.0025 w
.28809 .69136 m
.24475 .73573 L
s
P
p
1 0 .6 r
.0025 w
.28809 .69136 m
.24415 .70828 L
s
P
p
1 0 .6 r
.00177 w
.83342 .75191 m
.86717 .79555 L
s
P
p
1 0 .6 r
.00353 w
.56094 .71823 m
.54031 .77882 L
s
P
p
1 0 .6 r
.0025 w
.79583 .7033 m
.83342 .75191 L
s
P
p
1 0 .6 r
.00177 w
.24475 .73573 m
.20556 .77586 L
s
P
p
1 0 .6 r
.0025 w
.3163 .65101 m
.27288 .69544 L
s
P
p
1 0 .6 r
.00353 w
.33679 .59867 m
.3163 .65101 L
s
P
p
1 0 .6 r
.0025 w
.79583 .7033 m
.84772 .72505 L
s
P
p
1 0 .6 r
.00353 w
.75396 .64916 m
.79583 .7033 L
s
P
p
1 0 .6 r
.00177 w
.48371 .80889 m
.43612 .83817 L
s
P
p
1 0 .6 r
.0025 w
.50193 .7545 m
.48371 .80889 L
s
P
p
1 0 .6 r
.00353 w
.75396 .64916 m
.81127 .67275 L
s
P
p
1 0 .6 r
.00177 w
.27288 .69544 m
.23362 .73561 L
s
P
p
1 0 .6 r
.00707 w
.58381 .57016 m
.58423 .64986 L
s
P
p
1 0 .6 r
.00707 w
.58381 .57016 m
.56619 .60497 L
s
P
p
1 0 .6 r
.00177 w
.24401 .70174 m
.22827 .74328 L
s
P
p
1 0 .6 r
.00707 w
.45019 .48284 m
.39234 .50213 L
s
P
p
1 0 .6 r
.00707 w
.45019 .48284 m
.39069 .54362 L
s
P
p
1 0 .6 r
.00353 w
.56094 .71823 m
.50193 .7545 L
s
P
p
1 0 .6 r
.005 w
.58423 .64986 m
.56094 .71823 L
s
P
p
1 0 .6 r
.0025 w
.50193 .7545 m
.44871 .7872 L
s
P
p
1 0 .6 r
.00177 w
.24384 .69362 m
.22804 .73539 L
s
P
p
1 0 .6 r
.00177 w
.44871 .7872 m
.40073 .81669 L
s
P
p
1 0 .6 r
.00177 w
.44871 .7872 m
.39675 .77969 L
s
P
p
1 0 .6 r
.00353 w
.33664 .60709 m
.28793 .62476 L
s
P
p
1 0 .6 r
.00353 w
.33664 .60709 m
.28801 .65678 L
s
P
p
1 0 .6 r
.005 w
.39069 .54362 m
.33679 .59867 L
s
P
p
1 0 .6 r
.005 w
.39069 .54362 m
.33745 .56212 L
s
P
p
1 0 .6 r
.00177 w
.84772 .72505 m
.88186 .76924 L
s
P
p
1 0 .6 r
.00177 w
.84772 .72505 m
.89538 .74502 L
s
P
p
1 0 .6 r
.00177 w
.24415 .70828 m
.20349 .72394 L
s
P
p
1 0 .6 r
.00177 w
.24415 .70828 m
.20448 .74884 L
s
P
p
1 0 .6 r
.0025 w
.28801 .65678 m
.24401 .70174 L
s
P
p
1 0 .6 r
.0025 w
.28801 .65678 m
.2434 .67344 L
s
P
p
1 0 .6 r
.00353 w
.33679 .59867 m
.28799 .64852 L
s
P
p
1 0 .6 r
.0025 w
.81127 .67275 m
.86402 .69445 L
s
P
p
1 0 .6 r
.0025 w
.81127 .67275 m
.84755 .65347 L
s
P
p
1 0 .6 r
.005 w
.58423 .64986 m
.58461 .72303 L
s
P
p
1 0 .6 r
.00177 w
.24401 .70174 m
.20423 .7424 L
s
P
p
1 0 .6 r
.0025 w
.28799 .64852 m
.24384 .69362 L
s
P
p
1 0 .6 r
.0025 w
.28799 .64852 m
.24322 .66512 L
s
P
p
1 0 .6 r
.00177 w
.24384 .69362 m
.20391 .7344 L
s
P
p
1 0 .6 r
.00177 w
.24307 .65833 m
.22705 .70109 L
s
P
p
1 0 .6 r
.00177 w
.86402 .69445 m
.89859 .73926 L
s
P
p
1 0 .6 r
.00353 w
.58461 .72303 m
.58496 .79009 L
s
P
p
1 0 .6 r
.00353 w
.58461 .72303 m
.63165 .76415 L
s
P
p
1 0 .6 r
.00177 w
.86402 .69445 m
.91247 .71439 L
s
P
p
1 0 .6 r
.0025 w
.28793 .62476 m
.2427 .64117 L
s
P
p
1 0 .6 r
.0025 w
.28793 .62476 m
.26906 .60181 L
s
P
p
1 0 .6 r
.00177 w
.67799 .80391 m
.71932 .83936 L
s
P
p
1 0 .6 r
.005 w
.39234 .50213 m
.33821 .52018 L
s
P
p
1 0 .6 r
.005 w
.39234 .50213 m
.37136 .47078 L
s
P
p
1 0 .6 r
.00177 w
.2434 .67344 m
.2021 .68887 L
s
P
p
1 0 .6 r
.00177 w
.2434 .67344 m
.20312 .71454 L
s
P
p
1 0 .6 r
.00353 w
.33745 .56212 m
.28783 .57937 L
s
P
p
1 0 .6 r
.00353 w
.33745 .56212 m
.28791 .61263 L
s
P
p
1 0 .6 r
.005 w
.56619 .60497 m
.54957 .63782 L
s
P
p
1 0 .6 r
.005 w
.56619 .60497 m
.60874 .62184 L
s
P
p
1 0 .6 r
.00177 w
.84755 .65347 m
.88125 .63556 L
s
P
p
1 0 .6 r
.00177 w
.84755 .65347 m
.89612 .67312 L
s
P
p
1 0 .6 r
.00177 w
.24322 .66512 m
.20176 .68049 L
s
P
p
1 0 .6 r
.00177 w
.24322 .66512 m
.20279 .70634 L
s
P
p
1 0 .6 r
.0025 w
.28791 .61263 m
.24307 .65833 L
s
P
p
1 0 .6 r
.0025 w
.28791 .61263 m
.24244 .62894 L
s
P
p
1 0 .6 r
.00177 w
.67799 .80391 m
.71718 .83816 L
s
P
p
1 0 .6 r
.0025 w
.63165 .76415 m
.67799 .80391 L
s
P
p
1 0 .6 r
.0025 w
.58496 .79009 m
.58528 .85144 L
s
P
p
1 0 .6 r
.0025 w
.58496 .79009 m
.54244 .82867 L
s
P
p
1 0 .6 r
.00177 w
.24307 .65833 m
.20253 .69966 L
s
P
p
1 0 .6 r
.00177 w
.58528 .85144 m
.60388 .90124 L
s
P
p
1 0 .6 r
.0025 w
.63165 .76415 m
.67495 .80201 L
s
P
p
1 0 .6 r
.00177 w
.2422 .61783 m
.2259 .66174 L
s
P
p
1 0 .6 r
.00177 w
.58528 .85144 m
.58557 .90748 L
s
P
p
1 0 .6 r
.00177 w
.2427 .64117 m
.20081 .65637 L
s
P
p
1 0 .6 r
.00177 w
.2427 .64117 m
.20185 .68277 L
s
P
p
1 0 .6 r
.00177 w
.54244 .82867 m
.50343 .86408 L
s
P
p
1 0 .6 r
.00177 w
.54244 .82867 m
.52889 .84204 L
s
P
p
1 0 .6 r
.00177 w
.26906 .60181 m
.25145 .58041 L
s
P
p
1 0 .6 r
.00177 w
.26906 .60181 m
.22737 .61653 L
s
P
p
1 0 .6 r
.0025 w
.28783 .57937 m
.24171 .5954 L
s
P
p
1 0 .6 r
.0025 w
.28783 .57937 m
.26858 .55511 L
s
P
p
1 0 .6 r
.00353 w
.33821 .52018 m
.28773 .53701 L
s
P
p
1 0 .6 r
.00353 w
.33821 .52018 m
.28781 .57144 L
s
P
p
1 0 .6 r
.00177 w
.24244 .62894 m
.20032 .64405 L
s
P
p
1 0 .6 r
.00177 w
.24244 .62894 m
.20138 .67073 L
s
P
p
1 0 .6 r
.00177 w
.67495 .80201 m
.71473 .83679 L
s
P
p
1 0 .6 r
.00177 w
.67495 .80201 m
.68874 .81477 L
s
P
p
1 0 .6 r
.0025 w
.28781 .57144 m
.2422 .61783 L
s
P
p
1 0 .6 r
.0025 w
.28781 .57144 m
.24154 .5874 L
s
P
p
1 0 .6 r
.00353 w
.37136 .47078 m
.35162 .44128 L
s
P
p
1 0 .6 r
.00353 w
.37136 .47078 m
.32121 .48684 L
s
P
p
1 0 .6 r
.00353 w
.60874 .62184 m
.64863 .63766 L
s
P
p
1 0 .6 r
.00353 w
.60874 .62184 m
.59439 .65235 L
s
P
p
1 0 .6 r
.00177 w
.2422 .61783 m
.20094 .65978 L
s
P
p
1 0 .6 r
.00353 w
.54957 .63782 m
.53393 .66872 L
s
P
p
1 0 .6 r
.00353 w
.54957 .63782 m
.48927 .66503 L
s
P
p
1 0 .6 r
.00177 w
.24171 .5954 m
.19897 .61026 L
s
P
p
1 0 .6 r
.00177 w
.24171 .5954 m
.20006 .63771 L
s
P
p
1 0 .6 r
.0025 w
.48927 .66503 m
.43393 .69 L
s
P
p
1 0 .6 r
.0025 w
.48927 .66503 m
.47391 .6936 L
s
P
p
1 0 .6 r
.0025 w
.28773 .53701 m
.24079 .55266 L
s
P
p
1 0 .6 r
.0025 w
.28773 .53701 m
.26813 .51148 L
s
P
p
1 0 .6 r
.00177 w
.24154 .5874 m
.19865 .60219 L
s
P
p
1 0 .6 r
.00177 w
.24154 .5874 m
.19975 .62982 L
s
P
p
1 0 .6 r
.00177 w
.26858 .55511 m
.25061 .53245 L
s
P
p
1 0 .6 r
.00177 w
.26858 .55511 m
.22606 .56945 L
s
P
p
1 0 .6 r
.00177 w
.43393 .69 m
.37779 .69616 L
s
P
p
1 0 .6 r
.0025 w
.32121 .48684 m
.27458 .50177 L
s
P
p
1 0 .6 r
.0025 w
.32121 .48684 m
.30219 .4602 L
s
P
p
1 0 .6 r
.0025 w
.64863 .63766 m
.68589 .65245 L
s
P
p
1 0 .6 r
.0025 w
.64863 .63766 m
.71292 .63044 L
s
P
p
1 0 .6 r
.0025 w
.35162 .44128 m
.33311 .41362 L
s
P
p
1 0 .6 r
.0025 w
.35162 .44128 m
.37182 .38824 L
s
P
p
1 0 .6 r
.0025 w
.59439 .65235 m
.58094 .68094 L
s
P
p
1 0 .6 r
.0025 w
.59439 .65235 m
.63073 .66742 L
s
P
p
1 0 .6 r
.00177 w
.43393 .69 m
.38325 .71288 L
s
P
p
1 0 .6 r
.0025 w
.53393 .66872 m
.51927 .69768 L
s
P
p
1 0 .6 r
.0025 w
.53393 .66872 m
.56924 .68411 L
s
P
p
1 0 .6 r
.00177 w
.71292 .63044 m
.77144 .62386 L
s
P
p
1 0 .6 r
.00177 w
.71292 .63044 m
.74765 .64368 L
s
P
p
1 0 .6 r
.00177 w
.24079 .55266 m
.19726 .56718 L
s
P
p
1 0 .6 r
.00177 w
.24079 .55266 m
.19839 .59562 L
s
P
p
1 0 .6 r
.00177 w
.47391 .6936 m
.45958 .72027 L
s
P
p
1 0 .6 r
.00177 w
.47391 .6936 m
.42306 .71673 L
s
P
p
1 0 .6 r
.00177 w
.26813 .51148 m
.24983 .48763 L
s
P
p
1 0 .6 r
.00177 w
.26813 .51148 m
.22483 .52546 L
s
P
p
1 0 .6 r
.00177 w
.27458 .50177 m
.23133 .51562 L
s
P
p
1 0 .6 r
.00177 w
.27458 .50177 m
.23206 .54481 L
s
P
p
1 0 .6 r
.00177 w
.37182 .38824 m
.39042 .33941 L
s
P
p
1 0 .6 r
.00177 w
.37182 .38824 m
.35536 .36214 L
s
P
p
1 0 .6 r
.00177 w
.30219 .4602 m
.28441 .4353 L
s
P
p
1 0 .6 r
.00177 w
.30219 .4602 m
.25917 .4735 L
s
P
p
1 0 .6 r
.00177 w
.68589 .65245 m
.7206 .66621 L
s
P
p
1 0 .6 r
.00177 w
.68589 .65245 m
.67524 .67856 L
s
P
p
1 0 .6 r
.00177 w
.63073 .66742 m
.66458 .68146 L
s
P
p
1 0 .6 r
.00177 w
.63073 .66742 m
.61908 .69384 L
s
P
p
1 0 .6 r
.00177 w
.58094 .68094 m
.56838 .70763 L
s
P
p
1 0 .6 r
.00177 w
.58094 .68094 m
.53052 .70418 L
s
P
p
1 0 .6 r
.00177 w
.33311 .41362 m
.31582 .38778 L
s
P
p
1 0 .6 r
.00177 w
.33311 .41362 m
.29036 .42631 L
s
P
p
1 0 .6 r
.00177 w
.56924 .68411 m
.60213 .69845 L
s
P
p
1 0 .6 r
.00177 w
.56924 .68411 m
.55646 .71088 L
s
P
p
1 0 .6 r
.00177 w
.51927 .69768 m
.50559 .72472 L
s
P
p
1 0 .6 r
.00177 w
.51927 .69768 m
.46824 .72111 L
s
P
p
1 g
.002 w
.85288 .0276 m
.88513 .76554 L
s
.88513 .76554 m
.0276 .82538 L
s
.0276 .82538 m
.07397 .11949 L
s
.07397 .11949 m
.85288 .0276 L
s
.85288 .0276 m
.88513 .76554 L
s
.88513 .76554 m
.9724 .99861 L
s
.9724 .99861 m
.94002 .39109 L
s
.94002 .39109 m
.85288 .0276 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->1.1858,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40002RaP400000Q]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61@005lKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040001maPT01<H00`36aP0EaP400000MMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP08000Ua]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP010000K<H900?600?4a/H03lH201K60@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaPP001kFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/H2000Fe/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40001KaPT05LH00lC6aP0>aP805/H1000005?Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP08000_a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/H0
0P005]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000B/H902K600?4a/H03/H00`36000EaP400000@]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaPP005SFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003[6200>aP03a<K602O600?4a/H0
3LH00`36000EaP400000<MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H02@00J=K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002W6
200PaP03a<K602K600?4a/H03LH00`36000EaP4000008=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K62@00NLKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001S62008aP03a<K602K600?4a/H09lH00lC6aP0=aP030<H001C60@00000?
e/KFa]K6e/KFa]K6e/KF00T008[Fa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/H100002lH401[600?4a/H09/H00lC6
aP0WaP03a<K600c600<0aP005<H1000008WFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6eP02a00G0<C40<KFa]K6e/KF
a]K6e/KFa]K6e/H00@0000_60P0NaP03a<K602G600?4a/H09/H01<C6a/H9a0;600@0a/H04lH10000
07SFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H8a00Re/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000;aP030<H001k600?4a/H0
9LH00lC6aP0HaPW41LH00lC6aP0;aP040<K601?60@00001We/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6eP08a00ca]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6eP3Fa]H0e/KF
a]K6e/KFa]K6e/KFa]K60040000;aP050<K6aP007LH00lC6aP0UaP03a<K600K62L@FaP03a<K600_6
00D0a/K6000BaP400000EMK6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02L@0A=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6eP3Fa]H0e/KFa]K6e/KFa]K6e/KFa]K60@0000_6
00<0a/H00/H00`36aP0KaP03a<K601c62/@WaP03a<K600[600D0a/K6000BaP400000AMK6e/KFa]K6
e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
eP08a01Ea]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KF
a]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFaP0100002/H00`36aP05aP030<K601[600?4a/H0
2/H9a1;600?4a/H09<H00lC6aP0:aP030<K600;600<0a/H03lH1000003CFa]K6e/KFa]K60<KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K62<@0I]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]H0
e/KFaP36e/KFa]K6e/KFa]K6e/KFaP40000:aP030<K600K600<0a/H05LH9a2C600?4a/H09<H00lC6
aP09aP030<K600;600<0a/H03lH1000002?Fa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
eP08a01ga]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KF
a]K6e/H00@0000[600<0a/H02<H00`36aP02aPW43lH00lC6aP0SaP03a<K602G600?4a/H02<H00`36
aP03aP030<K600k60@00000Fe/KFa]K6e/KFaP36e/KFa]K6e/KF00C408SFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
0@0000[600<0a/H02LH00`36aP0JaP03a<K602?600?4a/H09<H00lC6aP08aP030<K600?600<0a/H0
3/H100000:;Fa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/H100002/H00`36
aP0:aP030<K601[600?4a/H08lH00lC6aP0TaP03a<K600O600<0a/H01<H00`36aP0=aP400000X]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFaP40000:aP030<K600c600<0a/H0
6LH00lC6aP0SaP03a<K602?600?4a/H01lH00`36a004a0030<K600g60@000022e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPW4
01L0a<KFa]K60<KFa]K6e/KFa]K6e/KFaP0100002/H00`36aP0=aP030<K601W600?4a/H08lH00lC6
aP0JaP[42LH00`36aP04aP030<K600c60@00001^e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/H;a00Ya]K6e/KFa]K6a<KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KF
a]K6e/H00@0000[600<0a/H03lH00`36aP0HaP03a<K602;61004aP[45LH00lC6aP06aP030<K600C6
00<0a/H03<H1000005_Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K400H00l@0?]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K60@0000W6
00<0a/H04LH00`36aP0IaP03a<K601C62/@8027600?4a/H01/H00`36aP05aP030<K600_60@000016
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFaP[400[Fa]K6e/KFa]K62000@=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/H100002LH00`36aP0BaP030<K601W63<@DaPP0
8/H00lC6aP05aP030<K600G600<0a/H02lH10000037Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KF00[401o6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K600P0
043Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/H0a]K6e/KFaP36e/KFa]K6
e/KFa]K60@0000W600<0a/H05<H00`36aP04aP[42/H00lC6aP0MaPH08lH00lC6aP05aP030<K600K6
00<0a/H02/H1000002;Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP361L@0=LKFa]K6e/KF
a]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K600@004;4a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/H10000
2LH00`36aP0EaP030<K601S600?4a/H07/H013m??l@TaP03a<K600C600<0a/H01/H00`36aP0:aP40
0000GMK6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`12e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K60@0000W600<0a/H0
5lH00`36aP0GaP03a<K601g600DoCco6a00SaP03a<K600C600<0a/H01lH00`36aP09aP400000GMK6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`12e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/K4a]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K60@0000W600<0a/H06<H00`36
aP0GaP03a3o601c600<oCcl00/H00lC6aP0QaP03a<K600?600<0a/H00/H5a0030<K600W60@00001M
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o02KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaPK400<0a<@00/@04LKFa]K60<KFa]K6e/KFa]K600400009aP030<K601W6
00<0a/H05/H00do6a00LaP03?dlo00?600?4a/H05LH;a003a/C600?600<0a/H01lH00`36aP09aP40
0000GMK6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lK4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`0Ae/KFa=K6e/KFa]K6e/KFa]H0
2/@09lKFa]K6e/KFa]K6e/CFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFaP0100002LH00`36aP0KaP03
0<K600o600<oa/H00/H014o6a/@KaP03?dlo00C600?4a/@02/@FaP03a<K600;600<0a/H02<H00`36
aP08aP400000GMK6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6eSoFa]Hoe/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a003?`K403cFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/H100002<H00`36
aP0MaP030<K600o600A?a/Ho1<H00lC6aP0<aP_400C6?dlo1LH00lC6aP0PaP05a<K6aP002/H00`36
aP08aP400000A]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KF?mHoe/KFa/C6e/H;a00<a]K6e/KFa]K6e/KF0cl0@]K6e/KFa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K60<KFa]K6e/KFa]K60<KFa]K6e/KFaP400008aP030<K601o6
00<0a/H01/H00co6aP06aP03ClC400O45lH00cm??`06aP03a<K601o600G4a/K60006aPH02LH10000
037Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF00;400<oa<@0
1/@083o6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K613l0:]K6e/KFa/C6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa0T000o6e/KFaP36e/KFa]K6e/H00@0000S600<0a/H08<H00`34
a003a0?600=?a/H01<H00co6aP06aP03a<K601C600@oCcm?1lH00lC6aP0EaP/000G4a/K6000:aP03
0<K600O60@00001Je/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFaSo6e/KFa]Hoe/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K61Cl05LKFa]K6e/KFa=K6e/KF
a]K6e/KFaP0:000Te/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K60@0000S600<0a/H0
8LH00`36aP05aP03Cco600?600=?a/H02<H00lC6aP0AaP06?dloaSm?2<H00lC6aP0:01W600<0a/H0
2<H00`36aP07aP400000<MK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]H00cl09=Hoe/KFaSo6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFaP<o00C6eSlo2@00>/@0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H10000
2<H00`36aP0SaP0303m?00G600A?a/Ho3LH00lC6aP0;aP8000<oCcl00`000cm?aP0]aP030<K600S6
00<0a/H01lH1000004_Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?`3Fa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/CFa]H02P002<Ho?co6e/KF0Sl0@lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H00@0000S6
00<0a/H08lH00dl0aP07aP03ClK600G620000l@0000:aP03?dlo00G600<oClH0;LH00`36aP08aP03
0<K600O60@00000fe/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
0<KFa]K60P000cl00005000De/KFa]K6e/KFa]K6e/KFa]K6e/H3?`06a]K6e/KF0Sl0@lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H0
0@0000S600<0a/H09<H00co6000400?600<oa/H05lH00cm??`07aP03?do602g600<0a/H02<H00`36
aP07aP400000;mK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o
0240e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00cl02<KFa]K6e/KF0Sl0@lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/H0
0@0000S600<0a/H08LH01TloClI?00W600<oa/H04/H014loCcl9aP03?do602g600<0a/H02LH00`36
aP06aP400000:]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o00oFa]K6
eSoFa]K6e/KFa]H00Sl04<KFa]K6e/KFa]K6e/KFa]H3?`0=eSloa]K6e/KFa]K6eP02?`13a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KF
aP0100001lH00`36aP0OaP03?lK600G600<0ClH01<H01DloClI?00g600=??dl00lH00do6aP0:aP03
?do602g600<0a/H02LH00`36aP06aP400000=MK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0eSoF00<o00oFa]K6eSoFa]K6e/KFa]H00cl04mK6e/KF?mK6e/KFa]K6
e/KFa]H00Sl0@lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF
a]K6e/KFa]H0e/KFa]K6e/H00@0000O600<0a/H07/H00do6aP06aP0404loC`W600=?a/H00lH01Dlo
ClI?00G600=?a/H03<H00cm?aP0]aP030<K600W600<0a/H01/H1000002kFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K613l03mK6e/KFa]K6e/KFaSo6eP03?`0Je/KF?mK6
e/KF?mK6e/KFa]K6e/KFa]K6e/H2?`12e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K60@0000O600<0a/H07lH01Cm??dlo00?600<0a/H0
2/H00dloC`05aP03ClK600?600=?a/H03lH00do6C`0/aP030<K600W600<0a/H01/H1000002OFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H01Cl03mK6e/KF0=K6e/KFa]K6eP03?`1T
e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFaP400007aP030<K601_600LoClK6
?dlo00G600<0a/H01<H00dloC`09aP03ClK600?600=?a/H04LH014o6aSl[aP030<K600W600<0a/H0
1/H1000002KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP@o00_F?mK6e/KF0=K6
eP03?`1Ze/KFa]K6e/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFaP400007aP03
0<K601[600E??lK6C`03aP03ClK600;600D0Ccm??`0<aP03ClK600?600=?a/H04lH00do6aP02aP03
?lK602O600<0a/H02LH00`36aP06aP4000009mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP02?`06a]K6eSoF0cl0L=K6?lKFa]K6e/KFa]K6eSoFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]H0e/KFa]K6e/H100001lH00`36aP0LaP03ClI?00?600=??dl00/H00`36?`0<aP03ClK600C6
00<oa/H05<H00do6aP03aP03ClK602K600<0a/H02LH00`36aP06aP400000:MK6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF00<o01;Fa]K6eP0oa]K6e/KFa]K6e/H2?`06e/KFa]K6
0Sl0F]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFaP400007aP030<K601c600E??do6C`06aP03
?lK600O600@oCcm?1/H00co6?`0FaP03ClK600G600=?a/H09LH00`36aP08aP030<K600K60@00000S
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H013l00lKF?`02?`0<e/KFaSo6e/KFa]K6
0cl0IlKF?mK6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF?mK6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H00@0000O600<0a/H0
5/H00dloC`02aP04?dloC`;600Hoa/K6?`04aP03?dlo00C600=?a/H01<H013o6aTlGaP03ClK600K6
00<oa/H09<H00`36aP08aP030<K600K60@00000Te/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K60Sl01]K6e/KFaP<o00?60<H013l0<MK6e/KF?mK6e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6e/KFa]H00Sl0>LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa]K6eP3Fa]K6e/KFaP0100001lH00`36aP0IaP03?lK600C600Q??dloCcm??`;600=?a/H0
0lH00do6aP04aP05?lK6aSl06<H00do6aP06aP03?lHo02C600<0a/H02<H00`36aP06aP400000:=K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/H2?`03e/Ho008o02k60<KF?mK6e/KF
?mK6e/KFaSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0Sl0@lKFa]K6e/KF?mK6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/H00@0000K600<0a/H0
6<H033o6a/HoCco6?dloC`?600<0aTl01LH00do6aP03aP03Cco600C600<oa/H05LH00cm?aP07aP05
?lK6aSl08/H00`36aP09aP030<K600G60@00000Re/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/HoaP<o00G6?cloaP02?`0?e/KFaP0oe/KFa]Hoe/KF00@o00C6e/KF0Sl0GLKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6?lHoa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa]K6e/H0a]K6e/KFaP0100001/H00`36aP0GaP07Cco6?dloC`03aP03Cco600?600=?a/H0
0lH01Do6Ccm?00;600<oa/H00/H00do6C`0GaP03ClI?00W600E?a/K6C`0QaP030<K600W600<0a/H0
1LH10000027Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl01<Ho?mH3?`0;eSoFa]Ho
0<KFa]H00cl08mK6e/Hoa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o04G6?lKFa]K6e/KF
aSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/H0
0@0000K600<0a/H05lH02Do6aSm??do6C`03aP0:Ccm?aP36Ccm??`G600<oa/H00/H014o6aSlGaP05
?lHoCcl02<H00do6aP03aP03ClK601g600<0a/H02LH00`36aP05aP4000008]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`05a]Hoe/H023l0;]Ho?coFa]K6?lKFa]Hoe/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6?lH2?`10e/KFa]K6?lKFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFaP400006aP030<K601S600<oClH00/H014loCcl3aP09
?do60<I??lHo00?600<oa/H00/H01Do6a/I?01O600E?a/K6C`03aP03Ccm?00?600=?a/H01LH00dlo
aP05aP05Ccm??dl04LH00`36aP09aP030<K600G60@00000Pe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H2?`03e/KF00<o00?FaSl00Sl01<KFaP02?`0baSo6e/Hoa]K6eSoFa]K6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6?lKFaSo6e/Hoa]H4?`05a]K6e/H02Sl0:]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/H0a]K6e/KFaP400006aP030<K601O600a?aTloClI?aTloaSl4aP05Cco6aTl0
0/H00co6aP02aP03ClK600;600<oa/H05<H00dloaP03aP04ClK6?`K600I??dloCcl3aP08?lK6aSm?
?dlDaP03?`3600[600<0a/H01LH10000023Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o
00?F?mH00cl01mK6?lKFa]H00Sl09LKFaSo6?lKFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/H0
0Sl04]Hoe/KFaSo6eSoFa]K6e/HoaP<o00[6e/KFaSo6e/KF0cl04MK6e/KFa]K6e/KFa]K6e/KF008o
01G60<KFa]K6e/KFa]K60<KFa]K6e/H00@0000K600<0a/H06LH014loCcl3aP08?lK6aSm??`02aP04
?lHoC`C600<oa/H00/H00do6aP0AaP05Cco6aTl01LH014o6aSl6aP07ClK6?lHoC`03aP03ClK600G6
00=??lH03LH01Do6a/H000_600<0a/H01LH10000023Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP8o00SF?cloe/HoaPDo00C60<KF0cl07=K6e/Hoa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/H2?`0<
e/KF?mK6e/KFaSo60cl03<KFa]K6eSoFaSo6eP8o00_6eSoFa]K6e/HoaP02?`0:e/KFa]K6e/KFaP<o
01O6e/H0a]K6e/KFa]K6e/H0a]K6e/KFaP0100001/H00`36aP0GaP0FClI??do6Ccm??dloClI?aP36
Cco6?`?600<oClH00lH00co6?`0>aP03Cco600C600<oa/H00lH013m?aTl2aP03?dlo00?600@oa/I?
0/H01So6?dloC`K600Hoa/I??dl5aP03Cco600;600@oCcl02lH00`36aP05aP4000008MK6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`03a]Ho00@o00OF?mHoe/H0008o01_6eSoFaSo6?lKF
a]Hoe/Hoa]K6e/KFa]K6e/H00Sl01]K6e/KFaP8o00GFa]K6eP03?`06e/KFa]K60Sl01MHoe/KF008o
00G6e/KFaP02?`0;e/KFa]K6?lKFa]H00Sl03<Ho?mK6e/KFa]K6008o0176e/KFa]K6e/H0a]K6e/KF
aP0100001/H00`36aP0GaP08Ccm??dloCcl2aP03ClI?00?600E??do6C`02aP03?lHo00G600Doa/K6
?`06aP06Ccm??lHo1/H014o6Ccl3aP03?dlo00K600E?aTloC`03aP03ClK600C600<oa/H01<H00do6
aP04aP03?do600S600@0a/Ho2<H00`36aP05aP4000008=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K61Cl02/Hoa]HoeSoFa]H3?`0Fe/HoaSo6eSoFa]K6?lKFa]Hoe/KFaP@o00kFaSo6e/KFa]Ho
e/KFaPDo00W6e/KFa]Hoe/H00Sl06mHoeSoF?mK6e/KFaSo6e/KFa]Hoe/KFa]K6eP03?`0Je/KFa]K6
0<KFa]K6e/KFa]K60<KFa]K6e/H100001LH00`36aP0HaP06Ccm??lHo0/H00do6C`03aP04Ccl0?`;6
00=??lH00/H00co6aP02aP0;ClK6aTo6ClI??dl01<H00co6aP05aP03?lK600?600@oCcm?1/H01Cm?
?lHo00G600<oa/H01LH00co6aP04aP03ClK600O600=??dl00lH00`36aP09aP030<K600G60@00000Q
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o00[6?coF?mHoe/KF0Sl01<H0?mH2?`0=
a]K6?lKFa]K6?lKFaP05?`04a]K6eP8o00_6e/KFa]K6eSoFaP03?`03aSlo00<o00?6e/H00Sl02MK6
eSoFa]K6eP02?`0Ja]K6e/KF?mK6e/KFaSo6e/KFa]K6e/KFa]H2?`0EaP36e/KFa]K6e/KFaP36e/KF
a]K600400005aP030<K601S600E??lHoC`02aP07?do6Ccm??`02aP04Ccm??`?600<oClH00lH02Sm?
?dloCcm?aTl2aP04?do6C`K600`oClI??dloaSo6?dl2aP03?dlo00G600<oa/H00lH00co6?`05aP03
?do600G600<oa/H02LH01Co6?dl000_600<0a/H01<H1000002KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6?lKFaPDo00?6?lH01Cl02LKFaSo6?lKFaP02?`09eSlo?mK6e/KF008o00S6eSoF
a]K6eP8o00O6?coFa]K6008o00CF?co60Sl07]Hoe/KFa]Hoe/KFa]Hoe/Hoa]K6eSoF?mK6e/KFaP<o
01o6e/KFa]K6e/Hoa]H0?lKFa]K6e/KFa]H0e/KFa]K600400005aP030<K601W6018oa/K6?dloaSo6
?dloaSm??dl2aP03?lHo00?600@oClI?0/H01So6a/HoC`C600Hoa/I??dl2aP03?lK600C600I??dlo
Ccl3aP03?lK600?600<oa/H01<H014o6aSl3aP04?lK6C`G600I?a/HoCcl7aP06?lH0aSm?2<H00`36
aP04aP4000008]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lH5?`03aSlo00<o00?6eSl0
0cl06<Hoa]Hoe/HoaSo6e/Hoa]K6?lKFa]K6eP<o00_Fa]K6?lKFa]K6eP02?`0[a]Ho?lKFa]Hoe/KF
a]Hoe/KFa]K6?lKF?mK6eSoFa]Hoe/KFa]Hoe/KFaP03?`0Ia]K6e/Ho0=K6eSoFa]K6e/KF0=K6e/KF
aP0100001LH00`36aP0HaP0<Cco6?dloCco6?dlo0/H01Tlo03o6?`;600I?a/HoaSl4aP03Cco600O6
00=??lH01<H00co6aP04aP08ClI??do6Ccl4aP03ClK600;600<oa/H01<H01Do6a/I?00;600<oa/H0
0/H00do6aP03aP03ClK600C600<oClH00/H00dl0aP0:aP030<K600C60@00000Re/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPDo00K6?lHoa]H2?`0WaP0o?lKFaSo6?lKF?mK6eSoFaSo6e/KF
a]K6e/KFa]K6e/KFa]K6008o03?FaSo6e/HoaSo6e/Hoa]K6eSoFa]K6e/Hoa]K6eSoF?mK6e/KF?mK6
e/KF?mK6e/KF?mH00Sl05LKF0=K6e/KFa]K6e/KF0=K6e/KFaP0100001LH00`36aP0IaP09?dloCco6
?lHo00;600I??lK6Ccl4aP03Cco600;600Doa/K6?`0EaP05?lK6aSl01<H014o6aSl2aP03ClK600;6
00<oa/H01<H00do6aP03aP03Cco600G600=??lH00lH00do6aP03aP07ClK6?dl0C`0:aP030<K600C6
0@00000Qe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o00C6?lKF0Sl00lKFaP02?`07
e/Ho?mK6eP02?`0La]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6eP8o00g6e/KF?mK6e/Hoa]K600<o
00C6e/KF0Sl01LKFa]K6008o00CFa]K61Cl01LKFaSo6008o00kFa]Hoe/KFa]Hoe/KF008o013Fa]K6
e/KFa]H0e/KFa]K60@0000G600<0a/H06LH00co6aP02aP03Cco600;600LoClK6?dlo00?600<oCcl0
0/H01Do6a/I?01?600=?a/H01<H00co6aP02aP07ClK6aTloC`04aP03?lHo00C600=?aTl01<H02Cm?
a/HoCco6?`02aP05Cco6aTl01LH01To6aP36?`W600<0a/H01<H1000002GFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o00?6e/H00cl01lKF?co6?lH00Sl06]K6?coF?mHoe/KFa]K6
e/KFa]K6e/KFa]K60Sl09MK6e/KFaSo6e/KFaSo6eSoFaSo6e/KFaSo6?lKFaSo6eSoFa]H00cl01=K6
e/H3?`03a]K6008o01cF?mK6e/Hoa]H0e/KFa]K6e/KFa]H0e/KFa]K60@0000G600<0a/H07<H00do6
C`02aP03?dlo00;600=?04l00/H00cm??`03aP04?lK6Ca7600A??lHo1/H00do6aP03aP03ClI?00?6
00=??lH00lH00do6C`03aP04ClK6?`C600=??dl00lH01Do6Ccm?00?600=??lH01<H00co6000;aP03
0<K600C60@00000Xe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/HoaP@o00SF?cl0
?lHoaP8o01KFaSo6e/KFa]K6e/KFa]K6e/KFa]K60Sl06=K6?lKFa]K6e/Hoa]K6e/Hoa]K6e/HoaP8o
01_FaSo6eSoFaSo6e/Hoa]K6?lHoa]K6eSoF?mH00Sl00lHo?`08000Be/KFa]K6e/KFa]H0e/KFa]K6
0@0000G600<0a/H06/H04do6aSo6?do6Ccm?aTloaSo6?dl00lH00do6aP0@aP03?lK600;600=?a/H0
1<H00co6aP04aP03ClK600?600M?a/K6Ccm?00?600=?aTl01<H01Co6aTo600h000S6?lHoCco600_6
00<0a/H01<H1000002GFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF00<o00OF?clo
eSoF008o00o6eSloa]Hoe/KFa]K6e/H01Cl01<KFa]H2?`0Ma]K6e/Hoa]K6e/KF?mK6e/KFaSo6e/KF
aSo6e/H00cl00lH0000<000=e/Hoa]K6eSoF?mK6eP02?`0IaSo6e/HoaP36e/KFa]K6e/KF0=K6e/KF
aP0100001<H00`36aP0XaP030<K601?600@oCcm?1/H00co6aP05aP03?lK600C63P001LHoCcm?00C6
00@oClI?0lH00dloaP02aP04?lK6C`;600@oaSm?1LH00`36aP08aP030<K600C60@00001@e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6eSl>000<?lKFa]K6e/Hoa]K60cl02LKF?co6e/HoaP03?`03a]K600<o02?6e/Ho
aSo6eSoF?mHoe/KFaP36e/KFa]K6e/KF0=K6e/KFaP0100001<H00`36aP0XaP030<K601763@06aP03
ClI?00?600=?aTl02lH00do6C`02aP05?dloaSl00/H00do6C`03aP04Ccm??`?600<oCcl01<H00do6
C`04aP030<K600O600<0a/H01<H1000003GFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6eP0>000Z?mK6e/KFa]K6e/Hoa]K6e/KFaSo6eSoF?mK6?lKFa]K6e/KF
a]K6?lKF0Sl02LHo?co6e/HoaP02?`05e/Ho?mH00Sl08LKFaSo6?lKFa]Hoe/KFa]H0e/KFa]K6e/KF
0=K6e/KFaP0100001<H00`36aP0PaPh03<H00co6aP09aP03?do600G600<oa/H00/H01Do6a/I?00_6
00Y?a/K6Ccm??lHo0/H014o6Ccl2aP06ClI??lHo0/H014o6aSl9aP030<K600O600<0a/H01<H10000
01WFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF00h003;6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6?lKF
a]K6e/KFa]K6?lHoa]K6e/KF?mK6eP8o01C6e/Hoa]K6e/KFa]K6e/Hoa]K6eP<o033FaSo6?lHoaSo6
?lHoaSo6?lHoa]Hoe/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/H100001<H00`36aP04aPh05/H00`36
aP0HaP04Cco6?`O600@oa/I?0/H013o6aTlBaP03?lK600C600M?a/HoClI?00;600@oaSm?0lH00do6
aP07aP030<K600O600<0a/H00lH1000000CFa]K61`00?LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00Sl0F=K6eSoFa]K6e/Hoa]Hoe/KF?mK6
?lKFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]H0e/KFa]K6
e/H0a]K6e/H100001/H00`36aP0VaP030<K601G600<oa/H00lH00co6aP03aP04?do6C`C600@oClI?
5<H00co6aP0MaP030<K600K600<0a/H00lH10000057Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6?lKFa]H00Sl02/Ho
?mK6e/Hoa]H2?`13a]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eP3Fa]K6e/KFaP36e/KFaP0100002<H00`36aP0TaP030<K601[600E?a/HoC`02aP03?do600C6
00E?a/HoC`0eaP030<K600G600<0a/H00lH1000000WFa]K6e/KFa]H00P00@LKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K600<o05?6e/KF
?mK6e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H0a]K6e/KFaP36e/KFaP0100002lH00`36aP0QaP030<K601W600<oClH01<H00do6aP05aP06
ClK6aTlo=<H00`36aP05aP030<K600?60@00001Ae/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o00_6e/KF
a]Hoe/KFaP02?`12e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K60<KFa]K60@0000g600<0a/H07lH00`36aP0PaP03ClK600C600<oa/H00/H00dlo
aP0daP030<K600C600<0a/H00lH1000000kFa]K6e/KFa]K6e/KFaP8004kFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6
e/H2?`12e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K60<KFa]K60@00013600<0a/H07<H00`36aP0/aP03ClI?03G600<0a/H00lH00`36aP03aP40
0000X]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFaP40000BaP030<K601[6
00<0a/H0;<H00do6C`0faP030<K600;600<0a/H00lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/H0a]K6e/H100005<H201W600<0a/H0;<H00do6aP0faP030<K600;600<0a/H0
0lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/H100005lH00`36
aP0EaP030<K606K600D0a/K60005aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFaP36e/KFaP40000IaP805<H00`36aP1WaP040<K600G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K60<KFa]K60@0001c600<0a/H03lH00`36aP1YaP040<K600C60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K60@0001k60P0>aP030<K606W6
00@0a/H01<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/H10000
8LH00`36aP0:aP030<K606[600<0aP001<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3F0=K6e/H100008lH200W600<0a/H0JlH200C60@00002Le/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60P001=K6e/H100009/H00`36aP05aP030<K606_60P04aP400000U=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H:0004e/KFaP40000XaP030<K600?600<0a/H0D<HC00k6
0@00000Ye/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P00A<KFaP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
4P008LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000:lH01036aP0]aQ<0<lH10000
04[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaQ8004KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002g60P08aQ<0F<H1000002kFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62@00JlKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP400000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0070777, -0.0382548, 
  0.00559205, 0.00559205}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.04629 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.000397978 1.08767 0.0271918 1.08767 [
[ 0 0 0 0 ]
[ 1 1.04629 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.04629 L
0 1.04629 L
closepath
clip
newpath
p
1 g
.002 w
.85222 .02719 m
.88283 .74139 L
s
.88283 .74139 m
.02719 .80214 L
s
.02719 .80214 m
.0716 .11851 L
s
.0716 .11851 m
.85222 .02719 L
s
.94184 .39331 m
.30808 .45221 L
s
.30808 .45221 m
.29049 1.0191 L
s
.29049 1.0191 m
.97281 .98136 L
s
.97281 .98136 m
.94184 .39331 L
s
.85222 .02719 m
.88283 .74139 L
s
.88283 .74139 m
.97281 .98136 L
s
.97281 .98136 m
.94184 .39331 L
s
.94184 .39331 m
.85222 .02719 L
s
.0716 .11851 m
.30808 .45221 L
s
.30808 .45221 m
.29049 1.0191 L
s
.29049 1.0191 m
.02719 .80214 L
s
.02719 .80214 m
.0716 .11851 L
s
p
.4 g
.8515 .02426 m
.06973 .11587 L
s
P
p
.4 g
.87979 .13982 m
.14384 .22045 L
s
P
p
.4 g
.90471 .24162 m
.20952 .31313 L
s
P
p
.4 g
.92683 .33197 m
.26813 .39584 L
s
P
p
.4 g
.70828 .04403 m
.82594 .40408 L
s
P
p
.4 g
.48233 .07046 m
.64314 .42107 L
s
P
p
.4 g
.2629 .09613 m
.46458 .43766 L
s
P
P
p
1 0 .6 r
.00125 w
.44971 .66901 m
.45972 .68295 L
s
P
p
1 0 .6 r
.00125 w
.4691 .64097 m
.47891 .65527 L
s
P
p
1 0 .6 r
.00125 w
.44971 .66901 m
.43659 .6998 L
s
P
p
1 0 .6 r
.00125 w
.4691 .64097 m
.49626 .63025 L
s
P
p
1 0 .6 r
.00125 w
.42072 .69001 m
.43114 .70377 L
s
P
p
1 0 .6 r
.00125 w
.55627 .69082 m
.53552 .70303 L
s
P
p
1 0 .6 r
.00125 w
.55627 .69082 m
.55948 .72247 L
s
P
p
1 0 .6 r
.00125 w
.58625 .71505 m
.56512 .72705 L
s
P
p
1 0 .6 r
.00125 w
.54297 .66092 m
.52227 .6735 L
s
P
p
1 0 .6 r
.00125 w
.42072 .69001 m
.40774 .72082 L
s
P
p
1 0 .6 r
.00125 w
.58625 .71505 m
.58922 .74661 L
s
P
p
1 0 .6 r
.00177 w
.43829 .65313 m
.44971 .66901 L
s
P
p
1 0 .6 r
.00125 w
.38812 .71363 m
.39899 .7272 L
s
P
p
1 0 .6 r
.00125 w
.61978 .74216 m
.59822 .75391 L
s
P
p
1 0 .6 r
.00125 w
.54297 .66092 m
.51026 .64672 L
s
P
p
1 0 .6 r
.00177 w
.43829 .65313 m
.4691 .64097 L
s
P
p
1 0 .6 r
.00125 w
.61339 .73699 m
.61616 .76846 L
s
P
p
1 0 .6 r
.00125 w
.61978 .74216 m
.6225 .77361 L
s
P
p
1 0 .6 r
.00125 w
.39435 .70912 m
.38149 .73995 L
s
P
p
1 0 .6 r
.00125 w
.38812 .71363 m
.3753 .74446 L
s
P
p
1 0 .6 r
.00177 w
.57985 .67694 m
.55627 .69082 L
s
P
p
1 0 .6 r
.00177 w
.40885 .67432 m
.42072 .69001 L
s
P
p
1 0 .6 r
.00125 w
.64711 .76425 m
.64962 .79561 L
s
P
p
1 0 .6 r
.00177 w
.61026 .70142 m
.58625 .71505 L
s
P
p
1 0 .6 r
.00177 w
.57985 .67694 m
.54297 .66092 L
s
P
p
1 0 .6 r
.00125 w
.61339 .73699 m
.63902 .76991 L
s
P
p
1 0 .6 r
.00125 w
.3614 .73298 m
.34871 .76384 L
s
P
p
1 0 .6 r
.00177 w
.61026 .70142 m
.61339 .73699 L
s
P
p
1 0 .6 r
.00125 w
.39435 .70912 m
.36507 .73932 L
s
P
p
1 0 .6 r
.00177 w
.40885 .67432 m
.39435 .70912 L
s
P
p
1 0 .6 r
.00177 w
.64428 .72881 m
.61978 .74216 L
s
P
p
1 0 .6 r
.00125 w
.65512 .7441 m
.63294 .75596 L
s
P
p
1 0 .6 r
.00177 w
.37572 .69816 m
.38812 .71363 L
s
P
p
1 0 .6 r
.0025 w
.42525 .63498 m
.43829 .65313 L
s
P
p
1 0 .6 r
.00125 w
.64711 .76425 m
.67281 .79727 L
s
P
p
1 0 .6 r
.00125 w
.36284 .71229 m
.37417 .72606 L
s
P
p
1 0 .6 r
.00177 w
.64428 .72881 m
.64711 .76425 L
s
P
p
1 0 .6 r
.00125 w
.65512 .7441 m
.65758 .77588 L
s
P
p
1 0 .6 r
.00125 w
.67601 .76603 m
.6783 .79766 L
s
P
p
1 0 .6 r
.0025 w
.60672 .66113 m
.57985 .67694 L
s
P
p
1 0 .6 r
.00125 w
.68287 .76645 m
.6851 .79814 L
s
P
p
1 0 .6 r
.00125 w
.3614 .73298 m
.33188 .76342 L
s
P
p
1 0 .6 r
.00177 w
.37572 .69816 m
.3614 .73298 L
s
P
p
1 0 .6 r
.00125 w
.36284 .71229 m
.35003 .74356 L
s
P
p
1 0 .6 r
.0025 w
.42525 .63498 m
.40885 .67432 L
s
P
p
1 0 .6 r
.0025 w
.60672 .66113 m
.61026 .70142 L
s
P
p
1 0 .6 r
.00125 w
.34057 .73211 m
.32789 .76332 L
s
P
p
1 0 .6 r
.00125 w
.67601 .76603 m
.70192 .79934 L
s
P
p
1 0 .6 r
.00177 w
.68034 .73062 m
.65512 .7441 L
s
P
p
1 0 .6 r
.0025 w
.64108 .68865 m
.64428 .72881 L
s
P
p
1 0 .6 r
.00177 w
.67342 .73027 m
.67601 .76603 L
s
P
p
1 0 .6 r
.00125 w
.33561 .73191 m
.32294 .7632 L
s
P
p
1 0 .6 r
.00125 w
.69534 .74631 m
.67244 .75829 L
s
P
p
1 0 .6 r
.00125 w
.68287 .76645 m
.70882 .79983 L
s
P
p
1 0 .6 r
.00177 w
.68034 .73062 m
.68287 .76645 L
s
P
p
1 0 .6 r
.0025 w
.39192 .65878 m
.37572 .69816 L
s
P
p
1 0 .6 r
.00177 w
.34993 .69658 m
.36284 .71229 L
s
P
p
1 0 .6 r
.00125 w
.71243 .76827 m
.71444 .80023 L
s
P
p
1 0 .6 r
.00125 w
.69534 .74631 m
.69749 .77847 L
s
P
p
1 0 .6 r
.00353 w
.41028 .61416 m
.42525 .63498 L
s
P
p
1 0 .6 r
.00125 w
.34057 .73211 m
.31068 .76289 L
s
P
p
1 0 .6 r
.00177 w
.35488 .69688 m
.34057 .73211 L
s
P
p
1 0 .6 r
.00125 w
.33392 .71075 m
.34578 .72476 L
s
P
p
1 0 .6 r
.00125 w
.72355 .76895 m
.72548 .80102 L
s
P
p
1 0 .6 r
.00353 w
.63744 .64305 m
.60672 .66113 L
s
P
p
1 0 .6 r
.00125 w
.70248 .76765 m
.72858 .80124 L
s
P
p
1 0 .6 r
.00125 w
.33561 .73191 m
.30564 .76277 L
s
P
p
1 0 .6 r
.00177 w
.34993 .69658 m
.33561 .73191 L
s
P
p
1 0 .6 r
.00125 w
.70248 .76765 m
.73756 .78316 L
s
P
p
1 0 .6 r
.00177 w
.67342 .73027 m
.70248 .76765 L
s
P
p
1 0 .6 r
.0025 w
.64108 .68865 m
.67342 .73027 L
s
P
p
1 0 .6 r
.00353 w
.63744 .64305 m
.64108 .68865 L
s
P
p
1 0 .6 r
.00125 w
.71243 .76827 m
.7386 .80196 L
s
P
p
1 0 .6 r
.00125 w
.33392 .71075 m
.32112 .74252 L
s
P
p
1 0 .6 r
.0025 w
.67747 .69001 m
.68034 .73062 L
s
P
p
1 0 .6 r
.00177 w
.71015 .73211 m
.71243 .76827 L
s
P
p
1 0 .6 r
.0025 w
.39192 .65878 m
.35488 .69688 L
s
P
p
1 0 .6 r
.00353 w
.41028 .61416 m
.39192 .65878 L
s
P
p
1 0 .6 r
.00125 w
.31419 .73101 m
.30153 .76267 L
s
P
p
1 0 .6 r
.00177 w
.72137 .73268 m
.69534 .74631 L
s
P
p
1 0 .6 r
.00125 w
.74592 .77032 m
.74767 .8026 L
s
P
p
1 0 .6 r
.00177 w
.35488 .69688 m
.32141 .73131 L
s
P
p
1 0 .6 r
.00125 w
.72355 .76895 m
.74981 .80276 L
s
P
p
1 0 .6 r
.00177 w
.72137 .73268 m
.72355 .76895 L
s
P
p
1 0 .6 r
.00125 w
.32141 .73131 m
.29118 .76241 L
s
P
p
1 0 .6 r
.00125 w
.32141 .73131 m
.29119 .74357 L
s
P
p
1 0 .6 r
.00125 w
.75388 .77081 m
.75557 .80317 L
s
P
p
1 0 .6 r
.00125 w
.3061 .73067 m
.29345 .76247 L
s
P
p
1 0 .6 r
.0025 w
.36611 .65663 m
.34993 .69658 L
s
P
p
1 0 .6 r
.00177 w
.32039 .69477 m
.33392 .71075 L
s
P
p
1 0 .6 r
.00125 w
.7395 .76993 m
.76587 .8039 L
s
P
p
1 0 .6 r
.00125 w
.31419 .73101 m
.28383 .76223 L
s
P
p
1 0 .6 r
.00177 w
.32849 .69527 m
.31419 .73101 L
s
P
p
1 0 .6 r
.00125 w
.7395 .76993 m
.77527 .78564 L
s
P
p
1 0 .6 r
.00177 w
.71015 .73211 m
.7395 .76993 L
s
P
p
1 0 .6 r
.0025 w
.67747 .69001 m
.71015 .73211 L
s
P
p
1 0 .6 r
.00125 w
.74592 .77032 m
.77234 .80436 L
s
P
p
1 0 .6 r
.00125 w
.33462 .67417 m
.34666 .68886 L
s
P
p
1 0 .6 r
.005 w
.63329 .59113 m
.63744 .64305 L
s
P
p
1 0 .6 r
.00353 w
.67421 .6439 m
.67747 .69001 L
s
P
p
1 0 .6 r
.00177 w
.74394 .73381 m
.74592 .77032 L
s
P
p
1 0 .6 r
.005 w
.43113 .56347 m
.41028 .61416 L
s
P
p
1 0 .6 r
.00125 w
.75388 .77081 m
.78035 .80494 L
s
P
p
1 0 .6 r
.00125 w
.3061 .73067 m
.2756 .76202 L
s
P
p
1 0 .6 r
.00177 w
.32039 .69477 m
.3061 .73067 L
s
P
p
1 0 .6 r
.0025 w
.7189 .69157 m
.72137 .73268 L
s
P
p
1 0 .6 r
.00177 w
.75196 .73421 m
.75388 .77081 L
s
P
p
1 0 .6 r
.00125 w
.2898 .72999 m
.27717 .76206 L
s
P
p
1 0 .6 r
.0025 w
.36611 .65663 m
.32849 .69527 L
s
P
p
1 0 .6 r
.00353 w
.38446 .61134 m
.36611 .65663 L
s
P
p
1 0 .6 r
.00125 w
.78825 .77292 m
.78966 .8056 L
s
P
p
1 0 .6 r
.00125 w
.33462 .67417 m
.32162 .70673 L
s
P
p
1 0 .6 r
.02 w
.57638 .28925 m
.57678 .38095 L
s
P
p
1 g
.05 w
.57638 .28925 Mdot
P
p
1 0 .6 r
.00125 w
.28399 .72975 m
.27136 .76192 L
s
P
p
1 0 .6 r
.00177 w
.32849 .69527 m
.29449 .73019 L
s
P
p
1 0 .6 r
.00125 w
.77357 .77202 m
.80019 .80635 L
s
P
p
1 0 .6 r
.00125 w
.29449 .73019 m
.26377 .76173 L
s
P
p
1 0 .6 r
.00125 w
.29449 .73019 m
.26355 .74261 L
s
P
p
1 0 .6 r
.00125 w
.77357 .77202 m
.80996 .78791 L
s
P
p
1 0 .6 r
.00177 w
.74394 .73381 m
.77357 .77202 L
s
P
p
1 0 .6 r
.0025 w
.71095 .69127 m
.74394 .73381 L
s
P
p
1 0 .6 r
.00125 w
.30636 .69421 m
.29351 .72679 L
s
P
p
1 0 .6 r
.00125 w
.78166 .77252 m
.80834 .80693 L
s
P
p
1 0 .6 r
.0025 w
.33655 .65416 m
.32039 .69477 L
s
P
p
1 0 .6 r
.00125 w
.2898 .72999 m
.25901 .76161 L
s
P
p
1 0 .6 r
.00177 w
.30407 .69377 m
.2898 .72999 L
s
P
p
1 0 .6 r
.0025 w
.71095 .69127 m
.75548 .71022 L
s
P
p
1 0 .6 r
.00353 w
.67421 .6439 m
.71095 .69127 L
s
P
p
1 0 .6 r
.00125 w
.58315 .80535 m
.60175 .83646 L
s
P
p
1 0 .6 r
.00125 w
.78166 .77252 m
.81821 .78845 L
s
P
p
1 0 .6 r
.00177 w
.75196 .73421 m
.78166 .77252 L
s
P
p
1 0 .6 r
.005 w
.63329 .59113 m
.67421 .6439 L
s
P
p
1 0 .6 r
.005 w
.43113 .56347 m
.38446 .61134 L
s
P
p
1 0 .6 r
.00707 w
.45488 .50574 m
.43113 .56347 L
s
P
p
1 0 .6 r
.0025 w
.7189 .69157 m
.75196 .73421 L
s
P
p
1 0 .6 r
.00125 w
.78825 .77292 m
.81497 .8074 L
s
P
p
1 0 .6 r
.00177 w
.32088 .65742 m
.33462 .67417 L
s
P
p
1 0 .6 r
.00125 w
.58315 .80535 m
.62281 .81106 L
s
P
p
1 0 .6 r
.00707 w
.62856 .53183 m
.63329 .59113 L
s
P
p
1 0 .6 r
.00353 w
.71609 .64486 m
.7189 .69157 L
s
P
p
1 0 .6 r
.00177 w
.78664 .73595 m
.78825 .77292 L
s
P
p
1 0 .6 r
.00125 w
.28399 .72975 m
.25309 .76147 L
s
P
p
1 0 .6 r
.00177 w
.29825 .69342 m
.28399 .72975 L
s
P
p
1 0 .6 r
.00125 w
.54736 .81341 m
.56627 .84455 L
s
P
p
1 0 .6 r
.00353 w
.38446 .61134 m
.34224 .65463 L
s
P
p
1 0 .6 r
.00125 w
.54736 .81341 m
.53417 .85187 L
s
P
p
1 0 .6 r
.00125 w
.50736 .82242 m
.52661 .8536 L
s
P
p
1 0 .6 r
.0025 w
.34224 .65463 m
.30407 .69377 L
s
P
p
1 0 .6 r
.0025 w
.34224 .65463 m
.30422 .66918 L
s
P
p
1 0 .6 r
.00125 w
.80314 .74412 m
.80445 .77745 L
s
P
p
1 0 .6 r
.00125 w
.30636 .69421 m
.27537 .726 L
s
P
p
1 0 .6 r
.00177 w
.32088 .65742 m
.30636 .69421 L
s
P
p
1 0 .6 r
.00125 w
.7854 .74884 m
.81228 .78354 L
s
P
p
1 0 .6 r
.00177 w
.56216 .77025 m
.58315 .80535 L
s
P
p
1 0 .6 r
.01414 w
.57678 .38095 m
.57714 .46544 L
s
P
p
1 0 .6 r
.01414 w
.57678 .38095 m
.51283 .44641 L
s
P
p
1 0 .6 r
.00125 w
.7854 .74884 m
.82225 .76472 L
s
P
p
1 0 .6 r
.00177 w
.75548 .71022 m
.7854 .74884 L
s
P
p
1 0 .6 r
.00125 w
.25881 .7287 m
.24621 .7613 L
s
P
p
1 0 .6 r
.00177 w
.30407 .69377 m
.26958 .72915 L
s
P
p
1 0 .6 r
.00125 w
.50736 .82242 m
.49431 .86096 L
s
P
p
1 0 .6 r
.00177 w
.75548 .71022 m
.79625 .72758 L
s
P
p
1 0 .6 r
.0025 w
.33655 .65416 m
.29825 .69342 L
s
P
p
1 0 .6 r
.00353 w
.35488 .6081 m
.33655 .65416 L
s
P
p
1 0 .6 r
.00125 w
.81662 .77467 m
.84355 .80944 L
s
P
p
1 0 .6 r
.00177 w
.56216 .77025 m
.54736 .81341 L
s
P
p
1 0 .6 r
.00125 w
.26958 .72915 m
.23842 .7611 L
s
P
p
1 0 .6 r
.00125 w
.26958 .72915 m
.23798 .74172 L
s
P
p
1 0 .6 r
.00125 w
.81662 .77467 m
.85382 .79078 L
s
P
p
1 0 .6 r
.00177 w
.78664 .73595 m
.81662 .77467 L
s
P
p
1 0 .6 r
.01 w
.51283 .44641 m
.45488 .50574 L
s
P
p
1 0 .6 r
.01 w
.51283 .44641 m
.45757 .46474 L
s
P
p
1 0 .6 r
.00125 w
.28389 .69284 m
.27106 .72581 L
s
P
p
1 0 .6 r
.00177 w
.29825 .69342 m
.26364 .7289 L
s
P
p
1 0 .6 r
.0025 w
.75326 .69286 m
.78664 .73595 L
s
P
p
1 0 .6 r
.0025 w
.75326 .69286 m
.79878 .71207 L
s
P
p
1 0 .6 r
.00353 w
.71609 .64486 m
.75326 .69286 L
s
P
p
1 0 .6 r
.00177 w
.522 .77917 m
.50736 .82242 L
s
P
p
1 0 .6 r
.00125 w
.47306 .80119 m
.4927 .83275 L
s
P
p
1 0 .6 r
.00125 w
.26364 .7289 m
.23238 .76095 L
s
P
p
1 0 .6 r
.00125 w
.26364 .7289 m
.23188 .74151 L
s
P
p
1 0 .6 r
.00125 w
.80314 .74412 m
.83019 .77906 L
s
P
p
1 0 .6 r
.005 w
.67469 .5914 m
.71609 .64486 L
s
P
p
1 0 .6 r
.00707 w
.45488 .50574 m
.40239 .55947 L
s
P
p
1 0 .6 r
.00125 w
.47961 .80525 m
.46661 .8441 L
s
P
p
1 0 .6 r
.00177 w
.80166 .7064 m
.80314 .74412 L
s
P
p
1 0 .6 r
.0025 w
.53845 .73059 m
.56216 .77025 L
s
P
p
1 0 .6 r
.005 w
.67469 .5914 m
.73024 .61407 L
s
P
p
1 0 .6 r
.00707 w
.62856 .53183 m
.67469 .5914 L
s
P
p
1 0 .6 r
.0025 w
.33731 .61578 m
.32088 .65742 L
s
P
p
1 0 .6 r
.00125 w
.47306 .80119 m
.46007 .84011 L
s
P
p
1 0 .6 r
.00125 w
.25881 .7287 m
.22746 .76083 L
s
P
p
1 0 .6 r
.00177 w
.27304 .69188 m
.25881 .7287 L
s
P
p
1 0 .6 r
.01 w
.57714 .46544 m
.62856 .53183 L
s
P
p
1 0 .6 r
.00125 w
.79625 .72758 m
.83353 .74344 L
s
P
p
1 0 .6 r
.00125 w
.79625 .72758 m
.82173 .71464 L
s
P
p
1 0 .6 r
.005 w
.40239 .55947 m
.35488 .6081 L
s
P
p
1 0 .6 r
.005 w
.40239 .55947 m
.35574 .57616 L
s
P
p
1 0 .6 r
.00177 w
.522 .77917 m
.47961 .80525 L
s
P
p
1 0 .6 r
.0025 w
.53845 .73059 m
.522 .77917 L
s
P
p
1 0 .6 r
.01 w
.57714 .46544 m
.57748 .54312 L
s
P
p
1 0 .6 r
.00125 w
.28389 .69284 m
.25249 .72501 L
s
P
p
1 0 .6 r
.00177 w
.29839 .65559 m
.28389 .69284 L
s
P
p
1 0 .6 r
.00177 w
.30422 .66918 m
.26917 .68259 L
s
P
p
1 0 .6 r
.00177 w
.30422 .66918 m
.26936 .70488 L
s
P
p
1 0 .6 r
.00125 w
.47961 .80525 m
.44141 .82875 L
s
P
p
1 0 .6 r
.00353 w
.35488 .6081 m
.3119 .6521 L
s
P
p
1 0 .6 r
.00125 w
.82905 .75121 m
.85625 .78636 L
s
P
p
1 0 .6 r
.00177 w
.48763 .75752 m
.47306 .80119 L
s
P
p
1 0 .6 r
.00125 w
.26936 .70488 m
.23787 .73713 L
s
P
p
1 0 .6 r
.00125 w
.26936 .70488 m
.23742 .71733 L
s
P
p
1 0 .6 r
.00125 w
.2584 .69848 m
.24564 .73175 L
s
P
p
1 0 .6 r
.00125 w
.82905 .75121 m
.86673 .76732 L
s
P
p
1 0 .6 r
.00177 w
.79878 .71207 m
.82905 .75121 L
s
P
p
1 0 .6 r
.00125 w
.4449 .78377 m
.43197 .823 L
s
P
p
1 0 .6 r
.00177 w
.79878 .71207 m
.84046 .72968 L
s
P
p
1 0 .6 r
.0025 w
.3119 .6521 m
.27304 .69188 L
s
P
p
1 0 .6 r
.0025 w
.3119 .6521 m
.27286 .66685 L
s
P
p
1 0 .6 r
.00125 w
.83201 .74563 m
.85927 .78088 L
s
P
p
1 0 .6 r
.00125 w
.83201 .74563 m
.8698 .76174 L
s
P
p
1 0 .6 r
.00177 w
.80166 .7064 m
.83201 .74563 L
s
P
p
1 0 .6 r
.00353 w
.55695 .67594 m
.53845 .73059 L
s
P
p
1 0 .6 r
.00125 w
.2583 .69128 m
.2455 .7247 L
s
P
p
1 0 .6 r
.0025 w
.76787 .66272 m
.80166 .7064 L
s
P
p
1 0 .6 r
.00177 w
.27304 .69188 m
.23792 .72783 L
s
P
p
1 0 .6 r
.0025 w
.33731 .61578 m
.29839 .65559 L
s
P
p
1 0 .6 r
.00353 w
.35595 .56854 m
.33731 .61578 L
s
P
p
1 0 .6 r
.0025 w
.76787 .66272 m
.81411 .6819 L
s
P
p
1 0 .6 r
.00353 w
.73024 .61407 m
.76787 .66272 L
s
P
p
1 0 .6 r
.00177 w
.48763 .75752 m
.4449 .78377 L
s
P
p
1 0 .6 r
.0025 w
.504 .70845 m
.48763 .75752 L
s
P
p
1 0 .6 r
.00125 w
.4449 .78377 m
.4064 .80743 L
s
P
p
1 0 .6 r
.00125 w
.23792 .72783 m
.20619 .76031 L
s
P
p
1 0 .6 r
.00125 w
.23792 .72783 m
.20546 .7406 L
s
P
p
1 0 .6 r
.00353 w
.73024 .61407 m
.78134 .63493 L
s
P
p
1 0 .6 r
.00177 w
.29839 .65559 m
.26321 .69158 L
s
P
p
1 0 .6 r
.00125 w
.41323 .76417 m
.40036 .80376 L
s
P
p
1 0 .6 r
.00707 w
.57748 .54312 m
.57779 .61439 L
s
P
p
1 0 .6 r
.00707 w
.57748 .54312 m
.56156 .57386 L
s
P
p
1 0 .6 r
.00125 w
.2584 .69848 m
.22663 .73099 L
s
P
p
1 0 .6 r
.00177 w
.27281 .6609 m
.2584 .69848 L
s
P
p
1 0 .6 r
.00125 w
.26321 .69158 m
.23144 .72409 L
s
P
p
1 0 .6 r
.00125 w
.26321 .69158 m
.23092 .704 L
s
P
p
1 0 .6 r
.00125 w
.84046 .72968 m
.87858 .74578 L
s
P
p
1 0 .6 r
.00125 w
.84046 .72968 m
.8668 .71659 L
s
P
p
1 0 .6 r
.00125 w
.26917 .68259 m
.23691 .69493 L
s
P
p
1 0 .6 r
.00125 w
.26917 .68259 m
.25559 .66719 L
s
P
p
1 0 .6 r
.00707 w
.45757 .46474 m
.40594 .48186 L
s
P
p
1 0 .6 r
.00707 w
.45757 .46474 m
.40423 .51922 L
s
P
p
1 0 .6 r
.00353 w
.55695 .67594 m
.504 .70845 L
s
P
p
1 0 .6 r
.005 w
.57779 .61439 m
.55695 .67594 L
s
P
p
1 0 .6 r
.0025 w
.504 .70845 m
.45626 .73776 L
s
P
p
1 0 .6 r
.00125 w
.2583 .69128 m
.22643 .72387 L
s
P
p
1 0 .6 r
.00177 w
.27276 .65352 m
.2583 .69128 L
s
P
p
1 0 .6 r
.00177 w
.45626 .73776 m
.41323 .76417 L
s
P
p
1 0 .6 r
.00177 w
.45626 .73776 m
.40974 .73074 L
s
P
p
1 0 .6 r
.00125 w
.41323 .76417 m
.37445 .78798 L
s
P
p
1 0 .6 r
.00125 w
.84476 .72157 m
.87229 .7572 L
s
P
p
1 0 .6 r
.00353 w
.35574 .57616 m
.31246 .59165 L
s
P
p
1 0 .6 r
.00353 w
.35574 .57616 m
.31219 .62066 L
s
P
p
1 0 .6 r
.005 w
.40423 .51922 m
.35595 .56854 L
s
P
p
1 0 .6 r
.005 w
.40423 .51922 m
.35684 .53554 L
s
P
p
1 0 .6 r
.00125 w
.84476 .72157 m
.88305 .73766 L
s
P
p
1 0 .6 r
.00177 w
.81411 .6819 m
.84476 .72157 L
s
P
p
1 0 .6 r
.00177 w
.81411 .6819 m
.85647 .69948 L
s
P
p
1 0 .6 r
.00177 w
.27286 .66685 m
.23684 .68046 L
s
P
p
1 0 .6 r
.00177 w
.27286 .66685 m
.23736 .70314 L
s
P
p
1 0 .6 r
.0025 w
.31219 .62066 m
.27281 .6609 L
s
P
p
1 0 .6 r
.0025 w
.31219 .62066 m
.27263 .6352 L
s
P
p
1 0 .6 r
.00125 w
.69864 .78373 m
.71417 .79694 L
s
P
p
1 0 .6 r
.00353 w
.35595 .56854 m
.31226 .61317 L
s
P
p
1 0 .6 r
.0025 w
.78134 .63493 m
.82825 .65408 L
s
P
p
1 0 .6 r
.0025 w
.78134 .63493 m
.81331 .61723 L
s
P
p
1 0 .6 r
.00125 w
.23736 .70314 m
.20529 .73592 L
s
P
p
1 0 .6 r
.00125 w
.23736 .70314 m
.20454 .71578 L
s
P
p
1 0 .6 r
.00125 w
.25787 .66006 m
.24491 .69418 L
s
P
p
1 0 .6 r
.005 w
.57779 .61439 m
.57807 .67968 L
s
P
p
1 0 .6 r
.00177 w
.27281 .6609 m
.23722 .69727 L
s
P
p
1 0 .6 r
.00125 w
.40974 .73074 m
.36736 .72435 L
s
P
p
1 0 .6 r
.00125 w
.40974 .73074 m
.37074 .75466 L
s
P
p
1 0 .6 r
.0025 w
.31226 .61317 m
.27276 .65352 L
s
P
p
1 0 .6 r
.0025 w
.31226 .61317 m
.27257 .62765 L
s
P
p
1 0 .6 r
.00125 w
.23722 .69727 m
.20507 .73013 L
s
P
p
1 0 .6 r
.00125 w
.23722 .69727 m
.20432 .70988 L
s
P
p
1 0 .6 r
.00177 w
.27276 .65352 m
.23706 .68998 L
s
P
p
1 0 .6 r
.00125 w
.23706 .68998 m
.2048 .72293 L
s
P
p
1 0 .6 r
.00125 w
.23706 .68998 m
.20405 .70256 L
s
P
p
1 0 .6 r
.00125 w
.85647 .69948 m
.89521 .71556 L
s
P
p
1 0 .6 r
.00125 w
.85647 .69948 m
.88334 .68586 L
s
P
p
1 0 .6 r
.00125 w
.85924 .69424 m
.88709 .73031 L
s
P
p
1 0 .6 r
.00125 w
.69864 .78373 m
.73175 .81225 L
s
P
p
1 0 .6 r
.00125 w
.25787 .66006 m
.22558 .69303 L
s
P
p
1 0 .6 r
.00177 w
.27253 .6215 m
.25787 .66006 L
s
P
p
1 0 .6 r
.00125 w
.85924 .69424 m
.8981 .71031 L
s
P
p
1 0 .6 r
.00177 w
.82825 .65408 m
.85924 .69424 L
s
P
p
1 0 .6 r
.00353 w
.57807 .67968 m
.57833 .73938 L
s
P
p
1 0 .6 r
.00353 w
.57807 .67968 m
.62006 .71606 L
s
P
p
1 0 .6 r
.00177 w
.82825 .65408 m
.87123 .67162 L
s
P
p
1 0 .6 r
.00125 w
.23684 .68046 m
.20369 .69298 L
s
P
p
1 0 .6 r
.00125 w
.23684 .68046 m
.2226 .66477 L
s
P
p
1 0 .6 r
.0025 w
.31246 .59165 m
.27241 .60597 L
s
P
p
1 0 .6 r
.0025 w
.31246 .59165 m
.29607 .57073 L
s
P
p
1 0 .6 r
.00125 w
.59524 .83871 m
.57661 .87134 L
s
P
p
1 0 .6 r
.00177 w
.66158 .75182 m
.69864 .78373 L
s
P
p
1 0 .6 r
.005 w
.40594 .48186 m
.35785 .4978 L
s
P
p
1 0 .6 r
.005 w
.40594 .48186 m
.38754 .45365 L
s
P
p
1 0 .6 r
.00177 w
.27263 .6352 m
.23612 .64861 L
s
P
p
1 0 .6 r
.00177 w
.27263 .6352 m
.23665 .67191 L
s
P
p
1 0 .6 r
.00353 w
.35684 .53554 m
.31284 .55068 L
s
P
p
1 0 .6 r
.00353 w
.35684 .53554 m
.31256 .58068 L
s
P
p
1 0 .6 r
.005 w
.56156 .57386 m
.54662 .60272 L
s
P
p
1 0 .6 r
.005 w
.56156 .57386 m
.59945 .58849 L
s
P
p
1 0 .6 r
.00125 w
.23665 .67191 m
.20414 .70508 L
s
P
p
1 0 .6 r
.00125 w
.23665 .67191 m
.20337 .68439 L
s
P
p
1 0 .6 r
.00125 w
.59524 .83871 m
.6101 .87865 L
s
P
p
1 0 .6 r
.00177 w
.81331 .61723 m
.84289 .60086 L
s
P
p
1 0 .6 r
.00177 w
.81331 .61723 m
.85638 .63455 L
s
P
p
1 0 .6 r
.00177 w
.27257 .62765 m
.23594 .64102 L
s
P
p
1 0 .6 r
.00177 w
.27257 .62765 m
.23648 .66447 L
s
P
p
1 0 .6 r
.0025 w
.31256 .58068 m
.27253 .6215 L
s
P
p
1 0 .6 r
.0025 w
.31256 .58068 m
.27233 .59493 L
s
P
p
1 0 .6 r
.00177 w
.66158 .75182 m
.69644 .78203 L
s
P
p
1 0 .6 r
.0025 w
.62006 .71606 m
.66158 .75182 L
s
P
p
1 0 .6 r
.00125 w
.25739 .62437 m
.24423 .65929 L
s
P
p
1 0 .6 r
.0025 w
.57833 .73938 m
.57856 .7939 L
s
P
p
1 0 .6 r
.0025 w
.57833 .73938 m
.54028 .77345 L
s
P
p
1 0 .6 r
.00125 w
.23648 .66447 m
.20387 .69773 L
s
P
p
1 0 .6 r
.00125 w
.23648 .66447 m
.20309 .67691 L
s
P
p
1 0 .6 r
.00177 w
.27253 .6215 m
.23634 .6584 L
s
P
p
1 0 .6 r
.00125 w
.87123 .67162 m
.91055 .68767 L
s
P
p
1 0 .6 r
.00125 w
.87123 .67162 m
.8986 .6575 L
s
P
p
1 0 .6 r
.00177 w
.57856 .7939 m
.59524 .83871 L
s
P
p
1 0 .6 r
.00125 w
.23634 .6584 m
.20364 .69174 L
s
P
p
1 0 .6 r
.00125 w
.23634 .6584 m
.20287 .67081 L
s
P
p
1 0 .6 r
.0025 w
.62006 .71606 m
.6586 .74947 L
s
P
p
1 0 .6 r
.00125 w
.69644 .78203 m
.72997 .8109 L
s
P
p
1 0 .6 r
.00125 w
.85638 .63455 m
.89579 .65039 L
s
P
p
1 0 .6 r
.00125 w
.85638 .63455 m
.88372 .61991 L
s
P
p
1 0 .6 r
.00125 w
.25739 .62437 m
.2246 .65778 L
s
P
p
1 0 .6 r
.00177 w
.27226 .5849 m
.25739 .62437 L
s
P
p
1 0 .6 r
.00125 w
.23612 .64861 m
.2025 .66097 L
s
P
p
1 0 .6 r
.00125 w
.23612 .64861 m
.22167 .63228 L
s
P
p
1 0 .6 r
.00177 w
.57856 .7939 m
.57878 .84361 L
s
P
p
1 0 .6 r
.00125 w
.69644 .78203 m
.72833 .80966 L
s
P
p
1 0 .6 r
.00177 w
.27241 .60597 m
.23545 .6192 L
s
P
p
1 0 .6 r
.00177 w
.27241 .60597 m
.23599 .64308 L
s
P
p
1 0 .6 r
.00177 w
.54028 .77345 m
.50544 .80464 L
s
P
p
1 0 .6 r
.00177 w
.54028 .77345 m
.52816 .78455 L
s
P
p
1 0 .6 r
.00125 w
.23599 .64308 m
.20308 .67661 L
s
P
p
1 0 .6 r
.00125 w
.23599 .64308 m
.2023 .6554 L
s
P
p
1 0 .6 r
.00125 w
.23594 .64102 m
.20222 .65333 L
s
P
p
1 0 .6 r
.00125 w
.23594 .64102 m
.22145 .62452 L
s
P
p
1 0 .6 r
.00177 w
.29607 .57073 m
.28084 .5513 L
s
P
p
1 0 .6 r
.00177 w
.29607 .57073 m
.25927 .58357 L
s
P
p
1 0 .6 r
.0025 w
.31284 .55068 m
.27211 .5647 L
s
P
p
1 0 .6 r
.0025 w
.31284 .55068 m
.29618 .52871 L
s
P
p
1 0 .6 r
.00353 w
.35785 .4978 m
.3132 .51261 L
s
P
p
1 0 .6 r
.00353 w
.35785 .4978 m
.31291 .54354 L
s
P
p
1 0 .6 r
.00125 w
.84289 .60086 m
.87019 .58574 L
s
P
p
1 0 .6 r
.00125 w
.84289 .60086 m
.84185 .56387 L
s
P
p
1 0 .6 r
.00177 w
.27233 .59493 m
.2352 .60808 L
s
P
p
1 0 .6 r
.00177 w
.27233 .59493 m
.23574 .63218 L
s
P
p
1 0 .6 r
.00177 w
.6586 .74947 m
.69393 .78008 L
s
P
p
1 0 .6 r
.00177 w
.6586 .74947 m
.67059 .76006 L
s
P
p
1 0 .6 r
.00125 w
.50544 .80464 m
.4722 .83418 L
s
P
p
1 0 .6 r
.00125 w
.57878 .84361 m
.57897 .88888 L
s
P
p
1 0 .6 r
.00125 w
.57878 .84361 m
.58794 .86624 L
s
P
p
1 0 .6 r
.0025 w
.31291 .54354 m
.27226 .5849 L
s
P
p
1 0 .6 r
.0025 w
.31291 .54354 m
.27206 .5575 L
s
P
p
1 0 .6 r
.00125 w
.23574 .63218 m
.20268 .66584 L
s
P
p
1 0 .6 r
.00125 w
.23574 .63218 m
.20189 .64444 L
s
P
p
1 0 .6 r
.00353 w
.38754 .45365 m
.37031 .42725 L
s
P
p
1 0 .6 r
.00353 w
.38754 .45365 m
.34315 .46785 L
s
P
p
1 0 .6 r
.00353 w
.59945 .58849 m
.63479 .60214 L
s
P
p
1 0 .6 r
.00353 w
.59945 .58849 m
.58647 .61518 L
s
P
p
1 0 .6 r
.00177 w
.27226 .5849 m
.23552 .62228 L
s
P
p
1 0 .6 r
.00353 w
.54662 .60272 m
.53264 .62971 L
s
P
p
1 0 .6 r
.00353 w
.54662 .60272 m
.49284 .62673 L
s
P
p
1 0 .6 r
.00125 w
.50544 .80464 m
.4736 .83315 L
s
P
p
1 0 .6 r
.00125 w
.69393 .78008 m
.72794 .80936 L
s
P
p
1 0 .6 r
.00125 w
.23552 .62228 m
.20232 .65607 L
s
P
p
1 0 .6 r
.00125 w
.23552 .62228 m
.20152 .63448 L
s
P
p
1 0 .6 r
.00125 w
.23545 .6192 m
.2014 .63138 L
s
P
p
1 0 .6 r
.00125 w
.23545 .6192 m
.22081 .60225 L
s
P
p
1 0 .6 r
.00125 w
.69393 .78008 m
.72625 .80808 L
s
P
p
1 0 .6 r
.00125 w
.25927 .58357 m
.22538 .5954 L
s
P
p
1 0 .6 r
.00125 w
.25927 .58357 m
.24491 .56607 L
s
P
p
1 0 .6 r
.00125 w
.2352 .60808 m
.20099 .6202 L
s
P
p
1 0 .6 r
.00125 w
.2352 .60808 m
.22048 .5909 L
s
P
p
1 0 .6 r
.00177 w
.27211 .5647 m
.2345 .57765 L
s
P
p
1 0 .6 r
.00177 w
.27211 .5647 m
.23507 .60236 L
s
P
p
1 0 .6 r
.00125 w
.52816 .78455 m
.51691 .79486 L
s
P
p
1 0 .6 r
.00125 w
.52816 .78455 m
.49623 .81314 L
s
P
p
1 0 .6 r
.00125 w
.39353 .65436 m
.34886 .6594 L
s
P
p
1 0 .6 r
.00125 w
.28084 .5513 m
.26674 .53331 L
s
P
p
1 0 .6 r
.00125 w
.28084 .5513 m
.29467 .51451 L
s
P
p
1 0 .6 r
.0025 w
.49284 .62673 m
.44361 .64871 L
s
P
p
1 0 .6 r
.0025 w
.49284 .62673 m
.47926 .6516 L
s
P
p
1 0 .6 r
.0025 w
.3132 .51261 m
.27184 .52632 L
s
P
p
1 0 .6 r
.0025 w
.3132 .51261 m
.29627 .48964 L
s
P
p
1 0 .6 r
.00125 w
.23507 .60236 m
.20159 .63638 L
s
P
p
1 0 .6 r
.00125 w
.23507 .60236 m
.20077 .61444 L
s
P
p
1 0 .6 r
.00177 w
.27206 .5575 m
.23434 .57039 L
s
P
p
1 0 .6 r
.00177 w
.27206 .5575 m
.2349 .59525 L
s
P
p
1 0 .6 r
.00177 w
.29618 .52871 m
.28069 .5083 L
s
P
p
1 0 .6 r
.00177 w
.29618 .52871 m
.25874 .54126 L
s
P
p
1 0 .6 r
.00125 w
.67059 .76006 m
.68171 .7699 L
s
P
p
1 0 .6 r
.00125 w
.67059 .76006 m
.70297 .78812 L
s
P
p
1 0 .6 r
.00125 w
.2349 .59525 m
.20133 .62937 L
s
P
p
1 0 .6 r
.00125 w
.2349 .59525 m
.20051 .60729 L
s
P
p
1 0 .6 r
.00125 w
.39353 .65436 m
.35292 .67238 L
s
P
p
1 0 .6 r
.00177 w
.44361 .64871 m
.39353 .65436 L
s
P
p
1 0 .6 r
.0025 w
.34315 .46785 m
.30203 .481 L
s
P
p
1 0 .6 r
.0025 w
.34315 .46785 m
.32667 .44401 L
s
P
p
1 0 .6 r
.0025 w
.63479 .60214 m
.66765 .61484 L
s
P
p
1 0 .6 r
.0025 w
.63479 .60214 m
.69191 .59556 L
s
P
p
1 0 .6 r
.0025 w
.37031 .42725 m
.35425 .40262 L
s
P
p
1 0 .6 r
.0025 w
.37031 .42725 m
.3885 .38006 L
s
P
p
1 0 .6 r
.0025 w
.58647 .61518 m
.57437 .64007 L
s
P
p
1 0 .6 r
.0025 w
.58647 .61518 m
.61862 .6281 L
s
P
p
1 0 .6 r
.00177 w
.44361 .64871 m
.39861 .6688 L
s
P
p
1 0 .6 r
.0025 w
.53264 .62971 m
.5196 .65488 L
s
P
p
1 0 .6 r
.0025 w
.53264 .62971 m
.56398 .64288 L
s
P
p
1 0 .6 r
.00125 w
.74385 .58959 m
.78215 .57199 L
s
P
p
1 0 .6 r
.00125 w
.2345 .57765 m
.19985 .58957 L
s
P
p
1 0 .6 r
.00125 w
.2345 .57765 m
.21959 .55982 L
s
P
p
1 0 .6 r
.00177 w
.69191 .59556 m
.74385 .58959 L
s
P
p
1 0 .6 r
.00177 w
.69191 .59556 m
.72242 .60694 L
s
P
p
1 0 .6 r
.00125 w
.23434 .57039 m
.19958 .58228 L
s
P
p
1 0 .6 r
.00125 w
.23434 .57039 m
.21938 .55241 L
s
P
p
1 0 .6 r
.00177 w
.27184 .52632 m
.23363 .53899 L
s
P
p
1 0 .6 r
.00177 w
.27184 .52632 m
.2342 .56449 L
s
P
p
1 0 .6 r
.00125 w
.25874 .54126 m
.22424 .55281 L
s
P
p
1 0 .6 r
.00125 w
.25874 .54126 m
.24412 .52285 L
s
P
p
1 0 .6 r
.00125 w
.39861 .6688 m
.35753 .68713 L
s
P
p
1 0 .6 r
.00125 w
.39861 .6688 m
.38616 .68978 L
s
P
p
1 0 .6 r
.00125 w
.2342 .56449 m
.2002 .59898 L
s
P
p
1 0 .6 r
.00125 w
.2342 .56449 m
.19936 .57633 L
s
P
p
1 0 .6 r
.00125 w
.74385 .58959 m
.79101 .58415 L
s
P
p
1 0 .6 r
.00177 w
.47926 .6516 m
.46663 .67472 L
s
P
p
1 0 .6 r
.00177 w
.47926 .6516 m
.43413 .67189 L
s
P
p
1 0 .6 r
.00125 w
.28069 .5083 m
.26633 .48937 L
s
P
p
1 0 .6 r
.00125 w
.28069 .5083 m
.29475 .47049 L
s
P
p
1 0 .6 r
.00177 w
.29627 .48964 m
.28054 .46829 L
s
P
p
1 0 .6 r
.00177 w
.29627 .48964 m
.25824 .50189 L
s
P
p
1 0 .6 r
.00177 w
.30203 .481 m
.26404 .49315 L
s
P
p
1 0 .6 r
.00177 w
.30203 .481 m
.26431 .51923 L
s
P
p
1 0 .6 r
.00177 w
.3885 .38006 m
.4052 .33673 L
s
P
p
1 0 .6 r
.00177 w
.3885 .38006 m
.3742 .35695 L
s
P
p
1 0 .6 r
.00125 w
.26431 .51923 m
.23022 .55378 L
s
P
p
1 0 .6 r
.00125 w
.26431 .51923 m
.22966 .53061 L
s
P
p
1 0 .6 r
.00177 w
.32667 .44401 m
.31135 .42185 L
s
P
p
1 0 .6 r
.00177 w
.32667 .44401 m
.28886 .45574 L
s
P
p
1 0 .6 r
.00177 w
.66765 .61484 m
.69814 .62661 L
s
P
p
1 0 .6 r
.00177 w
.66765 .61484 m
.65789 .63752 L
s
P
p
1 0 .6 r
.00177 w
.61862 .6281 m
.64843 .64008 L
s
P
p
1 0 .6 r
.00177 w
.61862 .6281 m
.60808 .65102 L
s
P
p
1 0 .6 r
.00125 w
.43413 .67189 m
.39293 .69041 L
s
P
p
1 0 .6 r
.00125 w
.43413 .67189 m
.42207 .69311 L
s
P
p
1 0 .6 r
.00177 w
.57437 .64007 m
.56313 .6632 L
s
P
p
1 0 .6 r
.00177 w
.57437 .64007 m
.52959 .66044 L
s
P
p
1 0 .6 r
.00177 w
.35425 .40262 m
.3393 .37972 L
s
P
p
1 0 .6 r
.00177 w
.35425 .40262 m
.31664 .41387 L
s
P
p
1 0 .6 r
.00177 w
.56398 .64288 m
.59305 .65509 L
s
P
p
1 0 .6 r
.00177 w
.56398 .64288 m
.55257 .66606 L
s
P
p
1 0 .6 r
.00125 w
.4052 .33673 m
.43915 .3024 L
s
P
p
1 0 .6 r
.00125 w
.72242 .60694 m
.75063 .61746 L
s
P
p
1 0 .6 r
.00125 w
.72242 .60694 m
.76994 .60153 L
s
P
p
1 0 .6 r
.00125 w
.23363 .53899 m
.19841 .55067 L
s
P
p
1 0 .6 r
.00125 w
.23363 .53899 m
.21846 .52033 L
s
P
p
1 0 .6 r
.00177 w
.5196 .65488 m
.50748 .67828 L
s
P
p
1 0 .6 r
.00177 w
.5196 .65488 m
.47433 .67539 L
s
P
p
1 0 .6 r
.00125 w
.4052 .33673 m
.4205 .29703 L
s
P
p
1 0 .6 r
.00125 w
.25824 .50189 m
.22318 .51318 L
s
P
p
1 0 .6 r
.00125 w
.25824 .50189 m
.24338 .48263 L
s
P
p
1 0 .6 r
.00125 w
.26404 .49315 m
.22902 .50435 L
s
P
p
1 0 .6 r
.00125 w
.26404 .49315 m
.24925 .47375 L
s
P
p
1 0 .6 r
.00125 w
.46663 .67472 m
.45493 .69615 L
s
P
p
1 0 .6 r
.00125 w
.46663 .67472 m
.49167 .68619 L
s
P
p
1 0 .6 r
.00125 w
.52959 .66044 m
.4887 .67903 L
s
P
p
1 0 .6 r
.00125 w
.52959 .66044 m
.51877 .68167 L
s
P
p
1 0 .6 r
.00125 w
.28054 .46829 m
.26595 .44848 L
s
P
p
1 0 .6 r
.00125 w
.28054 .46829 m
.29483 .42953 L
s
P
p
1 0 .6 r
.00125 w
.28886 .45574 m
.25401 .46655 L
s
P
p
1 0 .6 r
.00125 w
.28886 .45574 m
.27437 .43573 L
s
P
p
1 0 .6 r
.00125 w
.3742 .35695 m
.36093 .33553 L
s
P
p
1 0 .6 r
.00125 w
.3742 .35695 m
.38932 .31718 L
s
P
p
1 0 .6 r
.00125 w
.47433 .67539 m
.433 .69412 L
s
P
p
1 0 .6 r
.00125 w
.47433 .67539 m
.46272 .69687 L
s
P
p
1 0 .6 r
.00125 w
.69814 .62661 m
.72633 .6375 L
s
P
p
1 0 .6 r
.00125 w
.69814 .62661 m
.74606 .62123 L
s
P
p
1 0 .6 r
.00125 w
.31135 .42185 m
.29714 .40129 L
s
P
p
1 0 .6 r
.00125 w
.31135 .42185 m
.32597 .38252 L
s
P
p
1 0 .6 r
.00125 w
.31664 .41387 m
.28197 .42423 L
s
P
p
1 0 .6 r
.00125 w
.31664 .41387 m
.3025 .39318 L
s
P
p
1 0 .6 r
.00125 w
.65789 .63752 m
.64884 .65854 L
s
P
p
1 0 .6 r
.00125 w
.65789 .63752 m
.68559 .64856 L
s
P
p
1 0 .6 r
.00125 w
.64843 .64008 m
.67601 .65116 L
s
P
p
1 0 .6 r
.00125 w
.64843 .64008 m
.6962 .63475 L
s
P
p
1 0 .6 r
.00125 w
.60808 .65102 m
.5983 .67226 L
s
P
p
1 0 .6 r
.00125 w
.60808 .65102 m
.63516 .66226 L
s
P
p
1 0 .6 r
.00125 w
.59305 .65509 m
.61994 .66639 L
s
P
p
1 0 .6 r
.00125 w
.59305 .65509 m
.64065 .64982 L
s
P
p
1 0 .6 r
.00125 w
.56313 .6632 m
.5527 .68464 L
s
P
p
1 0 .6 r
.00125 w
.56313 .6632 m
.58965 .67461 L
s
P
p
1 0 .6 r
.00125 w
.55257 .66606 m
.54199 .68755 L
s
P
p
1 0 .6 r
.00125 w
.55257 .66606 m
.57896 .67752 L
s
P
p
1 0 .6 r
.00125 w
.3393 .37972 m
.32544 .35847 L
s
P
p
1 0 .6 r
.00125 w
.3393 .37972 m
.35423 .33986 L
s
P
p
1 0 .6 r
.00125 w
.50748 .67828 m
.49625 .69997 L
s
P
p
1 0 .6 r
.00125 w
.50748 .67828 m
.53331 .68991 L
s
P
p
1 g
.002 w
.85222 .02719 m
.88283 .74139 L
s
.88283 .74139 m
.02719 .80214 L
s
.02719 .80214 m
.0716 .11851 L
s
.0716 .11851 m
.85222 .02719 L
s
.85222 .02719 m
.88283 .74139 L
s
.88283 .74139 m
.97281 .98136 L
s
.97281 .98136 m
.94184 .39331 L
s
.94184 .39331 m
.85222 .02719 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->1.1858,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP400025aPG46<H1000007cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62L@6000Ga]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0007C6
2<@900G600<0a/H05LH1000006cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H7a0T002KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40001SaPO4
2@0GaP805/H1000005_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00K42@008=K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P005]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000D/H6a0T0
4/H00lC6aP0DaP805/H1000004[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPG42@00<]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P005]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
@/H4a0T09<H00lC6aP0DaP030<H001G60@00000ie/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00C42@00G=K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003760l@901;600?4a/H08/H00lC6aP0CaP030<H001G60@00000Xe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP?42@00K]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002360/@902G600?4a/H08/H00lC6aP0BaP030<H001G6
0@00000Ie/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a0090020e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/H100003lH00l@0000701;6
00?4a/H08lH00lC6aP0QaP03a<K601?600<0aP005<H1000000_Fa]K6e/KFa]K6eP05002Be/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0
e/KFa]K6e/KFa]K6e/KFa]K6e/H100002lH00`36aP0NaP03a<K602;600?4a/H08/H00lC6aP0BaP03
0<H001C60@00000;e/KFa]K6e/KFa]H00P00ULKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K60040
000;aP030<H001o600?4a/H08/H00lC6aP0RaP03a<K6017600@0a/H04lH1000008WFa]K6e/KFa]K6
eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6eP02a00G0<C40<KFa]K6e/KFa]K6e/KFa]K6e/H00@0000_600@0a/H08<H00lC6aP0QaP03
a<K6027600?4a/H01/H9a0;600@0a/H04lH1000007OFa]K6e/KFa]K6eP3Fa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP09a00Re/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6
e/KFa]K6e/KFaP40000;aP050<K6aP008<H00lC6aP0QaP03a<K601O62L@00lK4aP0AaP050<K6aP00
4/H1000006GFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6eP09a00de/KFa]K6
e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP40000:aP030<K600C6
00<0a/H07LH00lC6aP0QaP03a<K600C62L@DaP03a<K600o600D0a/K6000BaP400000D]K6e/KFa]K6
e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H:a016e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFaP40000:aP030<K600G600<0a/H07LH00lC6aP0DaPW4
1<H00lC6aP0PaP03a<K600o600<0a/H00/H00`36aP0?aP400000@=K6e/KFa]K6e/H0a]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/H9a01Ia]K6e/KFa]K6e/KF
a]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KF0=K6e/H0
a]K6e/KFa]K6e/KFa]K6e/H00@0000[600<0a/H01lH00`36aP0LaP04a<K6aPW45lH00lC6aP0PaP03
a<K600k600<0a/H00/H00`36aP0?aP400000;]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H9a01[a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KF
a]K6e/H00@0000[600<0a/H02<H00`36aP0=aPW41lH00lC6aP0PaP03a<K6023600?4a/H03LH00`36
aP03aP030<K600k60@00000Le/KFa]K6e/KFaP36e/KFa]K6e/KFaP36e/KFaPW407g6e/KFa]K6e/KF
a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP010000
2/H00`36aP09aP030<C400?46/H00lC6aP0PaP03a<K601o600?4a/H03LH00`36aP03aP030<K600k6
0@00002Re/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K60@0000[600<0a/H0
2lH00`36aP0LaP03a<K6023600?4a/H07lH00lC6aP0<aP030<K600C600<0a/H03LH1000008gFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KF0=H01L@04036e/KFa]K6e/KFa]K6e/H100002/H00`36aP0<aP030<K601c6
00?4a/H08<H00lC6aP0NaP03a<K600G62<@00`36aP03aP030<K600g60@00001je/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H:a00Ne/KFa]K6
e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K60@0000[600<0a/H03/H00`36aP0KaP03a<K6023600?4a/H0
4/H9a0?600?4a/H03<H00`36aP04aP030<K600c60@00001Xe/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/H9a00aa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K60<KFa]K6eP3F
a]K6e/KFa]K6e/KFaP0100002LH00`36aP0@aP030<K601c600?4a/H07LH400W45/H00lC6aP0;aP03
0<K600C600<0a/H03<H1000005GFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00G41P00@]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFaP40
0009aP030<K6017600<0a/H07<H00lC6aP0<aP[41<H801g600?4a/H02lH00`36aP05aP030<K600_6
0@000012e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6a<KFa]K62L@03/KFa]K6e/KFa]K6e/KF2000@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/CFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K600400009aP030<K601?600<0a/H0
5lH9a0;600=?a/H04/H801k600?4a/H02/H00`36aP05aP030<K600_60@00000_e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H02/@08<KFa]K6a<KFa]K6?lKF?mK6e/KF
a]K6e/KFa]K6e/KF2000@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/H0
a]K6e/KFaP36e/KFa]K6e/KFa]K600400009aP030<K601C600<0a/H00lH9a0o600?4a/H00/H013o6
aTlCaPH08<H00lC6aP09aP030<K600K600<0a/H02/H10000027Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H01L@0=MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KF?mHoe/KFa]K6e/KFa]K6
e/KFa]K6e/KF00@004?6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/H0
a]K6e/KFa]H0e/KFa]K6e/KFa]K600400009aP030<K601G600<0a/H06lH01So6aTo6CaO600E??do6
a00OaP03a<K600W600<0a/H01/H00`36aP0:aP400000@]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSo4aP8o01SFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H3?`13a]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K60<KF
a]K6e/KF0=K6e/KFa]K6e/KFaP0100002LH00`36aP0GaP030<K601S600E?a/K4C`0IaP03Ccm?00;6
00?4a/H07LH00lC6aP08aP030<K600;61L@00`36aP09aP400000>MK6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0Qa]K6?lKF?mK6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K600<o02O6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/H0
1/@00`34a002a00Aa]K6e/H0a]K6e/KFa]K6e/H00@0000W600<0a/H06<H00`36aP0BaP05?do6aSl0
0lH00co4aP0HaP03Ccm?00?600?4a/H05/H;a0K600<0a/H01lH00`36aP09aP400000G=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6?lKF?mHoe/Hoa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl04/KFa]K4e/KFa]K6e/KFa]K6eP[402O6e/KFa]K6a<KF
a]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/H00@0000W600<0a/H06/H00`36aP0;aP05ClK6aTl0
0lH01Do6a/I?00;600?4a/H05/H00dloC`04aP03a<K600_44LH00lC6aP07aP030<K600O600<0a/H0
2LH1000005cFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
?lKF?mK6e/Hoa]Hoe/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa0<o1l@0?=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFaP400008aP030<K601c6
00<0a/H02lH00co6?`05aP03?lHo00C600?4a/H02LH;a004aTloC`G600?4a/H07<H00lC6aP06aP03
0<K600S600<0a/H02<H1000004GFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6eSoF?mK6e/KF?mHoe/KFa]H02l@03=K6e/KFa]K6e/KFaP<o04?6e/KFa]K4e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K60040
0008aP030<K601g600<0a/H02LH00do6C`04aP?400=?a<@01L@FaP03Ccm?00K600?4a/H07<H00lC6
aP05aP030<K600S600<0a/H02<H10000033Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/H4a004?lC4?`?40276e/Hoa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0cl0@lKFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]H0e/KFa]K6e/KF
aP36e/KFa]K6e/H00@0000S600<0a/H07lH00`34a003a005aSo6aTl00lH00do6aP02aP03?lK600O6
00?4a/H04LH00cm??`08aP03a<K601_600?4a/H01/H00`36aP03aPH02LH10000033Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H2?`06eSoFa]K60Sl08=K6eSoFa]K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K613l0:mK6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]H02P003lKFa]K60<KFa]K6e/KFaP0100002<H00`36aP0PaP030<K600;600Y?aTlo
aSm??lHo0/H00do6aP09aP03a<K600k600DoCcm??`09aP03a<K601C61`001<@00004aP030<K600S6
00<0a/H01lH10000037Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KF00@o02?6e/KFaSo6?lKFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFaP03?`0IaSloe/KFa]K6e/KF
a=K6e/KFa]K6e/KFaP0:000Te/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K60@0000S6
00<0a/H08/H01P36?dloC`O600=?aTl03<H00lC6aP0;aP03?dlo00;600=??lH02LH00lC6000901W6
00<0a/H02<H00`36aP07aP400000;MK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP02?`0Wa]K6?lKFa]K6e/KF?mK6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K600<o00?6e/H0
0Sl00mH00009000he/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36
e/KFa]K6e/H100002<H00`36aP0SaP0503o6aTl02<H00co6aP0<aP03a<K600S600<oCcl010000dlo
000^aP030<K600S600<0a/H01lH1000004cFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6eSoFa]Hoe/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K42003?`05a]K6e/H00Sl0A=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6
e/KFa]K60@0000S600<0a/H08LH014o6C`03aP03?do600O600<oa/H02`08aP03?dlo00K600=??lH0
;/H00`36aP08aP030<K600O60@00000]e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoF008o00O6?cloaSo600L001Do003Fa]K6e/KFa]K6e/KFa]K6e/H00cl01lKFa]K6e/H0
0Sl0A=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/H0a]K6e/KFa]K60@0000S600<0a/H08<H01So6?dloaP@000<oa/H01<H00dloC`0@aP05?dloCcl0
2<H00dloaP0^aP030<K600W600<0a/H01/H1000002[Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H4?`0;e/KF0=K6e/Hoa]H00cl04=K6?lKFa]K6e/KFa]K6e/H3?`0=aSo6e/KF
a]K6e/KFaP02?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36aP0OaP09?lK6aSo6?lH000?600@oCcm?1/H00co6
aP06aP04Ccm??`?600<oa/H02/H00dloaP0^aP030<K600W600<0a/H01/H1000003;Fa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]HoeSoF00<o00k6e/KFa]K6e/KFaSo6ePHo
01?6e/KFaSo6e/KFa]K6e/KFa]K6008o04CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFaP400007aP030<K601g600<oClH01<H014lo
Ccl>aP03Ccm?00C600<oa/H00lH00co6aP0=aP03?do602g600<0a/H02LH00`36aP06aP400000;=K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK613l03MH0e/KFa]K6e/KFa]H0
0cl0H]K6e/KFaSo6e/KFaSo6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K60@0000O600<0a/H07/H014lo
Ccl2aP04Cco600S600=??dl02<H00co6aP03aP03?lK600o600@oa/I?;<H00`36aP09aP030<K600K6
0@00000Ve/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`03a]Ho00<o00S6?`3F
a]K6eP<o06SFa]K6e/KFa]K6?lKFa]K6?lKFa]K6e/KFa]K6e/KFa]K6eSoFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFaP400007aP03
0<K601_600ToaSm??do6Ccl00lH023o6aTloClI?2/H00co6aP03aP03?lK6017600Doa/K6?`0[aP03
0<K600W600<0a/H01/H1000002CFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`0:
a]K6eSoF?mK6eP<o06kFa]Hoe/KFa]K6e/KFaSo6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6
e/KFaP400007aP030<K601o600ToClK6?lHoC`001<H00do6aP07aP03Cco600G600=?a/H04/H00co6
aP03aP03?lK602O600<0a/H02LH00`36aP06aP4000009]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK60cl01<Hoa]H3?`0=eP3Fa]Hoe/KFa]K6eP04?`06a]K6e/KF0Sl0FLKFa]K6e/KF
a]K6e/KFa]K6e/KF?mK6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
0=K6e/KFa]K6e/KF0=K6e/KFa]K600400007aP030<K601W600loaSo6?lHoCcm?aTloaP000/H00do6
aP03aP03Ccm?00;600<oa/H01<H00do6C`0DaP03?lK600G600<oa/H09/H00`36aP08aP030<K600K6
0@00000We/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF00Po00S6?`3F?mK6eP<o
06SFa]K6?lKFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFaP400007aP030<K601W6
00ToCcm??dloCcl00/H02do6aSm?aTloClI?00C600<oa/H01<H014o6aSlEaP03?lK600G600<oClH0
9/H00`36aP08aP030<K600K60@00000Pe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`03
a]Ho00<o00?6e/H00Sl00mHo?`03?`1^e/KF?mK6e/Hoa]K6e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]H0e/KFa]K6e/H100001lH00`36aP0IaP05?dloaSl01LH01Cm??dlo00C600=?a/H00/H00co6
aP04aP05ClK6aTl05LH00dloaP06aP04?lK6CbG600<0a/H02<H00`36aP06aP400000:]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6?lKFaPDo0176?`3Fa]Hoe/KFaSo6e/KFaP02?`1P
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K60@0000K600<0a/H06/H03cm??lHoCcm?
?do6Cco60002aP03ClK600;600Poa/K6?dloC`C600<oa/H04lH00co6?`08aP04ClK6?ak600=?a/H0
0lH00`36aP08aP030<K600K60@00000Qe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00/o
00gFaSloeP3F?mK6e/KF00@o00O6eSoFa]K6008o01CFa]K6e/KFa]K6e/KFa]K6e/KFaP8o027F?mK6
e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]H00Sl08lKFa]K6e/KFaSo6e/KFaP36e/KFa]K6e/KF
aP36e/KFa]K600400006aP030<K601O600M??dloCcm?00;600DoCcm??`02aP03Ccm?00C600<oCcl0
1<H00do6aP02aP03?do601C600E?aTloC`07aP03ClK600;600<oa/H03LH00cm?aP0:aP03ClK600?6
00<0a/H02LH00`36aP05aP4000008=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K613l01=K6
e/H3?`04aSo6eP@o00?6?cl00cl09/KFa]Hoe/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoF
0Sl06<KFa]K6?lKFa]K6?lKFa]K6e/KFa]K6eP8o00?6?cl00cl02/KFa]K6e/Hoa]H2?`0EaP36e/KF
a]K6e/KFaP36e/KFa]K600400006aP030<K601O600A??lHo0/H00dloC`02aP04?dloC`;600<oCcl0
0/H00dloC`03aP03ClK600;600@oa/I?5<H01Co6a/Ho00?600<oClH00/H00do6aP04aP03?do600C6
00Q??dloCcm??`c600=?aTl00lH00`36aP09aP030<K600G60@00000Te/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K613l00mK6?`02?`08aSlo?`3Fa]H3?`0[e/KF?mK6e/Hoa]Hoe/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]HoeP04?`04a]K6ePTo01CFa]K6e/KFa]K6e/KFa]K6e/KFaP8o
01SFa]K60<KFa]K6e/KFa]K60<KFa]K6e/H100001/H00`36aP0IaP0?Ccm??do6Ccm??dloaSl000?6
00A??lHo0/H00do6aP02aP05?lK6aSl04lH00cm?aP03aP04?lK6C`G600E??dloC`03aP07ClK6?dlo
C`04aP04?dloC`[600<oClH01<H00`36aP09aP030<K600G60@00000Pe/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H<?`07e/HoaP36eP02?`0Pa]HoeSoFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KF
a]H2?`0AaSo6e/KF?mK6?lKFa]K6?lH013l02=K6eSoFa]K61Cl02lKFa]K6e/KFa]K600<o01_6e/KF
a]K60<KFa]K6e/KFa]K60<KFa]K6e/H00@0000K600<0a/H05lH02dloCcm??lHoCcm?00;600Loa/H0
?dlo00;600A?aTlo0lH00cm?aP02aP03ClK600g600=??dl00/H00co6aP03aP04?lHoC`G600A?a/Ho
0/H01Dloa/I?00G600A??dlo2<H00dloC`09aP030<K600W600<0a/H01LH10000023Fa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP@o00CF?co60Sl01=K6?lH5?`03a]Ho00<o00?6e/H00Sl04]K6
e/Hoa]K6e/KFa]K6e/KFaP8o00oFa]K6eSoFa]K6eSoF?mH00cl02]K6eSoFaSo6?lH4?`03e/KF00Ho
00G6e/KFaP02?`03e/KF00<o01[Fa]K6e/H0?mK6e/KFa]K6e/H0a]K6e/KFaP400006aP030<K601O6
019??dloCco6?dloaSm??dloCcl2aP05Ccm?aTl00/H00co6?`03aP03?lHo00[600=??dl01LH00dlo
aP04aP03?do600C600A??lHo0/H00dloaP04aP04?dloC`;600Toa/K6?dloaSl02<H01dloaSm??`00
2lH00`36aP05aP4000008=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl00mHo?`09?`0M
eSloa]HoeSoF?mK6?lKF?mK6eSoFaSo6e/KFa]H01Cl02=K6e/KFaSo60cl02lHo?co6e/KFaSo600<o
00C6eSoF13l03LHo?co6e/Hoa]K6e/H00Sl02]K6e/KFa]K6e/H2?`0Fe/H0a]K6e/KFa]K6e/H0a]K6
e/KFaP400006aP030<K601W600Y??dloCcm??dlo0/H01dlo0<I?aTl00/H00co6?`02aP05ClK6aTl0
0lH024loa/I??dlo0/H00do6aP04aP03?lK600?600<oCcl01LH02co6aTloaSm??dlo00G600<oaSl0
0lH00co6aP04aP03Ccm?00W600=??`002lH00`36aP05aP4000008=K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K62cl02<KF?co603oF0Sl03/KF?co6e/Hoa]K6?lKF1cl02=K6?lHoa]K60Sl01MHo
e/KF00Lo00?Fa]H00cl01=Hoe/H6?`0Ce/KFaSo6e/KF?mK6e/KFa]K6eP03?`09e/KFa]K6e/H0008o
0176e/KFa]K6e/H0a]K6e/KFaP0100001/H00`36aP0GaP0>Ccm??dloaSm??do6Ccl2aP08Ccm?aTo6
Ccl4aP0<Ccm??dloCcm??lHo1<H00dloaP04aP0;?dloCcm?aTloCcl00/H02TloCcm??dloaSl3aP03
?lK600C600=?a/H00lH00do6aP09aP03Cco600G600@0a/Ho2<H00`36aP05aP4000008=K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl00mHo?`05?`04eSloaP@o00?F?cl02Cl02mHoe/KF?mK6
eSoF00<o00GF?mK6eP02?`03aSlo00<o00?6?cl00Sl00mK6eP05?`07eSoF?mK6eP02?`05a]K6e/H0
0Sl04]K6e/KF?mK6e/KFa]K6e/HoaP<o00G6e/H0aP02?`0@e/KFa]K6e/H0a]K6e/KFaP400005aP03
0<K601S601M?aTloCcm??lHoCcm??dloClI??lHoC`03aP09Cco6aTloaSm?00C600<oClH00/H02To6
aSm?aTloaSl3aP0??dloCco6?dloClI?aTlo00G600<oaSl01<H00do6C`05aP03Cco600S600Toa/K6
?do603l02/H00`36aP05aP4000008=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61cl00lHo
?`02?`03eSoF00@o00K6?cloa]H2?`03a]Ho00<o00C6?lKF0Sl01LHoa]K600<o00C6?coF0cl00mK6
eP06?`0OaSo6?lKFa]Hoe/KFa]Hoe/Hoa]K6?lKF?mK6e/HoaP03?`0<a]K6e/KFaSo6e/KF0Sl04`3F
a]K6e/KFa]K60<KFa]K6e/H00@0000G600<0a/H06<H0<4loCcm??dloCcm??dloCcl0aTloClI?aTo6
ClI??do6ClI??do6ClI??lHoCco6?`;600=??dl00lH024loClI??dlo0/H00do6aP02aP03?lK600?6
00Doa/K6?`02aP05ClK6aTl01<H01So6a/HoC`K600<oa/H00lH00`1?aP08aP030<K600G60@00000P
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`04eSloaPTo00?60<H013l00mHoeP03?`03
eSoF00<o00OF?mHoeSoF00@o00O6?coFaSo6008o00?F?cl00cl09mHoeSoFaSo6e/KF?mK6e/KF?mK6
e/HoaSo6e/KF?mK6e/Hoa]K6eP02?`0<a]K6eSoFa]K6?`3F0Sl03lKFa]K6e/H0a]K6e/KFaP010000
1LH00`36aP0HaP0>ClI??lHoCcm??do6Ccl2aP0;03m?aTloClI??dl00/H01Cm??lHo00;600Q??lHo
ClI??`G600Xoa/K6?dloaSm?0/H01So6aTo6C`C600<oa/H00lH00co6aP03aP03?do600C600=??lH0
0/H02Co6a/HoaSm??`02aP06ClI??lH00lH00co6aP05aP030<K600C60@00000Qe/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00do00GF?cloeP03?`0@e/Ho?mK6?lKFaSo6e/HoaP8o00oF?co6
e/KFa]Hoe/Hoa]H013l01/KF?mK6eP8o0136e/KF?mK6e/KF?mK6e/KF1Cl01=K6?lH2?`0:eSoFa]K6
?lKFaP8o01SF?cloeP3Fa]K6e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0IaP0E?dloCcm?aTloCcm?
aTloCco6?dlo00;600E??lK6C`03aP07ClK6?lHoC`09aP04ClI??`;600E?a/HoC`02aP06?lK6aSm?
1<H00cm?aP03aP03?do600C600Q??lK6Cco6?`;600=?aTl01<H00co6aP02aP07Ccm?aTl0C`0:aP03
0<K600C60@00000Qe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00Do00GF?cloeP06?`05
aSlo?lH013l05]HoeSoF?mK6eSoFa]K6e/KFa]K6e/H2?`0=e/KFa]K6?lHoa]HoeP02?`0CaSloe/KF
?mHoe/KF?mHoe/KFaP03?`03a]K600<o00?6eSl00Sl02]K6e/Hoa]K6e/H3?`0C0=Hoe/KFa]K6e/KF
0=K6e/KFaP0100001LH00`36aP0IaP0K?do6ClI??do6ClI??dloClI?aTo6Ccm?aTlo00;600=??lH0
0/H00co6aP09aP03?lHo00K600=?aTl00/H00cm?aP02aP04ClI??`;600=?aTl00lH00do6C`03aP04
ClI??`;600A?aTlo0lH01cm??dloaSl00lH01cm??lH0Ccl02LH00`36aP04aP4000009MK6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mH02Cl00mHo?`03?`03eSlo008o00G6?coFaP02?`0=
e/Hoa]K6e/KFa]K6eP02?`0=aSo6e/KFa]K6?lHoaP03?`06a]K6?lKF0Sl03lHoa]Hoe/Hoa]Hoe/Ho
aP02?`05e/KF?mH00cl00mHo?`04?`0KaSlo?lKF?mH0e/KFa]K6e/KFa]H0e/KFa]K600400005aP03
0<K601[601m?aTloCcm??dloClI??dloaSo6?dloCcm??dloCcm?00[600<oClH00/H00do6aP04aP08
?lK6aSo6?dl4aP06?lK6Ccm?0lH00do6C`03aP03ClI?00;600<oClH00/H024o6ClI??dlo0lH02Cm?
?dloClI?000;aP030<K600C60@00000Qe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00/o
00GFaSlo0007?`04eSloaP<o00?6?cl01Cl07/KFaSo6e/KFaSo6e/KFa]Hoe/KFa]HoeSoFa]HoeP@o
00C6e/KF0Sl01<KFa]H2?`03a]K6008o00SFa]HoeSoFaP<o00C6e/KF0cl05]Ho?`3Fa]K6e/KFa]K6
eP3Fa]K6e/H100001LH00`36aP0IaP0M?lK6Ccm?aTloCcm??do6Ccm??dloCco6?dloaSl00/H00do6
aP04aP03?dlo00G600<oa/H01LH00co6aP03aP03?lHo00?600<oClH00/H01dloaSm??dl00/H013m?
?dl3aP03Cco600;600<oaSl00/H01To6Ccm?aPP02lH00`36aP04aP4000009mK6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eP04?`04aSloeP@o00G6?cloaP02?`04e/HoaP8o00KFa]K6
e/H2?`0De/KFa]K6eSoFa]K6e/HoaSo6e/H2?`03eSoF00@o00?6e/H00cl00lKF?`03?`07a]Ho?lKF
aP02?`h001[Fa]Hoe/Ho0=K6e/KFa]K6e/KF0=K6e/KFaP400005aP030<K601[600M?a/K6Ccm?00;6
00loCcm??dloaSm??dloaSl00lH00co6aP05aP03?lK600O600<oa/H01<H024o6aSo6?lHo0/H01Do6
aSm?00;600DoClI??`0>0003Cco600;600@oCcm?0lH014loCcl2aP05ClK6aP002/H00`36aP04aP40
00009MK6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]H00cl00mK6?`04?`03aSlo008o
00oF?co6eSoFaSo6e/KFa]H00Sl02<KFa]K6e/KF0Sl02/KFa]K6eSoFa]H2?`03a]Ho00h01Cl02LKF
?mHoe/HoaP03?`05a]Hoe/H00cl00lHo?`04?`0FeSoFaP36e/KFa]K6e/KF0=K6e/KFaP400004aP03
0<K601g6019??dloaSm??dloaSm??do6Ccl2aP03ClK600K600<oClH02<H014o6ClH>00G600PoClI?
aTo6C`;600@oClI?0/H06So6?do6ClI?aTloaSm?aTo6Cco6?do6Ccm?0lH00`36aP08aP030<K600C6
0@000013e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFaSo6?`0=000Ce/KFa]Hoe/Hoa]HoeSoFa]K6eP02?`08a]Ho?lHoa]H7?`03eSoF008o
00C6?lKF0cl02=Ho?coF?mK60Sl06=K6?lKFa]H0e/KFa]K6e/KF0=K6e/KFaP400004aP030<K602W6
00<0a/H00/H>00K600Doa/K6?`05aP05?do6Ccl00lH00co6?`06aP07ClK6aTloC`02aP0>?dloClI?
?dloClI??dl2aP0>?dloCcm?aTloClI?aTl6aP030<K600O600<0a/H01<H1000002OFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H03P004/KFa]K6e/KF?mK6eSoFa]K6eP8o00_6e/KF
?mK6e/HoaP02?`06e/KFaSo60Sl02mK6e/KFa]K6e/KF008o00?6eSl013l00mHo?`08?`03aSlo00Do
00?6eSl00Sl06=Hoe/KFa]H0e/KFa]K6e/KF0=K6e/KFaP400004aP030<K601;63P09aP030<K600W6
00=?a/H00/H023o6a/HoClI?1<H01Co6aTlo00;600=?a/H00lH014o6Ccl;aP0M?lHoaSm??dloCcm?
?lHoaSm?aTloaSm??lHoCcl01<H00do6aP05aP030<K600K600<0a/H01<H1000000_Fa]K60<KFa]K6
eP0>001Ca]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6?lKFaSo6eSoFa]K6?lKF
?mK6eSoFa]K6eSoFa]Hoe/KFa]K6e/KFa]Hoe/H00cl01/Ho?mHoeP8o00?6?cl00cl09LKF?co6?lKF
aSo6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/H00@0000C61`0UaP030<K600g600A?aTlo0lH00co6
aP02aP03ClI?00?600=??lH01<H01Co6a/Ho013601I?a/HoCcm??dloaSm?aTloaSm??lHo0lH00co6
aP08aP030<K600K600<0a/H01<H1000004cFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eSoFa]K6?lKFa]K60Sl03mK6?coF?mK6e/KF?mK6
eP05?`0Ke/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF00<o02;F?co6?lKFaSo6e/KFa]K6e/KF0=K6
e/KFa]K60<KFa]K60@0000O600<0a/H09/H00`36aP0CaP03ClK600;600PoaSo6?do6C`G600=?a/H0
0/H00cm?aP02aP03Ccm?017600=?a/H06/H00`36aP06aP030<K600?60@000019e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
eP04?`1EaSo6e/Hoa]K6e/Hoa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFaP0100002LH202G600<0a/H04/H013o6aTl2aP04
?dloC`?600=?a/H00/H00co6?`03aP04?lHoCc?600<0a/H01LH00`36aP03aP400000D]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6?lHoa]Hoe/H2?`0;e/KF?mK6?lKF?mH00Sl0@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K60040000<aP030<K6027600<0a/H0
5lH00dloaP04aP03?lHo00?600@oa/I?0/H01Co6aTlo03?600<0a/H01<H00`36aP03aP400000X]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eSoFa]K6eSoFaSo6?lKFa]HoeSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFaP40000>aP030<K601o600<0a/H0
7/H01So6aTo6C`K600@oaSm?=<H00`36aP04aP030<K600?60@00000?e/KFa]K6e/KFa]K6e/KF0080
04c6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/Hoa]K6eSoFa]K6e/KF0Sl0@lKF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6e/H00@00017600<0a/H07<H00`36aP0MaP03ClK600[6
00DoClK6?`0daP030<K600?600<0a/H00lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]HoeSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/H0a]K6e/H100004lH00`36aP0JaP030<K602[600<oa/H00/H00do6aP0baP030<K600;6
00<0a/H00lH1000001CFa]K6e/KFa]K6e/KFa]K6e/KFaP8008cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaP36e/KFaP40
000FaP030<K601K600<0a/H0:lH00co6aP0gaP030<K600;600<0a/H00lH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/H100006<H00`36aP0DaP030<K606K600D0a/K6
0005aP4000006MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P00QlKFa]K6e/KFa]K6e/KFa]K6e/KF
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFaP010000
6lH00`36aP0AaP030<K606O600@0a/H01LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/H0a]K6e/H100007LH00`36aP0?aP030<K606S600@0a/H01<H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/H100007lH200k600<0a/H0J<H01036aP04aP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFaP40000RaP030<K600[6
00<0a/H0JLH00`360004aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0
e/KFaP40000TaP802LH00`36aP1ZaP801<H1000009cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H20004e/KFaP40000WaP030<K600G600<0a/H0J/H200C60@00002De/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaPX000CFa]K60@0002W600<0a/H00lH00`36aP1?aQ<03/H1000002[Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H20013e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0B000Qa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000/aP040<K602g64P0caP400000B]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K64`00ALKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP010000;/H200S64P1HaP400000;mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00T006[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000001
\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {-0.000370497, -0.0462903, 
  0.00567534, 0.00567534}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.03357 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
0.00655807 1.07553 0.0268882 1.07553 [
[ 0 0 0 0 ]
[ 1 1.03357 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.03357 L
0 1.03357 L
closepath
clip
newpath
p
1 g
.002 w
.8517 .02689 m
.88114 .72344 L
s
.88114 .72344 m
.02689 .78484 L
s
.02689 .78484 m
.06986 .11778 L
s
.06986 .11778 m
.8517 .02689 L
s
.94317 .39493 m
.3086 .45352 L
s
.3086 .45352 m
.29167 1.00668 L
s
.29167 1.00668 m
.97311 .96851 L
s
.97311 .96851 m
.94317 .39493 L
s
.8517 .02689 m
.88114 .72344 L
s
.88114 .72344 m
.97311 .96851 L
s
.97311 .96851 m
.94317 .39493 L
s
.94317 .39493 m
.8517 .02689 L
s
.06986 .11778 m
.3086 .45352 L
s
.3086 .45352 m
.29167 1.00668 L
s
.29167 1.00668 m
.02689 .78484 L
s
.02689 .78484 m
.06986 .11778 L
s
p
.4 g
.85664 .04676 m
.08263 .13573 L
s
P
p
.4 g
.88238 .15031 m
.14939 .22962 L
s
P
p
.4 g
.90533 .24265 m
.20924 .31379 L
s
P
p
.4 g
.92592 .32552 m
.26321 .38968 L
s
P
p
.4 g
.68327 .04647 m
.80754 .40745 L
s
P
p
.4 g
.47605 .07056 m
.63987 .42293 L
s
P
p
.4 g
.27427 .09402 m
.47574 .43809 L
s
P
p
.4 g
.07772 .11687 m
.31504 .45293 L
s
P
P
p
1 0 .6 r
.00088 w
.46447 .6533 m
.47257 .66487 L
s
P
p
1 0 .6 r
.00088 w
.46447 .6533 m
.4868 .64436 L
s
P
p
1 0 .6 r
.00088 w
.4822 .62769 m
.49014 .63953 L
s
P
p
1 0 .6 r
.00088 w
.44314 .66875 m
.45148 .68022 L
s
P
p
1 0 .6 r
.00088 w
.4822 .62769 m
.50444 .61893 L
s
P
p
1 0 .6 r
.00088 w
.43812 .6724 m
.44651 .68384 L
s
P
p
1 0 .6 r
.00088 w
.49823 .60454 m
.52039 .59594 L
s
P
p
1 0 .6 r
.00088 w
.53447 .6717 m
.51757 .68188 L
s
P
p
1 0 .6 r
.00088 w
.43812 .6724 m
.46076 .66326 L
s
P
p
1 0 .6 r
.00088 w
.44314 .66875 m
.43235 .69415 L
s
P
p
1 0 .6 r
.00088 w
.55658 .68958 m
.53945 .69963 L
s
P
p
1 0 .6 r
.00088 w
.41656 .68801 m
.4252 .69936 L
s
P
p
1 0 .6 r
.00088 w
.56178 .69379 m
.5446 .7038 L
s
P
p
1 0 .6 r
.00088 w
.53447 .6717 m
.50771 .65997 L
s
P
p
1 0 .6 r
.00125 w
.45529 .64018 m
.46447 .6533 L
s
P
p
1 0 .6 r
.00088 w
.52224 .64435 m
.50539 .65481 L
s
P
p
1 0 .6 r
.00088 w
.4085 .69385 m
.41723 .70516 L
s
P
p
1 0 .6 r
.00088 w
.55658 .68958 m
.55923 .71567 L
s
P
p
1 0 .6 r
.00088 w
.58401 .71177 m
.5666 .72165 L
s
P
p
1 0 .6 r
.00125 w
.47319 .61426 m
.4822 .62769 L
s
P
p
1 0 .6 r
.00088 w
.56178 .69379 m
.53479 .68189 L
s
P
p
1 0 .6 r
.00088 w
.59231 .71848 m
.57481 .72831 L
s
P
p
1 0 .6 r
.00088 w
.49823 .60454 m
.52191 .5801 L
s
P
p
1 0 .6 r
.00088 w
.4085 .69385 m
.43151 .68449 L
s
P
p
1 0 .6 r
.00088 w
.41656 .68801 m
.40587 .71343 L
s
P
p
1 0 .6 r
.00088 w
.52224 .64435 m
.49545 .63273 L
s
P
p
1 0 .6 r
.00088 w
.58401 .71177 m
.58649 .73779 L
s
P
p
1 0 .6 r
.00125 w
.45529 .64018 m
.44314 .66875 L
s
P
p
1 0 .6 r
.00088 w
.3924 .70552 m
.40131 .71675 L
s
P
p
1 0 .6 r
.00125 w
.47319 .61426 m
.49823 .60454 L
s
P
p
1 0 .6 r
.00088 w
.60884 .73185 m
.59117 .74158 L
s
P
p
1 0 .6 r
.00125 w
.4286 .65941 m
.43812 .6724 L
s
P
p
1 0 .6 r
.00088 w
.61468 .73657 m
.59695 .74627 L
s
P
p
1 0 .6 r
.00088 w
.3867 .70965 m
.39568 .72085 L
s
P
p
1 0 .6 r
.00125 w
.55359 .66018 m
.53447 .6717 L
s
P
p
1 0 .6 r
.00088 w
.59231 .71848 m
.56506 .7064 L
s
P
p
1 0 .6 r
.00088 w
.60884 .73185 m
.61116 .7578 L
s
P
p
1 0 .6 r
.00088 w
.51116 .61957 m
.48434 .60804 L
s
P
p
1 0 .6 r
.00088 w
.61468 .73657 m
.61696 .76251 L
s
P
p
1 0 .6 r
.00088 w
.63967 .75678 m
.62167 .76633 L
s
P
p
1 0 .6 r
.00125 w
.55359 .66018 m
.55658 .68958 L
s
P
p
1 0 .6 r
.00088 w
.3924 .70552 m
.3818 .73095 L
s
P
p
1 0 .6 r
.00125 w
.58123 .68245 m
.56178 .69379 L
s
P
p
1 0 .6 r
.00088 w
.3867 .70965 m
.37612 .73509 L
s
P
p
1 0 .6 r
.00125 w
.54132 .63253 m
.52224 .64435 L
s
P
p
1 0 .6 r
.00125 w
.4286 .65941 m
.41656 .68801 L
s
P
p
1 0 .6 r
.00088 w
.63967 .75678 m
.64179 .78265 L
s
P
p
1 0 .6 r
.00088 w
.36225 .72737 m
.37151 .73844 L
s
P
p
1 0 .6 r
.00125 w
.58123 .68245 m
.58401 .71177 L
s
P
p
1 0 .6 r
.00177 w
.44485 .62526 m
.45529 .64018 L
s
P
p
1 0 .6 r
.00125 w
.3986 .68103 m
.4085 .69385 L
s
P
p
1 0 .6 r
.00125 w
.61212 .70735 m
.59231 .71848 L
s
P
p
1 0 .6 r
.00088 w
.51116 .61957 m
.48997 .59237 L
s
P
p
1 0 .6 r
.00125 w
.54132 .63253 m
.51116 .61957 L
s
P
p
1 0 .6 r
.00088 w
.62424 .72005 m
.60628 .72997 L
s
P
p
1 0 .6 r
.00177 w
.44485 .62526 m
.47319 .61426 L
s
P
p
1 0 .6 r
.00125 w
.60623 .7026 m
.60884 .73185 L
s
P
p
1 0 .6 r
.00088 w
.62987 .73297 m
.63206 .75909 L
s
P
p
1 0 .6 r
.00088 w
.38577 .69244 m
.39483 .7039 L
s
P
p
1 0 .6 r
.00125 w
.61212 .70735 m
.61468 .73657 L
s
P
p
1 0 .6 r
.00088 w
.36225 .72737 m
.35177 .75282 L
s
P
p
1 0 .6 r
.00125 w
.40433 .6769 m
.3924 .70552 L
s
P
p
1 0 .6 r
.00125 w
.3986 .68103 m
.3867 .70965 L
s
P
p
1 0 .6 r
.00177 w
.57529 .64712 m
.55359 .66018 L
s
P
p
1 0 .6 r
.00088 w
.64692 .73834 m
.62872 .74812 L
s
P
p
1 0 .6 r
.00088 w
.38577 .69244 m
.40925 .68298 L
s
P
p
1 0 .6 r
.00088 w
.66601 .75838 m
.64763 .76799 L
s
P
p
1 0 .6 r
.00088 w
.62424 .72005 m
.59653 .70785 L
s
P
p
1 0 .6 r
.00177 w
.41778 .64465 m
.4286 .65941 L
s
P
p
1 0 .6 r
.00088 w
.37737 .70469 m
.36677 .73034 L
s
P
p
1 0 .6 r
.00125 w
.63728 .72763 m
.63967 .75678 L
s
P
p
1 0 .6 r
.00088 w
.66097 .75807 m
.66296 .78411 L
s
P
p
1 0 .6 r
.00088 w
.64692 .73834 m
.64901 .76453 L
s
P
p
1 0 .6 r
.00088 w
.36359 .70844 m
.37291 .71979 L
s
P
p
1 0 .6 r
.00088 w
.67225 .75875 m
.65378 .76838 L
s
P
p
1 0 .6 r
.00088 w
.66601 .75838 m
.66797 .78445 L
s
P
p
1 0 .6 r
.00177 w
.60328 .66959 m
.58123 .68245 L
s
P
p
1 0 .6 r
.00177 w
.57529 .64712 m
.54132 .63253 L
s
P
p
1 0 .6 r
.00088 w
.62987 .73297 m
.65111 .76026 L
s
P
p
1 0 .6 r
.00125 w
.60623 .7026 m
.62987 .73297 L
s
P
p
1 0 .6 r
.00125 w
.37405 .69873 m
.36225 .72737 L
s
P
p
1 0 .6 r
.00088 w
.67225 .75875 m
.67417 .78488 L
s
P
p
1 0 .6 r
.00088 w
.34324 .72656 m
.35278 .73776 L
s
P
p
1 0 .6 r
.00177 w
.60328 .66959 m
.60623 .7026 L
s
P
p
1 0 .6 r
.00125 w
.40433 .6769 m
.37737 .70469 L
s
P
p
1 0 .6 r
.00177 w
.41778 .64465 m
.40433 .6769 L
s
P
p
1 0 .6 r
.00177 w
.63458 .69472 m
.61212 .70735 L
s
P
p
1 0 .6 r
.00088 w
.36359 .70844 m
.35302 .7342 L
s
P
p
1 0 .6 r
.00125 w
.64457 .70882 m
.62424 .72005 L
s
P
p
1 0 .6 r
.00177 w
.38735 .66645 m
.3986 .68103 L
s
P
p
1 0 .6 r
.00088 w
.34688 .72672 m
.33641 .75238 L
s
P
p
1 0 .6 r
.00088 w
.37737 .70469 m
.35304 .72978 L
s
P
p
1 0 .6 r
.00088 w
.66097 .75807 m
.68226 .78543 L
s
P
p
1 0 .6 r
.00088 w
.33872 .72637 m
.34833 .7376 L
s
P
p
1 0 .6 r
.0025 w
.43295 .60824 m
.44485 .62526 L
s
P
p
1 0 .6 r
.00125 w
.63728 .72763 m
.66097 .75807 L
s
P
p
1 0 .6 r
.00125 w
.37549 .67944 m
.38577 .69244 L
s
P
p
1 0 .6 r
.00177 w
.63458 .69472 m
.63728 .72763 L
s
P
p
1 0 .6 r
.00125 w
.64457 .70882 m
.64692 .73834 L
s
P
p
1 0 .6 r
.00088 w
.34324 .72656 m
.33277 .75228 L
s
P
p
1 0 .6 r
.00088 w
.66049 .72183 m
.64201 .73185 L
s
P
p
1 0 .6 r
.00125 w
.66379 .72899 m
.66601 .75838 L
s
P
p
1 0 .6 r
.00088 w
.68766 .75969 m
.68949 .78593 L
s
P
p
1 0 .6 r
.0025 w
.59995 .63227 m
.57529 .64712 L
s
P
p
1 0 .6 r
.00088 w
.69913 .76038 m
.68027 .77008 L
s
P
p
1 0 .6 r
.00088 w
.33872 .72637 m
.32825 .75215 L
s
P
p
1 0 .6 r
.00088 w
.68352 .74034 m
.66479 .75021 L
s
P
p
1 0 .6 r
.00125 w
.67008 .72931 m
.67225 .75875 L
s
P
p
1 0 .6 r
.00088 w
.69399 .76007 m
.69578 .78636 L
s
P
p
1 0 .6 r
.00125 w
.37405 .69873 m
.34688 .72672 L
s
P
p
1 0 .6 r
.00177 w
.38735 .66645 m
.37405 .69873 L
s
P
p
1 0 .6 r
.00088 w
.66049 .72183 m
.63226 .70948 L
s
P
p
1 0 .6 r
.00088 w
.35983 .69084 m
.36928 .70247 L
s
P
p
1 0 .6 r
.00125 w
.37549 .67944 m
.36359 .70844 L
s
P
p
1 0 .6 r
.00088 w
.34688 .72672 m
.32236 .75198 L
s
P
p
1 0 .6 r
.00088 w
.69913 .76038 m
.70089 .78671 L
s
P
p
1 0 .6 r
.0025 w
.43295 .60824 m
.41778 .64465 L
s
P
p
1 0 .6 r
.00088 w
.68352 .74034 m
.68539 .76681 L
s
P
p
1 0 .6 r
.0025 w
.59995 .63227 m
.60328 .66959 L
s
P
p
1 0 .6 r
.00088 w
.70924 .76099 m
.69023 .77072 L
s
P
p
1 0 .6 r
.00088 w
.35983 .69084 m
.38385 .68125 L
s
P
p
1 0 .6 r
.00125 w
.35503 .69762 m
.34324 .72656 L
s
P
p
1 0 .6 r
.00088 w
.68766 .75969 m
.70911 .78728 L
s
P
p
1 0 .6 r
.00088 w
.70924 .76099 m
.71093 .7874 L
s
P
p
1 0 .6 r
.00125 w
.66379 .72899 m
.68766 .75969 L
s
P
p
1 0 .6 r
.00177 w
.66763 .69608 m
.64457 .70882 L
s
P
p
1 0 .6 r
.00088 w
.33722 .70705 m
.34694 .71857 L
s
P
p
1 0 .6 r
.0025 w
.63153 .65751 m
.63458 .69472 L
s
P
p
1 0 .6 r
.00177 w
.6613 .69582 m
.66379 .72899 L
s
P
p
1 0 .6 r
.00088 w
.71207 .76117 m
.71374 .78759 L
s
P
p
1 0 .6 r
.00088 w
.32755 .7259 m
.31709 .75183 L
s
P
p
1 0 .6 r
.00125 w
.35051 .69736 m
.33872 .72637 L
s
P
p
1 0 .6 r
.00088 w
.69399 .76007 m
.71547 .78771 L
s
P
p
1 0 .6 r
.00088 w
.31922 .72555 m
.32913 .73689 L
s
P
p
1 0 .6 r
.00125 w
.68142 .71049 m
.66049 .72183 L
s
P
p
1 0 .6 r
.00125 w
.67008 .72931 m
.69399 .76007 L
s
P
p
1 0 .6 r
.00177 w
.66763 .69608 m
.67008 .72931 L
s
P
p
1 0 .6 r
.0025 w
.40236 .63 m
.38735 .66645 L
s
P
p
1 0 .6 r
.00177 w
.3638 .66465 m
.37549 .67944 L
s
P
p
1 0 .6 r
.00088 w
.32296 .7257 m
.3125 .7517 L
s
P
p
1 0 .6 r
.00125 w
.69714 .73071 m
.69913 .76038 L
s
P
p
1 0 .6 r
.00088 w
.72123 .76172 m
.72285 .78822 L
s
P
p
1 0 .6 r
.00088 w
.72953 .76222 m
.71022 .77199 L
s
P
p
1 0 .6 r
.00125 w
.68142 .71049 m
.68352 .74034 L
s
P
p
1 0 .6 r
.00088 w
.33722 .70705 m
.32666 .73319 L
s
P
p
1 0 .6 r
.00088 w
.31187 .72523 m
.32189 .73663 L
s
P
p
1 0 .6 r
.00353 w
.41934 .58878 m
.43295 .60824 L
s
P
p
1 0 .6 r
.00088 w
.31922 .72555 m
.30876 .75159 L
s
P
p
1 0 .6 r
.00125 w
.35503 .69762 m
.32755 .7259 L
s
P
p
1 0 .6 r
.00177 w
.36832 .665 m
.35503 .69762 L
s
P
p
1 0 .6 r
.00125 w
.34911 .67763 m
.35983 .69084 L
s
P
p
1 0 .6 r
.00088 w
.72953 .76222 m
.7311 .78879 L
s
P
p
1 0 .6 r
.00088 w
.73674 .76266 m
.71733 .77245 L
s
P
p
1 0 .6 r
.00125 w
.70732 .73123 m
.70924 .76099 L
s
P
p
1 0 .6 r
.00088 w
.73148 .76234 m
.73304 .78892 L
s
P
p
1 0 .6 r
.00353 w
.62808 .61533 m
.59995 .63227 L
s
P
p
1 0 .6 r
.00088 w
.71207 .76117 m
.73366 .78896 L
s
P
p
1 0 .6 r
.00088 w
.32755 .7259 m
.30275 .75142 L
s
P
p
1 0 .6 r
.00125 w
.68804 .73024 m
.71207 .76117 L
s
P
p
1 0 .6 r
.00125 w
.35051 .69736 m
.32296 .7257 L
s
P
p
1 0 .6 r
.00177 w
.3638 .66465 m
.35051 .69736 L
s
P
p
1 0 .6 r
.00088 w
.73674 .76266 m
.73827 .78928 L
s
P
p
1 0 .6 r
.00125 w
.68804 .73024 m
.72019 .74428 L
s
P
p
1 0 .6 r
.00177 w
.6613 .69582 m
.68804 .73024 L
s
P
p
1 0 .6 r
.00088 w
.31187 .72523 m
.30142 .75138 L
s
P
p
1 0 .6 r
.0025 w
.63153 .65751 m
.6613 .69582 L
s
P
p
1 0 .6 r
.00088 w
.32296 .7257 m
.29809 .75129 L
s
P
p
1 0 .6 r
.00088 w
.72123 .76172 m
.74288 .7896 L
s
P
p
1 0 .6 r
.00088 w
.36087 .65743 m
.37044 .66957 L
s
P
p
1 0 .6 r
.00353 w
.62808 .61533 m
.63153 .65751 L
s
P
p
1 0 .6 r
.00088 w
.30981 .72515 m
.29936 .75133 L
s
P
p
1 0 .6 r
.00125 w
.69714 .73071 m
.72123 .76172 L
s
P
p
1 0 .6 r
.00125 w
.34911 .67763 m
.33722 .70705 L
s
P
p
1 0 .6 r
.0025 w
.66486 .65848 m
.66763 .69608 L
s
P
p
1 0 .6 r
.00177 w
.6949 .6972 m
.69714 .73071 L
s
P
p
1 0 .6 r
.00088 w
.74615 .76323 m
.74762 .78992 L
s
P
p
1 0 .6 r
.0025 w
.40236 .63 m
.36832 .665 L
s
P
p
1 0 .6 r
.00353 w
.41934 .58878 m
.40236 .63 L
s
P
p
1 0 .6 r
.00125 w
.331 .69622 m
.31922 .72555 L
s
P
p
1 0 .6 r
.00177 w
.70516 .69762 m
.68142 .71049 L
s
P
p
1 0 .6 r
.00088 w
.36087 .65743 m
.38521 .64798 L
s
P
p
1 0 .6 r
.00088 w
.73148 .76234 m
.75319 .7903 L
s
P
p
1 0 .6 r
.00088 w
.29708 .72461 m
.30732 .7361 L
s
P
p
1 0 .6 r
.00125 w
.72776 .73228 m
.72953 .76222 L
s
P
p
1 0 .6 r
.00088 w
.75205 .76359 m
.75348 .79032 L
s
P
p
1 0 .6 r
.00177 w
.36832 .665 m
.33757 .69661 L
s
P
p
1 0 .6 r
.00125 w
.70732 .73123 m
.73148 .76234 L
s
P
p
1 0 .6 r
.00088 w
.30313 .72486 m
.29268 .75114 L
s
P
p
1 0 .6 r
.00088 w
.72019 .74428 m
.74194 .77229 L
s
P
p
1 0 .6 r
.00177 w
.70516 .69762 m
.70732 .73123 L
s
P
p
1 0 .6 r
.00088 w
.33794 .67373 m
.34778 .68575 L
s
P
p
1 0 .6 r
.00088 w
.72019 .74428 m
.74949 .75708 L
s
P
p
1 0 .6 r
.00125 w
.33757 .69661 m
.30981 .72515 L
s
P
p
1 0 .6 r
.00125 w
.33757 .69661 m
.30998 .70759 L
s
P
p
1 0 .6 r
.00125 w
.73502 .73265 m
.73674 .76266 L
s
P
p
1 0 .6 r
.00088 w
.75937 .76403 m
.76075 .79082 L
s
P
p
1 0 .6 r
.00125 w
.32364 .6958 m
.31187 .72523 L
s
P
p
1 0 .6 r
.00088 w
.76786 .76455 m
.74798 .77441 L
s
P
p
1 0 .6 r
.0025 w
.3788 .62772 m
.3638 .66465 L
s
P
p
1 0 .6 r
.00088 w
.29181 .72438 m
.30213 .73591 L
s
P
p
1 0 .6 r
.00088 w
.30981 .72515 m
.28475 .75091 L
s
P
p
1 0 .6 r
.00088 w
.29708 .72461 m
.28663 .75096 L
s
P
p
1 0 .6 r
.00088 w
.74615 .76323 m
.76795 .79132 L
s
P
p
1 0 .6 r
.00177 w
.33691 .6626 m
.34911 .67763 L
s
P
p
1 0 .6 r
.00088 w
.29565 .72455 m
.28521 .75092 L
s
P
p
1 0 .6 r
.00088 w
.76786 .76455 m
.76918 .7914 L
s
P
p
1 0 .6 r
.00125 w
.7219 .73198 m
.74615 .76323 L
s
P
p
1 0 .6 r
.00125 w
.331 .69622 m
.30313 .72486 L
s
P
p
1 0 .6 r
.00177 w
.34427 .66316 m
.331 .69622 L
s
P
p
1 0 .6 r
.00088 w
.33794 .67373 m
.32723 .70044 L
s
P
p
1 0 .6 r
.00125 w
.7219 .73198 m
.75462 .74618 L
s
P
p
1 0 .6 r
.00177 w
.6949 .6972 m
.7219 .73198 L
s
P
p
1 0 .6 r
.00088 w
.75205 .76359 m
.77389 .79173 L
s
P
p
1 0 .6 r
.00088 w
.31222 .69201 m
.32238 .7039 L
s
P
p
1 0 .6 r
.00088 w
.29181 .72438 m
.28137 .75081 L
s
P
p
1 0 .6 r
.0025 w
.66486 .65848 m
.6949 .6972 L
s
P
p
1 0 .6 r
.00125 w
.72776 .73228 m
.75205 .76359 L
s
P
p
1 0 .6 r
.00088 w
.30313 .72486 m
.27797 .75072 L
s
P
p
1 0 .6 r
.00125 w
.35 .64365 m
.36087 .65743 L
s
P
p
1 0 .6 r
.005 w
.62415 .56741 m
.62808 .61533 L
s
P
p
1 0 .6 r
.00353 w
.66172 .61587 m
.66486 .65848 L
s
P
p
1 0 .6 r
.00177 w
.72576 .69847 m
.72776 .73228 L
s
P
p
1 0 .6 r
.00088 w
.77745 .76513 m
.77871 .79206 L
s
P
p
1 0 .6 r
.005 w
.43859 .54204 m
.41934 .58878 L
s
P
p
1 0 .6 r
.00088 w
.75937 .76403 m
.78124 .79223 L
s
P
p
1 0 .6 r
.00125 w
.73502 .73265 m
.75937 .76403 L
s
P
p
1 0 .6 r
.00125 w
.32364 .6958 m
.29565 .72455 L
s
P
p
1 0 .6 r
.00177 w
.33691 .6626 m
.32364 .6958 L
s
P
p
1 0 .6 r
.0025 w
.70272 .6596 m
.70516 .69762 L
s
P
p
1 0 .6 r
.00177 w
.73309 .69877 m
.73502 .73265 L
s
P
p
1 0 .6 r
.00088 w
.78488 .76558 m
.78609 .79256 L
s
P
p
1 0 .6 r
.00125 w
.30883 .69493 m
.29708 .72461 L
s
P
p
1 0 .6 r
.00088 w
.28492 .72409 m
.27449 .75062 L
s
P
p
1 0 .6 r
.00088 w
.31222 .69201 m
.30162 .71874 L
s
P
p
1 0 .6 r
.00088 w
.29565 .72455 m
.27038 .7505 L
s
P
p
1 0 .6 r
.00088 w
.30998 .70759 m
.28471 .71764 L
s
P
p
1 0 .6 r
.00088 w
.30998 .70759 m
.28473 .73352 L
s
P
p
1 0 .6 r
.0025 w
.3788 .62772 m
.34427 .66316 L
s
P
p
1 0 .6 r
.00353 w
.39578 .58593 m
.3788 .62772 L
s
P
p
1 0 .6 r
.00088 w
.59521 .79266 m
.61042 .81827 L
s
P
p
1 0 .6 r
.00125 w
.76637 .73427 m
.76786 .76455 L
s
P
p
1 0 .6 r
.00088 w
.79092 .76594 m
.79209 .79298 L
s
P
p
1 0 .6 r
.00125 w
.35 .64365 m
.33794 .67373 L
s
P
p
1 0 .6 r
.00088 w
.75462 .74618 m
.77657 .77449 L
s
P
p
1 0 .6 r
.00088 w
.2806 .72391 m
.27017 .7505 L
s
P
p
1 0 .6 r
.00088 w
.75462 .74618 m
.78444 .75913 L
s
P
p
1 0 .6 r
.02 w
.57195 .29027 m
.57226 .37452 L
s
P
p
1 g
.05 w
.57195 .29027 Mdot
P
p
1 0 .6 r
.00125 w
.30356 .69463 m
.29181 .72438 L
s
P
p
1 0 .6 r
.00177 w
.34427 .66316 m
.31309 .69518 L
s
P
p
1 0 .6 r
.00088 w
.61453 .76929 m
.62965 .79507 L
s
P
p
1 0 .6 r
.00088 w
.59521 .79266 m
.58423 .82422 L
s
P
p
1 0 .6 r
.00088 w
.78114 .7383 m
.76092 .74851 L
s
P
p
1 0 .6 r
.00088 w
.77745 .76513 m
.79943 .79348 L
s
P
p
1 0 .6 r
.00088 w
.56263 .79998 m
.57807 .82562 L
s
P
p
1 0 .6 r
.00088 w
.26901 .72342 m
.27969 .73509 L
s
P
p
1 0 .6 r
.00088 w
.61453 .76929 m
.64701 .77413 L
s
P
p
1 0 .6 r
.00125 w
.75299 .73358 m
.77745 .76513 L
s
P
p
1 0 .6 r
.00125 w
.31309 .69518 m
.28492 .72409 L
s
P
p
1 0 .6 r
.00125 w
.31309 .69518 m
.2849 .70629 L
s
P
p
1 0 .6 r
.00088 w
.27524 .72368 m
.26482 .75034 L
s
P
p
1 0 .6 r
.00125 w
.75299 .73358 m
.78623 .74793 L
s
P
p
1 0 .6 r
.00177 w
.72576 .69847 m
.75299 .73358 L
s
P
p
1 0 .6 r
.00088 w
.78114 .7383 m
.78239 .76564 L
s
P
p
1 0 .6 r
.00088 w
.78488 .76558 m
.8069 .79399 L
s
P
p
1 0 .6 r
.0025 w
.69546 .65938 m
.72576 .69847 L
s
P
p
1 0 .6 r
.00088 w
.56263 .79998 m
.55174 .83159 L
s
P
p
1 0 .6 r
.00088 w
.28492 .72409 m
.2595 .75019 L
s
P
p
1 0 .6 r
.00125 w
.32417 .66191 m
.31222 .69201 L
s
P
p
1 0 .6 r
.00088 w
.78831 .74386 m
.7895 .77118 L
s
P
p
1 0 .6 r
.00125 w
.76036 .73396 m
.78488 .76558 L
s
P
p
1 0 .6 r
.00088 w
.29187 .69079 m
.30234 .70283 L
s
P
p
1 0 .6 r
.00088 w
.52623 .80817 m
.54193 .83382 L
s
P
p
1 0 .6 r
.0025 w
.3519 .62511 m
.33691 .6626 L
s
P
p
1 0 .6 r
.00125 w
.30883 .69493 m
.2806 .72391 L
s
P
p
1 0 .6 r
.00177 w
.32209 .66147 m
.30883 .69493 L
s
P
p
1 0 .6 r
.0025 w
.69546 .65938 m
.73616 .67655 L
s
P
p
1 0 .6 r
.00353 w
.66172 .61587 m
.69546 .65938 L
s
P
p
1 0 .6 r
.00125 w
.5781 .76386 m
.59521 .79266 L
s
P
p
1 0 .6 r
.00125 w
.76036 .73396 m
.79373 .74834 L
s
P
p
1 0 .6 r
.00177 w
.73309 .69877 m
.76036 .73396 L
s
P
p
1 0 .6 r
.00088 w
.79092 .76594 m
.81298 .79441 L
s
P
p
1 0 .6 r
.005 w
.62415 .56741 m
.66172 .61587 L
s
P
p
1 0 .6 r
.00088 w
.26901 .72342 m
.25859 .75017 L
s
P
p
1 0 .6 r
.005 w
.43859 .54204 m
.39578 .58593 L
s
P
p
1 0 .6 r
.00707 w
.46046 .48893 m
.43859 .54204 L
s
P
p
1 0 .6 r
.0025 w
.70272 .6596 m
.73309 .69877 L
s
P
p
1 0 .6 r
.00088 w
.53316 .80661 m
.52236 .83826 L
s
P
p
1 0 .6 r
.00125 w
.76637 .73427 m
.79092 .76594 L
s
P
p
1 0 .6 r
.00088 w
.2806 .72391 m
.25512 .75007 L
s
P
p
1 0 .6 r
.00177 w
.33764 .62796 m
.35 .64365 L
s
P
p
1 0 .6 r
.00125 w
.5781 .76386 m
.61453 .76929 L
s
P
p
1 0 .6 r
.00088 w
.29577 .69102 m
.28518 .71799 L
s
P
p
1 0 .6 r
.00088 w
.52623 .80817 m
.51545 .83983 L
s
P
p
1 0 .6 r
.00707 w
.61967 .51283 m
.62415 .56741 L
s
P
p
1 0 .6 r
.00353 w
.69995 .61649 m
.70272 .6596 L
s
P
p
1 0 .6 r
.00177 w
.76468 .70007 m
.76637 .73427 L
s
P
p
1 0 .6 r
.00088 w
.81692 .76752 m
.81792 .79475 L
s
P
p
1 0 .6 r
.00125 w
.30356 .69463 m
.27524 .72368 L
s
P
p
1 0 .6 r
.00177 w
.31682 .66107 m
.30356 .69463 L
s
P
p
1 0 .6 r
.00125 w
.54526 .77115 m
.56263 .79998 L
s
P
p
1 0 .6 r
.00353 w
.39578 .58593 m
.35707 .62561 L
s
P
p
1 0 .6 r
.00088 w
.29187 .69079 m
.28128 .71781 L
s
P
p
1 0 .6 r
.00088 w
.78623 .74793 m
.80837 .7765 L
s
P
p
1 0 .6 r
.00088 w
.4966 .81483 m
.4859 .84654 L
s
P
p
1 0 .6 r
.00088 w
.27524 .72368 m
.24968 .74991 L
s
P
p
1 0 .6 r
.00088 w
.26196 .72312 m
.25155 .74997 L
s
P
p
1 0 .6 r
.00088 w
.78623 .74793 m
.81653 .76101 L
s
P
p
1 0 .6 r
.00088 w
.53316 .80661 m
.50208 .82575 L
s
P
p
1 0 .6 r
.00125 w
.54526 .77115 m
.53316 .80661 L
s
P
p
1 0 .6 r
.00125 w
.50857 .7793 m
.52623 .80817 L
s
P
p
1 0 .6 r
.0025 w
.35707 .62561 m
.32209 .66147 L
s
P
p
1 0 .6 r
.0025 w
.35707 .62561 m
.32243 .63867 L
s
P
p
1 0 .6 r
.00125 w
.77974 .70747 m
.78114 .7383 L
s
P
p
1 0 .6 r
.00088 w
.80456 .73953 m
.80565 .76705 L
s
P
p
1 0 .6 r
.00088 w
.78831 .74386 m
.81048 .77249 L
s
P
p
1 0 .6 r
.00088 w
.49513 .78877 m
.51111 .81471 L
s
P
p
1 0 .6 r
.00088 w
.79373 .74834 m
.81592 .77698 L
s
P
p
1 0 .6 r
.00125 w
.32417 .66191 m
.29577 .69102 L
s
P
p
1 0 .6 r
.00177 w
.33764 .62796 m
.32417 .66191 L
s
P
p
1 0 .6 r
.00125 w
.76363 .712 m
.78831 .74386 L
s
P
p
1 0 .6 r
.00177 w
.55882 .73141 m
.5781 .76386 L
s
P
p
1 0 .6 r
.01414 w
.57226 .37452 m
.57254 .45197 L
s
P
p
1 0 .6 r
.01414 w
.57226 .37452 m
.51359 .43456 L
s
P
p
1 0 .6 r
.00088 w
.2849 .70629 m
.25909 .71647 L
s
P
p
1 0 .6 r
.00088 w
.2849 .70629 m
.25929 .73257 L
s
P
p
1 0 .6 r
.00088 w
.79373 .74834 m
.82414 .76146 L
s
P
p
1 0 .6 r
.00125 w
.76363 .712 m
.79725 .72634 L
s
P
p
1 0 .6 r
.00177 w
.73616 .67655 m
.76363 .712 L
s
P
p
1 0 .6 r
.00125 w
.28074 .6933 m
.26901 .72342 L
s
P
p
1 0 .6 r
.00088 w
.2565 .72289 m
.24609 .74981 L
s
P
p
1 0 .6 r
.00177 w
.32209 .66147 m
.2905 .69387 L
s
P
p
1 0 .6 r
.00088 w
.4966 .81483 m
.4654 .83403 L
s
P
p
1 0 .6 r
.00125 w
.50857 .7793 m
.4966 .81483 L
s
P
p
1 0 .6 r
.00088 w
.29577 .69102 m
.27014 .71731 L
s
P
p
1 0 .6 r
.00177 w
.73616 .67655 m
.77337 .69224 L
s
P
p
1 0 .6 r
.00088 w
.49513 .78877 m
.4844 .82072 L
s
P
p
1 0 .6 r
.00088 w
.81692 .76752 m
.83914 .79621 L
s
P
p
1 0 .6 r
.0025 w
.3519 .62511 m
.31682 .66107 L
s
P
p
1 0 .6 r
.00353 w
.36887 .58268 m
.3519 .62511 L
s
P
p
1 0 .6 r
.00088 w
.26879 .69595 m
.2796 .70804 L
s
P
p
1 0 .6 r
.00125 w
.7922 .7356 m
.81692 .76752 L
s
P
p
1 0 .6 r
.00177 w
.55882 .73141 m
.54526 .77115 L
s
P
p
1 0 .6 r
.00088 w
.47122 .79914 m
.46057 .83108 L
s
P
p
1 0 .6 r
.00125 w
.2905 .69387 m
.26196 .72312 L
s
P
p
1 0 .6 r
.00125 w
.2905 .69387 m
.26176 .7051 L
s
P
p
1 0 .6 r
.00088 w
.25205 .7227 m
.24165 .74968 L
s
P
p
1 0 .6 r
.00125 w
.7922 .7356 m
.8261 .75013 L
s
P
p
1 0 .6 r
.00177 w
.76468 .70007 m
.7922 .7356 L
s
P
p
1 0 .6 r
.01 w
.51359 .43456 m
.46046 .48893 L
s
P
p
1 0 .6 r
.01 w
.51359 .43456 m
.46303 .45126 L
s
P
p
1 0 .6 r
.00125 w
.3038 .66036 m
.29187 .69079 L
s
P
p
1 0 .6 r
.00177 w
.31682 .66107 m
.28512 .69356 L
s
P
p
1 0 .6 r
.00088 w
.46523 .79543 m
.45459 .82743 L
s
P
p
1 0 .6 r
.0025 w
.73405 .66052 m
.76468 .70007 L
s
P
p
1 0 .6 r
.00088 w
.26196 .72312 m
.2362 .74953 L
s
P
p
1 0 .6 r
.00088 w
.82827 .74601 m
.8292 .77365 L
s
P
p
1 0 .6 r
.00088 w
.26874 .68941 m
.27958 .7016 L
s
P
p
1 0 .6 r
.0025 w
.73405 .66052 m
.77557 .6779 L
s
P
p
1 0 .6 r
.00353 w
.69995 .61649 m
.73405 .66052 L
s
P
p
1 0 .6 r
.00088 w
.80456 .73953 m
.82687 .76834 L
s
P
p
1 0 .6 r
.00177 w
.522 .73948 m
.50857 .7793 L
s
P
p
1 0 .6 r
.00125 w
.47716 .7596 m
.49513 .78877 L
s
P
p
1 0 .6 r
.00125 w
.28512 .69356 m
.2565 .72289 L
s
P
p
1 0 .6 r
.00125 w
.28512 .69356 m
.25626 .70482 L
s
P
p
1 0 .6 r
.00088 w
.27506 .68978 m
.26449 .71705 L
s
P
p
1 0 .6 r
.00125 w
.77974 .70747 m
.80456 .73953 L
s
P
p
1 0 .6 r
.00088 w
.26879 .69595 m
.25825 .72318 L
s
P
p
1 0 .6 r
.005 w
.66197 .56745 m
.69995 .61649 L
s
P
p
1 0 .6 r
.00707 w
.46046 .48893 m
.41237 .53815 L
s
P
p
1 0 .6 r
.00088 w
.47122 .79914 m
.43985 .81844 L
s
P
p
1 0 .6 r
.00125 w
.48316 .76336 m
.47122 .79914 L
s
P
p
1 0 .6 r
.00088 w
.79725 .72634 m
.81959 .75519 L
s
P
p
1 0 .6 r
.00177 w
.77815 .67264 m
.77974 .70747 L
s
P
p
1 0 .6 r
.00088 w
.83097 .74091 m
.83188 .76864 L
s
P
p
1 0 .6 r
.00088 w
.2565 .72289 m
.23066 .74937 L
s
P
p
1 0 .6 r
.0025 w
.53707 .6948 m
.55882 .73141 L
s
P
p
1 0 .6 r
.00088 w
.79725 .72634 m
.8279 .73941 L
s
P
p
1 0 .6 r
.005 w
.66197 .56745 m
.7127 .58803 L
s
P
p
1 0 .6 r
.00707 w
.61967 .51283 m
.66197 .56745 L
s
P
p
1 0 .6 r
.00088 w
.26172 .70083 m
.25121 .72808 L
s
P
p
1 0 .6 r
.0025 w
.35285 .58961 m
.33764 .62796 L
s
P
p
1 0 .6 r
.00088 w
.46523 .79543 m
.43382 .81475 L
s
P
p
1 0 .6 r
.00125 w
.47716 .7596 m
.46523 .79543 L
s
P
p
1 0 .6 r
.00125 w
.28074 .6933 m
.25205 .7227 L
s
P
p
1 0 .6 r
.00177 w
.29398 .65933 m
.28074 .6933 L
s
P
p
1 0 .6 r
.01 w
.57254 .45197 m
.61967 .51283 L
s
P
p
1 0 .6 r
.00088 w
.26874 .68941 m
.25817 .71676 L
s
P
p
1 0 .6 r
.00125 w
.77337 .69224 m
.80734 .70656 L
s
P
p
1 0 .6 r
.00125 w
.77337 .69224 m
.79643 .68007 L
s
P
p
1 0 .6 r
.005 w
.41237 .53815 m
.36887 .58268 L
s
P
p
1 0 .6 r
.005 w
.41237 .53815 m
.36985 .55321 L
s
P
p
1 0 .6 r
.00088 w
.8261 .75013 m
.84848 .77905 L
s
P
p
1 0 .6 r
.00088 w
.43952 .77954 m
.42892 .81177 L
s
P
p
1 0 .6 r
.00088 w
.25205 .7227 m
.22614 .74924 L
s
P
p
1 0 .6 r
.00088 w
.8261 .75013 m
.85701 .76338 L
s
P
p
1 0 .6 r
.00177 w
.522 .73948 m
.48316 .76336 L
s
P
p
1 0 .6 r
.0025 w
.53707 .6948 m
.522 .73948 L
s
P
p
1 0 .6 r
.01 w
.57254 .45197 m
.5728 .52303 L
s
P
p
1 0 .6 r
.00125 w
.3038 .66036 m
.27506 .68978 L
s
P
p
1 0 .6 r
.00177 w
.31725 .62603 m
.3038 .66036 L
s
P
p
1 0 .6 r
.00177 w
.32243 .63867 m
.29056 .65068 L
s
P
p
1 0 .6 r
.00177 w
.32243 .63867 m
.29053 .67133 L
s
P
p
1 0 .6 r
.00125 w
.48316 .76336 m
.44815 .78487 L
s
P
p
1 0 .6 r
.00088 w
.82827 .74601 m
.85069 .77499 L
s
P
p
1 0 .6 r
.00088 w
.44815 .78487 m
.41662 .80426 L
s
P
p
1 0 .6 r
.00088 w
.44815 .78487 m
.41408 .77998 L
s
P
p
1 0 .6 r
.00353 w
.36887 .58268 m
.32953 .62294 L
s
P
p
1 0 .6 r
.00125 w
.80333 .71378 m
.82827 .74601 L
s
P
p
1 0 .6 r
.00177 w
.49052 .71942 m
.47716 .7596 L
s
P
p
1 0 .6 r
.00088 w
.27506 .68978 m
.24912 .71635 L
s
P
p
1 0 .6 r
.00088 w
.26176 .7051 m
.23544 .71539 L
s
P
p
1 0 .6 r
.00088 w
.26176 .7051 m
.2358 .73169 L
s
P
p
1 0 .6 r
.00125 w
.29053 .67133 m
.26172 .70083 L
s
P
p
1 0 .6 r
.00125 w
.29053 .67133 m
.26152 .68246 L
s
P
p
1 0 .6 r
.00125 w
.28066 .66527 m
.26879 .69595 L
s
P
p
1 0 .6 r
.00125 w
.80333 .71378 m
.83763 .7283 L
s
P
p
1 0 .6 r
.00177 w
.77557 .6779 m
.80333 .71378 L
s
P
p
1 0 .6 r
.00088 w
.23285 .72189 m
.22247 .74914 L
s
P
p
1 0 .6 r
.00088 w
.43952 .77954 m
.40792 .79895 L
s
P
p
1 0 .6 r
.00125 w
.4514 .74344 m
.43952 .77954 L
s
P
p
1 0 .6 r
.00088 w
.83097 .74091 m
.85343 .76995 L
s
P
p
1 0 .6 r
.00177 w
.77557 .6779 m
.81353 .69379 L
s
P
p
1 0 .6 r
.0025 w
.32953 .62294 m
.29398 .65933 L
s
P
p
1 0 .6 r
.0025 w
.32953 .62294 m
.29404 .63616 L
s
P
p
1 0 .6 r
.00088 w
.26172 .70083 m
.23571 .72746 L
s
P
p
1 0 .6 r
.00125 w
.80597 .7086 m
.83097 .74091 L
s
P
p
1 0 .6 r
.00125 w
.80597 .7086 m
.84036 .72312 L
s
P
p
1 0 .6 r
.00177 w
.77815 .67264 m
.80597 .7086 L
s
P
p
1 0 .6 r
.00088 w
.25162 .69498 m
.2411 .72246 L
s
P
p
1 0 .6 r
.00088 w
.25626 .70482 m
.22981 .71514 L
s
P
p
1 0 .6 r
.00088 w
.25626 .70482 m
.23021 .73148 L
s
P
p
1 0 .6 r
.00088 w
.80734 .70656 m
.82986 .73568 L
s
P
p
1 0 .6 r
.00088 w
.41063 .76167 m
.40007 .79416 L
s
P
p
1 0 .6 r
.00353 w
.554 .6446 m
.53707 .6948 L
s
P
p
1 0 .6 r
.00125 w
.28065 .6586 m
.26874 .68941 L
s
P
p
1 0 .6 r
.00088 w
.25604 .68865 m
.24548 .71618 L
s
P
p
1 0 .6 r
.0025 w
.74718 .6326 m
.77815 .67264 L
s
P
p
1 0 .6 r
.00177 w
.29398 .65933 m
.26186 .6922 L
s
P
p
1 0 .6 r
.00088 w
.80734 .70656 m
.83831 .71962 L
s
P
p
1 0 .6 r
.00088 w
.69783 .75517 m
.71051 .76618 L
s
P
p
1 0 .6 r
.00088 w
.84259 .71891 m
.84343 .74706 L
s
P
p
1 0 .6 r
.0025 w
.35285 .58961 m
.31725 .62603 L
s
P
p
1 0 .6 r
.00353 w
.37008 .5462 m
.35285 .58961 L
s
P
p
1 0 .6 r
.0025 w
.74718 .6326 m
.78929 .64995 L
s
P
p
1 0 .6 r
.00353 w
.7127 .58803 m
.74718 .6326 L
s
P
p
1 0 .6 r
.00177 w
.49052 .71942 m
.4514 .74344 L
s
P
p
1 0 .6 r
.0025 w
.50552 .67433 m
.49052 .71942 L
s
P
p
1 0 .6 r
.00088 w
.26852 .66111 m
.27949 .67375 L
s
P
p
1 0 .6 r
.00125 w
.4514 .74344 m
.41615 .76508 L
s
P
p
1 0 .6 r
.00125 w
.26186 .6922 m
.23285 .72189 L
s
P
p
1 0 .6 r
.00125 w
.26186 .6922 m
.23242 .70359 L
s
P
p
1 0 .6 r
.00088 w
.25152 .68838 m
.24097 .71598 L
s
P
p
1 0 .6 r
.00353 w
.7127 .58803 m
.75926 .60692 L
s
P
p
1 0 .6 r
.00088 w
.41615 .76508 m
.38438 .78459 L
s
P
p
1 0 .6 r
.00088 w
.41615 .76508 m
.3817 .76007 L
s
P
p
1 0 .6 r
.00177 w
.31725 .62603 m
.28509 .65893 L
s
P
p
1 0 .6 r
.00088 w
.83763 .7283 m
.86021 .7575 L
s
P
p
1 0 .6 r
.00088 w
.41063 .76167 m
.37883 .7812 L
s
P
p
1 0 .6 r
.00125 w
.42246 .72528 m
.41063 .76167 L
s
P
p
1 0 .6 r
.00088 w
.23285 .72189 m
.20666 .74869 L
s
P
p
1 0 .6 r
.00088 w
.79643 .68007 m
.8176 .6689 L
s
P
p
1 0 .6 r
.00088 w
.79643 .68007 m
.82745 .69301 L
s
P
p
1 0 .6 r
.00707 w
.5728 .52303 m
.57304 .58812 L
s
P
p
1 0 .6 r
.00707 w
.5728 .52303 m
.55815 .55085 L
s
P
p
1 0 .6 r
.00088 w
.83763 .7283 m
.8689 .74154 L
s
P
p
1 0 .6 r
.00125 w
.28066 .66527 m
.25162 .69498 L
s
P
p
1 0 .6 r
.00177 w
.29406 .63066 m
.28066 .66527 L
s
P
p
1 0 .6 r
.00125 w
.28509 .65893 m
.25604 .68865 L
s
P
p
1 0 .6 r
.00125 w
.28509 .65893 m
.25579 .67003 L
s
P
p
1 0 .6 r
.00088 w
.26852 .66111 m
.25782 .68898 L
s
P
p
1 0 .6 r
.00088 w
.84036 .72312 m
.86299 .75239 L
s
P
p
1 0 .6 r
.00125 w
.81353 .69379 m
.84819 .7083 L
s
P
p
1 0 .6 r
.00125 w
.81353 .69379 m
.83729 .68149 L
s
P
p
1 0 .6 r
.00125 w
.29056 .65068 m
.26129 .66171 L
s
P
p
1 0 .6 r
.00125 w
.29056 .65068 m
.27843 .63628 L
s
P
p
1 0 .6 r
.00707 w
.46303 .45126 m
.41595 .4668 L
s
P
p
1 0 .6 r
.00707 w
.46303 .45126 m
.41423 .5011 L
s
P
p
1 0 .6 r
.00353 w
.554 .6446 m
.50552 .67433 L
s
P
p
1 0 .6 r
.005 w
.57304 .58812 m
.554 .6446 L
s
P
p
1 0 .6 r
.00088 w
.25162 .69498 m
.22541 .7218 L
s
P
p
1 0 .6 r
.00088 w
.84036 .72312 m
.87172 .73636 L
s
P
p
1 0 .6 r
.00088 w
.26152 .68246 m
.23493 .69266 L
s
P
p
1 0 .6 r
.00088 w
.26152 .68246 m
.2353 .70928 L
s
P
p
1 0 .6 r
.00088 w
.25604 .68865 m
.22982 .71547 L
s
P
p
1 0 .6 r
.0025 w
.50552 .67433 m
.46183 .70113 L
s
P
p
1 0 .6 r
.00088 w
.23232 .69925 m
.22184 .72692 L
s
P
p
1 0 .6 r
.00125 w
.28065 .6586 m
.25152 .68838 L
s
P
p
1 0 .6 r
.00177 w
.29408 .62384 m
.28065 .6586 L
s
P
p
1 0 .6 r
.00088 w
.84259 .71891 m
.86526 .74824 L
s
P
p
1 0 .6 r
.00177 w
.46183 .70113 m
.42246 .72528 L
s
P
p
1 0 .6 r
.00177 w
.46183 .70113 m
.41932 .69453 L
s
P
p
1 0 .6 r
.00088 w
.69783 .75517 m
.72478 .77844 L
s
P
p
1 0 .6 r
.00125 w
.42246 .72528 m
.38697 .74705 L
s
P
p
1 0 .6 r
.00125 w
.81736 .68627 m
.84259 .71891 L
s
P
p
1 0 .6 r
.00353 w
.36985 .55321 m
.33051 .56715 L
s
P
p
1 0 .6 r
.00353 w
.36985 .55321 m
.33004 .59389 L
s
P
p
1 0 .6 r
.005 w
.41423 .5011 m
.37008 .5462 L
s
P
p
1 0 .6 r
.005 w
.41423 .5011 m
.37109 .51585 L
s
P
p
1 0 .6 r
.00088 w
.38697 .74705 m
.355 .76666 L
s
P
p
1 0 .6 r
.00088 w
.38697 .74705 m
.35218 .74191 L
s
P
p
1 0 .6 r
.00088 w
.25152 .68838 m
.22523 .71526 L
s
P
p
1 0 .6 r
.00125 w
.81736 .68627 m
.85216 .70078 L
s
P
p
1 0 .6 r
.00177 w
.78929 .64995 m
.81736 .68627 L
s
P
p
1 0 .6 r
.00088 w
.23219 .69388 m
.22169 .72164 L
s
P
p
1 0 .6 r
.00177 w
.78929 .64995 m
.8278 .66581 L
s
P
p
1 0 .6 r
.00177 w
.29404 .63616 m
.26138 .64833 L
s
P
p
1 0 .6 r
.00177 w
.29404 .63616 m
.26161 .66931 L
s
P
p
1 0 .6 r
.0025 w
.33004 .59389 m
.29406 .63066 L
s
P
p
1 0 .6 r
.0025 w
.33004 .59389 m
.29412 .60693 L
s
P
p
1 0 .6 r
.00125 w
.68343 .74268 m
.69783 .75517 L
s
P
p
1 0 .6 r
.00353 w
.37008 .5462 m
.33016 .58698 L
s
P
p
1 0 .6 r
.00088 w
.85576 .69396 m
.85651 .72259 L
s
P
p
1 0 .6 r
.00088 w
.23242 .70359 m
.20544 .71402 L
s
P
p
1 0 .6 r
.00088 w
.23242 .70359 m
.20603 .73057 L
s
P
p
1 0 .6 r
.0025 w
.75926 .60692 m
.80192 .62423 L
s
P
p
1 0 .6 r
.0025 w
.75926 .60692 m
.78814 .59046 L
s
P
p
1 0 .6 r
.00088 w
.84819 .7083 m
.87096 .73777 L
s
P
p
1 0 .6 r
.00125 w
.26161 .66931 m
.23232 .69925 L
s
P
p
1 0 .6 r
.00125 w
.26161 .66931 m
.23188 .68059 L
s
P
p
1 0 .6 r
.00125 w
.28056 .62972 m
.26852 .66111 L
s
P
p
1 0 .6 r
.00088 w
.23203 .68721 m
.22151 .71509 L
s
P
p
1 0 .6 r
.005 w
.57304 .58812 m
.57326 .64764 L
s
P
p
1 0 .6 r
.00177 w
.29406 .63066 m
.26155 .66388 L
s
P
p
1 0 .6 r
.00088 w
.84819 .7083 m
.8798 .72153 L
s
P
p
1 0 .6 r
.00125 w
.41932 .69453 m
.38064 .68853 L
s
P
p
1 0 .6 r
.00125 w
.41932 .69453 m
.38365 .71639 L
s
P
p
1 0 .6 r
.0025 w
.33016 .58698 m
.29408 .62384 L
s
P
p
1 0 .6 r
.0025 w
.33016 .58698 m
.29414 .59997 L
s
P
p
1 0 .6 r
.00088 w
.23232 .69925 m
.20588 .72628 L
s
P
p
1 0 .6 r
.00088 w
.38365 .71639 m
.35152 .73608 L
s
P
p
1 0 .6 r
.00088 w
.38365 .71639 m
.34867 .71109 L
s
P
p
1 0 .6 r
.00125 w
.26155 .66388 m
.23219 .69388 L
s
P
p
1 0 .6 r
.00125 w
.26155 .66388 m
.23175 .67513 L
s
P
p
1 0 .6 r
.00088 w
.25109 .65982 m
.24041 .68794 L
s
P
p
1 0 .6 r
.00088 w
.25579 .67003 m
.22894 .68021 L
s
P
p
1 0 .6 r
.00088 w
.25579 .67003 m
.22936 .69704 L
s
P
p
1 0 .6 r
.00088 w
.26826 .62887 m
.27938 .64202 L
s
P
p
1 0 .6 r
.00088 w
.85216 .70078 m
.875 .73034 L
s
P
p
1 0 .6 r
.00088 w
.57192 .82277 m
.55684 .84952 L
s
P
p
1 0 .6 r
.00177 w
.29408 .62384 m
.26148 .65714 L
s
P
p
1 0 .6 r
.00088 w
.26129 .66171 m
.23447 .67182 L
s
P
p
1 0 .6 r
.00088 w
.26129 .66171 m
.23484 .68873 L
s
P
p
1 0 .6 r
.00088 w
.85216 .70078 m
.8839 .714 L
s
P
p
1 0 .6 r
.00088 w
.23219 .69388 m
.20569 .72096 L
s
P
p
1 0 .6 r
.00088 w
.71375 .76886 m
.74088 .79228 L
s
P
p
1 0 .6 r
.00088 w
.83729 .68149 m
.85912 .67019 L
s
P
p
1 0 .6 r
.00088 w
.83729 .68149 m
.86895 .6946 L
s
P
p
1 0 .6 r
.00125 w
.26148 .65714 m
.23203 .68721 L
s
P
p
1 0 .6 r
.00125 w
.26148 .65714 m
.23159 .66836 L
s
P
p
1 0 .6 r
.00125 w
.8278 .66581 m
.86298 .6803 L
s
P
p
1 0 .6 r
.00125 w
.8278 .66581 m
.85201 .65306 L
s
P
p
1 0 .6 r
.00088 w
.27843 .63628 m
.26727 .62303 L
s
P
p
1 0 .6 r
.00088 w
.27843 .63628 m
.25169 .6462 L
s
P
p
1 0 .6 r
.00088 w
.57192 .82277 m
.58415 .85544 L
s
P
p
1 0 .6 r
.00088 w
.85576 .69396 m
.87866 .72362 L
s
P
p
1 0 .6 r
.00088 w
.38064 .68853 m
.34548 .68307 L
s
P
p
1 0 .6 r
.00088 w
.38064 .68853 m
.36331 .66092 L
s
P
p
1 0 .6 r
.00125 w
.83028 .66096 m
.85576 .69396 L
s
P
p
1 0 .6 r
.00088 w
.23203 .68721 m
.20545 .71436 L
s
P
p
1 0 .6 r
.00088 w
.71375 .76886 m
.73963 .79114 L
s
P
p
1 0 .6 r
.00125 w
.68343 .74268 m
.71375 .76886 L
s
P
p
1 0 .6 r
.00088 w
.26826 .62887 m
.25742 .65732 L
s
P
p
1 0 .6 r
.00088 w
.23165 .67069 m
.22105 .69888 L
s
P
p
1 0 .6 r
.00125 w
.28056 .62972 m
.25109 .65982 L
s
P
p
1 0 .6 r
.00177 w
.29416 .5943 m
.28056 .62972 L
s
P
p
1 0 .6 r
.00125 w
.83028 .66096 m
.86554 .67544 L
s
P
p
1 0 .6 r
.00177 w
.80192 .62423 m
.83028 .66096 L
s
P
p
1 0 .6 r
.00353 w
.57326 .64764 m
.57346 .70199 L
s
P
p
1 0 .6 r
.00353 w
.57326 .64764 m
.61154 .68061 L
s
P
p
1 0 .6 r
.00177 w
.80192 .62423 m
.84094 .64006 L
s
P
p
1 0 .6 r
.00088 w
.6025 .82931 m
.61465 .86205 L
s
P
p
1 0 .6 r
.00125 w
.26138 .64833 m
.23138 .6595 L
s
P
p
1 0 .6 r
.00125 w
.26138 .64833 m
.24872 .63368 L
s
P
p
1 0 .6 r
.00088 w
.25109 .65982 m
.22448 .68699 L
s
P
p
1 0 .6 r
.0025 w
.33051 .56715 m
.2942 .58001 L
s
P
p
1 0 .6 r
.0025 w
.33051 .56715 m
.31586 .54779 L
s
P
p
1 0 .6 r
.00125 w
.58889 .79264 m
.57192 .82277 L
s
P
p
1 0 .6 r
.00088 w
.23188 .68059 m
.20463 .69093 L
s
P
p
1 0 .6 r
.00088 w
.23188 .68059 m
.20522 .70781 L
s
P
p
1 0 .6 r
.00177 w
.64951 .71339 m
.68343 .74268 L
s
P
p
1 0 .6 r
.005 w
.41595 .4668 m
.37224 .48124 L
s
P
p
1 0 .6 r
.005 w
.41595 .4668 m
.39937 .44093 L
s
P
p
1 0 .6 r
.00088 w
.23149 .66389 m
.22086 .6922 L
s
P
p
1 0 .6 r
.00177 w
.29412 .60693 m
.26106 .61893 L
s
P
p
1 0 .6 r
.00177 w
.29412 .60693 m
.26129 .64043 L
s
P
p
1 0 .6 r
.00353 w
.37109 .51585 m
.33116 .52949 L
s
P
p
1 0 .6 r
.00353 w
.37109 .51585 m
.33068 .55705 L
s
P
p
1 0 .6 r
.00088 w
.86298 .6803 m
.886 .71014 L
s
P
p
1 0 .6 r
.00088 w
.23175 .67513 m
.20444 .68545 L
s
P
p
1 0 .6 r
.00088 w
.23175 .67513 m
.20503 .70241 L
s
P
p
1 0 .6 r
.005 w
.55815 .55085 m
.54446 .57686 L
s
P
p
1 0 .6 r
.005 w
.55815 .55085 m
.59264 .56391 L
s
P
p
1 0 .6 r
.00125 w
.26129 .64043 m
.23165 .67069 L
s
P
p
1 0 .6 r
.00125 w
.26129 .64043 m
.2312 .65157 L
s
P
p
1 0 .6 r
.00088 w
.6025 .82931 m
.63519 .84884 L
s
P
p
1 0 .6 r
.00125 w
.58889 .79264 m
.6025 .82931 L
s
P
p
1 0 .6 r
.00088 w
.23136 .65835 m
.2207 .68676 L
s
P
p
1 0 .6 r
.00088 w
.86298 .6803 m
.89506 .69351 L
s
P
p
1 0 .6 r
.00177 w
.78814 .59046 m
.81479 .57527 L
s
P
p
1 0 .6 r
.00177 w
.78814 .59046 m
.82723 .6061 L
s
P
p
1 0 .6 r
.00177 w
.29414 .59997 m
.26099 .61193 L
s
P
p
1 0 .6 r
.00177 w
.29414 .59997 m
.26122 .63356 L
s
P
p
1 0 .6 r
.0025 w
.33068 .55705 m
.29416 .5943 L
s
P
p
1 0 .6 r
.0025 w
.33068 .55705 m
.29423 .56984 L
s
P
p
1 0 .6 r
.00177 w
.64951 .71339 m
.68123 .7407 L
s
P
p
1 0 .6 r
.0025 w
.61154 .68061 m
.64951 .71339 L
s
P
p
1 0 .6 r
.00125 w
.28047 .59681 m
.26826 .62887 L
s
P
p
1 0 .6 r
.00088 w
.86554 .67544 m
.88861 .70535 L
s
P
p
1 0 .6 r
.00088 w
.23165 .67069 m
.20488 .69801 L
s
P
p
1 0 .6 r
.00088 w
.86554 .67544 m
.8977 .68865 L
s
P
p
1 0 .6 r
.00088 w
.23159 .66836 m
.2042 .67864 L
s
P
p
1 0 .6 r
.00088 w
.23159 .66836 m
.2048 .6957 L
s
P
p
1 0 .6 r
.0025 w
.57346 .70199 m
.57364 .75154 L
s
P
p
1 0 .6 r
.0025 w
.57346 .70199 m
.53869 .73281 L
s
P
p
1 0 .6 r
.00125 w
.26122 .63356 m
.23149 .66389 L
s
P
p
1 0 .6 r
.00125 w
.26122 .63356 m
.23103 .64466 L
s
P
p
1 0 .6 r
.00088 w
.7119 .76718 m
.73934 .79087 L
s
P
p
1 0 .6 r
.00177 w
.29416 .5943 m
.26116 .62796 L
s
P
p
1 0 .6 r
.00088 w
.25059 .62726 m
.23977 .65598 L
s
P
p
1 0 .6 r
.00088 w
.85201 .65306 m
.87424 .64136 L
s
P
p
1 0 .6 r
.00088 w
.85201 .65306 m
.88413 .66615 L
s
P
p
1 0 .6 r
.00125 w
.84094 .64006 m
.87659 .65452 L
s
P
p
1 0 .6 r
.00125 w
.84094 .64006 m
.86555 .6269 L
s
P
p
1 0 .6 r
.00177 w
.57364 .75154 m
.58889 .79264 L
s
P
p
1 0 .6 r
.00088 w
.23149 .66389 m
.20464 .69128 L
s
P
p
1 0 .6 r
.00125 w
.26116 .62796 m
.23136 .65835 L
s
P
p
1 0 .6 r
.00125 w
.26116 .62796 m
.2309 .63903 L
s
P
p
1 0 .6 r
.0025 w
.61154 .68061 m
.64663 .71082 L
s
P
p
1 0 .6 r
.00088 w
.7119 .76718 m
.73806 .78971 L
s
P
p
1 0 .6 r
.00125 w
.68123 .7407 m
.7119 .76718 L
s
P
p
1 0 .6 r
.00088 w
.23103 .64438 m
.22031 .67305 L
s
P
p
1 0 .6 r
.00088 w
.23138 .6595 m
.20388 .66975 L
s
P
p
1 0 .6 r
.00088 w
.23138 .6595 m
.20449 .68694 L
s
P
p
1 0 .6 r
.00088 w
.23136 .65835 m
.20445 .68579 L
s
P
p
1 0 .6 r
.00125 w
.82723 .6061 m
.86295 .62039 L
s
P
p
1 0 .6 r
.00125 w
.82723 .6061 m
.85181 .59251 L
s
P
p
1 0 .6 r
.00088 w
.24872 .63368 m
.23705 .6202 L
s
P
p
1 0 .6 r
.00088 w
.24872 .63368 m
.2213 .64373 L
s
P
p
1 0 .6 r
.00125 w
.28047 .59681 m
.25059 .62726 L
s
P
p
1 0 .6 r
.00177 w
.29425 .56063 m
.28047 .59681 L
s
P
p
1 0 .6 r
.00125 w
.26106 .61893 m
.23069 .62996 L
s
P
p
1 0 .6 r
.00125 w
.26106 .61893 m
.24824 .60374 L
s
P
p
1 0 .6 r
.00177 w
.57364 .75154 m
.5738 .79667 L
s
P
p
1 0 .6 r
.00125 w
.68123 .7407 m
.7102 .76564 L
s
P
p
1 0 .6 r
.00177 w
.2942 .58001 m
.26077 .59185 L
s
P
p
1 0 .6 r
.00177 w
.2942 .58001 m
.26101 .61383 L
s
P
p
1 0 .6 r
.00088 w
.2312 .65157 m
.2036 .66178 L
s
P
p
1 0 .6 r
.00088 w
.2312 .65157 m
.20421 .67908 L
s
P
p
1 0 .6 r
.00088 w
.23079 .63445 m
.22004 .66331 L
s
P
p
1 0 .6 r
.00088 w
.87659 .65452 m
.89985 .6847 L
s
P
p
1 0 .6 r
.00088 w
.25059 .62726 m
.22362 .65476 L
s
P
p
1 0 .6 r
.00177 w
.53869 .73281 m
.50691 .76098 L
s
P
p
1 0 .6 r
.00177 w
.53869 .73281 m
.52762 .7424 L
s
P
p
1 0 .6 r
.00088 w
.87659 .65452 m
.9091 .66772 L
s
P
p
1 0 .6 r
.00125 w
.26101 .61383 m
.23103 .64438 L
s
P
p
1 0 .6 r
.00125 w
.26101 .61383 m
.23057 .62483 L
s
P
p
1 0 .6 r
.00088 w
.47658 .78807 m
.44947 .81228 L
s
P
p
1 0 .6 r
.00125 w
.26099 .61193 m
.23052 .62292 L
s
P
p
1 0 .6 r
.00125 w
.26099 .61193 m
.24812 .59661 L
s
P
p
1 0 .6 r
.00177 w
.31586 .54779 m
.30229 .52986 L
s
P
p
1 0 .6 r
.00177 w
.31586 .54779 m
.28256 .55931 L
s
P
p
1 0 .6 r
.0025 w
.33116 .52949 m
.29431 .54209 L
s
P
p
1 0 .6 r
.0025 w
.33116 .52949 m
.3163 .50925 L
s
P
p
1 0 .6 r
.00088 w
.23103 .64466 m
.20336 .65483 L
s
P
p
1 0 .6 r
.00088 w
.23103 .64466 m
.20397 .67224 L
s
P
p
1 0 .6 r
.00353 w
.37224 .48124 m
.33178 .4946 L
s
P
p
1 0 .6 r
.00353 w
.37224 .48124 m
.33128 .52293 L
s
P
p
1 0 .6 r
.00088 w
.23103 .64438 m
.20396 .67196 L
s
P
p
1 0 .6 r
.00125 w
.81479 .57527 m
.83933 .56128 L
s
P
p
1 0 .6 r
.00125 w
.81479 .57527 m
.81358 .54139 L
s
P
p
1 0 .6 r
.00177 w
.29423 .56984 m
.26066 .58162 L
s
P
p
1 0 .6 r
.00177 w
.29423 .56984 m
.2609 .60379 L
s
P
p
1 0 .6 r
.00177 w
.64663 .71082 m
.67873 .73845 L
s
P
p
1 0 .6 r
.00177 w
.64663 .71082 m
.65735 .71996 L
s
P
p
1 0 .6 r
.00088 w
.23058 .62544 m
.21979 .65447 L
s
P
p
1 0 .6 r
.00088 w
.47658 .78807 m
.45041 .81127 L
s
P
p
1 0 .6 r
.00125 w
.50691 .76098 m
.47658 .78807 L
s
P
p
1 0 .6 r
.00125 w
.5738 .79667 m
.57395 .83773 L
s
P
p
1 0 .6 r
.00125 w
.5738 .79667 m
.58208 .81675 L
s
P
p
1 0 .6 r
.00088 w
.86555 .6269 m
.88815 .61481 L
s
P
p
1 0 .6 r
.00088 w
.86555 .6269 m
.89811 .63996 L
s
P
p
1 0 .6 r
.00088 w
.86295 .62039 m
.88633 .65073 L
s
P
p
1 0 .6 r
.00088 w
.2309 .63903 m
.20316 .64918 L
s
P
p
1 0 .6 r
.00088 w
.2309 .63903 m
.20377 .66667 L
s
P
p
1 0 .6 r
.0025 w
.33128 .52293 m
.29425 .56063 L
s
P
p
1 0 .6 r
.0025 w
.33128 .52293 m
.29432 .53548 L
s
P
p
1 0 .6 r
.00125 w
.2609 .60379 m
.23079 .63445 L
s
P
p
1 0 .6 r
.00125 w
.2609 .60379 m
.23033 .61473 L
s
P
p
1 0 .6 r
.00088 w
.36426 .62836 m
.34587 .61988 L
s
P
p
1 0 .6 r
.00088 w
.70979 .76528 m
.73758 .78927 L
s
P
p
1 0 .6 r
.00088 w
.86295 .62039 m
.89552 .63342 L
s
P
p
1 0 .6 r
.00088 w
.7102 .76564 m
.73662 .78839 L
s
P
p
1 0 .6 r
.00088 w
.7102 .76564 m
.71963 .7737 L
s
P
p
1 0 .6 r
.00353 w
.39937 .44093 m
.38392 .41681 L
s
P
p
1 0 .6 r
.00353 w
.39937 .44093 m
.35913 .4538 L
s
P
p
1 0 .6 r
.00353 w
.59264 .56391 m
.6247 .57605 L
s
P
p
1 0 .6 r
.00353 w
.59264 .56391 m
.5807 .5879 L
s
P
p
1 0 .6 r
.00088 w
.23079 .63445 m
.20361 .66213 L
s
P
p
1 0 .6 r
.00177 w
.29425 .56063 m
.2608 .59468 L
s
P
p
1 0 .6 r
.00353 w
.54446 .57686 m
.53169 .60109 L
s
P
p
1 0 .6 r
.00353 w
.54446 .57686 m
.49544 .59857 L
s
P
p
1 0 .6 r
.00125 w
.50691 .76098 m
.47791 .78669 L
s
P
p
1 0 .6 r
.00088 w
.70979 .76528 m
.73627 .78808 L
s
P
p
1 0 .6 r
.00125 w
.67873 .73845 m
.70979 .76528 L
s
P
p
1 0 .6 r
.00088 w
.57395 .83773 m
.55085 .86833 L
s
P
p
1 0 .6 r
.00088 w
.23069 .62996 m
.20284 .64006 L
s
P
p
1 0 .6 r
.00088 w
.23069 .62996 m
.20346 .65768 L
s
P
p
1 0 .6 r
.00125 w
.2608 .59468 m
.23058 .62544 L
s
P
p
1 0 .6 r
.00125 w
.2608 .59468 m
.23011 .60558 L
s
P
p
1 0 .6 r
.00088 w
.85181 .59251 m
.87438 .58002 L
s
P
p
1 0 .6 r
.00088 w
.85181 .59251 m
.88443 .60541 L
s
P
p
1 0 .6 r
.00088 w
.57395 .83773 m
.57409 .87504 L
s
P
p
1 0 .6 r
.00125 w
.26077 .59185 m
.23005 .60273 L
s
P
p
1 0 .6 r
.00125 w
.26077 .59185 m
.24779 .57615 L
s
P
p
1 0 .6 r
.00088 w
.23058 .62544 m
.2033 .65321 L
s
P
p
1 0 .6 r
.00088 w
.23057 .62483 m
.20265 .63491 L
s
P
p
1 0 .6 r
.00088 w
.23057 .62483 m
.20328 .65261 L
s
P
p
1 0 .6 r
.00088 w
.81358 .54139 m
.81248 .51042 L
s
P
p
1 0 .6 r
.00088 w
.81358 .54139 m
.83582 .52837 L
s
P
p
1 0 .6 r
.00088 w
.24824 .60374 m
.23642 .58975 L
s
P
p
1 0 .6 r
.00088 w
.24824 .60374 m
.22047 .61364 L
s
P
p
1 0 .6 r
.00088 w
.23015 .60732 m
.21928 .63668 L
s
P
p
1 0 .6 r
.00125 w
.67873 .73845 m
.70805 .7637 L
s
P
p
1 0 .6 r
.00088 w
.23052 .62292 m
.20259 .63299 L
s
P
p
1 0 .6 r
.00088 w
.23052 .62292 m
.20321 .65072 L
s
P
p
1 0 .6 r
.00088 w
.36426 .62836 m
.32785 .63254 L
s
P
p
1 0 .6 r
.00125 w
.28256 .55931 m
.25197 .5699 L
s
P
p
1 0 .6 r
.00125 w
.28256 .55931 m
.26982 .54316 L
s
P
p
1 0 .6 r
.00088 w
.83933 .56128 m
.86187 .54842 L
s
P
p
1 0 .6 r
.00088 w
.83933 .56128 m
.87201 .57403 L
s
P
p
1 0 .6 r
.00088 w
.23 .60087 m
.2191 .63035 L
s
P
p
1 0 .6 r
.00088 w
.24812 .59661 m
.23627 .5825 L
s
P
p
1 0 .6 r
.00088 w
.24812 .59661 m
.22028 .60647 L
s
P
p
1 0 .6 r
.00125 w
.26066 .58162 m
.2298 .59244 L
s
P
p
1 0 .6 r
.00125 w
.26066 .58162 m
.24762 .56573 L
s
P
p
1 0 .6 r
.00177 w
.29431 .54209 m
.26035 .55369 L
s
P
p
1 0 .6 r
.00177 w
.29431 .54209 m
.2606 .57636 L
s
P
p
1 0 .6 r
.00088 w
.47791 .78669 m
.45147 .81013 L
s
P
p
1 0 .6 r
.00088 w
.47791 .78669 m
.46811 .79519 L
s
P
p
1 0 .6 r
.00088 w
.23033 .61473 m
.2023 .62477 L
s
P
p
1 0 .6 r
.00088 w
.23033 .61473 m
.20293 .64261 L
s
P
p
1 0 .6 r
.00125 w
.52762 .7424 m
.51738 .75127 L
s
P
p
1 0 .6 r
.00125 w
.52762 .7424 m
.49855 .76817 L
s
P
p
1 0 .6 r
.00125 w
.405 .62367 m
.36426 .62836 L
s
P
p
1 0 .6 r
.00125 w
.30229 .52986 m
.28976 .5133 L
s
P
p
1 0 .6 r
.00125 w
.30229 .52986 m
.31506 .49626 L
s
P
p
1 0 .6 r
.0025 w
.49544 .59857 m
.45065 .61842 L
s
P
p
1 0 .6 r
.0025 w
.49544 .59857 m
.48313 .62086 L
s
P
p
1 0 .6 r
.0025 w
.33178 .4946 m
.2944 .50694 L
s
P
p
1 0 .6 r
.0025 w
.33178 .4946 m
.31671 .47354 L
s
P
p
1 0 .6 r
.00125 w
.2606 .57636 m
.23015 .60732 L
s
P
p
1 0 .6 r
.00125 w
.2606 .57636 m
.22968 .58716 L
s
P
p
1 0 .6 r
.00088 w
.58208 .81675 m
.58971 .83526 L
s
P
p
1 0 .6 r
.00088 w
.58208 .81675 m
.61417 .83194 L
s
P
p
1 0 .6 r
.00177 w
.29432 .53548 m
.26028 .54704 L
s
P
p
1 0 .6 r
.00177 w
.29432 .53548 m
.26053 .56984 L
s
P
p
1 0 .6 r
.00177 w
.3163 .50925 m
.30252 .49051 L
s
P
p
1 0 .6 r
.00177 w
.3163 .50925 m
.28249 .52053 L
s
P
p
1 0 .6 r
.00088 w
.23015 .60732 m
.20267 .63528 L
s
P
p
1 0 .6 r
.00125 w
.65735 .71996 m
.66727 .72843 L
s
P
p
1 0 .6 r
.00125 w
.65735 .71996 m
.68672 .74525 L
s
P
p
1 0 .6 r
.00088 w
.70805 .7637 m
.73479 .78673 L
s
P
p
1 0 .6 r
.00088 w
.70805 .7637 m
.71758 .77184 L
s
P
p
1 0 .6 r
.00088 w
.23011 .60558 m
.20197 .61557 L
s
P
p
1 0 .6 r
.00088 w
.23011 .60558 m
.20261 .63355 L
s
P
p
1 0 .6 r
.00125 w
.26053 .56984 m
.23 .60087 L
s
P
p
1 0 .6 r
.00125 w
.26053 .56984 m
.22953 .5806 L
s
P
p
1 0 .6 r
.00125 w
.405 .62367 m
.36812 .63992 L
s
P
p
1 0 .6 r
.00177 w
.45065 .61842 m
.405 .62367 L
s
P
p
1 0 .6 r
.00088 w
.75879 .54855 m
.78993 .5344 L
s
P
p
1 0 .6 r
.0025 w
.35913 .4538 m
.32196 .46568 L
s
P
p
1 0 .6 r
.0025 w
.35913 .4538 m
.34443 .43202 L
s
P
p
1 0 .6 r
.00088 w
.23005 .60273 m
.20187 .6127 L
s
P
p
1 0 .6 r
.00088 w
.23005 .60273 m
.20251 .63073 L
s
P
p
1 0 .6 r
.00088 w
.23 .60087 m
.20244 .62889 L
s
P
p
1 0 .6 r
.00088 w
.36812 .63992 m
.33134 .64411 L
s
P
p
1 0 .6 r
.00088 w
.49855 .76817 m
.47205 .79166 L
s
P
p
1 0 .6 r
.00088 w
.49855 .76817 m
.48893 .7765 L
s
P
p
1 0 .6 r
.0025 w
.6247 .57605 m
.65442 .58731 L
s
P
p
1 0 .6 r
.0025 w
.6247 .57605 m
.67663 .56997 L
s
P
p
1 0 .6 r
.00088 w
.24779 .57615 m
.23584 .56168 L
s
P
p
1 0 .6 r
.00088 w
.24779 .57615 m
.21971 .58591 L
s
P
p
1 0 .6 r
.00088 w
.25197 .5699 m
.2239 .57961 L
s
P
p
1 0 .6 r
.00088 w
.25197 .5699 m
.22438 .59793 L
s
P
p
1 0 .6 r
.0025 w
.38392 .41681 m
.36956 .39439 L
s
P
p
1 0 .6 r
.0025 w
.38392 .41681 m
.40061 .37387 L
s
P
p
1 0 .6 r
.00088 w
.31506 .49626 m
.32672 .46558 L
s
P
p
1 0 .6 r
.00088 w
.31506 .49626 m
.30385 .48088 L
s
P
p
1 0 .6 r
.0025 w
.5807 .5879 m
.56961 .61019 L
s
P
p
1 0 .6 r
.0025 w
.5807 .5879 m
.60983 .59934 L
s
P
p
1 0 .6 r
.00177 w
.45065 .61842 m
.40976 .63653 L
s
P
p
1 0 .6 r
.00088 w
.2298 .59244 m
.20151 .60237 L
s
P
p
1 0 .6 r
.00088 w
.2298 .59244 m
.20215 .62055 L
s
P
p
1 0 .6 r
.0025 w
.53169 .60109 m
.51984 .62361 L
s
P
p
1 0 .6 r
.0025 w
.53169 .60109 m
.56017 .61273 L
s
P
p
1 0 .6 r
.00088 w
.36812 .63992 m
.33455 .65471 L
s
P
p
1 0 .6 r
.00088 w
.75879 .54855 m
.79718 .54401 L
s
P
p
1 0 .6 r
.00125 w
.7238 .56445 m
.75879 .54855 L
s
P
p
1 0 .6 r
.00088 w
.22935 .57297 m
.21833 .60298 L
s
P
p
1 0 .6 r
.00088 w
.26982 .54316 m
.25808 .52828 L
s
P
p
1 0 .6 r
.00088 w
.26982 .54316 m
.24185 .55265 L
s
P
p
1 0 .6 r
.00125 w
.26035 .55369 m
.22914 .56435 L
s
P
p
1 0 .6 r
.00125 w
.26035 .55369 m
.24717 .53726 L
s
P
p
1 0 .6 r
.00088 w
.68672 .74525 m
.71351 .76832 L
s
P
p
1 0 .6 r
.00088 w
.68672 .74525 m
.69606 .75322 L
s
P
p
1 0 .6 r
.00088 w
.22968 .58716 m
.20132 .59706 L
s
P
p
1 0 .6 r
.00088 w
.22968 .58716 m
.20196 .61531 L
s
P
p
1 0 .6 r
.00088 w
.24762 .56573 m
.23562 .55109 L
s
P
p
1 0 .6 r
.00088 w
.24762 .56573 m
.21942 .57544 L
s
P
p
1 0 .6 r
.00177 w
.67663 .56997 m
.7238 .56445 L
s
P
p
1 0 .6 r
.00177 w
.67663 .56997 m
.70414 .58006 L
s
P
p
1 0 .6 r
.00088 w
.28976 .5133 m
.27821 .49804 L
s
P
p
1 0 .6 r
.00088 w
.28976 .5133 m
.26189 .52255 L
s
P
p
1 0 .6 r
.00125 w
.26028 .54704 m
.22899 .55767 L
s
P
p
1 0 .6 r
.00125 w
.26028 .54704 m
.24706 .53049 L
s
P
p
1 0 .6 r
.00088 w
.51738 .75127 m
.50793 .75945 L
s
P
p
1 0 .6 r
.00088 w
.51738 .75127 m
.53071 .73918 L
s
P
p
1 0 .6 r
.00177 w
.2944 .50694 m
.25997 .51831 L
s
P
p
1 0 .6 r
.00177 w
.2944 .50694 m
.26022 .54164 L
s
P
p
1 0 .6 r
.00125 w
.28249 .52053 m
.25141 .53089 L
s
P
p
1 0 .6 r
.00125 w
.28249 .52053 m
.26954 .50363 L
s
P
p
1 0 .6 r
.00088 w
.25676 .53181 m
.24551 .56221 L
s
P
p
1 0 .6 r
.00088 w
.22953 .5806 m
.20109 .59047 L
s
P
p
1 0 .6 r
.00088 w
.22953 .5806 m
.20173 .60882 L
s
P
p
1 0 .6 r
.00125 w
.40976 .63653 m
.3725 .65304 L
s
P
p
1 0 .6 r
.00125 w
.40976 .63653 m
.39861 .65526 L
s
P
p
1 0 .6 r
.00125 w
.26022 .54164 m
.22935 .57297 L
s
P
p
1 0 .6 r
.00125 w
.26022 .54164 m
.22886 .55223 L
s
P
p
1 0 .6 r
.00125 w
.7238 .56445 m
.76659 .55944 L
s
P
p
1 0 .6 r
.00177 w
.48313 .62086 m
.47173 .6415 L
s
P
p
1 0 .6 r
.00177 w
.48313 .62086 m
.44215 .63913 L
s
P
p
1 0 .6 r
.00125 w
.30252 .49051 m
.2898 .47319 L
s
P
p
1 0 .6 r
.00125 w
.30252 .49051 m
.3155 .45607 L
s
P
p
1 0 .6 r
.00177 w
.31671 .47354 m
.30274 .45402 L
s
P
p
1 0 .6 r
.00177 w
.31671 .47354 m
.28242 .48457 L
s
P
p
1 0 .6 r
.00088 w
.66727 .72843 m
.67643 .73624 L
s
P
p
1 0 .6 r
.00088 w
.66727 .72843 m
.65326 .71626 L
s
P
p
1 0 .6 r
.00088 w
.22935 .57297 m
.20147 .60127 L
s
P
p
1 0 .6 r
.00177 w
.32196 .46568 m
.28771 .47662 L
s
P
p
1 0 .6 r
.00177 w
.32196 .46568 m
.2877 .50042 L
s
P
p
1 0 .6 r
.00088 w
.3725 .65304 m
.3353 .65723 L
s
P
p
1 0 .6 r
.00177 w
.40061 .37387 m
.41589 .33453 L
s
P
p
1 0 .6 r
.00177 w
.40061 .37387 m
.38781 .35293 L
s
P
p
1 0 .6 r
.00125 w
.2877 .50042 m
.25676 .53181 L
s
P
p
1 0 .6 r
.00125 w
.2877 .50042 m
.2565 .51064 L
s
P
p
1 0 .6 r
.00088 w
.76659 .55944 m
.80539 .5549 L
s
P
p
1 0 .6 r
.00088 w
.76659 .55944 m
.78994 .56755 L
s
P
p
1 0 .6 r
.00177 w
.34443 .43202 m
.3308 .41184 L
s
P
p
1 0 .6 r
.00177 w
.34443 .43202 m
.31033 .44262 L
s
P
p
1 0 .6 r
.00088 w
.22914 .56435 m
.20051 .57414 L
s
P
p
1 0 .6 r
.00088 w
.22914 .56435 m
.20117 .59274 L
s
P
p
1 0 .6 r
.00088 w
.25676 .53181 m
.22882 .56014 L
s
P
p
1 0 .6 r
.00088 w
.3725 .65304 m
.33858 .66806 L
s
P
p
1 0 .6 r
.00177 w
.65442 .58731 m
.6819 .59771 L
s
P
p
1 0 .6 r
.00177 w
.65442 .58731 m
.64535 .60759 L
s
P
p
1 0 .6 r
.00177 w
.60983 .59934 m
.63677 .60991 L
s
P
p
1 0 .6 r
.00177 w
.60983 .59934 m
.60013 .61981 L
s
P
p
1 0 .6 r
.00088 w
.44672 .30332 m
.47438 .27533 L
s
P
p
1 0 .6 r
.00125 w
.44215 .63913 m
.40479 .65578 L
s
P
p
1 0 .6 r
.00125 w
.44215 .63913 m
.43132 .65804 L
s
P
p
1 0 .6 r
.00088 w
.24717 .53726 m
.23501 .52212 L
s
P
p
1 0 .6 r
.00088 w
.24717 .53726 m
.21863 .54682 L
s
P
p
1 0 .6 r
.00088 w
.22899 .55767 m
.20027 .56742 L
s
P
p
1 0 .6 r
.00088 w
.22899 .55767 m
.20093 .58612 L
s
P
p
1 0 .6 r
.00177 w
.56961 .61019 m
.55934 .63084 L
s
P
p
1 0 .6 r
.00177 w
.56961 .61019 m
.5289 .62852 L
s
P
p
1 0 .6 r
.00177 w
.36956 .39439 m
.35624 .37361 L
s
P
p
1 0 .6 r
.00177 w
.36956 .39439 m
.33562 .4046 L
s
P
p
1 0 .6 r
.00088 w
.25141 .53089 m
.22289 .5404 L
s
P
p
1 0 .6 r
.00088 w
.25141 .53089 m
.22338 .55931 L
s
P
p
1 0 .6 r
.00177 w
.56017 .61273 m
.58649 .6235 L
s
P
p
1 0 .6 r
.00177 w
.56017 .61273 m
.54975 .63343 L
s
P
p
1 0 .6 r
.00088 w
.3155 .45607 m
.32735 .42462 L
s
P
p
1 0 .6 r
.00088 w
.3155 .45607 m
.30412 .43999 L
s
P
p
1 0 .6 r
.00088 w
.44672 .30332 m
.45949 .27079 L
s
P
p
1 0 .6 r
.00125 w
.41589 .33453 m
.44672 .30332 L
s
P
p
1 0 .6 r
.00125 w
.70414 .58006 m
.7295 .58936 L
s
P
p
1 0 .6 r
.00125 w
.70414 .58006 m
.74722 .57507 L
s
P
p
1 0 .6 r
.00125 w
.25997 .51831 m
.22831 .52877 L
s
P
p
1 0 .6 r
.00125 w
.25997 .51831 m
.24659 .5012 L
s
P
p
1 0 .6 r
.00177 w
.51984 .62361 m
.50885 .64448 L
s
P
p
1 0 .6 r
.00177 w
.51984 .62361 m
.47873 .64207 L
s
P
p
1 0 .6 r
.00088 w
.40479 .65578 m
.36718 .66 L
s
P
p
1 0 .6 r
.00088 w
.22886 .55223 m
.20008 .56195 L
s
P
p
1 0 .6 r
.00088 w
.22886 .55223 m
.20074 .58073 L
s
P
p
1 0 .6 r
.00088 w
.24706 .53049 m
.23487 .51523 L
s
P
p
1 0 .6 r
.00088 w
.24706 .53049 m
.21844 .54001 L
s
P
p
1 0 .6 r
.00125 w
.41589 .33453 m
.42988 .29854 L
s
P
p
1 0 .6 r
.00088 w
.26954 .50363 m
.25761 .48806 L
s
P
p
1 0 .6 r
.00088 w
.26954 .50363 m
.24112 .51291 L
s
P
p
1 0 .6 r
.00088 w
.39861 .65526 m
.38834 .67252 L
s
P
p
1 0 .6 r
.00088 w
.39861 .65526 m
.36462 .67039 L
s
P
p
1 0 .6 r
.00125 w
.28242 .48457 m
.25089 .49471 L
s
P
p
1 0 .6 r
.00125 w
.28242 .48457 m
.26929 .46697 L
s
P
p
1 0 .6 r
.00125 w
.28771 .47662 m
.25621 .48669 L
s
P
p
1 0 .6 r
.00125 w
.28771 .47662 m
.27463 .45891 L
s
P
p
1 0 .6 r
.00088 w
.74722 .57507 m
.78628 .57054 L
s
P
p
1 0 .6 r
.00088 w
.74722 .57507 m
.77057 .58341 L
s
P
p
1 0 .6 r
.00088 w
.2898 .47319 m
.27806 .45722 L
s
P
p
1 0 .6 r
.00088 w
.2898 .47319 m
.26149 .48221 L
s
P
p
1 0 .6 r
.00088 w
.40479 .65578 m
.37077 .67095 L
s
P
p
1 0 .6 r
.00088 w
.2565 .51064 m
.22787 .52001 L
s
P
p
1 0 .6 r
.00088 w
.2565 .51064 m
.22832 .53918 L
s
P
p
1 0 .6 r
.00125 w
.47173 .6415 m
.4612 .66058 L
s
P
p
1 0 .6 r
.00125 w
.47173 .6415 m
.49451 .65158 L
s
P
p
1 0 .6 r
.00125 w
.5289 .62852 m
.49179 .64524 L
s
P
p
1 0 .6 r
.00125 w
.5289 .62852 m
.51909 .64744 L
s
P
p
1 0 .6 r
.00125 w
.30274 .45402 m
.28983 .43598 L
s
P
p
1 0 .6 r
.00125 w
.30274 .45402 m
.31591 .4188 L
s
P
p
1 0 .6 r
.00125 w
.31033 .44262 m
.27896 .45237 L
s
P
p
1 0 .6 r
.00125 w
.31033 .44262 m
.2975 .42442 L
s
P
p
1 0 .6 r
.00125 w
.38781 .35293 m
.37598 .33356 L
s
P
p
1 0 .6 r
.00125 w
.38781 .35293 m
.40165 .31688 L
s
P
p
1 0 .6 r
.00125 w
.47873 .64207 m
.44126 .65889 L
s
P
p
1 0 .6 r
.00125 w
.47873 .64207 m
.46827 .66118 L
s
P
p
1 0 .6 r
.00088 w
.49179 .64524 m
.4536 .64952 L
s
P
p
1 0 .6 r
.00088 w
.42988 .29854 m
.44265 .26566 L
s
P
p
1 0 .6 r
.00088 w
.42988 .29854 m
.41971 .28046 L
s
P
p
1 0 .6 r
.00125 w
.6819 .59771 m
.70725 .60731 L
s
P
p
1 0 .6 r
.00125 w
.6819 .59771 m
.72531 .59274 L
s
P
p
1 0 .6 r
.00088 w
.44126 .65889 m
.4032 .66313 L
s
P
p
1 0 .6 r
.00125 w
.3308 .41184 m
.31821 .39319 L
s
P
p
1 0 .6 r
.00125 w
.3308 .41184 m
.34424 .37616 L
s
P
p
1 0 .6 r
.00088 w
.22831 .52877 m
.19925 .53837 L
s
P
p
1 0 .6 r
.00088 w
.22831 .52877 m
.19992 .55751 L
s
P
p
1 0 .6 r
.00125 w
.33562 .4046 m
.30442 .41399 L
s
P
p
1 0 .6 r
.00125 w
.33562 .4046 m
.32308 .38584 L
s
P
p
1 0 .6 r
.00125 w
.64535 .60759 m
.63697 .62634 L
s
P
p
1 0 .6 r
.00125 w
.64535 .60759 m
.67029 .61732 L
s
P
p
1 0 .6 r
.00088 w
.43132 .65804 m
.42133 .67547 L
s
P
p
1 0 .6 r
.00088 w
.43132 .65804 m
.39723 .67331 L
s
P
p
1 0 .6 r
.00125 w
.63677 .60991 m
.66161 .61967 L
s
P
p
1 0 .6 r
.00125 w
.63677 .60991 m
.68005 .60498 L
s
P
p
1 0 .6 r
.00088 w
.7295 .58936 m
.75284 .59792 L
s
P
p
1 0 .6 r
.00088 w
.7295 .58936 m
.72293 .60602 L
s
P
p
1 0 .6 r
.00125 w
.60013 .61981 m
.59116 .63874 L
s
P
p
1 0 .6 r
.00125 w
.60013 .61981 m
.62457 .62969 L
s
P
p
1 0 .6 r
.00088 w
.49179 .64524 m
.458 .66045 L
s
P
p
1 0 .6 r
.00125 w
.58649 .6235 m
.61078 .63343 L
s
P
p
1 0 .6 r
.00125 w
.58649 .6235 m
.62964 .61862 L
s
P
p
1 0 .6 r
.00088 w
.24659 .5012 m
.23425 .48542 L
s
P
p
1 0 .6 r
.00088 w
.24659 .5012 m
.21763 .51056 L
s
P
p
1 0 .6 r
.00125 w
.55934 .63084 m
.54984 .64992 L
s
P
p
1 0 .6 r
.00125 w
.55934 .63084 m
.58332 .64086 L
s
P
p
1 0 .6 r
.00125 w
.54975 .63343 m
.54013 .65255 L
s
P
p
1 0 .6 r
.00125 w
.54975 .63343 m
.57363 .64348 L
s
P
p
1 0 .6 r
.00088 w
.44126 .65889 m
.40715 .6742 L
s
P
p
1 0 .6 r
.00125 w
.35624 .37361 m
.34393 .35439 L
s
P
p
1 0 .6 r
.00125 w
.35624 .37361 m
.36992 .3375 L
s
P
p
1 0 .6 r
.00088 w
.25089 .49471 m
.22195 .50402 L
s
P
p
1 0 .6 r
.00088 w
.25089 .49471 m
.22246 .52348 L
s
P
p
1 0 .6 r
.00088 w
.72531 .59274 m
.76467 .58824 L
s
P
p
1 0 .6 r
.00088 w
.72531 .59274 m
.74865 .60135 L
s
P
p
1 0 .6 r
.00088 w
.31591 .4188 m
.32793 .38663 L
s
P
p
1 0 .6 r
.00088 w
.31591 .4188 m
.30436 .40205 L
s
P
p
1 0 .6 r
.00088 w
.25621 .48669 m
.2273 .49593 L
s
P
p
1 0 .6 r
.00088 w
.25621 .48669 m
.22776 .51547 L
s
P
p
1 0 .6 r
.00125 w
.50885 .64448 m
.49869 .66377 L
s
P
p
1 0 .6 r
.00125 w
.50885 .64448 m
.53226 .65468 L
s
P
p
1 0 .6 r
.00088 w
.68005 .60498 m
.7193 .60051 L
s
P
p
1 0 .6 r
.00088 w
.68005 .60498 m
.70294 .61373 L
s
P
p
1 0 .6 r
.00088 w
.40165 .31688 m
.4143 .28395 L
s
P
p
1 0 .6 r
.00088 w
.40165 .31688 m
.3911 .29892 L
s
P
p
1 0 .6 r
.00088 w
.26929 .46697 m
.25717 .45074 L
s
P
p
1 0 .6 r
.00088 w
.26929 .46697 m
.24045 .47604 L
s
P
p
1 0 .6 r
.00088 w
.62964 .61862 m
.66876 .61419 L
s
P
p
1 0 .6 r
.00088 w
.62964 .61862 m
.65202 .62753 L
s
P
p
1 0 .6 r
.00088 w
.27463 .45891 m
.26257 .44257 L
s
P
p
1 0 .6 r
.00088 w
.27463 .45891 m
.24582 .46791 L
s
P
p
1 0 .6 r
.00088 w
.49451 .65158 m
.51546 .66085 L
s
P
p
1 0 .6 r
.00088 w
.49451 .65158 m
.48519 .66904 L
s
P
p
1 0 .6 r
.00088 w
.27896 .45237 m
.25018 .46132 L
s
P
p
1 0 .6 r
.00088 w
.27896 .45237 m
.25047 .48118 L
s
P
p
1 0 .6 r
.00088 w
.34424 .37616 m
.35651 .34356 L
s
P
p
1 0 .6 r
.00088 w
.34424 .37616 m
.33298 .35884 L
s
P
p
1 0 .6 r
.00088 w
.4612 .66058 m
.45148 .67817 L
s
P
p
1 0 .6 r
.00088 w
.4612 .66058 m
.42703 .67598 L
s
P
p
1 0 .6 r
.00088 w
.51909 .64744 m
.51004 .66488 L
s
P
p
1 0 .6 r
.00088 w
.51909 .64744 m
.48523 .66277 L
s
P
p
1 0 .6 r
.00088 w
.28983 .43598 m
.27793 .41934 L
s
P
p
1 0 .6 r
.00088 w
.28983 .43598 m
.26111 .44478 L
s
P
p
1 0 .6 r
.00088 w
.46827 .66118 m
.45862 .67881 L
s
P
p
1 0 .6 r
.00088 w
.46827 .66118 m
.43408 .67661 L
s
P
p
1 0 .6 r
.00088 w
.2975 .42442 m
.28567 .40762 L
s
P
p
1 0 .6 r
.00088 w
.2975 .42442 m
.26882 .43312 L
s
P
p
1 0 .6 r
.00088 w
.37598 .33356 m
.36507 .3157 L
s
P
p
1 0 .6 r
.00088 w
.37598 .33356 m
.34804 .34142 L
s
P
p
1 0 .6 r
.00088 w
.30442 .41399 m
.27577 .4226 L
s
P
p
1 0 .6 r
.00088 w
.30442 .41399 m
.27586 .44284 L
s
P
p
1 0 .6 r
.00088 w
.36992 .3375 m
.38242 .30451 L
s
P
p
1 0 .6 r
.00088 w
.36992 .3375 m
.35893 .31967 L
s
P
p
1 0 .6 r
.00088 w
.70725 .60731 m
.73058 .61615 L
s
P
p
1 0 .6 r
.00088 w
.70725 .60731 m
.70035 .62434 L
s
P
p
1 0 .6 r
.00088 w
.67029 .61732 m
.69325 .62627 L
s
P
p
1 0 .6 r
.00088 w
.67029 .61732 m
.66296 .63448 L
s
P
p
1 0 .6 r
.00088 w
.66161 .61967 m
.68448 .62864 L
s
P
p
1 0 .6 r
.00088 w
.66161 .61967 m
.65418 .63686 L
s
P
p
1 0 .6 r
.00088 w
.31821 .39319 m
.30659 .37598 L
s
P
p
1 0 .6 r
.00088 w
.31821 .39319 m
.28964 .40162 L
s
P
p
1 0 .6 r
.00088 w
.63697 .62634 m
.62924 .64362 L
s
P
p
1 0 .6 r
.00088 w
.63697 .62634 m
.6036 .64163 L
s
P
p
1 0 .6 r
.00088 w
.32308 .38584 m
.31151 .36853 L
s
P
p
1 0 .6 r
.00088 w
.32308 .38584 m
.29454 .39421 L
s
P
p
1 0 .6 r
.00088 w
.62457 .62969 m
.64706 .63879 L
s
P
p
1 0 .6 r
.00088 w
.62457 .62969 m
.6167 .64702 L
s
P
p
1 0 .6 r
.00088 w
.61078 .63343 m
.63313 .64257 L
s
P
p
1 0 .6 r
.00088 w
.61078 .63343 m
.60274 .65081 L
s
P
p
1 0 .6 r
.00088 w
.59116 .63874 m
.58289 .65619 L
s
P
p
1 0 .6 r
.00088 w
.59116 .63874 m
.5575 .65411 L
s
P
p
1 0 .6 r
.00088 w
.58332 .64086 m
.60539 .65009 L
s
P
p
1 0 .6 r
.00088 w
.58332 .64086 m
.57496 .65834 L
s
P
p
1 0 .6 r
.00088 w
.57363 .64348 m
.59561 .65274 L
s
P
p
1 0 .6 r
.00088 w
.57363 .64348 m
.56515 .661 L
s
P
p
1 0 .6 r
.00088 w
.54984 .64992 m
.54108 .66752 L
s
P
p
1 0 .6 r
.00088 w
.54984 .64992 m
.5159 .66538 L
s
P
p
1 0 .6 r
.00088 w
.54013 .65255 m
.53126 .67019 L
s
P
p
1 0 .6 r
.00088 w
.54013 .65255 m
.50613 .66803 L
s
P
p
1 0 .6 r
.00088 w
.53226 .65468 m
.55382 .66407 L
s
P
p
1 0 .6 r
.00088 w
.53226 .65468 m
.5233 .67235 L
s
P
p
1 0 .6 r
.00088 w
.34393 .35439 m
.33258 .33667 L
s
P
p
1 0 .6 r
.00088 w
.34393 .35439 m
.3155 .36249 L
s
P
p
1 0 .6 r
.00088 w
.49869 .66377 m
.48933 .68156 L
s
P
p
1 0 .6 r
.00088 w
.49869 .66377 m
.46442 .67933 L
s
P
p
1 g
.002 w
.8517 .02689 m
.88114 .72344 L
s
.88114 .72344 m
.02689 .78484 L
s
.02689 .78484 m
.06986 .11778 L
s
.06986 .11778 m
.8517 .02689 L
s
.8517 .02689 m
.88114 .72344 L
s
.88114 .72344 m
.97311 .96851 L
s
.97311 .96851 m
.94317 .39493 L
s
.94317 .39493 m
.8517 .02689 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 326}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
0025aPD06<H1000007cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K62@007LKFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040001caPT0
3LH00`36aP0FaP400000J]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H9000Ca]K6e/KFa]K6e/KFa]K6e/KFaP03a08001O6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
HLH900C600?4a/H03<H9a0?60P0GaP400000F=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000C
a]K6e/KFa]K6e/KFa]K4e/KFaP09a00<a]K6e/KFa]K6e/KF0P005lKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040001?aPT04lH9a1G60P0GaP400000A]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000Ca]K6e/KFa]K6e/KFa]K6e/KF
aP09a00ga]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP010000?LH900O600?4a/H02LH9a0k600?4a/H05/H00`36000FaP400000==K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000Ca]K6e/KFa]K6e/KFa]K6e/K4
aP09a019a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP010000:lH901?62L@PaP03a<K601K600<0aP005/H1000002;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62@004lK4a]K6e/KFa]K6e/KFa]K6e/H02L@0FlKF
a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001W62@0:aP03a<K600K62L@AaP03a<K601o6
00?4a/H05/H00`36000EaP4000004=K6e/KFa]K6e/KFa]K6e/H9000Ca]K6e/KFa]K6e/KFa]K6e/KF
aP09a01]a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
2lH501?62L@2aP03a<K601o600?4a/H07lH00lC6aP0EaP030<H001G60@00000Je/KFa]K6e/KFa]H0
a<KFa]K6e/KFa]K6e/H9a01oa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP0100002lH20004a<K6aPW45LH00lC6aP0OaP03a<K601k6
00?4a/H05LH01036aP0DaP4000003MK6e/KFa]K6e/KF0=H01<@0TLKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0000_600@0aP348LH00lC6aP0OaP03a<K601k600?4a/H05<H01036aP0DaP400000X]K6
e/KFa]K6e/KF0=K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000;aP060<K6aP348<H00lC6
aP0OaP03a<K601k600?4a/H04/H00l@0a002a0030<K601760@00001oe/KFa]K6e/KFa]H0e/KF0=K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6eP0:a00IaP36e/H0
a]K6e/KFa]K6e/KFa]K6e/KFaP0100002lH00`36aP02aP030<C601o600?4a/H07lH00lC6aP0MaP_4
2lH01@36a/H001?60@00001/e/KFa]K6e/KFaP36e/KFa]H0a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K62/@0;=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60@0000[6
00<0a/H01LH00`34aP0OaP03a<K601k600?4a/H02/H:a0W600?4a/H04/H00`36aP02aP030<K60136
0@00001He/KFa]K6e/KFaP36e/KFa]K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFaP[4043Fa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60@0000[600<0a/H01/H00`34
aP0OaP03a<K601K62/@NaP03a<K6017600<0a/H00/H00`36aP0@aP400000A=K6e/KFa]K6e/H0a]K6
e/KFa]K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K62/@0E=K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFaP36e/KFa]K6e/KFa]K6e/KFaP40000:aP030<K600O600<0a/@07lH01<C6a/H:a1;600?4a/H0
7LH00lC6aP0AaP030<K600?600<0a/H03lH10000037Fa]K6e/KFa]K60<KFa]K6e/KFa]H0a<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00W406SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6
e/KFa]K6e/KFaP40000:aP030<K600W600<0a<H03/H:a0K600?4a/H07LH00lC6aP0MaP03a<K60136
00<0a/H01<H00`36aP0>aP4000007MK6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a/C6e/KF00[407_6e/KF
a]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0
0@0000[600<0a/H02/H00`34a003a1_600?4a/H07LH00lC6aP0MaP03a<K600o600<0a/H01<H00`36
aP0>aP400000X]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP34e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP40000:aP03
0<K600_600<0a/@07lH00lC6aP0LaP03a<K601g600?4a/H03/H00`36aP05aP030<K600g60@00002=
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eP3Fa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6eP3F00G40100a]K6e/KFa]K6e/KFa]K60@0000[600<0a/H03LH00`34
aP0NaP03a<K601c600?4a/H07<H00lC6aP07aPS400<0a<H01<H00`36aP0=aP400000N=K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6eP34a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP_401o6e/KF
a]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K600400009aP030<K600o600<0a/@07/H00lC6aP08aP03
?lK6017600?4a/H04<H:a0;600?4a/H03/H00`36aP05aP030<K600c60@00001Ke/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFaP34e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]Ho
e/Hoa]K6e/KFa]K6e/KFa]K6eP040005a]K6e/H02/@0==K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/H100002LH00`36aP0AaP030<C601g600?4a/H01/H01do6
a/I?aTl03<H00l@0000400C45lH00lC6aP0=aP030<K600G600<0a/H03<H1000004oFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KF?mK6
?lKF?mHoe/KF00[42000@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6eP3F
a]K6e/KF0=K6e/KFa]K6e/KFa]K600400009aP030<K601;600<0a/@07LH00lC6aP02aP04?lK4C`;4
00<oCl@00l@:aPP06/H00lC6aP0=aP030<K600K600<0a/H02lH1000003_Fa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0<C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP07a00G?l@o?mK6eSoFa]K6
e/KFa]K6e/KFa]H02000@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6eP3F
a]K6e/KFaP36e/KFa]K6e/KFa]K600400009aP030<K601?600<0a/@03/H;a0C600@oa<I?0/H013o6
aTl@aPP06lH00lC6aP0<aP030<K600K600<0a/H02lH1000002KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36a<KFaP[402[Fa]K6e/KFa]K6e/KF?mHoa<Hoa]HoeSoFa]K6e/KFa]K6e/KFa]K6
e/H60012e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K60@0000W600<0a/H05LH5a1G600<oaSl00/H01dloa/I?aTl05<H40003a<K601_6
00?4a/H02lH00`36aP07aP030<K600[60@00000je/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o00O6e/KF?mK6008o01GFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00cl0A=K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K60@0000W600<0a/H05/H00`36a00EaP03ClI?00C600@oa<I?5/H01Cm?
?lK401g600?4a/H02lH00`36aP03aPC400<0a<H02/H1000003_Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP34a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0Na]K6?lKF?mK6e/KFa]K6e/KF
a]K6e/KFa]K6e/KF0cl0:=K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/H5a003
0<C400?40176e/KF0=K6e/KFa]K6e/KFaP0100002LH00`36aP0HaP030<C600k600Poa/K6?dloC`;6
00Doa/K6?`0GaP03?dlo00;600?4a/H06<H;a0G600<0a/H02<H00`36aP09aP400000>=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KF?mK60Sl08MHoeSoF?mK6
?lK4a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`0Be/KFa=K6e/KFa]K6e/KFa]K62l@09lKFa/C6e/KF
a]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFaP0100002LH00`36aP0IaP030<K400k600E?a/Ho
C`03aP07ClK6aTo6a00FaP03?dlo00?600C4a/K62l@?aP03a<K600W600<0a/H02<H00`36aP09aP40
0000=MK6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KF00@o
02;6?lKFaSo6eSoFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KF0cl7a00ma]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K4e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFaP0100002<H00`36aP0KaP03
0<K400[600PoCco6?do6C`C600<oaSl01<H00lC6aP07aP_400<oCcl01<H00lC6aP0JaP03a<K600W6
00<0a/H02LH00`36aP08aP400000>=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa=K6e/KFa]K6?lKFaSo60Sl02mK6e/KF?mHoe/KF00_400_Fa]K6e/KFa]K6eP03?`14e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K6
e/H100002<H00`36aP0MaP030<C600K600<oClH00lH00co6?`06a003ClC400;40/H00lC6aP0AaP03
?dlo00G600?4a/H06/H00lC6aP08aP030<K600W600<0a/H02<H1000002oFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<K4a]K6eP02a003?l@o00?402@oa3oFa]K6e/Hoa]K6e/KF
a=K6e/KFa]K6e/KFa]K6e/KFa]H3?`14e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/H100002<H00`36aP0NaP030<C400?40lH01Dlo
Ccm?00?600=?a/H00lH00do6aP05aP03a<K600o600=??dl01lH00lC6aP0JaP03a<K600S600<0a/H0
2LH00`36aP07aP400000;mK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
a<KF00Po00?6e/H00Sl07MK6eSoFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KF00@o03K6e/KFa]K6a<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFaP36e/KFa]H60009a]K6e/KFa]K60040
0008aP030<K601o60180a/C6Ccm??lHoCcm??dloaSl3aP03?lK600O600?4a/H03<H01DloCcm?00S6
00?4a/H06LH00lC6aP05aPX01LH00`36aP07aP400000==K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/@oa]Hoe/H3?`0Pa]K6e/Hoa]Hoe/KFa]K6e/KFa/C6e/KFa]K6e/KF
a]H3?`0TeSloa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K610000l@00004000Ia]K60<KF
a]K6e/KFa]K60<KFa]K6e/KFaP0100002<H00`36aP0QaP0:0<I?aTloCcm??`O600<oClH02/H00lC6
aP09aP03Ccm?00;600<oClH02<H00lC6aP0;aPX03/H00`36aP09aP030<K600O60@00000]e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00@o02C6eSoF?mK6e/KFa]K6?lKF
a]K6e/KFa]K6e/CFa]K6e/KFa]H3?`03e/KF008o00g6e/KFa]K6e/K4a]K600X002kFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K60@0000S600<0a/H08LH01DloCcm?00;6
00@oaSm?1lH00do6aP0;aP03a<K600G600=??dl01<H013m?a/H80003a00002;600<0a/H02LH00`36
aP07aP400000:mK6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H013l01/Ho
aSo6eP<o01_Fa]K6e/KF?mK6e/KFa]K6e/KFa/C6e/KFa]H00cl5008o0P00@lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFaP36e/KFa]K6e/H00@0000S6
00<0a/H08LH034loC`36?dloCco6?`O600<oa/H02LH20008a00003m??dl6aP03?do602k600<0a/H0
2LH00`36aP07aP400000:]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o
00C6eSoF0Sl03<Hoa]K6?lKFa]K6eP8o2P000lKF?`06?`07e/KFa]K6eP02?`15a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K60040
0008aP030<K601k600<oClH00/H024loCcm?aTo60`0023l004loC`1?2LH00dloC`03aP03ClK600S6
00<oClH0;/H00`36aP09aP030<K600O60@00000[e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]HoeP03?`06e/KF?`0o0P000mK6eP03?`0;e/KFa]Hoe/KFa]H013l04<KFa]Hoe/KF
a]K6e/KFa]H2?`15a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa]K6e/KF0=K6e/KFa]K600400007aP030<K601k600I??dloCcl3aP03?lHo00;600=??dl0
2LH01Do6Ccm?00;600<oa/H00/H00do6aP0;aP03Cco602g600<0a/H02/H00`36aP06aP4000009mK6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP05?`05eSloa]H01Cl02mK6e/KFa]K6
e/KF00<o05kFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K60@0000O600<0a/H07<H03dlo
Cco6?dloCcm?04loC`09aP03Ccm?00K600<oa/H00/H00do6aP0=aP04ClK6?bc600<0a/H02/H00`36
aP06aP400000:]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaP<o00?6eSl0
1Cl01LKFa]K600@o06CFa]K6e/KFaSo6e/KF?mK6e/KFa]K6e/KFa]K6e/Hoa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K60@0000O6
00<0a/H06lH043o6aTloaSm??do6Cco6?dl2aP05?dloaSl02LH00co6aP02aP03ClK600o600E?a/K6
C`0[aP030<K600[600<0a/H01/H1000002GFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00Ho00K6e/KF?mH6?`0Ba]K6?lKFa]K6e/KFaSo6e/KF0Sl0ElKFa]K6e/KFa]K6e/KFa]K6?lKF
a]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3F
a]K6e/KFaP0100001lH00`36aP0JaP07Ccm??do6C`02aP07?do6aSm??`05aP03?lK600K600=??lH0
0lH00dloaP0AaP03ClK600?600=?a/H09lH00`36aP0:aP030<K600K60@00000Se/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H03Sl03P0o?mK6e/Hoa]K6e/KF13l0GlKFa]HoeSoFa]K6e/KF
a]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa]K6e/KF0=K6e/KFa]K600400007aP030<K601W6014oaSm??dloaSm??dloaP1??`03aP03
?lK600?600DoClK6?`04aP04ClK6?a;600=?a/H01LH00do6aP0LaP03?lK600K600<0a/H02/H00`36
aP06aP4000009=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPTo00?6?cl00Sl02=Ho
e/Hoa]K60cl0ILKFaSo6e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFaSo6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K600400007aP03
0<K601[600i?aTloClI??dloCco6?`;600Q??lHoCco6?`?600<oa/H00/H01Do6a/I?01?600=?a/H0
1LH00dloaP0LaP03?lK600O600<0a/H02LH00`36aP06aP4000008]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H9?`05aSo6e/H01cl0ClKFaSo6e/Hoa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KF
a]K6e/Hoa]K6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/H00Sl06]K6e/KF0=K6
e/KFa]K6e/KF0=K6e/KFa]K60@0000O600<0a/H05/H034loa/I??dloCcm??`;600I??dloCcl5aP05
?lK6aSl00lH00cm?aP03aP03?lK6017600<oClH01/H014o6aSlFaP03Cco600;600<oCcl01lH00`36
aP09aP030<K600K60@00000Se/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H03Sl03@0o
a]K6e/Hoa]K6?lH00cl06/Hoa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KF0Sl07/KFa]K6e/KF?mK6?lKF
a]K6e/KFa]K6e/KFa]K6ePLo023F?mK6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFaP400006aP03
0<K601W6019??lK6Ccm??dloCcm??lHoCcl3aP07?lK6aSm??`03aP03?lK600;600=??lH04/H00cm?
aP07aP04?lK6Ca3600DoCcm??`05aP03?lK600C600A??lH02lH00`36aP06aP4000008mK6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF00Po00?6?cl013l02=Hoe/Hoa]K60Sl02MK6e/Hoa]K6
eP02?`0Ca]K6e/KFa]K6e/KFa]K6e/KFaP03?`0Ja]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]H2?`06
a]K6e/KF1Cl01=K6e/H2?`0He/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K60@0000K600<0a/H05lH02Dlo
Ccm??dloC`03aP06Ccm??lH00/H024loaSm??dlo0lH00co6aP02aP03ClI?01?600I?aTloCcl5aP03
?lK600;600=?a/H02LH02Do6aSm??dloC`04aP07?lK6Ccm??`03aP030<K600W600<0a/H01/H10000
023Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPdo00C6eSoF1Sl0:LHo?co6e/Hoa]K6eSoF
?mK6e/KFa]K6e/KFa]K6e/KFa]Hoe/Hoa]K6008o00WFa]Hoe/KFa]H00Sl01<KFa]H8?`0:a]K6e/KF
?mK6eP<o00CFa]K60cl05@3Fa]K6e/KFa]K6eP3Fa]K6e/KFaP0100001/H00`36aP0GaP0<Ccm??dlo
Ccm??dlo0/H01TloCcm??`?600@oClI?0/H00co6aP02aP04ClK6?a?600@oa/I?0lH01To6Ccm??`?6
00PoCcm??dloC`G600Y??dloCcm??dlo0/H00dloaP08aP030<K600[600<0a/H01LH10000023Fa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQ4o00D0?lKFaP02?`0Oe/HoaSo6e/KF?mK6?lKFa]K6
e/KFa]K6e/KFaSo6eP02?`0<a]K6?lKF?mK6e/KF13l01/KFaSo6ePLo02cFa]K6eSoFa]K6eSoFa]K6
e/KFa]K6?`3Fa]K6e/KFa]K6e/H0a]K6e/KFaP400006aP030<K601O6019??dloCcm??dloCcm??dlo
aSl2aP03Ccm?00;600<oaSl01<H01Do6a/I?00k600HoCcm?aTl3aP04ClK6?`G600ToaSo6?dloaSl0
0lH01Cm?aTlo00K600E?a/K6C`09aP04Cco600c600<0a/H01LH10000023Fa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaPlo00?6?cl013l00mK6eP03?`03e/KF008o0136eSoFa]K6e/KFa]K6eSoF
0cl02]K6eSoFa]K6?lH3?`0;a]K6eSoFaSo6?lH00cl00lKFaP0:?`03e/Ho00<o00KFa]K6e/H4?`0F
eP3Fa]K6e/KFa]K6e/H0a]K6e/KFaP400006aP030<K601O601E??dloClI??dloCco6?dloClI??dl0
0lH014loaSl2aP03Cco600;600<oClH02LH01Sm??dloC`;600<oa/H00/H00do6C`02aP05?dloaSl0
0/H00dloaP03aP0<Ccm??lHoaSm??dlo0lH00co6aP02aP03Ccm?00;600<oa/H00/H00dl0C`0;aP03
0<K600G60@00000Pe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HD?`03e/KF008o01?6?lKF
?mHoe/Hoa]Hoe/KFa]K600Ho00CFa]K60Sl00mK6eP03?`06e/KFaSo60cl01<KF?mH;?`03e/Ho008o
00[6?lKFa]K6e/KF0cl06]K6e/KF0=Hoe/KFa]K6e/KFaP36e/KFa]K60@0000K600<0a/H05lH04dlo
Ccm??dloCcm??dloCcl0?dl00lH02DloClI?aTo6C`03aP05ClK6aTl00lH024loaSm??lHo1<H01do6
Cco6?dl01LH02Do6aSo6?dloC`05aP06ClI??dlo1LH00cm??`0:aP03Cco600;600<0a/H02/H00`36
aP05aP4000008=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K63cl01/Ho?mK6eP<o00gFaSlo
e/Hoa]K6?lKF00Do00GF?co6eP03?`06e/KF?mK61Sl01MK6eSoF00/o00?Fa]H00Sl02lKF?co6e/KF
a]K600<o00g6e/KFa]K6e/Hoa]H0008o01;Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36aP0GaP0A
Ccm??dloCcm??dloCcm??dl00lH01dloaSm??dl00lH03DloCcm??dloCco6?dl00/H02cm?aTloCcm?
aTlo00;600m??do6Ccm??dloaSo6?dl00/H01cm??dloaSl01LH00co6aP07aP03?do600O600<oC`00
3<H00`36aP05aP4000008=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K63Sl00mHo0004?`03
aSo600Po00?F?mH00cl01=K6?lH3?`03aSlo00<o00K6?cloa]H4?`04a]K6eP8o00?6?cl00Sl00mHo
?`02?`03aSo600<o0136e/KFaSo6e/KFa]K6eSoF0cl01MK6e/KF008o01D0?cloa]K6e/KFa]K60<KF
a]K6e/H00@0000K600<0a/H05lH06TloCcm??dloCcm??dloCcm?aTloaSm??dlo0/H02Dloa/I??do6
C`03aP03Cco600;6014oCcm??dloaSm??dloClI??`02aP0>Ccm??dloaSo6?lHoaSl3aP03?lHo00G6
00<oClH01/H044o6a/I??lHoClI?04loCcl8aP030<K600G60@00000Re/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/HoaPho00<0?cl02Sl02LKF?co6?lHoaP02?`04eSoFaP8o00?F?cl01Cl00mK6
eP04?`04aSloeP8o01S6?cloaSo6eSoFaSo6eSoFaSo6e/KF?mH2?`0;a]K6e/KF?mK6e/H00cl05lHo
0=K6eSoFa]K6e/KFaP36e/KFa]K600400005aP030<K601S6031??dloCcm??dloClI??do6Ccm??lHo
Ccm??do6Ccm?aTloaSm??lHoaSm??dloCcl2aP03Ccm?00?600m??lHoCcm??dloaSo6?dl01<H013o6
aTl2aP04?lK6C`G600E?a/HoC`05aP03ClK600C600@oC`1?2lH00`36aP05aP4000008=K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K64Cl00lHoaP0:?`04eSloaP<o00?6?lH01Sl00mK6?`02?`03
aSlo00do01c6e/Hoa]K6eSoFa]HoeSoFa]Hoe/KFa]Hoe/KF0cl01mK6eSoFa]H00cl05]H0?coFa]K6
e/KFa]K60<KFa]K6e/H100001LH00`36aP0HaP0/Ccm??dloCcm??dloCcm??`0oaSm?aTloCcm??dlo
Ccm??do6Ccm??dloCcl3aP0C?dloCcm??dloCco6?dloCco6?`04aP03ClK600;600<oa/H00/H00dlo
aP03aP03Cco600?600e?a/K6ClI??do6Ccm?00?600M??`36Ccm?00O600<0a/H01LH10000023Fa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQ8o00CF?co60cl00lHo?`04?`03eSlo00<o00?F?cl0
13l00lHo?`0:?`06e/Hoa]K60Sl03]K6e/Hoa]K6eSoFa]K61Cl00lHoaP03?`0:a]Hoe/KF?mK6ePDo
01SFa]K603oFa]Hoe/KFa]K60<KFa]K6e/H100001LH00`36aP0IaP0G?dloCcm??dloCcm??dloClI?
?do6Ccl00/H084loClI?aTloClI?aTloCcm?aTloClI?aTo6Ccm?aTlo0/H01To6a/I??`C600=??lH0
0/H00cm?aP03aP07?do6aSm??`03aP04?do6C`?600=??dl00/H01Cm??dlo00;600<0aTl02LH00`36
aP05aP4000008MK6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0>?`03aSlo008o00?F?cl0
13l02LHo?mHoeSoFaP04?`07eSlo?mK6eP03?`0?e/Hoa]K6?lHoaSo6eSoF008o00k6e/HoaSo6eSoF
?mK6eP<o00?Fa]H00cl00mK6eP02?`03aSlo008o00CFa]K60Sl06=Ho?cl0aSo6e/KFa]K6e/H0a]K6
e/KFaP400005aP030<K601W602PoCcm??dloCcm??dloClI??dloCcm??dloClI??do6Ccm?aTloaSm?
1LH01TloaSo6?`;600U??do6ClI??dl00/H01So6?do6C`;600Hoa/I?aTl3aP03Ccm?00;600XoaSm?
?dloCcm?0/H01Sm??dloC`;600LoCcl0?dlo00W600<0a/H01<H10000027Fa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H03Cl00mHo?`03?`05eSlo?mH02Cl05MHoe/Hoa]K6e/KF?mK6eSoFa]K6
eP04?`0:aSo6?lKFaSo6eP8o00g6e/HoaSo6eSoFaSo6008o00OFaSloe/KF008o00G6?cloaP04?`03
eSlo00<o01@0?cloe/KFa]K6e/KF0=K6e/KFaP400005aP030<K601W602LoCcm??dloCco6?dloCcl0
?dloCcm??dloCcm?aTloCcm??dloCcl00lH00cm?aP02aP03ClK600C600PoClI??do6C`?600E?a/Ho
C`04aP03?do600;600=??dl00/H01Sm?a/HoC`?600=??dl00/H033m??do6Ccm?aTlo00;600<oa/H0
1lH00`36aP04aP4000008MK6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0I?`05eSlo?mH0
13l01LHoa]K600<o00c6e/KFaSo6e/KFa]H4?`0;aSo6?lKFaSo6?lH00Sl00mHo?`02?`08a]Ho?lHo
a]H2?`09a]HoeSoFaSo6008o00CFa]K60cl06LHo?mK60<KFa]K6e/KFa]K6eP3Fa]K6e/H00@0000G6
00<0a/H06LH08cm??dloCcm??dloCcm??dloCcm??dloCcm??lHoCcm?aTlo00C600=?a/H01LH00do6
aP03aP0>ClI?aTloClI?aTloCcl2aP03Ccm?00;600PoCcm?aTloC`;600<oCcl00/H01DloClI?00;6
00HoCcm?aTl2aP07?dloCcl0?`0;aP030<K600C60@00000Qe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF014o00CF?co60cl00lHo?`04?`06eSoFa]K60Sl05=K6e/KFa]Hoe/KFa]K6?lHoaSo6
0cl00lHo?`03?`03aSlo00Lo00K6?lHoa]H4?`03a]Ho00<o00?6e/H01Sl00mHo?`03?`0D03oFa]K6
e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0IaP0P?dloCco6?dloCcm??dloCcm??dloCcm??dloCcm?
aTl4aP03?lK600K600=??lH01<H02co6a/HoaSm?aTlo00;6015??dloaSm?aTloCcm?aTo6C`02aP0B
?lHoaSo6?do6Ccm?aTloCcm?200<aP030<K600C60@00000Qe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o00?F?cl063l01<KFa]H2?`0Ca]K6e/KFa]HoeSoFa]K6eSoFaP02?`03e/Ho008o
00?6e/H00Sl00mHoeP03?`08eSloaSo6?lH2?`03eSoF008o3P06?`0EaP36e/KFa]K6e/KFa]H0e/KF
a]K600400005aP030<K601W601doa/I??dloCcm??dloCcm??dloCcm??dloCcm??`03aP04?do6C`K6
00@oClI?1/H00co6?`02aP03ClI?00;600DoaSm??`02aP03Ccm?00;63P005cm??dloClI??lHoCcm?
?dloCcm??lH000_600<0a/H01<H1000002?Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP02?`03aSlo01Do01K6eSloa]Hoe/KFa]K6?lKFaSo6e/KF13l01lKFaSo6?lH03@0;?`05eSlo?mH0
13l00lHoaP02?`06eSloaSo613l05=H0e/KFa]K6e/KFa]H0e/KFa]K60@0000C600<0a/H06lH064o6
Ccm??dloCcm??dloCcm??dloCco6?`?600<oClH00lH00co6aP02aP03Cco600?600=?aP003@02aP0]
Ccm??lHoCcm??lHoCcm??dloCcm??dloClI??dloCcm??dloClI?aTloClI?00;600<0a/H02LH00`36
aP04aP4000009=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaQ<o00C6?lKF0Sl01LKF
a]K600h00Sl05=Ho?lKFa]Hoe/Hoa]K6e/KF?mK60cl01LHo?co600Do00?6?cl03Sl01]Ho?coFaP8o
01KFa]K60<KFa]K6e/KFa]H0e/KFa]K60@0000C600<0a/H0:LH01036a/H>0004ClI??`;600=?a/H0
0/H00co6?`02aP03Cco600C600@oa/I?1/H02So6aTloaSm??dl2aP0M?dloCco6?dloCcm??do6Ccm?
?dloClI??dloaSl01<H00`36aP08aP030<K600C60@00000Ve/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H>000=e/KFa]Hoe/KFa]K6eP03?`09e/KFaSo6e/KF008o00?6eSl00Sl02=K6
e/Hoa]K61Cl00lKF?`02?`03eSoF00@o00?6eSl02Sl00mHo?`0>?`0Ga]K6e/H0a]K6e/KFa]K6eP3F
a]K6e/H00@0000C600<0a/H04/H=00[600<0a/H03<H013m??dl5aP09ClK6?do6ClI?00;600<oa/H0
0/H01To6a/I??`?602XoCcm??dloCco6?do6Ccm??dloCcm??dloCcm??lHoCcm??dloClI?aTl6aP03
0<K600O600<0a/H01<H1000000_Fa]K60<KFa]K6eP0>000Ua]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa]K6e/KFaP02?`09eSoFa]K6eSoF008o01c6?coF?mK6?lKFa]K6?lKFaSo6?lKFa]Hoe/KF
0Sl00lKF?`02?`03eSlo018o01o6?lHoa]Hoe/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K600400004aPL0
9LH00`36aP0:aP0<?do6aSo6?dloCcm?0lH014loCcl2aP03ClK600;600<oaSl00/H014o6Ccl4aP04
ClK6?`?601/oCco6?dloCco6?dloaSm??dloCcm??do6Ccl03<H00`36aP06aP030<K600C60@000014
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]Hoe/H4?`03e/KF00<o013FaSo6?lKFa]Hoe/HoaSo60Sl03]K6e/KF?mK6e/KFa]K61Sl00mHo
?`0<?`0OaSo6?lKFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFaP0100001lH00`36aP0VaP030<K600g6
00M?a/HoaSm?00?600=??dl00lH014loaSl3aP06?lK6ClI?0/H00cm?aP04aP03ClK600o600=?a/H0
0/H023m??dloCcm?0/H00co6aP08aP030<K600K600<0a/H01<H1000004SFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/HoaSo6?lH5?`0>
a]HoeSoFaSo6?lKFa]H2?`15a]Ho?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K600400009aP030<K602C600<0a/H04<H02So6aTloaSm?
aTl2aP03?lHo00?600<oClH00lH01cm??dloCcl0<LH00`36aP06aP030<K600?60@00000:e/KFa]K6
e/KFaP8003WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]H00Sl00lHo?`02?`03e/KF008o00?6?cl00cl01LKFaSo6008o04CF?cloe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFaP40000<aP03
0<K6027600<0a/H05<H043o6aTloaSm?aTo6ClI??dl3aP09ClI??dloClI?037600<0a/H01LH00`36
aP03aP400000BmK6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeP02?`07a]HoeSoFaP03?`05a]K6?lH00cl0@lHo?co6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/H0
0@0000k600<0a/H07lH00`36aP0GaP03Cco600;600<oa/H00/H01TloaSo6?`;600Q?a/HoaSm??c76
00<0a/H01<H00`36aP03aP400000DmK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF008o00K6e/KFa]H3?`05
eSoF?mH00Sl0?LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F
a]K6e/H0a]K6e/H00@0001360P0NaP030<K601_600=?a/H02/H00cm??`04aP04ClK6?bo600<0a/H0
1<H00`36aP03aP400000F]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP@o04CFa]K6?lKFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFaP40
000CaP030<K601[600<0a/H09lH01Do6ClI?00?600=?a/H0<LH00`36aP03aP030<K600?60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF?mK6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K60@0001G600<0a/H06<H00`36
aP0VaP05?lK6aSl0>LH00`36aP02aP030<K600?60@00000Fe/KFa]K6e/KFa]K6e/KFa]K6e/KFaP80
08[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/H0a]K6e/H100006<H00`36aP0DaP030<K606K600D0a/K60005aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFaP40000JaP030<K601;600<0a/H0
I/H01@36a/H000G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60<KFa]K6
0@0001c600<0a/H04<H00`36aP1WaP040<K600G60@00000Me/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00P00PlKFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KF0=K60<KFa]K60040000OaP030<K600g600<0a/H0J<H01036aP04aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFaP40000QaP030<K600_600<0a/H0
JLH00`360004aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFaP40
000SaP802/H00`36aP1YaP030<H000C60@00002Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60P001=K6e/H100009/H00`36aP06aP030<K606[60P04aP400000W=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8000CFa]K60@0002S600<0a/H01<H00`36aP1RaPX01<H10000
02WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02001Fa]K6eP3Fa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]HC000>e/KFa]K6e/KFa]K6e/H10000:lH01@36a/H003o64P0QaP400000GMK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0B000ca]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000]aP030<H001[64`15aP400000;]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H20008e/KFa]K6e/HB001He/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000_aPT0J/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {-0.00610217, -0.0524439, \
0.0057394, 0.0057394}}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  ButtonBox["Example",
    ButtonData:>"Example C",
    ButtonStyle->"Hyperlink"],
  " (c)"
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  ButtonBox["Parameters",
    ButtonData:>"Example C:parameters",
    ButtonStyle->"Hyperlink"],
  " and L-system interpretation"
}], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"Example C"],

Cell["\<\
r1 = 0.9;   (* contraction ratio for the trunk  *)
r2 = 0.8;   (* contraction ratio for branches   *)

a0 = 45;    (* branching angle from the trunk   *)
a2 = 45;    (* branching angle for lateral axes *)

d  = 137.5; (* divergence angle                 *)
wr = 0.707; (* width decrease rate              *)\
\>", "Input",
  AspectRatioFixed->True,
  CellTags->"Example C:parameters"]
}, Closed]],

Cell[CellGroupData[{

Cell["L-system and turtle interpretation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
plants = runKLSystem[
            plantLSystem[r1,r2,a0,a2,d,wr],9,
            SkipPatterns -> plantSkipPatterns];\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  "Map[\n    turtleInterpretation[#,\n      StartDirection -> \n        \
Transpose[{{0,0,1},{1,0,0},{0,-1,0}}],\n      MaxNumberOfPaths -> 4000,\n     \
 LineThickness -> 0.05,\n      LineHue -> 0.9,\n      GraphicOptions ->\n     \
 {\n        AspectRatio -> Automatic,\n\t      Axes -> False,\n\t      Boxed \
-> True, BoxStyle -> GrayLevel[1],\n\t      ViewPoint -> {-3.6,-0.8,1.5},\n\t \
     FaceGrids -> {{0,0,-1}},\n\t      PlotRange -> All,\n\t      Background \
-> GrayLevel[0.9],",
  StyleBox["\n    ",
    FontFamily->"Times"],
  "      DisplayFunction -> $DisplayFunction\n      }]&,Drop[plants,1]\n  ];"
}], "Input",
  AspectRatioFixed->True],

Cell[TextData[
"Starting turtle interpretation ...\nTime needed: 0.05 Second\nGenerating \
graphics ...\nStarting turtle interpretation ...\nTime needed: 0.116667 \
Second\nGenerating graphics ...\nStarting turtle interpretation ...\nTime \
needed: 0.266667 Second\nGenerating graphics ...\nStarting turtle \
interpretation ...\nTime needed: 0.566667 Second\nGenerating graphics ...\n\
Starting turtle interpretation ...\nTime needed: 1.16667 Second\nGenerating \
graphics ...\nStarting turtle interpretation ...\nTime needed: 2.41667 Second\
\nGenerating graphics ...\nStarting turtle interpretation ...\nTime needed: \
4.85 Second\nGenerating graphics ...\nStarting turtle interpretation ...\n\
Time needed: 10. Second\nGenerating graphics ...\nStarting turtle \
interpretation ...\nTime needed: 20.3333 Second\nGenerating graphics ..."], 
  "Print",
  Evaluatable->False,
  CellOpen->False,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Graphics", "Subsubsection"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.09277 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0217706 1.13101 0.0282753 1.13101 [
[ 0 0 0 0 ]
[ 1 1.09277 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.09277 L
0 1.09277 L
closepath
clip
newpath
p
1 g
.002 w
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
.07914 .12169 m
.85581 .02828 L
s
.93606 .38326 m
.3047 .44368 L
s
.3047 .44368 m
.28397 1.06449 L
s
.28397 1.06449 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.93606 .38326 m
.85581 .02828 L
s
.07914 .12169 m
.3047 .44368 L
s
.3047 .44368 m
.28397 1.06449 L
s
.28397 1.06449 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
p
.4 g
.85819 .03878 m
.08575 .13112 L
s
P
p
.4 g
.88047 .13735 m
.14794 .2199 L
s
P
p
.4 g
.90039 .22549 m
.20386 .29973 L
s
P
p
.4 g
.91832 .30477 m
.25442 .3719 L
s
P
p
.4 g
.93452 .37646 m
.30034 .43745 L
s
P
p
.4 g
.83632 .03062 m
.92038 .38476 L
s
P
p
.4 g
.64418 .05373 m
.76534 .39959 L
s
P
p
.4 g
.45698 .07625 m
.61352 .41412 L
s
P
p
.4 g
.27454 .09819 m
.4648 .42836 L
s
P
p
.4 g
.09668 .11958 m
.31911 .4423 L
s
P
P
p
1 0 .6 r
.02 w
.54374 .27855 m
.54374 .93876 L
s
P
p
1 g
.05 w
.54374 .27855 Mdot
P
p
1 g
.002 w
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
.07914 .12169 m
.85581 .02828 L
s
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.93606 .38326 m
.85581 .02828 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 333}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000Q]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61@005lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001maPT000G6a<K6000GaP400000MMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP08000:a]K6e/KFa]K6eP?401P0a=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000KLH800W62L@00lK4aP0201K60@00001Te/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT000W6e/KFa]K6e/H02<@03=K6e/KFa]K6e/K4aP8001KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0005c62004aP03a<K600?62<@BaP04a<H001K60@00001Ce/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H02@002MK6e/KFa]K6eP09a00Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4aP8001KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0004_6200:aPS41<H00lC6aP0MaP03a00001K6
0@000013e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP080009a]K6e/KFa]K600W404G6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/@0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003[62@07aP03a<K400O4
5/H00lC6aP0LaP04a03601G60@00000be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H8000:e/KFa]K6e/KFaPS405KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa0360<KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000YaPT02LH9a0O600?4a/H07<H00lC6aP0MaP030<H001G60@00000Qe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00P000[6e/K4a]K6e/KF2<@0IlKFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K40=H0e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001W62009aPW46LH00lC6aP0LaP03a<K601c600C40<H05<H10000
013Fa]K6e/KFa]K6e/KFa]K62@002LKFa]K6e/KFaP08a01he/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a03F0=K6e/KFa]K6e/KFa]K6e/KFa]K60@0000c6100:aPS43<H00lC6aP0LaP03
a<K601c600?4a/H07<H00`36000DaP4000004MK6e/KFa]K6e/KFaP36e/CF00W408SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6
e/KFa]K60@0000c600<0a<@00/@NaP03a<K601c600?4a/H06lH00lC6aP0LaP040<K601?60@000029
e/KFa]K6e/KFa]K60<H0a]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H00/@05`34a036e/KFa]K6e/KFa]K6e/KFa]K60040000<aP030<H000;6
00?4a/H07<H00lC6aP0LaP03a<K601_600?4a/H04<H9a0;600@0a/H04lH1000007OFa]K6e/KFa]K6
e/H0a]H0e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6eP09a00Re/KFa]K6
e/KFa]H0a<H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000<aP050<K6aP000/H00lC6aP0KaP03a<K601c6
00?4a/H06lH9a1C600D0a<K6000BaP400000IMK6e/KFa]K6e/KFaP36e/KF0=K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KF00[403?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0<C6eP3Fa]K6e/KFa]K6e/KF
a]K6e/H00@0000c600<0a/H00/H01036a/@NaP03a<K601_600?4a/H02<H9a0W600?4a/H06/H01@34
a/H001;60@00001Ae/KFa]K6e/KFa]H0e/KFa]K60<KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00_404KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa=H0e/KFa]K6e/KFa]K6e/KFa]K60@0000_600<0a/H0
1LH01036a/@MaP03a<K601;62/@LaP03a<K601W600D0a/C6000BaP400000@=K6e/KFa]K6e/KF0=K6
e/KFa]H0e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/H9a01Ia]K6e/KF
a]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
0=K4e/H0a]K6e/KFa]K6e/KFa]K6e/H00@0000_600<0a/H01/H01036a/@MaP03a<K400S44/H00lC6
aP0KaP03a<K601S600<0a/@00/H00`36aP0?aP400000;]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/H9a01[a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6a<H0a]K6e/KF
a]K6e/KFa]K6e/H00@0000_600<0a/H02<H00`36a00<aPW42<H00lC6aP0JaP03a<K601[600?4a/H0
6<H01P36a/C601760@00000Le/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/CFaPW407g6e/KFa]K6e/KF
a]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/K4a]H0e/KFa]K6e/KFa]K6e/KFaP010000
2lH00`36aP09aPG46lH00lC6aP0JaP03a<K601[600?4a/H05lH01036a/@2aP030<K600k60@00002<
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP05a00A0=K6e/KFa]K6e/KFa]K6e/H00@0000_600<0a/H02/H01036
a/@LaP03a<K601[600?4a/H06/H00lC6aP0>aPW400H0a/K4aP0@aP400000N]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]H0e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K62L@07lKFa]K6e/KF
aP36e/CFaP36e/KFa]K6e/KFa]K6e/H00@0000_600<0a/H03<H01036a/@KaP03a<K601[600?4a/H0
5lH:a1;600@0a/K40/H00`36aP0=aP400000ImK6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]H02L@0<]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6a<H0a]K6e/KFa]K6
e/KFa]K60@0000_600<0a/H03LH01036a/@LaP03a<K601S61004aPW43<H00lC6aP0FaP070<K6a/C6
000?aP400000EMK6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/@01P03a014e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/K4aP36e/KFa]K6e/KFa]K6e/H100002/H00`36
aP0@aP030<K401c600?4a/H03<H9a0P06<H00lC6aP0EaP050<K6a/@00/H00`36aP0<aP400000@]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFaPW400W6e/KFa]K6e/H02000A]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa=H0e/KFa]K6e/KFa]K6e/H100002/H00`36aP0AaP040<K6a1K62/@BaPP0
6<H00lC6aP0EaP030<K600;600?4aP003/H1000002oFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K4e/KFa]K6e/KFa]K6eP09a00Le/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFaPP004KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/CF0=K6e/KFa]K6
e/KFa]K60@0000[600<0a/H04lH00`36a003aPW43lH00lC6aP0DaPH06/H00lC6aP0DaP030<K600;6
00C4a/H03LH10000027Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP001L@0<=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP@004S4a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa/C60<KFa]K6e/KFa]K6e/H10000
2/H00`36aP0DaP030<K401_600?4a/H05LH01Cm??lK401[600?4a/H04lH00`36aP05a0030<K600_6
0@00001Ge/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o02_Fa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KF00O401H0a<C6e/K4aP36e/KFa]K6e/KFa]K60@0000[600<0a/H0
5LH01036a/@JaP03a<K601C600<oCcl00/H00lC6aP0GaP03a<K600?62L@7aP030<K600?600?4aP00
3LH1000005OFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa/C6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl06=K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFaP[402KFa]K6e/KFa]K6e/KFa]K60<KFa]K6a<KF0=K6e/KFa]K6e/KFaP40000:aP030<K601O6
00<0a/@06lH00lC6aP0BaP03?dlo00;600?4a/H02LH:a0G600?4a/H04/H00`36aP04aP03a<H000c6
0@00001Ge/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00?Fa]H02l@0>]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K4eP3Fa]K6e/KFa]K6e/H100002/H00`36aP0HaP04
0<K6a1[600?4a/H03lH2a003?dlo00C46/H00lC6aP0AaP030<K600C600?4aP003<H1000004_Fa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]H02/@00lKF?`02?`18e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa=K60<KFa]K6e/KFa]K60@0000[600<0a/H06/H00`36a00GaP[4
3<H00cm??`04aP03a<K601O600?4a/H04LH00`36aP05aP03a<H000_60@00000he/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6a<KFa]K6e/KFa]K6e/H9a00Fa]K6a<KFa]K6e/KF
a]K6e/KFa]K6eP<o04SFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6a<H0a]K6e/KFa]K6e/H100002LH00`36aP0LaP030<K400?62/@=aP03a<K600o6
00<oCcl01LH00lC6aP0GaP03a<K6017600<0a/H01<H00lC6000;aP400000:MK6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00G402WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6eP03?`0he/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/H4a00<0<CFa]K6e/KFa]K60@0000W600<0a/H07/H00`36a00IaP03a<K600k6
00<oCcl01/H00lC6aP0GaP03a<K600_61L@00`34a002a0?600?4aP002/H1000005OFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]H00cl08mK6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KF00_4
00WFa]K6eP3Fa]H010003L@00=K6e/KFa]K6e/H00@0000W600<0a/H07lH00`36a00IaP03a<K600g6
00<oCcl01lH00lC6aP0?aP[42LH;00K600<0a/H02<H1000005OFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6
e/KFa]H00cl03mK6e/KFa]K4e/KFa]K6eP0:a009a]K6e/KFa]K400X001cFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K60@0000W600<0a/H08<H01036a/@HaP03a<K600c600<oCcl01<H;a0K6300BaP03
0<K600O600<0a/H02<H1000005CFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/H3a0<o1<@01]K6e/K4aP/0
03?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/H00@0000W6
00<0a/H08/H00`36a00IaP[40lH00cm??`090003a<K602O600<0a/H01lH00`36aP08aP400000?mK6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K4e/KFa]K6e/KFa]K6
eP0<a003a]H000T00cl0B=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFaP400009aP030<K602?600<0a/@00lH:a0?62@000l@0
aP09aP03?dlo03?600<0a/H01lH00`36aP08aP400000<=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPG400?6eP002P005MK6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`18
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K60@0000W600<0a/H09LH20004a000023600<oCcl0<lH00`36aP07aP030<K600S6
0@00001Ge/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36
aP0VaP030<K602?600<oCcl0<lH00`36aP08aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?600<oCcl0<lH00`36
aP08aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6
e/H100002<H00`36aP0VaP030<K602?600<oCcl0<lH00`36aP08aP030<K600O60@00001Ge/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?6
00<oCcl0=<H00`36aP07aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?600<oCcl0=<H00`36aP07aP030<K600O6
0@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36
aP0VaP030<K602?600<oCcl0=<H00`36aP07aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?600<oCcl0=<H00`36
aP07aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6
e/H100002<H00`36aP0VaP030<K602?600<oCcl0=<H00`36aP07aP030<K600O60@00001Ge/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/H100001lH00`36aP0VaP030<K602C6
00<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C600<oCcl0=<H00`36aP08aP030<K600K6
0@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36
aP0VaP030<K602C600<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C600<oCcl0=<H00`36
aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6
e/H100001lH00`36aP0VaP030<K602C600<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C6
00<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C600<oCcl0=LH00`36aP07aP030<K600K6
0@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/H100001/H00`36
aP0WaP030<K602C600<oCcl0=LH00`36aP07aP030<K600K60@00001Ge/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36
aP07aP030<K600K60@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6
e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36aP0WaP030<K602C6
00<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K60<KFa]K6e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G6
0@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36
aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36
aP08aP030<K600G60@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6
e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001LH00`36aP0XaP030<K602C6
00<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K60<KFa]K6e/H100001LH00`36aP0XaP030<K602C600<oCcl0=/H00`36aP07aP030<K600G6
0@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/H100001LH00`36
aP0WaP030<K602G600<oCcl0=/H00`36aP07aP030<K600G60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0WaP030<K602G600<oCcl0=/H00`36
aP08aP030<K600C60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6
e/H100001LH00`36aP0WaP030<K602G600<oCcl0=/H00`36aP08aP030<K600C60@00001Ge/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0WaP030<K602G6
00<oCcl0=/H00`36aP08aP030<K600C60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0WaP030<K602G600<oCcl0;/H900[600<0a/H01<H10000
05OFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl07mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H03`006]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K60@0000C600<0a/H0:<H00`36aP0UaP03
?dlo00o6400HaP030<K600O600<0a/H01<H1000005OFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0cl?000ia]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KF
a]K600400004aP030<K602S600<0a/H06<H@03O600<0a/H01lH00`36aP04aP400000>]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H@000=e/KFa]K6
e/KFa]K6eP03?`18e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K60@0000C600<0a/H09<H?01g600<oCcl0><H00`36aP06aP03
0<K600C60@00000Ke/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF010002c6e/KF0=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/H100001<H00`36aP05aPl0
5<H00`36aP0UaP03?dlo03W600<0a/H01LH00`36aP04aP4000001=K6e/H8001;e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6eP3Fa]K6e/H100001/H00`36aP0VaP030<K602G600<oCcl0>/H00`36aP05aP03
0<K600?60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/H10000
2<H202G600<0a/H09LH00cm??`0jaP030<K600G600<0a/H00lH1000005OFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H00cl0B=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFaP40000;aP030<K6027600<0a/H09LH00cm??`0kaP03
0<K600C600<0a/H00lH1000000cFa]K6e/KFa]K6e/H20019e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`18e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
0<KFa]K60@0000k600<0a/H07/H00`36aP0UaP03?dlo03c600<0a/H00lH00`36aP03aP400000EmK6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`18e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K60@00013600<0a/H07<H00`36
aP0UaP03?dlo03g600<0a/H00/H00`36aP03aP4000004MK6e/KFa]K6e/KFa]K6e/KF008004C6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eP<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/H0a]K6e/H100004lH00`36aP0IaP030<K602G600<oCcl0?LH00`36aP02aP03
0<K600?60@00001Ge/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/H10000
5LH201S600<0a/H09LH00cm??`0naP050<K6aP001LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/H0a]K6e/H100006<H00`36aP0DaP030<K606O600@0a/H01LH1000001WFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008008O6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/H00@0001_600<0a/H04<H00`36
aP1XaP040<K600G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6
0@0001g60P0?aP030<K606W600@0a/H01<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3F0=K6e/H100008<H00`36aP0;aP030<K606[600<0aP001<H10000027Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P00OlKFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/H00@0002?600<0a/H02<H00`36aP1[aP80
1<H1000009cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H20004e/KFaP40000UaP03
0<K600K600<0a/H0JlH200C60@00000Ve/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H2001/e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62P001=K6
e/H10000:<H00`36aP03aP030<K605364`0>aP400000KmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0B000Qa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000ZaP800/H00`36aP0[aQ<0<lH1000004[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQ8004KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002g60P08aQ<0F<H1000002kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K62@00JlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP400000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0191726, -0.0250049, 
  0.00545875, 0.00545875}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 2.48268 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.680563 2.40937 0.0602343 2.40937 [
[ 0 0 0 0 ]
[ 1 2.48268 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 2.48268 L
0 2.48268 L
closepath
clip
newpath
p
1 g
.002 w
.70991 .06023 m
.72977 2.09047 L
s
.72977 2.09047 m
.06023 2.13246 L
s
.06023 2.13246 m
.10435 .12889 L
s
.10435 .12889 m
.70991 .06023 L
s
.90399 .5545 m
.36076 .60914 L
s
.36076 .60914 m
.34561 2.42244 L
s
.34561 2.42244 m
.93977 2.38978 L
s
.93977 2.38978 m
.90399 .5545 L
s
.70991 .06023 m
.72977 2.09047 L
s
.72977 2.09047 m
.93977 2.38978 L
s
.93977 2.38978 m
.90399 .5545 L
s
.90399 .5545 m
.70991 .06023 L
s
.10435 .12889 m
.36076 .60914 L
s
.36076 .60914 m
.34561 2.42244 L
s
.34561 2.42244 m
.06023 2.13246 L
s
.06023 2.13246 m
.10435 .12889 L
s
p
.4 g
.71508 .0734 m
.11117 .14167 L
s
P
p
.4 g
.76518 .20098 m
.17728 .26548 L
s
P
p
.4 g
.81253 .32158 m
.23982 .38262 L
s
P
p
.4 g
.85736 .43574 m
.29908 .4936 L
s
P
p
.4 g
.89986 .54399 m
.3553 .5989 L
s
P
p
.4 g
.69528 .06189 m
.89089 .55582 L
s
P
p
.4 g
.48946 .08523 m
.70644 .57437 L
s
P
p
.4 g
.28575 .10833 m
.52368 .59275 L
s
P
P
p
1 0 .6 r
.02 w
.7993 .36486 m
.81248 1.28915 L
s
P
p
1 g
.05 w
.7993 .36486 Mdot
P
p
1 0 .6 r
.01414 w
.81248 1.28915 m
.82547 2.20012 L
s
P
p
1 0 .6 r
.01414 w
.81248 1.28915 m
.23207 1.89261 L
s
P
p
1 g
.002 w
.70991 .06023 m
.72977 2.09047 L
s
.72977 2.09047 m
.06023 2.13246 L
s
.06023 2.13246 m
.10435 .12889 L
s
.10435 .12889 m
.70991 .06023 L
s
.70991 .06023 m
.72977 2.09047 L
s
.72977 2.09047 m
.93977 2.38978 L
s
.93977 2.38978 m
.90399 .5545 L
s
.90399 .5545 m
.70991 .06023 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 333}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000FmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
1@00@]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40001BaPT000K6a<C40<A1aP400000BMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02@000mK4a007a003
e/KF00800476e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP010000@LH80003a/C400O43<H204760@00000he/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H900W401GFa]K6e/KFa=K6e/KFa]K6
e/KFa]H00P00@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000daP@000?6a<@02<@>aP03a<K600_600<0a000@<H1000003GFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60004a01Ya]K6e/KF
a]K6a<KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]H0a03Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000daP803LH00lC6aP0<aP03
a<K600[600@0a/@0?lH1000003CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60P00K=K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KF0=K4
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000daP030<H000g600?4a/H03<H00lC6aP09aP040<K403o60@00001Pe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa/@00l@0?`3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000=<H01036aP0=aP03a<K600_62l@01/H0
a/K403k60@000019e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/H0a]K6e/KFa]K6e/KFa=K6eP0:a01?a/C6e/KFa]K6e/KF0=K6e/@0a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000=<H01@36
a/H000G62l@<aP03a<K600O600H0a/K6a00maP400000>MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP05a01Te/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KF0=K6e/@0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000daP030<K600;600<0a/H02lH00lC6aP0<aP03a<K600K600<0a/H0
0/H00l@0aP0kaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6a<KFa]K6e/KF0=K6e/K40=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000daP030<K600?600<0a/H02lH00lC6aP0;aP03a<K600K600<0a/H00lH00l@0aP0jaP400000HmK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/CFa]K6e/KF0=K6eP03a00l0<CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003C600<0a/H01LH00`36
aP0:aP03a<K600_600C4a/K61<@01034a<@2aP03a03603[60@00001Be/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/CFa]K6
e/KFaPW404O6e/KF0=K6e/KFa/@0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP010000=<H00`36aP06aP030<K600[62<@6aP03a<K600C600<0a/H0
0lH303[60@000012e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6eP3Fa]K62L@06/KFa]K6e/KFa]K6e/KFa=K6e/KF0=K6e/KF1000>LKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000=<H00`36
aP07aPC42<H00lC6aP0<aP03a<K600?600<0a/H00lH403W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K4e/KFa]H0e/KFa]K6?l@0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003C600<0a/H02<H00`36aP09aP03a<K600c600?4a/H0
0/H00`36aP04aP04ClK403S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6a<KFa]H0
e/KFa]K6?lK40=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003C600<0a/H02LH00`36aP09aP03a<K600c600G4a/K60005aP03a4o400;400<0a/H0
=LH1000005_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KF00C400<0a<@00l@0?LHoa]K40<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003C6
00<0a/H02/H00`36aP09aP04a<K6aP[400G6a<K60006aP05ClK6a000=lH1000004OFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6
eP0:a01Aa]K6e/KFa]K6e/K4a]H0e/KFa]K6?lKFa/@0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000caP030<K600c61L@7aP03a<K600c600?4aP00
1/H01To6a/K403K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa=H0e/KFa]K6
?lKFa]K40<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0003?600<0a/H03LH00`36aP09aP03a<K600_600?4aP001/H00do6aP02aP03a03603C60@00001X
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa/@0e/KFa]K6?lH4a00f0<CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003?600<0a/H03/H00`36
aP09aP03a<K600_600?40<@01L@00do400030003a03603?60@00001Ee/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa=K6eP09a003eP0000D003`o0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<lH00`36aP0@aP030<K600;62/@:0003aP3600C600=?a/H0
1<H00`36aP0baP400000A]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H5a003aP0000@005340036e/KFa]K6e/KFaP36e/KFaSo6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000caP030<K601761@0DaP030<K600?600=?a/H01<H00`36aP0baP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaSo6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000caP030<K6017600<0a/H05/H00`36aP03aP03
ClK600C600<0a/H0</H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/Hoa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000<lH00`36aP0AaP030<K601K600<0a/H00lH00do6aP04aP030<K603;60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6?lKFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003?600<0a/H04LH00`36aP0FaP03
0<K600?600=?a/H01<H00`36aP0baP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFaSo6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000caP030<K6017600<0a/H05/H00`36aP03aP03ClK600C600<0a/H0</H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/Hoa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<lH00`36aP0AaP03
0<K601K600<0a/H00lH00do6aP04aP030<K603;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6?lKFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0003?600<0a/H04LH00`36aP0FaP030<K600?600=?a/H01<H00`36
aP0baP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaSo6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000caP03
0<K6017600<0a/H05/H00`36aP03aP03ClK600C600<0a/H0</H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/Hoa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<lH00`36aP0AaP030<K601K600<0a/H01<H00co6
aP03aP030<K603;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
eSoFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0003?600<0a/H04LH00`36aP0FaP030<K600C600<oa/H00lH00`36aP0baP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000caP030<K6017600<0a/H05/H00`36
aP04aP03?lK600C600<0a/H0<LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000<lH00`36aP0AaP030<K601K600<0a/H01<H00co6aP04aP030<K603760@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eSoFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003?600<0a/H04LH00`36
aP0FaP030<K600C600<oa/H01<H00`36aP0aaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000caP030<K6017600<0a/H05/H00`36aP04aP03?lK600C600<0a/H0
<LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF?mK6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<lH00`36
aP0AaP030<K601K600<0a/H01<H00co6aP04aP030<K603760@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003?600<0a/H04LH00`36aP0FaP030<K600C600<oa/H0
1<H00`36aP0aaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]Ho
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000caP030<K6017600<0a/H05/H00`36aP04aP03?lK600C600<0a/H0<LH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<lH00`36aP0@aP030<K601O600<0a/H0
1<H00co6aP04aP030<K603760@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6eSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003?600<0a/H04<H00`36aP0GaP030<K600C600<oa/H01<H00`36aP0aaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000baP030<K6017600<0a/H0
5lH00`36aP04aP03?lK600C600<0a/H0<LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000</H00`36aP0AaP030<K601O600<0a/H01<H00co6aP04aP030<K60376
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eSoFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003;600<0a/H0
4LH00`36aP0GaP030<K600C600<oa/H01<H00`36aP0aaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000baP030<K6017600<0a/H05lH00`36aP04aP03?lK600C6
00<0a/H0<LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF?mK6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
</H00`36aP0AaP030<K601O600<0a/H01<H00co6aP04aP030<K603760@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003;600<0a/H04LH00`36aP0GaP030<K600C6
00<oa/H01<H00`36aP0aaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000baP030<K6017600<0a/H05lH00`36aP03aP03Cco600G600<0a/H0<LH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eSoF?mK6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H00`36aP0AaP030<K601O6
00D0a/K6C`02aP03?lK600C600<0a/H0<LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]Hoe/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000</H00`36aP0AaP030<K601O600<0aTl01<H00co6aP04aP030<K60376
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K603oFa]K6eSoFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003;600<0a/H0
4LH00`36aP0GaP030<K600C600<oa/H01<H00`36aP0aaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?`36e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000baP030<K6017600<0a/H05LH00do60006aP03?lK600C6
00<0a/H0<LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/H0a]K6e/KF?mK6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
</H00`36aP0AaP030<K601?600E?a/K60006aP03?lK600C600<0a/H0<LH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/H0a]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H00`36aP0AaP030<K6017600=?a/H0
0lH00`36aP04aP03?lK600G600<0a/H0<<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/H0a]K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000</H00`36aP0AaP030<K600o600=?a/H01LH00`36aP04aP03?lK600G6
00<0a/H0<<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/H0a]K6e/KF?mK6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
</H00`36aP0AaP030<K600g600=?a/H01lH00`36aP04aP03?lK600G600<0a/H0<<H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/H0a]K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H00`36aP0AaP030<K600_6
00=?a/H02LH00`36aP04aP03?lK600G600<0a/H0<<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/H0a]K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H00`36aP0AaP030<K600W600=?a/H02lH00`36aP04aP03
?lK600G600<0a/H0<<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KF0=K6
e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000</H00`36aP0AaP030<K600O600=?a/H03/H00`36aP03aP03?lK600G600<0a/H0<<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H00`36aP0AaP03
0<K600G600=?a/H04<H00`36aP03aP03?lK600G600<0a/H0<<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H00`36aP0AaP030<K600?600=?a/H04/H00`36
aP03aP03?lK600G600<0a/H0<<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000</H00`36aP0AaP050<K6aTl05/H00`36aP03aP03?lK600G600<0a/H0<<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K60<KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF?mK6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H00`36aP0AaP03
0<I?01S600<0a/H00lH00co6aP05aP030<K603360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP0oe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/Hoa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0003;600<0a/H04LH00do6aP0HaP030<K600C600=?a/H01<H00`36
aP0`aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6eSl0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6?lKFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000baP03
0<K600o600=?aP006/H00`36aP04aP03ClK600C600<0a/H0<<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF?mK60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaSo6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<LH00`36aP0>aP05ClK6aP006/H00`36aP04aP03
ClK600C600<0a/H0<<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eSoFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFaSo6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000<LH00`36aP0<aP03ClK600?600<0a/H06<H00`36aP04aP03ClK600C600<0a/H0<<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaSo6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<LH00`36aP0:aP03
ClK600G600<0a/H06<H00`36aP04aP03ClK600C600<0a/H0<<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF?mK6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaSo6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<LH00`36aP0BaP030<K601S600<0a/H01<H00do6
aP04aP030<K603360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/Hoa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@00037600<0a/H04/H00`36aP0HaP030<K600C600=?a/H01<H00`36aP0`aP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6?lKFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000aaP030<K601;600<0a/H06<H00`36
aP04aP03ClK600C600<0a/H0<<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFaSo6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000<LH00`36aP0AaP030<K601W600<0a/H01<H00do6aP04aP030<K603360@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/Hoa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00037600<0a/H04LH00`36
aP0IaP030<K600C600=?a/H01<H00`36aP0`aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6?lKFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000aaP030<K6017600<0a/H06LH00`36aP04aP03ClK600C600<0a/H0
<<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaSo6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<LH00`36
aP0AaP030<K601W600<0a/H01<H00do6aP04aP030<K603360@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/Hoa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00037600<0a/H04LH00`36aP0AaPT01/H00do6aP05aP03
0<K602o60@000019e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP0@0019a]K6e/KFa]H0e/KFa]K6?lKFa]K6e/H0a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000<LH00`36aP05aQ00
6LH00`36aP03aP03ClK600G600<0a/H0;lH10000037Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00P006W6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]H0e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0003;600<0a/H04<H00`36aP0LaP050<K6aTl01lH00`36aP0_aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6?lKFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000daP030<K600k600<0a/H0
7LH01036aTl7aP030<K602o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003K600<0a/H03<H00`36aP0NaP030<K600O600<0a/H0;lH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000><H00`36aP0:aP030<K6023600<0a/H0
1LH00`36aP0_aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000jaP030<K600S600<0a/H08LH00`36aP04aP030<K602o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003c600<0a/H01/H00`36aP0SaP030<K600;600<0a/H0
;lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000?/H00`36
aP04aP030<K602C600D0a/K6000aaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP400010aP030<K600;600<0a/H09/H00`36000aaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP400012aP040<K602W60P0aaP400000IMK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00`00376e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K600400014aP802/HE03g60@000015e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00/0
05;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@000001\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0184322, -0.0250052, 
  0.00582168, 0.00582168}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.69107 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.296016 1.61121 0.0395781 1.61121 [
[ 0 0 0 0 ]
[ 1 1.69107 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.69107 L
0 1.69107 L
closepath
clip
newpath
p
1 g
.002 w
.85198 .04028 m
.88775 1.48379 L
s
.88775 1.48379 m
.04028 1.53533 L
s
.04028 1.53533 m
.08351 .12503 L
s
.08351 .12503 m
.85198 .04028 L
s
.9198 .24194 m
.19654 .31654 L
s
.19654 .31654 m
.16691 1.65079 L
s
.16691 1.65079 m
.95972 1.60599 L
s
.95972 1.60599 m
.9198 .24194 L
s
.85198 .04028 m
.88775 1.48379 L
s
.88775 1.48379 m
.95972 1.60599 L
s
.95972 1.60599 m
.9198 .24194 L
s
.9198 .24194 m
.85198 .04028 L
s
.08351 .12503 m
.19654 .31654 L
s
.19654 .31654 m
.16691 1.65079 L
s
.16691 1.65079 m
.04028 1.53533 L
s
.04028 1.53533 m
.08351 .12503 L
s
p
.4 g
.85821 .05881 m
.09388 .1426 L
s
P
p
.4 g
.87505 .10887 m
.12191 .19009 L
s
P
p
.4 g
.89136 .15739 m
.14911 .23617 L
s
P
p
.4 g
.90719 .20444 m
.1755 .28088 L
s
P
p
.4 g
.64018 .06364 m
.7207 .26248 L
s
P
p
.4 g
.38699 .09156 m
.48246 .28705 L
s
P
p
.4 g
.13819 .119 m
.24809 .31122 L
s
P
P
p
1 0 .6 r
.02 w
.68731 .20923 m
.69317 .66978 L
s
P
p
1 g
.05 w
.68731 .20923 Mdot
P
p
1 0 .6 r
.01414 w
.69317 .66978 m
.69877 1.111 L
s
P
p
1 0 .6 r
.01414 w
.69317 .66978 m
.40522 .96724 L
s
P
p
1 0 .6 r
.01 w
.40522 .96724 m
.14172 1.23946 L
s
P
p
1 0 .6 r
.01 w
.40522 .96724 m
.17627 1.05784 L
s
P
p
1 0 .6 r
.01 w
.69877 1.111 m
.93336 1.41272 L
s
P
p
1 0 .6 r
.01 w
.69877 1.111 m
.70412 1.53179 L
s
P
p
1 g
.002 w
.85198 .04028 m
.88775 1.48379 L
s
.88775 1.48379 m
.04028 1.53533 L
s
.04028 1.53533 m
.08351 .12503 L
s
.08351 .12503 m
.85198 .04028 L
s
.85198 .04028 m
.88775 1.48379 L
s
.88775 1.48379 m
.95972 1.60599 L
s
.95972 1.60599 m
.9198 .24194 L
s
.9198 .24194 m
.85198 .04028 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 333}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000LMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00D002cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40001XaPT01<H00`36aP0ZaP400000GmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00T000WFa]K6e/KFa]H01<@2000[a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP010000E/H90003a<K600G62/@4aP80:lH1000004gFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP090007e/KFa]K6eP0:a00>a]K6e/KFa]K6e/KFa]H2000[a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP010000A<H900K62/@3aP03a<K601;600<0aP00:/H1000003_Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP090005
e/CFa]H02/@0ClKFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003;62@04aP[46<H00lC6aP0?aP;400@0a034
:LH1000002WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP090003e/KF00[4
02[6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]H:a00_a]H0e/H0a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002G61002aP[44/H00lC6aP0EaP[4
3<H01036aP0YaP4000009]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H01L@0:/K4
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6eP[404?6e/K4a]K6e/KFa]K6e/KF
a]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000UaP80
1LH00lC6aP0IaP04a<K6aPW43/H00lC6aP0?aP050<K6aP00:<H1000004;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/H:a00Ze/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa/@00l@0:@3Fa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000UaP030<H000G600?4a/H02<H:a0O600?4a/H06<H00lC6
aP04aPW400?60<H00/H00`36aP0VaP400000;]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/H0a]K6e/H:a00Ye/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
2/@0=lKFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@0002G600@0a/H01L@00lK4aP0IaP03a<K600[62/@2aP<03lH00`36aP02aP030<K602G60@00001>
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/K4a]K62L@02lKFa]K6e/KFa]K600D003_6e/KFa]K6e/KFa]K6eP3Fa]K60<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100009LH00`36aP02aP030<K600?6
00?4a/H04LH:a1C61@0>aP030<C400?400<0a/H09<H1000003[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/K4a]K6e/KFa]K62/@07]K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaPD000K6e/KFa]H8a00]0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000UaP030<K600?600<0a/H00lH9a17600?4a/H05LH300O42<H00`36aP03aP03
0<K602C60@00000/e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP06a00X
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFaPW40Sl0?LKFa=K6e/KFa]K6e/KF
a]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002G600<0a/H0
1<H00`36aP03aP03a<K601O600C4a/K62/@9aP05?do6a/@03/H702G60@000017e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]H0
2L@04mK6e/KFa]K6e/KFa]K6e/KFa]H00Sl02LKFa=K6e/KFaP09000[a]K6e/H0a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100009LH00`36aP05aP030<K600?600?4a/H01lH:a0K6
00?4a/H04lH00cm?00020003a00000<02<H00`36aP03aP030<K602?60@00000de/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFaPW401k6e/KFa]K6e/KFa]K6e/KF
a/C6e/KFa]K6e/KFa]H8008o03g6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000TaP030<K600O600<0a<@01<@IaP04a<K6aPT02<H00cm?
aP0@aP030<K600?600<0a/H08lH1000004SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6eP3Fa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/H7000Da000e/KFa]K6e/KFa]K6e/KF
a]H2?`0ma]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100009<H00`36aP09aP030<K600;600?4a/H01lH901_600<oClH04<H00`36aP03aP03
0<K602?60@00000ge/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
0<KFa]K6a008000Ta]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0Sl0?LKFa]K6e/KF
a]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002C6
00<0a/H02/H502g600<oClH04<H00`36aP03aP030<K602?60@00001Se/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o03g6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000TaP030<K600[600<0a/H0;lH00cm?aP0@aP03
0<K600?600<0a/H08lH1000006?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0Sl0?LKFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0002C600<0a/H02/H00`36aP0_aP03?do6013600<0a/H00lH00`36aP0SaP400000HmK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0ma]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100009<H00`36aP0:aP03
0<K602o600<oClH04<H00`36aP03aP030<K602?60@00001Se/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF008o03g6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000TaP030<K600[600<0a/H0;lH00cm?aP0@aP030<K600C6
00<0a/H08/H1000006?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl0?LKF
a]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@0002C600<0a/H02/H00`36aP0_aP03?do6013600<0a/H01<H00`36aP0RaP400000HmK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0ma]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100009<H00`36aP0:aP030<K602o6
00<oClH04<H00`36aP04aP030<K602;60@00001Se/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o03cFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100009<H00`36aP0:aP030<K6033600=??lH03lH00`36aP04aP030<K602;6
0@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6
e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36
aP0:aP030<K6033600=??lH03lH00`36aP04aP030<K602;60@00001Te/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36aP0:aP030<K6033600=??lH03lH00`36
aP04aP030<K602;60@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o
03cFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100009<H00`36aP0:aP030<K6033600=??lH03lH00`36aP04aP030<K602;60@00001Te/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K60<KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36aP0:aP030<K60336
00=??lH03lH00`36aP04aP030<K602;60@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100009<H00`36aP09aP030<K6037600=??lH03lH00`36aP04aP030<K602;6
0@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6
e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36
aP0:aP030<K6037600=??lH03lH00`36aP04aP030<K602;60@00001Te/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0:aP030<K6037600=??lH03lH00`36
aP04aP030<K602;60@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o
03cFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008lH00`36aP0:aP030<K6037600=??lH04<H00`36aP03aP030<K602;60@00001Te/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0:aP030<K60376
00=??lH04<H00`36aP03aP030<K602;60@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008lH00`36aP0:aP030<K6037600=??lH04<H00`36aP03aP030<K602;6
0@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36
aP0:aP030<K6037600=??lH04<H00`36aP04aP030<K602760@00001Te/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o03cFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0:aP030<K6037600=??lH04<H00`36
aP04aP030<K602760@00001Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o
03cFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008lH00`36aP0:aP030<K6033600<oaSl04LH00`36aP04aP030<K602760@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H02/H00`36aP0^aP05
?lK6aSl04LH00`36aP04aP030<K602760@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002?600<0a/H02/H00`36aP0/aP03?lK600?600<oa/H03lH00`36aP04aP03
0<K602760@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]Hoe/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?6
00<0a/H02/H00`36aP0ZaP03?lK600G600<oa/H03lH00`36aP04aP030<K602760@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H02/H00`36aP0XaP03
?lK600O600<oa/H03lH00`36aP04aP030<K602760@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H02/H00`36aP0VaP03?lK600W600<oa/H03lH00`36
aP04aP030<K602760@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002?600<0a/H02/H00`36aP0TaP03?lK600_600<oa/H03lH00`36aP04aP030<K602760@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H02lH00`36
aP0RaP03?lK600g600<oa/H03lH00`36aP04aP030<K602760@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H02lH00`36aP0PaP03?lK600o600<oa/H0
3lH00`36aP04aP030<K602760@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002;600<0a/H02lH00`36aP0NaP03?lK6017600<oa/H03lH00`36aP04aP030<K60276
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H0
2lH00`36aP0LaP03?lK601?600<oa/H03lH00`36aP04aP030<K602760@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H02lH00`36aP0JaP03?lK601G6
00<oa/H03lH00`36aP04aP030<K602760@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002;600<0a/H02lH00`36aP0HaP03?lK601O600<oa/H03lH00`36aP05aP03
0<K602360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;6
00<0a/H02lH00`36aP0FaP03?lK601W600<oa/H04<H00`36aP04aP030<K602360@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H02lH00`36aP0CaP03
Cco601c600<oa/H04<H00`36aP04aP030<K602360@000013e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP04?`1Ka]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100008/H00`36aP0:aP030<K600k600=??dl00/H00co6aP0MaP03
?lK6013600<0a/H01<H00`36aP0PaP400000?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60Sl0H]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002;600<0a/H02/H00`36aP09aP03?dlo00G600<oa/H07lH00co6aP0@aP03
0<K600C600<0a/H08<H1000003SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6eP3Fa]K6e/KFaP<o06O6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]Hoe/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000RaP030<K600[600<0a/H01<H00dloaP08aP03?lK6027600<oa/H04<H00`36aP04aP03
0<K602360@00000ce/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0
e/KF00<o06cFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
8/H00`36aP0:aP0404loC`c600<oa/H08lH00co6aP0@aP030<K600C600<0a/H08<H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36aP0:aP030<K600_6
00<oa/H09LH00co6aP0@aP030<K600C600<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36aP0:aP030<K600W600<oa/H09lH00co6aP0@aP03
0<K600C600<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008/H00`36aP0:aP030<K600O600<oa/H0:LH00co6aP0@aP030<K600C600<0a/H08<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6e/KFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0;aP03
0<K600G600<oa/H0:lH00co6aP0@aP030<K600C600<0a/H08<H1000006GFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eP3Fa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0ka]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00027600<0a/H02lH00`36aP03aP03?lK602g6
00<oaSl04<H00`36aP04aP030<K602360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]H0e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@00027600<0a/H02lH01@36a/Ho037600Doa/K6?`0>aP030<K600C600<0a/H0
8<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eP3FaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]Hoe/KFa]K6
e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36
aP0;aP030<Ho03?600<oa/H00/H00do6aP0;aP030<K600C600<0a/H08<H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eP0oa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6e/H0a]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0;aP03?lK603?600<oa/H0
1<H00do6aP09aP030<K600C600<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6?`3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008LH00`36aP09aP03?lH003G600<oa/H01LH00co6aP08aP030<K600G6
00<0a/H07lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaSo6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFaSo6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
8LH00`36aP07aP05?lK6aP00=LH00co6aP07aP03?lK600K600<0a/H01LH00`36aP0OaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/Hoa]K6e/KFaP36
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600_600<0a/H0
<lH00co6aP09aP03?lK600C600<0a/H01LH00`36aP0OaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFaSo6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600_600<0a/H0<lH00co6aP0:aP03ClK600?6
00<0a/H01LH00`36aP0OaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/KFa]K6e/KFa]Hoe/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000QaP030<K600_600<0a/H0<lH00co6aP0<aP05ClK6aP001lH00`36aP0OaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6eSoFaP36
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600_600<0a/H0
<lH00co6aP0>aP04ClK600K600<0a/H07lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6?lKF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008LH00`36aP0;aP030<K603C600=?a/H03/H00co60006aP030<K601o6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6?`3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H0
2lH00`36aP0daP03ClK6013600<0a/H01<H00`36aP0OaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]H0?lKFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600_600<0a/H0=<H00do6aP0@aP0304o600C6
00<0a/H07lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KF0=Hoe/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
8LH00`36aP0;aP030<K603C600=?a/H04<H01036aTl3aP030<K601o60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6eP3Fa]Hoe/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H03<H00`36aP0daP03ClK60136
00<0a/H00/H00do6000QaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000PaP030<K600c600<0a/H0=<H00do6aP0@aP030<K600C600<0a/H07lH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0;aP030<K603G6
00=?a/H04<H00`36aP04aP030<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@00023600<0a/H02lH00`36aP0eaP03ClK6013600<0a/H01<H00`36aP0OaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600_6
00<0a/H0=LH00do6aP07aPX01lH00`36aP0NaP400000G]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/HB000be/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008<H00`36aP0;aP030<K601_64P08aP03ClK6017600<0a/H01<H00`36aP0NaP400000>mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF0140
05KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600K64P0[aP03ClK601;600<0a/H0
0lH00`36aP0NaP4000008=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62@00NLKFa]K60<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KF
a]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002;6
00<0a/H02LH00`36aP1;aP030<K600;600<0a/H07/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36aP07aP030<K604g600@0a/H08<H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36aP05aP030<K604k6
00<0aP008<H1000002OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P00NLKF
a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@0002W600<0a/H00/H00`36aP1?aP808<H1000007OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0;000Pe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000:lH01036aP0caQD0:lH1000004gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0E0010e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000]aP802LHE05G60@00000^e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaPX006[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000:;6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000001\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0137343, -0.0245695, 
  0.00592981, 0.00592981}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.44977 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.187636 1.41391 0.0353477 1.41391 [
[ 0 0 0 0 ]
[ 1 1.44977 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.44977 L
0 1.44977 L
closepath
clip
newpath
p
1 g
.002 w
.84222 .03535 m
.87694 1.20834 L
s
.87694 1.20834 m
.03535 1.26089 L
s
.03535 1.26089 m
.0808 .12134 L
s
.0808 .12134 m
.84222 .03535 L
s
.92588 .30666 m
.23827 .37606 L
s
.23827 .37606 m
.21233 1.41442 L
s
.21233 1.41442 m
.96465 1.37291 L
s
.96465 1.37291 m
.92588 .30666 L
s
.84222 .03535 m
.87694 1.20834 L
s
.87694 1.20834 m
.96465 1.37291 L
s
.96465 1.37291 m
.92588 .30666 L
s
.92588 .30666 m
.84222 .03535 L
s
.0808 .12134 m
.23827 .37606 L
s
.23827 .37606 m
.21233 1.41442 L
s
.21233 1.41442 m
.03535 1.26089 L
s
.03535 1.26089 m
.0808 .12134 L
s
p
.4 g
.86273 .10186 m
.11931 .18363 L
s
P
p
.4 g
.88682 .17998 m
.16461 .25691 L
s
P
p
.4 g
.90948 .25348 m
.20732 .32599 L
s
P
p
.4 g
.75267 .04546 m
.84525 .3148 L
s
P
p
.4 g
.58825 .06403 m
.69704 .32976 L
s
P
p
.4 g
.42614 .08234 m
.55071 .34453 L
s
P
p
.4 g
.2663 .10039 m
.40622 .35911 L
s
P
p
.4 g
.10868 .11819 m
.26353 .37351 L
s
P
P
p
1 0 .6 r
.02 w
.64649 .22961 m
.64978 .51664 L
s
P
p
1 g
.05 w
.64649 .22961 Mdot
P
p
1 0 .6 r
.00707 w
.3069 .86951 m
.24954 1.00819 L
s
P
p
1 0 .6 r
.00707 w
.7984 .97557 m
.80656 1.11654 L
s
P
p
1 0 .6 r
.01414 w
.64978 .51664 m
.65288 .78796 L
s
P
p
1 0 .6 r
.01414 w
.64978 .51664 m
.47043 .70122 L
s
P
p
1 0 .6 r
.01 w
.47043 .70122 m
.3069 .86951 L
s
P
p
1 0 .6 r
.01 w
.47043 .70122 m
.33035 .7525 L
s
P
p
1 0 .6 r
.00707 w
.3069 .86951 m
.15797 1.02278 L
s
P
p
1 0 .6 r
.00707 w
.7984 .97557 m
.92861 1.14343 L
s
P
p
1 0 .6 r
.01 w
.65288 .78796 m
.7984 .97557 L
s
P
p
1 0 .6 r
.01 w
.65288 .78796 m
.65581 1.04344 L
s
P
p
1 0 .6 r
.00707 w
.33035 .7525 m
.19607 .80167 L
s
P
p
1 0 .6 r
.00707 w
.33035 .7525 m
.20975 .87619 L
s
P
p
1 0 .6 r
.00707 w
.65581 1.04344 m
.65856 1.28313 L
s
P
p
1 0 .6 r
.00707 w
.65581 1.04344 m
.61288 1.14839 L
s
P
p
1 g
.002 w
.84222 .03535 m
.87694 1.20834 L
s
.87694 1.20834 m
.03535 1.26089 L
s
.03535 1.26089 m
.0808 .12134 L
s
.0808 .12134 m
.84222 .03535 L
s
.84222 .03535 m
.87694 1.20834 L
s
.87694 1.20834 m
.96465 1.37291 L
s
.96465 1.37291 m
.92588 .30666 L
s
.92588 .30666 m
.84222 .03535 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 333}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000MMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP06000Wa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001/aPT01LH00`36aP0UaP400000HmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP09000fe/KFa=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0005W62P0=aP03a<K600O60P0VaP400000D=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
2@008LKFa=K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFaP02000Ve/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000AlH900c600?4a/H04LH00lC6aP07aP809/H1000003kFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT0
05_4e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/H0aP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000daPX02LH00lC6aP0BaP03a<K601;6
00?4a/H01/H00`36000UaP400000:mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H02@00A<C6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K60/@0:0340<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008/H900W600?4a/H04LH00lC6aP0BaP03a<K600o62L@2aP040<K602C60@00000Me/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H01@00A=K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K62L@0<lKFa/C6e/KFa]K60<KF0=K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007LH01@36a/K401?600?4a/H04LH00lC6
aP0AaPW43<H00lC6aP05aP040<K602C60@00000Me/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0P00=LKFa/C6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K600W4
04G6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001g600<0aP000lH00lC6aP0@aP03a<K601762/@;aP03a<K6017600?4a/H0
1<H01@36a/H002?60@000012e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K62/@0E]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001g6
00@0a/H00lH00lC6aP0AaP[42LH00lC6aP0BaP03a<K6017600?4a/H01<H01036aP0SaP400000<=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa/C6e/KFa]K6e/KFaPW406W6e/KFa]K6e/KF
a]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]H0e/KF
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001g600D0a/K60003aP03a<K400S4
2LH00lC6aP0@aP03a<K601;600?4a/H04LH00lC6aP03aP060<C4a0348LH1000002;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K61L@0C<KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KF
a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]H8a00W0=K6eP3Fa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000MaP030<K600;600D0a/K6a00CaP03a<K60136
00?4a/H04/H00lC6aP05aPW40/H00lC6aP03aP030<K600;600<0a/H07lH10000067Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K4e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KF00W403SFa]K6e/KFa]K6e/K4a]K6eP3Fa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K600C600@0a/K44lH00lC6aP0@aP03
a<K600O62L@4017600?4a/H00/H00`36aP02aP030<K601o60@00001?e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K60<KFa/C6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
eP09a008e/KFa]K6e/H6000le/KFa]K6e/KFa]K6e/KFa/C6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001g600<0a/H01LH01@36a/K401;600?4a/H02<H9a1361P0AaP05
a<K6aP001LH00`36aP0NaP400000?MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
0<KFa=K6e/KFa]K6e/KFa]K6e/KFa]H02/@06LKFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/H01P00?=K6
e/KFa]K6e/KFa]K6e/KFa=K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000LaP030<K600O600D0a/K6a00:aPW44/H00lC6aP0=aPH04/H01<C6aP05aP030<K601k60@00000[
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6eP0:a00/a]K6e/KFa]K6a<KF
a]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]H4000Ha=K6e/KFa]K6e/KFa]K6e/KFa/C6eP3F
1L@08036e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H02LH4a1;600?4a/H0
4<H00lC6aP0=aP05?do6a/@03/H7a0030<C600C600<0a/H07LH10000067Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa/C6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KF008o00O6e/CFa]K600[402kFa]K6e/CF0=K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H02/H01036a/@BaP03a<K6013600?4a/H0
3<H00cm?a006a0o600?4aP001lH00`36aP0LaP400000EmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFaP36e/CFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa=K6
eP0:a08o03o6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa=H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001c600<0a/H02lH01@36a/K4017600?4a/H02lH9a0[600<oClH00lH00lC6
aP0@aP03a03600K600<0a/H07<H1000004GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KF0=K6a<KFa]K6e/KFa]K6e/KFa]K6e/CFa]H02L@04mK6e/KFa/C6e/KFa]K6e/KFa]H0
0Sl0?lKFa]K4e/KFa]K6e/KFa]K6e/KFa]K6a03Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100007<H00`36aP0=aP040<K6a0_62/@?aP03a<K600[600<oClH01<H00lC6aP0?aP03
a03600;61P0MaP400000<]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
0<KFa=K62L@09/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KF0Sl04LKFa]K6a<KF
a]K6e/KFa]K600/002?6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007<H00`36
aP0>aPG44LH00lC6aP0?aP03a<K600W600<oClH01<H00lC6000900O600<0a/H01/H00`36aP0KaP40
0000HMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K4e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFaP000Sl6000ia=K6e/KFa]K6e/KF
a]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000LaP030<K600o6
00@0a/K44/H00lC6aP0>aP030<@000P000?6?dl06<H00`36aP06aP030<K601_60@00001;e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/K4a]K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KF00X000c6e/CFa]K6e/KFa]H2?`0oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF
a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000LaP030<K6013600@0a/K43/H40003
a00000<05/H00cm?aP0GaP030<K600K600<0a/H06lH1000003KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K4e/H;000Pa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]H2?`0oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000LaP030<K601;60`000l@0aP0ZaP03?do601O600<0a/H01/H00`36
aP0KaP400000HMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl0?]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c6
00<0a/H04/H00`36aP0^aP03Cco601K600<0a/H01/H00`36aP0KaP400000H]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04/H00`36aP0^aP03Cco601O6
00<0a/H01LH00`36aP0KaP400000H]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0Sl0?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001c600<0a/H04/H00`36aP0^aP03Cco601O600<0a/H01/H00`36aP0JaP400000H]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0?]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04/H00`36
aP0^aP03Cco601O600<0a/H01/H00`36aP0JaP400000H]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60Sl0?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001c600<0a/H04/H00`36aP0^aP03Cco601O600<0a/H01/H00`36
aP0JaP400000H]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0?]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001_6
00<0a/H04lH00`36aP0^aP03Cco601O600<0a/H01/H00`36aP0JaP400000H]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001_600<0a/H04lH00`36aP0^aP03Cco601O6
00<0a/H01/H00`36aP0JaP400000H]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0Sl0?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001_600<0a/H04lH00`36aP0^aP03Cco601O600<0a/H01/H00`36aP0JaP400000H]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0?]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001_600<0a/H04/H00`36
aP0_aP03Cco601O600<0a/H01/H00`36aP0JaP400000H]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60Sl0?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001_600<0a/H04/H00`36aP0^aP03?lHo01S600<0a/H01/H00`36
aP0JaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP03
0<K601;600<0a/H0;<H01Co6a/Ho01S600<0a/H01/H00`36aP0JaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601;600<0a/H0:/H00co6aP03aP03
?lK601K600<0a/H01/H00`36aP0JaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000KaP030<K601;600<0a/H0:<H00co6aP05aP03?lK601K600<0a/H01/H00`36
aP0JaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP03
0<K601;600<0a/H09/H00co6aP07aP03?lK601K600<0a/H01/H00`36aP0JaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601;600<0a/H09<H00co6
aP09aP03?lK601K600<0a/H01/H00`36aP0JaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601;600<0a/H08/H00co6aP0;aP03?lK601O600<0a/H0
1/H00`36aP0IaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000KaP030<K601;600<0a/H08<H00co6aP0=aP03?lK601O600<0a/H01/H00`36aP0IaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601;600<0a/H0
7/H00co6aP0?aP03?lK601O600<0a/H01/H00`36aP0IaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K601;600<0a/H07<H00co6aP0AaP03?lK601O6
00<0a/H01/H00`36aP0IaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000JaP030<K601?600<0a/H06LH00dloaP0DaP03?lK601O600<0a/H01/H00`36aP0IaP40
0000BMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H00cl0E]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001[600<0a/H0
4lH00`36aP0CaP03Ccm?00?600=?a/H05<H00co6aP0GaP030<K600K600<0a/H06LH1000004?Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KF00<o05cFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000JaP030<K601?600<0a/H0
3LH00dloC`07aP03ClK601K600<oa/H05lH00`36aP06aP030<K601W60@00000me/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP03?`1Re/KFa]K6
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006/H00`36aP0CaP030<K600S600<oClH0
2/H00do6aP0HaP03?lK601O600<0a/H01/H00`36aP0IaP400000>=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K613l0I]K6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000JaP030<K601?600<0a/H00/H00cm??`02aP03ClK600W6
00=?a/H06/H00co6aP0GaP030<K600K600<0a/H06LH1000003;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP<o06g6e/KF?mK6e/KFa]K6e/KF?mK6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000JaP030<K601;600<oCcl01/H00do6aP09aP03ClK601c6
00<oa/H05lH00`36aP06aP030<K601W60@00000/e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/H3?`1c0=K6e/KFa]Hoe/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100006/H00`36aP0>aP05?lK6aP001/H00do6aP09aP03ClK601k600<oa/H0
5lH00`36aP06aP030<K601W60@00001Se/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]Hoe/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF008o03g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000JaP030<K601;600<0a/H00/H00do6aP09aP03ClK6023600<oaSl05lH00`36
aP06aP030<K601W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KF?mK6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001[600<0a/H04/H01036aTl;aP03ClK602;600Doa/K6?`0EaP030<K600K600<0a/H06LH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6eP3F?mK6e/KFa]K6
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006/H00`36aP0BaP03
04o600[600=?a/H09<H00co6aP02aP03ClK601;600<0a/H01lH00`36aP0HaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000JaP030<K6017600=?0<H02LH00do6
aP0VaP03?lK600C600=?a/H04LH00`36aP06aP030<K601S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF?mH0e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001[600<0a/H04/H00`36aP06aP03Cco602S600<oa/H0
1LH00co6aP0@aP030<K600K600<0a/H06<H1000003OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF008o06W6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001[600<0a/H04/H00`36aP04aP03ClI?02[600<oa/H01lH00co6
aP0>aP030<K600K600<0a/H06<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100006/H00`36aP0BaP030<K600;600A?a/Ho:lH00co6aP08aP03ClK600g600<0a/H0
1/H00`36aP0HaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6eSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6
e/KFa]K6eSoFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000IaP030<K601?600@0a/I?0lH00do6aP0[aP03ClK600W600=?a/H02lH00`36aP06aP030<K601S6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]H0eSoFa]K6
?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001W600<0a/H0
4lH00`1?aP03aP03?lK602c600=?a/H02/H00co6aP0:aP030<K600K600<0a/H06<H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6
e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0BaP03C`3600C6
00<oa/H0;<H00do6aP0<aP03?lK600S600<0a/H01/H00`36aP0HaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eSoF0=K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000IaP030<K6013600A?a/H01<H00do6aP0]aP03
ClK600k600<oa/H01/H00`36aP06aP030<K601S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6eSoFa]H0e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001W600<0a/H03/H00do6aP02aP050<K6aSl0<<H00do6aP0>aP03
?do600K600<0a/H01/H00`36aP0HaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KF?mK6e/KF0=K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000IaP030<K600c600=?a/H01<H01036aTlaaP03ClK600k600@oa/I?1LH00`36
aP06aP030<K601S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF?mK6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001W600<0a/H04/H00`36aP0caP03ClK600k600Doa/K6?`04aP030<K600K600<0a/H06<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]Ho
e/KFaSo6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0BaP03
0<K603?600=?a/H03/H00co6aP03aP04?lK600S600<0a/H06<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6?lKFa]K6?lH0a]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006LH00`36aP0BaP030<K603;600<oClH04<H00do6
aP04aP03?`3600S600<0a/H05lH1000006?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00Sl0?LKFa]K6e/KFa]K6e/KFa]K6?lKFa]K6eSl0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001W600<0a/H04/H00`36aP0aaP03ClI?017600=?a/H01LH00`36aP07aP03
0<K601O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K603oFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001W6
00<0a/H04/H00`36aP0`aP04?lK6Ca7600=?a/H01LH00`36C`07aP030<K601O60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
eP3F?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001W600<0a/H04/H00`36aP0`aP04
?lK6Ca7600=?a/H01/H00`36?`06aP030<K601O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6eP3FaSo6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001W600<0a/H04/H00`36aP0_aP05ClK6aTl06/H01@36a/Ho00C6
00<0a/H05lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/Hoa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
6LH00`36aP0BaP030<K602k600<oa/H00/H00do6aP0HaP030<K600?600@oa/H06LH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006<H00`36aP0CaP030<K603?6
00=?a/H06<H00`36aP06aP030<K601O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0001S600<0a/H04lH00`36aP0caP03ClK601S600<0a/H01/H00`36aP0GaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000HaP030<K601?6
00<0a/H0<lH00do6aP0HaP030<K600K600<0a/H05lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100006<H00`36aP0CaP030<K603?600=?a/H03lH:00S600<0a/H0
5lH1000006GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?`0A000/e/KFa]K6
e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006<H00`36aP0CaP030<K602?6
4@0KaP030<K600G600<0a/H05lH1000004?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF014004kFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
6<H00`36aP0CaP040<K6aQ408LH00do6aP0JaP030<K600C600<0a/H05lH10000027Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H04@00L=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100006<H900g600<0a/H0<lH00do6aP0KaP030<K600?600<0a/H0
5lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100006lH00`36
aP0@aP030<K603?600=?a/H07<H00`36aP03aP030<K601K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001g600<0a/H03LH00`36aP1DaP030<K600;600<0a/H0
5/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH00`36
aP0;aP030<K605G600D0a/K6000HaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000QaP030<K600W600<0a/H0E/H01036aP0HaP4000008]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H2001ne/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002C600<0a/H01/H00`36aP1GaP030<H001S6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002K600<0a/H0
1<H00`36aP1HaP806<H1000008SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P006=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000XaP030<K600;600<0a/H0D<H:01S60@00001]e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0C000Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000ZaP040<K602g64P0eaP400000BMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H04P00AlKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000/aP802<HC05W60@00000]e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00T006cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0170982, -0.0250051, 
  0.00579307, 0.00579307}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.30581 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.121733 1.29564 0.032391 1.29564 [
[ 0 0 0 0 ]
[ 1 1.30581 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.30581 L
0 1.30581 L
closepath
clip
newpath
p
1 g
.002 w
.84433 .03239 m
.8793 1.05118 L
s
.8793 1.05118 m
.03239 1.10509 L
s
.03239 1.10509 m
.07939 .12029 L
s
.07939 .12029 m
.84433 .03239 L
s
.92964 .33291 m
.25889 .39958 L
s
.25889 .39958 m
.23467 1.27342 L
s
.23467 1.27342 m
.96761 1.23364 L
s
.96761 1.23364 m
.92964 .33291 L
s
.84433 .03239 m
.8793 1.05118 L
s
.8793 1.05118 m
.96761 1.23364 L
s
.96761 1.23364 m
.92964 .33291 L
s
.92964 .33291 m
.84433 .03239 L
s
.07939 .12029 m
.25889 .39958 L
s
.25889 .39958 m
.23467 1.27342 L
s
.23467 1.27342 m
.03239 1.10509 L
s
.03239 1.10509 m
.07939 .12029 L
s
p
.4 g
.85789 .08016 m
.1078 .1645 L
s
P
p
.4 g
.89055 .1952 m
.17641 .27125 L
s
P
p
.4 g
.92001 .299 m
.23854 .36792 L
s
P
p
.4 g
.78839 .03882 m
.88081 .33776 L
s
P
p
.4 g
.5481 .06643 m
.67069 .35865 L
s
P
p
.4 g
.31356 .09338 m
.46494 .3791 L
s
P
p
.4 g
.08455 .1197 m
.26344 .39913 L
s
P
P
p
1 0 .6 r
.005 w
.3308 .80129 m
.29473 .88883 L
s
P
p
1 0 .6 r
.02 w
.61464 .24508 m
.61656 .44988 L
s
P
p
1 g
.05 w
.61464 .24508 Mdot
P
p
1 0 .6 r
.005 w
.72853 .87819 m
.73431 .96717 L
s
P
p
1 0 .6 r
.005 w
.3308 .80129 m
.25691 .87733 L
s
P
p
1 0 .6 r
.00707 w
.37227 .70064 m
.3308 .80129 L
s
P
p
1 0 .6 r
.005 w
.72853 .87819 m
.79316 .96145 L
s
P
p
1 0 .6 r
.00707 w
.72185 .77548 m
.72853 .87819 L
s
P
p
1 0 .6 r
.01414 w
.61656 .44988 m
.61835 .64191 L
s
P
p
1 0 .6 r
.01414 w
.61656 .44988 m
.48865 .58118 L
s
P
p
1 0 .6 r
.01 w
.48865 .58118 m
.37227 .70064 L
s
P
p
1 0 .6 r
.01 w
.48865 .58118 m
.38951 .61576 L
s
P
p
1 0 .6 r
.00707 w
.37227 .70064 m
.2665 .80921 L
s
P
p
1 0 .6 r
.005 w
.81456 .89511 m
.89763 1.00231 L
s
P
p
1 0 .6 r
.005 w
.81456 .89511 m
.9164 .93892 L
s
P
p
1 0 .6 r
.00707 w
.72185 .77548 m
.81456 .89511 L
s
P
p
1 0 .6 r
.005 w
.2665 .80921 m
.17045 .90781 L
s
P
p
1 0 .6 r
.005 w
.2665 .80921 m
.18082 .84248 L
s
P
p
1 0 .6 r
.01 w
.61835 .64191 m
.72185 .77548 L
s
P
p
1 0 .6 r
.01 w
.61835 .64191 m
.62002 .82137 L
s
P
p
1 0 .6 r
.00707 w
.38951 .61576 m
.29548 .64855 L
s
P
p
1 0 .6 r
.00707 w
.38951 .61576 m
.30421 .70306 L
s
P
p
1 0 .6 r
.005 w
.30421 .70306 m
.22689 .78219 L
s
P
p
1 0 .6 r
.005 w
.30421 .70306 m
.23605 .72787 L
s
P
p
1 0 .6 r
.00707 w
.62002 .82137 m
.62159 .98855 L
s
P
p
1 0 .6 r
.00707 w
.62002 .82137 m
.58905 .891 L
s
P
p
1 0 .6 r
.005 w
.62159 .98855 m
.57849 1.11119 L
s
P
p
1 0 .6 r
.005 w
.62159 .98855 m
.62303 1.14383 L
s
P
p
1 0 .6 r
.005 w
.29548 .64855 m
.20668 .67952 L
s
P
p
1 0 .6 r
.005 w
.29548 .64855 m
.26437 .60512 L
s
P
p
1 0 .6 r
.005 w
.58905 .891 m
.55923 .95803 L
s
P
p
1 0 .6 r
.005 w
.58905 .891 m
.66009 .92363 L
s
P
p
1 g
.002 w
.84433 .03239 m
.8793 1.05118 L
s
.8793 1.05118 m
.03239 1.10509 L
s
.03239 1.10509 m
.07939 .12029 L
s
.07939 .12029 m
.84433 .03239 L
s
.84433 .03239 m
.8793 1.05118 L
s
.8793 1.05118 m
.96761 1.23364 L
s
.96761 1.23364 m
.92964 .33291 L
s
.92964 .33291 m
.84433 .03239 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 333}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000NmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP05000Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40001baPT01<H00`36aP0PaP400000JMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP09000`e/KFa]K6a<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@000676200?aP03a<K600C60P0QaP400000F=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H9000Na]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KF0P008LKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP010000ClH9027600?4a/H00lH202760@000017e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
2000;/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]H2a00S0<@0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003k62@0AaP03a<K601W62L@2aP030<H00236
0@00000ee/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
2@00;]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/H8a00^e/KFa]K6
a<KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000]aPP00/H00lC6aP0OaP03
a<K600O62L@>aP03a<K600;600<0aP008<H1000002CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H9000^a]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4ePS4
03o6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001_62@0DaP03a<K601O62L@PaP05a<K6aP000/H00`36aP0MaP4000005mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00@002o6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF
a]K6e/KFaP08a01@e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KF0=K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100005lH00`34aP0OaP03a<K600G62L@@aP03
a<K601k600G4a/K60003aP030<K601c60@00000Ge/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P008<CF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF2<@0HLKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001O600@0aP345LH9a0;600?4a/H07LH00lC6aP0NaP05a<K6aP000/H00`36
aP0LaP400000:=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0a<KFa]K6e/KFa]K6e/H8a01be/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001O600D0a/H0
a003aPW45<H00lC6aP0MaP03a<K601k600C4a/H00lH00`36aP0KaP4000006mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6eP04a023a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFaP36e/H0
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001O600H0a/K60<@PaP03a<K601g600?4a/H0
7LH01<C6aP03aP030<K601_60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaP34e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001O600<0a/H00lH00lC6aP0NaP03a<K601g600?4a/H07LH00lC60004aP030<K601[6
0@000021e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H0a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<H000C401d0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100005lH00`36
aP04aP030<C601k600?4a/H07LH00lC6aP0EaPW400<0a/H00lH00`36aP0IaP400000KMK6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]H02/@0:lKFa]K6e/KFa036e/KF
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001K600<0a/H01/H00`34aP0NaP03a<K601g6
00?4a/H02/@BaP03a03600C600<0a/H06LH1000005[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFaP34e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H9a00oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/@0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000FaP030<K600S600?4a/H07LH00lC6aP0<aP[41<H401k600<0a/H01<H00`36
aP0HaP400000AmK6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP34a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa/C6e/KF00W400gFa]K6e/KFa]K6e/KF00H003o6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001K600<0a/H0
2LH00lC6aP0HaP[45/H601g600<0a/H01<H00`36aP0HaP400000<mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6eP0:a00Pa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]H6000oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a=K6e/KFaP36e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000FaP030<K600[600<0a<H01<H9a13600?4a/H05lH601g600<0a<H0
1LH00`36aP0GaP4000009=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaPK403CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61000@=K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP34e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
5/H00`36aP0;aP030<C601g600?4a/H06<H01Cm?a/K401c600<0a<H01/H00`36aP0FaP400000GmK6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o0476e/CFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60<K4a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100005/H00`36aP0=aP03
a<K601c600?4a/H05lH00cm?aP02aP03a<K601W600<0a/@01/H00`36aP0FaP400000GmK6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o02?6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60<K4aP05a00I0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100005/H00`36aP0>aP03a<K601c6
00?4a/H05/H00cm?aP03aP03a<K601;61/@01034a<@6aP030<K601G60@00001Oe/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl03/KFa]K4e/KFa]K6e/KF2l@0:=K6e/KFaP36e/CFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100005/H00`36aP0?aP030<C601c600?4a/H05LH00cm?
aP03aP[44LH01036a/@6aP030<K601G60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
eP04a08o1<@0?LK4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/K4a]K6e/KF0=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001K600<0a/H04LH00lC6aP0LaP03a<K600G62/@4aP03?do600C600?4a/H0
5lH01P36a/K4aPH05/H1000004OFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/H0a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0:a00>a]K6e/KFa]K6e/KFa]H2?`0Ka]K6e/KF
a=K6e/KFa]K6e/KFa]K6e/KFa]K600X001cFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001K6
00<0a/H04/H00lC6aP0>aP_40lH00lC6aP0BaP03?do600G600?4a/H02<H:00G600<0a/H01lH00`36
aP0DaP400000<]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6
2/@08mK6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KF008o00S6e/KFa]K6a0T0033Fa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100005/H00`36aP0CaP03
0<C400?46LH00lC6aP0?aP8000<oC`001P0IaP030<K600O600<0a/H05<H1000005?Fa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6eP0:0015a]Ho?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF
a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000EaP030<K601K600?4a/H06<H30003a00000@0
3<H00cm?aP0OaP030<K600O600<0a/H05<H1000003oFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]H02P005/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]H2?`11a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001G600<0a/H05lH00lC6aP03aPX08<H00cm?aP0OaP030<K600O600<0a/H0
5<H10000037Fa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K400@0
02[6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H2?`11a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001G6
00<0a/H06<H00`36aP0/aP03?do601o600<0a/H01lH00`36aP0DaP400000GmK6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o0476e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F
a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100005LH00`36aP0HaP030<K602c600<oClH0
7lH00`36aP07aP030<K601C60@00001Oe/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0Sl0@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000EaP030<K601S600<0a/H0;<H00cm?aP0OaP030<K600S600<0a/H04lH10000
05oFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`11a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001G600<0a/H0
6<H00`36aP0/aP03?do601o600<0a/H02<H00`36aP0CaP400000GmK6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF008o0476e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF
a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100005LH00`36aP0HaP030<K602_600=?aTl08<H00`36
aP08aP030<K601?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001G600<0a/H06<H00`36aP0YaP05ClK6aTl08<H00`36aP08aP030<K601?60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001G600<0a/H06<H00`36aP0WaP03
ClK600?600=?a/H07/H00`36aP08aP030<K601?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001G600<0a/H06<H00`36aP0UaP03ClK600G600=?a/H07/H00`36
aP08aP030<K601?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001G600<0a/H06<H00`36aP0SaP03ClK600O600=?a/H07/H00`36aP08aP030<K601?60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001C600<0a/H06LH00`36
aP0QaP03ClK600W600=?a/H07/H00`36aP08aP030<K601?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001C600<0a/H06<H00`36aP0PaP03ClK600c600<oa/H0
7/H00`36aP07aP030<K601?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001C600<0a/H06<H00`36aP0NaP03ClK600k600<oa/H07/H00`36aP07aP030<K601?6
0@00001>e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0D]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H100005<H00`36
aP0HaP030<K601W600@oCcm?4/H00co6aP0NaP030<K600O600<0a/H04lH1000004SFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H3?`1Ga]Hoe/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000DaP030<K601S600<0a/H05<H00dlo
aP03aP03ClK601;600<oa/H07/H00`36aP07aP030<K601?60@000013e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eSoFa]K6e/KFa]K6e/KFa]K6eP03?`1Le/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H100005<H00`36aP0HaP030<Ho00k600=??dl01lH00do6
aP0DaP03?lK601k600<0a/H02<H00`36aP0BaP400000?MK6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6?lKFa]K6e/KFa]H00cl0H]Hoe/KFa]K6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001C600<0a/H06<H01@36a/Ho00K600=??dl00lH00do6aP05aP03
ClK601K600<oa/H07/H00`36aP08aP030<K601;60@00000ge/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaSo6eP03?`1Xe/KFa]Hoe/KFa]K6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/H100005<H00`36aP0HaP030<K600;600=??dl01lH00do6aP05aP03
ClK601S600<oa/H07/H00`36aP08aP030<K601;60@00000ae/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP03?`1^e/KFa]K6e/KF?mK6e/KFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/H100005<H00`36aP0HaP03?do600[600=?a/H01LH00do6aP0JaP03
?do601k600<0a/H02<H00`36aP0BaP400000;MK6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP02?`1c0=K6e/KFa]K6e/KF?mK6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KF
a]K6e/KFa]K6e/KFaP0100005<H00`36aP0CaP03Ccm?00;600<0a/H02<H00do6aP05aP03ClK601c6
00@oa/I?7LH00`36aP08aP030<K601;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]H0e/KFa]K6e/KF?mK6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K60@0001C600<0a/H06<H00`36aP06aP03ClK600G600=?a/H07/H01Co6a/Ho01c6
00<0a/H02<H00`36aP0BaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFaP40000CaP030<K601W600<0a/H00lH00cm?aP07aP03?lK601o600<oa/H00lH00co6aP0HaP03
0<K600S600<0a/H04/H1000003;Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3FaP@o06cFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/H100004lH00`36aP0IaP03?dlo00;600=?a/H01/H00cm?aP0QaP03?lK600C600=?a/H05lH00`36
aP08aP030<K601;60@00000]e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF008o07<0e/KF?mK6e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF
a]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K60040000CaP030<K601W600@0a/I?2<H00co6?`0SaP03?lK600K600=?a/H05LH00`36aP08aP03
0<K601;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
eSoFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60@0001?6
00<0a/H06LH00`1?aP07aP05?lK6aSl08lH00co6aP08aP03ClK601?600<0a/H02<H00`36aP0BaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP40000CaP030<K601S6
00=?0<H01/H00co6aP02aP03ClK602;600<oa/H02LH00co6aP0CaP030<K600O600<0a/H04/H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeP3Fa]K6e/Hoa]K6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H100004lH00`36aP0FaP04
ClK600G600<oa/H00lH00co6aP0SaP03?lK600_600<oa/H04LH00`36aP07aP030<K601;60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]H0e/KFaSo6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60@0001?600<0a/H06LH01@36
a/Ho00O600<oa/H08lH00co6aP0;aP03?do6017600<0a/H02<H00`36aP0AaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6?lKFa]K6e/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000CaP030<K601W600<0Ccl01lH00cm?
aP0UaP03?lK600_600@oa/I?4<H00`36aP08aP030<K601760@00000]e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00SF?mK6e/KFaP8o06SFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000CaP030<K601G600HoClK604l6aP03?lHo02O6
00<oa/H02lH01Co6a/Ho00o600<0a/H02<H00`36aP0AaP400000:MK6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o07O6e/KF?mK6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KF0=K6e/KF
a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP0100004lH00`36aP0@aP03Ccm?00G600=?0<H01<H013o6
aTlWaP03Cco600c600<oa/H00lH00co6aP0;aP030<K600S600<0a/H04LH10000063Fa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]Ho0<KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`10e/KFa]K6e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000CaP030<K601K600=?aP001<H01Co6
a/Ho02O600<oaSl03LH00co6aP04aP03ClK600[600<0a/H02<H00`36aP0AaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/H0a]K6?lKFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6
e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000BaP030<K601G600E?a/K60002aP03
?lK600;600=?a/H09/H00co6?`0=aP03?lK600K600=?a/H02<H00`36aP08aP030<K601760@00002R
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFaP36?lKFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
?lKFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60@0001;600<0a/H04lH00do6
aP03aP030<K600G600=?a/H09LH014o6aSl=aP03?lK600O600<oa/H01lH00`36aP08aP030<K60176
0@00001Me/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFaP36e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o04?6eSoFa]K6e/KFa]K6e/KF
?mK6e/KFa]K6e/Hoa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60040000BaP03
0<K6017600=?a/H01LH00`36aP0/aP05?lHoCcl03LH00cm?aP09aP03?do600G600<0a/H02<H00`36
aP0AaP400000HMK6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]H00Sl06/KFa]K6e/KF
a]K6eSoF?mK6e/KFa]K6eSoF0cl08]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H10000
4/H00`36aP0?aP03ClK600O600<0a/H0:lH00do6aP02aP03?lHo00_600@oa/I?2LH024o6a/I??lH0
2/H00`36aP0AaP400000I=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]Hoe/H2?`0l
e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]Hoe/KFaSl0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
0@0001;600<0a/H06LH00`36aP0ZaP03?lK600?600<oa/H00/H00do6aP06aP03?lK600;600=?a/H0
1lH00do6aP02aP0404loC`O600<0a/H04LH1000008OFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/KF?mK6e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KF?mK6eP3Fa]H00Sl06LKFa]K60<KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001;600<0a/H06LH00`36aP0YaP03ClK600C600<oa/H03<H00do6
aP02aP03?lK600O600Doa/K60005aP03?lK600;600<0a/H04LH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6?lKFa]K6?lKFa]K6e/KFaSo6eP3Fa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H100004/H00`36aP0IaP030<K602S600<oa/H01LH00co6
aP0<aP03ClK600C600<oa/H01lH013o6aP09aP030<K601760@00002Re/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFaSo6e/KFa]K6?lKFa]K6e/KFaSo60<KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60@0001;600<0a/H06LH00`36aP0`aP03?lK600c600=?a/H0
3lH00do6000:aP030<K601360@00002Re/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho0<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K60@0001;600<0a/H06LH00`36aP0`aP03?lK6023600<0a/H02<H00`36aP0@aP400000X]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP0oe/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP40000BaP030<K601W600<0a/H0
;lH00dloaP0QaP030<I?00S600<0a/H04<H10000063Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H2?`10e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFaP40000BaP030<K601W600<0a/H0;lH00dloaP0QaP030<K600S600<0a/H0
4<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H100004LH00`36
aP0JaP030<K602k600<oaSl08/H00`36aP08aP030<K601360@00002Re/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60@00017600<0a/H06/H00`36aP0]aP04ClK6?b;600<0a/H0
2<H00`36aP0@aP400000O=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H9000Ma]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H00@000176
00<0a/H06/H00`36aP0]aP04ClK6?`W64@08aP030<K600S600<0a/H04<H1000005_Fa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF010003O6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF
a]H0e/KFa]K6e/KFa]K6e/KFa]K60040000AaP030<K601[600<0a/H06LHA00;600Doa/K6?`0SaP03
0<K600O600<0a/H04<H1000003[Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K64000F=K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H100004LH00`36
aP0FaQ008/H00do6aP02aP03?lK602;600<0a/H01/H00`36aP0@aP4000006MK6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]H04@00N=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFaP40000AaPP05LH00`36aP0[aP03ClK600;600<oa/H08lH00`36aP05aP03
0<K601360@00002Re/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60@0001C6
00<0a/H05lH00`36aP0`aP03?lK602C600<0a/H01<H00`36aP0@aP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP40000FaP030<K601C600<0a/H0<LH00co6aP0UaP03
0<K600?600<0a/H04<H1000001OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP020029a]K6e/KFa]K6e/KF
a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KF
a]K6e/H00@0001W600<0a/H04LH00`36aP0aaP03?lK602K600<0a/H00/H00`36aP0@aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KFa]K6e/KFaP40000KaP030<K600o600<0a/H0
FlH00`36aP02aP030<K600o60@00000Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8008CFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6
e/KFa]K6e/H100007/H00`36aP0<aP030<K605c600D0a/K6000AaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600[600<0a/H0GLH01036aP0AaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFaP40000RaP802LH00`36
aP1NaP030<H001760@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6
0@0002G600<0a/H01LH00`36aP1OaP804LH1000008oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02000A
a]K6e/KFa]K6e/KFa]K6e/H00@0002O60P04aP030<K605K62`0AaP400000L]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQ@001cFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002[600@0a/H0<<HD03360@00001;e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF01<004CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000/aP802LHD05O60@00000]e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00X006_6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP010000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0186417, -0.025005, 
  0.00569412, 0.00569412}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.23175 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0873881 1.23592 0.0308981 1.23592 [
[ 0 0 0 0 ]
[ 1 1.23175 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.23175 L
0 1.23175 L
closepath
clip
newpath
p
1 g
.002 w
.84711 .0309 m
.8824 .97016 L
s
.8824 .97016 m
.0309 1.02506 L
s
.0309 1.02506 m
.0789 .1202 L
s
.0789 .1202 m
.84711 .0309 L
s
.93169 .34686 m
.27108 .41188 L
s
.27108 .41188 m
.24783 1.20085 L
s
.24783 1.20085 m
.9691 1.16213 L
s
.9691 1.16213 m
.93169 .34686 L
s
.84711 .0309 m
.8824 .97016 L
s
.8824 .97016 m
.9691 1.16213 L
s
.9691 1.16213 m
.93169 .34686 L
s
.93169 .34686 m
.84711 .0309 L
s
.0789 .1202 m
.27108 .41188 L
s
.27108 .41188 m
.24783 1.20085 L
s
.24783 1.20085 m
.0309 1.02506 L
s
.0309 1.02506 m
.0789 .1202 L
s
p
.4 g
.86896 .11253 m
.12831 .1952 L
s
P
p
.4 g
.89341 .20384 m
.18378 .27939 L
s
P
p
.4 g
.91575 .28729 m
.23466 .3566 L
s
P
p
.4 g
.72078 .04558 m
.82363 .3575 L
s
P
p
.4 g
.52787 .06801 m
.65818 .37378 L
s
P
p
.4 g
.33903 .08996 m
.49572 .38977 L
s
P
p
.4 g
.15415 .11145 m
.33616 .40547 L
s
P
P
p
1 0 .6 r
.00353 w
.34454 .76642 m
.36378 .79124 L
s
P
p
1 0 .6 r
.00353 w
.69451 .82864 m
.65514 .84975 L
s
P
p
1 0 .6 r
.00353 w
.34454 .76642 m
.31912 .82828 L
s
P
p
1 0 .6 r
.00353 w
.69451 .82864 m
.69888 .89151 L
s
P
p
1 0 .6 r
.005 w
.37355 .69583 m
.34454 .76642 L
s
P
p
1 0 .6 r
.02 w
.59925 .25383 m
.60055 .41645 L
s
P
p
1 g
.05 w
.59925 .25383 Mdot
P
p
1 0 .6 r
.005 w
.68951 .75668 m
.69451 .82864 L
s
P
p
1 0 .6 r
.00353 w
.74089 .82292 m
.74389 .87351 L
s
P
p
1 0 .6 r
.00353 w
.31492 .75605 m
.29474 .80599 L
s
P
p
1 0 .6 r
.005 w
.37355 .69583 m
.31492 .75605 L
s
P
p
1 0 .6 r
.00707 w
.40677 .61502 m
.37355 .69583 L
s
P
p
1 0 .6 r
.00353 w
.74089 .82292 m
.78701 .88237 L
s
P
p
1 0 .6 r
.005 w
.68951 .75668 m
.74089 .82292 L
s
P
p
1 0 .6 r
.00353 w
.31492 .75605 m
.26187 .81054 L
s
P
p
1 0 .6 r
.00353 w
.82318 .85403 m
.82585 .91841 L
s
P
p
1 0 .6 r
.00707 w
.68377 .67403 m
.68951 .75668 L
s
P
p
1 0 .6 r
.01414 w
.60055 .41645 m
.60175 .56812 L
s
P
p
1 0 .6 r
.01414 w
.60055 .41645 m
.49902 .52049 L
s
P
p
1 0 .6 r
.00353 w
.24708 .77866 m
.22195 .84271 L
s
P
p
1 0 .6 r
.01 w
.49902 .52049 m
.40677 .61502 L
s
P
p
1 0 .6 r
.01 w
.49902 .52049 m
.42071 .54691 L
s
P
p
1 0 .6 r
.00353 w
.82318 .85403 m
.88229 .93036 L
s
P
p
1 0 .6 r
.00707 w
.40677 .61502 m
.32303 .70083 L
s
P
p
1 0 .6 r
.005 w
.75727 .76894 m
.82318 .85403 L
s
P
p
1 0 .6 r
.005 w
.75727 .76894 m
.83729 .80252 L
s
P
p
1 0 .6 r
.00707 w
.68377 .67403 m
.75727 .76894 L
s
P
p
1 0 .6 r
.005 w
.32303 .70083 m
.24708 .77866 L
s
P
p
1 0 .6 r
.005 w
.32303 .70083 m
.25591 .72583 L
s
P
p
1 0 .6 r
.01 w
.60175 .56812 m
.68377 .67403 L
s
P
p
1 0 .6 r
.01 w
.60175 .56812 m
.60287 .70917 L
s
P
p
1 0 .6 r
.00353 w
.24708 .77866 m
.17825 .8492 L
s
P
p
1 0 .6 r
.00353 w
.29238 .67808 m
.27165 .73076 L
s
P
p
1 0 .6 r
.00353 w
.83729 .80252 m
.88473 .86386 L
s
P
p
1 0 .6 r
.00353 w
.83729 .80252 m
.91124 .83355 L
s
P
p
1 0 .6 r
.00353 w
.57002 .93767 m
.54009 1.02397 L
s
P
p
1 0 .6 r
.00707 w
.42071 .54691 m
.34696 .5718 L
s
P
p
1 0 .6 r
.00707 w
.42071 .54691 m
.35337 .61575 L
s
P
p
1 0 .6 r
.005 w
.35337 .61575 m
.29238 .67808 L
s
P
p
1 0 .6 r
.005 w
.35337 .61575 m
.30003 .63446 L
s
P
p
1 0 .6 r
.00707 w
.60287 .70917 m
.60391 .83996 L
s
P
p
1 0 .6 r
.00707 w
.60287 .70917 m
.57811 .76181 L
s
P
p
1 0 .6 r
.00353 w
.25591 .72583 m
.19324 .74918 L
s
P
p
1 0 .6 r
.00353 w
.25591 .72583 m
.20073 .78226 L
s
P
p
1 0 .6 r
.00353 w
.29238 .67808 m
.23719 .7345 L
s
P
p
1 0 .6 r
.00353 w
.57002 .93767 m
.49425 .98438 L
s
P
p
1 0 .6 r
.005 w
.60391 .83996 m
.57002 .93767 L
s
P
p
1 0 .6 r
.005 w
.60391 .83996 m
.60487 .96092 L
s
P
p
1 0 .6 r
.00353 w
.30003 .63446 m
.25059 .65181 L
s
P
p
1 0 .6 r
.00353 w
.30003 .63446 m
.25591 .67948 L
s
P
p
1 0 .6 r
.005 w
.34696 .5718 m
.27776 .59515 L
s
P
p
1 0 .6 r
.005 w
.34696 .5718 m
.32313 .53663 L
s
P
p
1 0 .6 r
.00353 w
.60487 .96092 m
.60576 1.07253 L
s
P
p
1 0 .6 r
.00353 w
.60487 .96092 m
.67375 1.02287 L
s
P
p
1 0 .6 r
.005 w
.57811 .76181 m
.55449 .81203 L
s
P
p
1 0 .6 r
.005 w
.57811 .76181 m
.63353 .78553 L
s
P
p
1 0 .6 r
.00353 w
.27776 .59515 m
.21304 .61699 L
s
P
p
1 0 .6 r
.00353 w
.27776 .59515 m
.22052 .65338 L
s
P
p
1 0 .6 r
.00353 w
.32313 .53663 m
.30074 .5036 L
s
P
p
1 0 .6 r
.00353 w
.32313 .53663 m
.27274 .553 L
s
P
p
1 0 .6 r
.00353 w
.63353 .78553 m
.68566 .80784 L
s
P
p
1 0 .6 r
.00353 w
.63353 .78553 m
.61761 .82228 L
s
P
p
1 0 .6 r
.00353 w
.55449 .81203 m
.53205 .85973 L
s
P
p
1 0 .6 r
.00353 w
.55449 .81203 m
.47652 .84835 L
s
P
p
1 g
.002 w
.84711 .0309 m
.8824 .97016 L
s
.8824 .97016 m
.0309 1.02506 L
s
.0309 1.02506 m
.0789 .1202 L
s
.0789 .1202 m
.84711 .0309 L
s
.84711 .0309 m
.8824 .97016 L
s
.8824 .97016 m
.9691 1.16213 L
s
.9691 1.16213 m
.93169 .34686 L
s
.93169 .34686 m
.84711 .0309 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 333}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000O]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPD001o6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001eaPT01<H00`36aP0MaP400000KMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02000;LKFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP010000I<H900?600?4a/H03lH201k60@00001Le/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H8000Ne/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K60P007]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40001CaPT05LH00lC6aP0>aP807/H1000004_Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H02000ClKFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K60<H0
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0004?6200;aP03a<K601W600?4a/H03LH00`36
000MaP400000>]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/@9001Oa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4
a]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003;6200LaP03
a<K601W600?4a/H03LH00`36000MaP400000:MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00T0073Fa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@000276200AaP03a<K601[600?4a/H06LH00lC6aP0<aP040<K601c60@00000He/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K62@00H/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/H0
0/@07@34a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000DaP@01lH00lC6aP0IaP03a<K601[6
00?4a/H06LH00lC6aP02aPW400D0a/K6000KaP400000L=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9a00Ya]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001C60P0;aP03a<K601S600?4a/H06/H00lC6aP0;aPW41<H00lC6aP0<aP04
0<K601_60@00001Ne/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFaPW403_6e/KFa]K6e/KF
a]K6e/CFa]K6e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100005<H00`36
000;aP03a<K601S600?4a/H05LH9a1O600?4a/H02lH01@36a/H001[60@00001<e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]H0e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6
e/KFaPW404g6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KF0=K6eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100005<H01@36a/H000[600?4a/H06<H00lC6aP02aPW4
3lH00lC6aP0HaP03a<K600[600D0a/K6000JaP400000>]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/H9a01Oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001C600<0a/H00/H00`36aP08aP03a<K600[62L@6aP03a<K601S600?4a/H0
6<H00lC6aP0:aP030<K600;600<0a/H05lH1000002SFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36
e/KFa]K6e/KFa=K62L@0LLKFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000CaP030<K600C600<0a/H00/H9a1W600?4a/H06<H00lC6aP0HaP03a<K600W6
00<0a/H00lH00`36aP0FaP4000006mK6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP04a023a]K6e/KF
a/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001?600<0a/H01/H00`36aP08aP03a<K601S600?4a/H06<H00lC6aP0HaP03a<K600S6
00<0a<@00l@00`36aP0FaP400000NmK6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6eP08a00O0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP0100004lH00`36aP07aP030<K600S600?4a/H06<H00lC6aP0HaP03a<K601762L@8aP030<K600C6
00<0a/H05LH1000006WFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]H0
2L@0<=K6e/KFa]K4e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000CaP03
0<K600S600<0a/H02<H00lC6aP0HaP03a<K601O60`08a13600?4a/H01lH00`36aP04aP030<K601G6
0@00001Fe/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/H7a0D0043Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001?600<0a/H02/H00`36
aP07aP03a<K601S600?4a/H01LH9a0K61`0GaP03a<K600K600<0a/H01LH00`36aP0DaP400000@mK6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H02/@03lKFa]K6e/KFa]K6e/KFaP07000oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KF
a]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000CaP030<K600_600<0a/H02<H00lC6
aP0;aPW40lH00lC6aP0CaPL05lH00lC6aP06aP030<K600G600<0a/H05<H10000037Fa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa/C6e/KF00W402?Fa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP050010e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KF0=K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000CaP030<K600c600<0a/H00lH9a1K600?4a/H0
5<H30003a<K601O600?4a/H01LH00`36aP06aP030<K601?60@00000Se/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]H01L@0=]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8o04;Fa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6eP3Fa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H100004lH00`36aP0>aP030<K600O600?4a/H05lH00lC6
aP0CaP05Cco6a/@06LH00lC6aP04aP040<K6aPK400<0a/H04/H1000005kFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6e/KFa]K60Sl07=K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H7a00O0<C4a<KF
a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP0100004lH00`36aP0?aP030<K600O600?4a/H05lH00lC6
aP0BaP03Cco600;600?4a/H03LH:a0K600<0a/H01lH00`36aP0BaP400000G]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0:e/KFa=K6e/KFaPW402o6e/KFa]K6e/KFa=K6e/KF0=K6e/KF
a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP0100004lH00`36aP0@aP030<K600S600?4a/H05/H00lC6
aP0AaP03Cco400W44lH00lC6aP04aP030<K600O600<0a/H04LH1000005KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFaPS40Sl0@]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFaP36e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000BaP030<K601?600<0a/H01lH00lC6aP0FaP_42<H00dlo
aP03aP03a<K601O600?4a/H00lH00`36aP07aP030<K601760@000012e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K62l@04LKFa]K6e/KF
a]K6e/KFa]K6008o04;Fa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/H0a]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/H100004/H00`36aP0DaP030<K600O600?4a/H00lH9a0[600?4a/H0
3lH00dloaP04aP03a<K601K600?4a/H00lH00`36aP03aPH04/H1000002oFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP0:a00Ua]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KF
a]K6e/KFa]K6e/KFaP02?`0Qe/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CF00T001SFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/H100004/H00`36aP0EaPG41LH00lC6aP0FaP03a<K600k600=??lH0
1LH00lC6aP0>aPP000?40<H00/H00`36aP08aP030<K601360@00001Ne/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFaP8o00kFa]K6e/K4a]K6e/KFaPT002_6e/KFa]K6e/KFa]K60<KFa]K6e/KF
a]H0e/KFa]K6e/KFa]K6e/KFa]K60040000BaP030<K601O600<0a/H01lH00lC6aP0EaP03a<K600g6
00=??lH00lH30003a00000@05/H00`36aP08aP030<K601360@00001Ke/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6eP03008o1000?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60@0001;600<0a/H06<H00`36aP07aP03a<K601G600?4aP00
2@03aP03Cco602?600<0a/H02<H00`36aP0@aP400000B=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFaPP000k4a]K6e/KFa]K6
e/KFaP8o04;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/H100004/H00`36aP0IaP030<K600O600?4a/H00lH:01K600=??lH08lH00`36
aP08aP030<K601360@00000ee/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]H010000l@00002000Pe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`12
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K60@0001;600<0a/H06lH502W600=??lH08lH00`36aP08aP030<K601360@00001Me/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H100004/H00`36aP0KaP030<K602W6
00A??dlo9<H00`36aP08aP030<K601360@00001Ke/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP05?`12e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K60@0001;600<0a/H06lH00`36aP0WaP06Ccm?aTlo9<H00`36aP09aP030<K600o6
0@00001Ie/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl0A]K6?coFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H100004LH00`36
aP0LaP030<K602G600=??dl00lH00dloaP0SaP030<K600W600<0a/H03lH1000005OFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H00cl01=K6e/H2?`12e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60@00017600<0a/H07<H00`36aP0SaP03
Ccm?00G600=??lH08lH00`36aP09aP030<K600o60@00001Ee/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP03?`06e/KFa]K60Sl0@]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFaP40000AaP030<K601c600<0a/H08LH00dloC`07aP03Cco602?6
00<0a/H02LH00`36aP0?aP400000DmK6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00SFa]K6e/KFaP8o
04;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/H100004LH00`36aP0LaP030<K601o600=??dl02LH00dloaP0SaP030<K600W600<0a/H0
3lH10000057Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl02]K6e/KFa]K6e/H2?`12e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60@000176
00<0a/H07<H01@36a/I?01_600=??dl02lH00dloaP0TaP030<K600S600<0a/H03lH1000004oFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00<o00cFa]K6e/KFa]K6e/H2?`12e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60@00017600<0a/H06lH00`36
aP04aP03ClK601?600E??dloC`0=aP03Cco602C600<0a/H02<H00`36aP0?aP400000BMK6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]H00cl04]K6eSoFa]K6e/KFa]K6e/KFaP8o04;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H100004LH00`36aP0KaP030<K600?6
00<oCcl03/H00dloC`05aP03ClK600g600=??lH09<H00`36aP08aP030<K600o60@00000be/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/H3?`0?a]Hoe/KFa]K6e/KF
a]K6008o01SFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/H2?`12e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60@00017600<0a/H06lH00`1?
?`06aP03ClK600K600@oCcm?1lH00do6aP0?aP03Cco602C600<0a/H02<H00`36aP0?aP400000?mK6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eSoFa]K6
eP02?`0Ma]Hoe/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/H00Sl0@]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP40000AaP030<K601_6
00<0a/H02<H01Do6Ccm?00?600=?a/H01LH00do6aP0AaP03Cco602C600<0a/H02<H00`36aP0?aP40
0000>MK6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP03?`0Re/KFa]Hoe/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H100004<H00`36
aP0LaP030<K600C600=??dl01lH00do6aP05aP03ClK601C600<oClH08lH00`36aP08aP030<K600o6
0@00000ce/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF00<o
06cFa]K6e/KFa]Hoe/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H100004<H00`36
aP0LaP04?dloC`_600=?a/H01LH00do6aP0FaP04?lK6Cb;600<0a/H02LH00`36aP0>aP400000;=K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K613l0L]K6e/KFa]K6e/KFa]Ho
e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP40000@aP030<K601K600<oCcl0
0/H00dl0aP0;aP03ClK600G600=?a/H06<H01Co6a/Ho027600<0a/H02LH00`36aP0>aP4000009mK6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0Aa]K6eSoF0=K6e/KFa]K6e/H0
0Sl0I]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP40000@aP030<K601W6
00A?a/H01lH01Cm??lHo00K600=??lH06/H00co6aP03aP03?lK601g600<0a/H02LH00`36aP0>aP40
0000=MK6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF0=K6e/KF008o
00[6e/Hoa]K6e/KF0Sl0GlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K60040000@aP03
0<K601O600=?a/H00/H01P36aTloC`C600<oa/H01<H00do6C`0LaP03?lK600G600<oa/H06lH00`36
aP09aP030<K600k60@00000_e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]H013l0KlKFa]K6?lKFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF
a]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF
aP0100004<H00`36aP0EaP03ClK600;600DoC`36?`05aP03?lK600C600A?a/Ho7LH00co6aP06aP03
ClK601[600<0a/H02LH00`36aP0>aP400000X]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF03o6e/KFaSo6e/KFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFaP40000@aP030<K601c600<oa/H00lH00co6aP04aP05ClK6aTl07/H00co6aP08aP03
ClK601S600<0a/H02LH00`36aP0>aP400000X]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Ho0=K6e/Hoa]K6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFaP40000@aP030<K601[600<oaP000lH00co6aP04aP03ClK600;600<oa/H07LH00co6
aP09aP03?lK601O600<0a/H02LH00`36aP0>aP400000<]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60Sl0=mK6e/KF?mK6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]H00Sl0=LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF
a]K6eP3Fa]K6e/KFa]K6e/KFa]K60040000@aP030<K601c600@0aSm?1LH00do6aP03aP03ClK601k6
00<oa/H02LH00co6?`0HaP030<K600S600<0a/H03/H1000003KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0oaSo6e/H2?`1Ze/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP40000@aP030<K601c600Poa/I??dloC`K600<oa/H07lH00co6
aP09aP04?lK6CaO600<0a/H02<H00`36aP0>aP400000<MK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]H00Sl02LKF?mK6e/KFaP02?`1Te/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP40000?aP030<K601_600DoCcm??`02aP03ClK600C600<oaSl0
8<H00dloaP0;aP05ClK6aTl05LH00`36aP08aP030<K600k60@00000/e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0`0<KF?mHoe/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60Sl0@]K6e/KFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP40000?aP030<K601O600XoCcm?aP36ClI?1/H013o6
aTlQaP03Cco600_600=?a/H00/H00co6aP0BaP030<K600S600<0a/H03/H1000002KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o07W6eSoFaP36eSoFa]K6e/Hoa]K6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6?lKFa]K6?lKFa]K6e/KFa]K6e/KF
a]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K60040000?aP030<K601;600=??lH00lH01do6
a/H0aTl01/H01Co6a/Ho027600<oaSl03<H00do6aP04aP03?lK6013600<0a/H02<H00`36aP0>aP40
0000X]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/H0?mK6e/KFaSo6
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFaSo6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP40000?aP030<K601K6
00=?a/H00lH00do6aP04aP03?do600?600<oa/H07/H014loaSl<aP03ClK600G600=?a/H03lH00`36
aP09aP030<K600g60@00000de/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KF?`36e/KFaP8o02SFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo60cl02lKF
a]K6e/KFa]K6008o00OFa]K6e/KF008o02_6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KF
a]K6e/KFa]K60040000?aP030<K601C600=?a/H00lH00do60004aP03?lHo00C600=??lH07/H02Co6
a/HoaSm??`08aP03ClI?00K600DoaSm??`0<aP030<K600W600<0a/H03LH1000006CFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFaSo60<KFaSo6?lKFa]Hoe/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eSoFa]K60Sl05=K6e/KFaSo6?lKFa]K6e/Hoa]K60Sl09]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60@0000o600<0a/H06LH013m?aP02aP04
?lK6C`C600Doa/K6?`0LaP03ClK600;600<oa/H00/H014o6Ccl4aP04ClK6?`O600<oa/H00/H00dlo
aP07aP030<K600W600<0a/H03LH1000002[Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H2?`1Be/H0aSo6e/Hoa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KF?mK6eSoFa]K6?lKFaSo6e/Hoa]K6e/KFaSo6e/KFaP<o0276e/KFaP36e/KFa]K6e/KFaP36e/KF
a]K6e/KFa]K6e/H00@0000o600<0a/H05lH00co6?`02aP0303o600;600<oa/H00/H00do6aP0NaP03
?lK600?600Doa/K6?`05aP04?do6C`C600<oa/H01LH00co6aP05aP03?do600;600<0a/H02LH00`36
aP0=aP400000EmK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/Hoa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0Ba]K6e/KF?mK6?lKFa]K6e/KF
0Sl05/KFa]Hoe/KFa]K6e/Hoa]K6e/KF?mH3?`0L0<KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP40
000?aP030<K601G600@oa/I?0lH00`36aP07aP03ClK601[600@oClI?1/H013o6aTl9aP03ClK600?6
00=?a/H01LH00do6aP05aP07ClK6aP0oC`09aP030<K600g60@00001Be/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6?lKFaP36e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP<o03C6eSoFa]K6e/KF?mHoe/KFa]K6e/KFaSo6e/KFa]Hoe/KFa]K6eSoFa]K6e/KF?mK60<KF
0cl05]K6e/KFaP36e/KFa]K6e/KFa]K6e/H100003lH00`36aP0CaP03?lK600;600E?a/K60008aP03
?lK601K600=??lH01<H00co6aP05aP03?lK600W600<oClH01LH00co6aP06aP03ClK600G600=?aP00
1LH00do6aP03aP030<K600g60@00001>e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]Hoe/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl06MK6e/KFaSo6e/KFa]K6
eSoFa]K6e/KFa]H00Sl02<Hoa]K6e/KF0Sl0;LKFa]K6e/KF?mK6e/KFa]Ho0<KFa]K6e/KFa]K60<KF
a]K6e/KFa]K6e/KFaP0100003/H00`36aP0BaP03?lK600?600<oa/H00/H00`36aP0LaP03?lK600K6
00=?a/H01/H00co6aP06aP05ClK6aTl01/H00co6?`08aP03ClK600C600<o0<H02/H00`36aP0=aP40
0000X]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF?mK6e/KFa]Hoe/KFaSo6e/KFa]K6
?lHoa]K6e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP40000>aP030<K601g6
00<0a/H09<H00co6aP06aP03Cco600_600=?a/H01LH014o6aSl7aP03?lK600C600<0?lH02LH00`36
aP0=aP400000G]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0Oe/KFa]K6e/KFa]K6
eSoFa]K6e/Hoa]K6?lKFa]K6eP02?`0Qa]K6e/H0aSo6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60040
000>aP030<K601g600<0a/H0;LH00dloaP0<aP03?lK600C600=?a/H00/H00co6aP03aP03?lHo00C6
00<0a/H02LH00`36aP0=aP400000X]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6
e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6?lKFa]Hoe/Hoa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFaP40000>aP030<K601g600<0a/H0;<H00co6?`0=aP03?lK600o600@oa/I?1<H00`36aP08aP03
0<K600g60@00002Re/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6eSoFa]Hoe/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60@0000k6
00<0a/H07LH00`36aP0/aP03?lHo01o600<oa/H00/H014o6aP0:aP030<K600g60@00002Re/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6?lKF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60@0000k600<0a/H07<H00`36aP0/aP05
ClK6aTl07/H00co6aP03aP03?lH000[600<0a/H03LH100000:;Fa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSl0e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/H100003/H00`36aP0LaP030<K602_600<oa/H00/H00do6aP0TaP03
0<K600W600<0a/H03<H1000005[Fa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`16e/KFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFaP40000>aP030<K601c600<0a/H0:LH00co6?`04aP03ClK602C600<0a/H02LH00`36aP0<aP40
0000EmK6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`19aSo6e/KFaSo6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP0100003/H00`36
aP0LaP030<K602G600<oClH00/H00do6aP03aP03ClK602C600<0a/H02LH00`36aP0<aP400000H=K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFaSo6e/KFaP8o043Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60@0000g600<0a/H07LH00`36
aP0RaP03Cco600C600<oa/H01<H00do6C`0LaPT02lH00`36aP0<aP400000L=K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6e/KF?mK6e/KFaSo6eSoFa]K6e/KFa]K6e/H?000Sa]K6e/KFa]H0e/KFa]K6e/KF
a]H0e/KFa]K6e/KFa]K6e/H00@0000g600<0a/H07LH00`36aP0PaP03ClK600G600=?a/H01LH00dl0
000=01S600<0a/H02<H00`36aP0<aP400000D]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H?0011a]K6eSoF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0
0@0000g600<0a/H07LH00`36aP0BaQ001/H00do6aP05aP03ClK600?600=?a/H08<H00`36aP07aP03
0<K600c60@00000ce/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KF00l0063Fa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H100003LH00`36aP0DaPl0
9<H00co6aP06aP03ClK600G600=?a/H07lH00`36aP06aP030<K600c60@00000Ee/KFa]K6e/KFa]K6
eP3Fa]K6e/KF00l007kFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/Hoa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/H100003LH801S600<0a/H09/H00do6aP07aP03ClK602S600<0a/H0
1LH00`36aP0<aP400000X]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP40
000@aP030<K601[600<0a/H0<<H00do6aP0YaP030<K600C600<0a/H03<H100000:;Fa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/H100004/H201W600<0a/H0<<H00do6aP0ZaP03
0<K600?600<0a/H03<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6
e/H100005LH00`36aP0EaP030<K6033600=?a/H0:lH00`36aP02aP030<K600c60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K60@0001O60P0DaP030<K605k600<0a/H0
0lH00`36aP0;aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFaP40
000JaP030<K6013600<0a/H0GlH00`36aP02aP030<K600_60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFaP36e/KFa]K6e/KFa]K60@0001c60P0>aP030<K6067600D0a/K6000=aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFaP40000OaP030<K600[600<0a/H0
H/H01036aP0=aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFaP40
000QaP030<K600S600<0a/H0HlH00`36000=aP4000008]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H2001_e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF008000g6e/KFa]K6e/KFa]K60040000TaP030<K600G600<0a/H0I<H200g60@00002;e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP0:000=a]K6e/KFa]K6e/KFaP0100009/H00`36aP03aP030<K604_64@0GaP40
00009mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP020010a]K60<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eQ4002SFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002W600@0a/H0:/HB03W60@000016
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaQ4004_6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002_60P08aQ40G<H1000002cFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT006g6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP400000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0191762, -0.0250051, 
  0.00563071, 0.00563071}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.18686 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0663736 1.20025 0.0300061 1.20025 [
[ 0 0 0 0 ]
[ 1 1.18686 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.18686 L
0 1.18686 L
closepath
clip
newpath
p
1 g
.002 w
.84957 .03001 m
.88514 .92096 L
s
.88514 .92096 m
.03001 .97661 L
s
.03001 .97661 m
.07871 .12036 L
s
.07871 .12036 m
.84957 .03001 L
s
.93299 .35553 m
.27917 .41943 L
s
.27917 .41943 m
.25656 1.15685 L
s
.25656 1.15685 m
.96999 1.11884 L
s
.96999 1.11884 m
.93299 .35553 L
s
.84957 .03001 m
.88514 .92096 L
s
.88514 .92096 m
.96999 1.11884 L
s
.96999 1.11884 m
.93299 .35553 L
s
.93299 .35553 m
.84957 .03001 L
s
.07871 .12036 m
.27917 .41943 L
s
.27917 .41943 m
.25656 1.15685 L
s
.25656 1.15685 m
.03001 .97661 L
s
.03001 .97661 m
.07871 .12036 L
s
p
.4 g
.85437 .04875 m
.09017 .13747 L
s
P
p
.4 g
.87583 .13248 m
.1415 .21404 L
s
P
p
.4 g
.89556 .20945 m
.18885 .28468 L
s
P
p
.4 g
.91375 .28044 m
.23267 .35005 L
s
P
p
.4 g
.93058 .34612 m
.27334 .41072 L
s
P
p
.4 g
.84687 .03032 m
.93071 .35575 L
s
P
p
.4 g
.67971 .04992 m
.78975 .36953 L
s
P
p
.4 g
.51579 .06913 m
.65107 .38308 L
s
P
p
.4 g
.35501 .08797 m
.51463 .39642 L
s
P
p
.4 g
.19727 .10646 m
.38036 .40954 L
s
P
P
p
1 0 .6 r
.0025 w
.39123 .71431 m
.40521 .73333 L
s
P
p
1 0 .6 r
.0025 w
.63777 .76363 m
.60882 .77997 L
s
P
p
1 0 .6 r
.0025 w
.39123 .71431 m
.37588 .75125 L
s
P
p
1 0 .6 r
.0025 w
.67474 .79884 m
.67818 .84618 L
s
P
p
1 0 .6 r
.0025 w
.63777 .76363 m
.64081 .80136 L
s
P
p
1 0 .6 r
.0025 w
.35352 .74539 m
.33441 .79197 L
s
P
p
1 0 .6 r
.00353 w
.37521 .69252 m
.39123 .71431 L
s
P
p
1 0 .6 r
.00353 w
.67083 .74498 m
.63777 .76363 L
s
P
p
1 0 .6 r
.0025 w
.67474 .79884 m
.70894 .84285 L
s
P
p
1 0 .6 r
.0025 w
.35352 .74539 m
.31437 .78567 L
s
P
p
1 0 .6 r
.00353 w
.37521 .69252 m
.35352 .74539 L
s
P
p
1 0 .6 r
.00353 w
.67083 .74498 m
.67474 .79884 L
s
P
p
1 0 .6 r
.0025 w
.71247 .78272 m
.7149 .82093 L
s
P
p
1 0 .6 r
.0025 w
.33327 .72563 m
.31804 .76331 L
s
P
p
1 0 .6 r
.005 w
.3999 .63237 m
.37521 .69252 L
s
P
p
1 0 .6 r
.02 w
.59038 .25949 m
.59133 .3966 L
s
P
p
1 g
.05 w
.59038 .25949 Mdot
P
p
1 0 .6 r
.005 w
.66637 .68354 m
.67083 .74498 L
s
P
p
1 0 .6 r
.0025 w
.71247 .78272 m
.73989 .81805 L
s
P
p
1 0 .6 r
.0025 w
.78135 .81994 m
.78367 .86828 L
s
P
p
1 0 .6 r
.00353 w
.70973 .73946 m
.71247 .78272 L
s
P
p
1 0 .6 r
.0025 w
.33327 .72563 m
.30177 .75797 L
s
P
p
1 0 .6 r
.00353 w
.35049 .68304 m
.33327 .72563 L
s
P
p
1 0 .6 r
.0025 w
.27228 .75573 m
.25337 .80376 L
s
P
p
1 0 .6 r
.0025 w
.74865 .78967 m
.78361 .83477 L
s
P
p
1 0 .6 r
.005 w
.3999 .63237 m
.35049 .68304 L
s
P
p
1 0 .6 r
.00707 w
.42807 .56371 m
.3999 .63237 L
s
P
p
1 0 .6 r
.0025 w
.74865 .78967 m
.79082 .80773 L
s
P
p
1 0 .6 r
.00353 w
.70973 .73946 m
.74865 .78967 L
s
P
p
1 0 .6 r
.0025 w
.78135 .81994 m
.81635 .8651 L
s
P
p
1 0 .6 r
.005 w
.66637 .68354 m
.70973 .73946 L
s
P
p
1 0 .6 r
.00353 w
.35049 .68304 m
.3058 .72887 L
s
P
p
1 0 .6 r
.00353 w
.77871 .76492 m
.78135 .81994 L
s
P
p
1 0 .6 r
.00707 w
.66127 .61321 m
.66637 .68354 L
s
P
p
1 0 .6 r
.0025 w
.3058 .72887 m
.26541 .7703 L
s
P
p
1 0 .6 r
.0025 w
.3058 .72887 m
.27005 .7426 L
s
P
p
1 0 .6 r
.01414 w
.59133 .3966 m
.59222 .52401 L
s
P
p
1 0 .6 r
.01414 w
.59133 .3966 m
.50575 .4842 L
s
P
p
1 0 .6 r
.0025 w
.27228 .75573 m
.23163 .7974 L
s
P
p
1 0 .6 r
.00353 w
.29377 .70117 m
.27228 .75573 L
s
P
p
1 0 .6 r
.01 w
.50575 .4842 m
.42807 .56371 L
s
P
p
1 0 .6 r
.01 w
.50575 .4842 m
.43997 .50587 L
s
P
p
1 0 .6 r
.0025 w
.82854 .82928 m
.87326 .88705 L
s
P
p
1 0 .6 r
.0025 w
.82854 .82928 m
.88355 .85289 L
s
P
p
1 0 .6 r
.00353 w
.77871 .76492 m
.82854 .82928 L
s
P
p
1 0 .6 r
.00707 w
.42807 .56371 m
.35762 .63582 L
s
P
p
1 0 .6 r
.005 w
.72318 .69318 m
.77871 .76492 L
s
P
p
1 0 .6 r
.005 w
.72318 .69318 m
.79015 .72079 L
s
P
p
1 0 .6 r
.00707 w
.66127 .61321 m
.72318 .69318 L
s
P
p
1 0 .6 r
.005 w
.35762 .63582 m
.29377 .70117 L
s
P
p
1 0 .6 r
.005 w
.35762 .63582 m
.30157 .65607 L
s
P
p
1 0 .6 r
.01 w
.59222 .52401 m
.66127 .61321 L
s
P
p
1 0 .6 r
.0025 w
.3146 .66057 m
.299 .70008 L
s
P
p
1 0 .6 r
.01 w
.59222 .52401 m
.59304 .64208 L
s
P
p
1 0 .6 r
.00353 w
.29377 .70117 m
.23595 .76035 L
s
P
p
1 0 .6 r
.0025 w
.54031 .90685 m
.56861 .95343 L
s
P
p
1 0 .6 r
.0025 w
.54031 .90685 m
.51804 .97164 L
s
P
p
1 0 .6 r
.0025 w
.23595 .76035 m
.18362 .81392 L
s
P
p
1 0 .6 r
.0025 w
.23595 .76035 m
.18869 .77856 L
s
P
p
1 0 .6 r
.0025 w
.83007 .77243 m
.86592 .8188 L
s
P
p
1 0 .6 r
.0025 w
.3146 .66057 m
.28198 .69392 L
s
P
p
1 0 .6 r
.00353 w
.33224 .61588 m
.3146 .66057 L
s
P
p
1 0 .6 r
.0025 w
.83007 .77243 m
.87408 .79086 L
s
P
p
1 0 .6 r
.00353 w
.79015 .72079 m
.83007 .77243 L
s
P
p
1 0 .6 r
.00353 w
.79015 .72079 m
.85186 .74623 L
s
P
p
1 0 .6 r
.00353 w
.56542 .83378 m
.54031 .90685 L
s
P
p
1 0 .6 r
.00707 w
.43997 .50587 m
.37832 .52618 L
s
P
p
1 0 .6 r
.00707 w
.43997 .50587 m
.38342 .56362 L
s
P
p
1 0 .6 r
.0025 w
.5018 .87293 m
.48424 .92484 L
s
P
p
1 0 .6 r
.005 w
.38342 .56362 m
.33224 .61588 L
s
P
p
1 0 .6 r
.005 w
.38342 .56362 m
.33891 .57883 L
s
P
p
1 0 .6 r
.00707 w
.59304 .64208 m
.5938 .75121 L
s
P
p
1 0 .6 r
.00707 w
.59304 .64208 m
.57207 .68493 L
s
P
p
1 0 .6 r
.00353 w
.30157 .65607 m
.24943 .67491 L
s
P
p
1 0 .6 r
.00353 w
.30157 .65607 m
.25528 .70335 L
s
P
p
1 0 .6 r
.00353 w
.33224 .61588 m
.28595 .66315 L
s
P
p
1 0 .6 r
.0025 w
.25528 .70335 m
.21344 .7461 L
s
P
p
1 0 .6 r
.0025 w
.25528 .70335 m
.21777 .71725 L
s
P
p
1 0 .6 r
.00353 w
.56542 .83378 m
.5018 .87293 L
s
P
p
1 0 .6 r
.005 w
.5938 .75121 m
.56542 .83378 L
s
P
p
1 0 .6 r
.0025 w
.28595 .66315 m
.2441 .70589 L
s
P
p
1 0 .6 r
.0025 w
.28595 .66315 m
.24871 .67662 L
s
P
p
1 0 .6 r
.0025 w
.5018 .87293 m
.44443 .90823 L
s
P
p
1 0 .6 r
.0025 w
.85186 .74623 m
.90862 .76963 L
s
P
p
1 0 .6 r
.0025 w
.85186 .74623 m
.88665 .72806 L
s
P
p
1 0 .6 r
.005 w
.5938 .75121 m
.5945 .85185 L
s
P
p
1 0 .6 r
.00353 w
.33891 .57883 m
.29779 .59288 L
s
P
p
1 0 .6 r
.00353 w
.33891 .57883 m
.30196 .61651 L
s
P
p
1 0 .6 r
.0025 w
.30196 .61651 m
.26858 .65054 L
s
P
p
1 0 .6 r
.0025 w
.30196 .61651 m
.27243 .62682 L
s
P
p
1 0 .6 r
.005 w
.37832 .52618 m
.32073 .54516 L
s
P
p
1 0 .6 r
.005 w
.37832 .52618 m
.35873 .49614 L
s
P
p
1 0 .6 r
.0025 w
.24943 .67491 m
.20107 .69238 L
s
P
p
1 0 .6 r
.0025 w
.24943 .67491 m
.23155 .65305 L
s
P
p
1 0 .6 r
.00353 w
.5945 .85185 m
.59514 .94445 L
s
P
p
1 0 .6 r
.00353 w
.5945 .85185 m
.65199 .90272 L
s
P
p
1 0 .6 r
.0025 w
.29779 .59288 m
.25987 .60583 L
s
P
p
1 0 .6 r
.0025 w
.29779 .59288 m
.28418 .57444 L
s
P
p
1 0 .6 r
.005 w
.57207 .68493 m
.55219 .72556 L
s
P
p
1 0 .6 r
.005 w
.57207 .68493 m
.61822 .70367 L
s
P
p
1 0 .6 r
.0025 w
.65199 .90272 m
.70207 .94545 L
s
P
p
1 0 .6 r
.00353 w
.32073 .54516 m
.26711 .56282 L
s
P
p
1 0 .6 r
.00353 w
.32073 .54516 m
.27292 .59378 L
s
P
p
1 0 .6 r
.0025 w
.59514 .94445 m
.59574 1.02948 L
s
P
p
1 0 .6 r
.0025 w
.59514 .94445 m
.54345 .99241 L
s
P
p
1 0 .6 r
.00353 w
.35873 .49614 m
.34042 .46806 L
s
P
p
1 0 .6 r
.00353 w
.35873 .49614 m
.31692 .50944 L
s
P
p
1 0 .6 r
.0025 w
.27292 .59378 m
.22969 .63774 L
s
P
p
1 0 .6 r
.0025 w
.27292 .59378 m
.23432 .60688 L
s
P
p
1 0 .6 r
.0025 w
.65199 .90272 m
.70501 .94965 L
s
P
p
1 0 .6 r
.00353 w
.61822 .70367 m
.66142 .72122 L
s
P
p
1 0 .6 r
.00353 w
.61822 .70367 m
.60473 .7333 L
s
P
p
1 0 .6 r
.0025 w
.31692 .50944 m
.27835 .52171 L
s
P
p
1 0 .6 r
.0025 w
.31692 .50944 m
.30325 .48949 L
s
P
p
1 0 .6 r
.0025 w
.26711 .56282 m
.21732 .57923 L
s
P
p
1 0 .6 r
.0025 w
.26711 .56282 m
.2489 .53833 L
s
P
p
1 0 .6 r
.00353 w
.55219 .72556 m
.53342 .76391 L
s
P
p
1 0 .6 r
.00353 w
.55219 .72556 m
.48715 .75526 L
s
P
p
1 0 .6 r
.0025 w
.34042 .46806 m
.32336 .44189 L
s
P
p
1 0 .6 r
.0025 w
.34042 .46806 m
.35752 .42361 L
s
P
p
1 0 .6 r
.0025 w
.48715 .75526 m
.4275 .7825 L
s
P
p
1 0 .6 r
.0025 w
.48715 .75526 m
.47268 .78312 L
s
P
p
1 0 .6 r
.0025 w
.60473 .7333 m
.59216 .76089 L
s
P
p
1 0 .6 r
.0025 w
.60473 .7333 m
.63566 .74634 L
s
P
p
1 0 .6 r
.0025 w
.66142 .72122 m
.70173 .73759 L
s
P
p
1 0 .6 r
.0025 w
.66142 .72122 m
.72299 .71444 L
s
P
p
1 0 .6 r
.0025 w
.53342 .76391 m
.51577 .79998 L
s
P
p
1 0 .6 r
.0025 w
.53342 .76391 m
.57184 .78117 L
s
P
p
1 g
.002 w
.84957 .03001 m
.88514 .92096 L
s
.88514 .92096 m
.03001 .97661 L
s
.03001 .97661 m
.07871 .12036 L
s
.07871 .12036 m
.84957 .03001 L
s
.84957 .03001 m
.88514 .92096 L
s
.88514 .92096 m
.96999 1.11884 L
s
.96999 1.11884 m
.93299 .35553 L
s
.93299 .35553 m
.84957 .03001 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 333}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000PMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP05000Le/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40001haPT00lH00l@0aP0KaP400000KmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP09000Ze/KFa]K6e/KFa]K6a03Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0006K62@0BaPC40P0KaP400000GMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP09000Be/KFa]K4e/KFa]K6e/KFa]K62L@01<KFa]H2000Ka]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001DaPT03lH00lC6aP09a0g60P0KaP400000BmK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP09000B
e/KFa]K6e/KFa]K6e/KFa]K62L@05/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H2000Ka]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K600400013aPP02<H00lC6aP08aPS41/H00lC6aP0FaP030<@001[60@00000j
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT0
0176e/KFa]K6e/KFa]K6e/KFaP0:a014e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0<@0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<LH90003a/C600o62L@HaP03a<K601G6
00<0a0006/H1000002SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62@004/KF
a]K6e/KFa]K4e/KFa]K6ePW405KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaPT04/H9a1;6
00?4a/H05/H00lC6aP0DaP040<K401W60@00000Fe/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT001?6e/KF
a=K6e/KFa]K6e/KFa]K600S406SFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/@0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000BaP@03/H00lC6aP02aPW42lH00lC6aP0FaP03a<K601G600?4a/H05<H01036a00IaP40
00008=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K62L@0NLKFa]K6e/KFa]K6e/KFa]K6e/KF
a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001;60P03aPW41LH00lC6
aP0FaP03a<K601K600?4a/H05LH00lC6aP0BaP;400@0a<@06<H1000001?Fa]K6e/KFa]K6e/KFa]K6
e/H000C406C6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KF2L@07]K60<K40=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000BaP030<H0017600?4a/H05/H00lC6aP0EaP03a<K601K6
00?4a/@02<@;aP040<K401S60@00001Ye/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6
e/KFa]K6e/KF00W4033Fa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100004/H01@36a/H0017600?4a/H05LH00lC6aP0EaP03a<K600G62L@7aP03a<K601?600D0a/K4
000GaP400000EmK6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP09a012e/KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K40<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001;600<0a/H0
0/H00`36aP0?aP03a<K601G600?4a/H02LH:a0;600?4a/H05LH00lC6aP0BaP050<K6a0005lH10000
04CFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4aPW405G6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KF
a]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000AaP030<K600C600<0a/H0
3lH00lC6aP0>aPW45/H00lC6aP0EaP03a<K6017600H0a/K6a00FaP400000<]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K62L@0IlKFa]K6e/KFa=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFaP36e/K4
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00017600<0a/H01/H00`36aP0<aPW44LH00lC6aP0EaP03
a<K601G600?4a/H04<H00`36aP02aP030<K601C60@00000Pe/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/H0a]K6e/H9a01ia]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100004LH00`36aP07aPG43<H00lC6aP0EaP03a<K601G600?4a/H05<H00lC6
aP0@aP030<C400;400<0a/H05<H1000007gFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6eP09a00L0<KFa]K40<KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000AaP030<K600S600<0a/H03lH00lC6aP0DaP03a<K601G600?4a/H04lH:a0W600<0a/H0
0lH00`36aP0CaP400000J]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/H9a00_a/C6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H00@000176
00<0a/H02/H00`36aP0>aP03a<K601C600?4a/H05<H300[42lH00lC6aP0>aP030<K600?600<0a/H0
4lH1000005KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFaPK41@00@LKFa]K6e/KFa]K6e/KFa]K6e/KF
a=K6e/KFa]K6e/KFa]K6e/H0a]K6e/K40=K6e/KFa]K6e/KFa]K6e/KFa]K60040000AaP030<K600_6
00<0a/H03/H00lC6aP0DaP03a<K600?62L@5aPL04lH00lC6aP0>aP030<K600C600<0a/H04/H10000
04?Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6
e/KFa]K6e/KF00[400k6e/KFa]K6e/KFa]K6ePL0043Fa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6
e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60@00017600<0a/H03<H00`36aP0>aP03
a<K600K62L@5aP03a<K601361`0DaP03a<K600g600<0a/H01<H00`36aP0BaP400000<=K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP[402;Fa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]K61@00@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa036e/KFa]K6e/KFa]K6e/KFa]K60040000AaP030<K600k600<0a/H00/H9a0?600?4a/H0
4lH00lC6aP0AaP<000?4a/H05<H00lC6aP0<aP030<K600G400<0a/H04LH1000002;Fa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K61L@0=/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6a<KFa]K6e/KFa]K6e/KFa]K6eP8o0276a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/H0
1/@07034a<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H100004<H00`36aP0@aP030<K600k600?4a/H0
4lH00lC6aP0@aP05?do6a/@05LH9a0K600<0a/H01LH00`36aP0AaP400000GMK6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6eP02?`0?a]K4e/KFa]K6e/KFa]K600W402_6a<KFa]K6e/KFa]K6e/H0
a]K6e/KFa/@0e/KFa]K6e/KFa]K6e/KFa]K60040000@aP030<K6017600<0a/H03/H00lC6aP0CaP03
a<K600o600<oClH00/H00lC6aP09a0[600?4a/H03<H00`36aP05aP030<K601360@00001Ke/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6eP02a08o1/@0?LKFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KF
a]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H00@00013600<0a/H04lH00`36aP0=aP03
a<K601?600?4a/H00lH9a0;600<oClH00lH00lC6aP0CaP03a<K600_600<0a/H01LH00`36aP0@aP40
0000BMK6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K4
e/KFa]K6e/KFa]K6e/KFa]H02L@02mK6e/KFa]K6e/KF008o04?6e/KFa=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/CFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60040000@aP030<K601C6
00<0a/H03LH00lC6aP06aPW41LH00lC6aP0<aP03?do600?600?4a/H05<H00lC6aP0:aP030<K600K6
00<0a/H03lH1000003OFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KF00W401gFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6eP02?`13a]K6e/K4a]K6e/KF
a]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP010000
4<H00`36aP0EaP030<K600?62L@2aP03a<K601?600?4a/H02lH00cm?aP04aP03a<K601?600?4a/H0
2/H00`36aP02aPC400<0a<H03lH1000002WFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP05a00_e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]H0
0Sl08lKFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K600G400<0a<@00/@05]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/H100004<H00`36aP0GaP030<K600g600?4a/H04lH00lC6aP0:aP03?do600G6
00?4a/H04<H:a0G600<0a/H00/H601360@00001Me/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6
e/KF008o0136e/KFa]K6a<KFa]K6e/KF2L@02MK6e/CFa]K6eP0;000Fe/KFa]H0e/KFa]K6e/KFa]K6
e/KFaP40000@aP030<K601S600<0a/H03LH00lC6aP0CaP03a<K600W600<oClH01LH:a0O61P000l@0
000200K600<0a/H01lH00`36aP0>aP400000FmK6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]H0
0/@2?`K400K6a<KFa]H;000/e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/H100004<H00`36aP0IaP030<K600g600?4a/H04/H:a0;600<oClH01`001<@0000LaP030<K600O6
00<0a/H03/H1000004OFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6eP0:a005a/C6e/H01`02?`130=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP0100003lH00`36
aP0LaP030<K600c62/@4aPP000?400001lH00cm?aP0WaP030<K600O600<0a/H03/H1000003CFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K62l@00lH00009000A
a]K6e/KFa]K6e/KFa]K6e/H00cl0@lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H00@0000o600<0a/H07LH5a003aP0000P000?4a/H0
6LH013m??dlXaP030<K600O600<0a/H03/H10000033Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H5000Ua]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP05?`13a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFaP0100003lH00`36aP0NaP030<K600S600<oa/H06lH01Sm??lHoCbS600<0a/H0
2<H00`36aP0=aP400000F=K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`17a]Ho?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0
0@0000o600<0a/H07/H00`36aP03aP05ClK6aTl07<H00cm??`03aP03?do602O600<0a/H02<H00`36
aP0=aP400000E]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl01<KFa]H2?`13a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP010000
3lH00`36aP0NaP030<K600C600@oa/I?6/H00cm??`05aP03?do602O600<0a/H02<H00`36aP0=aP40
0000>=K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
0Sl06]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl01/KFa]K6eP8o04?6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60040000?aP03
0<K601k600<0a/H01/H00co6aP0GaP03?dlo00O600<oClH09lH00`36aP08aP030<K600g60@00001B
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o00S6e/KFa]K6eP8o04?6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60040000?aP030<K601k6
00<0a/H01lH00do6aP0DaP03?dlo00W600<oClH0:<H00`36aP07aP030<K600g60@00001@e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF?mK6e/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/H3?`0:a]K6e/KFa]K6eP8o04?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60040000?aP030<K601k600@0a/Ho
1/H00dloaP0@aP05?dloCcl02lH00cm?aP0XaP030<K600O600<0a/H03LH1000003OFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6?lKF00<o013F?mK6e/KFa]K6
e/KFa]K60cl04<KFaSo6e/KFa]K6e/KFa]H2?`13a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP0100003/H00`36aP0OaP070<K6aTlo
C`05aP03ClK600O600A??dlo1LH00co6aP0;aP03?do602S600<0a/H01lH00`36aP0=aP400000<MK6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP000cl03mK6e/KFa]K6
eSoFa]K6eP03?`0GeSoFa]K6e/Hoa]K6e/KFa]K6e/KFa]H00Sl0@lKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H00@0000k600<0a/H0
7/H00cm?aP0;aP06?lK6Ccm?0lH00do6aP04aP03?lK600g600<oClH0:<H00`36aP07aP030<K600g6
0@00000me/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6eP03?`0Me/KFa]Hoe/KFa]K6?lKFa]K6e/KFa]K6e/KFa]H00Sl0@lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H00@0000k6
00<0a/H07/H00`36aP08aP03Ccm?00O600=?a/H01<H00co6aP0?aP03?do602S600<0a/H01lH00`36
aP0=aP400000=mK6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF0=K6
e/KFa]H00cl09=K6e/KFa]K6eSoFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFaP8o04;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H10000
3/H00`36aP0KaP04ClK600C600=??dl02lH00do6aP04aP03?lK601;600=?aTl09lH00`36aP07aP03
0<K600g60@00000`e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mH0
13l0K]Hoe/KFa]K6e/KFa]Hoe/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60@0000k6
00<0a/H07<H00cm??`04aP03ClK600W600=?a/H01<H00co6aP0DaP05ClK6aTl09LH00`36aP08aP03
0<K600c60@00000Ze/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl04<KF
0=K6eSoFa]K6e/KFa]H3?`05e/KFa]H00Sl0FlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Hoe/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0
0@0000k600<0a/H05/H00cm??`05aP0404o6C`O600A??dlo1/H00do6C`0GaP03ClK600?600=?a/H0
8LH00`36aP08aP030<K600c60@00000`e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/KFa]H00Sl01MK6e/KF00<o06SFaSo6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFaP40000>aP030<K601k600<0Ccl00/H014loCcl3aP03?lK600C600A?a/Ho6<H00do6
aP04aP03?lK6023600<0a/H02<H00`36aP0<aP400000;]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`1beSlo?mK6?lKFaSo6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K60@0000k600<0a/H06/H01Sm??dloC`C600Doa/K6?`06aP05ClK6aTl0
6LH00do6aP06aP03?lK601k600<0a/H02<H00`36aP0<aP400000:MK6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o07O6eSoF0=K6e/Hoa]K6?lKFa]K6eSoFa]K6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP0100003LH00`36aP0LaP04ClK600;600=??lH00/H00co6
aP04aP03ClK600;600<oa/H06<H00do6aP08aP03?lK601c600<0a/H02<H00`36aP0<aP400000<=K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF008o073F?mK6eSoFa]K6
eSoFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60@0000g600<0a/H06/H00do6
aP02aP04?lK6C`?600=??lH00lH00do6aP04aP03?lK601S600=?a/H02<H00cm?aP0LaP030<K600S6
00<0a/H03<H1000003GFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
eP3F?mK6eP02?`03a]K6008o00GFa]K6eP02?`1Oa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF
a]K6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KF
a]K6e/H00@0000g600<0a/H06<H00do6aP04aP0304o600;600Q?aTloCco6?`C600=?aTl06lH00do6
aP08aP04?lK6Ca_600<0a/H02<H00`36aP0<aP400000<mK6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eP04?`1[a]K6?lKFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6?lKFa]K6e/KFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF
a]H0e/KFa]K6e/KFa]K6e/H00@0000g600<0a/H06<H00do6aP03aP08C`36aTloaSl3aP03?lK600;6
00A?a/Ho6lH00cm?aP09aP05?lK6aSl06/H00`36aP08aP030<K600c60@00000_e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]H013l0:/KF?mK6?lKFa]Hoe/Hoa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP8o04?6e/KFa]K6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60040000=aP030<K601[600Q?aTloCcm??`;6
00A??lHo1<H01Do6a/I?01_600=?aTl02/H00co6aP03aP03?lK601O600<0a/H01lH00`36aP0<aP40
0000:]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o00K6eSloa]H2?`1]
aSo6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6eSoFa]K6eSoF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP0100003LH00`36
aP0GaP03?dlo00C600Q??lK6ClI??`C600=?a/H00/H00co6aP0JaP03ClI?00[600<oa/H01<H00do6
aP0FaP030<K600S600<0a/H02lH1000002GFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF008o00K6e/KFa]H2?`0/0=Hoe/Hoa]K6e/Hoa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]H4?`13a]K6e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0
a]K6e/KFa]K6e/KFaP0100003LH00`36aP0DaP03ClK600G600E??lH0C`02aP03?lK600?600<oClH0
0/H00do6aP0JaP06?lK6Ccm?2<H00cm?aP06aP03Cco601C600<0a/H02<H00`36aP0;aP400000:mK6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl01LH0a]K6008o00CFa]K6
0Sl09mK6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFaSo6eP03?`0@e/KFa]HoeSoFa]K6
e/HoaP<o02_6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60040000=aP03
0<K601S600M??do6ClH000;600<oClH00lH00co6?`03aP03?lHo01[600E?a/K6C`03aP05ClI??dl0
0/H013o6aTl6aP06?lK6aSm?4<H00`36aP08aP030<K600_60@00000Ve/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`08e/KF?mK60<H2?`0ee/KFaSo6eSoFa]Hoe/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/Hoa]Hoe/KFa]H00cl00mK6eP06?`06aSo6e/KF0cl09]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60@0000c600<0a/H06lH024o6a/H0?lHo0lH013o6
aTl4aP04?lK6CaS600<oa/H00/H014o6aSl7aP05?dloCcl01lH00co6aP04aP03Cco600[600<0a/H0
2<H00`36aP0;aP400000<mK6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/Hoa]HoeP02?`0Ra]K6?lKFaSo6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6eP8o01?6e/KFaSo6eSoF
a]K6e/KFaSo600<o00o6e/KFa]Hoe/KFa]K6?lH00Sl08]K6e/KFa]K6eP0oa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/H100003<H00`36aP0IaP03ClK600;600Lo0<I??dlo00?600<oClH00/H014o6aSl2aP03
ClK6013600@oClI?1LH014o6Ccl8aP03ClK600;600<oa/H01<H00do6aP04aP06?lK6Ccm?1<H00cm?
000:aP030<K600_60@00000^e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/HoaP<o00G6?lKFaP02?`0Je/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/H3?`0=a]Hoe/KFa]K6?lHo
aP03?`0Na]K6e/Hoa]K6e/Hoa]K6e/KF?mK6e/KFaSo6e/KF0Sl07LHoa]H0e/KFa]K6e/KFaP36e/KF
a]K6e/KFa]K60040000<aP030<K601O600=?a/H00/H01co6aP36Ccl00lH00cm?aP03aP04?lK6Ca76
00=??lH00lH00do6aP05aP03Cco600C600Hoa/K6?dl5aP03ClK600C600<oa/H01LH00co6aP03aP05
?do6aP002/H00`36aP0;aP400000;]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/H3?`09a]K6?lHoa]K6008o01;FaSo6e/KFa]K6e/KFa]K6e/H2?`0>e/KFa]K6?lKFa]K6
e/H2?`06e/KFa]K60cl01lHoa]K6e/H00Sl05MK6e/KFaSo6e/KFa]Hoe/KFa]K6eP02?`0I0=K6e/KF
a]K6e/H0a]K6e/KFa]K6e/KFaP0100003<H00`36aP0IaP03Cco600;600<o03l00lH00co6?`03aP03
?do6013600A??lHo1LH00cm?aP06aP03ClK600?600=??lH00lH00do6aP03aP03ClI?00K600<oa/H0
1<H00do6aP06aP0404loC`O600<0a/H02lH1000002GFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00@o0236e/HoaSo6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6eP<o00_FaSo6e/KFa]Ho
eP02?`04a]K6eP8o04?6e/KF?mHoe/KFaSo6e/KFaSo6eSoFa]K6e/Hoa]K6e/KF?mK6e/KFa]H0e/KF
?mK6e/KFaP36e/KFa]K6e/KFa]K60040000<aP030<K601C600DoClK6?`03aP04?lK6C`S600<oaSl0
3LH00cm?aP03aP03?lK600C600=?a/H00/H01Sm?a/HoC`?600A?a/Ho1<H00do6aP03aP05ClK6aTl0
1LH00do6aP05aP03Ccm?00C600<0a/H02<H00`36aP0;aP400000GMK6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6?lKFaSo6eSl0a]K6e/KFaSo6eSoFa]K6e/KFa]K6e/Hoa]K6e/Hoa]K6
e/KFaSo6e/KFa]HoeP02?`0Ka]Hoe/KF?mK6e/KF?mK6e/Hoa]K6eSoFa]K6008o00WFa]K6e/Hoa]H0
0cl06]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60@0000c600<0a/H05/H01Co6a/Ho00?600<o0<H0
1LH01Co6a/Ho01[600=?a/H01LH00do6C`07aP03ClK600;600<oa/H00/H00do6aP03aP07Cco6aTo6
C`06aP03?lK600;600=?0<H02LH00`36aP0;aP400000L=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/Hoa]K6eSl0a]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFa]K6?lHoa]K6e/KFaSo6e/KF?mK6e/H2?`06e/KFaSo60cl09lKF?mK6e/KFaSo6e/KF0=K6e/KF
a]K6e/H0a]K6e/KFa]K6e/KFaP0100003<H00`36aP0DaP03?lK600K600=?aP009<H00co6aP06aP03
ClI?00O600=?a/H00/H00co6aP02aP03ClI?00C600Doa/I??`02aP03ClK600C600Doa/K6000:aP03
0<K600_60@00002Re/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]Hoe/KFa]K6e/KFa]Ho
e/KFa]HoeSoFa]K6?lHoaSo6?lKFa]K6eSoFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60@0000c6
00<0a/H04/H00co6aP0:aP030<K602[600Doa/K6?`0;aP03?do600?600@oa/I?1<H00cm?aP03aP03
?lK600C600A?a/H02lH00`36aP0:aP400000NMK6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KF?mK6e/KFa]K6e/KF?mHoe/KF?mK6e/KFa]H00Sl09lKFa]K6?lKFa]K6eSoF0=K6e/KFa]K6e/KF
0=K6e/KFa]K6e/KFaP0100002lH00`36aP0PaP030<K602W600=?a/H00/H00co6aP09aP04?lK6C`_6
00=?a/H01<H00cm?aP05aP030<K600W600<0a/H02/H1000005WFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP02?`0Oa]K6eSoFa]K6e/KFa]K6eSoFa]Hoe/KFa]K6e/KFaP02?`07e/KFa]HoeP02?`0M
a]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H00@0000_600<0a/H08<H00`36aP0WaP03ClI?00C6
00<oa/H02LH00co6aP02aP03ClK600O600=?aTl01LH01To6aSm??`;600<0a/H02<H00`36aP0:aP40
0000E]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0<=K6?lKFa]Hoe/KFa]K6e/KFa]Hoe/KFa]K6
e/KFa]K6e/KF?mHoe/KFa]Hoe/KFaP8o01P0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H100002lH00`36
aP0PaP030<K602C600Doa/K6?`05aP03?do601W600@oa/I?1LH00do6aP03aP030<K600S600<0a/H0
2/H1000005?Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`1=a]K6eSoFa]K6eSoF?mK6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]Hoe/KF?mK6e/KF?mK6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H00@0000_6
00<0a/H08<H00`36aP0QaP03ClK600C600<oa/H00lH013o6aTlHaP03?lK600;600=?a/H00/H00co6
aP02aP030<K600S600<0a/H02/H10000053Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o053Fa]K6e/Hoa]K6
e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFaP36e/KFa]K6e/KF0=K6
e/KFa]K6e/KFaP40000;aP030<K6023600<0a/H07LH014loaSl6aP03ClK600C600<oa/H00/H00do6
aP0PaP04?lK600[600<0a/H02/H1000004cFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0E=K6?lKFa]K6e/Hoa]K6
e/KF?mK6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaP36e/KFa]K6e/KF0=K6
e/KFa]K6e/KFaP40000;aP030<K601o600<0a/H06lH00co6aP02aP03ClK600G600=?a/H01<H00co6
aP04aP03ClK6027600<0a/H02<H00`36aP0:aP400000BMK6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl07<KFa]Hoe/KF
a]K6eSoFa]K6e/KF?mK6e/KFa]H2?`0ia]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF
a]K6e/KFa]H0e/KFa]K6e/KFa]K60040000;aP030<K601o600<0a/H06<H00do6aP04aP03?lK600G6
00<oa/H01LH00co6aP07aP03?lK601k600<0a/H02<H00`36aP0:aP400000X]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP40000;aP030<K601o600<0a/H07/H00do6aP05aP03
ClI?00K600<oa/H02LH00cm?aP0DaPT02/H00`36aP0:aP400000K=K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lHoa]K6e/KF?mK6e/KFa]K6e/KFaP8o00CFa]K640008=K6e/KFa]K60<KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K60@0000[600<0a/H08<H00`36aP0UaP05?lK6aSl01LH00co6aP0@01W600<0a/H0
2<H00`36aP09aP400000D]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H@000<e/KFa]K6e/KFa]K60Sl0<]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K60@0000[600<0a/H0
8<H00`36aP0BaQ000lH00co6aP02aP06ClK6?lHo3lH00co6aP0JaP030<K600O600<0a/H02LH10000
03;Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaQ0001WFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KF008o04G6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/H00@0000[600<0a/H05LH@02;600=?a/H0
1<H01Co6a/Ho02c600<0a/H01lH00`36aP09aP4000004]K6e/KFa]K6e/H0a]K6e/KFaQ00083Fa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFaSo6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6
e/KFaP40000:aPP06lH00`36aP0YaP03?lK600?600<oa/H0:lH00`36aP06aP030<K600W60@00002R
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K60@0000g600<0a/H07LH00`36
aP0WaP03?lK600G600<oa/H0;<H00`36aP05aP030<K600W60@00002Re/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K60@0000o60P0LaP030<K602o600<oa/H0;LH00`36aP04aP03
0<K600W60@00002Re/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K60@0001;6
00<0a/H06<H00`36aP0_aP03?lK602k600<0a/H00lH00`36aP09aP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFaP40000DaP805lH00`36aP0_aP03?lK602o600<0a/H0
0/H00`36aP09aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFaP40
000GaP030<K601?600<0a/H0H/H01@36a/H000_60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K60<KFa]K6e/KFa]K60@0001W60P0BaP030<K606?600@0a/H02lH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/H100007<H00`36aP0=aP030<K606G600@0a/H0
2/H1000001gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP020023a]K6e/KFa]K6e/KFaP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/H00@0001o6
00<0a/H02/H00`36aP1VaP030<H000[60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
eP3Fa]K6e/KFa]K60@00027600<0a/H02<H00`36aP1VaP030<H000[60@00000Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8007;Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H2000:e/KFa]K6e/KFaP40000TaP030<K600G600<0a/H0IlH200[6
0@00002>e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPX000[Fa]K6e/KFa]K60@0002K600<0a/H00lH00`36
aP1=aQ805<H1000002OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P00@LKF
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6018002KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000YaP040<K602c6
4@0haP400000AmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF018004W6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000[aP802<HB05_60@00000/
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9001]a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000X/H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0193533, -0.0250048, 
  0.00558674, 0.00558674}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.15689 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0522455 1.17669 0.0294174 1.17669 [
[ 0 0 0 0 ]
[ 1 1.15689 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.15689 L
0 1.15689 L
closepath
clip
newpath
p
1 g
.002 w
.85161 .02942 m
.88742 .88807 L
s
.88742 .88807 m
.02942 .94429 L
s
.02942 .94429 m
.07864 .12058 L
s
.07864 .12058 m
.85161 .02942 L
s
.93388 .36142 m
.28495 .42453 L
s
.28495 .42453 m
.26276 1.12747 L
s
.26276 1.12747 m
.97058 1.08997 L
s
.97058 1.08997 m
.93388 .36142 L
s
.85161 .02942 m
.88742 .88807 L
s
.88742 .88807 m
.97058 1.08997 L
s
.97058 1.08997 m
.93388 .36142 L
s
.93388 .36142 m
.85161 .02942 L
s
.07864 .12058 m
.28495 .42453 L
s
.28495 .42453 m
.26276 1.12747 L
s
.26276 1.12747 m
.02942 .94429 L
s
.02942 .94429 m
.07864 .12058 L
s
p
.4 g
.86245 .07318 m
.10564 .16036 L
s
P
p
.4 g
.8972 .21339 m
.19254 .28839 L
s
P
p
.4 g
.92715 .33426 m
.26794 .39948 L
s
P
p
.4 g
.79931 .03559 m
.8903 .36566 L
s
P
p
.4 g
.50783 .06996 m
.64656 .38936 L
s
P
p
.4 g
.22655 .10314 m
.40994 .41237 L
s
P
P
p
1 0 .6 r
.00177 w
.42199 .6802 m
.43266 .69529 L
s
P
p
1 0 .6 r
.00177 w
.42199 .6802 m
.44756 .67031 L
s
P
p
1 0 .6 r
.00177 w
.60104 .72102 m
.57874 .73407 L
s
P
p
1 0 .6 r
.00177 w
.39626 .69573 m
.405 .70761 L
s
P
p
1 0 .6 r
.00177 w
.35985 .73141 m
.37135 .74602 L
s
P
p
1 0 .6 r
.00177 w
.66197 .77907 m
.63895 .79155 L
s
P
p
1 0 .6 r
.00177 w
.60104 .72102 m
.57026 .70778 L
s
P
p
1 0 .6 r
.00177 w
.66197 .77907 m
.66474 .81618 L
s
P
p
1 0 .6 r
.00177 w
.39626 .69573 m
.38421 .72478 L
s
P
p
1 0 .6 r
.0025 w
.40983 .66301 m
.42199 .6802 L
s
P
p
1 0 .6 r
.00177 w
.62913 .73967 m
.61117 .74988 L
s
P
p
1 0 .6 r
.00177 w
.35985 .73141 m
.34489 .76792 L
s
P
p
1 0 .6 r
.00177 w
.62913 .73967 m
.63156 .76933 L
s
P
p
1 0 .6 r
.0025 w
.62638 .7062 m
.60104 .72102 L
s
P
p
1 0 .6 r
.0025 w
.40983 .66301 m
.39626 .69573 L
s
P
p
1 0 .6 r
.0025 w
.65882 .73704 m
.66197 .77907 L
s
P
p
1 0 .6 r
.0025 w
.62638 .7062 m
.62913 .73967 L
s
P
p
1 0 .6 r
.0025 w
.37677 .69013 m
.35985 .73141 L
s
P
p
1 0 .6 r
.00177 w
.68887 .77572 m
.69089 .8054 L
s
P
p
1 0 .6 r
.00177 w
.34242 .72542 m
.33056 .75468 L
s
P
p
1 0 .6 r
.00353 w
.39593 .64336 m
.40983 .66301 L
s
P
p
1 0 .6 r
.00177 w
.694 .75618 m
.67521 .76641 L
s
P
p
1 0 .6 r
.00353 w
.65525 .68931 m
.62638 .7062 L
s
P
p
1 0 .6 r
.00177 w
.68887 .77572 m
.71586 .81048 L
s
P
p
1 0 .6 r
.00177 w
.34575 .70552 m
.35515 .71755 L
s
P
p
1 0 .6 r
.00177 w
.694 .75618 m
.696 .78619 L
s
P
p
1 0 .6 r
.0025 w
.65882 .73704 m
.68887 .77572 L
s
P
p
1 0 .6 r
.0025 w
.37677 .69013 m
.34242 .72542 L
s
P
p
1 0 .6 r
.00353 w
.39593 .64336 m
.37677 .69013 L
s
P
p
1 0 .6 r
.00353 w
.65525 .68931 m
.65882 .73704 L
s
P
p
1 0 .6 r
.00177 w
.34242 .72542 m
.3114 .7573 L
s
P
p
1 0 .6 r
.00177 w
.34575 .70552 m
.33378 .73511 L
s
P
p
1 0 .6 r
.00177 w
.75419 .79736 m
.72963 .80994 L
s
P
p
1 0 .6 r
.00177 w
.75419 .79736 m
.75618 .83519 L
s
P
p
1 0 .6 r
.0025 w
.69174 .72231 m
.694 .75618 L
s
P
p
1 0 .6 r
.00177 w
.71579 .75332 m
.71726 .77727 L
s
P
p
1 0 .6 r
.0025 w
.35922 .67219 m
.34575 .70552 L
s
P
p
1 0 .6 r
.00177 w
.28927 .74048 m
.30198 .75542 L
s
P
p
1 0 .6 r
.005 w
.4177 .59024 m
.39593 .64336 L
s
P
p
1 0 .6 r
.02 w
.58469 .26347 m
.58543 .38357 L
s
P
p
1 g
.05 w
.58469 .26347 Mdot
P
p
1 0 .6 r
.005 w
.65119 .63499 m
.65525 .68931 L
s
P
p
1 0 .6 r
.00177 w
.33163 .70049 m
.32216 .72413 L
s
P
p
1 0 .6 r
.00177 w
.28927 .74048 m
.27445 .77803 L
s
P
p
1 0 .6 r
.00177 w
.71579 .75332 m
.73741 .7812 L
s
P
p
1 0 .6 r
.0025 w
.69174 .72231 m
.71579 .75332 L
s
P
p
1 0 .6 r
.0025 w
.75193 .7545 m
.75419 .79736 L
s
P
p
1 0 .6 r
.00177 w
.75397 .76762 m
.75556 .79801 L
s
P
p
1 0 .6 r
.00353 w
.68919 .68402 m
.69174 .72231 L
s
P
p
1 0 .6 r
.0025 w
.35922 .67219 m
.33163 .70049 L
s
P
p
1 0 .6 r
.00353 w
.37443 .63457 m
.35922 .67219 L
s
P
p
1 0 .6 r
.00177 w
.78261 .79411 m
.784 .82436 L
s
P
p
1 0 .6 r
.00177 w
.33163 .70049 m
.30673 .72603 L
s
P
p
1 0 .6 r
.00177 w
.75397 .76762 m
.7815 .80316 L
s
P
p
1 0 .6 r
.0025 w
.30605 .698 m
.28927 .74048 L
s
P
p
1 0 .6 r
.00177 w
.29998 .71085 m
.28809 .74098 L
s
P
p
1 0 .6 r
.0025 w
.72331 .72806 m
.75397 .76762 L
s
P
p
1 0 .6 r
.005 w
.4177 .59024 m
.37443 .63457 L
s
P
p
1 0 .6 r
.00707 w
.44249 .52976 m
.4177 .59024 L
s
P
p
1 0 .6 r
.0025 w
.72331 .72806 m
.76011 .74357 L
s
P
p
1 0 .6 r
.00353 w
.68919 .68402 m
.72331 .72806 L
s
P
p
1 0 .6 r
.00177 w
.78261 .79411 m
.81018 .82969 L
s
P
p
1 0 .6 r
.0025 w
.75193 .7545 m
.78261 .79411 L
s
P
p
1 0 .6 r
.005 w
.65119 .63499 m
.68919 .68402 L
s
P
p
1 0 .6 r
.00353 w
.37443 .63457 m
.33532 .67464 L
s
P
p
1 0 .6 r
.00177 w
.83219 .81283 m
.83348 .85125 L
s
P
p
1 0 .6 r
.00353 w
.74937 .70582 m
.75193 .7545 L
s
P
p
1 0 .6 r
.00707 w
.64655 .57296 m
.65119 .63499 L
s
P
p
1 0 .6 r
.00177 w
.2705 .73441 m
.25875 .76451 L
s
P
p
1 0 .6 r
.0025 w
.33532 .67464 m
.29998 .71085 L
s
P
p
1 0 .6 r
.0025 w
.33532 .67464 m
.30421 .68628 L
s
P
p
1 0 .6 r
.01414 w
.58543 .38357 m
.58613 .49488 L
s
P
p
1 0 .6 r
.01414 w
.58543 .38357 m
.51048 .46023 L
s
P
p
1 0 .6 r
.00177 w
.29998 .71085 m
.26805 .74356 L
s
P
p
1 0 .6 r
.00177 w
.76011 .74357 m
.78204 .7719 L
s
P
p
1 0 .6 r
.00177 w
.3296 .64895 m
.33945 .66191 L
s
P
p
1 0 .6 r
.00177 w
.76011 .74357 m
.79367 .75772 L
s
P
p
1 0 .6 r
.0025 w
.30605 .698 m
.2705 .73441 L
s
P
p
1 0 .6 r
.00353 w
.32506 .64985 m
.30605 .698 L
s
P
p
1 0 .6 r
.01 w
.51048 .46023 m
.44249 .52976 L
s
P
p
1 0 .6 r
.01 w
.51048 .46023 m
.45301 .47883 L
s
P
p
1 0 .6 r
.00177 w
.2705 .73441 m
.23838 .7673 L
s
P
p
1 0 .6 r
.00177 w
.83219 .81283 m
.86737 .85829 L
s
P
p
1 0 .6 r
.00177 w
.3296 .64895 m
.31738 .67984 L
s
P
p
1 0 .6 r
.00177 w
.56548 .87051 m
.58741 .90698 L
s
P
p
1 0 .6 r
.0025 w
.79301 .76221 m
.83219 .81283 L
s
P
p
1 0 .6 r
.0025 w
.79301 .76221 m
.84088 .78243 L
s
P
p
1 0 .6 r
.00353 w
.74937 .70582 m
.79301 .76221 L
s
P
p
1 0 .6 r
.00707 w
.44249 .52976 m
.38087 .59277 L
s
P
p
1 0 .6 r
.005 w
.70074 .64298 m
.74937 .70582 L
s
P
p
1 0 .6 r
.00177 w
.30421 .68628 m
.27567 .69695 L
s
P
p
1 0 .6 r
.00177 w
.30421 .68628 m
.2788 .71229 L
s
P
p
1 0 .6 r
.00177 w
.56548 .87051 m
.55162 .91058 L
s
P
p
1 0 .6 r
.005 w
.70074 .64298 m
.75909 .66672 L
s
P
p
1 0 .6 r
.00707 w
.64655 .57296 m
.70074 .64298 L
s
P
p
1 0 .6 r
.00177 w
.22885 .74824 m
.21416 .78667 L
s
P
p
1 0 .6 r
.00177 w
.52124 .8863 m
.50393 .93698 L
s
P
p
1 0 .6 r
.005 w
.38087 .59277 m
.32506 .64985 L
s
P
p
1 0 .6 r
.005 w
.38087 .59277 m
.33211 .60998 L
s
P
p
1 0 .6 r
.01 w
.58613 .49488 m
.64655 .57296 L
s
P
p
1 0 .6 r
.00177 w
.82538 .75248 m
.82647 .78375 L
s
P
p
1 0 .6 r
.0025 w
.34338 .61414 m
.3296 .64895 L
s
P
p
1 0 .6 r
.01 w
.58613 .49488 m
.58677 .59776 L
s
P
p
1 0 .6 r
.00353 w
.32506 .64985 m
.27454 .7015 L
s
P
p
1 0 .6 r
.0025 w
.5407 .82929 m
.56548 .87051 L
s
P
p
1 0 .6 r
.00177 w
.84088 .78243 m
.86897 .81875 L
s
P
p
1 0 .6 r
.00177 w
.31489 .64324 m
.30521 .66794 L
s
P
p
1 0 .6 r
.00177 w
.52124 .8863 m
.47682 .91366 L
s
P
p
1 0 .6 r
.0025 w
.5407 .82929 m
.52124 .8863 L
s
P
p
1 0 .6 r
.0025 w
.27454 .7015 m
.22885 .74824 L
s
P
p
1 0 .6 r
.0025 w
.27454 .7015 m
.23357 .71688 L
s
P
p
1 0 .6 r
.00177 w
.84088 .78243 m
.88472 .80095 L
s
P
p
1 0 .6 r
.00177 w
.82538 .75248 m
.85356 .78894 L
s
P
p
1 0 .6 r
.00177 w
.22885 .74824 m
.18753 .7905 L
s
P
p
1 0 .6 r
.0025 w
.79401 .7119 m
.82538 .75248 L
s
P
p
1 0 .6 r
.0025 w
.34338 .61414 m
.31489 .64324 L
s
P
p
1 0 .6 r
.00353 w
.35894 .57482 m
.34338 .61414 L
s
P
p
1 0 .6 r
.0025 w
.79401 .7119 m
.83227 .72769 L
s
P
p
1 0 .6 r
.00353 w
.75909 .66672 m
.79401 .7119 L
s
P
p
1 0 .6 r
.00177 w
.49171 .84485 m
.47802 .88551 L
s
P
p
1 0 .6 r
.00177 w
.31489 .64324 m
.28918 .66952 L
s
P
p
1 0 .6 r
.00353 w
.75909 .66672 m
.81275 .68854 L
s
P
p
1 0 .6 r
.00353 w
.56262 .76508 m
.5407 .82929 L
s
P
p
1 0 .6 r
.00707 w
.45301 .47883 m
.39934 .49619 L
s
P
p
1 0 .6 r
.00707 w
.45301 .47883 m
.40362 .52923 L
s
P
p
1 0 .6 r
.00177 w
.25523 .68848 m
.24329 .71967 L
s
P
p
1 0 .6 r
.00177 w
.28204 .6533 m
.26989 .68478 L
s
P
p
1 0 .6 r
.00177 w
.49171 .84485 m
.45626 .86665 L
s
P
p
1 0 .6 r
.0025 w
.50706 .79923 m
.49171 .84485 L
s
P
p
1 0 .6 r
.005 w
.40362 .52923 m
.35894 .57482 L
s
P
p
1 0 .6 r
.005 w
.40362 .52923 m
.36492 .54219 L
s
P
p
1 0 .6 r
.00707 w
.58677 .59776 m
.58736 .69263 L
s
P
p
1 0 .6 r
.00707 w
.58677 .59776 m
.56834 .63433 L
s
P
p
1 0 .6 r
.00353 w
.33211 .60998 m
.28689 .62595 L
s
P
p
1 0 .6 r
.00353 w
.33211 .60998 m
.29172 .65121 L
s
P
p
1 0 .6 r
.00177 w
.83227 .72769 m
.85472 .75675 L
s
P
p
1 0 .6 r
.00177 w
.83227 .72769 m
.86719 .7421 L
s
P
p
1 0 .6 r
.00353 w
.35894 .57482 m
.31854 .61605 L
s
P
p
1 0 .6 r
.0025 w
.29172 .65121 m
.25523 .68848 L
s
P
p
1 0 .6 r
.0025 w
.29172 .65121 m
.25922 .66297 L
s
P
p
1 0 .6 r
.00177 w
.23357 .71688 m
.19579 .73107 L
s
P
p
1 0 .6 r
.00177 w
.23357 .71688 m
.20061 .75055 L
s
P
p
1 0 .6 r
.00353 w
.56262 .76508 m
.50706 .79923 L
s
P
p
1 0 .6 r
.005 w
.58736 .69263 m
.56262 .76508 L
s
P
p
1 0 .6 r
.0025 w
.31854 .61605 m
.28204 .6533 L
s
P
p
1 0 .6 r
.0025 w
.31854 .61605 m
.28626 .62746 L
s
P
p
1 0 .6 r
.00177 w
.25523 .68848 m
.22226 .72214 L
s
P
p
1 0 .6 r
.0025 w
.50706 .79923 m
.45696 .83002 L
s
P
p
1 0 .6 r
.00177 w
.45696 .83002 m
.41181 .85777 L
s
P
p
1 0 .6 r
.00177 w
.45696 .83002 m
.41367 .82368 L
s
P
p
1 0 .6 r
.0025 w
.81275 .68854 m
.862 .70858 L
s
P
p
1 0 .6 r
.0025 w
.81275 .68854 m
.84273 .67218 L
s
P
p
1 0 .6 r
.00177 w
.28204 .6533 m
.24906 .68695 L
s
P
p
1 0 .6 r
.00177 w
.30361 .60467 m
.29379 .63008 L
s
P
p
1 0 .6 r
.005 w
.58736 .69263 m
.5879 .77993 L
s
P
p
1 0 .6 r
.00353 w
.36492 .54219 m
.32925 .55413 L
s
P
p
1 0 .6 r
.00353 w
.36492 .54219 m
.3327 .57502 L
s
P
p
1 0 .6 r
.00177 w
.25922 .66297 m
.22938 .67375 L
s
P
p
1 0 .6 r
.00177 w
.25922 .66297 m
.23296 .68974 L
s
P
p
1 0 .6 r
.0025 w
.3327 .57502 m
.30361 .60467 L
s
P
p
1 0 .6 r
.0025 w
.3327 .57502 m
.30711 .58377 L
s
P
p
1 0 .6 r
.00177 w
.862 .70858 m
.89076 .74587 L
s
P
p
1 0 .6 r
.00177 w
.28626 .62746 m
.25663 .63793 L
s
P
p
1 0 .6 r
.00177 w
.28626 .62746 m
.26 .65422 L
s
P
p
1 0 .6 r
.005 w
.39934 .49619 m
.34938 .51236 L
s
P
p
1 0 .6 r
.005 w
.39934 .49619 m
.3825 .46963 L
s
P
p
1 0 .6 r
.0025 w
.28689 .62595 m
.24506 .64071 L
s
P
p
1 0 .6 r
.0025 w
.28689 .62595 m
.27165 .60639 L
s
P
p
1 0 .6 r
.00177 w
.862 .70858 m
.90712 .72693 L
s
P
p
1 0 .6 r
.00177 w
.30361 .60467 m
.27735 .63143 L
s
P
p
1 0 .6 r
.00177 w
.84273 .67218 m
.87037 .65709 L
s
P
p
1 0 .6 r
.00177 w
.84273 .67218 m
.8783 .68646 L
s
P
p
1 0 .6 r
.00177 w
.30711 .58377 m
.28372 .59177 L
s
P
p
1 0 .6 r
.00177 w
.30711 .58377 m
.28624 .60502 L
s
P
p
1 0 .6 r
.00353 w
.5879 .77993 m
.5884 .8601 L
s
P
p
1 0 .6 r
.00353 w
.5879 .77993 m
.63789 .82364 L
s
P
p
1 0 .6 r
.0025 w
.32925 .55413 m
.29643 .56512 L
s
P
p
1 0 .6 r
.0025 w
.32925 .55413 m
.31763 .53776 L
s
P
p
1 0 .6 r
.005 w
.56834 .63433 m
.55095 .66884 L
s
P
p
1 0 .6 r
.005 w
.56834 .63433 m
.6084 .64996 L
s
P
p
1 0 .6 r
.00177 w
.68156 .86111 m
.72055 .89455 L
s
P
p
1 0 .6 r
.00177 w
.24506 .64071 m
.20645 .65434 L
s
P
p
1 0 .6 r
.00177 w
.24506 .64071 m
.21129 .67508 L
s
P
p
1 0 .6 r
.00177 w
.27018 .59287 m
.25777 .6257 L
s
P
p
1 0 .6 r
.00177 w
.27165 .60639 m
.25755 .5883 L
s
P
p
1 0 .6 r
.00177 w
.27165 .60639 m
.24144 .61682 L
s
P
p
1 0 .6 r
.00177 w
.68156 .86111 m
.71436 .88978 L
s
P
p
1 0 .6 r
.0025 w
.63789 .82364 m
.68156 .86111 L
s
P
p
1 0 .6 r
.00353 w
.34938 .51236 m
.30299 .52737 L
s
P
p
1 0 .6 r
.00353 w
.34938 .51236 m
.30778 .55465 L
s
P
p
1 0 .6 r
.0025 w
.5884 .8601 m
.58886 .93359 L
s
P
p
1 0 .6 r
.0025 w
.5884 .8601 m
.54336 .90124 L
s
P
p
1 0 .6 r
.00353 w
.3825 .46963 m
.36681 .44488 L
s
P
p
1 0 .6 r
.00353 w
.3825 .46963 m
.34629 .48097 L
s
P
p
1 0 .6 r
.0025 w
.30778 .55465 m
.27018 .59287 L
s
P
p
1 0 .6 r
.0025 w
.30778 .55465 m
.27442 .56575 L
s
P
p
1 0 .6 r
.00177 w
.29643 .56512 m
.26631 .57521 L
s
P
p
1 0 .6 r
.00177 w
.29643 .56512 m
.26967 .59233 L
s
P
p
1 0 .6 r
.0025 w
.63789 .82364 m
.68389 .86387 L
s
P
p
1 0 .6 r
.00177 w
.58886 .93359 m
.60858 .98636 L
s
P
p
1 0 .6 r
.00177 w
.27018 .59287 m
.23621 .62741 L
s
P
p
1 0 .6 r
.00177 w
.31763 .53776 m
.30694 .52269 L
s
P
p
1 0 .6 r
.00177 w
.31763 .53776 m
.294 .54551 L
s
P
p
1 0 .6 r
.00177 w
.58886 .93359 m
.58928 1.00083 L
s
P
p
1 0 .6 r
.00177 w
.54336 .90124 m
.50203 .93897 L
s
P
p
1 0 .6 r
.00177 w
.54336 .90124 m
.53074 .91409 L
s
P
p
1 0 .6 r
.00353 w
.6084 .64996 m
.64577 .66454 L
s
P
p
1 0 .6 r
.00353 w
.6084 .64996 m
.59654 .67506 L
s
P
p
1 0 .6 r
.00177 w
.27442 .56575 m
.24379 .57594 L
s
P
p
1 0 .6 r
.00177 w
.27442 .56575 m
.24737 .59322 L
s
P
p
1 0 .6 r
.0025 w
.34629 .48097 m
.31297 .4914 L
s
P
p
1 0 .6 r
.0025 w
.34629 .48097 m
.33463 .46338 L
s
P
p
1 0 .6 r
.00177 w
.68389 .86387 m
.72614 .90082 L
s
P
p
1 0 .6 r
.00177 w
.68389 .86387 m
.69698 .876 L
s
P
p
1 0 .6 r
.0025 w
.30299 .52737 m
.26005 .54126 L
s
P
p
1 0 .6 r
.0025 w
.30299 .52737 m
.28751 .50571 L
s
P
p
1 0 .6 r
.00353 w
.55095 .66884 m
.5346 .70127 L
s
P
p
1 0 .6 r
.00353 w
.55095 .66884 m
.49441 .69429 L
s
P
p
1 0 .6 r
.0025 w
.36681 .44488 m
.35224 .42191 L
s
P
p
1 0 .6 r
.0025 w
.36681 .44488 m
.3818 .40612 L
s
P
p
1 0 .6 r
.00177 w
.31297 .4914 m
.28236 .50099 L
s
P
p
1 0 .6 r
.00177 w
.31297 .4914 m
.28566 .51908 L
s
P
p
1 0 .6 r
.00177 w
.33463 .46338 m
.32389 .44719 L
s
P
p
1 0 .6 r
.00177 w
.33463 .46338 m
.31063 .47073 L
s
P
p
1 0 .6 r
.0025 w
.49441 .69429 m
.44266 .71758 L
s
P
p
1 0 .6 r
.0025 w
.49441 .69429 m
.48191 .7178 L
s
P
p
1 0 .6 r
.00177 w
.3818 .40612 m
.39549 .3707 L
s
P
p
1 0 .6 r
.00177 w
.3818 .40612 m
.37156 .3893 L
s
P
p
1 0 .6 r
.00177 w
.26005 .54126 m
.22039 .5541 L
s
P
p
1 0 .6 r
.00177 w
.26005 .54126 m
.22524 .57654 L
s
P
p
1 0 .6 r
.0025 w
.59654 .67506 m
.58553 .69837 L
s
P
p
1 0 .6 r
.0025 w
.59654 .67506 m
.62328 .68586 L
s
P
p
1 0 .6 r
.00177 w
.44266 .71758 m
.39569 .7228 L
s
P
p
1 0 .6 r
.0025 w
.64577 .66454 m
.68053 .67809 L
s
P
p
1 0 .6 r
.0025 w
.64577 .66454 m
.69916 .65847 L
s
P
p
1 0 .6 r
.00177 w
.28751 .50571 m
.27318 .48565 L
s
P
p
1 0 .6 r
.00177 w
.28751 .50571 m
.25648 .51549 L
s
P
p
1 0 .6 r
.00177 w
.35224 .42191 m
.33875 .40062 L
s
P
p
1 0 .6 r
.00177 w
.35224 .42191 m
.32174 .4309 L
s
P
p
1 0 .6 r
.00177 w
.44266 .71758 m
.39535 .73888 L
s
P
p
1 0 .6 r
.00177 w
.69916 .65847 m
.74763 .65295 L
s
P
p
1 0 .6 r
.00177 w
.69916 .65847 m
.72447 .66804 L
s
P
p
1 0 .6 r
.0025 w
.5346 .70127 m
.51929 .73165 L
s
P
p
1 0 .6 r
.0025 w
.5346 .70127 m
.56786 .71551 L
s
P
p
1 0 .6 r
.00177 w
.48191 .7178 m
.47033 .73957 L
s
P
p
1 0 .6 r
.00177 w
.48191 .7178 m
.44456 .73471 L
s
P
p
1 0 .6 r
.00177 w
.62328 .68586 m
.64792 .69581 L
s
P
p
1 0 .6 r
.00177 w
.62328 .68586 m
.61568 .70268 L
s
P
p
1 0 .6 r
.00177 w
.58553 .69837 m
.57533 .71995 L
s
P
p
1 0 .6 r
.00177 w
.58553 .69837 m
.54867 .71523 L
s
P
p
1 0 .6 r
.00177 w
.68053 .67809 m
.71275 .69066 L
s
P
p
1 0 .6 r
.00177 w
.68053 .67809 m
.67162 .69943 L
s
P
p
1 0 .6 r
.00177 w
.56786 .71551 m
.59871 .72873 L
s
P
p
1 0 .6 r
.00177 w
.56786 .71551 m
.55733 .73754 L
s
P
p
1 0 .6 r
.00177 w
.51929 .73165 m
.505 .76 L
s
P
p
1 0 .6 r
.00177 w
.51929 .73165 m
.47147 .75354 L
s
P
p
1 g
.002 w
.85161 .02942 m
.88742 .88807 L
s
.88742 .88807 m
.02942 .94429 L
s
.02942 .94429 m
.07864 .12058 L
s
.07864 .12058 m
.85161 .02942 L
s
.85161 .02942 m
.88742 .88807 L
s
.88742 .88807 m
.97058 1.08997 L
s
.97058 1.08997 m
.93388 .36142 L
s
.93388 .36142 m
.85161 .02942 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 333}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000P]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H5000Ka]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001iaPT01<H00`36aP0IaP400000LMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00P002W6e/KFa/C6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP010000J<H900g600?4a/H01LH201[60@00001Pe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K620007]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFaP8001[Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40001HaPP07lH00lC6aP04aP806/H1000004oFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00T002kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
0P006]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0004O62003aP03a<K602_600C4a/K60/@00`34
000IaP400000?]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K62@00=<KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]H9a00Ne/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003K6200EaP03a<K601c6
2L@5aP03a<K600?600<0aP006LH1000002gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H02@00<mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6
e/KFa]K6eP09a00`e/KFa]K6e/KFa]K6e/K4a]K6e/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002G6200WaP03a<K600W62L@HaP03a<K600;600@0a/H06<H1000001gFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP08000ba]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/K4a]H9a012e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KF0=H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001C62@0;aP03a<K602?62L@ZaP03a<K600?600<0aP006<H10000
013Fa]K6e/KFa]K6e/KFa]K61000<MK6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H02L@0E=K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000@aP030<K601K600?4a/H0
4<H9a17600?4a/H0:LH00lC6aP02aP040<K601O60@00000@e/KFa]K6e/KFa]K6e/KFaP80027Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]H02L@0I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6eP3FaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000@aP030<H001O62L@TaP03a<K602S600?4a/H00/H01036aP0GaP40
00008MK6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6eP09a01he/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00013600@0a/H01<H9a0[6
00?4a/H0:LH00lC6aP0YaP05a<K6aP000lH00`36aP0DaP4000005=K6e/KFa]K6e/KFa]K6e/H0a]K6
1<@0R]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6eP3Fa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000@aP030<K600;600<0a/H05LH00lC6aP0XaP03a<K602S6
00G4a/K60003aP030<K601C60@00002Re/KFa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00013600<0a/H00lH00`36aP0EaP03a<K602S600?4a/H0:<H01<C6aP04aP030<K601?6
0@00002Re/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60@0000o600<0a/H0
1LH00`36aP0EaP03a<K602S600?4a/H0:<H00lC60004aP030<K601?60@00002Re/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60@0000o600<0a/H01lH00`36aP0DaP03a<K602S6
00?4a/H09lH00lC60005aP030<K601;60@000029e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CF0=H01<@05@3Fa]K6e/KF
a]K6e/KFa]K6e/KFaP0100003lH00`36aP08aP030<K601C600?4a/H0:<H00lC6aP0QaPO400<0a<H0
0lH00`36aP0BaP400000MmK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00W402;Fa]K6e/K40=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60@0000o6
00<0a/H02LH00`36aP0DaP03a<K602S600?4a/H03/H9a0o600?40<H01LH00`36aP0AaP400000IMK6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KF00W403CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60@0000o600<0a/H02lH00`36aP0DaP03
a<K602G60`06a2;600<0a/H01<H00`36aP0AaP400000DmK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00S4
1@00@]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/@0a]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFaP40000?aP030<K600c600<0a/H05<H00lC6aP0BaPW41lH702K600?40<H01LH00`36
aP0@aP400000@MK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]K6e/KF00W4013Fa]K6e/KFa]K6e/KFa]K61`00@LKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60040000?aP030<K600k6
00<0a/H04lH00lC6a008a1W61`0WaP030<K600C600<0a/H04<H1000002oFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eP09a00Se/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H01@00@/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFaP40000?aP030<K600o600<0a/H00/H9a0S600?4a/H08/H30003
a/C602K600<0a<H01LH00`36aP0?aP4000008MK6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
eP05a00fe/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0cl0@lK4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<CFa]K6e/H0a]K6e/KF
a]K6e/KFa]K6e/H00@0000o600<0a/H04<H00`36aP0CaP03a<K6027600=??dl00/H00lC6aP0TaP03
0<C600G600<0a/H03lH1000005cFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o04?6e/CF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP34e/KFa]K6eP3Fa]K6e/KFa]K6e/KF
a]K60040000>aP030<K601?600<0a/H04/H00lC6aP0PaP03Ccm?00?600?4a/H08lH00`36a006aP03
0<K600k60@00001Le/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`13a]K6a<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a/C6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP010000
3/H00`36aP0DaP030<K601?600?4a/H07/H014loCcl3aP03a<K602;600<0a/@01/H00`36aP0>aP40
0000G=K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K613l0@]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a/C6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP40000>aP030<K601K6
00<0a/H04/H00lC6aP0NaP03?dlo00?600?4a/H08/H01@36a/C600G400<0a/H03LH1000005gFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl08mK6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00G400<0a<@00/@05LKFa]K60<KFa]K6e/KFa]K6e/KFaP0100003/H00`36aP0GaP03
0<K601;600?4a/H07LH00cm??`04aP03a<K601;62/@5aP040<K6a0K600<0a/H03LH1000005gFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl03mK6e/KFa=K6e/KFa]K6eP0:a00Ya]K6e/KF
a]K6e/KFa]K60<KFa/C6e/KFa]H0e/KFa]K6e/KFa]K6e/H00@0000k600<0a/H06<H00`36aP0BaP03
a<K601c600<oCcl01LH:a1W600H0a/K6a<H600k60@00001Je/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa=Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60l@3?`G401k6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H;000De/KFa]H0e/KFa]K6
e/KFa]K6e/H100003/H00`36aP0JaP030<K6017600?4aSl03/H:a0?600<oCcl01/H00lC6aP0?aP/0
1LH00`36aP08aP030<K600c60@000016e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFaP[400gFa]K6e/KFa]K6e/KF00<o00gFa]K6
e/K4a]K6e/KF00/002[Fa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H10000
3/H00`36aP0KaP030<K600g600G4?lC4C`05a1K600A??dlo0/H50003a00000<06lH00`36aP08aP03
0<K600c60@00000be/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/H:a00KeSoF?mK4e/KFa]K6e/KFa]K6e/KFa]K6e/KF00@013l30010e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP40000>aP030<K601c6
1L@6aP03ClK600?600E??lK6a009aP/00lH01DloCcm?02[600<0a/H01lH00`36aP0<aP400000@mK6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6?lKFa]K6
?lKF0<@02@003MK6e/KFa]K6e/KFa]H00cl0A]Ho?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H100003/H00`36aP0NaP030<K600C6
0`000cl000020003C`0000;600?4a/H04/H00dloC`02aP03?do602W600<0a/H01lH00`36aP0<aP40
0000<=K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPH000?FaSl0
0Sl07<KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H3?`03e/KF008o04?6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60040000=aP03
0<K6023600<0a/H00/H00cm??`02aP04ClK6?aS600=??dl01<H00cm?aP0YaP030<K600O600<0a/H0
3<H1000005GFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00GFa]K6eP02?`13a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP010000
3LH00`36aP0PaP030<K600S600<oClH05/H00dloC`06aP03?do602W600<0a/H02<H00`36aP0;aP40
0000DmK6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaSo6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00OFa]K6e/KF008o04?6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60040000=aP03
0<K6023600<0a/H00lH00do6aP04aP03?lK601;600=??dl02<H00cm?aP0YaP030<K600S600<0a/H0
2lH1000003KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/H2?`0Ie/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6eP03?`09e/KFa]K6e/KF008o04?6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60040
000=aP030<K6023600<0a/H00/H00co6?`06aP03Cco600g600E??dloC`0:aP03?do602W600<0a/H0
2<H00`36aP0;aP400000>mK6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/Hoa]K6?lKF00<o00gF?mK6e/KFa]K6e/KF00<o00oFa]Hoe/KFa]K6e/KFa]H00Sl0@lKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KF
a]K6e/H00@0000g600<0a/H08<H00`36aP05aP03Ccm?00G600=?a/H01<H013m??dl5aP03ClK600[6
00<oClH0:LH00`36aP08aP030<K600_60@00000ee/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo60<KFa]H00cl02mK6e/KFa]K6?lKF00@o01K6?lKFa]K6eSoFa]K6e/KF
a]K6e/KF0Sl0@lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF
a]K60<KFa]K6e/KFa]K6e/H00@0000g600<0a/H07/H01do60<I??dl02lH00dloC`04aP03?lK600C6
00=?a/H03<H00cm?aP0YaP030<K600S600<0a/H02lH1000002oFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`0;eSoFa]K6e/KFa]H00cl07MK6e/KFaSo6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KF008o04?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60040000=aP030<K601k600E??do6C`07aP03Ccm?00S6
00<oa/H01<H00do6aP0?aP03Cco602S600<0a/H02<H00`36aP0;aP400000:mK6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl02MH0?coFa]K6eP03?`1Xe/KFa]K6e/KFaSo6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H100003LH00`36aP0OaP0:04loaSm??do6C`[6
00<oa/H01<H00do6aP0AaP04ClK6?bO600<0a/H02<H00`36aP0;aP400000<MK6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H00cl03MK6eSoFa]K6e/KFa]H00Sl0GlKF
a]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60040000=aP030<K601k600=??dl00lH00do6
C`07aP04Ccm??`G600<oClH05<H01Do6a/I?02O600<0a/H01lH00`36aP0;aP400000:mK6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl01MH0e/KF00<o00GFa]K6eP03?`1T
e/Hoa]K6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP40000<aP030<K601W600A??dlo
0lH01`36?do6Ccl00/H014loCcl3aP03?lK600?600<oaSl05/H00do6aP03aP03ClK602?600<0a/H0
1lH00`36aP0;aP4000009]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl02]K6
?lKFa]H0e/H2?`1^eSlo?mK6?lKFaSo6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6
e/H100003<H00`36aP0JaP03?lK600?600HoCcm??dl4aP05?lK6aSl01LH013o6aTlGaP03ClK600C6
00<oa/H08/H00`36aP07aP030<K600_60@00000]e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KF008o07<0?coFa]K6e/Hoa]K6?lKFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaSo6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF
aP36e/KFa]K6e/KFa]K60040000<aP030<K601S600Xoa/I??dloCcm?1LH00dloaP02aP03?lK600?6
00<oa/H00/H00do6aP0EaP03ClK600K600<oa/H08<H00`36aP07aP030<K600_60@00000/e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/H2?`06eSoFa]K60cl0JlKFa]Hoe/KF
aSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K60040000<aP030<K601c600/oa/I?
0<HoCco6?`04aP03ClK600;600<oa/H00lH00co6aP0FaP03ClK600K600<oClH08<H00`36aP08aP03
0<K600[60@00000Ze/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K613l02mHo
?lHoaSo6e/KF008o06O6eSloa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6eSoF
?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60040
000<aP030<K601g600Q??lH0aSo6?`C600M?aTloClI?00C600<oClH06<H00do6aP06aP04?lK6Cao6
00<0a/H02<H00`36aP0:aP400000:mK6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H013l0200oaSo6e/KF0cl02=K6eSoFa]K60Sl0G]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/H100003<H00`36aP0KaP09Ccm?aTl0aSm?00;600DoCco6?`02aP03ClK600;600<oaSl0
6LH00cm?aP08aP04ClK6?ak600<0a/H02<H00`36aP0:aP400000;mK6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6?lKF008o00?6?cl00cl09/Ho?mHoe/KFaSo6eSoFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KF0Sl0@lKFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H00@0000c600<0a/H06LH014o6aSl3aP0<?dloCco6
?lHoClI?1<H013o6aTlIaP03ClI?00W600E?a/K6C`0MaP030<K600S600<0a/H02/H1000002cFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o00T0?cloaSo6?lH00Sl0J=K6
e/Hoa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/Hoa]K6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60@0000c600<0a/H06lH00dlo
aP02aP0:?lHoaSo6?lHoC`C600<oa/H00/H00do6aP0FaP04?dloC`W600=?a/H00lH00do6aP0IaP03
0<K600S600<0a/H02/H1000002SFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0Sl04]K6e/Ho03o6?lHoa]Hoe/KFaP8o023Fa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaP<o
00k6e/KFa]K6?lKFa]K6eP8o0376e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KF
a]K6e/KFa]K60040000<aP030<K601K600@oCcm?1<H02So6?dloaSm?aTl4aP03?do600?600<oa/H0
5/H01Do6a/I?00;600<oCcl01<H00dloaP04aP08?lHoCcm??dlCaP030<K600S600<0a/H02/H10000
02cFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFaPDo00?6?lH013l0;=K6
?lHoa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6?lKF?mK60cl00lHoaP0<?`0Be/KFa]K6
e/KFa]K6e/KFa]K60Sl06036e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP40000;aP030<K601S600=?a/H0
0/H03cm?aTloaSo6?dloClI??`02aP05ClK6aTl00/H00co6aP0CaP03?lK600;600=?aTl01/H01Cm?
?dlo00G600<oClH00/H00dloaP0=aP05Cco6aP002/H00`36aP0:aP400000:=K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/H4?`0KeSlo03o6eSoF?mK6?lKF?mK6eSoFa]Hoe/KF008o
00k6e/KFa]K6e/KFa]K6eP8o00o6e/KFaSo6?lKFa]K6e/H013l01]K6e/KFaP8o00CFa]K60Sl02]K6
e/KFa]K6e/H3?`0Ka]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60040000;aP030<K601K600A?a/Ho
0/H01To6Ccm?00;600I?aTloCcl3aP05?lK6aSl00/H01Do6ClI?00k600@oClI?1LH014loCcl6aP06
ClK6aTlo1LH00co6aP02aP05ClI??dl01LH00dloaP02aP05?do6aP002LH00`36aP0:aP400000:mK6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mH00cl00mH0eP06?`0La]K6?lKF
a]Hoe/Hoa]Hoe/KFa]K6e/KFa]K6eP8o00W6eSoFa]K6e/H00Sl00mK6?`02?`07a]K6?lKFaP05?`0<
a]K6?lKFa]Hoe/KF0cl08]Hoe/KFa]K6eSoF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H100002lH00`36
aP0JaP04ClI??`;600P0?dloClI??`?600HoClK6?dl3aP04ClK6?`_600<oClH00lH00co6aP04aP03
ClK600;600HoaSm??dl3aP03Cco600;600Doa/K6?`04aP03ClK600?600=??lH01lH00dl0aP08aP03
0<K600[60@00000Ze/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl01mK6
?coF?mH00Sl06/KFaSo6?lHoaSo6eSoFa]K6?lKFa]K6e/KF0Sl03<KFa]K6eSoFa]K6eP8o00O6e/Ho
a]K600<o00C6eSoF0Sl04lKFa]K6e/Hoa]K6eSoFa]K6e/H00cl07LKFa]K6eP3Fa]K6e/KFa]H0e/KF
a]K6e/KFa]K60040000;aP030<K601_600/oClK6?do6ClI??`03aP07?lHoaSo6?`03aP03?lK600S6
00E??do6C`05aP03Cco600;600@oCcm?0lH014o6aSl2aP08ClK6?lHoaSl7aP03?lK600;600=?a/H0
1/H00cm??`03aP030<K600O600<0a/H02/H1000002[Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lH4?`0303oF008o00?6e/H00Sl04MHo?lKF?mK6?lHoa]K6e/KF00<o00cFa]Ho
e/KFa]K6?lH7?`04a]K6eP8o01S6e/Hoa]K6e/HoaSo6e/KFa]Hoe/KFa]H2?`09a]K6e/KFa]K6008o
01SF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H100002lH00`36aP0IaP0<?dloClI?aP36Ccm?0/H023m?
aTloClI?0lH00do6aP02aP04?dloC`C600<oClH01LH013o6aTl2aP0:?dloCco6?do6C`C600<oa/H0
0/H014o6aSl5aP03?do600?600@oaSm?1lH01Do6C`1?00S600<0a/H02/H1000002CFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H4?`07eSoF?mK60003?`0?e/Ho?mK6?lKFaSo6eSoF00Ho
00C6e/KF0Sl03/Hoa]K6e/Hoa]K6e/KF1Sl08<KFaSo6e/KF?mK6e/Hoa]K6?lKFa]HoeSoFa]K6?lKF
0Sl02/KFa]K6eSoF0=H2?`0Ca]K6e/KF0=K6e/KFa]K6e/KFaP0100002lH00`36aP0DaP05Cco6aTl0
0lH02To6a/I??lHoaSl4aP04ClK6?`O600<oClH00lH01Cm?a/Ho00C600=??lH01LH01do6ClI?aTl0
0lH00do6aP02aP03?lK600;600=?a/H00/H01cm?a/HoaSl01LH01co6a/HoCcl01<H00dl0aP02aP03
?lK600C600<0a/H02LH1000002gFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
eSoFa]H00Sl02<KF?mK6e/KF0Sl02<KF?mK6e/KF0Sl03LKFa]K6?lKFa]Hoe/H00Sl02]Hoe/KFa]Ho
e/H3?`0?a]K6e/Hoa]K6eSoFa]K6008o00GFa]HoeP03?`0>e/Hoa]K6e/Hoa]K6?lH3?`0IaSl0e/KF
a]K6e/KFaP36e/KFa]K6e/KFaP0100002lH00`36aP0FaP05ClK6aTl00lH01Dlo0<I?00G600M??lK6
ClI?00?600=?a/H02LH014o6aSl2aP03ClK600K600@oa/I?1<H00cm?aP03aP03?lK600;600=?aTl0
0lH024o6aSm??lHo1<H00do6aP02aP07?lK6aSo6000:aP030<K600W60@00000`e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6eSoF?`360Sl06mK6eSoF?mK6?lKF?mK6e/KFa]K6
e/KFa]K6eP02?`0Ja]K6?lKFa]K6e/KF?mK6?lKFaSo6?lKFa]H2?`0<a]K6?lKF?mK6eSoF0Sl0:LHo
?co6e/KF?mK6e/Hoa]K6eP0oa]K6e/KFa]K60<KFa]K6e/KFa]K60040000;aP030<K601S600Y??lK6
ClI?aP0o0/H00do6C`02aP04?lK6Ca7600=?a/H00lH00do6aP06aP04?lK6C`G600=?a/H00/H01So6
?lHoC`?600Q?a/HoaSo6?`;600=??lH00lH00do6aP02aP05?lK6aP002/H00`36aP09aP4000009MK6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl0A<KF?mK6?lH0?mK6e/KFa]K6eSoF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFaSo6e/Hoa]K6e/KF?mK6eSoF0Sl02LHoa]K6?lKF
aP02?`05e/Hoa]H00Sl00lKFaP02?`0Ne/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K60@0000_6
00<0a/H05/H01Do6ClI?00G600<0?lH02<H00co6aP0MaP03?do600;600=?a/H01<H02So6a/HoaSm?
aTl3aP03Cco600;600hoClK6?lHoaSm??do6C`K600<0a/H02<H00`36aP09aP400000KMK6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6?lKFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/Hoa]K6e/KFa]K6eSoFa]H00Sl02<KFaSo6?lKF0cl02=K6
?lHoa]K613l07=K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/H100002/H00`36aP0EaP04ClK6?`S6
00=?a/H09LH014loaSl4aP03Cco600O600=??lH00/H00cm?aP05aP06?lHoaSm?1<H013o6aTl2aP03
?do600?600<0a/H02<H00`36aP09aP400000E=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]Hoe/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o01OFa]Ho
e/KFaSo6?lKFa]K6eSoF?mK6eP03?`07e/KFa]K6eP02?`0>aSloe/KFaSo6e/KF?mH2?`0Ia]H0e/KF
a]K6e/KFaP36e/KFa]K6e/KFaP0100002/H00`36aP0QaP030<K602;600<oa/H00lH00co6aP02aP04
ClK6?`C600A?a/Ho1<H00do6C`05aP03Ccm?00;600<oClH00/H00do6aP03aP06ClK6?dl02/H00`36
aP09aP400000DMK6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`0Ta]K6e/Hoa]K6e/Hoa]K6?lKFa]K6e/Ho
a]K6?lKF?mK6eSoF0Sl0:LKFaSo6e/KF?mK6e/KF?mK6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K60040
000:aP030<K6027600<0a/H07/H013m?aTl5aP03ClK600?600=?a/H00/H00co6aP04aP05ClK6aTl0
0lH00do6C`02aP03?lK600;600=??lH00lH00do6aP02aP05?lK6aP002/H00`36aP09aP400000CMK6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF008o05?6eSoFa]K6e/Hoa]K6e/Hoa]K6e/Hoa]K6e/Hoa]K6e/KFa]K6e/KF
?mK6e/HoaSo6e/KF?mK6e/Hoa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFaP0100002/H00`36aP0QaP03
0<K601[600<oClH00lH00co6aP03aP03?lK600C600=?a/H01<H00co6aP0@aP05ClK6aTl00/H01Co6
a/Ho00G600@oa/H02LH00`36aP09aP400000@mK6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]H023l06lKFa]K6?lKFa]K6eSoFa]K6e/Ho
a]K6e/KFaP02?`0Ke/KFa]K6e/KFa]K6e/KFaSo6e/Hoa]K6?lKF008o01g6e/KFa]K60<KFa]K6e/KF
aP36e/KFa]K6e/KFaP0100002/H00`36aP0QaP030<K601O600=?a/H01LH00do6aP04aP03?lK600C6
00=?a/H01lH00do6aP0=aP03ClK600S600<oaSl01/H00`36aP07aP030<K600W60@000016e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP8o05[Fa]K6e/KFaSo6e/KFaSo6?lKFa]K6?lKFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/HoaSo6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/H100002/H00`36aP0QaP030<K601C6
00<oa/H01/H00dloaP05aP03ClI?00G600=?a/H02LH00do6aP0GaP04ClK6?`C600<0a/H01lH00`36
aP09aP400000C=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/H2?`1DeSoFa]K6e/Hoa]Hoe/KFaSo6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFaSo6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K60@0000[6
00<0a/H08LH00`36aP0BaP03?lK600G600@oa/I?1/H00co6aP02aP05ClK6?dl03LH00dloaP0JaP04
?lK600W600<0a/H02LH1000006gFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/Hoa]K6e/KF?mK6e/HoaSo6?lKFa]K6
e/KFa]K6e/KF008o03?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KF
a]K6e/H00@0000[600<0a/H08<H00`36aP0NaP03ClK600C600<oa/H00lH013o6aTl?aP03Cco601_6
00<0a/H01lH00`36aP09aP400000F]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFaSo6e/KFaP8o01?FaSo6
e/KFa]K6e/KFa]K6e/KF008o0376e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3F
a]K6e/KFa]K60040000:aP030<K6023600<0a/H07LH00co6aP03aP03?do600?600HoClI?aTlAaP03
Cco601;6200:aP030<K600S60@00001Ae/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o00[6?lKFaSo6?lKF
0Sl04/KFa]K6e/KFa]K6e/KFa]K6eP8o00?6e/H03`007LKFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KF
a]K600400009aP030<K6027600<0a/H08<H014o6aSl3aP03?lHo00?600<oClH02<H>01O600<0a/H0
1lH00`36aP08aP400000C]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o00WFa]Hoe/Hoa]H03`00>]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/H100002LH00`36
aP0QaP030<K601[63`05aP03ClK602c600<0a/H01lH00`36aP08aP400000?=K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaPh005SFa]K6e/KFaSo6
?lKFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6eP3Fa]K6e/KFa]K60@0000W600<0a/H08LH?01K600=??lH02LH00do6aP0]aP030<K600K6
00<0a/H02<H1000001oFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF00l007CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFaP400009aP030<K600C6
3`0>aP030<K6027600<oa/H02/H00do6aP0^aP030<K600G600<0a/H02<H1000000WFa]K6e/KFa]H0
1`00C]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/H100002lH00`36aP0OaP030<K602k600=??lH0
;lH00`36aP04aP030<K600S60@00001Ne/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o
04;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6
e/KFa]K6e/H100003LH00`36aP0MaP030<K602k600=?aTl0;lH00`36aP04aP030<K600S60@00000>
e/KFa]K6e/KFa]K6e/H2002Be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/H100004<H00`36aP0JaP03
0<K602k600=?aTl0<<H00`36aP03aP030<K600S60@00002Re/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6eP3Fa]K6e/KFa]K60@0001;600<0a/H06<H00`36aP0^aP03ClK6037600<0a/H00/H00`36
aP08aP4000004mK6e/KFa]K6e/KFa]K6e/KFa]H00P00SLKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFaP010000
5LH00`36aP0EaP030<K602k600=?a/H0</H01@36a/H000[60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K60@0001O600<0a/H04lH00`36aP1TaP040<K600[60@00000H
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P00R=K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/H100006/H00`36aP0@aP03
0<K606C600D0a/K60009aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60<KFa]K6
e/KFaP40000LaP030<K600g600<0a/H0I/H01036aP09aP4000007MK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF008008?6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KF0=K60<KFa]K6e/KFaP0100007lH00`36aP0:aP030<K606O600<0aP002LH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/H100008LH00`36aP08aP03
0<K606S60P09aP4000008]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2001ce/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP020009a]K6e/KF
a]K60040000TaP030<K600G600<0a/H0J<H200W60@00002?e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
2P002LKFa]K6e/KFaP0100009/H00`36aP03aP030<K604k64P0CaP4000009mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP020012a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF4P009LKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0002W600@0a/H0;<HB03O60@000017e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H04P00BLKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0002_60P08aQ80FlH1000002cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaPT006g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
0000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.01939, -0.025005, 0.00555471, 
  0.00555471}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.13558 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0421398 1.16009 0.0290023 1.16009 [
[ 0 0 0 0 ]
[ 1 1.13558 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.13558 L
0 1.13558 L
closepath
clip
newpath
p
1 g
.002 w
.85328 .029 m
.8893 .86464 L
s
.8893 .86464 m
.029 .92131 L
s
.029 .92131 m
.07862 .1208 L
s
.07862 .1208 m
.85328 .029 L
s
.93453 .36568 m
.28925 .42818 L
s
.28925 .42818 m
.2674 1.10657 L
s
.2674 1.10657 m
.971 1.06945 L
s
.971 1.06945 m
.93453 .36568 L
s
.85328 .029 m
.8893 .86464 L
s
.8893 .86464 m
.971 1.06945 L
s
.971 1.06945 m
.93453 .36568 L
s
.93453 .36568 m
.85328 .029 L
s
.07862 .1208 m
.28925 .42818 L
s
.28925 .42818 m
.2674 1.10657 L
s
.2674 1.10657 m
.029 .92131 L
s
.029 .92131 m
.07862 .1208 L
s
p
.4 g
.86814 .09057 m
.11686 .17661 L
s
P
p
.4 g
.89848 .2163 m
.19535 .29114 L
s
P
p
.4 g
.92491 .32583 m
.26413 .39152 L
s
P
p
.4 g
.76539 .03942 m
.86189 .37272 L
s
P
p
.4 g
.50222 .0706 m
.64349 .39387 L
s
P
p
.4 g
.24765 .10077 m
.43101 .41445 L
s
P
P
p
1 0 .6 r
.00125 w
.44365 .65629 m
.45208 .66856 L
s
P
p
1 0 .6 r
.00125 w
.44365 .65629 m
.43381 .67966 L
s
P
p
1 0 .6 r
.00125 w
.45712 .63366 m
.46371 .64358 L
s
P
p
1 0 .6 r
.00125 w
.45712 .63366 m
.47755 .62593 L
s
P
p
1 0 .6 r
.00125 w
.57554 .69113 m
.5578 .7018 L
s
P
p
1 0 .6 r
.00125 w
.38837 .70185 m
.39741 .71377 L
s
P
p
1 0 .6 r
.00125 w
.57554 .69113 m
.5778 .71513 L
s
P
p
1 0 .6 r
.00177 w
.43409 .64237 m
.44365 .65629 L
s
P
p
1 0 .6 r
.00125 w
.41874 .66719 m
.42566 .6769 L
s
P
p
1 0 .6 r
.00125 w
.62985 .74291 m
.61158 .75315 L
s
P
p
1 0 .6 r
.00125 w
.38837 .70185 m
.37875 .72516 L
s
P
p
1 0 .6 r
.00125 w
.56787 .66729 m
.55382 .67592 L
s
P
p
1 0 .6 r
.00125 w
.65312 .76508 m
.6554 .79499 L
s
P
p
1 0 .6 r
.00125 w
.62985 .74291 m
.6318 .76668 L
s
P
p
1 0 .6 r
.00177 w
.43409 .64237 m
.45712 .63366 L
s
P
p
1 0 .6 r
.00125 w
.41874 .66719 m
.411 .68577 L
s
P
p
1 0 .6 r
.00125 w
.60477 .70523 m
.59045 .71362 L
s
P
p
1 0 .6 r
.00125 w
.56787 .66729 m
.54317 .6568 L
s
P
p
1 0 .6 r
.00125 w
.36454 .7215 m
.35248 .75093 L
s
P
p
1 0 .6 r
.00125 w
.40001 .6826 m
.39029 .70608 L
s
P
p
1 0 .6 r
.00177 w
.59562 .67907 m
.57554 .69113 L
s
P
p
1 0 .6 r
.00125 w
.62316 .72274 m
.62515 .74671 L
s
P
p
1 0 .6 r
.00125 w
.60477 .70523 m
.60643 .72426 L
s
P
p
1 0 .6 r
.00177 w
.41093 .65622 m
.41874 .66719 L
s
P
p
1 0 .6 r
.00177 w
.37812 .68832 m
.38837 .70185 L
s
P
p
1 0 .6 r
.00177 w
.65053 .73131 m
.62985 .74291 L
s
P
p
1 0 .6 r
.00125 w
.65312 .76508 m
.67466 .7928 L
s
P
p
1 0 .6 r
.00177 w
.59562 .67907 m
.56787 .66729 L
s
P
p
1 0 .6 r
.00177 w
.65053 .73131 m
.65312 .76508 L
s
P
p
1 0 .6 r
.00125 w
.40001 .6826 m
.38057 .7026 L
s
P
p
1 0 .6 r
.00177 w
.41093 .65622 m
.40001 .6826 L
s
P
p
1 0 .6 r
.0025 w
.42322 .62653 m
.43409 .64237 L
s
P
p
1 0 .6 r
.00177 w
.62092 .69577 m
.60477 .70523 L
s
P
p
1 0 .6 r
.00125 w
.36454 .7215 m
.33985 .74689 L
s
P
p
1 0 .6 r
.00177 w
.37812 .68832 m
.36454 .7215 L
s
P
p
1 0 .6 r
.00125 w
.62316 .72274 m
.64024 .74471 L
s
P
p
1 0 .6 r
.00177 w
.62092 .69577 m
.62316 .72274 L
s
P
p
1 0 .6 r
.00125 w
.67659 .75498 m
.67828 .77896 L
s
P
p
1 0 .6 r
.0025 w
.61839 .66538 m
.59562 .67907 L
s
P
p
1 0 .6 r
.0025 w
.42322 .62653 m
.41093 .65622 L
s
P
p
1 0 .6 r
.00125 w
.35176 .70917 m
.34218 .7328 L
s
P
p
1 0 .6 r
.00125 w
.6624 .71966 m
.64747 .72807 L
s
P
p
1 0 .6 r
.0025 w
.64761 .69311 m
.65053 .73131 L
s
P
p
1 0 .6 r
.00125 w
.37397 .6756 m
.38137 .68542 L
s
P
p
1 0 .6 r
.0025 w
.61839 .66538 m
.62092 .69577 L
s
P
p
1 0 .6 r
.0025 w
.39346 .65086 m
.37812 .68832 L
s
P
p
1 0 .6 r
.00125 w
.67659 .75498 m
.69378 .77711 L
s
P
p
1 0 .6 r
.00177 w
.67469 .728 m
.67659 .75498 L
s
P
p
1 0 .6 r
.00125 w
.68113 .73745 m
.6828 .76168 L
s
P
p
1 0 .6 r
.00125 w
.6624 .71966 m
.66381 .7389 L
s
P
p
1 0 .6 r
.00125 w
.71138 .75871 m
.69198 .76904 L
s
P
p
1 0 .6 r
.00125 w
.37397 .6756 m
.36627 .6945 L
s
P
p
1 0 .6 r
.00125 w
.35176 .70917 m
.33202 .72946 L
s
P
p
1 0 .6 r
.00177 w
.36253 .68261 m
.35176 .70917 L
s
P
p
1 0 .6 r
.00353 w
.41081 .60847 m
.42322 .62653 L
s
P
p
1 0 .6 r
.00125 w
.35475 .69133 m
.3451 .7152 L
s
P
p
1 0 .6 r
.00125 w
.73527 .7814 m
.73698 .81184 L
s
P
p
1 0 .6 r
.00125 w
.71138 .75871 m
.71287 .78291 L
s
P
p
1 0 .6 r
.00177 w
.67924 .71018 m
.6624 .71966 L
s
P
p
1 0 .6 r
.00125 w
.32619 .70943 m
.33611 .72161 L
s
P
p
1 0 .6 r
.00125 w
.69903 .75935 m
.72089 .78752 L
s
P
p
1 0 .6 r
.00125 w
.68113 .73745 m
.69842 .75973 L
s
P
p
1 0 .6 r
.00353 w
.6443 .64981 m
.61839 .66538 L
s
P
p
1 0 .6 r
.00125 w
.69903 .75935 m
.7251 .77061 L
s
P
p
1 0 .6 r
.00177 w
.67469 .728 m
.69903 .75935 L
s
P
p
1 0 .6 r
.00177 w
.3656 .6645 m
.37397 .6756 L
s
P
p
1 0 .6 r
.00177 w
.67924 .71018 m
.68113 .73745 L
s
P
p
1 0 .6 r
.0025 w
.64761 .69311 m
.67469 .728 L
s
P
p
1 0 .6 r
.0025 w
.39346 .65086 m
.36253 .68261 L
s
P
p
1 0 .6 r
.00353 w
.41081 .60847 m
.39346 .65086 L
s
P
p
1 0 .6 r
.00353 w
.6443 .64981 m
.64761 .69311 L
s
P
p
1 0 .6 r
.00177 w
.36253 .68261 m
.3346 .71128 L
s
P
p
1 0 .6 r
.00125 w
.35475 .69133 m
.33489 .71172 L
s
P
p
1 0 .6 r
.00177 w
.3656 .6645 m
.35475 .69133 L
s
P
p
1 0 .6 r
.00125 w
.70018 .72912 m
.70142 .74849 L
s
P
p
1 0 .6 r
.00125 w
.32619 .70943 m
.31663 .73335 L
s
P
p
1 0 .6 r
.00177 w
.73334 .74702 m
.71138 .75871 L
s
P
p
1 0 .6 r
.00125 w
.3346 .71128 m
.30939 .73716 L
s
P
p
1 0 .6 r
.00125 w
.3346 .71128 m
.3124 .71991 L
s
P
p
1 0 .6 r
.00125 w
.73527 .7814 m
.75724 .80972 L
s
P
p
1 0 .6 r
.00177 w
.73334 .74702 m
.73527 .7814 L
s
P
p
1 0 .6 r
.00125 w
.30146 .72966 m
.28951 .75986 L
s
P
p
1 0 .6 r
.0025 w
.67712 .67944 m
.67924 .71018 L
s
P
p
1 0 .6 r
.00125 w
.3444 .68115 m
.33674 .70026 L
s
P
p
1 0 .6 r
.00125 w
.70018 .72912 m
.71395 .74688 L
s
P
p
1 0 .6 r
.00125 w
.73457 .74759 m
.73594 .7721 L
s
P
p
1 0 .6 r
.00177 w
.69878 .70738 m
.70018 .72912 L
s
P
p
1 0 .6 r
.0025 w
.37781 .63429 m
.3656 .6645 L
s
P
p
1 0 .6 r
.00177 w
.31493 .6956 m
.32619 .70943 L
s
P
p
1 0 .6 r
.00125 w
.76014 .77125 m
.76136 .79566 L
s
P
p
1 0 .6 r
.005 w
.43049 .56041 m
.41081 .60847 L
s
P
p
1 0 .6 r
.02 w
.58077 .2664 m
.58138 .37443 L
s
P
p
1 g
.05 w
.58077 .2664 Mdot
P
p
1 0 .6 r
.005 w
.64054 .6006 m
.6443 .64981 L
s
P
p
1 0 .6 r
.00125 w
.3444 .68115 m
.32856 .6974 L
s
P
p
1 0 .6 r
.00177 w
.353 .65972 m
.3444 .68115 L
s
P
p
1 0 .6 r
.00125 w
.71825 .7325 m
.73575 .75507 L
s
P
p
1 0 .6 r
.00125 w
.30146 .72966 m
.27598 .75579 L
s
P
p
1 0 .6 r
.00177 w
.31493 .6956 m
.30146 .72966 L
s
P
p
1 0 .6 r
.00125 w
.71825 .7325 m
.73919 .74139 L
s
P
p
1 0 .6 r
.00177 w
.69878 .70738 m
.71825 .7325 L
s
P
p
1 0 .6 r
.00125 w
.73457 .74759 m
.75208 .77019 L
s
P
p
1 0 .6 r
.0025 w
.67712 .67944 m
.69878 .70738 L
s
P
p
1 0 .6 r
.0025 w
.73116 .70812 m
.73334 .74702 L
s
P
p
1 0 .6 r
.00177 w
.73303 .72 m
.73457 .74759 L
s
P
p
1 0 .6 r
.00353 w
.67473 .64474 m
.67712 .67944 L
s
P
p
1 0 .6 r
.00125 w
.31387 .69605 m
.30427 .72033 L
s
P
p
1 0 .6 r
.00125 w
.76014 .77125 m
.77767 .79387 L
s
P
p
1 0 .6 r
.00125 w
.80453 .79516 m
.80573 .82604 L
s
P
p
1 0 .6 r
.0025 w
.37781 .63429 m
.353 .65972 L
s
P
p
1 0 .6 r
.00353 w
.39158 .60024 m
.37781 .63429 L
s
P
p
1 0 .6 r
.00177 w
.75878 .74377 m
.76014 .77125 L
s
P
p
1 0 .6 r
.00177 w
.353 .65972 m
.3306 .68267 L
s
P
p
1 0 .6 r
.00125 w
.3306 .68267 m
.3104 .70338 L
s
P
p
1 0 .6 r
.00125 w
.3306 .68267 m
.31282 .68941 L
s
P
p
1 0 .6 r
.00125 w
.28755 .71708 m
.27805 .74134 L
s
P
p
1 0 .6 r
.00125 w
.75782 .75201 m
.7801 .78077 L
s
P
p
1 0 .6 r
.00125 w
.36018 .6247 m
.36791 .63522 L
s
P
p
1 0 .6 r
.00125 w
.75782 .75201 m
.78475 .76346 L
s
P
p
1 0 .6 r
.00177 w
.73303 .72 m
.75782 .75201 L
s
P
p
1 0 .6 r
.0025 w
.33015 .65712 m
.31493 .6956 L
s
P
p
1 0 .6 r
.00125 w
.31387 .69605 m
.2936 .71682 L
s
P
p
1 0 .6 r
.00177 w
.32466 .66875 m
.31387 .69605 L
s
P
p
1 0 .6 r
.0025 w
.70544 .68439 m
.73303 .72 L
s
P
p
1 0 .6 r
.005 w
.43049 .56041 m
.39158 .60024 L
s
P
p
1 0 .6 r
.00707 w
.45286 .50578 m
.43049 .56041 L
s
P
p
1 0 .6 r
.00125 w
.78359 .77581 m
.80589 .80461 L
s
P
p
1 0 .6 r
.0025 w
.70544 .68439 m
.73844 .69812 L
s
P
p
1 0 .6 r
.00353 w
.67473 .64474 m
.70544 .68439 L
s
P
p
1 0 .6 r
.00125 w
.78359 .77581 m
.8107 .78742 L
s
P
p
1 0 .6 r
.00177 w
.75878 .74377 m
.78359 .77581 L
s
P
p
1 0 .6 r
.00125 w
.80453 .79516 m
.82684 .82398 L
s
P
p
1 0 .6 r
.0025 w
.73116 .70812 m
.75878 .74377 L
s
P
p
1 0 .6 r
.005 w
.64054 .6006 m
.67473 .64474 L
s
P
p
1 0 .6 r
.00353 w
.39158 .60024 m
.35642 .63623 L
s
P
p
1 0 .6 r
.00177 w
.80317 .76027 m
.80453 .79516 L
s
P
p
1 0 .6 r
.00353 w
.72868 .66399 m
.73116 .70812 L
s
P
p
1 0 .6 r
.00125 w
.36018 .6247 m
.35232 .64437 L
s
P
p
1 0 .6 r
.00707 w
.63625 .54452 m
.64054 .6006 L
s
P
p
1 0 .6 r
.00125 w
.28755 .71708 m
.26717 .73795 L
s
P
p
1 0 .6 r
.00177 w
.29822 .6898 m
.28755 .71708 L
s
P
p
1 0 .6 r
.00125 w
.58313 .84492 m
.60064 .8743 L
s
P
p
1 0 .6 r
.0025 w
.35642 .63623 m
.32466 .66875 L
s
P
p
1 0 .6 r
.0025 w
.35642 .63623 m
.32858 .64643 L
s
P
p
1 0 .6 r
.00125 w
.34037 .64074 m
.33052 .66558 L
s
P
p
1 0 .6 r
.01414 w
.58138 .37443 m
.58195 .47433 L
s
P
p
1 0 .6 r
.01414 w
.58138 .37443 m
.51397 .44332 L
s
P
p
1 0 .6 r
.00177 w
.32466 .66875 m
.29598 .69811 L
s
P
p
1 0 .6 r
.00125 w
.58313 .84492 m
.61638 .84973 L
s
P
p
1 0 .6 r
.00125 w
.75817 .72361 m
.77591 .74653 L
s
P
p
1 0 .6 r
.00125 w
.75817 .72361 m
.77959 .7326 L
s
P
p
1 0 .6 r
.00177 w
.73844 .69812 m
.75817 .72361 L
s
P
p
1 0 .6 r
.00177 w
.35144 .61281 m
.36018 .6247 L
s
P
p
1 0 .6 r
.00177 w
.73844 .69812 m
.76851 .71064 L
s
P
p
1 0 .6 r
.00125 w
.29598 .69811 m
.27009 .72461 L
s
P
p
1 0 .6 r
.00125 w
.29598 .69811 m
.27294 .70685 L
s
P
p
1 0 .6 r
.00125 w
.24768 .73662 m
.23584 .76747 L
s
P
p
1 0 .6 r
.0025 w
.33015 .65712 m
.29822 .6898 L
s
P
p
1 0 .6 r
.00353 w
.34739 .61356 m
.33015 .65712 L
s
P
p
1 0 .6 r
.00125 w
.50809 .87168 m
.52618 .90101 L
s
P
p
1 0 .6 r
.00125 w
.55095 .84801 m
.56502 .87131 L
s
P
p
1 0 .6 r
.01 w
.51397 .44332 m
.45286 .50578 L
s
P
p
1 0 .6 r
.01 w
.51397 .44332 m
.46239 .45978 L
s
P
p
1 0 .6 r
.00125 w
.83482 .80117 m
.86325 .83792 L
s
P
p
1 0 .6 r
.00177 w
.29822 .6898 m
.26938 .71931 L
s
P
p
1 0 .6 r
.00125 w
.79792 .73394 m
.79893 .75911 L
s
P
p
1 0 .6 r
.00125 w
.55095 .84801 m
.53984 .88032 L
s
P
p
1 0 .6 r
.00125 w
.83482 .80117 m
.86985 .81619 L
s
P
p
1 0 .6 r
.00177 w
.80317 .76027 m
.83482 .80117 L
s
P
p
1 0 .6 r
.00125 w
.34037 .64074 m
.31991 .66166 L
s
P
p
1 0 .6 r
.00177 w
.35144 .61281 m
.34037 .64074 L
s
P
p
1 0 .6 r
.00125 w
.50809 .87168 m
.49424 .91247 L
s
P
p
1 0 .6 r
.00177 w
.56339 .81182 m
.58313 .84492 L
s
P
p
1 0 .6 r
.0025 w
.76793 .71472 m
.80317 .76027 L
s
P
p
1 0 .6 r
.00125 w
.26938 .71931 m
.24335 .74596 L
s
P
p
1 0 .6 r
.00125 w
.26938 .71931 m
.24605 .72825 L
s
P
p
1 0 .6 r
.0025 w
.76793 .71472 m
.81077 .73259 L
s
P
p
1 0 .6 r
.00353 w
.72868 .66399 m
.76793 .71472 L
s
P
p
1 0 .6 r
.00707 w
.45286 .50578 m
.3975 .56235 L
s
P
p
1 0 .6 r
.005 w
.68497 .60749 m
.72868 .66399 L
s
P
p
1 0 .6 r
.00125 w
.76851 .71064 m
.79588 .72204 L
s
P
p
1 0 .6 r
.00125 w
.76851 .71064 m
.78499 .70173 L
s
P
p
1 0 .6 r
.00177 w
.32858 .64643 m
.30308 .65578 L
s
P
p
1 0 .6 r
.00177 w
.32858 .64643 m
.30576 .66977 L
s
P
p
1 0 .6 r
.00177 w
.56339 .81182 m
.55095 .84801 L
s
P
p
1 0 .6 r
.00125 w
.30576 .66977 m
.28518 .69082 L
s
P
p
1 0 .6 r
.00125 w
.30576 .66977 m
.28751 .67655 L
s
P
p
1 0 .6 r
.005 w
.68497 .60749 m
.73723 .62852 L
s
P
p
1 0 .6 r
.00707 w
.63625 .54452 m
.68497 .60749 L
s
P
p
1 0 .6 r
.00125 w
.24768 .73662 m
.22153 .76337 L
s
P
p
1 0 .6 r
.00177 w
.26104 .70181 m
.24768 .73662 L
s
P
p
1 0 .6 r
.00177 w
.52364 .82591 m
.50809 .87168 L
s
P
p
1 0 .6 r
.005 w
.3975 .56235 m
.34739 .61356 L
s
P
p
1 0 .6 r
.005 w
.3975 .56235 m
.35388 .57747 L
s
P
p
1 0 .6 r
.00125 w
.32958 .62977 m
.32176 .64966 L
s
P
p
1 0 .6 r
.00125 w
.79792 .73394 m
.81581 .75707 L
s
P
p
1 0 .6 r
.01 w
.58195 .47433 m
.63625 .54452 L
s
P
p
1 0 .6 r
.00177 w
.79679 .7056 m
.79792 .73394 L
s
P
p
1 0 .6 r
.0025 w
.36391 .58135 m
.35144 .61281 L
s
P
p
1 0 .6 r
.00125 w
.48374 .85046 m
.47281 .88299 L
s
P
p
1 0 .6 r
.01 w
.58195 .47433 m
.58247 .5665 L
s
P
p
1 0 .6 r
.00353 w
.34739 .61356 m
.30204 .6599 L
s
P
p
1 0 .6 r
.0025 w
.54112 .77446 m
.56339 .81182 L
s
P
p
1 0 .6 r
.00125 w
.83602 .76525 m
.85871 .7946 L
s
P
p
1 0 .6 r
.00125 w
.48484 .82501 m
.49941 .84869 L
s
P
p
1 0 .6 r
.00125 w
.83602 .76525 m
.86394 .77702 L
s
P
p
1 0 .6 r
.00177 w
.81077 .73259 m
.83602 .76525 L
s
P
p
1 0 .6 r
.00125 w
.32958 .62977 m
.31326 .64645 L
s
P
p
1 0 .6 r
.00177 w
.33835 .60745 m
.32958 .62977 L
s
P
p
1 0 .6 r
.00177 w
.52364 .82591 m
.48374 .85046 L
s
P
p
1 0 .6 r
.0025 w
.54112 .77446 m
.52364 .82591 L
s
P
p
1 0 .6 r
.0025 w
.30204 .6599 m
.26104 .70181 L
s
P
p
1 0 .6 r
.0025 w
.30204 .6599 m
.26548 .67334 L
s
P
p
1 0 .6 r
.00177 w
.81077 .73259 m
.84996 .74894 L
s
P
p
1 0 .6 r
.00125 w
.48484 .82501 m
.47386 .85776 L
s
P
p
1 0 .6 r
.00125 w
.48374 .85046 m
.44779 .87259 L
s
P
p
1 0 .6 r
.00125 w
.2741 .676 m
.26446 .70107 L
s
P
p
1 0 .6 r
.00125 w
.30308 .65578 m
.27976 .66432 L
s
P
p
1 0 .6 r
.00125 w
.30308 .65578 m
.29463 .64519 L
s
P
p
1 0 .6 r
.00125 w
.82212 .73837 m
.84488 .76782 L
s
P
p
1 0 .6 r
.00125 w
.82212 .73837 m
.85004 .75002 L
s
P
p
1 0 .6 r
.00177 w
.79679 .7056 m
.82212 .73837 L
s
P
p
1 0 .6 r
.00177 w
.26104 .70181 m
.22398 .73968 L
s
P
p
1 0 .6 r
.00125 w
.29801 .64464 m
.28822 .66993 L
s
P
p
1 0 .6 r
.0025 w
.76861 .66912 m
.79679 .7056 L
s
P
p
1 0 .6 r
.0025 w
.36391 .58135 m
.33835 .60745 L
s
P
p
1 0 .6 r
.00353 w
.37798 .54587 m
.36391 .58135 L
s
P
p
1 0 .6 r
.0025 w
.76861 .66912 m
.80281 .68308 L
s
P
p
1 0 .6 r
.00353 w
.73723 .62852 m
.76861 .66912 L
s
P
p
1 0 .6 r
.00177 w
.49714 .78832 m
.48484 .82501 L
s
P
p
1 0 .6 r
.00125 w
.22398 .73968 m
.19049 .7739 L
s
P
p
1 0 .6 r
.00125 w
.22398 .73968 m
.19355 .75136 L
s
P
p
1 0 .6 r
.00177 w
.33835 .60745 m
.31528 .63101 L
s
P
p
1 0 .6 r
.00353 w
.73723 .62852 m
.78521 .64784 L
s
P
p
1 0 .6 r
.00125 w
.31528 .63101 m
.29447 .65226 L
s
P
p
1 0 .6 r
.00125 w
.31528 .63101 m
.29688 .63763 L
s
P
p
1 0 .6 r
.00353 w
.56079 .71657 m
.54112 .77446 L
s
P
p
1 0 .6 r
.00125 w
.46532 .80787 m
.45666 .83395 L
s
P
p
1 0 .6 r
.00707 w
.46239 .45978 m
.41435 .47511 L
s
P
p
1 0 .6 r
.00707 w
.46239 .45978 m
.41806 .50499 L
s
P
p
1 0 .6 r
.00125 w
.2741 .676 m
.25321 .69733 L
s
P
p
1 0 .6 r
.00177 w
.28494 .64781 m
.2741 .676 L
s
P
p
1 0 .6 r
.00125 w
.84996 .74894 m
.88575 .76387 L
s
P
p
1 0 .6 r
.00125 w
.84996 .74894 m
.87195 .73784 L
s
P
p
1 0 .6 r
.00125 w
.29801 .64464 m
.27713 .66596 L
s
P
p
1 0 .6 r
.00177 w
.30903 .6162 m
.29801 .64464 L
s
P
p
1 0 .6 r
.00177 w
.49714 .78832 m
.46532 .80787 L
s
P
p
1 0 .6 r
.0025 w
.51092 .74719 m
.49714 .78832 L
s
P
p
1 0 .6 r
.005 w
.41806 .50499 m
.37798 .54587 L
s
P
p
1 0 .6 r
.005 w
.41806 .50499 m
.38346 .5164 L
s
P
p
1 0 .6 r
.00125 w
.46532 .80787 m
.43666 .82548 L
s
P
p
1 0 .6 r
.00707 w
.58247 .5665 m
.58295 .65134 L
s
P
p
1 0 .6 r
.00707 w
.58247 .5665 m
.56585 .59873 L
s
P
p
1 0 .6 r
.00125 w
.82298 .70919 m
.8411 .73267 L
s
P
p
1 0 .6 r
.00353 w
.35388 .57747 m
.31351 .59146 L
s
P
p
1 0 .6 r
.00353 w
.35388 .57747 m
.31766 .61442 L
s
P
p
1 0 .6 r
.00125 w
.82298 .70919 m
.84519 .71834 L
s
P
p
1 0 .6 r
.00177 w
.80281 .68308 m
.82298 .70919 L
s
P
p
1 0 .6 r
.00177 w
.80281 .68308 m
.834 .69581 L
s
P
p
1 0 .6 r
.00353 w
.37798 .54587 m
.34175 .58282 L
s
P
p
1 0 .6 r
.00125 w
.42546 .79966 m
.4146 .83285 L
s
P
p
1 0 .6 r
.0025 w
.31766 .61442 m
.28494 .64781 L
s
P
p
1 0 .6 r
.0025 w
.31766 .61442 m
.28866 .62471 L
s
P
p
1 0 .6 r
.00177 w
.26548 .67334 m
.23183 .68572 L
s
P
p
1 0 .6 r
.00177 w
.26548 .67334 m
.23594 .7035 L
s
P
p
1 0 .6 r
.00353 w
.56079 .71657 m
.51092 .74719 L
s
P
p
1 0 .6 r
.005 w
.58295 .65134 m
.56079 .71657 L
s
P
p
1 0 .6 r
.0025 w
.34175 .58282 m
.30903 .6162 L
s
P
p
1 0 .6 r
.0025 w
.34175 .58282 m
.31294 .59282 L
s
P
p
1 0 .6 r
.00177 w
.28494 .64781 m
.25539 .67796 L
s
P
p
1 0 .6 r
.0025 w
.51092 .74719 m
.46597 .77479 L
s
P
p
1 0 .6 r
.00125 w
.23594 .7035 m
.20926 .73072 L
s
P
p
1 0 .6 r
.00125 w
.23594 .7035 m
.21181 .71252 L
s
P
p
1 0 .6 r
.00125 w
.31963 .59528 m
.31171 .61571 L
s
P
p
1 0 .6 r
.00177 w
.46597 .77479 m
.42546 .79966 L
s
P
p
1 0 .6 r
.00177 w
.46597 .77479 m
.42716 .7689 L
s
P
p
1 0 .6 r
.0025 w
.78521 .64784 m
.82919 .66554 L
s
P
p
1 0 .6 r
.0025 w
.78521 .64784 m
.81184 .63282 L
s
P
p
1 0 .6 r
.00177 w
.30903 .6162 m
.27947 .64635 L
s
P
p
1 0 .6 r
.00125 w
.42546 .79966 m
.38896 .82207 L
s
P
p
1 0 .6 r
.00125 w
.25539 .67796 m
.22871 .70518 L
s
P
p
1 0 .6 r
.00125 w
.25539 .67796 m
.23138 .6868 L
s
P
p
1 0 .6 r
.00125 w
.27947 .64635 m
.25278 .67357 L
s
P
p
1 0 .6 r
.00125 w
.27947 .64635 m
.25561 .65495 L
s
P
p
1 0 .6 r
.00125 w
.834 .69581 m
.8624 .7074 L
s
P
p
1 0 .6 r
.00125 w
.834 .69581 m
.85138 .68658 L
s
P
p
1 0 .6 r
.00125 w
.31963 .59528 m
.30299 .61225 L
s
P
p
1 0 .6 r
.00177 w
.32852 .57236 m
.31963 .59528 L
s
P
p
1 0 .6 r
.00125 w
.42716 .7689 m
.39189 .76355 L
s
P
p
1 0 .6 r
.00125 w
.42716 .7689 m
.3982 .78667 L
s
P
p
1 0 .6 r
.005 w
.58295 .65134 m
.58339 .72927 L
s
P
p
1 0 .6 r
.00353 w
.38346 .5164 m
.35161 .5269 L
s
P
p
1 0 .6 r
.00353 w
.38346 .5164 m
.35458 .54581 L
s
P
p
1 0 .6 r
.00177 w
.28866 .62471 m
.26209 .63413 L
s
P
p
1 0 .6 r
.00177 w
.28866 .62471 m
.26515 .64868 L
s
P
p
1 0 .6 r
.00125 w
.85501 .69901 m
.8782 .72908 L
s
P
p
1 0 .6 r
.0025 w
.35458 .54581 m
.32852 .57236 L
s
P
p
1 0 .6 r
.0025 w
.35458 .54581 m
.33175 .55349 L
s
P
p
1 0 .6 r
.00125 w
.85501 .69901 m
.88368 .71068 L
s
P
p
1 0 .6 r
.00177 w
.82919 .66554 m
.85501 .69901 L
s
P
p
1 0 .6 r
.00125 w
.26515 .64868 m
.24393 .6703 L
s
P
p
1 0 .6 r
.00125 w
.26515 .64868 m
.24613 .65551 L
s
P
p
1 0 .6 r
.00177 w
.31294 .59282 m
.28654 .60198 L
s
P
p
1 0 .6 r
.00177 w
.31294 .59282 m
.28942 .61678 L
s
P
p
1 0 .6 r
.005 w
.41435 .47511 m
.36973 .48935 L
s
P
p
1 0 .6 r
.005 w
.41435 .47511 m
.39941 .45105 L
s
P
p
1 0 .6 r
.0025 w
.31351 .59146 m
.27625 .60438 L
s
P
p
1 0 .6 r
.0025 w
.31351 .59146 m
.30009 .5736 L
s
P
p
1 0 .6 r
.00125 w
.23183 .68572 m
.2009 .69708 L
s
P
p
1 0 .6 r
.00125 w
.23183 .68572 m
.22009 .67231 L
s
P
p
1 0 .6 r
.00125 w
.70222 .83184 m
.71522 .84289 L
s
P
p
1 0 .6 r
.00177 w
.82919 .66554 m
.86943 .68174 L
s
P
p
1 0 .6 r
.00177 w
.32852 .57236 m
.30499 .59632 L
s
P
p
1 0 .6 r
.00125 w
.28942 .61678 m
.2682 .63841 L
s
P
p
1 0 .6 r
.00125 w
.28942 .61678 m
.27052 .62344 L
s
P
p
1 0 .6 r
.00125 w
.30499 .59632 m
.28377 .61794 L
s
P
p
1 0 .6 r
.00125 w
.30499 .59632 m
.28617 .60286 L
s
P
p
1 0 .6 r
.00177 w
.81184 .63282 m
.83635 .61899 L
s
P
p
1 0 .6 r
.00177 w
.81184 .63282 m
.84357 .64543 L
s
P
p
1 0 .6 r
.00125 w
.28763 .59093 m
.27764 .61721 L
s
P
p
1 0 .6 r
.00125 w
.26209 .63413 m
.23778 .64275 L
s
P
p
1 0 .6 r
.00125 w
.26209 .63413 m
.25304 .62305 L
s
P
p
1 0 .6 r
.00177 w
.33175 .55349 m
.31091 .56049 L
s
P
p
1 0 .6 r
.00177 w
.33175 .55349 m
.31306 .57251 L
s
P
p
1 0 .6 r
.00125 w
.70222 .83184 m
.73348 .85876 L
s
P
p
1 0 .6 r
.00353 w
.58339 .72927 m
.5838 .80074 L
s
P
p
1 0 .6 r
.00353 w
.58339 .72927 m
.62809 .76801 L
s
P
p
1 0 .6 r
.00125 w
.31306 .57251 m
.29621 .58966 L
s
P
p
1 0 .6 r
.00125 w
.31306 .57251 m
.29816 .57758 L
s
P
p
1 0 .6 r
.00125 w
.86943 .68174 m
.9062 .69654 L
s
P
p
1 0 .6 r
.00125 w
.86943 .68174 m
.89213 .66973 L
s
P
p
1 0 .6 r
.0025 w
.35161 .5269 m
.32237 .53654 L
s
P
p
1 0 .6 r
.0025 w
.35161 .5269 m
.34136 .51202 L
s
P
p
1 0 .6 r
.00125 w
.28654 .60198 m
.26238 .61036 L
s
P
p
1 0 .6 r
.00125 w
.28654 .60198 m
.27768 .5906 L
s
P
p
1 0 .6 r
.005 w
.56585 .59873 m
.55023 .62904 L
s
P
p
1 0 .6 r
.005 w
.56585 .59873 m
.60164 .61226 L
s
P
p
1 0 .6 r
.00125 w
.84357 .64543 m
.87247 .65692 L
s
P
p
1 0 .6 r
.00125 w
.84357 .64543 m
.8613 .63567 L
s
P
p
1 0 .6 r
.00177 w
.66725 .80173 m
.70222 .83184 L
s
P
p
1 0 .6 r
.00125 w
.60185 .91367 m
.58414 .94433 L
s
P
p
1 0 .6 r
.00177 w
.27625 .60438 m
.24192 .61628 L
s
P
p
1 0 .6 r
.00177 w
.27625 .60438 m
.24604 .63512 L
s
P
p
1 0 .6 r
.00125 w
.28763 .59093 m
.26617 .61276 L
s
P
p
1 0 .6 r
.00177 w
.29888 .56136 m
.28763 .59093 L
s
P
p
1 0 .6 r
.00177 w
.30009 .5736 m
.2877 .55711 L
s
P
p
1 0 .6 r
.00177 w
.30009 .5736 m
.27321 .58272 L
s
P
p
1 0 .6 r
.00125 w
.31091 .56049 m
.2919 .56688 L
s
P
p
1 0 .6 r
.00125 w
.31091 .56049 m
.30406 .55119 L
s
P
p
1 0 .6 r
.00125 w
.24604 .63512 m
.21876 .66287 L
s
P
p
1 0 .6 r
.00125 w
.24604 .63512 m
.22143 .64381 L
s
P
p
1 0 .6 r
.00125 w
.60185 .91367 m
.6176 .956 L
s
P
p
1 0 .6 r
.00177 w
.66725 .80173 m
.69653 .82709 L
s
P
p
1 0 .6 r
.0025 w
.62809 .76801 m
.66725 .80173 L
s
P
p
1 0 .6 r
.00125 w
.83635 .61899 m
.85886 .60629 L
s
P
p
1 0 .6 r
.00125 w
.83635 .61899 m
.83554 .59167 L
s
P
p
1 0 .6 r
.00353 w
.36973 .48935 m
.32841 .50253 L
s
P
p
1 0 .6 r
.00353 w
.36973 .48935 m
.33251 .52718 L
s
P
p
1 0 .6 r
.0025 w
.5838 .80074 m
.58417 .86615 L
s
P
p
1 0 .6 r
.0025 w
.5838 .80074 m
.54345 .83714 L
s
P
p
1 0 .6 r
.00353 w
.39941 .45105 m
.38554 .4287 L
s
P
p
1 0 .6 r
.00353 w
.39941 .45105 m
.36713 .46104 L
s
P
p
1 0 .6 r
.0025 w
.33251 .52718 m
.29888 .56136 L
s
P
p
1 0 .6 r
.0025 w
.33251 .52718 m
.30282 .53691 L
s
P
p
1 0 .6 r
.00177 w
.32237 .53654 m
.29556 .54537 L
s
P
p
1 0 .6 r
.00177 w
.32237 .53654 m
.29843 .56087 L
s
P
p
1 0 .6 r
.0025 w
.62809 .76801 m
.66917 .8036 L
s
P
p
1 0 .6 r
.00125 w
.69653 .82709 m
.72152 .84862 L
s
P
p
1 0 .6 r
.00177 w
.58417 .86615 m
.60185 .91367 L
s
P
p
1 0 .6 r
.00177 w
.29888 .56136 m
.2685 .59224 L
s
P
p
1 0 .6 r
.00177 w
.34136 .51202 m
.33194 .49835 L
s
P
p
1 0 .6 r
.00177 w
.34136 .51202 m
.32032 .51882 L
s
P
p
1 0 .6 r
.00125 w
.29843 .56087 m
.27683 .58282 L
s
P
p
1 0 .6 r
.00125 w
.29843 .56087 m
.27923 .56729 L
s
P
p
1 0 .6 r
.00125 w
.2685 .59224 m
.24107 .62011 L
s
P
p
1 0 .6 r
.00125 w
.2685 .59224 m
.2439 .60065 L
s
P
p
1 0 .6 r
.00125 w
.69653 .82709 m
.72323 .85023 L
s
P
p
1 0 .6 r
.00125 w
.27321 .58272 m
.24861 .59107 L
s
P
p
1 0 .6 r
.00125 w
.27321 .58272 m
.26412 .57102 L
s
P
p
1 0 .6 r
.00125 w
.24192 .61628 m
.21037 .62721 L
s
P
p
1 0 .6 r
.00125 w
.24192 .61628 m
.23003 .60178 L
s
P
p
1 0 .6 r
.00177 w
.58417 .86615 m
.58451 .92594 L
s
P
p
1 0 .6 r
.00177 w
.54345 .83714 m
.50648 .87049 L
s
P
p
1 0 .6 r
.00177 w
.54345 .83714 m
.53215 .84794 L
s
P
p
1 0 .6 r
.00125 w
.2877 .55711 m
.27629 .54192 L
s
P
p
1 0 .6 r
.00125 w
.2877 .55711 m
.29795 .52996 L
s
P
p
1 0 .6 r
.00125 w
.32032 .51882 m
.30114 .52503 L
s
P
p
1 0 .6 r
.00125 w
.32032 .51882 m
.31345 .50911 L
s
P
p
1 0 .6 r
.00353 w
.60164 .61226 m
.63494 .62484 L
s
P
p
1 0 .6 r
.00353 w
.60164 .61226 m
.59095 .63426 L
s
P
p
1 0 .6 r
.00125 w
.29556 .54537 m
.27102 .55346 L
s
P
p
1 0 .6 r
.00125 w
.29556 .54537 m
.28662 .53328 L
s
P
p
1 0 .6 r
.00177 w
.30282 .53691 m
.2756 .54583 L
s
P
p
1 0 .6 r
.00177 w
.30282 .53691 m
.27864 .56145 L
s
P
p
1 0 .6 r
.0025 w
.36713 .46104 m
.33747 .47022 L
s
P
p
1 0 .6 r
.0025 w
.36713 .46104 m
.35685 .44515 L
s
P
p
1 0 .6 r
.00177 w
.66917 .8036 m
.70683 .83624 L
s
P
p
1 0 .6 r
.00177 w
.66917 .8036 m
.68069 .81377 L
s
P
p
1 0 .6 r
.00125 w
.27864 .56145 m
.25683 .5836 L
s
P
p
1 0 .6 r
.00125 w
.27864 .56145 m
.25915 .56794 L
s
P
p
1 0 .6 r
.0025 w
.32841 .50253 m
.29024 .51471 L
s
P
p
1 0 .6 r
.0025 w
.32841 .50253 m
.31481 .48292 L
s
P
p
1 0 .6 r
.00125 w
.33194 .49835 m
.32331 .48582 L
s
P
p
1 0 .6 r
.00125 w
.33194 .49835 m
.34026 .47657 L
s
P
p
1 0 .6 r
.00125 w
.50648 .87049 m
.47501 .89834 L
s
P
p
1 0 .6 r
.00353 w
.55023 .62904 m
.53559 .65743 L
s
P
p
1 0 .6 r
.00353 w
.55023 .62904 m
.49968 .65154 L
s
P
p
1 0 .6 r
.00125 w
.58451 .92594 m
.58482 .9805 L
s
P
p
1 0 .6 r
.00125 w
.58451 .92594 m
.59443 .9506 L
s
P
p
1 0 .6 r
.0025 w
.38554 .4287 m
.37269 .408 L
s
P
p
1 0 .6 r
.0025 w
.38554 .4287 m
.39902 .39396 L
s
P
p
1 0 .6 r
.00125 w
.70683 .83624 m
.73891 .86386 L
s
P
p
1 0 .6 r
.00125 w
.50648 .87049 m
.47267 .901 L
s
P
p
1 0 .6 r
.00125 w
.2756 .54583 m
.25068 .55399 L
s
P
p
1 0 .6 r
.00125 w
.2756 .54583 m
.2664 .53363 L
s
P
p
1 0 .6 r
.00125 w
.70683 .83624 m
.74132 .86612 L
s
P
p
1 0 .6 r
.00177 w
.33747 .47022 m
.31027 .47863 L
s
P
p
1 0 .6 r
.00177 w
.33747 .47022 m
.31308 .49493 L
s
P
p
1 0 .6 r
.00177 w
.35685 .44515 m
.3474 .43056 L
s
P
p
1 0 .6 r
.00177 w
.35685 .44515 m
.33551 .45162 L
s
P
p
1 0 .6 r
.00125 w
.31308 .49493 m
.29108 .51723 L
s
P
p
1 0 .6 r
.00125 w
.31308 .49493 m
.29361 .50107 L
s
P
p
1 0 .6 r
.0025 w
.49968 .65154 m
.45346 .67212 L
s
P
p
1 0 .6 r
.0025 w
.49968 .65154 m
.48854 .6721 L
s
P
p
1 0 .6 r
.00125 w
.41147 .67691 m
.37396 .68119 L
s
P
p
1 0 .6 r
.00177 w
.39902 .39396 m
.41133 .36225 L
s
P
p
1 0 .6 r
.00177 w
.39902 .39396 m
.38998 .37884 L
s
P
p
1 0 .6 r
.00125 w
.53215 .84794 m
.52169 .85794 L
s
P
p
1 0 .6 r
.00125 w
.53215 .84794 m
.50546 .87202 L
s
P
p
1 0 .6 r
.00177 w
.29024 .51471 m
.25506 .52594 L
s
P
p
1 0 .6 r
.00177 w
.29024 .51471 m
.25917 .5462 L
s
P
p
1 0 .6 r
.0025 w
.59095 .63426 m
.58104 .65465 L
s
P
p
1 0 .6 r
.0025 w
.59095 .63426 m
.61476 .64356 L
s
P
p
1 0 .6 r
.00125 w
.41147 .67691 m
.38144 .69021 L
s
P
p
1 0 .6 r
.00177 w
.45346 .67212 m
.41147 .67691 L
s
P
p
1 0 .6 r
.0025 w
.63494 .62484 m
.66582 .63651 L
s
P
p
1 0 .6 r
.0025 w
.63494 .62484 m
.68258 .61929 L
s
P
p
1 0 .6 r
.00177 w
.31481 .48292 m
.30223 .46479 L
s
P
p
1 0 .6 r
.00177 w
.31481 .48292 m
.28726 .49149 L
s
P
p
1 0 .6 r
.00125 w
.25917 .5462 m
.23111 .57463 L
s
P
p
1 0 .6 r
.00125 w
.25917 .5462 m
.23393 .55443 L
s
P
p
1 0 .6 r
.00125 w
.68069 .81377 m
.69135 .8232 L
s
P
p
1 0 .6 r
.00125 w
.68069 .81377 m
.70788 .83734 L
s
P
p
1 0 .6 r
.00125 w
.41133 .36225 m
.43332 .34 L
s
P
p
1 0 .6 r
.00125 w
.33551 .45162 m
.31605 .45752 L
s
P
p
1 0 .6 r
.00125 w
.33551 .45162 m
.32861 .44124 L
s
P
p
1 0 .6 r
.00177 w
.37269 .408 m
.36081 .38886 L
s
P
p
1 0 .6 r
.00177 w
.37269 .408 m
.34557 .41592 L
s
P
p
1 0 .6 r
.00125 w
.72581 .61425 m
.7543 .60127 L
s
P
p
1 0 .6 r
.00125 w
.41133 .36225 m
.42255 .33334 L
s
P
p
1 0 .6 r
.00177 w
.45346 .67212 m
.41127 .6909 L
s
P
p
1 0 .6 r
.00125 w
.31027 .47863 m
.28537 .48634 L
s
P
p
1 0 .6 r
.00125 w
.31027 .47863 m
.30129 .46571 L
s
P
p
1 0 .6 r
.00177 w
.68258 .61929 m
.72581 .61425 L
s
P
p
1 0 .6 r
.00177 w
.68258 .61929 m
.70503 .62753 L
s
P
p
1 0 .6 r
.00125 w
.3474 .43056 m
.33873 .41717 L
s
P
p
1 0 .6 r
.00125 w
.3474 .43056 m
.35596 .40802 L
s
P
p
1 0 .6 r
.00125 w
.38998 .37884 m
.38169 .36497 L
s
P
p
1 0 .6 r
.00125 w
.38998 .37884 m
.39876 .35604 L
s
P
p
1 0 .6 r
.0025 w
.53559 .65743 m
.52192 .68394 L
s
P
p
1 0 .6 r
.0025 w
.53559 .65743 m
.56524 .66966 L
s
P
p
1 0 .6 r
.00125 w
.72581 .61425 m
.76501 .60968 L
s
P
p
1 0 .6 r
.00125 w
.28726 .49149 m
.26204 .49934 L
s
P
p
1 0 .6 r
.00125 w
.28726 .49149 m
.27802 .47861 L
s
P
p
1 0 .6 r
.00177 w
.48854 .6721 m
.47825 .69109 L
s
P
p
1 0 .6 r
.00177 w
.48854 .6721 m
.45523 .68701 L
s
P
p
1 0 .6 r
.00125 w
.25506 .52594 m
.2227 .53627 L
s
P
p
1 0 .6 r
.00125 w
.25506 .52594 m
.24296 .50998 L
s
P
p
1 0 .6 r
.00125 w
.41127 .6909 m
.3728 .70802 L
s
P
p
1 0 .6 r
.00125 w
.41127 .6909 m
.40114 .70819 L
s
P
p
1 0 .6 r
.00177 w
.61476 .64356 m
.63665 .65211 L
s
P
p
1 0 .6 r
.00177 w
.61476 .64356 m
.6079 .65825 L
s
P
p
1 0 .6 r
.00125 w
.34557 .41592 m
.32075 .42318 L
s
P
p
1 0 .6 r
.00125 w
.34557 .41592 m
.33684 .40231 L
s
P
p
1 0 .6 r
.00125 w
.30223 .46479 m
.29064 .44808 L
s
P
p
1 0 .6 r
.00125 w
.30223 .46479 m
.31288 .43625 L
s
P
p
1 0 .6 r
.00177 w
.58104 .65465 m
.57189 .67348 L
s
P
p
1 0 .6 r
.00177 w
.58104 .65465 m
.54813 .66951 L
s
P
p
1 0 .6 r
.00177 w
.66582 .63651 m
.69438 .64731 L
s
P
p
1 0 .6 r
.00177 w
.66582 .63651 m
.65772 .65514 L
s
P
p
1 0 .6 r
.00125 w
.70503 .62753 m
.72564 .6351 L
s
P
p
1 0 .6 r
.00125 w
.70503 .62753 m
.73612 .62394 L
s
P
p
1 0 .6 r
.00125 w
.45523 .68701 m
.42494 .70057 L
s
P
p
1 0 .6 r
.00125 w
.45523 .68701 m
.4476 .70068 L
s
P
p
1 0 .6 r
.00125 w
.36081 .38886 m
.34986 .37122 L
s
P
p
1 0 .6 r
.00125 w
.36081 .38886 m
.37185 .35976 L
s
P
p
1 0 .6 r
.00125 w
.54813 .66951 m
.5182 .68303 L
s
P
p
1 0 .6 r
.00125 w
.54813 .66951 m
.54131 .68306 L
s
P
p
1 0 .6 r
.00125 w
.6079 .65825 m
.6016 .67173 L
s
P
p
1 0 .6 r
.00125 w
.6079 .65825 m
.62352 .66448 L
s
P
p
1 0 .6 r
.00125 w
.63665 .65211 m
.65675 .65995 L
s
P
p
1 0 .6 r
.00125 w
.63665 .65211 m
.66775 .64856 L
s
P
p
1 0 .6 r
.00177 w
.56524 .66966 m
.59268 .68098 L
s
P
p
1 0 .6 r
.00177 w
.56524 .66966 m
.55581 .68885 L
s
P
p
1 0 .6 r
.00125 w
.47825 .69109 m
.46877 .7086 L
s
P
p
1 0 .6 r
.00125 w
.47825 .69109 m
.49688 .69932 L
s
P
p
1 0 .6 r
.00177 w
.52192 .68394 m
.5092 .70862 L
s
P
p
1 0 .6 r
.00177 w
.52192 .68394 m
.4793 .70321 L
s
P
p
1 0 .6 r
.00125 w
.57189 .67348 m
.56345 .69084 L
s
P
p
1 0 .6 r
.00125 w
.57189 .67348 m
.59147 .68157 L
s
P
p
1 0 .6 r
.00125 w
.65772 .65514 m
.65026 .67231 L
s
P
p
1 0 .6 r
.00125 w
.65772 .65514 m
.67814 .66306 L
s
P
p
1 0 .6 r
.00125 w
.69438 .64731 m
.72075 .65727 L
s
P
p
1 0 .6 r
.00125 w
.69438 .64731 m
.73424 .64277 L
s
P
p
1 0 .6 r
.00125 w
.4793 .70321 m
.44044 .72078 L
s
P
p
1 0 .6 r
.00125 w
.4793 .70321 m
.46974 .72102 L
s
P
p
1 0 .6 r
.00125 w
.55581 .68885 m
.54711 .70654 L
s
P
p
1 0 .6 r
.00125 w
.55581 .68885 m
.57541 .69715 L
s
P
p
1 0 .6 r
.00125 w
.59268 .68098 m
.61801 .69142 L
s
P
p
1 0 .6 r
.00125 w
.59268 .68098 m
.63246 .67653 L
s
P
p
1 0 .6 r
.00125 w
.5092 .70862 m
.4974 .73152 L
s
P
p
1 0 .6 r
.00125 w
.5092 .70862 m
.53367 .71946 L
s
P
p
1 g
.002 w
.85328 .029 m
.8893 .86464 L
s
.8893 .86464 m
.029 .92131 L
s
.029 .92131 m
.07862 .1208 L
s
.07862 .1208 m
.85328 .029 L
s
.85328 .029 m
.8893 .86464 L
s
.8893 .86464 m
.971 1.06945 L
s
.971 1.06945 m
.93453 .36568 L
s
.93453 .36568 m
.85328 .029 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 333}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000Q=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPD001W6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001kaPT01<H00`36aP0GaP400000L]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT002O6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0006[62008aP03a<K600_60P0HaP400000HMK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H02@007]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFaP8001SFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000F<H901[600?4a/H02/H201S60@00001@e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H8000`e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6
0P006=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP400017aPT000?6a<H0:<H00lC6aP0:aP030<H001O6
0@00000oe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00P005_6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa/C6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000faPT04lH00lC6
aP0WaP03a<K600W600<0aP005lH1000002gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H02@00D=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K60/@06P340<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002G6200VaP03a<K602K62/@2aP030<H001O60@00000Le/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaPT004o6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K600[402CFa]K6e/KFa]K60<KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100004lH900k600?4a/H09/H00lC6aP0EaPW42LH00lC6aP08aP040<K601K6
0@00000?e/KFa]K6e/KFa]K6e/KF00@004o6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K600W403O6e/KFa]K6e/KF
a]K6e/KFa]K4e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000?aP030<K601W6
00?4a/H09/H00lC6aP02aPW47<H00lC6aP08aP030<H001K60@00000?e/KFa]K6e/KFa]K6e/KF0080
03o6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H02L@0BLKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6eP3F
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0000o600<0aP006/H00lC6aP0HaPW41LH00lC6aP0VaP03
a<K600S600@0a/H05LH1000003kFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFaPW405_6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000?aP040<K601[600?4a/H01LH9a1S600?4a/H09/H00lC6aP07aP040<K601G60@00000/e/KFa]K6
e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9a01]a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KF
a]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaP0100003lH01@36a/H000o62L@3aP03a<K602G6
00?4a/H09LH00lC6aP07aP050<K6aP005<H1000001[Fa]K6e/KFa]K6e/KFa]H0e/KFaP36e/KFaPW4
07o6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KF
a]K6e/KFa]K60040000>aP030<K600C61L@FaP03a<K602G600?4a/H09LH00lC6aP06aP050<K6aP00
5<H100000:;Fa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6eP3Fa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H100003/H00`36
aP05aP030<K601S600?4a/H09LH00lC6aP0TaP03a<K600K600<0a/H00/H00`36aP0AaP400000X]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000>aP030<K600O600<0a/H0
5lH00lC6aP0UaP03a<K602C600?4a/H01LH00`36aP02aP030<K601760@00002Re/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60@0000k600<0a/H02<H00`36aP0GaP03a<K602C6
00?4a/H09LH00lC6aP04aP030<C400?400<0a/H04<H10000087Fa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02<@06@3Fa]K6eP3F
a]K6e/KFa]K6e/KFa]K6e/H00@0000k600<0a/H02LH00`36aP0HaP03a<K602?600?4a/H06/H9a003
a/C600G600<0a/H00lH00`36aP0@aP400000KmK6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6eP09a00Ze/KFa]K6e/KFa]K4e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K60@0000k600<0a/H02lH00`36aP0GaP03a<K602?600?4a/H01lH9a1C600?4a/H00lH00`36
aP04aP030<K600o60@00001Le/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H300O403cFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H10000
3/H00`36aP0<aP030<K601O600?4a/H06LH8a0D08lH00lC6aP03aP030<K600C600<0a/H03lH10000
04[Fa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFaPW400O6e/KFa]K600L00476e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa/C6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP0100003/H00`36aP0=aP030<K601O6
00?4a/H01/H9a1361`0SaP03a<K600;600<0a/H01<H00`36aP0?aP400000>=K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62L@06LKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H01`00@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]H0e/KF
a]K6eP3Fa]K6e/KFa]K6e/KFa]K60040000=aP030<K6013600<0a/H03<H9a003a/C602361@0UaP05
a<K6aP001lH00`36aP0>aP4000009]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
2L@0;LKFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP030013a=K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KF
aP0100003LH00`36aP0AaPG45<H00lC6aP0OaP05Ccm?a/@09<H00lC6aP02aP030<K600C600<0a/H0
3/H1000005cFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o04?6a<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60040000=aP03
0<K601?600<0a/H05/H00lC6aP0MaP03Ccm?00;600?4a/H08/H01LC6a/H000O600<0a/H03LH10000
05cFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o04?6e/CFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/K4a]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60040000=aP030<K601C6
00<0a/H05/H00lC6aP0LaP03Ccm?00?600?4a/H08LH01LC6a/H000O600<0a/H03LH1000005cFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<o02o6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa=K60<KFaP05a00?0=K6e/KFa]K6e/KFa]K60040000=aP030<K601G600<0a/H0
5/H00lC6aP03aP03ClK601G600=??dl00lH00lC6aP0PaPG400@0a<C41LH00`36aP0<aP400000G=K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl07LKFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K600W401g6e/CFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaP0100003LH00`36aP0GaP030<K601G6
00?4a/H00/H00do6C`0EaP03Ccm?00C600?4a/H03<H:a0_600C4a/H02<H00`36aP0<aP400000G=K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4a]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K60cl02/KFa]K6a<KFa]H9a00`e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60@0000g600<0a/H06<H00`36aP0EaP05
a3o6?dl05lH00dloC`0:a1o600?4aP002LH00`36aP0;aP400000?MK6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H00Sl05lKF?mHoe/KFa]K6e/KF
a]K6e/KFa]K600K40cl0<<KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<H0
a]K6ePH000g6e/KFa]K6e/KFa]K60040000=aP030<K601W600<0a/H03LH02co6a/HoClI?a/@o00W6
2L@6aP03Ccm?00K600?4a/H07LH40003a00000<01LH00`36aP0;aP400000?mK6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eSoFaSo6eP02?`03aSo400W4
00o6e/KFa]K6e/KFa]K6e/H00cl07<KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]H:000Ma]K6e/@0
a]K6e/KFa]K60<KFa]K6e/KFa]K6e/H00@0000c600<0a/H07<H00`36aP0<aP03ClA?00;400Doa<A?
a00HaP03Ccm?00O600?4a/H02<H:00o600<0a/H01lH00`36aP0;aP400000<MK6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H02L@08MHoe/KFaSo6?lCFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP03?`09e/KFa]K6e/K400X00376e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF
a]K6e/KFaP36e/KFa]K6e/KFa]K60040000<aP030<K601g61L@:aP03?lK600?600@oa/K45LH014lo
Ccl90003a<K6023600<0a/H01lH00`36aP0;aP400000DmK6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]Hoe/KFaSo6e/KF?mK6e/CFa]K6e/KFa]K6e/KF00H0
1Cl0A=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36
e/KFa]K6e/KFa]K60@0000c600<0a/H07lH00`36aP06aP07?lK6Ccm??`02aP03ClK600;600C4a/K6
2P05aP06Ccm?aTlo;<H00`36aP07aP030<K600_60@00000ge/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP04?`06a]HoeP0o1@004L@00<KFa]K6e/KFa]K6
e/KF00<o04SFaSloe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K60<KFa]K6e/KFa]K6e/H100003<H00`36aP0PaP030<K600?600<oCcl00P001dl0001?aTl0
5LH00dloC`03aP03Cco602_600<0a/H01lH00`36aP0;aP400000<=K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPD000?6e/H00Sl06mK6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6eP03?`04e/KFaP8o04CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP40000<aP030<K6027600@0a/Ho1LH00co6aP03aP03
?lK601;600=??dl01LH00dloaP0[aP030<K600S600<0a/H02/H1000005?Fa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]Hoe/Hoa]Hoe/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6eP03?`06e/KFa]K60Sl0A=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60@0000c600<0a/H08LH014o6aSl2aP05ClK6?dl0
1LH00do6aP0>aP04?dloC`O600=??lH0:lH00`36aP08aP030<K600[60@00000fe/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K60cl01/KF?mK6eP<o00_Fa]K6
e/KFa]K6eP07?`08e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H100003<H00`36aP0QaP0603m?aTlo1LH013m?
?dl2aP03?lK600K600=??dl00lH00do6aP09aP03Cco602c600<0a/H01lH00`36aP0:aP400000>=K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36?lKFa]K60cl03<KF
a]K6e/Hoa]K6eP@o0176e/KF?mK6e/KFa]K6e/KFaP02?`14e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H100003<H00`36aP0QaP03
0<I?00;600<oCcl02/H01Do6Ccm?00;600<oa/H00/H00do6aP0;aP03Cco602c600<0a/H01lH00`36
aP0:aP400000<MK6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaP00
13l03<HoaSo6e/KFa]K6eP<o01SFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/H2?`14e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/H10000
2lH00`36aP0PaP08Ccm?aTloCcl2aP03ClK600?600=??dl01/H00co6aP02aP03ClK600k600<oClH0
:lH00`36aP07aP030<K600[60@00000]e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00Do00WFaSloeSoFa]H00cl0I=K6e/KFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]Ho
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/H100002lH00`36aP0MaP03?do600;600`0aTloaSm?aTloCcl9aP03?lK600;600=?a/H0
4<H013o6aTlZaP030<K600O600<0a/H02/H10000033Fa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`03a]Ho008o00_FaSo6e/KFa]K6eP02?`1Ma]K6eSoFa]K6e/KF
a]K6e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F
a]K6e/KFa]H0e/KFa]K6e/KFa]K60040000;aP030<K601[600=?a/H01LH02P0oCcm?aTloCcl6aP04
Ccm??`G600<oa/H04LH00co6aP02aP03ClK602K600<0a/H01lH00`36aP0:aP400000;MK6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6eP05?`0;eSlo?mK6?lKFa]H00cl0H]K6
?lKFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K60@0000_600<0a/H06lH013m??dl2aP04
?lK6C`C600PoaSm??do6C`;600<oa/H00lH00cm?aP0CaP03?lK600?600<oa/H09LH00`36aP07aP03
0<K600[60@00000Ve/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`0;a]K6e/Ho
0=Hoe/H01Sl0J=K6eSoFaSo6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K60@0000_6
00<0a/H05lH00co6aP04aP0;Cco6?lHoCcm??dl01LH014o6aSl5aP03?lHo01G600<oa/H01LH00co6
aP0SaP030<K600O600<0a/H02/H1000002cFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaPTo06g6e/KFa]Hoe/Hoa]K6e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF
a]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KF
a]K60040000;aP030<K601_600/oCcm??dloCcm??`04aP03Ccm?00;600<oa/H00lH01Co6a/Ho01G6
00<oa/H01/H00do6aP0RaP030<K600S600<0a/H02LH1000002OFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H00Sl01<Ho?mH3?`05e/Hoa]H00cl01=Hoe/H2?`0Xe/KFaSo6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFa]K60@0000_600<0a/H06lH03Co6a/HoCcm??dloCcl0
0/H01Do6aSm?00?600=??lH00lH00do6aP0DaP03?lK600K600=?aTl08/H00`36aP08aP030<K600W6
0@00000[e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eP07?`0:e/Hoa]Ho
e/HoaPDo00C6e/KF0Sl0FlKFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/HoaSo6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K6e/H00@0000[600<0a/H0
6/H00co6aP02aP0;ClK6?dloCco6?dl00/H013o6?dl2aP03?lK600;600=??lH05/H00co6aP06aP04
ClK6?b7600<0a/H02<H00`36aP09aP400000:mK6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H013l01`0o?co6?lH01Sl08=K6?lKFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0Sl0A=K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
0<KFa]K6e/KFa]K60@0000[600<0a/H07LH054loaSo604loCcm??dloClI??lHo1<H00do6C`0GaP03
Cco600O600=?a/H00/H00co6aP0MaP030<K600S600<0a/H02LH1000002_Fa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF008o00C6?coF13l01<KF?mH2?`0QaSo6e/KF?mK6?lKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6008o04CFa]K6e/KFaSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/KFaP40000:aP030<K601W600I?a/HoCcl2aP0>
Ccm??dloClI?aTo6Ccl4aP05ClK6aTl05/H00cm??`08aP03ClK600?600=?a/H02<H00cm?aP0;aP03
?lK600?600<0a/H02<H00`36aP09aP400000;=K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFaSo613l03mHo?coF?mHoe/Hoa]K6eP02?`0La]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]HoeP<o00gFa]K6e/Hoa]K6e/KF008o00K6e/KFa]H2?`0@a]K6e/KFa]K6e/KFa]HoeP8o01W6eP3F
a]K6e/KFa]K60<KFa]K6e/KFa]K60040000:aP030<K601[600hoaSm??do6C`1??dloC`;600<oaSl0
1<H00dloaP02aP03?lK601C600A?a/Ho0/H00dloC`03aP03Cco600C600hoaSm??dloCcm??dloC`[6
00<oClH00lH00`36aP08aP030<K600W60@00000Ve/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H4?`04eSoFaPHo00?FaSl013l0:<KF?co6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6eSoF
a]Hoe/Hoa]H4?`03aSo600Lo01?6?cloa]K6e/KFa]K6e/KFa]K6008o01cFa]K6e/H0a]K6e/KFa]K6
0<KFa]K6e/KFa]K60@0000[600<0a/H05/H00cm??`04aP0EClK6?dloCcm??lHoCcm??lHoClI?00?6
00A?a/Ho1/H00dloaP0:aP07?lK6aSo6?`06aP04Ccm??`G600PoCcm??dloC`_600=??lH01lH00`36
aP07aP030<K600W60@00000Xe/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPHo
00?F?cl01Sl04/Hoa]HoeSoFa]Hoe/KF?mK6eP<o00_Fa]K6e/KFa]K6eP02?`06a]K6eSoF0Sl01/KF
a]K6eP@o00S6e/KFaSo6eP<o00[F?cloe/KFa]K60cl07lKFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KF
a]K6e/H00@0000[600<0a/H06LH014loaSl2aP0BClI??dloClI??dloCcm?aTlo0lH02So6aTo6Ccm?
aTl9aP05Ccm?aTl01<H01Co6?lHo00G600Loa/I??dlo00?600<oa/H00/H02To6a/I??do6Ccl3aP03
?dlo00;600E??lK60009aP030<K600W60@00000]e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFaSo6e/KF00Do00?F?cl01Cl05mK6?coFa]Hoe/HoaSo6e/KF?mK6e/KF00<o00WFa]Ho
e/KFa]H00Sl00lKFaP03?`09a]Hoe/HoaSo600Po00OF?mK6e/KF008o00O6e/KFa]K6008o01[Fa]K6
0<KFa]K6e/KFaP36e/KFa]K6e/KFaP40000:aP030<K601[6018oa/K6?dloCcm??lHoCcm??dl2aP03
?do600;600E?a/K6C`02aP03?lK600G600<oClH01LH00co6aP03aP03?do600;600]?a/HoCcm??dlo
C`04aP03?do600C600=?a/H01<H00cm??`06aP05Ccm?aP002LH00`36aP09aP400000:MK6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF00Xo00?6?cl00Sl01mK6?lHoa]H00Sl02lKF
?mK6e/Hoa]K600<o00O6?lKFa]K600<o00?6e/H00Sl00mK6eP05?`03eSoF00Do01CFa]K6eSoFa]K6
?lKFa]K6e/KFaP8o01kFa]K6e/KF?`36e/KFa]K6e/H0a]K6e/KFa]K6e/H100002/H00`36aP0HaP03
?lK600;600e??do6Ccm??lHoCcm?00;600LoClI?aTlo00?600<oClH00/H014o6Ccl3aP03?lK600C6
00Q?aTloCco6?`?600@oCcm?0/H00co6?`02aP03ClI?00G600=?a/H00/H00co6aP08aP03Cco600G6
00<0a/H02<H00`36aP08aP400000:MK6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KF00Xo00G6?coFaP02?`0<e/Ho?mHoe/HoaSo613l01=K6e/H2?`07e/KFa]HoeP02?`03aSlo008o
00WFaSloeSoFa]H00Sl04LKFaSo6eSoFa]K6?lKFa]K600<o00W6e/KFa]K6?lH00Sl01MK6e/H0008o
01?6e/KFa]K6eP3Fa]K6e/KFa]K600400009aP030<K601[6029?aTloCco6?lHoCco6?dloaSo6?lHo
Cco6?dloCcm??dlo1<H014loaSl4aP0<Ccm?aTloaSm??dlo0/H014loCcl2aP05ClK6aTl00lH01To6
a/I??`G600DoaSm??`05aP08?lK6Cco6?`0:aP030<K600S60@00000Ve/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H5?`07aSlo?`0oaP05?`06aSo6eSoF1Cl04MHo?coFa]K6eSoFaSo6
e/KF008o00G6eSoFaP04?`0CeSlo?mHoe/KFaSo6e/Hoa]K6eP02?`0=aSo6?lKFa]K6?lKFaP02?`08
e/KFaSo6e/H2?`0F0<KFa]K6e/KFa]H0e/KFa]K6e/KFaP400009aP030<K601O6024oCco6?dloaSo6
?`0oaSm??dloaSm?aTloClI?aTloCcl01LH033m?a/HoCcm??do6C`C600DoCcm??`04aP03Cco600?6
00I?a/K6Ccl3aP07?lHoCco6?`05aP0;?lK6ClI??do6Ccl01<H0100oCcl7aP030<K600S60@00000W
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KF008o00O6?lHoaP36008o00CF?co6
0Sl01]Ho?lHoaP@o00CF?mK613l00mK6eP04?`0:a]Hoe/KFa]HoeP<o00CFa]K60Sl04MK6e/Hoa]K6
?lHoa]K6?lKF00<o00gFa]K6e/Hoa]Hoe/KF008o01_6?coFaP36e/Hoa]K6e/KF0=K6e/KFa]K6e/H0
0@0000W600<0a/H06/H00dloaP02aP0:?do6Ccm?aTloC`;600@oCcm?0/H01Sm??do6C`;600@oa/I?
0lH00dloaP04aP03?lK600;600I?aTloCcl3aP03?lHo00C600M?a/K6ClI?00C600LoaSm?aTlo00;6
00A??lHo0/H00do6aP02aP06?do6Ccl02/H00`36aP08aP4000009MK6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H00Sl00lKFaP02?`03eSl000<o00?F?mH00cl01=Hoe/H2?`0<eSlo?mK6
e/KFa]K613l01=K6e/H2?`0<e/KFaSo6?lKF?mK60Sl01]Hoe/KFaP8o00oFaSo6eSoFa]HoeSoF?mH0
0cl01mK6eSoFa]H00cl07=K6eSoFaP36e/KFa]K6e/KF0=K6e/KFa]K6e/H100002LH00`36aP0HaP03
Cco600;600<oClH00/H034loClI??dloClI??`;600I?a/HoaSl6aP05Cco6aTl01LH014o6Ccl3aP09
?do6aSo6?lHo00;600U?a/K6ClI??dl00/H00cm?aP02aP0=Cco6aTo6Ccm??dloC`02aP04?lK6C`?6
00=?aP002/H00`36aP08aP400000:]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/HoaP@o00@0?mK60Sl0==HoeSoF?mHoe/Hoa]K6e/KFa]Hoe/KFaSo6e/KF?mK6e/HoaSo6?lKF?mK6
eSoFaSo6e/H5?`03a]K6008o00?Fa]H00Sl01LKF?co600@o02;F?mK6?lKFa]K6?lH0a]K6e/KFa]K6
eP3Fa]K6e/KFa]K60@0000W600<0a/H05lH02Co6a/HoaSm??`02aP0;Cco6aTo6ClI?aTl00/H013o6
aTlBaP03?lK600;600A??lHo0lH00cm?aP04aP0:ClK6?do6ClI??`;600=?aTl00/H01co6?lHoaSl0
0lH00cm??`03aP03?lK600?600<o0<H02LH00`36aP08aP400000:MK6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKF008o00K6eSloa]H4?`05a]K6?lH00Sl06=K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFaP8o00kFa]Hoe/KF?mHoe/KFaP<o00G6?lHoaP02?`05e/Hoa]H013l02/HoaSo6?lKF
?mH3?`0Ne/Hoa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K60@0000W600<0a/H06<H01Tloa/I??`;6
00I?aTo6Ccl7aP03?do601O600<oa/H00lH01Co6a/Ho00;600I?a/K6Ccl2aP06ClI?aTlo0/H05dlo
aSo6?dloaSo6?lHoaSo6?lHoCcm?00;600@oClH02/H00`36aP08aP4000008]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H3?`0/a]Ho?lKFa]K603oF?mK6e/KFaSo6?lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]H2?`0@a]K6e/Hoa]K6eSoFa]HoeP@o00G6?lKFaP03?`05aSo6?lH00Sl02=K6?coFaSo6
0cl01LHo?mK600<o01W6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K600400009aP030<K601G600<oaSl0
0/H00do6C`05aP04ClK6?`S600=?a/H04/H013m?aTl5aP03ClK600;600<oa/H00/H014o6aSl2aP08
ClK6aTloCcl2aP04Cco6?`?600<oCcl00lH01So6?lHoC`C600@oClH02/H00`36aP08aP400000K=K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/Hoa]K6e/H0aSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/Hoa]K6eSoFa]K6eSoF?mK6?lKFaP8o00OF?cloe/KF008o
00C6eSoF0cl01]Ho?lHoaP8o01cFa]K6eSl0a]K6e/KFa]K6eP3Fa]K6e/KFa]K60@0000W600<0a/H0
5LH00co6aP03aP03?lK600C600<0a/H03lH02DloCcm??dloC`03aP03Cco600;600<oa/H00lH00co6
aP04aP03ClK600?600E??lK6C`03aP0ACcm??dloCco6?lHoaSm?aTl00lH00do6aP02aP03?do600C6
00<0?lH02<H00`36aP08aP400000BMK6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]H00cl07=K6e/KF?mK6e/KF?mK6e/KFaSo6
e/KFa]K6?lH2?`0:e/HoaSo6eSoFaP8o00OFaSloeSoF008o00S6?coFa]HoeP8o01W6e/H0a]K6e/KF
a]K6eP3Fa]K6e/KFa]K600400008aP030<K602?600<0a/H04LH00do6aP04aP03?lK600C600=?a/H0
1<H00co6aP04aP03ClK600K600HoClI?aTl2aP04?lK6C`;600hoa/K6?do6Cco6?do6C`?600A?a/Ho
0/H00`36aP09aP030<K600O60@000017e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]H00Sl01/KFa]K6eP8o01O6e/KFaSo6?lKF
a]K6?lKFa]K6e/KFaP02?`08eSoFa]K6e/H2?`0<eSoFa]HoeSoFaSo60Sl08=Hoe/KF?mK6e/KF0=K6
e/KFa]K6e/H0a]K6e/KFa]K60@0000S600<0a/H08lH00`36aP0EaP03ClK600C600@oClI?1LH00do6
C`05aP03ClK600S600@oClI?2<H01Cm?a/Ho00;600E?a/HoC`03aP05ClK6aTl01<H00`36aP08aP03
0<K600O60@000014e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0Ge/KFa]K6?lKF?mK6e/KFaSo6eSoFa]H00Sl02lKFa]K6e/KF
a]K6008o01?Fa]K6e/KFa]HoeSoF?mK6e/KF008o00C6e/KF0Sl06lKFa]K6eP3Fa]K6e/KFa]K60<KF
a]K6e/KFaP0100002<H00`36aP0SaP030<K601;600<oaSl01<H00dloaP02aP03?lK600?600Doa/K6
?`02aP03ClI?00c600<oClH01lH013o6aTl7aP03Cco600;600@oaSm?1<H00`36aP08aP030<K600O6
0@000011e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]H00Sl05lHoa]K6eSoF?mK6eSoFa]K6eSoFa]K6008o04KFaSo6e/KFa]K6e/KFa]K6
eSoFa]K6e/KF?mK6eSoFa]K6e/HoaSo6e/Hoa]Hoe/KF0=K6e/KFa]K6e/H0a]K6e/KFa]K60@0000S6
00<0a/H08lH00`36aP0?aP05ClK6aTl00lH014o6aSl2aP03ClK600C600<oa/H00/H01Do6a/I?00k6
00<oClH04<H00do6C`04aP04?lK6C`;600<0a/H02<H00`36aP07aP400000DmK6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eSoFa]K6?lKF?mK6
?lKFaSo6e/KF008o01W6e/KF?mHoe/Hoa]K6e/KFa]K6e/KFa]K6008o03;Fa]K6e/KFa]K6e/KFa]K6
?lKF?mK6eSoFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/KFaP400008aP030<K602?600<0a/H04/H00co6
aP04aP05ClK6aTl00lH00do6C`03aP07Cco6aTo6C`0AaP03Cco601G600=?a/H00/H00`36aP08aP03
0<K600O60@00001?e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeP03?`0Oe/Hoa]HoeSoFaSo6?lKFa]K6e/KFa]K6
e/KFa]K6eP02?`0_a]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H0
0@0000S600<0a/H08lH00`36aP0LaP03?lHo00?600Hoa/I??dl4aP04?dloCa7600=??lH06<H00`36
aP08aP030<K600O60@00001=e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl01/Hoa]HoeP8o00K6?lKFa]H2?`03
a]Ho008o00oFa]K6e/KFa]K6e/KFa]H00Sl0;LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF
a]K60<KFa]K6e/KFaP0100002<H00`36aP0RaP030<K601c600=?aTl01<H00cm?aP02aP03Cco600?6
00=?a/H05<H00co6aP0EaP030<K600S600<0a/H01lH1000004[Fa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o00KF?mK6
e/H2?`0:e/KFaSo6?lKFaP8o02KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFaPP0
01CFa]K6e/KFa]K60<KFa]K6e/KFaP400008aP030<K602;600<0a/H06LH01Co6a/Ho00?600<oClH0
0lH01Co6a/Ho00;600=??lH05/H?00O600<0a/H02<H00`36aP07aP400000D=K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KF?mK60cl05LKFa]Hoe/KFa]K6?lHoa]K6e/KFaP0?000[a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
a]K6e/KFa]K60<KFa]K6e/KFaP0100001lH00`36aP0SaP030<K601c600Q?a/HoClI??`?600<oaP00
3P0VaP030<K600O600<0a/H01lH1000004[Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPl000G6e/KFaP02?`12e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6
0@0000O600<0a/H08lH00`36aP0;aPl00lH01Cm?a/Ho00;600=?a/H01lH00dloaP0^aP030<K600O6
00<0a/H01/H1000002cFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPl0
0176e/KFa]K6e/KFa]K6e/KFaP02?`0@e/KF?mK6eSoFa]K6e/KFaP8o04;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36
aP0CaPl000?60<H08LH00do6aP0;aP03ClI?02o600<0a/H01/H00`36aP06aP4000003]K6e/KFa]H0
e/KFa]K63`00QLKFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aSo6e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H0a]K6e/KFa]H0e/KFa]K6e/H00@0000O61`0OaP030<K602k600=?aTl0;lH00`36aP06aP03
0<K600K60@00001Ne/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04;F?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/H10000
2/H00`36aP0PaP030<K602k600A??lHo;lH00`36aP05aP030<K600K60@00001Ne/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04;FaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/H100003<H201o600<0a/H0;/H01Dloa/I?02o6
00<0a/H01<H00`36aP06aP400000G]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`12
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6
e/KFa]K60@0000o600<0a/H06lH00`36aP0^aP03ClK600;600<oa/H0;LH00`36aP03aP030<K600K6
0@00000@e/KFa]K6e/KFa]K6e/KFaP80093Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/H100004/H00`36
aP0HaP030<K602k600=?a/H0<lH00`36aP02aP030<K600K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K60@0001C600<0a/H05/H00`36aP1UaP050<K6aP002<H10000
01GFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P00RlKFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0e/KFa]K6e/H00@0001O600<0a/H0
4lH00`36aP1UaP050<K6aP002<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0
e/KFa]K6e/H100006LH201;600<0a/H0I/H01036aP08aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/H0a]K6e/KFaP40000LaP030<K600k600<0a/H0IlH01036aP07aP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/KFaP40000NaP803<H00`36aP1YaP03
0<H000O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K60@000276
00<0a/H02<H00`36aP1ZaP801lH1000009WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0P001lKFa]K6e/H00@0002?60P07aP030<K606[60P07aP400000TMK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H02P001lKFa]K6e/H00@0002K600<0a/H00lH00`36aP1?aQ<04LH1000002OFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P00@lKFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H04P009=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000YaP040<K602g64P0faP400000AmK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF01<0
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000:lH200S64P1KaP400000;=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K62@00KLKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@000001\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0193671, -0.025, 0.00553035, \
0.00553035}}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  ButtonBox["Example",
    ButtonData:>"Example D",
    ButtonStyle->"Hyperlink"],
  " (d)"
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  ButtonBox["Parameters",
    ButtonData:>"Example D: parameters",
    ButtonStyle->"Hyperlink"],
  " and L-system interpretation"
}], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"Example D"],

Cell["\<\
r1 = 0.9;   (* contraction ratio for the trunk  *)
r2 = 0.7;   (* contraction ratio for branches   *)

a0 = 30;    (* branching angle from the trunk   *)
a2 = -30;   (* branching angle for lateral axes *)

d  = 137.5; (* divergence angle                 *)
wr = 0.707; (* width decrease rate              *)\
\>", "Input",
  AspectRatioFixed->True,
  CellTags->"Example D: parameters"]
}, Closed]],

Cell[CellGroupData[{

Cell["L-system and turtle interpretation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
plants = runKLSystem[
            plantLSystem[r1,r2,a0,a2,d,wr],9,
            SkipPatterns -> plantSkipPatterns];\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData[{
  "Map[\n    turtleInterpretation[#,\n      StartDirection -> \
Transpose[{{0,0,1},{1,0,0},{0,-1,0}}],\n      MaxNumberOfPaths -> 4000,\n     \
 LineThickness -> 0.05,\n      LineHue -> 0.9,\n      GraphicOptions ->\n     \
 {\n        AspectRatio -> Automatic,\n\t      Axes -> False,\n\t      Boxed \
-> True, BoxStyle -> GrayLevel[1],\n\t      ViewPoint -> {-3.6,-0.8,1.5},\n\t \
     FaceGrids -> {{0,0,-1}},\n\t      PlotRange -> All,\n\t      Background \
-> GrayLevel[0.9],",
  StyleBox["\n    ",
    FontFamily->"Times"],
  "      DisplayFunction -> $DisplayFunction\n      }]&,Drop[plants,1]\n  ];"
}], "Input",
  AspectRatioFixed->True],

Cell[TextData[
"Starting turtle interpretation ...\nTime needed: 0.05 Second\nGenerating \
graphics ...\nStarting turtle interpretation ...\nTime needed: 0.116667 \
Second\nGenerating graphics ...\nStarting turtle interpretation ...\nTime \
needed: 0.266667 Second\nGenerating graphics ...\nStarting turtle \
interpretation ...\nTime needed: 0.583333 Second\nGenerating graphics ...\n\
Starting turtle interpretation ...\nTime needed: 1.15 Second\nGenerating \
graphics ...\nStarting turtle interpretation ...\nTime needed: 2.41667 Second\
\nGenerating graphics ...\nStarting turtle interpretation ...\nTime needed: \
4.78333 Second\nGenerating graphics ...\nStarting turtle interpretation ...\n\
Time needed: 9.93333 Second\nGenerating graphics ...\nStarting turtle \
interpretation ...\nTime needed: 19.85 Second\nGenerating graphics ..."], 
  "Print",
  Evaluatable->False,
  CellOpen->False,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Graphics", "Subsubsection"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.09277 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.0217706 1.13101 0.0282753 1.13101 [
[ 0 0 0 0 ]
[ 1 1.09277 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.09277 L
0 1.09277 L
closepath
clip
newpath
p
1 g
.002 w
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
.07914 .12169 m
.85581 .02828 L
s
.93606 .38326 m
.3047 .44368 L
s
.3047 .44368 m
.28397 1.06449 L
s
.28397 1.06449 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.93606 .38326 m
.85581 .02828 L
s
.07914 .12169 m
.3047 .44368 L
s
.3047 .44368 m
.28397 1.06449 L
s
.28397 1.06449 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
p
.4 g
.85819 .03878 m
.08575 .13112 L
s
P
p
.4 g
.88047 .13735 m
.14794 .2199 L
s
P
p
.4 g
.90039 .22549 m
.20386 .29973 L
s
P
p
.4 g
.91832 .30477 m
.25442 .3719 L
s
P
p
.4 g
.93452 .37646 m
.30034 .43745 L
s
P
p
.4 g
.83632 .03062 m
.92038 .38476 L
s
P
p
.4 g
.64418 .05373 m
.76534 .39959 L
s
P
p
.4 g
.45698 .07625 m
.61352 .41412 L
s
P
p
.4 g
.27454 .09819 m
.4648 .42836 L
s
P
p
.4 g
.09668 .11958 m
.31911 .4423 L
s
P
P
p
1 0 .6 r
.02 w
.54374 .27855 m
.54374 .93876 L
s
P
p
1 g
.05 w
.54374 .27855 Mdot
P
p
1 g
.002 w
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.02828 .87038 L
s
.02828 .87038 m
.07914 .12169 L
s
.07914 .12169 m
.85581 .02828 L
s
.85581 .02828 m
.8921 .81254 L
s
.8921 .81254 m
.97172 1.02868 L
s
.97172 1.02868 m
.93606 .38326 L
s
.93606 .38326 m
.85581 .02828 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 334}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000Q]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61@005lKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001maPT000G6a<K6000GaP400000MMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP08000:a]K6e/KFa]K6eP?401P0a=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000KLH800W62L@00lK4aP0201K60@00001Te/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT000W6e/KFa]K6e/H02<@03=K6e/KFa]K6e/K4aP8001KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0005c62004aP03a<K600?62<@BaP04a<H001K60@00001Ce/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H02@002MK6e/KFa]K6eP09a00Le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4aP8001KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0004_6200:aPS41<H00lC6aP0MaP03a00001K6
0@000013e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP080009a]K6e/KFa]K600W404G6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/@0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003[62@07aP03a<K400O4
5/H00lC6aP0LaP04a03601G60@00000be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H8000:e/KFa]K6e/KFaPS405KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa0360<KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000YaPT02LH9a0O600?4a/H07<H00lC6aP0MaP030<H001G60@00000Qe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF00P000[6e/K4a]K6e/KF2<@0IlKFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K40=H0e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0001W62009aPW46LH00lC6aP0LaP03a<K601c600C40<H05<H10000
013Fa]K6e/KFa]K6e/KFa]K62@002LKFa]K6e/KFaP08a01he/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a03F0=K6e/KFa]K6e/KFa]K6e/KFa]K60@0000c6100:aPS43<H00lC6aP0LaP03
a<K601c600?4a/H07<H00`36000DaP4000004MK6e/KFa]K6e/KFaP36e/CF00W408SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6
e/KFa]K60@0000c600<0a<@00/@NaP03a<K601c600?4a/H06lH00lC6aP0LaP040<K601?60@000029
e/KFa]K6e/KFa]K60<H0a]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H00/@05`34a036e/KFa]K6e/KFa]K6e/KFa]K60040000<aP030<H000;6
00?4a/H07<H00lC6aP0LaP03a<K601_600?4a/H04<H9a0;600@0a/H04lH1000007OFa]K6e/KFa]K6
e/H0a]H0e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6eP09a00Re/KFa]K6
e/KFa]H0a<H0a]K6e/KFa]K6e/KFa]K6e/KFaP40000<aP050<K6aP000/H00lC6aP0KaP03a<K601c6
00?4a/H06lH9a1C600D0a<K6000BaP400000IMK6e/KFa]K6e/KFaP36e/KF0=K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6
e/KFa]K6e/KF00[403?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0<C6eP3Fa]K6e/KFa]K6e/KF
a]K6e/H00@0000c600<0a/H00/H01036a/@NaP03a<K601_600?4a/H02<H9a0W600?4a/H06/H01@34
a/H001;60@00001Ae/KFa]K6e/KFa]H0e/KFa]K60<KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00_404KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa=H0e/KFa]K6e/KFa]K6e/KFa]K60@0000_600<0a/H0
1LH01036a/@MaP03a<K601;62/@LaP03a<K601W600D0a/C6000BaP400000@=K6e/KFa]K6e/KF0=K6
e/KFa]H0e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/H9a01Ia]K6e/KF
a]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
0=K4e/H0a]K6e/KFa]K6e/KFa]K6e/H00@0000_600<0a/H01/H01036a/@MaP03a<K400S44/H00lC6
aP0KaP03a<K601S600<0a/@00/H00`36aP0?aP400000;]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/H9a01[a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6a<H0a]K6e/KF
a]K6e/KFa]K6e/H00@0000_600<0a/H02<H00`36a00<aPW42<H00lC6aP0JaP03a<K601[600?4a/H0
6<H01P36a/C601760@00000Le/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/CFaPW407g6e/KFa]K6e/KF
a]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/K4a]H0e/KFa]K6e/KFa]K6e/KFaP010000
2lH00`36aP09aPG46lH00lC6aP0JaP03a<K601[600?4a/H05lH01036a/@2aP030<K600k60@00002<
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP05a00A0=K6e/KFa]K6e/KFa]K6e/H00@0000_600<0a/H02/H01036
a/@LaP03a<K601[600?4a/H06/H00lC6aP0>aPW400H0a/K4aP0@aP400000N]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]H0e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K62L@07lKFa]K6e/KF
aP36e/CFaP36e/KFa]K6e/KFa]K6e/H00@0000_600<0a/H03<H01036a/@KaP03a<K601[600?4a/H0
5lH:a1;600@0a/K40/H00`36aP0=aP400000ImK6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KFa]H02L@0<]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6a<H0a]K6e/KFa]K6
e/KFa]K60@0000_600<0a/H03LH01036a/@LaP03a<K601S61004aPW43<H00lC6aP0FaP070<K6a/C6
000?aP400000EMK6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K4e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/@01P03a014e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/K4aP36e/KFa]K6e/KFa]K6e/H100002/H00`36
aP0@aP030<K401c600?4a/H03<H9a0P06<H00lC6aP0EaP050<K6a/@00/H00`36aP0<aP400000@]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6
e/KFaPW400W6e/KFa]K6e/H02000A]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa=H0e/KFa]K6e/KFa]K6e/H100002/H00`36aP0AaP040<K6a1K62/@BaPP0
6<H00lC6aP0EaP030<K600;600?4aP003/H1000002oFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K4e/KFa]K6e/KFa]K6eP09a00Le/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFaPP004KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/CF0=K6e/KFa]K6
e/KFa]K60@0000[600<0a/H04lH00`36a003aPW43lH00lC6aP0DaPH06/H00lC6aP0DaP030<K600;6
00C4a/H03LH10000027Fa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFaP001L@0<=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP@004S4a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa/C60<KFa]K6e/KFa]K6e/H10000
2/H00`36aP0DaP030<K401_600?4a/H05LH01Cm??lK401[600?4a/H04lH00`36aP05a0030<K600_6
0@00001Ge/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o02_Fa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KF00O401H0a<C6e/K4aP36e/KFa]K6e/KFa]K60@0000[600<0a/H0
5LH01036a/@JaP03a<K601C600<oCcl00/H00lC6aP0GaP03a<K600?62L@7aP030<K600?600?4aP00
3LH1000005OFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa/C6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl06=K6a<KFa]K6e/KFa]K6e/KFa]K6
e/KFaP[402KFa]K6e/KFa]K6e/KFa]K60<KFa]K6a<KF0=K6e/KFa]K6e/KFaP40000:aP030<K601O6
00<0a/@06lH00lC6aP0BaP03?dlo00;600?4a/H02LH:a0G600?4a/H04/H00`36aP04aP03a<H000c6
0@00001Ge/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KF00<o00?Fa]H02l@0>]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K4eP3Fa]K6e/KFa]K6e/H100002/H00`36aP0HaP04
0<K6a1[600?4a/H03lH2a003?dlo00C46/H00lC6aP0AaP030<K600C600?4aP003<H1000004_Fa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa=K6e/KFa]H02/@00lKF?`02?`18e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa=K60<KFa]K6e/KFa]K60@0000[600<0a/H06/H00`36a00GaP[4
3<H00cm??`04aP03a<K601O600?4a/H04LH00`36aP05aP03a<H000_60@00000he/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6a<KFa]K6e/KFa]K6e/H9a00Fa]K6a<KFa]K6e/KF
a]K6e/KFa]K6eP<o04SFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6a<H0a]K6e/KFa]K6e/H100002LH00`36aP0LaP030<K400?62/@=aP03a<K600o6
00<oCcl01LH00lC6aP0GaP03a<K6017600<0a/H01<H00lC6000;aP400000:MK6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00G402WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFa]K6eP03?`0he/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/H4a00<0<CFa]K6e/KFa]K60@0000W600<0a/H07/H00`36a00IaP03a<K600k6
00<oCcl01/H00lC6aP0GaP03a<K600_61L@00`34a002a0?600?4aP002/H1000005OFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]H00cl08mK6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KF00_4
00WFa]K6eP3Fa]H010003L@00=K6e/KFa]K6e/H00@0000W600<0a/H07lH00`36a00IaP03a<K600g6
00<oCcl01lH00lC6aP0?aP[42LH;00K600<0a/H02<H1000005OFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6
e/KFa]H00cl03mK6e/KFa]K4e/KFa]K6eP0:a009a]K6e/KFa]K400X001cFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K60@0000W600<0a/H08<H01036a/@HaP03a<K600c600<oCcl01<H;a0K6300BaP03
0<K600O600<0a/H02<H1000005CFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/H3a0<o1<@01]K6e/K4aP/0
03?6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/H00@0000W6
00<0a/H08/H00`36a00IaP[40lH00cm??`090003a<K602O600<0a/H01lH00`36aP08aP400000?mK6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K4e/KFa]K6e/KFa]K6
eP0<a003a]H000T00cl0B=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFaP400009aP030<K602?600<0a/@00lH:a0?62@000l@0
aP09aP03?dlo03?600<0a/H01lH00`36aP08aP400000<=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPG400?6eP002P005MK6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`18
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K60@0000W600<0a/H09LH20004a000023600<oCcl0<lH00`36aP07aP030<K600S6
0@00001Ge/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36
aP0VaP030<K602?600<oCcl0<lH00`36aP08aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?600<oCcl0<lH00`36
aP08aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6
e/H100002<H00`36aP0VaP030<K602?600<oCcl0<lH00`36aP08aP030<K600O60@00001Ge/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?6
00<oCcl0=<H00`36aP07aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?600<oCcl0=<H00`36aP07aP030<K600O6
0@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36
aP0VaP030<K602?600<oCcl0=<H00`36aP07aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/H100002<H00`36aP0VaP030<K602?600<oCcl0=<H00`36
aP07aP030<K600O60@00001Ge/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6
e/H100002<H00`36aP0VaP030<K602?600<oCcl0=<H00`36aP07aP030<K600O60@00001Ge/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/H100001lH00`36aP0VaP030<K602C6
00<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C600<oCcl0=<H00`36aP08aP030<K600K6
0@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36
aP0VaP030<K602C600<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C600<oCcl0=<H00`36
aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6
e/H100001lH00`36aP0VaP030<K602C600<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C6
00<oCcl0=<H00`36aP08aP030<K600K60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/H100001lH00`36aP0VaP030<K602C600<oCcl0=LH00`36aP07aP030<K600K6
0@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/H100001/H00`36
aP0WaP030<K602C600<oCcl0=LH00`36aP07aP030<K600K60@00001Ge/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36
aP07aP030<K600K60@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6
e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36aP0WaP030<K602C6
00<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K60<KFa]K6e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G6
0@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36
aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36
aP08aP030<K600G60@00001Ge/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6
e/H100001/H00`36aP0WaP030<K602C600<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K60<KFa]K6e/H100001LH00`36aP0XaP030<K602C6
00<oCcl0=LH00`36aP08aP030<K600G60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K60<KFa]K6e/H100001LH00`36aP0XaP030<K602C600<oCcl0=/H00`36aP07aP030<K600G6
0@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/H100001LH00`36
aP0WaP030<K602G600<oCcl0=/H00`36aP07aP030<K600G60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0WaP030<K602G600<oCcl0=/H00`36
aP08aP030<K600C60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6
e/H100001LH00`36aP0WaP030<K602G600<oCcl0=/H00`36aP08aP030<K600C60@00001Ge/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0WaP030<K602G6
00<oCcl0=/H00`36aP08aP030<K600C60@00001Ge/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o
04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6eP3Fa]K6e/H100001LH00`36aP0WaP030<K602G600<oCcl0;/H900[600<0a/H01<H10000
05OFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00cl07mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H03`006]K6e/KFa]K60<KFa]K6e/KFa]H0e/KFa]K60@0000C600<0a/H0:<H00`36aP0UaP03
?dlo00o6400HaP030<K600O600<0a/H01<H1000005OFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0cl?000ia]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KF
a]K600400004aP030<K602S600<0a/H06<H@03O600<0a/H01lH00`36aP04aP400000>]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H@000=e/KFa]K6
e/KFa]K6eP03?`18e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K60@0000C600<0a/H09<H?01g600<oCcl0><H00`36aP06aP03
0<K600C60@00000Ke/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF010002c6e/KF0=K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/H100001<H00`36aP05aPl0
5<H00`36aP0UaP03?dlo03W600<0a/H01LH00`36aP04aP4000001=K6e/H8001;e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6eP3Fa]K6e/H100001/H00`36aP0VaP030<K602G600<oCcl0>/H00`36aP05aP03
0<K600?60@00001Ge/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/H10000
2<H202G600<0a/H09LH00cm??`0jaP030<K600G600<0a/H00lH1000005OFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H00cl0B=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFaP40000;aP030<K6027600<0a/H09LH00cm??`0kaP03
0<K600C600<0a/H00lH1000000cFa]K6e/KFa]K6e/H20019e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`18e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
0<KFa]K60@0000k600<0a/H07/H00`36aP0UaP03?dlo03c600<0a/H00lH00`36aP03aP400000EmK6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP03?`18e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K60@00013600<0a/H07<H00`36
aP0UaP03?dlo03g600<0a/H00/H00`36aP03aP4000004MK6e/KFa]K6e/KFa]K6e/KF008004C6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6eP<o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/H0a]K6e/H100004lH00`36aP0IaP030<K602G600<oCcl0?LH00`36aP02aP03
0<K600?60@00001Ge/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00<o04SFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/H10000
5LH201S600<0a/H09LH00cm??`0naP050<K6aP001LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/H0a]K6e/H100006<H00`36aP0DaP030<K606O600@0a/H01LH1000001WFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008008O6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/H00@0001_600<0a/H04<H00`36
aP1XaP040<K600G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6
0@0001g60P0?aP030<K606W600@0a/H01<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3F0=K6e/H100008<H00`36aP0;aP030<K606[600<0aP001<H10000027Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00P00OlKFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/H00@0002?600<0a/H02<H00`36aP1[aP80
1<H1000009cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H20004e/KFaP40000UaP03
0<K600K600<0a/H0JlH200C60@00000Ve/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H2001/e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62P001=K6
e/H10000:<H00`36aP03aP030<K605364`0>aP400000KmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0B000Qa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000ZaP800/H00`36aP0[aQ<0<lH1000004[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQ8004KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002g60P08aQ<0F<H1000002kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K62@00JlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP400000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0191726, -0.0250049, 
  0.00545875, 0.00545875}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 3.24741 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-1.04717 3.14311 0.0785777 3.14311 [
[ 0 0 0 0 ]
[ 1 3.24741 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 3.24741 L
0 3.24741 L
closepath
clip
newpath
p
1 g
.002 w
.61529 .07858 m
.62497 2.74977 L
s
.62497 2.74977 m
.07858 2.78404 L
s
.07858 2.78404 m
.1211 .13461 L
s
.1211 .13461 m
.61529 .07858 L
s
.88734 .72695 m
.44401 .77154 L
s
.44401 .77154 m
.43653 3.16884 L
s
.43653 3.16884 m
.92142 3.14218 L
s
.92142 3.14218 m
.88734 .72695 L
s
.61529 .07858 m
.62497 2.74977 L
s
.62497 2.74977 m
.92142 3.14218 L
s
.92142 3.14218 m
.88734 .72695 L
s
.88734 .72695 m
.61529 .07858 L
s
.1211 .13461 m
.44401 .77154 L
s
.44401 .77154 m
.43653 3.16884 L
s
.43653 3.16884 m
.07858 2.78404 L
s
.07858 2.78404 m
.1211 .13461 L
s
p
.4 g
.62253 .09584 m
.12969 .15155 L
s
P
p
.4 g
.69274 .26316 m
.21296 .3158 L
s
P
p
.4 g
.75911 .42135 m
.29173 .47117 L
s
P
p
.4 g
.82196 .57113 m
.36635 .61835 L
s
P
p
.4 g
.88155 .71315 m
.43713 .75797 L
s
P
p
.4 g
.60341 .07992 m
.8767 .72802 L
s
P
p
.4 g
.46808 .09527 m
.75537 .74022 L
s
P
p
.4 g
.33343 .11053 m
.6346 .75237 L
s
P
p
.4 g
.19948 .12572 m
.51439 .76446 L
s
P
P
p
1 0 .6 r
.02 w
.74837 .47758 m
.75907 1.69411 L
s
P
p
1 g
.05 w
.74837 .47758 Mdot
P
p
1 0 .6 r
.01414 w
.75907 1.69411 m
.76961 2.89281 L
s
P
p
1 0 .6 r
.01414 w
.75907 1.69411 m
.2849 2.52232 L
s
P
p
1 g
.002 w
.61529 .07858 m
.62497 2.74977 L
s
.62497 2.74977 m
.07858 2.78404 L
s
.07858 2.78404 m
.1211 .13461 L
s
.1211 .13461 m
.61529 .07858 L
s
.61529 .07858 m
.62497 2.74977 L
s
.62497 2.74977 m
.92142 3.14218 L
s
.92142 3.14218 m
.88734 .72695 L
s
.88734 .72695 m
.61529 .07858 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 334}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000DmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00D004[Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40001:aPT01<@00`36aP18aP400000@MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K400T02L@01<KFa]H20019a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP010000?<H500W41/H00lC6aP04aP80BLH1000003gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H000G4063Fa]K6e/K4a]K6e/KFa/C6
e/KFa]H0a03Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000?<H200?600?4a/H01<H00lC6aP06aP03a<K600?600<0a000
B<H1000003cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H2001Te/KFa/C6e/KFa]K4e/KFa]K6e/CFa]K6eP340=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000laP03
0<H000?600?4a/H01<H00lC6aP05aP03a<K600?600@0a/@0AlH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa=K6e/KFa/C6
e/KFa]K6a<KFa]H0e/@0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000?<H01036aP03aP03a<K600C600?4a/H01LH00lC6
aP02aP050<K6a000A/H1000005SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa/C6e/KFa]K4e/KFa]K6e/CFa]H00l@0A`3Fa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000laP050<K6aP000lH00lC6aP04aP03a<K600W400H0a/K6a015aP400000AMK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6
eP09a01De/KFa]K6a<KF0=K6e/@0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003c600<0a/H00/H5a0K600?4a/H01LH01<C6
aP03aP03a03604C60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa/C6e/KFa]K4e/KFa]K6a<KF0=K6e/K40=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0003c600<0a/H00lH01@36a/K400K600?4a/H01LH00lC60004aP03a03604?60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
0<KFa]K4e/KFa]K6a<KFa]K6e/CF0=K6e/KFa036e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003c600<0a/H01<H01@36a/K400K6
00?4a/H01LH00l@0aP04aP03a03604;60@00001Ke/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6a<KFa]K6e/CFa]K6e/K40=K6
eP04a0130=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP010000?<H00`36aP05aP050<K6a/@01/H00lC6aP05a0040<C4a0?600?40<H0
@LH1000004WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFaP36e/KF00W4053Fa]K6eP3Fa]K6e/K40=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000laP030<K600K6
1L@6aP03a<K600C600<0a/H00lH20003a03604360@00001Me/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/CFa]K6e/K4a]K6
e/KF0<C6e/KF008004?40<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000laP030<K600K600<0a/H00/H00lC6aP04aP03a<K600?6
00<0a<H01<H014o6a010aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6a<KFa]K6e/CFa]K6eP3Fa=K6e/Hoa/@0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000laP030<K600O600<0a/H00/H00lC6aP04aP03a<K600;600<0a/@01<H01Do6a/@003o6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]H0e/KFa=K6e/KFa/C6e/KF0=K6a<KFaSo6e/@0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003c600<0a/H0
2<H00`36aP02aP03a<K600C600G4a/K60002aP05a<K4a4l00l@00`36aP0maP400000CmK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFaP36e/K4a]H02<@00`34a002a016e/Hoa]K6a03Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000laP030<K600W600<0a<@01<@5aP04
a<K600?600C4a/I?0lH00l@0aP0maP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa=K6e/KFa/C6eP3Fa]K4
e/Hoa]K6e/@0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000laP030<K600[600<0a/H00/H00lC6aP04aP03a<H000C600?4aTl01<H00l@0
aP0laP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60<KFa/C6e/KFa]K4eP3Fa]K6a<Hoa]K6e/K40=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000laP03
0<K600_600<0a/H00/H00lC6aP04aP03a03600C600?4ClH01<H00l@0aP0kaP400000HMK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6eP3Fa]K4e/KFa]K6a03Fa]K6e/@oa]H01<@0?@3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003c600<0a/H03<H00`36aP02aP03
a<K600C600<0a/@01<@014o4a<H30003a03603[60@00001@e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP36e/H7a003
0<@000@004@o0000e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000laP030<K600g600<0a<@00l@60003a<K600?600=?a/H01LH00`36
aP0iaP400000CMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF00@00576e/KFa]H0e/KFa]K6?lKFa]K6e/H0a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003c6
00<0a/H03/H00`36aP07aP030<K600C600=?a/H01LH00`36aP0iaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6eP3Fa]K6e/Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000kaP030<K600o600<0a/H01lH00`36aP04aP03
ClK600G600<0a/H0>LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6?lKFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000>lH00`36aP0?aP030<K600O600<0a/H01<H00do6aP05aP030<K603W60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003_600<0a/H03lH00`36aP07aP03
0<K600C600=?a/H01LH00`36aP0iaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6
e/Hoa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000kaP030<K600o600<0a/H01lH00`36aP04aP03ClK600G600<0a/H0>LH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6?lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>lH00`36aP0?aP03
0<K600O600<0a/H01<H00do6aP05aP030<K603W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KF0=K6e/KFaSo6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0003_600<0a/H03lH00`36aP07aP030<K600C600=?a/H01LH00`36
aP0iaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/Hoa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000kaP03
0<K600o600<0a/H01lH00`36aP04aP03ClK600G600<0a/H0>LH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]H0e/KFa]K6?lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>lH00`36aP0?aP030<K600O600<0a/H01<H00do6
aP05aP030<K603W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0003_600<0a/H03lH00`36aP07aP030<K600G600<oa/H01<H00`36aP0iaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000kaP030<K600o600<0a/H01lH00`36
aP05aP03?lK600C600<0a/H0>LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6
eSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000>lH00`36aP0?aP030<K600O600<0a/H01LH00co6aP04aP030<K603W60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003_600<0a/H03lH00`36
aP07aP030<K600G600<oa/H01<H00`36aP0iaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP3Fa]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000kaP030<K600o600<0a/H01lH00`36aP05aP03?lK600C600<0a/H0
>LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6eSoFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>lH00`36
aP0?aP030<K600O600<0a/H01LH00co6aP04aP030<K603W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003_600<0a/H03lH00`36aP07aP030<K600G600<oa/H0
1<H00`36aP0iaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KF?mK6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000kaP030<K600o600<0a/H01lH00`36aP05aP03?lK600C600<0a/H0>LH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6eSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>lH00`36aP0?aP030<K600O600<0a/H0
1LH00co6aP04aP030<K603W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]Ho
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003_600<0a/H03lH00`36aP07aP030<K600G600<oa/H01<H00`36aP0iaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000kaP030<K600o600<0a/H0
1lH00`36aP05aP03?lK600C600<0a/H0>LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0
e/KFa]K6eSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000>lH00`36aP0?aP030<K600O600<0a/H01LH00co6aP04aP030<K603W6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003_600<0a/H0
3lH00`36aP07aP030<K600G600<oa/H01<H00`36aP0iaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6eP3Fa]K6e/KF?mK6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000kaP030<K600o600<0a/H01lH00`36aP05aP03?lK600C6
00<0a/H0>LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6eSoFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
>lH00`36aP0?aP030<K600O600<0a/H01LH00co6aP04aP030<K603W60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003_600<0a/H03lH00`36aP07aP030<K600G6
00<oa/H01<H00`36aP0iaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KF?mK6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000kaP030<K600o600<0a/H01lH00`36aP05aP03?lK600C600<0a/H0>LH1000005kFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K60Sl0@]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000kaP030<K600o600<0a/H0
1lH00`36aP04aP03Cco600G600<0a/H0>LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0
e/KFa]HoeSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000>lH00`36aP0?aP030<K600O600<0a/H00/H014o6aSl6aP030<K603W6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/Hoa]Hoe/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003_600<0a/H0
3lH00`36aP07aP050<K6aSl00lH00co6aP04aP030<K603W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KF0=K6eSoFa]Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003_600<0a/H03lH00`36aP07aP040<K6C`C600<oa/H0
1<H00`36aP0iaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3FaSo6e/KF?mK6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000kaP030<K600o600<0a/H01lH00`36?`05aP03?lK600C600<0a/H0>LH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]H0?lKFa]K6eSoFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>lH00`36aP0?aP030<K600O600<0ClH0
1LH00co6aP04aP030<K603W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]Ho
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003_600<0a/H03lH00`36aP07aP030<K600G600<oa/H01LH00`36aP0haP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6?`3Fa]K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000kaP030<K600o600<0a/H0
1LH00co60007aP03?lK600G600<0a/H0><H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF?mH0
e/KFa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000>lH00`36aP0?aP030<K600C600A?a/H01lH00co6aP05aP030<K603S6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6?lKF0=K6e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003_600<0a/H0
3lH00`36aP03aP05?lK6aP001lH00co6aP05aP030<K603S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]Hoe/KF0=K6e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003_600<0a/H03lH00`36aP02aP03ClK600;600<0a/H0
1LH00co6aP05aP030<K603S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KF?mK6e/KF0=K6e/KFa]Ho
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003[600<0a/H04<H01@36a/Ho00G600<0a/H01LH00co6aP05aP030<K603S60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]H0e/Hoa]K6e/KF0=K6e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003[600<0a/H04<H01036
aTl6aP030<K600G600<oa/H01LH00`36aP0haP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=Hoe/KFa]K6
eP3Fa]K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000jaP030<K6013600<0aSl01lH00`36aP05aP03?lK600G600<0a/H0
><H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP0oa]K6e/KFa]H0e/KFa]K6eSoFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>/H00`36
aP0@aP03?lK600O600<0a/H01LH00co6aP05aP030<K603S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003[600<0a/H03lH00dl0aP08aP030<K600G600<oa/H0
1LH00`36aP0haP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/Ho0=K6e/KFa]K6eP3Fa]K6e/KF?mK6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000jaP030<K600k600<oaP002LH00`36aP05aP03?lK600G600<0a/H0><H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFaSo6eP3Fa]K6e/KFa]H0e/KFa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>/H00`36aP0=aP04ClK600W600<0a/H0
1LH00co6aP05aP030<K603S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eSoFa]H0e/KFa]K6e/KF0=K6e/KFa]Ho
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003[600<0a/H03<H01Co6a/H000W600<0a/H01LH00co6aP05aP030<K603S60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6?lKFa]H0e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003[600<0a/H02lH00do6
aP02aP030<K600O600<0a/H01LH00co6aP05aP030<K603S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]Hoe/KFa]H0
e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003[600<0a/H02LH00do6aP04aP030<K600O600<0a/H0
1LH00co6aP05aP030<K603S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFaSo6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]Ho
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003[600<0a/H02<H00co6aP05aP030<K600O600<0a/H01LH00co6aP05aP030<K603S6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003[600<0a/H0
4<H00`36aP07aP030<K600G600<oa/H01LH00`36aP0haP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6eP3Fa]K6e/KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000jaP030<K6013600<0a/H01lH00`36aP05aP03?lK600G6
00<0a/H0><H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6eSoFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
>/H00`36aP0@aP030<K600O600<0a/H01LH00co6aP05aP030<K603S60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]Hoe/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003[600<0a/H04<H00`36aP07aP030<K600G6
00<oa/H01LH00`36aP0haP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KF?mK6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000jaP030<K6013600<0a/H01lH00`36aP05aP03?lK600G600<0a/H0><H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>/H00`36aP0@aP030<K600P0
1lH00co6aP05aP030<K603S60@000011e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H03`00D]K6e/KFa]H0e/KFa]K6eSoFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
>/H700c600<0a/H02<H00`36aP04aP03?lK600G600<0a/H0><H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6eP3Fa]K6eSoFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000>lH00`36aP0?aP030<K600[600<0a/H00/H00co6
aP05aP030<K603S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<KFa]Hoe/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0003g600<0a/H03LH00`36aP0;aP050<K6aSl01lH00`36aP0haP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K60<KF?mK6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000oaP030<K600_600<0a/H03<H01036aSl7aP03
0<K603S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000476
00<0a/H02LH00`36aP0>aP030<K600K600<0a/H0><H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000@lH00`36aP07aP030<K600o600<0a/H01LH00`36aP0haP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP400014aP030<K600K6
00<0a/H04LH00`36aP03aP030<K603S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0004K600<0a/H01<H00`36aP0BaP030<K600;600<0a/H0><H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000B<H00`36aP02aP030<K601C6
00@0a/H0>/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
B/H01036aP0GaP030<H003[60@00001Ve/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60P00>]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000C<H200c63P0jaP400000CMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF00d004SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0194242, -0.0250051, 
  0.00583725, 0.00583725}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 2.52836 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.73596 2.47368 -0.00716307 2.47368 [
[ 0 0 0 0 ]
[ 1 2.52836 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 2.52836 L
0 2.52836 L
closepath
clip
newpath
p
1 g
.002 w
.86023 .06184 m
.89664 2.35859 L
s
.89664 2.35859 m
.06184 2.40806 L
s
.06184 2.40806 m
.10159 .14355 L
s
.10159 .14355 m
.86023 .06184 L
s
.89872 .16187 m
.15408 .24044 L
s
.15408 .24044 m
.12029 2.46651 L
s
.12029 2.46651 m
.93816 2.41913 L
s
.93816 2.41913 m
.89872 .16187 L
s
.86023 .06184 m
.89664 2.35859 L
s
.89664 2.35859 m
.93816 2.41913 L
s
.93816 2.41913 m
.89872 .16187 L
s
.89872 .16187 m
.86023 .06184 L
s
.10159 .14355 m
.15408 .24044 L
s
.15408 .24044 m
.12029 2.46651 L
s
.12029 2.46651 m
.06184 2.40806 L
s
.06184 2.40806 m
.10159 .14355 L
s
p
.4 g
.86116 .06427 m
.10286 .1459 L
s
P
p
.4 g
.87629 .10359 m
.12349 .18398 L
s
P
p
.4 g
.89119 .14231 m
.14381 .22148 L
s
P
p
.4 g
.81553 .06666 m
.85486 .1665 L
s
P
p
.4 g
.65273 .08419 m
.6951 .18336 L
s
P
p
.4 g
.49104 .1016 m
.53641 .2001 L
s
P
p
.4 g
.33046 .1189 m
.37878 .21673 L
s
P
p
.4 g
.17097 .13608 m
.2222 .23325 L
s
P
P
p
1 0 .6 r
.02 w
.65409 .13617 m
.6592 .89394 L
s
P
p
1 g
.05 w
.65409 .13617 Mdot
P
p
1 0 .6 r
.01414 w
.6592 .89394 m
.66409 1.62044 L
s
P
p
1 0 .6 r
.01414 w
.6592 .89394 m
.36435 1.40234 L
s
P
p
1 0 .6 r
.01 w
.36435 1.40234 m
.23348 1.78552 L
s
P
p
1 0 .6 r
.01 w
.36435 1.40234 m
.09175 1.87239 L
s
P
p
1 0 .6 r
.01 w
.66409 1.62044 m
.66876 2.3138 L
s
P
p
1 0 .6 r
.01 w
.66409 1.62044 m
.9075 2.12443 L
s
P
p
1 g
.002 w
.86023 .06184 m
.89664 2.35859 L
s
.89664 2.35859 m
.06184 2.40806 L
s
.06184 2.40806 m
.10159 .14355 L
s
.10159 .14355 m
.86023 .06184 L
s
.86023 .06184 m
.89664 2.35859 L
s
.89664 2.35859 m
.93816 2.41913 L
s
.93816 2.41913 m
.89872 .16187 L
s
.89872 .16187 m
.86023 .06184 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 334}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000I]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaPD003O6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001KaP03a<H000P000G6a<K6000gaP400000E=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaPT004G6e/KFa]K6e/KFa=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0004_62@08aP03a<K600O61<@203K60@000012e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62@003lKF
a]K6a<KFa]K6e/KFaP0300W400CFa/C60P00=]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000iaPT00lH00lC6aP08aP[40`000lC6aP08aP;40P000lC6
aP0caP400000=MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00@000g4e/KFa]K6e/KFa]K600[400[Fa=K6e/KFa]K60`000lCFa008a00je/@0aP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000eaP030<K600;6
3L@;aP04a<K6aPG400@oa<C42<H20004a00003G60@00000fe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H01L@04lKFa]K6e/KFa]K6e/CFa]K6e/H02<@01]K6
e/KF?`8000?400001P00>lKFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000eaP801<H00lC6aP07aPW41<H00l@000060003?lK600c600<0aP00
=LH1000003cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3F0=K6e/H9a003a]K400X0053Fa=K6e/KFa]Hoe/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000eaP030<H000G42`000lC6
aP0@aP03?lK600c600<0aP00=LH1000003SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3FaPD006G4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF
a]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP010000=LH01036aP0RaP03?lK600c600<0aP00=LH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=LH01036aP0RaP03?lK600c600<0aP00=LH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=LH01036aP0RaP03
?lK600c600<0aP00=LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000=LH01036aP0RaP03?lK600c600<0aP00=LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=LH01036aP0RaP03?lK600c600<0aP00=LH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=LH01036aP0RaP03?lK600c6
00<0aP00=LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6
0<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
=LH01036aP0RaP03?lK600c600<0aP00=LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000=LH01036aP0RaP03?lK600c600<0aP00=LH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=LH01036aP0RaP03?lK600c600<0aP00
=LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K60<H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=LH01036
aP0RaP03?lK600c600<0aP00=LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000=<H01@36a/H002?600=?a/H02lH00`36000eaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000daP050<K6aP008lH00do6aP0;aP040<K603C6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFaP36eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003C600D0a/K6
000SaP03ClK600_600@0a/H0=<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000=<H01@36a/H002?600=?a/H02lH01036aP0daP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000daP050<K6aP008lH00do6aP0<aP030<H003C6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]H0eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003C600D0a/K6
000SaP03ClK600c600<0aP00=<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000=<H01@36a/H002?600=?a/H03<H00`36000daP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000daP050<K6aP008lH00do6aP0<aP030<H003C6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]H0eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003C600D0a/K6
000SaP03ClK600c600<0aP00=<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000=<H01@36a/H002?600=?a/H03<H00`36000daP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000daP040<K602C600=?a/H03<H00`36000daP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000daP040<K602C6
00=?a/H03<H00`36000daP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000daP040<K602C600=?a/H03<H00`36000daP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000daP040<K602C600=?a/H03<H00`36000daP400000FmK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl0ALKFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000=<H01036aP0SaP03
?do600g600<0aP00=<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6
e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000=<H01036aP0QaP04?lK6C`k600<0aP00=<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=<H01036aP0PaP05ClK6aTl03/H00`36000daP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6?lKFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000daP040<K601o600<oa/H0
0/H00do6aP0<aP030<H003C60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/Hoa]K6
e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003C600@0a/H07/H00do6aP03aP03ClK600c600<0aP00=<H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFaSo6e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=<H01036aP0MaP03?lK600C600=?a/H0
3<H00`36000daP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6?lKFa]K6e/KFa]K6
e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000daP040<K601c600=?a/H01LH00do6aP0<aP030<H003C60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003C600@0a/H06/H00do6aP07aP03ClK600c600<0aP00
=<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3F0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000=<H01036
aP0IaP03?lK600S600=?a/H03<H00`36000daP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000daP040<K601S600=?a/H02LH00do6aP0<aP030<H003C60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003C600@0a/H05lH00co6
aP0:aP03ClK600c600<0aP00=<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000=<H01036aP0FaP03ClK600_600=?a/H03<H00`36000daP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000daP040<K601G600<oa/H03<H00do6
aP0<aP030<H003C60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6
e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0003?600D0a/K6000CaP03?lK600k600=?a/H03<H01036aP0caP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0e/KFa]K6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000caP050<K6aP004/H00do6aP0?aP03ClK600c6
00@0a/H0<lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
<lH01@36a/H0017600<oa/H04<H00do6aP0<aP040<K603?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003?600D0a/K6000@aP03ClK6017600=?a/H03<H01036
aP0caP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]H0e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000caP05
0<K6aP003lH00co6aP0BaP03ClK600c600@0a/H0<lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<lH01@36a/H000k600=?a/H04lH00do6aP0<aP040<K603?6
0@000015e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
eP3Fa]K6e/KFa]K6e/KF008o05_6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]H0e/H0
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000caP05
0<K6aP003<H00dloaP0EaP03ClK600c600@0a/H0<lH1000004CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6e/KFaP8o05cFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000caP050<K6aP002lH00co6?`0FaP03ClK600c600@0a/H0
<lH1000004?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KF0=K6e/KFa]K6e/KF008o05g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3F
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003?6
00D0a/K6000:aP03ClI?01O600=?a/H03<H01036aP0caP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0e/KFa]K6e/KFaSo6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000caP050<K6aP002LH00co6?`0HaP03ClK600c600@0a/H0
<lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KF0=K6e/KFa]K6?lKF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eP3FaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<lH01@36
a/H000S600A?a/Ho6<H00do6aP0<aP040<K603?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0003?600D0a/K60007aP04?lK6CaW600=?a/H03<H01036aP0caP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0
e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KF0=K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000caP050<K6aP00
1LH01Co6a/Ho01[600=??lH03<H01036aP0caP400000G=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60Sl0A=K6e/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0003?600D0a/K60004aP03ClK600;600<oa/H06<H00do6C`0<aP04
0<K603?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6eP3Fa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]H0
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003?6
00D0a/K60003aP03?lK600;600=?a/H06LH014o6aSl;aP040<K603?60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]Hoe/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003?600D0a/K60002aP03ClK600;600<oa/H0
6/H01Do6a/I?00[600@0a/H0<lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/Hoa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000<lH01`36a/H0aSl01LH00co6aP0JaP03ClK600;600<oa/H01lH01036aP0caP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0
?lKFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Hoe/KFa]K6e/KF0=K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000caP060<K6aP1?
8lH00do6aP03aP03ClK600K600@0a/H0<lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFaSo6e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000<lH01@36a/Ho02C600=?a/H01<H00co6aP06aP030<H003?60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6?`3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K60<H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003?600D0aSo6000TaP03
ClK600G600=?a/H01LH00`36000caP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3F?mH0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/Hoa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000caP0504o6aP009<H00do6aP06aP03?lK600C600<0aP00<lH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6eSoFa]K6e/H0aP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<lH01@36a/H002C600=?a/H0
1/H00co6aP04aP030<H003?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6
e/KFa]K6?lKFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0003?600@0a/H09LH00do6aP07aP03ClK600?600<0aP00<lH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KF?mK6e/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<lH01036aP0UaP03ClK600S600<oa/H0
0/H00`36000caP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6
?lKFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000caP040<K602G600=?a/H02LH01do6a/H0aP00<lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]Hoe/H0aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<lH01036aP0UaP03ClK600[600Hoa/H0aP0caP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/HoaP360<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000baP050<K6aP009LH00do6
aP0;aP05ClH0aP00<lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6
e/KFa]K6eSl0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000</H01@36a/H002G600=?a/H03<H01Cl0a/H003;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003;600D0a/K6000UaP03ClK600g600@0a/H0</H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/H0?mH0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H01@36a/H002G6
00=?a/H03LH01036aP0baP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000baP050<K6aP009LH00do6aP0=aP040<K603;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003;600D0a/K6000UaP03ClK600g600@0a/H0</H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H01@36a/H002G6
00=?a/H03LH01036aP0baP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000baP050<K6aP009LH00do6aP0=aP040<K603;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003;600D0a/K6000UaP03ClK600g600@0a/H0</H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000</H01@36a/H002G6
00=?a/H03LH01036aP0baP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000baP050<K6aP00=LH01036aP0baP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000baP050<K6aP00:lH;00;600<0a/H0<<H1000004oFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF01<0043Fa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0003;600D0a/K60005aQ<07/H00`36000baP400000<]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62P00<]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P00<]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003?600@0a/H0;lH:03;60@00001Ce/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H04`00?=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000eaP802LHC04o60@00000fe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62P00H]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@000001\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0318967, 0.0028906, 
  0.00577466, 0.00577466}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 2.02436 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.468246 1.94967 0.0259481 1.94967 [
[ 0 0 0 0 ]
[ 1 2.02436 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 2.02436 L
0 2.02436 L
closepath
clip
newpath
p
1 g
.002 w
.8451 .04874 m
.88003 1.81918 L
s
.88003 1.81918 m
.04874 1.86925 L
s
.04874 1.86925 m
.09067 .1312 L
s
.09067 .1312 m
.8451 .04874 L
s
.9116 .23252 m
.19026 .30755 L
s
.19026 .30755 m
.15997 1.97561 L
s
.15997 1.97561 m
.95126 1.93048 L
s
.95126 1.93048 m
.9116 .23252 L
s
.8451 .04874 m
.88003 1.81918 L
s
.88003 1.81918 m
.95126 1.93048 L
s
.95126 1.93048 m
.9116 .23252 L
s
.9116 .23252 m
.8451 .04874 L
s
.09067 .1312 m
.19026 .30755 L
s
.19026 .30755 m
.15997 1.97561 L
s
.15997 1.97561 m
.04874 1.86925 L
s
.04874 1.86925 m
.09067 .1312 L
s
p
.4 g
.85403 .07341 m
.10402 .15485 L
s
P
p
.4 g
.87136 .12129 m
.12996 .20078 L
s
P
p
.4 g
.88826 .16802 m
.15529 .24562 L
s
P
p
.4 g
.90477 .21364 m
.18002 .28942 L
s
P
p
.4 g
.8158 .05194 m
.88361 .23543 L
s
P
p
.4 g
.5684 .07898 m
.6472 .26002 L
s
P
p
.4 g
.32436 .10566 m
.41385 .2843 L
s
P
p
.4 g
.08362 .13197 m
.18352 .30825 L
s
P
P
p
1 0 .6 r
.02 w
.5997 .18797 m
.60212 .63677 L
s
P
p
1 g
.05 w
.5997 .18797 Mdot
P
p
1 0 .6 r
.00707 w
.35034 1.1637 m
.28164 1.36578 L
s
P
p
1 0 .6 r
.01414 w
.60212 .63677 m
.6044 1.06108 L
s
P
p
1 0 .6 r
.01414 w
.60212 .63677 m
.42794 .93543 L
s
P
p
1 0 .6 r
.00707 w
.35034 1.1637 m
.26393 1.31238 L
s
P
p
1 0 .6 r
.01 w
.42794 .93543 m
.35034 1.1637 L
s
P
p
1 0 .6 r
.01 w
.42794 .93543 m
.26787 1.2099 L
s
P
p
1 0 .6 r
.00707 w
.26787 1.2099 m
.12105 1.46166 L
s
P
p
1 0 .6 r
.00707 w
.26787 1.2099 m
.13915 1.34152 L
s
P
p
1 0 .6 r
.01 w
.6044 1.06108 m
.60655 1.4607 L
s
P
p
1 0 .6 r
.01 w
.6044 1.06108 m
.74715 1.35588 L
s
P
p
1 0 .6 r
.00707 w
.74715 1.35588 m
.87666 1.62334 L
s
P
p
1 0 .6 r
.00707 w
.74715 1.35588 m
.89678 1.5045 L
s
P
p
1 0 .6 r
.00707 w
.60655 1.4607 m
.60857 1.83568 L
s
P
p
1 0 .6 r
.00707 w
.60655 1.4607 m
.56299 1.66904 L
s
P
p
1 g
.002 w
.8451 .04874 m
.88003 1.81918 L
s
.88003 1.81918 m
.04874 1.86925 L
s
.04874 1.86925 m
.09067 .1312 L
s
.09067 .1312 m
.8451 .04874 L
s
.8451 .04874 m
.88003 1.81918 L
s
.88003 1.81918 m
.95126 1.93048 L
s
.95126 1.93048 m
.9116 .23252 L
s
.9116 .23252 m
.8451 .04874 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 334}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000J]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H6000be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000HLH900;600C4a/H0</H1000005OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/@0
2P002LKFa]K6e/KFaP05a00c0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001>aPT02/H9a0?600C4aP00<LH1000004GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02@002MK6e/KFa]K6
eP0:a00>a]K6e/KFa]K6e/KFa=H2000aa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP010000>lH:00W62/@FaP03a00003760@00000be/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000:a]K6e/KFa=K6ePW401kFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KFa]K6e/H3a00c0<@0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000/aP03a00000<02/H9a1?600?4a/H02<H9a0;600C40<H0<<H10000
03?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/@0e/KFa]H02L@07]K6
e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/K4aPW403o6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002g600<0a<@00l@@aP03a<K600[6
2/@EaP040<K602o60@000017e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0<C6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]H02L@07MK6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KF00;403<0a<@0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@0002g600<0a0003/H9a1;60P09aPW40/H01034aP0_aP400000=MK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa=K6e/KF00W401[Fa]K6e/K4a]K6e/KFa]K6e/KFa]K6
e/KFaP@02<@0?]K6e/KFa]K6e/KF0<C6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002g600<0a/@01L@@aP03a<K600[61/@401?600D0a/C6000^aP400000BMK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa/C6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]H02L@01mK6e/KFa]H00P005LCFa]K6e/KFa]K6e/KFa]K6e/KF0003a00_0<C6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002g600D0a/K6a00>aPW4
4<H00co6a00;aPS400<0a/@00/H00`36aP0[aP400000=mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K40<KFa]H02L@07]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]Ho
e/K4aPW400S6e/KFa]K6eP<003340036e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000;LH00`36aP02aPG44<H00lC6aP0;aPC400<oa<@00/@6aP`01<H00`36aP0[aP40
0000C=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6a03Fa]K6
e/KFa]K6e/KFa]K6e/KFa/C6e/H9a005a]K6eSl00`000l@00004000ne/KFa]K6e/KFa]H0e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;LH00`36aP03aP03
a<K600g62L@3aPX000<oa/H04lH00`36aP02aP030<K602_60@00000je/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa/C6e/KFaPW400?6eP000`000l@00003001C
a]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002g600<0a/H01<H6a0/05<H00co6aP0CaP030<K600;6
00<0a/H0:lH1000003KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/@4001Xe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
;LH00`36aP05aP030<K6027600<oa/H04lH00`36aP02aP030<K602_60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002g600<0a/H01LH00`36aP0QaP03?lK601?6
00<0a/H00/H00`36aP0[aP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000/aP030<K600K600<0a/H08LH00co6aP0DaP050<K6aP00;LH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;<H00`36aP06aP030<K6027600<oa/H0
5<H01@36a/H002g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002c600<0a/H01/H00`36aP0QaP03?lK601C600D0a/K6000]aP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000/aP030<K600K600<0a/H08LH00co6aP0DaP05
0<K6aP00;LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
;<H00`36aP06aP030<K6027600<oa/H05<H00`36aP02aP030<K602[60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002c600<0a/H01/H00`36aP0QaP03?lK601C6
00<0a/H00/H00`36aP0ZaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000/aP030<K600K600<0a/H08LH00co6aP0DaP030<K600;600<0a/H0:/H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;<H00`36aP06aP030<K60276
00<oa/H05<H00`36aP02aP030<K602[60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002c600<0a/H01/H00`36aP0QaP03?lK601C600<0a/H00/H00`36aP0ZaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000/aP030<K600K6
00<0a/H08LH00co6aP0DaP030<K600;600<0a/H0:/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;<H00`36aP06aP030<K6027600<oa/H05<H00`36aP02aP03
0<K602[60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002c6
00<0a/H01/H00`36aP0QaP03?lK601C600<0a/H00/H00`36aP0ZaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000/aP030<K600K600<0a/H08LH00co6aP0DaP03
0<K600;600<0a/H0:/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000;<H00`36aP06aP030<K6023600=??lH05LH00`36aP02aP030<K602[60@00001He/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;<H00`36aP06aP030<K601o6
00<oaSl05/H00`36aP02aP030<K602[60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002c600<0a/H01/H00`36aP0NaP04ClK6?aK600<0a/H00/H00`36aP0ZaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000/aP030<K600G6
00<0a/H07/H01Co6a/Ho01K600<0a/H00/H00`36aP0ZaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000/aP030<K600G600<0a/H07LH00do6aP02aP03?lK601C6
00<0a/H00/H00`36aP0ZaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000/aP030<K600G600<0a/H06lH00do6aP04aP03?lK601C600<0a/H00/H00`36aP0ZaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000[aP030<K600K6
00<0a/H06/H00co6aP05aP03?lK601C600<0a/H00/H00`36aP0ZaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000[aP030<K600K600<0a/H06LH00do6aP06aP03
?lK601C600<0a/H00/H00`36aP0ZaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000[aP030<K600K600<0a/H06<H00co6aP07aP03?lK601C600<0a/H00/H00`36
aP0ZaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000[aP03
0<K600K600<0a/H05lH00do6aP09aP03ClK601?600<0a/H00/H00`36aP0ZaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000[aP030<K600K600<0a/H05/H00co6
aP0:aP03ClK601?600<0a/H00lH00`36aP0YaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000[aP030<K600K600<0a/H05<H00co6aP0<aP03ClK601?600<0a/H0
0lH00`36aP0YaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000[aP030<K600K600<0a/H04lH00do6aP0=aP03ClK601?600<0a/H00lH00`36aP0YaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000[aP030<K600K600<0a/H0
4/H00co6aP0>aP03ClK601C600<0a/H00/H00`36aP0YaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000[aP030<K600K600<0a/H04LH00dloaP0?aP03ClK601C6
00<0a/H00/H00`36aP0YaP400000AmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF008o05W6e/KFa]K6e/KFa]K6e/KFaSo6e/KF
a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP010000:lH00`36aP06aP030<K6013600<oClH04<H00do6aP0DaP030<K600;600<0a/H0
:LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:lH00`36
aP06aP030<K600o600=??lH04LH00do6aP0DaP030<K600;600<0a/H0:LH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]Ho
eSoFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:lH00`36aP06aP030<K600g600A?a/Ho
4/H00do6aP0DaP030<K600;600<0a/H0:LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000:lH00`36aP06aP030<K600c600@oa/I?4lH00do6aP0DaP030<K600;6
00<0a/H0:LH1000005[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K60<KFa]K6e/KFa]K6e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/H2?`16e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000[aP030<K600K600<0a/H02lH014o6aSlDaP03Cco601C600<0a/H00/H00`36aP0YaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6
e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000[aP030<K600K600<0a/H0
2/H01Co6a/Ho01C600=?aTl05<H00`36aP02aP030<K602W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKF?mK6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002_600<0a/H01/H00`36aP09aP05ClK6aTl05LH014o6
aSlCaP030<K600;600<0a/H0:LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]Hoe/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000:lH00`36aP06aP030<K600S600Doa/K6?`0FaP05ClK6aTl04/H00`36aP02aP03
0<K602W60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFaP36e/KFa]K6e/Hoa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002_6
00<0a/H01/H00`36aP06aP03?lK600;600=?a/H05LH00do6aP02aP03?lK600o600<0a/H00/H00`36
aP0YaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/H0a]K6e/KFa]Hoe/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KF?mK6e/KFa]K6e/KFa]K6
e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000[aP03
0<K600K600<0a/H01LH00do6aP02aP03?do601K600=?a/H00lH00do6aP0>aP030<K600;600<0a/H0
:LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
0<KFa]K6e/Hoa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/Hoa]K6e/KFa]K6e/KFa]K6
eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:/H00`36
aP07aP030<K600C600<oa/H00/H00dloaP0GaP03ClK600C600<oa/H03LH00`36aP02aP030<K602W6
0@00000je/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36
e/KFaP8o06KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6
eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:/H00`36
aP07aP030<K600;600<oClH00lH00cm?aP0HaP03ClK600G600=?a/H03<H00`36aP02aP030<K602W6
0@00000he/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36
e/H2?`1Xe/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFaSo6e/KFa]K6e/KFa]K6
eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:/H00`36
aP07aP060<K6?lHo1<H00do6C`0IaP03ClK600K600<oa/H02lH00`36aP02aP030<K602W60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36?lHoa]K6
eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF?mK6e/KFa]K6e/KFa]H0e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002[600<0a/H01lH01@0o
a/I?00C600<oaSl06/H00do6aP06aP03?lK600_600<0a/H00lH00`36aP0XaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/Hoa]Hoe/KFaSo6eSoFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/Hoa]K6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000ZaP030<K600K600@o0<I?1lH00do6
aP0IaP03ClK600O600=?a/H02/H00`36aP03aP030<K602S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/HoaP36?lKFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]Hoe/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002[600<0a/H01<H01Co6aP0o00S600=?a/H06LH00do6
aP08aP03?lK600W600<0a/H00lH00`36aP0XaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0?mK6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KFaSo6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000ZaP030<K600O600=?a/H01/H00co6aP0JaP03ClK600W600=??lH0
2<H00`36aP03aP030<K602S60@00001We/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF?`36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6eP02?`0ia]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000ZaP030<K600K600<o0<H09<H00do6aP0:aP03?lHo00O600<0a/H00lH00`36
aP0XaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
?lH0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6?lHoa]K6
e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000ZaP03
0<K600G600=?aP009LH00do6aP0;aP04ClK6?`G600<0a/H00lH00`36aP0XaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]Hoe/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6eSoFaSo6e/KF0=K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000ZaP030<K600?600E?a/K6000UaP03
ClK600c600Doa/K6?`03aP030<K600?600<0a/H0:<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/Hoa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6?lKFaSo6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:/H00`36aP02aP03?lK600;600<0a/H08lH00do6aP0=aP03
ClK600;600<oaP001LH00`36aP0XaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6e/KF?mK6e/Ho0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000ZaP030<K600O600<0a/H08lH00do6aP0>aP03?lK600?600<0a/H00lH00`36
aP0XaP400000FMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o04O6e/KFa]K6e/KFa]K6e/KF
aSo6e/KF03o6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
:/H00`36aP07aP030<K602;600<oClH04<H00do6aP02aP030<Ho00?600<0a/H0:<H1000005WFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`17a]K6e/KFa]K6e/KFa]K6e/Hoa]K6eP3Fa]K6eP3F
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002[600<0a/H01lH00`36
aP0RaP03?do6017600Doa/K60005aP030<K602S60@00001Ie/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00Sl0AlKFa]K6e/KFa]K6e/KFa]K6eSoFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K60040000ZaP030<K600O600<0a/H08LH00do6C`0CaP05ClK6aP00
1<H00`36aP0XaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFaP36e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000ZaP030<K600K600<0a/H08/H00do6C`0DaP04?lK600C600<0a/H0:<H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/H0a]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:/H00`36aP06aP030<K6027600@oa/I?
5LH00do60004aP030<K602S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFaSo60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002[600<0a/H01/H00`36aP0QaP04?lK6CaK600<o0<H00lH00`36aP0XaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000ZaP030<K600K600<0a/H0
8LH013o6aTlGaP030<K600;600<0a/H0:<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000:LH00`36aP07aP030<K6023600E?a/K6C`0GaP030<K600;600<0a/H0
:<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:LH00`36
aP07aP030<K602C600=?a/H05LH00`36aP02aP030<K602S60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002W600<0a/H01lH00`36aP0TaP03ClK601G600<0a/H0
0/H00`36aP0XaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000YaP030<K600O600<0a/H09<H00do6aP0EaP030<K600?600<0a/H09lH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000:LH00`36aP07aP030<K602C600=?a/H0
5LH00`36aP03aP030<K602O60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002W600<0a/H01lH00`36aP0TaP03ClK601G600<0a/H00lH00`36aP0WaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000YaP030<K600O600<0a/H0
9<H00do6aP0EaP030<K600?600<0a/H09lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000:LH00`36aP07aP030<K602C600=?a/H03<H:00G600<0a/H09lH10000
05OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H04P00>LKFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000:LH00`36aP07aP030<K600k64`0LaP03
0<K600;600<0a/H09lH1000003;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFaQ8005kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002W62@000lH0
aP0oaP050<K6aP00:LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H10000;<H00`36aP04aP030<K6043600<0aP00:LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000;/H00`36aP02aP030<K604760P0YaP400000KmK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0:000Ya]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00033600@0a/H0:/HA03?60@00001=e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H04@00A=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0003;60P08aQ40ELH1000003?Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02@00I]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP400000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0214573, -0.0133142, 
  0.00586621, 0.00586621}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.82321 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.357295 1.7366 0.043415 1.7366 [
[ 0 0 0 0 ]
[ 1 1.82321 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.82321 L
0 1.82321 L
closepath
clip
newpath
p
1 g
.002 w
.83765 .04342 m
.8718 1.59787 L
s
.8718 1.59787 m
.04342 1.64836 L
s
.04342 1.64836 m
.08661 .1264 L
s
.08661 .1264 m
.83765 .04342 L
s
.91719 .27181 m
.21267 .34435 L
s
.21267 .34435 m
.18444 1.77979 L
s
.18444 1.77979 m
.95658 1.73624 L
s
.95658 1.73624 m
.91719 .27181 L
s
.83765 .04342 m
.8718 1.59787 L
s
.8718 1.59787 m
.95658 1.73624 L
s
.95658 1.73624 m
.91719 .27181 L
s
.91719 .27181 m
.83765 .04342 L
s
.08661 .1264 m
.21267 .34435 L
s
.21267 .34435 m
.18444 1.77979 L
s
.18444 1.77979 m
.04342 1.64836 L
s
.04342 1.64836 m
.08661 .1264 L
s
p
.4 g
.842 .0559 m
.0935 .1383 L
s
P
p
.4 g
.8729 .14462 m
.14242 .22289 L
s
P
p
.4 g
.90224 .2289 m
.18895 .30334 L
s
P
p
.4 g
.71549 .05691 m
.80274 .28359 L
s
P
p
.4 g
.53354 .07702 m
.63218 .30116 L
s
P
p
.4 g
.35369 .09689 m
.46345 .31853 L
s
P
p
.4 g
.17591 .11653 m
.29655 .33571 L
s
P
P
p
1 0 .6 r
.02 w
.57738 .20888 m
.57881 .53476 L
s
P
p
1 g
.05 w
.57738 .20888 Mdot
P
p
1 0 .6 r
.005 w
.34603 1.06473 m
.34168 1.1457 L
s
P
p
1 0 .6 r
.005 w
.34603 1.06473 m
.30154 1.19605 L
s
P
p
1 0 .6 r
.00707 w
.39608 .91702 m
.34603 1.06473 L
s
P
p
1 0 .6 r
.01414 w
.57881 .53476 m
.58016 .84037 L
s
P
p
1 0 .6 r
.01414 w
.57881 .53476 m
.45246 .75062 L
s
P
p
1 0 .6 r
.00707 w
.39608 .91702 m
.33352 1.02421 L
s
P
p
1 0 .6 r
.01 w
.45246 .75062 m
.39608 .91702 L
s
P
p
1 0 .6 r
.005 w
.33352 1.02421 m
.30629 1.10485 L
s
P
p
1 0 .6 r
.005 w
.33352 1.02421 m
.27674 1.1215 L
s
P
p
1 0 .6 r
.01 w
.45246 .75062 m
.33675 .9483 L
s
P
p
1 0 .6 r
.00707 w
.33675 .9483 m
.23094 1.12906 L
s
P
p
1 0 .6 r
.00707 w
.33675 .9483 m
.24452 1.04073 L
s
P
p
1 0 .6 r
.005 w
.77666 1.24555 m
.79335 1.383 L
s
P
p
1 0 .6 r
.005 w
.23094 1.12906 m
.18581 1.26391 L
s
P
p
1 0 .6 r
.01 w
.58016 .84037 m
.58142 1.126 L
s
P
p
1 0 .6 r
.01 w
.58016 .84037 m
.68325 1.05294 L
s
P
p
1 0 .6 r
.00707 w
.68325 1.05294 m
.77666 1.24555 L
s
P
p
1 0 .6 r
.00707 w
.68325 1.05294 m
.79063 1.15793 L
s
P
p
1 0 .6 r
.005 w
.23094 1.12906 m
.13435 1.29409 L
s
P
p
1 0 .6 r
.005 w
.77666 1.24555 m
.86123 1.41994 L
s
P
p
1 0 .6 r
.005 w
.24452 1.04073 m
.15878 1.12664 L
s
P
p
1 0 .6 r
.005 w
.24452 1.04073 m
.18574 1.14086 L
s
P
p
1 0 .6 r
.005 w
.79063 1.15793 m
.88963 1.25472 L
s
P
p
1 0 .6 r
.005 w
.79063 1.15793 m
.84224 1.26416 L
s
P
p
1 0 .6 r
.00707 w
.58142 1.126 m
.5826 1.39213 L
s
P
p
1 0 .6 r
.00707 w
.58142 1.126 m
.54978 1.27033 L
s
P
p
1 0 .6 r
.005 w
.5826 1.39213 m
.54063 1.58323 L
s
P
p
1 0 .6 r
.005 w
.5826 1.39213 m
.58369 1.63935 L
s
P
p
1 0 .6 r
.005 w
.54978 1.27033 m
.51982 1.40697 L
s
P
p
1 0 .6 r
.005 w
.54978 1.27033 m
.45443 1.36904 L
s
P
p
1 g
.002 w
.83765 .04342 m
.8718 1.59787 L
s
.8718 1.59787 m
.04342 1.64836 L
s
.04342 1.64836 m
.08661 .1264 L
s
.08661 .1264 m
.83765 .04342 L
s
.83765 .04342 m
.8718 1.59787 L
s
.8718 1.59787 m
.95658 1.73624 L
s
.95658 1.73624 m
.91719 .27181 L
s
.91719 .27181 m
.83765 .04342 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 334}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000K=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaPH0033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000HlH90003a/C400;400<0a<H0;/H1000005[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H90003a/C400O400C6e/KF0P00;lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040001AaPT000?6a<@01l@2aP03a<K600S60P0_aP400000B=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaPT000?6a<@01l@05/KFa]K6e/KFa]K6a<KFa]K6e/KFa]H2000_a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003o62@000lK4a007a0?600?4a/H03/H00lC6
aP08aP030<H002k60@00000fe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K62@000lK4a007a01Ia]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa=K6e/KF
a]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002g6
2@000lK4a007a0?600?4a/H03lH00lC6aP0?aP03a<K600O600<0aP00;/H1000002SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61@000lK4a007a01[a]K6e/KFa]K6e/KFa=K6e/KF
a]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002S600<0a<@00l@4aP03a<K600o600?4a/H0
3lH00lC6aP0?aP03a<K600K600@0a/H0;LH1000002SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60P00B=K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6
e/CFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/K400;402h0a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002S600<0aP002<H00lC6aP0?aP03a<K600o600?4a/H03<H:a003
aP3600;600<0a/H0:/H1000005cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<H0a]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K4e/KFaP[403cFa]K4
e/KFa]K6eP3Fa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
:<H01036aP08aP03a<K600o600?4a/H02<H;a0k600?4a/H01<H00`36aP02aP030<K602W60@000016
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36eP3Fa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFaP_40576e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6eP3Fa]K60<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002S600D0a/K60008aP03a<K600G6
2l@?aP8000?4a/H03lH00lC6aP03aP030<K600;600<0a/H0:LH1000003?Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]H0e/KFa]H02/@06LKFa]K6e/KFa]K6a<KFa]K6e/KF
a]K6e/H01000B=K6e/KFa]K6e/KFa]K6e/KFa=K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000XaP030<K600;600<0a<@00l@3aP03a<K600o600?4a/H0
2lH40003a<K600k600?4a/H00lH00`36aP03aP030<K602S60@00001Ge/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/CFa]K6
e/KFa]K6e/KF008001[6a<KFa]K6e/KFa]K6e/KFa]K6a<KFa]H0ePC402/0a<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000XaP030<K600C600<0a/H01/H00lC6aP0>aP03
a<K600c600=?a/@03/H8a0030<C600C600<0a/H09lH1000005oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6
e/KFa]K6?lKFa=K6eP0:a00ia]K6e/CFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000XaP030<K600G600<0a/H01/H00lC6aP0>aP03a<K600S60l@00do4
a004a0k600?4a/H00/H00`36aP03aP030<K602O60@00001;e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KF00[401o6e/Ho
a]K6a<KFa]K6e/KFa]K6e/KFa]K4e/KFaP3600H002SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002S600<0a/H01/H00`36aP06aP03a<K600C62l@<aP05ClK6a/@03LH40003
a00000<01LH00`36aP0VaP400000=mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K60<KFa]H02/@08<KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6?lKFa/C6e/KF2@00>=K6
e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002S6
00<0a/H01lH5a0C600?4a/H03/H00lC6aP08aP0304l000<000C400004LH00`36aP04aP030<K602K6
0@00001>e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF0=K6
e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K42@00BlHoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF
a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100009lH00`36aP09aP03
0<K600K600?4a/H01LH900_600=?a/H05lH00`36aP04aP030<K602K60@00000je/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFaP<000?400001000G]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009lH00`36aP0;aPD07/H00do6aP0GaP03
0<K600C600<0a/H09/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100009lH00`36aP0;aP030<K6023600=?a/H05lH00`36aP04aP030<K602K60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H02lH00`36aP0PaP03
ClK601O600<0a/H01<H00`36aP0VaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000WaP030<K600_600<0a/H08<H00do6aP0GaP030<K600C600<0a/H09/H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009lH00`36aP0;aP03
0<K6023600=?a/H05lH00`36aP04aP030<K602K60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H02lH00`36aP0PaP03ClK601O600<0a/H01<H00`36
aP0VaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000WaP03
0<K600_600<0a/H08<H00do6aP0GaP030<K600G600<0a/H09LH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009lH00`36aP0;aP030<K6023600=?a/H05lH00`36
aP05aP030<K602G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002O600<0a/H02lH00`36aP0PaP03ClK601O600<0a/H01LH00`36aP0UaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000WaP030<K600_600<0a/H08<H00do6
aP0GaP030<K600G600<0a/H09LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100009lH00`36aP0;aP030<K601o600<oClH06<H00`36aP05aP030<K602G60@00001G
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o04W6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF
a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000WaP030<K600_6
00<0a/H07/H00do6C`0IaP030<K600G600<0a/H09LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100009lH00`36aP0:aP030<K601k600@oa/I?6LH00`36aP05aP03
0<K602G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O6
00<0a/H02/H00`36aP0MaP05ClK6aTl06LH00`36aP05aP030<K602G60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H02/H00`36aP0LaP03?lK600;6
00=?a/H05lH00`36aP05aP030<K602G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002O600<0a/H02/H00`36aP0JaP03?lK600C600=?a/H06<H00`36aP04aP03
0<K602G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O6
00<0a/H02/H00`36aP0IaP03ClK600G600=?a/H06<H00`36aP04aP030<K602G60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O600<0a/H02/H00`36aP0HaP03
?lK600K600=?a/H06<H00`36aP04aP030<K602G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002K600<0a/H02lH00`36aP0GaP03ClK600O600=?a/H06<H00`36
aP04aP030<K602G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002K600<0a/H02lH00`36aP0FaP03?lK600S600=?a/H06<H00`36aP04aP030<K602G60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002K600<0a/H02lH00`36
aP0EaP03ClK600W600=?a/H06<H00`36aP04aP030<K602G60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002K600<0a/H02lH00`36aP0DaP03?lK600[600=?a/H0
6<H00`36aP04aP030<K602G60@00001:e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`1Fe/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100009/H00`36aP0;aP030<K601?600=?a/H02lH00do6aP0HaP030<K600C600<0a/H0
9LH1000004WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KF008o05O6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002K6
00<0a/H02lH00`36aP0AaP03ClI?00g600=?a/H06<H00`36aP04aP030<K602G60@000018e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K60Sl0F=K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36aP0;aP030<K60136
00<oaSl03/H00do6aP0HaP030<K600G600<0a/H09<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6
e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36aP0;aP030<K600o600=?aTl03lH00dloaP0HaP03
0<K600G600<0a/H09<H1000005SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K60Sl0B=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000VaP030<K600_600<0a/H03/H013o6aTl?aP03ClI?01S600<0a/H01LH00`36aP0TaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000VaP030<K600_6
00<0a/H03LH014o6aSl@aP04ClK6?aO600<0a/H01LH00`36aP0TaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]Hoe/KF?mK6
e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000VaP030<K600_600<0a/H03<H013o6aTlAaP05
ClK6aTl05/H00`36aP05aP030<K602C60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFaSo6
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002K600<0a/H02lH00`36aP0;aP05ClK6?dl04LH00do6aP02aP03?lK601?6
00<0a/H01LH00`36aP0TaP400000A=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF?mK60Sl0G=K6e/KFa]K6e/KFa]K6e/KFaSo6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002K600<0a/H02lH00`36aP09aP06Cco6aTlo4/H00do6aP02aP03?lK601?600<0a/H0
1LH00`36aP0TaP400000?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6eP02?`1Qa]HoeSoFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/Hoa]K6e/KF
a]K6e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP0100009/H00`36aP0;aP030<K600O600=??lH00/H00cm?aP0BaP03ClK600?600=?a/H04/H00`36
aP05aP030<K602C60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFaP36e/KFa]K6eSoF?mK6?lHoa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]Hoe/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002K600<0a/H02lH00`36aP05aP03ClI?00;600@oa/I?4lH00do6aP04aP03?lK6017600<0a/H0
1LH00`36aP0TaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/H0a]K6e/KF?mHoe/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFaSo6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000VaP030<K600_600<0a/H00lH014o6aSl2aP04ClK6?aC600=?a/H01LH00do6aP0AaP030<K600C6
00<0a/H09<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K60<KFa]Hoe/Hoa]K6?lKF?mK6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
9/H00`36aP0;aP050<K6?dl00/H01So6a/HoC`;600<oa/H04/H00do6aP06aP03?lK6013600<0a/H0
1<H00`36aP0TaP400000H]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/H0aSo6?lKF?mK6eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K60Sl0?]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002K600<0a/H02/H01@36?lHo00;600I?a/K6Ccl2aP03ClK601?600=?a/H01lH00do6C`0?aP03
0<K600C600<0a/H09<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]H0?lHoa]K6?lKF?mHoe/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFa]Ho
eSoFa]K6e/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100009LH00`36aP0;aP04?lK6C`;600Xoa/K6?lHoaSm?5LH00do6aP08aP04?lK6C`g600<0a/H0
1<H00`36aP0TaP400000@MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6?`3F?mK6?lKFaSo6?lKF008o05o6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/Ho
a]Hoe/KFa]K6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP0100009LH00`36aP09aP04?lH0C`?600M?a/K6ClI?00;600<oClH05<H00do6aP09aP05ClK6aTl0
2lH00`36aP04aP030<K602C60@000010e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6?lKF03o6eSoFa]Hoe/KFaP8o063Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KFa]K6eSoFa]Hoe/KFa]K6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100009LH00`36aP07aP05?lK6aSl00/H00do6aP07aP03Cco601G600=?a/H02/H00co6
aP02aP03ClK600O600<0a/H01<H00`36aP0TaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6?`3FaSo6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/KFa]K6e/KFaSo6e/KF?mK6e/KFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000UaP030<K600_600@0aSm?2<H00co6?`0FaP03ClK600_600=?a/H0
0lH00do6aP05aP030<K600C600<0a/H09<H1000005OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0eSoFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0Sl0BLKFa]K6e/KFa]K6e/KF?mK6e/KF?mK6e/KFaP36e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0002G600<0a/H02lH00`1??`08aP03ClK601K600<oClH03LH00co6
aP03aP03?do600C600<0a/H01<H00`36aP0TaP400000EmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eSoF?mK6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP02?`0Ea]K6e/KFa]K6e/KFa]K6?lKFa]K6008o03;Fa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000UaP030<K600_600<oClH02<H00do6aP0FaP03?do600k6
00=?a/H00lH00do6C`03aP030<K600C600<0a/H09<H1000005OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaSl0?lKFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H00Sl0BLKFa]K6e/KFa]K6e/KFa]Hoe/KFa]HoeSoFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002G600<0a/H02/H00dl0C`0QaP03ClI?013600<oa/H0
0lH01So6aTo600O600<0a/H08lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6?lKFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6?lKF?`36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100009LH00`36aP09aP03?lHo02;600=?aTl04LH00do6aP03aP05ClK6aP001lH00`36
aP0SaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaSo6
eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KF?mK603oFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000UaP03
0<K600S600A?aTl08/H00do6C`0BaP03?lK600?600Hoa/H0aTl5aP030<K602?60@00001[e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]Hoe/Ho0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFaSo6e/KFa]K6e/KFa]K6e/KFa]H00Sl0=LKFa]K6?lH0a]K6e/KF
aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000UaP030<K600K600=?a/H0
0/H00`36aP0OaP05?lK6aSl04LH00cm?aP06aP030<K600G600<0a/H08lH1000005CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6?lKFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H2?`0Fe/KF?mK6e/KFa]K6e/KFa]K6e/KFaP8o03CFa]K6e/H0a]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H01LH00co6aP03aP03
0<K601g600<oaSl00lH00co6aP0@aP03Cco600G600<0a/H01LH00`36aP0SaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/HoaSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KFaSo6?lKFa]K60<KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000UaP030<K600_600<0a/H06lH013o6
aTl4aP03?lK6013600=?aTl01LH00`36aP05aP030<K602?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6?lKF?mK6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H02lH00`36aP0IaP03?lK600;600=?a/H0
0/H00co6aP0@aP05ClK6aTl00lH00`36aP05aP030<K602?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6?lKFaSo6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H02lH00`36aP0GaP03?lK600?600<oa/H0
0lH00co6aP0AaP05?lK6aSl00/H00`36aP05aP030<K602?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6eSoFa]Hoe/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H02lH00`36aP0MaP03?lK600?600<oa/H0
4LH00co6aP02aP03ClH000O600<0a/H08lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/HoaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100009LH00`36aP0;aP030<K601c600=?a/H01<H00co6aP0GaP03?`3600K6
00<0a/H08lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6eSoFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?`36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
9LH00`36aP0;aP030<K602?600<oa/H06<H00dl0aP05aP030<K602?60@00001He/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8o04SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009LH00`36aP0;aP030<K602;600=??lH0
6/H00`36aP04aP030<K602?60@00001He/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04SFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100009LH00`36aP0;aP030<K6027600<oaSl06lH00`36aP04aP030<K602?60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002C600<0a/H03<H00`36
aP0QaP03?lHo01_600<0a/H01<H00`36aP0SaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000TaP030<K600c600<0a/H08<H014o6aSlKaP030<K600C600<0a/H0
8lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36
aP0<aP030<K6023600A?a/Ho6lH00`36aP04aP030<K602?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002C600<0a/H03<H00`36aP0OaP05?lK6aSl06lH00`36
aP04aP030<K602?60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]Hoe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002C600<0a/H02lH00`36aP0PaP05?lK6aSl06lH00`36aP05aP030<K602;60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002C600<0a/H02lH00`36aP0OaP03
ClK600;600<oa/H06LH00`36aP05aP030<K602;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002C600<0a/H02lH00`36aP0TaP03?lK601762@07aP030<K602;6
0@00001Me/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF010003G6e/KFa]K6eP3Fa]K6e/KF
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100009<H00`36aP0;aP030<K601O6
4@0IaP030<K600C600<0a/H08/H1000003cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFaP36e/KFa]K6e/H@001Fe/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
9<H00`36aP05aQ007LH00co6aP0KaP030<K600?600<0a/H08/H1000002CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H8001fe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000VaP030<K600W600<0a/H0@lH00`36aP02aP030<K602;6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002S600<0a/H0
1lH00`36aP15aP040<K602C60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002[600<0a/H01LH00`36aP16aP030<H002C60@00000[e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02001ea]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=H0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000]aP030<K600;600<0a/H0AlH202C60@00001d
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H:000T
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002o600@0a/H0;/HC02k60@00001>
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K64`00@LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000aaP802<HC05C60@00000be/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9001Wa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0132076, -0.0250052, 
  0.00593155, 0.00593155}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.71606 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.309476 1.64683 0.0411708 1.64683 [
[ 0 0 0 0 ]
[ 1 1.71606 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.71606 L
0 1.71606 L
closepath
clip
newpath
p
1 g
.002 w
.83427 .04117 m
.86805 1.47969 L
s
.86805 1.47969 m
.04117 1.53049 L
s
.04117 1.53049 m
.08511 .12455 L
s
.08511 .12455 m
.83427 .04117 L
s
.91971 .29305 m
.22576 .36402 L
s
.22576 .36402 m
.19871 1.67489 L
s
.19871 1.67489 m
.95883 1.63233 L
s
.95883 1.63233 m
.91971 .29305 L
s
.83427 .04117 m
.86805 1.47969 L
s
.86805 1.47969 m
.95883 1.63233 L
s
.95883 1.63233 m
.91971 .29305 L
s
.91971 .29305 m
.83427 .04117 L
s
.08511 .12455 m
.22576 .36402 L
s
.22576 .36402 m
.19871 1.67489 L
s
.19871 1.67489 m
.04117 1.53049 L
s
.04117 1.53049 m
.08511 .12455 L
s
p
.4 g
.84973 .08674 m
.11051 .1678 L
s
P
p
.4 g
.87385 .15785 m
.15019 .23535 L
s
P
p
.4 g
.89691 .22583 m
.18817 .30002 L
s
P
p
.4 g
.91898 .2909 m
.22456 .36197 L
s
P
p
.4 g
.81075 .04379 m
.89797 .29527 L
s
P
p
.4 g
.51541 .07666 m
.6247 .32322 L
s
P
p
.4 g
.22605 .10886 m
.35654 .35065 L
s
P
P
p
1 0 .6 r
.00353 w
.37702 .97224 m
.37377 1.03046 L
s
P
p
1 0 .6 r
.02 w
.56613 .22075 m
.56711 .48164 L
s
P
p
1 g
.05 w
.56613 .22075 Mdot
P
p
1 0 .6 r
.00353 w
.37702 .97224 m
.35772 1.02918 L
s
P
p
1 0 .6 r
.005 w
.3807 .90628 m
.37702 .97224 L
s
P
p
1 0 .6 r
.00353 w
.34494 1.01203 m
.31307 1.1063 L
s
P
p
1 0 .6 r
.00353 w
.34494 1.01203 m
.30468 1.08113 L
s
P
p
1 0 .6 r
.005 w
.3807 .90628 m
.34494 1.01203 L
s
P
p
1 0 .6 r
.00707 w
.42086 .7875 m
.3807 .90628 L
s
P
p
1 0 .6 r
.00353 w
.34902 .93774 m
.32947 .99573 L
s
P
p
1 0 .6 r
.01414 w
.56711 .48164 m
.56803 .72502 L
s
P
p
1 0 .6 r
.01414 w
.56711 .48164 m
.46602 .65394 L
s
P
p
1 0 .6 r
.00707 w
.42086 .7875 m
.37087 .87291 L
s
P
p
1 0 .6 r
.01 w
.46602 .65394 m
.42086 .7875 L
s
P
p
1 0 .6 r
.00353 w
.34902 .93774 m
.32442 .97982 L
s
P
p
1 0 .6 r
.005 w
.37087 .87291 m
.34902 .93774 L
s
P
p
1 0 .6 r
.005 w
.37087 .87291 m
.32555 .95036 L
s
P
p
1 0 .6 r
.01 w
.46602 .65394 m
.37364 .81137 L
s
P
p
1 0 .6 r
.00353 w
.32555 .95036 m
.28448 1.02052 L
s
P
p
1 0 .6 r
.00353 w
.32555 .95036 m
.28982 .98633 L
s
P
p
1 0 .6 r
.00353 w
.73827 1.15836 m
.75031 1.25665 L
s
P
p
1 0 .6 r
.00353 w
.25314 1.06327 m
.22087 1.15973 L
s
P
p
1 0 .6 r
.00707 w
.37364 .81137 m
.28935 .95502 L
s
P
p
1 0 .6 r
.00707 w
.37364 .81137 m
.30044 .88374 L
s
P
p
1 0 .6 r
.00353 w
.73827 1.15836 m
.77468 1.23348 L
s
P
p
1 0 .6 r
.005 w
.72472 1.04781 m
.73827 1.15836 L
s
P
p
1 0 .6 r
.00353 w
.25314 1.06327 m
.21154 1.13432 L
s
P
p
1 0 .6 r
.005 w
.28935 .95502 m
.25314 1.06327 L
s
P
p
1 0 .6 r
.01 w
.56803 .72502 m
.56889 .95137 L
s
P
p
1 0 .6 r
.01 w
.56803 .72502 m
.65027 .89444 L
s
P
p
1 0 .6 r
.00707 w
.65027 .89444 m
.72472 1.04781 L
s
P
p
1 0 .6 r
.00707 w
.65027 .89444 m
.73558 .97698 L
s
P
p
1 0 .6 r
.005 w
.28935 .95502 m
.21254 1.08593 L
s
P
p
1 0 .6 r
.005 w
.72472 1.04781 m
.79208 1.18657 L
s
P
p
1 0 .6 r
.00353 w
.79208 1.18657 m
.85299 1.31204 L
s
P
p
1 0 .6 r
.00353 w
.79208 1.18657 m
.86267 1.25625 L
s
P
p
1 0 .6 r
.00353 w
.21254 1.08593 m
.14263 1.20508 L
s
P
p
1 0 .6 r
.00353 w
.21254 1.08593 m
.15072 1.14844 L
s
P
p
1 0 .6 r
.005 w
.30044 .88374 m
.23268 .95072 L
s
P
p
1 0 .6 r
.005 w
.30044 .88374 m
.25374 .96313 L
s
P
p
1 0 .6 r
.005 w
.73558 .97698 m
.81398 1.05284 L
s
P
p
1 0 .6 r
.005 w
.73558 .97698 m
.77664 1.06143 L
s
P
p
1 0 .6 r
.00353 w
.77664 1.06143 m
.8137 1.13764 L
s
P
p
1 0 .6 r
.00353 w
.77664 1.06143 m
.81942 1.10306 L
s
P
p
1 0 .6 r
.00707 w
.56889 .95137 m
.56968 1.16128 L
s
P
p
1 0 .6 r
.00707 w
.56889 .95137 m
.54354 1.06337 L
s
P
p
1 0 .6 r
.00353 w
.25374 .96313 m
.21143 1.03508 L
s
P
p
1 0 .6 r
.00353 w
.25374 .96313 m
.2166 1.00009 L
s
P
p
1 0 .6 r
.00353 w
.53634 1.31358 m
.56585 1.41228 L
s
P
p
1 0 .6 r
.00353 w
.81398 1.05284 m
.88589 1.12243 L
s
P
p
1 0 .6 r
.00353 w
.81398 1.05284 m
.87325 1.06917 L
s
P
p
1 0 .6 r
.00353 w
.53634 1.31358 m
.50647 1.45 L
s
P
p
1 0 .6 r
.00353 w
.23268 .95072 m
.17012 1.01257 L
s
P
p
1 0 .6 r
.00353 w
.23268 .95072 m
.19155 .96078 L
s
P
p
1 0 .6 r
.005 w
.56968 1.16128 m
.53634 1.31358 L
s
P
p
1 0 .6 r
.005 w
.56968 1.16128 m
.57041 1.35545 L
s
P
p
1 0 .6 r
.005 w
.54354 1.06337 m
.51971 1.16869 L
s
P
p
1 0 .6 r
.005 w
.54354 1.06337 m
.46793 1.14012 L
s
P
p
1 0 .6 r
.00353 w
.57041 1.35545 m
.57109 1.53462 L
s
P
p
1 0 .6 r
.00353 w
.57041 1.35545 m
.63835 1.46784 L
s
P
p
1 0 .6 r
.00353 w
.46793 1.14012 m
.39842 1.21068 L
s
P
p
1 0 .6 r
.00353 w
.46793 1.14012 m
.45406 1.19844 L
s
P
p
1 0 .6 r
.00353 w
.51971 1.16869 m
.49739 1.26737 L
s
P
p
1 0 .6 r
.00353 w
.51971 1.16869 m
.5598 1.2292 L
s
P
p
1 g
.002 w
.83427 .04117 m
.86805 1.47969 L
s
.86805 1.47969 m
.04117 1.53049 L
s
.04117 1.53049 m
.08511 .12455 L
s
.08511 .12455 m
.83427 .04117 L
s
.83427 .04117 m
.86805 1.47969 L
s
.86805 1.47969 m
.95883 1.63233 L
s
.95883 1.63233 m
.91971 .29305 L
s
.91971 .29305 m
.83427 .04117 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 334}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000K]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K61P00;]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000ILH900?600?4aP00;/H1000005_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00X000k6e/KFa]K6e/KFa]K6a08002g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0005762P0GaP03a00002g60@000018e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K62@008<K4a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0/@2000]a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000naPX02lH00lC6aP0BaPW40/H00`36000/aP400000==K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H:000Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa=K6e/KFa]K6e/KFaPS403[Fa]K6e/KFa]K6eP3F0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002_62@000lC6aP0LaP04a<K6aPW44lH00`36000/aP40
00009]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K61@008lKFa]K6e/KFa/C6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K600W404_6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0<C60<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002K600<0a/H03<H00lC6
aP0>aPS41/H00lC6aP0LaP040<C602_60@00000Ve/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H2000Ee/KFa]K6e/KFa]K6e/CFa]K6e/KF00W405cFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0a<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000VaP803LH8a1S600?4a/H06lH01@36a<H002[60@00000/e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/H9a00oa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/@000?402/0e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000VaP030<K400?42lH00lC6aP0LaP03a<K60136
2L@01/H0a/C602[60@00001Pe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0
e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K62L@0>LKF
a]K6e/KFa]H0e/K4aP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
9/H01@36a/H000g600?4a/H06lH:a1?600H0a/K4aP0YaP400000CMK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KF00W4
0`00BLKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6a<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0002K600<0a/H00/H00`36aP0;aP03a<K600O62/@8aPD06LH01`36
a/K4aP00:<H1000003[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KF0=K6
e/KFa]K6e/KFa]K62L@04/KFa]K6e/KFa]K6e/KFa]K6ePD004SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/CF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009/H00`36
aP03aP030<K600;62/@JaPD06LH00`34a003a0030<K602K60@00000/e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H5a00Ua]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP03000@a=K6e/KFa]K6e/KFa]K6eP[402l0e/KFa/C60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100009/H00`36aP04aP030<K600c600?4a/H05lH014loa/@5aP[4
2/H00`36aP02aP03a<H002O60@00001De/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60/@2?`O404?6e/KF
a]K6e/KFa]K6e/KFa]K6eP3Fa]K6a<H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000UaP030<K600K600<0a/H03<H00lC6aP0:aP[40/H01Dloa/K401S600<0a/H00lH00lC6
000VaP400000@=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K4e/H:a00<e/KFa]K6e/KFa]K60Sl0B]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/CF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H0
1lH00`36aP03aP_45/H00dloaP02aP03a<K601G600<0a/H00lH00lC6000VaP400000<=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaPG40276e/KFa]K6e/K4a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00Sl07mK6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H01L@09P36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H02<H00`36aP0<aP03
a<K601C600=??lH00lH00lC6aP0>aPO400<0a<@01LH00`36aP0SaP400000E]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60Sl02]K6e/K4a]K6e/H;a00ea]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002G600<0a/H02LH00`36aP0<aP03a<K601?600=??l@0
2L@BaP030<K600G600<0a/H08lH1000004kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/H8a08o04[Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000UaP030<K600_600<0a/H02lH00lC6a00:a0S600=??lH06lH00`36aP05aP030<K602?6
0@00000ie/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF0=K6
e/KF00[401?6e/KFa]K6e/KFa]K6e/KFa]K6008o04[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000UaP030<K600c6
1L@MaP03Cco601_600<0a/H01LH00`36aP0SaP400000E]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H03<H00`36aP0OaP03Cco601_600<0a/H01LH00`36
aP0SaP400000E]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G6
00<0a/H03<H00`36aP0OaP03Cco601_600<0a/H01LH00`36aP0SaP400000E]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H03<H00`36aP0OaP03Cco601_6
00<0a/H01LH00`36aP0SaP400000E]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0B]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002G600<0a/H03<H00`36aP0OaP03Cco601_600<0a/H01LH00`36aP0SaP400000E]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H03<H00`36
aP0OaP03Cco601_600<0a/H01LH00`36aP0SaP400000E]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H03<H00`36aP0OaP03Cco601_600<0a/H01/H00`36
aP0RaP400000E]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G6
00<0a/H03<H00`36aP0OaP03Cco601_600<0a/H01/H00`36aP0RaP400000E]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002G600<0a/H03<H00`36aP0NaP03?lHo01c6
00<0a/H01/H00`36aP0RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000UaP030<K600c600<0a/H07LH014o6aSlLaP030<K600K600<0a/H08/H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36aP0=aP030<K601c6
00Doa/K6?`0LaP030<K600K600<0a/H08/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100009<H00`36aP0=aP030<K601_600=?a/H00/H00co6aP0JaP030<K600K6
00<0a/H08/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
9<H00`36aP0<aP030<K601_600<oa/H00lH00co6aP0JaP030<K600K600<0a/H08/H100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36aP0<aP030<K601W6
00<oa/H01/H00do6aP0IaP030<K600K600<0a/H08/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6
e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36aP0<aP030<K601S600=?a/H01lH00do6aP0IaP03
0<K600K600<0a/H08/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100009<H00`36aP0<aP030<K601O600<oa/H02<H00do6aP0IaP030<K600K600<0a/H08/H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H00`36aP0<aP03
0<K601K600=?a/H02LH00do6aP0IaP030<K600K600<0a/H08/H1000004_Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0Sl0ELKFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002C600<0a/H03<H00`36aP0EaP03?do600[6
00=?a/H06LH00`36aP06aP030<K602;60@00001:e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`1Fe/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100009<H00`36aP0<aP030<K601C600=??lH02lH00do6aP0IaP030<K600K6
00<0a/H08/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
9<H00`36aP0<aP030<K601;600=?aTl03LH00do6aP0IaP030<K600K600<0a/H08/H1000005SFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K60Sl0B=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000TaP030<K600c600<0a/H0
4LH013o6aTl=aP03Cco601W600<0a/H01/H00`36aP0RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFa]K6
e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000TaP030<K600c600<0a/H04<H014o6aSl>aP03ClI?01[6
00<0a/H01LH00`36aP0RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eSoFa]Hoe/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000TaP030<K600c600<0a/H03lH013o6aTl?aP04ClK6?aW600<0a/H01LH00`36aP0RaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000TaP030<K600c6
00<0a/H03LH01Co6a/Ho013600E?a/K6C`0HaP030<K600K600<0a/H08LH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF?mK6
eSoFa]K6e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0=aP030<K600c600I?a/K6
Ccl@aP03ClK600;600<oa/H05LH00`36aP06aP030<K602760@000011e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]H00Sl0GlKF?co6e/KF
a]K6e/KFa]K6e/KFaSo6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000SaP030<K600g600<0a/H02/H00dloaP02aP03
?do6013600=?a/H00lH00do6aP0DaP030<K600K600<0a/H08LH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]HoeSoFaSo6?lKFa]K6
e/KFa]K6e/KFa]K6?lKFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0=aP030<K600S600=?aTl00lH00dlo
aP0AaP03ClK600?600=?a/H05<H00`36aP06aP030<K602760@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eSoFaSo6eSoF?mK6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H03LH00`36aP06aP04ClK6?`?600<oaSl0
4/H00do6aP04aP03?lK601?600<0a/H01/H00`36aP0QaP400000>mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF008o02?6?lKFaSo6?lKFa]K6e/KF
a]K6e/KFa]K6e/Hoa]K6e/KFaP02?`10e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000SaP030<K600g600<0a/H01<H01Dloa/I?00?6
00=?aTl04lH00do6aP05aP03ClI?01;600<0a/H01/H00`36aP0QaP400000>MK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6eP02?`06a]Hoe/KF0Sl0GlHo
a]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000SaP030<K600g600<0a/H00/H00do6
C`02aP05?lK6aSl00/H00do6aP0AaP03ClK600K600@oa/I?4<H00`36aP06aP030<K602760@000010
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF0=K6eSoF?mK6
?lKFaP8o063F?co6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0=aP04
0<K6C`;600@oa/I?0lH01DloaSm?01?600=?a/H01lH01Do6a/I?00k600<0a/H01/H00`36aP0QaP40
0000<mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP03?`08
e/Hoa]Hoe/H3?`1Qa]Ho?lKFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6eSoFa]Hoe/KFa]K6e/KF
a]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008lH00`36
aP0;aP03?dlo00?600hoa/K6?lHoaSm?aTo6Ca?600=?a/H02<H00co6aP02aP03ClK600[600<0a/H0
1/H00`36aP0QaP400000=]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6?`3FaP8o00KFaSo6?lH3?`1QaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]K6e/Ho
a]K6eSoFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP0100008lH00`36aP0;aP06?lH0aSm?0lH01TloaSm??`;600=?aTl04/H00cm?aP0:aP03ClK600;6
00<oClH02LH00`36aP06aP030<K602760@00000ie/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6?lKF03o6?lKF008o00O6?lKF?mK600<o01;6e/KFa]K6e/KFa]K6e/KF
a]H2?`0Aa]K6e/KFa]K6e/KF?mK6e/H00Sl0=]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000SaP030<K600W600Loa/K6?lHo00;600E??lK6C`04aP04
?lHoCa;600<oClH02lH00co6aP02aP03ClI?00S600<0a/H01/H00`36aP0QaP400000>=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/Hoa]K6eP0oa]K60Sl0J=Hoe/KFa]Ho
eSoFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6?lKFa]HoeSoFa]K6e/KF0=K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H03<H00`36C`02aP04
?lHoC`K600<oCcl04/H00do6C`0=aP03ClK600;600@oa/I?1/H00`36aP06aP030<K602760@00000g
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H0?mK6eP02?`09
a]K6e/KFaSo6008o05kFa]K6e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6eSoFa]Hoe/KF?mK6
e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H0
3<H01`36a/I?aTl01/H00cm?aP0DaP03ClI?00k600<oa/H00/H01Do6a/I?00C600<0a/H01/H00`36
aP0QaP400000LMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
0<KFaSo6?lKFa]K6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K6?lKFaSo6
e/KF00<o02kF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?6
00<0a/H03<H01P36aSo6?`K600=??lH05<H013o6aTl?aP03ClK600;600<oa/H00/H01Do6C`1?00O6
00<0a/H08LH1000005CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFaP36?lKF?mK6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0Be/Hoa]K6e/KFa]K6e/KFa]K6
0Sl00mK6eP02?`0ca]K6eSoF0=Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000SaP030<K600c600H0aTo6Ccl4aP03ClI?01C600<oaSl00/H00do6aP0=aP03Cco600?6
00=??lH00lH00dl0aP07aP030<K602760@00000be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/H2?`1^e/Hoa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6?lKF?mK6
?lKFa]K6e/KFa]K6e/KFaSo6?lKFaSo6?lKFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008lH00`36aP0;aP06?`0oaSm?1lH00do6aP0@aP04?lK6C`?600=?a/H0
3LH00do6C`04aP03?lHo00?600<0ClH01/H00`36aP0QaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaSo6?lHoaSo6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
?lKFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6eSoF?mK6eSoFa]K6eP3F?mK6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000RaP030<K600[600Loa/I?aTlo01W600<oa/H00/H01Do6
a/I?013600<oaSl01<H00do6aP02aP040<K6C`G600<0a/H08LH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6?lKF?`0oeSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/Hoa]K6e/Hoa]K6?lKFa]K6e/KFa]K6e/KFa]Hoe/Hoa]K6?lKFa]H0e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36aP08aP06?lK6ClH00/H00co6aP0EaP03
?lK600C600E?a/K6C`0@aP04?lK6C`C600Doa/K60009aP030<K602360@00001<e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/Hoa]K6?lH0aSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP8o05CFa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]H0e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36aP0:aP06?lK60<I?5/H00co6
?`05aP03?lK600;600=?a/H03/H01Co6a/Ho00O600<0a/H01lH00`36aP0PaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF?mK60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKF?mK6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6eSoFa]K6?lKFa]K6eP3Fa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000RaP030<K600W600E?a/K6000FaP04
?lK6C`K600<oa/H00/H00do6aP0>aP03?do600;600=?a/H01<H00`36aP07aP030<K602360@00001C
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KF?mK6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]H00Sl05<KF?co6e/KFa]K6e/KFa]K6e/KF0Sl0=lKFa]Hoe/KF
a]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002;600<0a/H0
2<H00co6aP02aP030<K601;600<oa/H00/H00do6aP03aP07ClK6?lHoC`0@aP03?lHo00?600<oClH0
0lH00`36aP07aP030<K602360@00001Ge/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/Hoa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFaSo6eSoF008o01O6e/KF
a]K6e/KFa]K6e/KF?mHoe/KFaP02?`0`e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002;600<0a/H03LH00`36aP0MaP07ClK6aTloC`0AaP03ClI?00?600=?aTl0
0/H00`36aP07aP030<K602360@00001Fe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/H3?`19a]K6e/KF
a]K6e/KFa]K6e/HoaSo6e/KF?mHoeP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100008/H00`36aP0=aP030<K601c600<oa/H00/H00do6C`0AaP04ClK6?`?600Doa/I?
0009aP030<K602360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/HoaSo6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6?lKF?`36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002;600<0a/H03LH00`36aP0KaP03ClK600?600=?aTl04LH00do6aP05aP05ClK6aP002<H00`36
aP0PaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000RaP03
0<K600g600<0a/H08<H013o6aTlJaP04?lK600S600<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK60<KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36aP0=aP030<K6023600@oa/I?6lH00do6
0008aP030<K602360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/HoaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002;600<0a/H03LH00`36aP0OaP05ClK6aTl07<H00cl0aP07aP030<K602360@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6?lKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H03LH00`36aP0OaP05
ClK6aTl07LH00`36aP06aP030<K602360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002;600<0a/H03LH00`36aP0NaP03?lHo00;600=?a/H06lH00`36aP06aP03
0<K602360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;6
00<0a/H03LH00`36aP0NaP07?lK6ClI??`0LaP030<K600K600<0a/H08<H1000005SFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eSoFaSo60Sl0B=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600k600<0a/H07LH02Do6
a/I?aTo6C`0KaP030<K600K600<0a/H08<H1000005OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]H0
0Sl0BLKF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@00027600<0a/H03/H00`36aP0MaP03ClK600;600DoClK6?`0JaP03
0<K600K600<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6?lKFaSo6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008LH00`36aP0>aP030<K601g600=?a/H00lH01Do6a/I?01W600<0a/H01/H00`36aP0PaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/Hoa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600k6
00<0a/H07<H00co6aP04aP03ClK600?600=?a/H05LH00`36aP06aP030<K602360@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H03LH00`36aP0TaP03
ClK600C600<oa/H05<H00`36aP06aP030<K602360@00001^e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000[a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100008LH00`36aP0=aP030<K602C600=?a/H00/HA00S600<0a/H01lH00`36
aP0OaP400000C=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HA0015a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF
a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000QaP030<K600g600<0a/H0
1lHA00c600=?a/H07LH00`36aP05aP030<K601o60@00000Ze/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K64@00IlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0002762@07aP030<K602C600=?a/H07/H00`36aP04aP030<K601o60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002C600<0a/H02/H00`36aP16aP03
0<K600?600<0a/H07lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100009/H00`36aP08aP030<K604O600<0a/H00/H00`36aP0OaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000XaP030<K600K600<0a/H0BLH01036aP0QaP40
0000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000ZaP030<K600C6
00<0a/H0B/H00`36000QaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000/aP030<K600;600<0a/H0BlH202760@00001fe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP/00276e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0002k600@0a/H0<<HD02c60@00001?e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0C0010
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000`aP802LHD05?60@00000ae/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP0:001Wa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP010000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0146661, -0.0250052, 
  0.00588728, 0.00588728}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.65024 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.279982 1.59201 0.0398002 1.59201 [
[ 0 0 0 0 ]
[ 1 1.65024 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.65024 L
0 1.65024 L
closepath
clip
newpath
p
1 g
.002 w
.83262 .0398 m
.86622 1.40706 L
s
.86622 1.40706 m
.0398 1.45812 L
s
.0398 1.45812 m
.08424 .12352 L
s
.08424 .12352 m
.83262 .0398 L
s
.9213 .3062 m
.23423 .37614 L
s
.23423 .37614 m
.20792 1.61044 L
s
.20792 1.61044 m
.9602 1.56854 L
s
.9602 1.56854 m
.9213 .3062 L
s
.83262 .0398 m
.86622 1.40706 L
s
.86622 1.40706 m
.9602 1.56854 L
s
.9602 1.56854 m
.9213 .3062 L
s
.9213 .3062 m
.83262 .0398 L
s
.08424 .12352 m
.23423 .37614 L
s
.23423 .37614 m
.20792 1.61044 L
s
.20792 1.61044 m
.0398 1.45812 L
s
.0398 1.45812 m
.08424 .12352 L
s
p
.4 g
.83371 .04305 m
.08606 .12659 L
s
P
p
.4 g
.85462 .10589 m
.12138 .18607 L
s
P
p
.4 g
.87469 .16619 m
.15531 .24323 L
s
P
p
.4 g
.89398 .22412 m
.18794 .29818 L
s
P
p
.4 g
.91251 .2798 m
.21933 .35105 L
s
P
p
.4 g
.75609 .04836 m
.85119 .31334 L
s
P
p
.4 g
.50442 .07652 m
.62038 .33683 L
s
P
p
.4 g
.25734 .10415 m
.39344 .35993 L
s
P
P
p
1 0 .6 r
.0025 w
.39613 .91607 m
.40729 .93282 L
s
P
p
1 0 .6 r
.0025 w
.39613 .91607 m
.3936 .96041 L
s
P
p
1 0 .6 r
.00353 w
.39899 .86603 m
.39613 .91607 L
s
P
p
1 0 .6 r
.0025 w
.38257 .91454 m
.38109 .94161 L
s
P
p
1 0 .6 r
.0025 w
.34472 .97975 m
.34255 1.02402 L
s
P
p
1 0 .6 r
.0025 w
.38257 .91454 m
.36786 .958 L
s
P
p
1 0 .6 r
.02 w
.5595 .22825 m
.56024 .44937 L
s
P
p
1 g
.05 w
.5595 .22825 Mdot
P
p
1 0 .6 r
.0025 w
.34472 .97975 m
.32051 1.05148 L
s
P
p
1 0 .6 r
.00353 w
.39899 .86603 m
.38257 .91454 L
s
P
p
1 0 .6 r
.005 w
.40222 .80944 m
.39899 .86603 L
s
P
p
1 0 .6 r
.00353 w
.37184 .89945 m
.34472 .97975 L
s
P
p
1 0 .6 r
.00353 w
.37184 .89945 m
.33774 .95782 L
s
P
p
1 0 .6 r
.005 w
.40222 .80944 m
.37184 .89945 L
s
P
p
1 0 .6 r
.0025 w
.33774 .95782 m
.32299 1.00162 L
s
P
p
1 0 .6 r
.0025 w
.33774 .95782 m
.30689 1.01064 L
s
P
p
1 0 .6 r
.0025 w
.35885 .88504 m
.35745 .91264 L
s
P
p
1 0 .6 r
.00707 w
.43631 .70847 m
.40222 .80944 L
s
P
p
1 0 .6 r
.0025 w
.35885 .88504 m
.34397 .92922 L
s
P
p
1 0 .6 r
.00353 w
.37546 .83571 m
.35885 .88504 L
s
P
p
1 0 .6 r
.01414 w
.56024 .44937 m
.56092 .65486 L
s
P
p
1 0 .6 r
.01414 w
.56024 .44937 m
.47459 .59507 L
s
P
p
1 0 .6 r
.00707 w
.43631 .70847 m
.394 .78062 L
s
P
p
1 0 .6 r
.01 w
.47459 .59507 m
.43631 .70847 L
s
P
p
1 0 .6 r
.00353 w
.37546 .83571 m
.35464 .87125 L
s
P
p
1 0 .6 r
.005 w
.394 .78062 m
.37546 .83571 L
s
P
p
1 0 .6 r
.0025 w
.71525 1.10515 m
.70028 1.14894 L
s
P
p
1 0 .6 r
.0025 w
.35464 .87125 m
.3456 .89813 L
s
P
p
1 0 .6 r
.0025 w
.26713 1.02302 m
.26548 1.06797 L
s
P
p
1 0 .6 r
.0025 w
.35464 .87125 m
.33585 .90333 L
s
P
p
1 0 .6 r
.0025 w
.71525 1.10515 m
.72445 1.17972 L
s
P
p
1 0 .6 r
.005 w
.394 .78062 m
.35568 .84599 L
s
P
p
1 0 .6 r
.0025 w
.26713 1.02302 m
.24265 1.09623 L
s
P
p
1 0 .6 r
.01 w
.47459 .59507 m
.39646 .72801 L
s
P
p
1 0 .6 r
.00353 w
.35568 .84599 m
.32097 .90517 L
s
P
p
1 0 .6 r
.00353 w
.35568 .84599 m
.32556 .87597 L
s
P
p
1 0 .6 r
.0025 w
.32097 .90517 m
.30601 .9498 L
s
P
p
1 0 .6 r
.00353 w
.70494 1.02148 m
.71525 1.10515 L
s
P
p
1 0 .6 r
.00353 w
.29454 .94103 m
.26713 1.02302 L
s
P
p
1 0 .6 r
.0025 w
.32097 .90517 m
.28957 .95872 L
s
P
p
1 0 .6 r
.0025 w
.73571 1.08491 m
.74126 1.13044 L
s
P
p
1 0 .6 r
.00707 w
.39646 .72801 m
.32528 .84912 L
s
P
p
1 0 .6 r
.00707 w
.39646 .72801 m
.3348 .78838 L
s
P
p
1 0 .6 r
.0025 w
.32556 .87597 m
.29813 .90328 L
s
P
p
1 0 .6 r
.0025 w
.32556 .87597 m
.30653 .9084 L
s
P
p
1 0 .6 r
.00353 w
.70494 1.02148 m
.73571 1.08491 L
s
P
p
1 0 .6 r
.005 w
.69335 .92748 m
.70494 1.02148 L
s
P
p
1 0 .6 r
.00353 w
.29454 .94103 m
.25943 1.00088 L
s
P
p
1 0 .6 r
.005 w
.32528 .84912 m
.29454 .94103 L
s
P
p
1 0 .6 r
.01 w
.56092 .65486 m
.56155 .84532 L
s
P
p
1 0 .6 r
.01 w
.56092 .65486 m
.63045 .79799 L
s
P
p
1 0 .6 r
.0025 w
.25943 1.00088 m
.24451 1.0456 L
s
P
p
1 0 .6 r
.0025 w
.73571 1.08491 m
.76347 1.14212 L
s
P
p
1 0 .6 r
.0025 w
.25943 1.00088 m
.22766 1.05504 L
s
P
p
1 0 .6 r
.00707 w
.63045 .79799 m
.69335 .92748 L
s
P
p
1 0 .6 r
.00707 w
.63045 .79799 m
.70236 .86706 L
s
P
p
1 0 .6 r
.005 w
.32528 .84912 m
.26049 .95935 L
s
P
p
1 0 .6 r
.0025 w
.80164 1.1504 m
.81056 1.22589 L
s
P
p
1 0 .6 r
.005 w
.69335 .92748 m
.75023 1.04457 L
s
P
p
1 0 .6 r
.00353 w
.75023 1.04457 m
.80164 1.1504 L
s
P
p
1 0 .6 r
.00353 w
.75023 1.04457 m
.8096 1.10265 L
s
P
p
1 0 .6 r
.00353 w
.26049 .95935 m
.20159 1.05956 L
s
P
p
1 0 .6 r
.00353 w
.26049 .95935 m
.20864 1.01118 L
s
P
p
1 0 .6 r
.0025 w
.80164 1.1504 m
.84808 1.246 L
s
P
p
1 0 .6 r
.0025 w
.20159 1.05956 m
.1769 1.13402 L
s
P
p
1 0 .6 r
.005 w
.3348 .78838 m
.27789 .8441 L
s
P
p
1 0 .6 r
.005 w
.3348 .78838 m
.29543 .85521 L
s
P
p
1 0 .6 r
.0025 w
.76826 1.00252 m
.7738 1.04896 L
s
P
p
1 0 .6 r
.005 w
.70236 .86706 m
.7683 .9304 L
s
P
p
1 0 .6 r
.005 w
.70236 .86706 m
.737 .93827 L
s
P
p
1 0 .6 r
.00353 w
.737 .93827 m
.76826 1.00252 L
s
P
p
1 0 .6 r
.00353 w
.737 .93827 m
.77297 .97301 L
s
P
p
1 0 .6 r
.00707 w
.56155 .84532 m
.56214 1.02138 L
s
P
p
1 0 .6 r
.00707 w
.56155 .84532 m
.54007 .93818 L
s
P
p
1 0 .6 r
.0025 w
.20159 1.05956 m
.1481 1.15057 L
s
P
p
1 0 .6 r
.00353 w
.29543 .85521 m
.25979 .91573 L
s
P
p
1 0 .6 r
.00353 w
.29543 .85521 m
.26426 .88592 L
s
P
p
1 0 .6 r
.0025 w
.76826 1.00252 m
.79646 1.06049 L
s
P
p
1 0 .6 r
.0025 w
.25979 .91573 m
.24464 .96132 L
s
P
p
1 0 .6 r
.0025 w
.8096 1.10265 m
.86385 1.15572 L
s
P
p
1 0 .6 r
.0025 w
.8096 1.10265 m
.83785 1.16074 L
s
P
p
1 0 .6 r
.0025 w
.55895 1.23384 m
.58118 1.3086 L
s
P
p
1 0 .6 r
.0025 w
.25979 .91573 m
.22753 .9705 L
s
P
p
1 0 .6 r
.0025 w
.77297 .97301 m
.80565 1.00456 L
s
P
p
1 0 .6 r
.0025 w
.77297 .97301 m
.79009 1.00816 L
s
P
p
1 0 .6 r
.0025 w
.55895 1.23384 m
.54526 1.29629 L
s
P
p
1 0 .6 r
.00353 w
.53403 1.15004 m
.55895 1.23384 L
s
P
p
1 0 .6 r
.0025 w
.20864 1.01118 m
.161 1.05878 L
s
P
p
1 0 .6 r
.0025 w
.20864 1.01118 m
.17616 1.06634 L
s
P
p
1 0 .6 r
.0025 w
.50885 1.26535 m
.48626 1.36873 L
s
P
p
1 0 .6 r
.0025 w
.26426 .88592 m
.23586 .91389 L
s
P
p
1 0 .6 r
.0025 w
.26426 .88592 m
.2447 .91909 L
s
P
p
1 0 .6 r
.00353 w
.7683 .9304 m
.82866 .98837 L
s
P
p
1 0 .6 r
.00353 w
.7683 .9304 m
.81794 .94335 L
s
P
p
1 0 .6 r
.0025 w
.50885 1.26535 m
.45569 1.32984 L
s
P
p
1 0 .6 r
.00353 w
.53403 1.15004 m
.50885 1.26535 L
s
P
p
1 0 .6 r
.00353 w
.27789 .8441 m
.22549 .8954 L
s
P
p
1 0 .6 r
.00353 w
.27789 .8441 m
.24357 .85172 L
s
P
p
1 0 .6 r
.005 w
.56214 1.02138 m
.53403 1.15004 L
s
P
p
1 0 .6 r
.005 w
.56214 1.02138 m
.56268 1.18375 L
s
P
p
1 0 .6 r
.0025 w
.82866 .98837 m
.88383 1.04136 L
s
P
p
1 0 .6 r
.0025 w
.82866 .98837 m
.85733 1.04716 L
s
P
p
1 0 .6 r
.0025 w
.81794 .94335 m
.86345 .95522 L
s
P
p
1 0 .6 r
.0025 w
.81794 .94335 m
.85122 .97516 L
s
P
p
1 0 .6 r
.0025 w
.22549 .8954 m
.17735 .94254 L
s
P
p
1 0 .6 r
.0025 w
.22549 .8954 m
.1926 .95104 L
s
P
p
1 0 .6 r
.005 w
.54007 .93818 m
.51997 1.02508 L
s
P
p
1 0 .6 r
.005 w
.54007 .93818 m
.47642 1.0019 L
s
P
p
1 0 .6 r
.0025 w
.24357 .85172 m
.21198 .85872 L
s
P
p
1 0 .6 r
.0025 w
.24357 .85172 m
.21464 .87988 L
s
P
p
1 0 .6 r
.00353 w
.56268 1.18375 m
.56318 1.33318 L
s
P
p
1 0 .6 r
.00353 w
.56268 1.18375 m
.61973 1.27697 L
s
P
p
1 0 .6 r
.00353 w
.47642 1.0019 m
.41803 1.06035 L
s
P
p
1 0 .6 r
.00353 w
.47642 1.0019 m
.4648 1.04994 L
s
P
p
1 0 .6 r
.0025 w
.56318 1.33318 m
.56363 1.47041 L
s
P
p
1 0 .6 r
.0025 w
.56318 1.33318 m
.51138 1.42003 L
s
P
p
1 0 .6 r
.0025 w
.61973 1.27697 m
.67216 1.36264 L
s
P
p
1 0 .6 r
.0025 w
.61973 1.27697 m
.63922 1.32271 L
s
P
p
1 0 .6 r
.00353 w
.51997 1.02508 m
.50122 1.10614 L
s
P
p
1 0 .6 r
.00353 w
.51997 1.02508 m
.55358 1.07447 L
s
P
p
1 0 .6 r
.0025 w
.41803 1.06035 m
.36458 1.11386 L
s
P
p
1 0 .6 r
.0025 w
.41803 1.06035 m
.35748 1.08818 L
s
P
p
1 0 .6 r
.0025 w
.4648 1.04994 m
.45414 1.09403 L
s
P
p
1 0 .6 r
.0025 w
.4648 1.04994 m
.43276 1.0822 L
s
P
p
1 0 .6 r
.0025 w
.55358 1.07447 m
.58465 1.12012 L
s
P
p
1 0 .6 r
.0025 w
.55358 1.07447 m
.54363 1.11935 L
s
P
p
1 0 .6 r
.0025 w
.50122 1.10614 m
.48379 1.18152 L
s
P
p
1 0 .6 r
.0025 w
.50122 1.10614 m
.44754 1.16095 L
s
P
p
1 g
.002 w
.83262 .0398 m
.86622 1.40706 L
s
.86622 1.40706 m
.0398 1.45812 L
s
.0398 1.45812 m
.08424 .12352 L
s
.08424 .12352 m
.83262 .0398 L
s
.83262 .0398 m
.86622 1.40706 L
s
.86622 1.40706 m
.9602 1.56854 L
s
.9602 1.56854 m
.9213 .3062 L
s
.9213 .3062 m
.83262 .0398 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 334}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000L=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H5000]a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001WaPT01<H00`36aP0[aP400000G]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H9000=a]K6e/K4a]K6e/KFaP02000/e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000ELH900o600?4a/H01<H202c60@00001<e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT0
01o6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6008002cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP400013aPT01LH00lC6aP0IaP03a<K600C600<0aP00:lH10000
03[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
2@00GlKFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/H0aP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000aaPT06<H00lC6aP0IaP04
a<K6aP;400@0a034:/H1000002SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
2@00=lKFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/H0
2/@0<=K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000TaP@0
3lH00lC6aP0IaP03a<K600S62/@7aP03a<K600;600@0a/H0:/H1000005?Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP0;a014e/KFa]K6e/KFa]K6e/KFa]K4e/KFaP36eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100009<H201;600?4a/H04<H:a1[600?4a/H00/H01@36a/H002W6
0@00000Te/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P006mK6e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6eP0:a01Ga]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/H0
a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000TaP030<H00136
2/@DaP03a<K601S600G4a/K60003a0030<C602O60@00000]e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KF0=K6e/KF00[403G6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP08a00^0<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000TaP040<K600G43LH00lC6aP0IaP03a<K600_62<@5aP04a<K600C600<0a/H0
9/H1000005_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K60<KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KF00W403kFa]K6e/KFa]K6e/KFa=K6
0<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000TaP050<K6aP00
4/H00lC6aP0DaPW45lH00lC60005aP030<K602G60@00001:e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/H8a004e/KFaP<0
04W6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<H0a]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000TaP030<K600?600<0a/H03lH00lC6aP02aPW42lH501S600C4a/H0
1LH00`36aP0TaP400000>MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36
e/KFa]K6e/KFa]K6eP08a00Da]K6e/KFa]K6e/KFa]K6e/KFa]H5000Le/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CF00G402L0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002C6
00<0a/H01<H00`36aP02aPW41LH00lC6aP0DaPD04LH:a0030<K600?600<0a/H09<H1000002cFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KF00C402KFa]K6e/KFa]K6e/KFa/C6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP<000O4e/KFa]K600_403O6e/KFa]K6e/CF0=K6e/KFaP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000TaP030<K600G600<0a/H04<H00lC6
aP0CaP03a4lo00S45<H00l@0aP05aP030<K602?60@00001:e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/H;a01=aSloe/CF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/@0e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0002?600<0a/H01lH00`36aP0?aP_43<H01Dloa/K401W600?40<H01/H00`36
aP0RaP400000==K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/H0a]K6
e/H;a00Ga/C6e/KFa]K6e/KFa]K6e/KFa]K6e/H00Sl08=K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K61L@09@3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002?600<0a/H0
2<H00`34a003a0g600?4a/H04/H00dloaP02aP03a<K600o62<@00`34a005aP030<K602;60@00001F
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0:e/KFa=K6e/KFaP_400c6e/KFa]K6eP3Fa]H6000S
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002?600<0a/H02/H00`36aP0?aP03
a<K6017600=??l@02L@>aPH000?400001LH00`36aP0QaP400000CMK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF00W4
0Sl03mK6e/K4a]K6e/KFa]K6eP09000be/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008lH00`36aP0;aP030<K600k62l@9aP03Cco600?600?4aP00200>aP03
0<K600K600<0a/H08LH1000003OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KF0=K6e/KF00_401;Fa/C6e/KFa]K6e/KFa]K6e/H2008o1@00ALCFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
8lH00`36aP0<aPG43LH00lC6aP04aPT00/H00dloaP0LaP030<K600K600<0a/H08LH1000004;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/H30003a00000<000_6e/KFa]K6e/KFaP02?`1:e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0=aP03
0<K600?62@0DaP03Cco601c600<0a/H01/H00`36aP0QaP400000==K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H5000Ma]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H03/H00`36aP0OaP03Cco601c600<0a/H0
1/H00`36aP0QaP400000E]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0B]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002?600<0a/H03/H00`36aP0OaP03Cco601c600<0a/H01/H00`36aP0QaP400000E]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H03/H00`36aP0OaP03
Cco601c600<0a/H01/H00`36aP0QaP400000E]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0B]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002?600<0a/H03/H00`36aP0OaP03Cco601c600<0a/H01/H00`36aP0QaP40
0000E]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H0
3/H00`36aP0OaP03Cco601c600<0a/H01/H00`36aP0QaP400000E]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002?600<0a/H03/H00`36aP0NaP03?lHo01g600<0a/H0
1lH00`36aP0PaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000SaP030<K600k600<0a/H07LH014o6aSlMaP030<K600O600<0a/H08<H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH00`36aP0>aP030<K601c600Doa/K6
?`0MaP030<K600O600<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]Hoe/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100008/H00`36aP0?aP030<K601_600=?a/H00/H00co6aP0KaP030<K600O600<0a/H0
8<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36
aP0?aP030<K601[600<oa/H00lH00co6aP0KaP030<K600O600<0a/H08<H100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaSo6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36aP0?aP030<K601S600<oa/H0
1LH00co6aP0LaP030<K600K600<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008/H00`36aP0>aP030<K601S600=?a/H01/H00co6aP0LaP030<K600K6
00<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
8/H00`36aP0>aP030<K601O600<oa/H01lH00co6aP0LaP030<K600K600<0a/H08<H1000004cFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60Sl0E=K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000RaP030<K600k600<0a/H0
5/H00dloaP08aP03?lK601c600<0a/H01/H00`36aP0PaP400000BmK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`1E
a]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008/H00`36aP0>aP030<K601G600<oClH02LH00co6
aP0LaP030<K600K600<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6?lKFa]K6e/KFa]Hoe/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100008/H00`36aP0>aP030<K601?600<oaSl02lH00co6aP0LaP030<K600K600<0a/H0
8<H1000005OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]H00Sl0BLKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002;6
00<0a/H03/H00`36aP0BaP04ClK6?`_600<oClH07<H00`36aP06aP030<K602360@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6?lHoa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H03/H00`36aP0AaP04
?lK6C`c600<oaSl07<H00`36aP06aP030<K602360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6
e/KF?mK6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H03/H00`36aP0@aP04ClK6?`g600@oa/I?6lH00`36
aP06aP030<K602360@000018e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF?mK60Sl0F=K6e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008/H00`36aP0>aP030<K600k600I??lK6Ccl=aP05?lK6aSl06/H00`36aP06aP030<K60236
0@000013e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6eP02?`1Ma]Ho?lKFa]K6e/KFa]K6e/KF?mK6eSoFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000RaP03
0<K600k600<0a/H03<H00do6C`02aP03?do600g600<oa/H00/H00do6aP0GaP030<K600K600<0a/H0
8<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6eSoF?mK6?lHoa]K6e/KFa]K6e/KFa]Hoe/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36
aP0>aP030<K600[600Q?a/HoaSo6?`o600<oa/H00lH00co6aP0FaP030<K600K600<0a/H08<H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]Hoe/Hoa]HoeSoFa]K6e/KFa]K6e/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0?aP03
0<K600S600A??lHo0/H014o6aSl?aP03?lK600C600=??lH05LH00`36aP07aP030<K601o60@00000m
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
eP02?`1Sa]Hoe/HoaSo6e/KFa]K6e/KFa]K6e/KF?mK6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KF
aP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000QaP030<K600o6
00<0a/H01/H01Do6ClI?00;600@oClI?4<H00co6aP05aP03?lHo01C600<0a/H01lH00`36aP0OaP40
0000@]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KF?mHoe/HoaP8o05kFaSo6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H0
3lH00`36aP04aP03ClI?00;600Poa/I??lHoCa3600<oa/H01/H014o6aSlBaP030<K600O600<0a/H0
7lH1000003OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0
e/KF00<o00_FaSo6eSoF?mHoeP02?`1Ka]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFaSo6e/Hoa]K6e/KF
a]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
8LH00`36aP0?aP0604loClI?0/H023o6aTo6Ccm?0/H00cm?aP0?aP03?lK600O600Doa/K6?`0@aP03
0<K600O600<0a/H07lH1000003;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFaP<o00G6eSoFaP02?`03e/Ho008o0676?lHoaSo6e/KFa]K6e/KFa]K6e/KF?mK6e/KF
a]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000QaP030<K600o600@oa/I?0/H03Sm?a/HoClI??do6ClI?3lH00dloaP09aP06
ClK6aTlo3/H00`36aP07aP030<K601o60@00000le/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/Ho0=Hoe/HoaSo613l01=Hoe/H3?`0?a]K6e/KFa]K6e/KFa]K6008o
00oFa]K6e/KFa]K6?lKFa]H00Sl0>LKFa]K6e/KFa]K6e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100008LH00`36aP0?aP0704o6aSo6?`02aP0;Ccm?aTloaSo6?dl0
3lH00dloaP0:aP07?lK6aSo6?`0<aP030<K600O600<0a/H07lH1000003KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]Hoe/H3?`03a]Ho00Ho01CF?mHoe/KFa]K6
e/KFa]K6e/KFaP8o04[Fa]K6e/KFa]K6eSoFa]K6?lHoa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600k600a??lHoClI?aTo6Ccl2aP06
Cco6?dlo4<H00dloaP0;aP05ClK6aTl00/H00co6aP09aP030<K600K600<0a/H07lH10000037Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF008o00L0?coF?mK6008o
00SF?mK6?lHoaP8o05cFa]K6e/KFa]K6e/KFa]HoeSoFa]K6e/KFa]K6e/Hoa]K6eSoFaSo6e/KFa]K6
e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600c6
00A?aTl00lH01co6?lHoCcl00/H01dloClI??dl03/H00co6?`0=aP05?lK6aSl00lH00cm??`07aP03
0<K600K600<0a/H07lH1000003WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6eSoF?mH0e/Hoa]H013l01<KFa]H5?`0ZeSoFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6
eSoFa]K6?lKFaSo60cl0;lKFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000QaP030<K600[600m?a/HoaP36?do6ClI??dl00lH01TloaSo6?`k600A??lHo3LH00cm?
aP02aP03Cco600;600Toa/K6?dloaP002<H00`36aP0OaP400000=MK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaSo6eP3F00<o00WF?co6e/KF?mH00Sl08/KF?mK6e/KF
a]K6e/KFa]HoeSoF?mK6e/KFa]K6e/KFa]H2?`04a]K6eP8o03G6e/Hoa]K6?lHo0=K6e/KFa]K60<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008LH00`36aP0?aP0704loCco6?`05aP03
?lHo00?600<oa/H02/H00do6C`02aP03?lK600_600<oaSl00lH00co6?`03aP07?lK6aSo60008aP03
0<K601o60@00000ee/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KF?mH00Sl01lHo?mK6e/H00cl0HLKFa]K6e/KFa]K6e/KFa]Hoe/Hoa]Hoe/KFa]K6e/KFa]K6eSoF
?mK6e/HoaSo6e/Hoa]K6?`3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0
0@00027600<0a/H03lH00`1??`02aP03Cco600?600=?aTl03lH01Do6a/I?00;600<oa/H03<H00do6
C`03aP04ClI??`?600Doa/K60008aP030<K601o60@00000he/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF?mHoe/H2?`03e/KF008o0336?lKFa]K6e/KFa]K6e/KF
?mK6e/Hoa]Hoe/KFa]K6e/KFa]K6e/HoaSo6e/Hoa]H2?`03a]K6008o02cF0=K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600k600=?aTl00/H00co6?`03aP04
?dloC`g600=?a/H00lH014o6aSl>aP03ClI?00C600DoaSo6?`02aP04ClI?00S600<0a/H07lH10000
03OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF?`0oe/KF008o
00K6e/Hoa]H2?`0<a]K6e/KFa]K6e/KF0Sl0DlKFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6?lKF?mK6eSoF
aSo6e/KF?mH0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000QaP03
0<K600c600A??`0o0/H00do6C`05aP03ClI?00_600=?aTl01<H01Co6a/Ho00k600A?a/Ho0lH00cm?
aP05aP04?lH0C`O600<0a/H07lH1000002oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6eP02?`04aSo6eP8o06_6?lKFa]K6?lKFa]K6e/KFa]K6eSoF?mK6e/KF?mK6eSoF
a]K6e/KFa]K6e/KFaSo6e/Hoa]K6?lKFa]K6e/Ho0=Hoe/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100008LH00`36aP0:aP05ClI?aTl00/H013m??dl5aP03ClK600W600A?a/Ho
1LH01Cm?a/Ho00k600E??lK6C`03aP03Cco600G600E?0<K6C`05aP030<K601o60@00000de/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KF?mHoeSl0aP8o023F?mK6e/KF?mK6
e/KFa]K6e/KF?mK6eSoFa]K6?lHoaP8o01?Fa]K6e/KFa]K6e/KFa]Hoe/KF008o03G6?coFa]K6e/KF
0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008LH00`36aP08aP08
ClK6?do603l3aP03?lK600g600<oClH00/H00dloaP03aP06ClK6?dlo3lH01cm?a/HoaSl00/H00do6
aP04aP030<K600K600<0a/H07lH1000003KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6?lHoaP36e/H2?`0<e/KFa]K6e/KFa]K613l03MK6eSoF?mK6e/Hoa]H00cl0B]K6
e/KFa]K6e/KFa]K6eSoF?mK6?lHoa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@00023600<0a/H03<H013m?aP03aP03ClK600W600E??lK6C`03aP03ClI?00G6
00I?a/K6Ccl?aP03?lHo00;600A?a/Ho1lH00`36aP06aP030<K601o60@00001Fe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]Hoe/H0a]K6?lKFa]K6e/KFa]Hoe/KF?mK6
eSoFaSo6e/KFaSo6e/H2?`1:e/KFa]K6e/KFa]K6e/KF?mK6?lKF?mK6?lKFa]K6eP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0;aP05Cco6aP000/H00co6
aP0<aP03ClK600G600=?a/H00/H01co6a/HoCcl04<H00do6C`02aP05?lK6aSl01LH00`36aP06aP03
0<K601o60@00000^e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP8o
02OFaP36e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]Hoe/KF?mH00Sl04LKFa]K6e/KFa]K6e/KF
aSo6008o00KFaSo6e/H2?`0^e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP40000PaP030<K600[600<oaSl00/H00`36aP0=aP03ClK600_600=??lH00/H01Co6?lHo00k6
00A?aTlo0lH01So6aTo6C`;600<0a/H01lH00`36aP0NaP400000;MK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eP02?`0ha]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]HoeSoFa]HoeSoFaSo6e/KFa]K6e/KFa]H2?`0iaSo6?lKF?mK6eSoF?mH0e/KFa]K6e/KF0=K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000PaP030<K600W600=?aTl00lH00`36aP0IaP03
ClI?00C600<oaSl03lH01Sm?aTo6C`?600A?a/Ho0/H00dl0aP08aP030<K601k60@00001We/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/Hoa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/Hoa]K6?lKF?mK6e/KFa]K6e/KFa]K6eP02?`0ia]K6eSoFaSo6e/Hoa]H0e/KF
a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000PaP030<K600S600<oa/H0
1<H00`36aP0GaP05ClK6aTl00lH014o6aSl>aP04ClK6?`O600@oa/I?0/H00`1?aP07aP030<K601k6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/Hoa]K6?lKF?mK6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]Ho
e/KF?mH0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H0
3lH00`36aP0JaP03?lK600;600A??lHo4LH00co6aP05aP03?do600?600<0a/H01lH00`36aP0NaP40
0000LMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mHoeSoFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF008o
02o6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008<H00`36
aP0?aP030<K601k600DoaSo6?`0IaP03?lHo00?600<0a/H01lH00`36aP0NaP400000E]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mK60cl06LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00Sl0;]K6eP3Fa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0?aP030<K601k6
00Loa/I??lHo01S600=?aTl00/H00`36aP07aP030<K601k60@00001Fe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaSo6e/H2?`1:eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/HoaSo6eP3Fa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0?aP030<K601g600=?a/H00/H013o6
aTlGaP06ClK6?lH02LH00`36aP0NaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6eSoFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000PaP030<K600o600<0a/H07LH00do6aP02aP05?lK6aSl06/H00do60008aP03
0<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000236
00<0a/H03lH00`36aP0LaP03?lK600;600=??dl00lH00do6aP0IaP030<K600K600<0a/H07/H10000
05KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFaP<o04W6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000PaP030<K600o6
00<0a/H06lH00dloaP03aP03Ccm?00C600<oa/H06<H00`36aP06aP030<K601k60@00001Ge/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eSoF?mK6eSoF008o04W6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF
a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000PaP030<K600o600<0a/H0
6LH00do6C`04aP05?lHoaSl01<H00dloaP0GaP030<K600K600<0a/H07/H1000005kFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/HoaSo6e/KFa]HoeSoFa]K60Sl0@]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K600o600<0a/H06<H013o6
aTl6aP03?lK600G600<oClH05/H00`36aP06aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
e/Hoa]K6e/KF?mK6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H04<H00`36aP0KaP03ClK600C600<oa/H0
1lH00co6aP0DaP030<K600K600<0a/H07/H1000005KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFaP8o
04[Fa]K6e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K6013600<0a/H06/H00co6aP04aP03Cco600W600=?a/H0
4lH00`36aP06aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6eSoF?mK6e/KFa]K6
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001o600<0a/H04<H00`36aP0PaP03?lHo023600<0a/H01/H00`36aP0NaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K6013600<0a/H0
7lH014o6aSlPaP030<K600K600<0a/H07/H10000077Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]Ho
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP08000Ya]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0001o600<0a/H03lH00`36aP0OaP05?lK6aSl02/H?00O600<0a/H01/H00`36
aP0NaP400000DmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Ho00l0043Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03lH00`36
aP0@aPl01<H00co6aP0OaP030<K600K600<0a/H07LH1000003GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6eP0?001Ne/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000OaP030<K600C63`0RaP03?lK6027600<0a/H01<H00`36aP0MaP4000007mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H01`00O=K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0=aP030<K602?6
00<oa/H08/H00`36aP03aP030<K601g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0002?600<0a/H02lH00`36aP19aP030<K600;600<0a/H07LH100000:;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100009LH00`36aP09aP030<K604[6
00D0a/K6000OaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000WaP030<K600O600<0a/H0BlH01036aP0OaP400000:=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H2001he/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0aP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002[600<0a/H01<H00`36aP1<aP030<H001o60@000021e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF008001o6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000/aP030<K600;600<0a/H0
CLH201o60@00001he/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K62`007lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002k600@0a/H0
</HD02[60@00001?e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0E000ne/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<<H200W6501CaP400000<MK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02P00IlKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@000:;60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000001\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0155651, -0.0250052, 
  0.00585642, 0.00585642}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.60592 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.260058 1.55526 0.0388814 1.55526 [
[ 0 0 0 0 ]
[ 1 1.60592 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.60592 L
0 1.60592 L
closepath
clip
newpath
p
1 g
.002 w
.83174 .03888 m
.86524 1.35813 L
s
.86524 1.35813 m
.03888 1.4094 L
s
.03888 1.4094 m
.08369 .12288 L
s
.08369 .12288 m
.83174 .03888 L
s
.92238 .31511 m
.24014 .38432 L
s
.24014 .38432 m
.21435 1.56703 L
s
.21435 1.56703 m
.96112 1.52559 L
s
.96112 1.52559 m
.92238 .31511 L
s
.83174 .03888 m
.86524 1.35813 L
s
.86524 1.35813 m
.96112 1.52559 L
s
.96112 1.52559 m
.92238 .31511 L
s
.92238 .31511 m
.83174 .03888 L
s
.08369 .12288 m
.24014 .38432 L
s
.24014 .38432 m
.21435 1.56703 L
s
.21435 1.56703 m
.03888 1.4094 L
s
.03888 1.4094 m
.08369 .12288 L
s
p
.4 g
.83992 .0638 m
.09777 .14641 L
s
P
p
.4 g
.8754 .17193 m
.15894 .24864 L
s
P
p
.4 g
.90835 .27236 m
.21588 .34377 L
s
P
p
.4 g
.71924 .05151 m
.82001 .3255 L
s
P
p
.4 g
.49708 .07646 m
.61762 .34603 L
s
P
p
.4 g
.27866 .10099 m
.41831 .36625 L
s
P
P
p
1 0 .6 r
.00177 w
.4211 .85427 m
.42978 .86772 L
s
P
p
1 0 .6 r
.00177 w
.40904 .87857 m
.407 .91362 L
s
P
p
1 0 .6 r
.00177 w
.4211 .85427 m
.41982 .87561 L
s
P
p
1 0 .6 r
.00177 w
.40904 .87857 m
.39749 .91263 L
s
P
p
1 0 .6 r
.0025 w
.41133 .83913 m
.4211 .85427 L
s
P
p
1 0 .6 r
.0025 w
.41133 .83913 m
.40904 .87857 L
s
P
p
1 0 .6 r
.00177 w
.36416 .93412 m
.36238 .96911 L
s
P
p
1 0 .6 r
.00177 w
.39809 .86155 m
.39689 .88304 L
s
P
p
1 0 .6 r
.00177 w
.36416 .93412 m
.3526 .96834 L
s
P
p
1 0 .6 r
.00353 w
.41392 .79468 m
.41133 .83913 L
s
P
p
1 0 .6 r
.00177 w
.39809 .86155 m
.39106 .88235 L
s
P
p
1 0 .6 r
.0025 w
.39944 .8375 m
.39809 .86155 L
s
P
p
1 0 .6 r
.0025 w
.36617 .89473 m
.36416 .93412 L
s
P
p
1 0 .6 r
.00177 w
.38648 .87587 m
.37485 .91027 L
s
P
p
1 0 .6 r
.00177 w
.34481 .95807 m
.32571 1.01471 L
s
P
p
1 0 .6 r
.00177 w
.38648 .87587 m
.37194 .90078 L
s
P
p
1 0 .6 r
.0025 w
.39944 .8375 m
.38648 .87587 L
s
P
p
1 0 .6 r
.02 w
.55519 .23342 m
.55577 .42781 L
s
P
p
1 g
.05 w
.55519 .23342 Mdot
P
p
1 0 .6 r
.00177 w
.34481 .95807 m
.32063 .9995 L
s
P
p
1 0 .6 r
.0025 w
.36617 .89473 m
.34481 .95807 L
s
P
p
1 0 .6 r
.00353 w
.41392 .79468 m
.39944 .8375 L
s
P
p
1 0 .6 r
.005 w
.41683 .7445 m
.41392 .79468 L
s
P
p
1 0 .6 r
.00353 w
.39007 .82386 m
.36617 .89473 L
s
P
p
1 0 .6 r
.00177 w
.3471 .91371 m
.33544 .94836 L
s
P
p
1 0 .6 r
.00177 w
.37745 .8353 m
.3763 .85718 L
s
P
p
1 0 .6 r
.00353 w
.39007 .82386 m
.36011 .87506 L
s
P
p
1 0 .6 r
.005 w
.41683 .7445 m
.39007 .82386 L
s
P
p
1 0 .6 r
.00177 w
.3471 .91371 m
.33238 .93889 L
s
P
p
1 0 .6 r
.0025 w
.36011 .87506 m
.3471 .91371 L
s
P
p
1 0 .6 r
.00177 w
.37745 .8353 m
.37034 .85642 L
s
P
p
1 0 .6 r
.0025 w
.36011 .87506 m
.33302 .92137 L
s
P
p
1 0 .6 r
.0025 w
.37873 .81081 m
.37745 .8353 L
s
P
p
1 0 .6 r
.00177 w
.36563 .84976 m
.35388 .88468 L
s
P
p
1 0 .6 r
.00177 w
.67884 1.04262 m
.66724 1.07725 L
s
P
p
1 0 .6 r
.00177 w
.29672 .97142 m
.29531 1.00691 L
s
P
p
1 0 .6 r
.00707 w
.44684 .65553 m
.41683 .7445 L
s
P
p
1 0 .6 r
.00177 w
.33302 .92137 m
.30852 .96323 L
s
P
p
1 0 .6 r
.00177 w
.33302 .92137 m
.3117 .9429 L
s
P
p
1 0 .6 r
.00177 w
.36563 .84976 m
.35086 .87498 L
s
P
p
1 0 .6 r
.0025 w
.37873 .81081 m
.36563 .84976 L
s
P
p
1 0 .6 r
.00353 w
.39335 .76734 m
.37873 .81081 L
s
P
p
1 0 .6 r
.00177 w
.67884 1.04262 m
.68328 1.0782 L
s
P
p
1 0 .6 r
.01414 w
.55577 .42781 m
.55631 .60797 L
s
P
p
1 0 .6 r
.01414 w
.55577 .42781 m
.4805 .55571 L
s
P
p
1 0 .6 r
.00177 w
.70004 1.06949 m
.70731 1.12826 L
s
P
p
1 0 .6 r
.00177 w
.29672 .97142 m
.28504 1.00629 L
s
P
p
1 0 .6 r
.00177 w
.36712 .82218 m
.35998 .84345 L
s
P
p
1 0 .6 r
.00707 w
.44684 .65553 m
.40968 .7188 L
s
P
p
1 0 .6 r
.01 w
.4805 .55571 m
.44684 .65553 L
s
P
p
1 0 .6 r
.00353 w
.39335 .76734 m
.37508 .79849 L
s
P
p
1 0 .6 r
.005 w
.40968 .7188 m
.39335 .76734 L
s
P
p
1 0 .6 r
.0025 w
.69189 1.00366 m
.67884 1.04262 L
s
P
p
1 0 .6 r
.00177 w
.36712 .82218 m
.35815 .83747 L
s
P
p
1 0 .6 r
.0025 w
.37508 .79849 m
.36712 .82218 L
s
P
p
1 0 .6 r
.0025 w
.2983 .93146 m
.29672 .97142 L
s
P
p
1 0 .6 r
.00177 w
.27672 .996 m
.25743 1.05371 L
s
P
p
1 0 .6 r
.0025 w
.37508 .79849 m
.35859 .8266 L
s
P
p
1 0 .6 r
.00177 w
.70004 1.06949 m
.72172 1.11424 L
s
P
p
1 0 .6 r
.0025 w
.69189 1.00366 m
.70004 1.06949 L
s
P
p
1 0 .6 r
.005 w
.40968 .7188 m
.37604 .7761 L
s
P
p
1 0 .6 r
.00177 w
.35859 .8266 m
.3437 .85197 L
s
P
p
1 0 .6 r
.00177 w
.35859 .8266 m
.34569 .83943 L
s
P
p
1 0 .6 r
.00177 w
.33242 .86726 m
.32061 .90251 L
s
P
p
1 0 .6 r
.00177 w
.27672 .996 m
.25189 1.03839 L
s
P
p
1 0 .6 r
.0025 w
.2983 .93146 m
.27672 .996 L
s
P
p
1 0 .6 r
.01 w
.4805 .55571 m
.41192 .67225 L
s
P
p
1 0 .6 r
.00353 w
.37604 .7761 m
.34559 .82794 L
s
P
p
1 0 .6 r
.00353 w
.37604 .7761 m
.34967 .80212 L
s
P
p
1 0 .6 r
.00177 w
.33242 .86726 m
.31746 .89276 L
s
P
p
1 0 .6 r
.0025 w
.34559 .82794 m
.33242 .86726 L
s
P
p
1 0 .6 r
.00353 w
.68275 .92986 m
.69189 1.00366 L
s
P
p
1 0 .6 r
.00177 w
.71467 1.02564 m
.71907 1.06161 L
s
P
p
1 0 .6 r
.00353 w
.32244 .85923 m
.2983 .93146 L
s
P
p
1 0 .6 r
.0025 w
.34559 .82794 m
.31806 .87483 L
s
P
p
1 0 .6 r
.00177 w
.71467 1.02564 m
.72788 1.05288 L
s
P
p
1 0 .6 r
.0025 w
.70974 .98547 m
.71467 1.02564 L
s
P
p
1 0 .6 r
.00177 w
.27853 .951 m
.26675 .98631 L
s
P
p
1 0 .6 r
.00177 w
.31806 .87483 m
.29316 .91723 L
s
P
p
1 0 .6 r
.00177 w
.31806 .87483 m
.29635 .89647 L
s
P
p
1 0 .6 r
.00707 w
.41192 .67225 m
.34949 .77833 L
s
P
p
1 0 .6 r
.00707 w
.41192 .67225 m
.35794 .72472 L
s
P
p
1 0 .6 r
.0025 w
.34967 .80212 m
.32568 .82581 L
s
P
p
1 0 .6 r
.0025 w
.34967 .80212 m
.33298 .83052 L
s
P
p
1 0 .6 r
.00353 w
.68275 .92986 m
.70974 .98547 L
s
P
p
1 0 .6 r
.005 w
.6725 .84703 m
.68275 .92986 L
s
P
p
1 0 .6 r
.00353 w
.32244 .85923 m
.29167 .91161 L
s
P
p
1 0 .6 r
.005 w
.34949 .77833 m
.32244 .85923 L
s
P
p
1 0 .6 r
.01 w
.55631 .60797 m
.5568 .77452 L
s
P
p
1 0 .6 r
.01 w
.55631 .60797 m
.61732 .73351 L
s
P
p
1 0 .6 r
.00177 w
.27853 .951 m
.26341 .97676 L
s
P
p
1 0 .6 r
.0025 w
.29167 .91161 m
.27853 .951 L
s
P
p
1 0 .6 r
.00177 w
.77536 1.10893 m
.78245 1.16836 L
s
P
p
1 0 .6 r
.0025 w
.70974 .98547 m
.73409 1.03562 L
s
P
p
1 0 .6 r
.00177 w
.33298 .83052 m
.31792 .85614 L
s
P
p
1 0 .6 r
.00177 w
.33298 .83052 m
.31989 .84348 L
s
P
p
1 0 .6 r
.00177 w
.73409 1.03562 m
.75604 1.08085 L
s
P
p
1 0 .6 r
.00177 w
.73409 1.03562 m
.75934 1.06042 L
s
P
p
1 0 .6 r
.0025 w
.29167 .91161 m
.26384 .95899 L
s
P
p
1 0 .6 r
.00707 w
.61732 .73351 m
.6725 .84703 L
s
P
p
1 0 .6 r
.00707 w
.61732 .73351 m
.68029 .79366 L
s
P
p
1 0 .6 r
.005 w
.34949 .77833 m
.29274 .87477 L
s
P
p
1 0 .6 r
.00177 w
.77536 1.10893 m
.79741 1.15434 L
s
P
p
1 0 .6 r
.0025 w
.76742 1.04235 m
.77536 1.10893 L
s
P
p
1 0 .6 r
.00177 w
.32568 .82581 m
.30388 .84734 L
s
P
p
1 0 .6 r
.00177 w
.32568 .82581 m
.31148 .82901 L
s
P
p
1 0 .6 r
.00177 w
.26384 .95899 m
.23868 1.00182 L
s
P
p
1 0 .6 r
.00177 w
.26384 .95899 m
.24174 .98116 L
s
P
p
1 0 .6 r
.005 w
.6725 .84703 m
.72236 .94964 L
s
P
p
1 0 .6 r
.00177 w
.21943 1.02792 m
.19998 1.08653 L
s
P
p
1 0 .6 r
.00353 w
.72236 .94964 m
.76742 1.04235 L
s
P
p
1 0 .6 r
.00353 w
.72236 .94964 m
.77427 1.00007 L
s
P
p
1 0 .6 r
.00353 w
.29274 .87477 m
.24118 .96237 L
s
P
p
1 0 .6 r
.00353 w
.29274 .87477 m
.2475 .91959 L
s
P
p
1 0 .6 r
.0025 w
.76742 1.04235 m
.80811 1.12607 L
s
P
p
1 0 .6 r
.00177 w
.74294 .95319 m
.74734 .98982 L
s
P
p
1 0 .6 r
.00177 w
.21943 1.02792 m
.19405 1.07111 L
s
P
p
1 0 .6 r
.0025 w
.24118 .96237 m
.21943 1.02792 L
s
P
p
1 0 .6 r
.00177 w
.80811 1.12607 m
.84485 1.20166 L
s
P
p
1 0 .6 r
.00177 w
.80811 1.12607 m
.85075 1.16805 L
s
P
p
1 0 .6 r
.005 w
.35794 .72472 m
.30824 .77303 L
s
P
p
1 0 .6 r
.005 w
.35794 .72472 m
.32347 .78318 L
s
P
p
1 0 .6 r
.00177 w
.57401 1.18059 m
.60822 1.21089 L
s
P
p
1 0 .6 r
.00177 w
.57401 1.18059 m
.59144 1.23944 L
s
P
p
1 0 .6 r
.00177 w
.74294 .95319 m
.75635 .98076 L
s
P
p
1 0 .6 r
.0025 w
.73803 .9123 m
.74294 .95319 L
s
P
p
1 0 .6 r
.005 w
.68029 .79366 m
.73794 .84873 L
s
P
p
1 0 .6 r
.005 w
.68029 .79366 m
.71065 .85604 L
s
P
p
1 0 .6 r
.00177 w
.27895 .87618 m
.267 .91212 L
s
P
p
1 0 .6 r
.00353 w
.71065 .85604 m
.73803 .9123 L
s
P
p
1 0 .6 r
.00353 w
.71065 .85604 m
.74209 .88622 L
s
P
p
1 0 .6 r
.00707 w
.5568 .77452 m
.55726 .92813 L
s
P
p
1 0 .6 r
.00707 w
.5568 .77452 m
.53792 .85485 L
s
P
p
1 0 .6 r
.0025 w
.24118 .96237 m
.1944 1.04187 L
s
P
p
1 0 .6 r
.00353 w
.32347 .78318 m
.29227 .83609 L
s
P
p
1 0 .6 r
.00353 w
.32347 .78318 m
.29626 .80977 L
s
P
p
1 0 .6 r
.0025 w
.73803 .9123 m
.76273 .96305 L
s
P
p
1 0 .6 r
.00177 w
.27895 .87618 m
.26362 .9022 L
s
P
p
1 0 .6 r
.0025 w
.29227 .83609 m
.27895 .87618 L
s
P
p
1 0 .6 r
.0025 w
.77427 1.00007 m
.82163 1.04608 L
s
P
p
1 0 .6 r
.0025 w
.77427 1.00007 m
.79901 1.05092 L
s
P
p
1 0 .6 r
.0025 w
.5545 1.11473 m
.57401 1.18059 L
s
P
p
1 0 .6 r
.00177 w
.76273 .96305 m
.785 1.00881 L
s
P
p
1 0 .6 r
.00177 w
.76273 .96305 m
.78842 .98791 L
s
P
p
1 0 .6 r
.00177 w
.79901 1.05092 m
.82132 1.09677 L
s
P
p
1 0 .6 r
.00177 w
.79901 1.05092 m
.82483 1.0761 L
s
P
p
1 0 .6 r
.00177 w
.54251 1.16956 m
.55316 1.20533 L
s
P
p
1 0 .6 r
.00177 w
.4908 1.23288 m
.50859 1.29182 L
s
P
p
1 0 .6 r
.0025 w
.29227 .83609 m
.26405 .88394 L
s
P
p
1 0 .6 r
.00177 w
.54251 1.16956 m
.53173 1.2188 L
s
P
p
1 0 .6 r
.00177 w
.1944 1.04187 m
.15198 1.11395 L
s
P
p
1 0 .6 r
.00177 w
.1944 1.04187 m
.15673 1.07975 L
s
P
p
1 0 .6 r
.0025 w
.74209 .88622 m
.77062 .91361 L
s
P
p
1 0 .6 r
.0025 w
.74209 .88622 m
.75707 .91699 L
s
P
p
1 0 .6 r
.0025 w
.5545 1.11473 m
.54251 1.16956 L
s
P
p
1 0 .6 r
.00177 w
.4908 1.23288 m
.47305 1.31429 L
s
P
p
1 0 .6 r
.00177 w
.75707 .91699 m
.77058 .94472 L
s
P
p
1 0 .6 r
.00177 w
.75707 .91699 m
.77263 .93195 L
s
P
p
1 0 .6 r
.00353 w
.53265 1.04097 m
.5545 1.11473 L
s
P
p
1 0 .6 r
.00177 w
.26405 .88394 m
.23854 .92721 L
s
P
p
1 0 .6 r
.00177 w
.26405 .88394 m
.24164 .90606 L
s
P
p
1 0 .6 r
.0025 w
.2475 .91959 m
.20602 .96069 L
s
P
p
1 0 .6 r
.0025 w
.2475 .91959 m
.2191 .96777 L
s
P
p
1 0 .6 r
.0025 w
.51059 1.14214 m
.4908 1.23288 L
s
P
p
1 0 .6 r
.0025 w
.29626 .80977 m
.2715 .83398 L
s
P
p
1 0 .6 r
.0025 w
.29626 .80977 m
.27916 .83875 L
s
P
p
1 0 .6 r
.00353 w
.73794 .84873 m
.79063 .89906 L
s
P
p
1 0 .6 r
.00353 w
.73794 .84873 m
.7812 .85955 L
s
P
p
1 0 .6 r
.0025 w
.51059 1.14214 m
.46402 1.1985 L
s
P
p
1 0 .6 r
.00353 w
.53265 1.04097 m
.51059 1.14214 L
s
P
p
1 0 .6 r
.00177 w
.82163 1.04608 m
.8648 1.08802 L
s
P
p
1 0 .6 r
.00177 w
.82163 1.04608 m
.85726 1.05625 L
s
P
p
1 0 .6 r
.00177 w
.27916 .83875 m
.26372 .86491 L
s
P
p
1 0 .6 r
.00177 w
.27916 .83875 m
.26564 .852 L
s
P
p
1 0 .6 r
.00177 w
.2191 .96777 m
.19343 1.01132 L
s
P
p
1 0 .6 r
.00177 w
.2191 .96777 m
.19642 .99034 L
s
P
p
1 0 .6 r
.00177 w
.77062 .91361 m
.7965 .93845 L
s
P
p
1 0 .6 r
.00177 w
.77062 .91361 m
.7919 .91918 L
s
P
p
1 0 .6 r
.00353 w
.30824 .77303 m
.26258 .81742 L
s
P
p
1 0 .6 r
.00353 w
.30824 .77303 m
.27842 .77914 L
s
P
p
1 0 .6 r
.00177 w
.46402 1.1985 m
.45326 1.24797 L
s
P
p
1 0 .6 r
.00177 w
.46402 1.1985 m
.42199 1.24938 L
s
P
p
1 0 .6 r
.005 w
.55726 .92813 m
.53265 1.04097 L
s
P
p
1 0 .6 r
.005 w
.55726 .92813 m
.55769 1.06948 L
s
P
p
1 0 .6 r
.00177 w
.2715 .83398 m
.24898 .85599 L
s
P
p
1 0 .6 r
.00177 w
.2715 .83398 m
.25672 .83729 L
s
P
p
1 0 .6 r
.0025 w
.79063 .89906 m
.83872 .945 L
s
P
p
1 0 .6 r
.0025 w
.79063 .89906 m
.8157 .95047 L
s
P
p
1 0 .6 r
.00177 w
.20602 .96069 m
.16805 .99832 L
s
P
p
1 0 .6 r
.00177 w
.20602 .96069 m
.18087 .9673 L
s
P
p
1 0 .6 r
.00177 w
.8157 .95047 m
.83832 .99682 L
s
P
p
1 0 .6 r
.00177 w
.8157 .95047 m
.84193 .97561 L
s
P
p
1 0 .6 r
.0025 w
.7812 .85955 m
.8208 .86945 L
s
P
p
1 0 .6 r
.0025 w
.7812 .85955 m
.81022 .88714 L
s
P
p
1 0 .6 r
.0025 w
.26258 .81742 m
.22069 .85813 L
s
P
p
1 0 .6 r
.0025 w
.26258 .81742 m
.23385 .86596 L
s
P
p
1 0 .6 r
.005 w
.53792 .85485 m
.52031 .92975 L
s
P
p
1 0 .6 r
.005 w
.53792 .85485 m
.48223 .91003 L
s
P
p
1 0 .6 r
.0025 w
.27842 .77914 m
.25102 .78476 L
s
P
p
1 0 .6 r
.0025 w
.27842 .77914 m
.25324 .80349 L
s
P
p
1 0 .6 r
.00177 w
.81022 .88714 m
.83654 .91217 L
s
P
p
1 0 .6 r
.00177 w
.81022 .88714 m
.83192 .89266 L
s
P
p
1 0 .6 r
.00177 w
.23385 .86596 m
.20788 .90986 L
s
P
p
1 0 .6 r
.00177 w
.23385 .86596 m
.21095 .88833 L
s
P
p
1 0 .6 r
.00177 w
.83872 .945 m
.88255 .98687 L
s
P
p
1 0 .6 r
.00177 w
.83872 .945 m
.87493 .95457 L
s
P
p
1 0 .6 r
.00353 w
.55769 1.06948 m
.55808 1.1993 L
s
P
p
1 0 .6 r
.00353 w
.55769 1.06948 m
.6075 1.15013 L
s
P
p
1 0 .6 r
.00177 w
.8208 .86945 m
.85699 .8785 L
s
P
p
1 0 .6 r
.00177 w
.8208 .86945 m
.84297 .8565 L
s
P
p
1 0 .6 r
.00177 w
.25324 .80349 m
.23034 .82563 L
s
P
p
1 0 .6 r
.00177 w
.25324 .80349 m
.23817 .80668 L
s
P
p
1 0 .6 r
.00177 w
.22069 .85813 m
.18235 .8954 L
s
P
p
1 0 .6 r
.00177 w
.22069 .85813 m
.19535 .86392 L
s
P
p
1 0 .6 r
.00353 w
.48223 .91003 m
.43124 .96055 L
s
P
p
1 0 .6 r
.00353 w
.48223 .91003 m
.47211 .95138 L
s
P
p
1 0 .6 r
.00177 w
.25102 .78476 m
.22591 .7899 L
s
P
p
1 0 .6 r
.00177 w
.25102 .78476 m
.2403 .76949 L
s
P
p
1 0 .6 r
.0025 w
.55808 1.1993 m
.55843 1.31831 L
s
P
p
1 0 .6 r
.0025 w
.55808 1.1993 m
.5128 1.27431 L
s
P
p
1 0 .6 r
.0025 w
.6075 1.15013 m
.6532 1.22412 L
s
P
p
1 0 .6 r
.0025 w
.6075 1.15013 m
.6244 1.18896 L
s
P
p
1 0 .6 r
.00353 w
.52031 .92975 m
.50393 .99939 L
s
P
p
1 0 .6 r
.00353 w
.52031 .92975 m
.54963 .97198 L
s
P
p
1 0 .6 r
.0025 w
.43124 .96055 m
.38463 1.00674 L
s
P
p
1 0 .6 r
.0025 w
.43124 .96055 m
.37835 .98475 L
s
P
p
1 0 .6 r
.0025 w
.47211 .95138 m
.46284 .98926 L
s
P
p
1 0 .6 r
.0025 w
.47211 .95138 m
.44414 .97922 L
s
P
p
1 0 .6 r
.00177 w
.37835 .98475 m
.33061 1.0066 L
s
P
p
1 0 .6 r
.00177 w
.37835 .98475 m
.35281 1.00995 L
s
P
p
1 0 .6 r
.00177 w
.55843 1.31831 m
.57854 1.4022 L
s
P
p
1 0 .6 r
.00177 w
.5128 1.27431 m
.47354 1.32968 L
s
P
p
1 0 .6 r
.00177 w
.55843 1.31831 m
.55876 1.42722 L
s
P
p
1 0 .6 r
.00177 w
.5128 1.27431 m
.47137 1.34296 L
s
P
p
1 0 .6 r
.00177 w
.44414 .97922 m
.41876 1.0045 L
s
P
p
1 0 .6 r
.00177 w
.44414 .97922 m
.43896 .99999 L
s
P
p
1 0 .6 r
.00177 w
.6532 1.22412 m
.69506 1.29188 L
s
P
p
1 0 .6 r
.00177 w
.6532 1.22412 m
.69346 1.27901 L
s
P
p
1 0 .6 r
.00177 w
.38463 1.00674 m
.34208 1.04889 L
s
P
p
1 0 .6 r
.00177 w
.38463 1.00674 m
.37556 1.04144 L
s
P
p
1 0 .6 r
.00177 w
.6244 1.18896 m
.63997 1.22472 L
s
P
p
1 0 .6 r
.00177 w
.6244 1.18896 m
.64957 1.22976 L
s
P
p
1 0 .6 r
.00177 w
.46284 .98926 m
.45436 1.0239 L
s
P
p
1 0 .6 r
.00177 w
.46284 .98926 m
.47689 1.01039 L
s
P
p
1 0 .6 r
.0025 w
.54963 .97198 m
.57666 1.01091 L
s
P
p
1 0 .6 r
.0025 w
.54963 .97198 m
.54091 1.01047 L
s
P
p
1 0 .6 r
.0025 w
.50393 .99939 m
.48875 1.06396 L
s
P
p
1 0 .6 r
.0025 w
.50393 .99939 m
.45715 1.04659 L
s
P
p
1 0 .6 r
.00177 w
.54091 1.01047 m
.53294 1.04568 L
s
P
p
1 0 .6 r
.00177 w
.54091 1.01047 m
.55562 1.03198 L
s
P
p
1 0 .6 r
.00177 w
.45715 1.04659 m
.41443 1.08968 L
s
P
p
1 0 .6 r
.00177 w
.45715 1.04659 m
.44851 1.08215 L
s
P
p
1 0 .6 r
.00177 w
.57666 1.01091 m
.60153 1.04672 L
s
P
p
1 0 .6 r
.00177 w
.57666 1.01091 m
.61772 1.02369 L
s
P
p
1 0 .6 r
.00177 w
.48875 1.06396 m
.47471 1.12367 L
s
P
p
1 0 .6 r
.00177 w
.48875 1.06396 m
.51283 1.10054 L
s
P
p
1 g
.002 w
.83174 .03888 m
.86524 1.35813 L
s
.86524 1.35813 m
.03888 1.4094 L
s
.03888 1.4094 m
.08369 .12288 L
s
.08369 .12288 m
.83174 .03888 L
s
.83174 .03888 m
.86524 1.35813 L
s
.86524 1.35813 m
.96112 1.52559 L
s
.96112 1.52559 m
.92238 .31511 L
s
.92238 .31511 m
.83174 .03888 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 334}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  AnimationDisplayTime->0.913066,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000L=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H6000/e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000IlH900G600<0a/H0:/H1000005kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K62@003/KFa=K6e/KFa]K6e/KF0P00:lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@0005G62@0<aP03a<K600C61<@202_60@00001<e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT0
01?6e/KFa]K6e/KFa]K6e/KFa]K600W400C6e/KF0P00:lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0004?62@04aP03a<K600c62L@2aP03a<K600S600<0aP00:/H10000
03[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
2@004lKFa]K6e/KFa]K6e/KFa=K6e/H02L@0@lKFa]K6e/KFa]K6e/CFa]K6e/KFa]H0eP3Fa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003762@0CaPW45LH00lC6aP07aP03
0<H002[60@00000Xe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaPT001?6e/KF
a]K6a<KFa]K6e/KFa]K600W405G6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KF
0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000SaPD04LH00lC6
a008a0k600?4a/H05lH00lC6aP06aP040<K602W60@00000be/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H9a01Wa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100008lH200C62L@8aP03a<K601K600?4a/H05/H00lC6aP06aP050<K6aP00
:<H1000002CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP05a01ia]K6e/KFa]K6e/KF
a]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KF
a]K6eP3Fa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008lH00`36
000EaP03a<K601K600?4a/H05/H00lC6aP05aP050<K6aP00:<H1000007KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3FaP36e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]H01<@0:036e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008lH01036aP0EaP03a<K601K600?4a/H05LH8a003
0<K600;600<0a/H09LH1000006CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6
2L@0=LK4a]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000SaP050<K6aP005LH00lC6aP0EaP03a<K600?62L@;aP03a<K600?600<0a/H00lH00`36aP0TaP40
0000D]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/H9a017a]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]H0e/KF
a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002?600<0a/H00lH00`36
aP0BaP03a<K600W62<@3aP<05lH00lC6aP04aP030<K600;600<0a/H09<H10000047Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa/C6eP09a00:
e/KFa]K6e/KFaPD004W6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFaP36e/KFaP36e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000SaP030<K600C600<0a/H02lH9a1?61@0GaP03
a<K600?600<0a/H00lH00`36aP0SaP400000;mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFaP36e/KF00W401cFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K61@00BLKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/CFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0002?600<0a/H01LH4a17600?4a/H04/H30003a<K601K600?4a/H00/H00`36aP04aP03
0<K602;60@00001Fe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`1:a<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/CFa]K60<KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
8/H00`36aP07aP030<K601;600?4a/H04/H014loa/@HaP05a<K6aP001/H00`36aP0RaP400000E]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K60Sl08MK4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFaP36
eP05a00T0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H02<H00`36
aP0BaP03a<K6017600E??lK6a00CaPS400<0a<@01LH00`36aP0QaP400000E]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K60Sl02mK6a<KFa]K6e/KF00_403CFa]K6e/CFaP36e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H02LH00`36aP0BaP03a<K6013600=??l@0
2/@@aP04a<K600S600<0a/H08<H1000004gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6eP09a08o02;Fa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K4e/H0a]K61P008]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008/H00`36aP0;aP030<K600o62l@9aP03Cco600;600?4a/H04lH30003a00000<01LH00`36
aP0PaP400000=mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaP36
e/KFa]H02l@05=K6e/CFa]K6e/KFa]K6e/KFa]K60Sl04=K6e/K4a]K6e/KFa]K6e/H9000aa]K6e/H0
a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008/H00`36aP0<aPK4
3/H00lC6aP0>aP03Cco600?600?4aP002@0>aP030<K600K600<0a/H08<H1000005KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
a<KFa]K6e/KFa]K6e/KF008o1@00ALCFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008/H00`36aP0=aP030<K6017600?4a/H0
0/H:0003aTlo01k600<0a/H01/H00`36aP0PaP400000@]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaPD000o40000a]K6e/KFa]K6e/H0
0Sl0B]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H03/H00`36aP03aPT05<H00dloaP0MaP030<K600K6
00<0a/H08<H1000003CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K61@007LKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6008o04[Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000RaP030<K600o600<0a/H07lH00dloaP0MaP030<K600K600<0a/H08<H1000005KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8o04[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000RaP030<K600o600<0a/H07lH00dlo
aP0MaP030<K600K600<0a/H08<H1000005KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04[Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000RaP030<K600o600<0a/H07lH00dloaP0MaP030<K600K600<0a/H08<H10000
05KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o04[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000RaP030<K600o6
00<0a/H07lH00dloaP0MaP030<K600K600<0a/H08<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36aP0?aP030<K601k600<oaSl07/H00`36aP06aP03
0<K602360@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;6
00<0a/H03lH00`36aP0LaP05?lK6aSl07/H00`36aP07aP030<K601o60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;600<0a/H03lH00`36aP0KaP03ClK600;6
00<oa/H07<H00`36aP07aP030<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/KF?mK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@00027600<0a/H04<H00`36aP0JaP03?lK600?600<oa/H07<H00`36aP07aP03
0<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000276
00<0a/H04<H00`36aP0IaP03ClK600C600<oa/H07LH00`36aP06aP030<K601o60@00002Re/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eSoFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H04<H00`36aP0GaP03
ClK600K600<oa/H07LH00`36aP06aP030<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFa]K6
e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H04<H00`36aP0FaP03?do600O600<oa/H07LH00`36
aP06aP030<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@00027600<0a/H03lH00`36aP0FaP03Cco600S600<oa/H07LH00`36aP06aP030<K601o60@00001<
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP8o05CFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0?aP03
0<K601G600<oClH02LH00co6aP0MaP030<K600K600<0a/H07lH100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
?lKFa]K6e/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0?aP030<K601C600=?aTl02/H00cm?
aP0MaP030<K600K600<0a/H07lH1000005OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6?lKFa]K6e/KFa]H00Sl0BLKF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/H00@00027600<0a/H03lH00`36aP0CaP03?lHo00_600<oaSl07LH00`36aP06aP03
0<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6?lKF?mK6e/KFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@000276
00<0a/H03lH00`36aP0BaP04ClK6?`_600@oa/I?7<H00`36aP06aP030<K601o60@000016e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFaP8o05[FaSo6e/KFa]K6e/KFa]Hoe/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0?aP030<K600o6
00<oaSl00/H00do6aP0:aP04?lK6Cac600<0a/H01/H00`36aP0OaP400000BMK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6?lHoa]H0
0Sl0ElKFa]K6e/KFa]K6eSoFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008LH00`36aP0?aP030<K600g600<oaSl0
0/H00dloaP0<aP05?lK6aSl06lH00`36aP06aP030<K601o60@000018e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6?lKF?mK60Sl0F=K6
e/KFa]K6e/KFa]Hoe/KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0?aP030<K600_600@oa/I?0/H00cm?
aP0=aP03?lK600;600=?a/H06<H00`36aP06aP030<K601o60@000010e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP8o00GF?mK6eP02?`1I
a]K6e/KFa]K6e/KFa]Hoe/KFa]Hoe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00027600<0a/H03lH00`36aP09aP05?do6aSl0
0/H00do6C`0>aP03?lK600?600<oClH05lH00`36aP06aP030<K601o60@000015e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/HoaSo6?lKF00<o
01KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K60Sl0@]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600o600<0a/H01lH00co6
?`02aP06ClK6?dlo3lH00co6aP04aP03ClI?01K600<0a/H01/H00`36aP0OaP400000A=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6eP0oa]K6e/KFaSo6?lKF?mK6
13l0F]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KF?mHoe/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP030<K6013600T0ClK6?dloCcl0
0/H00do6C`02aP05?lHoCcl03lH00co6aP05aP04?lK6CaC600<0a/H01lH00`36aP0NaP400000==K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP04?`0:e/Hoa]Ho
e/HoaP<o05g6?coFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/Hoa]Hoe/KFa]K6e/KFa]K6e/KFa]K6eP3F
a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00023600<0a/H03lH01Dlo
a/I?00;600loa/I??lHoaSm?aTloaSl03lH00co6aP07aP05?lK6Ccl04LH00`36aP07aP030<K601k6
0@00000de/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF008o
00GFaSo6eP02?`03a]Ho008o01CF?cloeSoFa]K6e/KFa]K6e/KFaP8o04[Fa]K6e/KFa]Hoe/HoaSo6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000PaP030<K6013601D0ClK6?lHoClI?aTloCco6?lHoCcl03/H00dloaP09aP06ClK6?lHo3lH00`36
aP07aP030<K601k60@00000je/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KF?mK6?lHoaP8o00?FaSl00Sl01LHo?co6008o00kFa]K6e/KFa]K6e/KFaP8o04[Fa]K6
e/KFa]K6?lKF?mK6?lKFa]K6e/KFa]K6e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000PaP030<K6013601D0aSm??lHoaSm??dloCcm??do6Ccl03/H00dloaP0:aP04
?lK6C`;600<oa/H02lH00`36aP07aP030<K601k60@00000de/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF00Do00?6?lH02Sl04=Hoe/KFa]K6e/KFa]K6e/H2?`1:
e/KFa]K6e/KFa]Hoe/KF?mK6?lKFa]K6e/KFa]K6eP3Fa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008<H00`36aP0@aP0=?do6Ccm?aTloCcm??`02aP06Cco6?lHo3LH00co6
?`0<aP04ClK6?`?600<oCcl02LH00`36aP07aP030<K601k60@00000ae/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP02?`0803loeSoF?mH4?`03a]K6008o00?F?mH0
0Sl09LKFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFaSo6e/Hoa]K6?lH01Cl0;lKF?cl0e/KFa]K6e/KF
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000PaP030<K600c600DoClK6?`02aP09
ClI??lHoaSm?00;600ToCcm??do6Ccl02/H014loaSl<aP06Cco6aTlo0lH02co6a/HoaSm??dl000W6
00<0a/H07/H1000003;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
eSoFaP8o00?Fa]H00Sl01lHoaSo6?lH00Sl00mHo?`02?`0MaSo6e/KFa]K6e/KF?mHoeSoFa]K6e/KF
a]K6e/H00Sl00mK6eP02?`0ga]K6?lKFaSo6e/KF?`36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100008<H00`36aP0;aP06ClK6?dl00/H04Do6Ccm??dloClI??do6Ccm?00_6
00=?aTl00/H00co6aP0:aP03ClI?00;600<oaSl00lH01So6a/HoC`?600<0a/H01/H00`36aP0NaP40
0000=MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6eSoFa]HoeP3F00To
00?FaSl013l08<Hoa]K6e/KFa]K6eSoFaSo6eSoFa]K6e/KFa]K6e/KF0Sl00lKFaP03?`07a]K6?lKF
aP02?`0/e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36
aP0>aP08?lH0Ccm??dl2aP0<?lHoaSm?aTloaSm?2LH01Do6a/I?00;600<oa/H02lH00co6?`02aP04
ClI??`?600Doa/K6?`02aP030<K600K600<0a/H07/H1000003GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/Hoa]H0eP04?`06aSloe/KF1Cl02]Ho?lKFa]K6e/H2?`0K
e/KFaSo6eSoFa]K6e/KFa]K6e/KF?mHoe/KF008o00?6?cl00cl0;lKFaSo60<KFa]K6e/KF0=K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000PaP030<K6013600D0Cco6?`02aP09Cco6aTo6
Ccm?00[600<oaSl00lH01Co6a/Ho00g600<oaSl00lH02Co6?dloaSm??`04aP030<K600K600<0a/H0
7/H1000003?Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0
0cl00mHoeP02?`03a]Ho00<o02[6?lKFa]K6e/KFaSo6?lKFa]Hoe/KF?mK6e/KFa]K6e/KFa]Hoe/Ho
a]H3?`0deSloaSo6?lKFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000PaP030<K600o6015?04o6ClI??do6Ccm??do6C`08aP04?lK6C`C600Doa/K6?`0=aP04?lK6C`;6
00@oClI?0/H01Cm?a/Ho00;600<0a/H01/H00`36aP0NaP400000=mK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]HoeSoF?mH00Sl01lHoaSo6?lH00cl04<KFa]K6e/Ho
a]Hoe/KFa]H2?`0@a]Hoe/KFa]K6e/KFa]K6eP8o00C6eSoF0Sl02LHoa]K6eSoFaP02?`0Z0<KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H03<H03Sm?a/HoaSm?
aTloClI?0/H00co6?`06aP06Cco6aTlo1<H01To6aSm??`g600ToClK6?dloaSl01LH00cm?aP02aP03
03m?00K600<0a/H07/H1000002gFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]H00Sl01lHoaSl0?lH01Sl00mK6eP03?`04e/KFaP<o00c6eSoF?mK6e/Hoa]H3?`0Be/KFa]K6
e/KFa]K6eSoF?mK60Sl02=Ho?lKFa]K60Sl0;=K603oFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@00023600<0a/H03<H033o6?dl0Ccm??lHoC`?600=?a/H00lH014loaSl2aP03
ClI?00G600I?a/K6Ccl>aP0:Cco6aTloCco6?`G600HoClH0aTl6aP030<K601k60@00000`e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFaSo60Sl01@0o?coF008o00W6?lKF
aSo6e/H00Sl04]K6?lKFaSo6?lKFa]K6?lKFaP8o01?Fa]K6e/KFa]K6e/KFaSo6?lKF00@o03?6?lKF
a]Hoe/H0a]Hoe/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00023600<0a/H0
2/H02Co6?do6Cco6?`02aP03Ccm?00?600E??dloC`02aP08?lK6aSm?aTl4aP07?lK6aSm??`0>aP03
ClI?00;600DoClI??`06aP03ClH000S600<0a/H07/H1000003;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFaSo6e/HoaP<o00?6e/H00cl04LKF?co6eSoFaSo6e/HoaSo6008o
00WFa]Hoe/KF?mH00Sl03lKFa]K6e/KFa]K6e/HoaP02?`0he/Hoa]Hoe/KFa]K6e/H0a]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0<aP05?lHo03l00lH00cm?
aP03aP04?lK6C`;600<oClH01LH01co6aTo6Ccl00lH01co6?lHoCcl02/H014o6Ccl2aP05ClK6?dl0
1lH00`36aP06aP030<K601k60@00000ae/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6eP02?`03a]K6008o01gFa]K6e/KFa]K6?lHoa]K6e/KF?mK6eSoF?mK6eP03?`04
eSoFaP8o00OFa]K6e/KF008o00W6?coFa]Hoe/H00Sl0<=K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K600k600=?aTl00lH00dloaP08aP03?lHo00[6
00=?aTl00lH014loaSl2aP03ClK600S600HoClI?aTl2aP06?lK6ClI?1LH00`36aP06aP030<K601k6
0@00001We/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]Hoe/Hoa]Ho
eSoFa]K6e/KFaSo6eSoFa]K6e/KFa]Hoe/Hoa]K6?lKF?mK6eSoFa]K6e/KFaSo6eP02?`0iaSloe/Ho
aSo6eSoFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000OaP03
0<K600g600@oaSl00lH00do6aP06aP03?lK600[600E?a/K6C`03aP04ClK6?`C600=?a/H01LH02do6
aSm??do6ClI?00;600Poa/I??do600S600<0a/H07/H10000033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6?lH2?`0I0<KFaSo6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`07
a]Hoe/KFaP02?`0CeSoFa]K6e/KFa]K6e/Hoa]HoeP03?`05eSlo?mH00Sl00lKFaP02?`0Z0<KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H02lH01So6aTo601O6
00=?aTl00/H00co6aP02aP04Cco6?`_600LoaSo6?lHo00;600A?aTlo0/H00dloaP02aP03?`3600O6
00<0a/H07/H1000002cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFaP8o
043F?co60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeSoFa]Hoe/KF?mHoeSoFa]K6e/KFa]K6eSoF?mHo
e/KFaSo60Sl00mK6eP02?`0]a]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000OaP030<K600W600DoClK6?`02aP030<K601?600A?a/Ho0lH01Cm?a/Ho00;600=??dl0
3/H00cm?aP03aP04?lHoC`;600<oa/H00/H00`0oaP07aP030<K601g60@00001Fe/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/Hoa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]Ho
e/KFa]K6eSoF?mHoe/H3?`0>a]K6e/KFa]K6e/KFa]H2?`06a]K6e/KF0Sl0<LKFaSo6e/H0a]K6e/KF
a]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001o600<0a/H02LH00co6aP04aP03
0<K601W600I?a/K6Ccl2aP04Cco6?`g600<oClH01LH00co6?`06aP030<K600O600<0a/H07LH10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/Hoa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6eSoFa]Hoe/Hoa]K6e/KFa]K6e/KF?mHoe/KFa]HoeSoFa]K6
e/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH00`36aP0@aP03
0<K601W600E?a/K6C`04aP04?lK6C`c600<oa/H01LH00co6?`06aP030<K600O600<0a/H07LH10000
05KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lKFaP8o01OFa]Hoe/KFa]K6e/KFa]Hoe/KFa]K6eP02?`0a
aSloe/KFaP36e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007lH00`36
aP0@aP030<K601g600M?a/K6Ccm?00;600<oa/H04LH01Sm?aTo6C`?600<0a/H01lH00`36aP0MaP40
0000E]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K60cl0BLKFaSo6e/KFa]K6e/KFa]K6e/KFa]K6?lKF
?mHoe/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001o600<0a/H0
4<H00`36aP0LaP08?do6aSo6?dl3aP03ClK6017600U??lK6ClI?aP002LH00`36aP0MaP400000D=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60Sl01MK6eSoF008o04W6e/KF?mK6e/KFa]K6e/KFa]K6e/KFaSo6e/Ho
a]Ho0<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000OaP030<K60136
00<0a/H06/H00co6?`03aP05?lHoaSl00lH00cm?aP0EaP04?lK600W600<0a/H07LH1000005gFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF?mHoe/KF?mHoeSoFa]H00Sl0@lKFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/H0
a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001o600<0a/H04<H00`36
aP0IaP03ClI?00C600HoCco6?dl3aP03Cco601G600=?aP002LH00`36aP0MaP400000E]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF?mK6?lKFaSo60Sl01]K6?coFaP8o04;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF0=K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH00`36aP0@aP030<K601O6
00E??lK6C`03aP04ClK6?`;600=?aTl00/H00cm?aP0GaP030<K600K600<0a/H07LH1000004_Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H00Sl02LKF?mK6e/HoaP02?`08e/Hoa]K6e/H2?`10e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K60136
00<0a/H05LH00do6C`02aP03?lK600?600<oaSl00lH00co6aP03aP03?lK601G600<0a/H01/H00`36
aP0MaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/Hoa]Hoe/KFa]HoeSoFa]Hoe/KFa]K6?lKFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP03
0<K6013600<0a/H04lH014o6aSl3aP03?lK600;600A?a/Ho2lH00co6aP0CaP030<K600K600<0a/H0
7LH1000004oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o01;6e/Hoa]Hoe/KFa]K6e/KFa]H2?`0ma]K6e/KF
a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
7lH00`36aP0@aP030<K601[600DoClK6?`03aP03?lK600[600=??lH04/H00`36aP06aP030<K601g6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHoaSo6e/KF?mK6e/KFa]K6e/KFaSo6?lKFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H0
4<H00`36aP0IaP05ClK6?dl01<H00co6aP0;aP03?lK6017600<0a/H01/H00`36aP0MaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6eSoFa]K6eSoFa]K6e/KFa]K6e/KFaSo6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K6017600<0a/H0
6LH00do6C`06aP03?lK601o600<0a/H01/H00`36aP0MaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6
?lKFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K6017600<0a/H06/H00co6aP05aP03?lK601o6
00<0a/H01/H00`36aP0MaP400000C]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o05;Fa]K6e/KF?mK6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001k600<0a/H04LH00`36aP0IaP03ClK600K600<oa/H07lH00`36aP06aP030<K601g6
0@00001Ge/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KFa]K6e/KF008o04W6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000NaP03
0<K6017600<0a/H08/H00cm?aP0GaPT02<H00`36aP0MaP400000EmK6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP02?`09a]K6e/KFa]K600l00376e/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60040000NaP030<K6013600<0a/H07lH?01S600<0a/H01LH00`36aP0MaP40
0000A=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K63`001<KFa]H2?`19a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KF
a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007/H00`36aP0@aP040<K6aPl0
4lH00co6?`0QaP030<K600G600<0a/H07<H1000002KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFaPl006g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHoe/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K60040000NaPP02lH00`36aP0SaP03?lK602;600<0a/H01<H00`36aP0LaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP030<K600g600<0a/H08lH00co6
aP0SaP030<K600?600<0a/H07<H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H100008lH00`36aP0;aP030<K604[600<0a/H00/H00`36aP0LaP400000X]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000UaP030<K600W600<0a/H0BlH01@36
a/H001k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002O6
0P08aP030<K604c600@0a/H07/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H10000:/H00`36aP04aP030<K604g600<0aP007/H1000008;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60P007]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000/aP030<K600;600<0a/H0C/H201k60@00001i
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP0;000Ne/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002k600@0a/H0</HE02W60@00001@
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/HD000ne/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000<<H200W65@1BaP400000<MK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02P00IlKFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@000:;60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@000001\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.0161633, -0.0250051, 
  0.00583381, 0.00583381}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.57418 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Background color
.9 g
MFill
% Scaling calculations
-0.245763 1.52904 0.038226 1.52904 [
[ 0 0 0 0 ]
[ 1 1.57418 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
0 0 m
1 0 L
1 1.57418 L
0 1.57418 L
closepath
clip
newpath
p
1 g
.002 w
.83123 .03823 m
.86467 1.32309 L
s
.86467 1.32309 m
.03823 1.37454 L
s
.03823 1.37454 m
.08331 .12246 L
s
.08331 .12246 m
.83123 .03823 L
s
.92317 .32153 m
.2445 .39019 L
s
.2445 .39019 m
.21908 1.53596 L
s
.21908 1.53596 m
.96177 1.49486 L
s
.96177 1.49486 m
.92317 .32153 L
s
.83123 .03823 m
.86467 1.32309 L
s
.86467 1.32309 m
.96177 1.49486 L
s
.96177 1.49486 m
.92317 .32153 L
s
.92317 .32153 m
.83123 .03823 L
s
.08331 .12246 m
.2445 .39019 L
s
.2445 .39019 m
.21908 1.53596 L
s
.21908 1.53596 m
.03823 1.37454 L
s
.03823 1.37454 m
.08331 .12246 L
s
p
.4 g
.84436 .07869 m
.10628 .1606 L
s
P
p
.4 g
.87598 .17611 m
.16165 .25257 L
s
P
p
.4 g
.90549 .26706 m
.21344 .3386 L
s
P
p
.4 g
.69284 .05381 m
.79788 .3342 L
s
P
p
.4 g
.49187 .07645 m
.61572 .35263 L
s
P
p
.4 g
.29406 .09872 m
.43613 .3708 L
s
P
p
.4 g
.09933 .12066 m
.25907 .38871 L
s
P
P
p
1 0 .6 r
.00125 w
.43888 .81045 m
.44583 .82149 L
s
P
p
1 0 .6 r
.00125 w
.4183 .85192 m
.42536 .86274 L
s
P
p
1 0 .6 r
.00125 w
.4183 .85192 m
.41663 .88034 L
s
P
p
1 0 .6 r
.00125 w
.43888 .81045 m
.44933 .80801 L
s
P
p
1 0 .6 r
.00125 w
.4299 .81748 m
.43415 .82416 L
s
P
p
1 0 .6 r
.00125 w
.4299 .81748 m
.42885 .83484 L
s
P
p
1 0 .6 r
.00177 w
.43108 .79806 m
.43888 .81045 L
s
P
p
1 0 .6 r
.00177 w
.42018 .82 m
.4183 .85192 L
s
P
p
1 0 .6 r
.00125 w
.40973 .85084 m
.40874 .86814 L
s
P
p
1 0 .6 r
.00177 w
.43108 .79806 m
.4299 .81748 L
s
P
p
1 0 .6 r
.00125 w
.37805 .9017 m
.38537 .91234 L
s
P
p
1 0 .6 r
.00125 w
.37805 .9017 m
.37656 .93008 L
s
P
p
1 0 .6 r
.00125 w
.40973 .85084 m
.40036 .87851 L
s
P
p
1 0 .6 r
.00177 w
.42018 .82 m
.40973 .85084 L
s
P
p
1 0 .6 r
.0025 w
.42229 .78412 m
.43108 .79806 L
s
P
p
1 0 .6 r
.0025 w
.42229 .78412 m
.42018 .82 L
s
P
p
1 0 .6 r
.00125 w
.40924 .82386 m
.41359 .83057 L
s
P
p
1 0 .6 r
.00125 w
.40924 .82386 m
.40824 .84134 L
s
P
p
1 0 .6 r
.00177 w
.37971 .86983 m
.37805 .9017 L
s
P
p
1 0 .6 r
.00125 w
.36926 .90081 m
.36838 .91809 L
s
P
p
1 0 .6 r
.00125 w
.345 .94257 m
.34368 .97091 L
s
P
p
1 0 .6 r
.00177 w
.41035 .80432 m
.40924 .82386 L
s
P
p
1 0 .6 r
.00125 w
.36926 .90081 m
.35987 .92862 L
s
P
p
1 0 .6 r
.00125 w
.40399 .82314 m
.40339 .83375 L
s
P
p
1 0 .6 r
.00125 w
.38936 .84829 m
.38843 .86576 L
s
P
p
1 0 .6 r
.00125 w
.345 .94257 m
.32953 .98847 L
s
P
p
1 0 .6 r
.00125 w
.40399 .82314 m
.39827 .84005 L
s
P
p
1 0 .6 r
.00177 w
.37971 .86983 m
.36926 .90081 L
s
P
p
1 0 .6 r
.00125 w
.38936 .84829 m
.37993 .87622 L
s
P
p
1 0 .6 r
.00353 w
.42467 .74372 m
.42229 .78412 L
s
P
p
1 0 .6 r
.00177 w
.41035 .80432 m
.40399 .82314 L
s
P
p
1 0 .6 r
.0025 w
.4116 .78244 m
.41035 .80432 L
s
P
p
1 0 .6 r
.0025 w
.38159 .83399 m
.37971 .86983 L
s
P
p
1 0 .6 r
.00177 w
.39988 .81716 m
.38936 .84829 L
s
P
p
1 0 .6 r
.00177 w
.36228 .89129 m
.345 .94257 L
s
P
p
1 0 .6 r
.00177 w
.39988 .81716 m
.38676 .83959 L
s
P
p
1 0 .6 r
.0025 w
.4116 .78244 m
.39988 .81716 L
s
P
p
1 0 .6 r
.00125 w
.38676 .83959 m
.38104 .85656 L
s
P
p
1 0 .6 r
.02 w
.55218 .23718 m
.55266 .41248 L
s
P
p
1 g
.05 w
.55218 .23718 Mdot
P
p
1 0 .6 r
.00125 w
.38676 .83959 m
.37493 .85983 L
s
P
p
1 0 .6 r
.00177 w
.36228 .89129 m
.34048 .9286 L
s
P
p
1 0 .6 r
.0025 w
.38159 .83399 m
.36228 .89129 L
s
P
p
1 0 .6 r
.00125 w
.34048 .9286 m
.33108 .95655 L
s
P
p
1 0 .6 r
.00353 w
.42467 .74372 m
.4116 .78244 L
s
P
p
1 0 .6 r
.00125 w
.34048 .9286 m
.32079 .9623 L
s
P
p
1 0 .6 r
.00125 w
.35389 .88227 m
.35305 .89978 L
s
P
p
1 0 .6 r
.005 w
.42736 .69815 m
.42467 .74372 L
s
P
p
1 0 .6 r
.00125 w
.39076 .79998 m
.39522 .80685 L
s
P
p
1 0 .6 r
.00125 w
.39076 .79998 m
.38981 .81775 L
s
P
p
1 0 .6 r
.00353 w
.40318 .76989 m
.38159 .83399 L
s
P
p
1 0 .6 r
.00125 w
.35389 .88227 m
.34443 .91038 L
s
P
p
1 0 .6 r
.00125 w
.65322 .99831 m
.64396 1.0264 L
s
P
p
1 0 .6 r
.00125 w
.31775 .93484 m
.32554 .9455 L
s
P
p
1 0 .6 r
.00125 w
.65322 .99831 m
.63712 1.00747 L
s
P
p
1 0 .6 r
.00125 w
.31775 .93484 m
.31655 .96359 L
s
P
p
1 0 .6 r
.00177 w
.36443 .85093 m
.35389 .88227 L
s
P
p
1 0 .6 r
.00177 w
.39182 .7801 m
.39076 .79998 L
s
P
p
1 0 .6 r
.00125 w
.3854 .79919 m
.38483 .80998 L
s
P
p
1 0 .6 r
.00125 w
.37057 .82463 m
.36967 .84239 L
s
P
p
1 0 .6 r
.00353 w
.40318 .76989 m
.37618 .81598 L
s
P
p
1 0 .6 r
.005 w
.42736 .69815 m
.40318 .76989 L
s
P
p
1 0 .6 r
.00177 w
.36443 .85093 m
.35116 .87359 L
s
P
p
1 0 .6 r
.0025 w
.37618 .81598 m
.36443 .85093 L
s
P
p
1 0 .6 r
.00125 w
.35116 .87359 m
.34542 .89067 L
s
P
p
1 0 .6 r
.00125 w
.3854 .79919 m
.37963 .81633 L
s
P
p
1 0 .6 r
.00125 w
.37057 .82463 m
.36104 .85295 L
s
P
p
1 0 .6 r
.00125 w
.35116 .87359 m
.33919 .89403 L
s
P
p
1 0 .6 r
.00177 w
.39182 .7801 m
.3854 .79919 L
s
P
p
1 0 .6 r
.0025 w
.37618 .81598 m
.35177 .85765 L
s
P
p
1 0 .6 r
.00125 w
.6893 1.04406 m
.67983 1.07204 L
s
P
p
1 0 .6 r
.0025 w
.39302 .75785 m
.39182 .7801 L
s
P
p
1 0 .6 r
.00177 w
.38118 .79306 m
.37057 .82463 L
s
P
p
1 0 .6 r
.00177 w
.66361 .96677 m
.65322 .99831 L
s
P
p
1 0 .6 r
.00125 w
.66765 .99897 m
.66197 1.01606 L
s
P
p
1 0 .6 r
.00177 w
.3191 .90254 m
.31775 .93484 L
s
P
p
1 0 .6 r
.00707 w
.45444 .61779 m
.42736 .69815 L
s
P
p
1 0 .6 r
.00125 w
.6893 1.04406 m
.69521 1.09161 L
s
P
p
1 0 .6 r
.00177 w
.35177 .85765 m
.3297 .89531 L
s
P
p
1 0 .6 r
.00177 w
.35177 .85765 m
.3326 .87686 L
s
P
p
1 0 .6 r
.00125 w
.30854 .93407 m
.30784 .95158 L
s
P
p
1 0 .6 r
.00125 w
.28369 .97671 m
.28265 1.00543 L
s
P
p
1 0 .6 r
.00177 w
.38118 .79306 m
.36787 .81575 L
s
P
p
1 0 .6 r
.0025 w
.39302 .75785 m
.38118 .79306 L
s
P
p
1 0 .6 r
.00125 w
.66765 .99897 m
.67126 1.02784 L
s
P
p
1 0 .6 r
.00125 w
.3297 .89531 m
.32021 .92362 L
s
P
p
1 0 .6 r
.00125 w
.36787 .81575 m
.3621 .83295 L
s
P
p
1 0 .6 r
.00125 w
.36787 .81575 m
.35587 .83622 L
s
P
p
1 0 .6 r
.00125 w
.37612 .78723 m
.37556 .79811 L
s
P
p
1 0 .6 r
.00125 w
.30854 .93407 m
.29907 .96236 L
s
P
p
1 0 .6 r
.00125 w
.3297 .89531 m
.30977 .92933 L
s
P
p
1 0 .6 r
.00353 w
.40622 .71858 m
.39302 .75785 L
s
P
p
1 0 .6 r
.00177 w
.66361 .96677 m
.66765 .99897 L
s
P
p
1 0 .6 r
.01414 w
.55266 .41248 m
.5531 .57461 L
s
P
p
1 0 .6 r
.01414 w
.55266 .41248 m
.4848 .52768 L
s
P
p
1 0 .6 r
.00125 w
.37612 .78723 m
.37032 .80449 L
s
P
p
1 0 .6 r
.00125 w
.28369 .97671 m
.26808 1.02342 L
s
P
p
1 0 .6 r
.00177 w
.6827 .99086 m
.6893 1.04406 L
s
P
p
1 0 .6 r
.00177 w
.3191 .90254 m
.30854 .93407 L
s
P
p
1 0 .6 r
.00177 w
.38257 .76801 m
.37612 .78723 L
s
P
p
1 0 .6 r
.00707 w
.45444 .61779 m
.42096 .67474 L
s
P
p
1 0 .6 r
.01 w
.4848 .52768 m
.45444 .61779 L
s
P
p
1 0 .6 r
.00353 w
.40622 .71858 m
.38976 .7466 L
s
P
p
1 0 .6 r
.005 w
.42096 .67474 m
.40622 .71858 L
s
P
p
1 0 .6 r
.00125 w
.3326 .87686 m
.31521 .89429 L
s
P
p
1 0 .6 r
.00125 w
.3326 .87686 m
.32053 .89745 L
s
P
p
1 0 .6 r
.0025 w
.6753 .93131 m
.66361 .96677 L
s
P
p
1 0 .6 r
.00177 w
.38257 .76801 m
.37449 .78177 L
s
P
p
1 0 .6 r
.0025 w
.38976 .7466 m
.38257 .76801 L
s
P
p
1 0 .6 r
.00125 w
.37449 .78177 m
.37098 .79224 L
s
P
p
1 0 .6 r
.00125 w
.34069 .84028 m
.33988 .85816 L
s
P
p
1 0 .6 r
.0025 w
.32062 .86621 m
.3191 .90254 L
s
P
p
1 0 .6 r
.00125 w
.37449 .78177 m
.36721 .79417 L
s
P
p
1 0 .6 r
.00177 w
.30113 .92453 m
.28369 .97671 L
s
P
p
1 0 .6 r
.00125 w
.70223 1.03116 m
.7058 1.06011 L
s
P
p
1 0 .6 r
.0025 w
.38976 .7466 m
.3749 .7719 L
s
P
p
1 0 .6 r
.00125 w
.34069 .84028 m
.33112 .86885 L
s
P
p
1 0 .6 r
.00177 w
.6827 .99086 m
.70223 1.03116 L
s
P
p
1 0 .6 r
.0025 w
.6753 .93131 m
.6827 .99086 L
s
P
p
1 0 .6 r
.005 w
.42096 .67474 m
.39065 .72629 L
s
P
p
1 0 .6 r
.00177 w
.3749 .7719 m
.3615 .79472 L
s
P
p
1 0 .6 r
.00177 w
.3749 .7719 m
.36331 .78335 L
s
P
p
1 0 .6 r
.00125 w
.3615 .79472 m
.35569 .81206 L
s
P
p
1 0 .6 r
.00125 w
.70223 1.03116 m
.71983 1.06748 L
s
P
p
1 0 .6 r
.00177 w
.35135 .80843 m
.34069 .84028 L
s
P
p
1 0 .6 r
.00125 w
.3615 .79472 m
.34941 .8153 L
s
P
p
1 0 .6 r
.00177 w
.30113 .92453 m
.27878 .96263 L
s
P
p
1 0 .6 r
.0025 w
.32062 .86621 m
.30113 .92453 L
s
P
p
1 0 .6 r
.00125 w
.69979 .98349 m
.69396 1.00077 L
s
P
p
1 0 .6 r
.01 w
.4848 .52768 m
.42302 .63256 L
s
P
p
1 0 .6 r
.00125 w
.27878 .96263 m
.26929 .99107 L
s
P
p
1 0 .6 r
.00353 w
.39065 .72629 m
.36324 .77291 L
s
P
p
1 0 .6 r
.00353 w
.39065 .72629 m
.36696 .74953 L
s
P
p
1 0 .6 r
.00125 w
.69979 .98349 m
.70337 1.01265 L
s
P
p
1 0 .6 r
.00125 w
.36331 .78335 m
.35282 .79371 L
s
P
p
1 0 .6 r
.00125 w
.36331 .78335 m
.35599 .79581 L
s
P
p
1 0 .6 r
.00177 w
.35135 .80843 m
.33788 .83136 L
s
P
p
1 0 .6 r
.0025 w
.36324 .77291 m
.35135 .80843 L
s
P
p
1 0 .6 r
.00125 w
.33788 .83136 m
.33208 .84871 L
s
P
p
1 0 .6 r
.00125 w
.27878 .96263 m
.2586 .99705 L
s
P
p
1 0 .6 r
.00353 w
.66701 .8646 m
.6753 .93131 L
s
P
p
1 0 .6 r
.00125 w
.29224 .91551 m
.29158 .93326 L
s
P
p
1 0 .6 r
.00125 w
.75681 1.07939 m
.74687 1.10755 L
s
P
p
1 0 .6 r
.00125 w
.33788 .83136 m
.32574 .85204 L
s
P
p
1 0 .6 r
.00177 w
.69578 .95095 m
.69979 .98349 L
s
P
p
1 0 .6 r
.00353 w
.34243 .80097 m
.32062 .86621 L
s
P
p
1 0 .6 r
.0025 w
.36324 .77291 m
.33846 .81507 L
s
P
p
1 0 .6 r
.00125 w
.29224 .91551 m
.28269 .94413 L
s
P
p
1 0 .6 r
.00125 w
.75681 1.07939 m
.76258 1.12744 L
s
P
p
1 0 .6 r
.00125 w
.70768 .97547 m
.70985 .99318 L
s
P
p
1 0 .6 r
.00177 w
.69578 .95095 m
.70768 .97547 L
s
P
p
1 0 .6 r
.0025 w
.69132 .91464 m
.69578 .95095 L
s
P
p
1 0 .6 r
.00177 w
.30288 .88361 m
.29224 .91551 L
s
P
p
1 0 .6 r
.00177 w
.33846 .81507 m
.31606 .85317 L
s
P
p
1 0 .6 r
.00177 w
.33846 .81507 m
.31897 .83436 L
s
P
p
1 0 .6 r
.00707 w
.42302 .63256 m
.36684 .72794 L
s
P
p
1 0 .6 r
.00707 w
.42302 .63256 m
.37451 .67945 L
s
P
p
1 0 .6 r
.00125 w
.70768 .97547 m
.7184 .99756 L
s
P
p
1 0 .6 r
.00125 w
.31606 .85317 m
.30646 .88194 L
s
P
p
1 0 .6 r
.0025 w
.36696 .74953 m
.34541 .77067 L
s
P
p
1 0 .6 r
.0025 w
.36696 .74953 m
.35194 .77506 L
s
P
p
1 0 .6 r
.00353 w
.66701 .8646 m
.69132 .91464 L
s
P
p
1 0 .6 r
.005 w
.65772 .78977 m
.66701 .8646 L
s
P
p
1 0 .6 r
.00353 w
.34243 .80097 m
.31474 .84804 L
s
P
p
1 0 .6 r
.005 w
.36684 .72794 m
.34243 .80097 L
s
P
p
1 0 .6 r
.01 w
.5531 .57461 m
.55351 .72419 L
s
P
p
1 0 .6 r
.01 w
.5531 .57461 m
.60805 .68762 L
s
P
p
1 0 .6 r
.00177 w
.30288 .88361 m
.28928 .90676 L
s
P
p
1 0 .6 r
.0025 w
.31474 .84804 m
.30288 .88361 L
s
P
p
1 0 .6 r
.00125 w
.28928 .90676 m
.28348 .92414 L
s
P
p
1 0 .6 r
.00125 w
.73299 1.00045 m
.73654 1.02976 L
s
P
p
1 0 .6 r
.00125 w
.31606 .85317 m
.29583 .88759 L
s
P
p
1 0 .6 r
.00177 w
.75036 1.02563 m
.75681 1.07939 L
s
P
p
1 0 .6 r
.0025 w
.69132 .91464 m
.71323 .95977 L
s
P
p
1 0 .6 r
.00177 w
.35194 .77506 m
.33838 .79809 L
s
P
p
1 0 .6 r
.00177 w
.35194 .77506 m
.34017 .78663 L
s
P
p
1 0 .6 r
.00125 w
.23225 1.00535 m
.23147 1.03438 L
s
P
p
1 0 .6 r
.00125 w
.33838 .79809 m
.33254 .81558 L
s
P
p
1 0 .6 r
.00125 w
.28928 .90676 m
.27701 .92764 L
s
P
p
1 0 .6 r
.00177 w
.71323 .95977 m
.73299 1.00045 L
s
P
p
1 0 .6 r
.00177 w
.71323 .95977 m
.73591 .98191 L
s
P
p
1 0 .6 r
.00125 w
.33838 .79809 m
.32616 .81887 L
s
P
p
1 0 .6 r
.0025 w
.31474 .84804 m
.28971 .8906 L
s
P
p
1 0 .6 r
.00125 w
.73299 1.00045 m
.7508 1.03712 L
s
P
p
1 0 .6 r
.00707 w
.60805 .68762 m
.65772 .78977 L
s
P
p
1 0 .6 r
.00707 w
.60805 .68762 m
.66466 .74147 L
s
P
p
1 0 .6 r
.00125 w
.31897 .83436 m
.30127 .85186 L
s
P
p
1 0 .6 r
.00125 w
.31897 .83436 m
.30671 .8552 L
s
P
p
1 0 .6 r
.00125 w
.7702 1.06648 m
.77368 1.09574 L
s
P
p
1 0 .6 r
.00125 w
.34017 .78663 m
.32954 .79709 L
s
P
p
1 0 .6 r
.00125 w
.34017 .78663 m
.33277 .7992 L
s
P
p
1 0 .6 r
.00125 w
.23225 1.00535 m
.21652 1.05273 L
s
P
p
1 0 .6 r
.005 w
.36684 .72794 m
.31579 .81459 L
s
P
p
1 0 .6 r
.00177 w
.75036 1.02563 m
.7702 1.06648 L
s
P
p
1 0 .6 r
.0025 w
.74313 .96545 m
.75036 1.02563 L
s
P
p
1 0 .6 r
.00177 w
.34541 .77067 m
.32583 .78987 L
s
P
p
1 0 .6 r
.00177 w
.34541 .77067 m
.33268 .77336 L
s
P
p
1 0 .6 r
.00177 w
.28971 .8906 m
.26709 .92907 L
s
P
p
1 0 .6 r
.00177 w
.28971 .8906 m
.26989 .91034 L
s
P
p
1 0 .6 r
.005 w
.65772 .78977 m
.7026 .88208 L
s
P
p
1 0 .6 r
.00125 w
.26709 .92907 m
.25751 .95789 L
s
P
p
1 0 .6 r
.00125 w
.73591 .98191 m
.75646 1.00196 L
s
P
p
1 0 .6 r
.00125 w
.73591 .98191 m
.74671 1.00413 L
s
P
p
1 0 .6 r
.00125 w
.7702 1.06648 m
.78808 1.10329 L
s
P
p
1 0 .6 r
.00125 w
.72505 .91815 m
.71908 .93585 L
s
P
p
1 0 .6 r
.00177 w
.24982 .95242 m
.23225 1.00535 L
s
P
p
1 0 .6 r
.00125 w
.26709 .92907 m
.24666 .96382 L
s
P
p
1 0 .6 r
.00125 w
.72505 .91815 m
.72864 .9478 L
s
P
p
1 0 .6 r
.00353 w
.7026 .88208 m
.74313 .96545 L
s
P
p
1 0 .6 r
.00353 w
.7026 .88208 m
.7492 .92712 L
s
P
p
1 0 .6 r
.00125 w
.5998 1.11704 m
.62736 1.14163 L
s
P
p
1 0 .6 r
.00125 w
.58469 1.14273 m
.59874 1.19031 L
s
P
p
1 0 .6 r
.00125 w
.81277 1.10868 m
.81842 1.15714 L
s
P
p
1 0 .6 r
.00125 w
.29268 .84807 m
.29201 .86626 L
s
P
p
1 0 .6 r
.00353 w
.31579 .81459 m
.26946 .89325 L
s
P
p
1 0 .6 r
.00353 w
.31579 .81459 m
.27524 .85451 L
s
P
p
1 0 .6 r
.0025 w
.74313 .96545 m
.77973 1.04073 L
s
P
p
1 0 .6 r
.00177 w
.72106 .88507 m
.72505 .91815 L
s
P
p
1 0 .6 r
.00125 w
.5998 1.11704 m
.60828 1.14589 L
s
P
p
1 0 .6 r
.00125 w
.32583 .78987 m
.30806 .8073 L
s
P
p
1 0 .6 r
.00125 w
.32583 .78987 m
.31351 .81078 L
s
P
p
1 0 .6 r
.00125 w
.26989 .91034 m
.2519 .92824 L
s
P
p
1 0 .6 r
.00125 w
.26989 .91034 m
.25751 .93137 L
s
P
p
1 0 .6 r
.00177 w
.24982 .95242 m
.22701 .99119 L
s
P
p
1 0 .6 r
.0025 w
.26946 .89325 m
.24982 .95242 L
s
P
p
1 0 .6 r
.00125 w
.33268 .77336 m
.32113 .7758 L
s
P
p
1 0 .6 r
.00125 w
.33268 .77336 m
.32196 .78385 L
s
P
p
1 0 .6 r
.00125 w
.22701 .99119 m
.21745 1.02004 L
s
P
p
1 0 .6 r
.00125 w
.29268 .84807 m
.28301 .87716 L
s
P
p
1 0 .6 r
.00177 w
.77973 1.04073 m
.81277 1.10868 L
s
P
p
1 0 .6 r
.00177 w
.77973 1.04073 m
.81798 1.07816 L
s
P
p
1 0 .6 r
.00125 w
.58469 1.14273 m
.57598 1.18239 L
s
P
p
1 0 .6 r
.005 w
.37451 .67945 m
.32992 .72255 L
s
P
p
1 0 .6 r
.005 w
.37451 .67945 m
.34352 .73197 L
s
P
p
1 0 .6 r
.00125 w
.73312 .90986 m
.73528 .92787 L
s
P
p
1 0 .6 r
.00177 w
.56898 1.08955 m
.5998 1.11704 L
s
P
p
1 0 .6 r
.00177 w
.56898 1.08955 m
.58469 1.14273 L
s
P
p
1 0 .6 r
.00177 w
.72106 .88507 m
.73312 .90986 L
s
P
p
1 0 .6 r
.0025 w
.7166 .84815 m
.72106 .88507 L
s
P
p
1 0 .6 r
.005 w
.66466 .74147 m
.71642 .79071 L
s
P
p
1 0 .6 r
.005 w
.66466 .74147 m
.69197 .79756 L
s
P
p
1 0 .6 r
.00125 w
.22701 .99119 m
.20641 1.02621 L
s
P
p
1 0 .6 r
.00125 w
.73312 .90986 m
.74398 .93219 L
s
P
p
1 0 .6 r
.00125 w
.81277 1.10868 m
.84258 1.16999 L
s
P
p
1 0 .6 r
.00177 w
.30346 .81564 m
.29268 .84807 L
s
P
p
1 0 .6 r
.00125 w
.51012 1.18956 m
.52444 1.2372 L
s
P
p
1 0 .6 r
.00353 w
.69197 .79756 m
.7166 .84815 L
s
P
p
1 0 .6 r
.00353 w
.69197 .79756 m
.7202 .82454 L
s
P
p
1 0 .6 r
.00707 w
.55351 .72419 m
.55389 .86191 L
s
P
p
1 0 .6 r
.00707 w
.55351 .72419 m
.53648 .79573 L
s
P
p
1 0 .6 r
.0025 w
.26946 .89325 m
.22744 .96458 L
s
P
p
1 0 .6 r
.00353 w
.34352 .73197 m
.31548 .77948 L
s
P
p
1 0 .6 r
.00353 w
.34352 .73197 m
.31912 .75568 L
s
P
p
1 0 .6 r
.00125 w
.55022 1.11176 m
.55882 1.14074 L
s
P
p
1 0 .6 r
.00125 w
.75883 .9349 m
.76237 .96471 L
s
P
p
1 0 .6 r
.0025 w
.7166 .84815 m
.73881 .89377 L
s
P
p
1 0 .6 r
.00177 w
.30346 .81564 m
.28968 .83901 L
s
P
p
1 0 .6 r
.0025 w
.31548 .77948 m
.30346 .81564 L
s
P
p
1 0 .6 r
.00125 w
.7915 1.01403 m
.79498 1.04369 L
s
P
p
1 0 .6 r
.0025 w
.7492 .92712 m
.79169 .96818 L
s
P
p
1 0 .6 r
.0025 w
.7492 .92712 m
.77145 .97283 L
s
P
p
1 0 .6 r
.00125 w
.28968 .83901 m
.28382 .85667 L
s
P
p
1 0 .6 r
.0025 w
.55142 1.03007 m
.56898 1.08955 L
s
P
p
1 0 .6 r
.00125 w
.55022 1.11176 m
.54495 1.13586 L
s
P
p
1 0 .6 r
.00125 w
.51012 1.18956 m
.50143 1.22935 L
s
P
p
1 0 .6 r
.00177 w
.73881 .89377 m
.75883 .9349 L
s
P
p
1 0 .6 r
.00177 w
.73881 .89377 m
.76186 .91597 L
s
P
p
1 0 .6 r
.00177 w
.77145 .97283 m
.7915 1.01403 L
s
P
p
1 0 .6 r
.00177 w
.77145 .97283 m
.79461 .99529 L
s
P
p
1 0 .6 r
.00125 w
.28968 .83901 m
.27726 .86008 L
s
P
p
1 0 .6 r
.00177 w
.54063 1.07945 m
.55022 1.11176 L
s
P
p
1 0 .6 r
.00125 w
.53094 1.12381 m
.52223 1.16368 L
s
P
p
1 0 .6 r
.00177 w
.49412 1.1363 m
.51012 1.18956 L
s
P
p
1 0 .6 r
.00125 w
.75883 .9349 m
.77688 .97198 L
s
P
p
1 0 .6 r
.0025 w
.31548 .77948 m
.29013 .82244 L
s
P
p
1 0 .6 r
.00125 w
.7915 1.01403 m
.80958 1.05118 L
s
P
p
1 0 .6 r
.00125 w
.47814 1.20964 m
.4638 1.27548 L
s
P
p
1 0 .6 r
.00125 w
.81798 1.07816 m
.85277 1.11219 L
s
P
p
1 0 .6 r
.00125 w
.81798 1.07816 m
.83609 1.11536 L
s
P
p
1 0 .6 r
.00125 w
.53094 1.12381 m
.51053 1.14854 L
s
P
p
1 0 .6 r
.00177 w
.54063 1.07945 m
.53094 1.12381 L
s
P
p
1 0 .6 r
.00177 w
.22744 .96458 m
.18936 1.02924 L
s
P
p
1 0 .6 r
.00177 w
.22744 .96458 m
.19373 .99822 L
s
P
p
1 0 .6 r
.00125 w
.74581 .87712 m
.74797 .89527 L
s
P
p
1 0 .6 r
.0025 w
.7202 .82454 m
.7458 .84901 L
s
P
p
1 0 .6 r
.0025 w
.7202 .82454 m
.73367 .8522 L
s
P
p
1 0 .6 r
.0025 w
.55142 1.03007 m
.54063 1.07945 L
s
P
p
1 0 .6 r
.00125 w
.47814 1.20964 m
.44428 1.25068 L
s
P
p
1 0 .6 r
.00177 w
.49412 1.1363 m
.47814 1.20964 L
s
P
p
1 0 .6 r
.00125 w
.18936 1.02924 m
.17353 1.07717 L
s
P
p
1 0 .6 r
.00177 w
.73367 .8522 m
.74581 .87712 L
s
P
p
1 0 .6 r
.00177 w
.73367 .8522 m
.74762 .86556 L
s
P
p
1 0 .6 r
.00353 w
.53176 .96349 m
.55142 1.03007 L
s
P
p
1 0 .6 r
.00125 w
.74581 .87712 m
.75675 .89957 L
s
P
p
1 0 .6 r
.00177 w
.29013 .82244 m
.26722 .86127 L
s
P
p
1 0 .6 r
.00177 w
.29013 .82244 m
.27005 .84212 L
s
P
p
1 0 .6 r
.0025 w
.27524 .85451 m
.2381 .89106 L
s
P
p
1 0 .6 r
.0025 w
.27524 .85451 m
.24974 .89773 L
s
P
p
1 0 .6 r
.00125 w
.76186 .91597 m
.78273 .93607 L
s
P
p
1 0 .6 r
.00125 w
.76186 .91597 m
.7728 .93844 L
s
P
p
1 0 .6 r
.00125 w
.79461 .99529 m
.81559 1.01564 L
s
P
p
1 0 .6 r
.00125 w
.79461 .99529 m
.80557 1.0178 L
s
P
p
1 0 .6 r
.00125 w
.26722 .86127 m
.25751 .89056 L
s
P
p
1 0 .6 r
.0025 w
.51192 1.05458 m
.49412 1.1363 L
s
P
p
1 0 .6 r
.0025 w
.31912 .75568 m
.29693 .77725 L
s
P
p
1 0 .6 r
.0025 w
.31912 .75568 m
.30375 .78169 L
s
P
p
1 0 .6 r
.00353 w
.71642 .79071 m
.76368 .83566 L
s
P
p
1 0 .6 r
.00353 w
.71642 .79071 m
.75519 .80008 L
s
P
p
1 0 .6 r
.00125 w
.74762 .86556 m
.76023 .87763 L
s
P
p
1 0 .6 r
.00125 w
.74762 .86556 m
.75425 .87915 L
s
P
p
1 0 .6 r
.00125 w
.18936 1.02924 m
.15487 1.08779 L
s
P
p
1 0 .6 r
.00125 w
.46036 1.14973 m
.45166 1.18976 L
s
P
p
1 0 .6 r
.00125 w
.26722 .86127 m
.24651 .89634 L
s
P
p
1 0 .6 r
.0025 w
.51192 1.05458 m
.47004 1.10518 L
s
P
p
1 0 .6 r
.00353 w
.53176 .96349 m
.51192 1.05458 L
s
P
p
1 0 .6 r
.00177 w
.79169 .96818 m
.83038 1.00556 L
s
P
p
1 0 .6 r
.00177 w
.79169 .96818 m
.82357 .97694 L
s
P
p
1 0 .6 r
.00177 w
.30375 .78169 m
.28989 .80516 L
s
P
p
1 0 .6 r
.00177 w
.30375 .78169 m
.29164 .79349 L
s
P
p
1 0 .6 r
.00177 w
.24974 .89773 m
.22669 .9368 L
s
P
p
1 0 .6 r
.00177 w
.24974 .89773 m
.22943 .9178 L
s
P
p
1 0 .6 r
.00125 w
.28989 .80516 m
.28398 .82298 L
s
P
p
1 0 .6 r
.00177 w
.7458 .84901 m
.76901 .87118 L
s
P
p
1 0 .6 r
.00177 w
.7458 .84901 m
.76486 .85382 L
s
P
p
1 0 .6 r
.00125 w
.22669 .9368 m
.21703 .96604 L
s
P
p
1 0 .6 r
.00353 w
.32992 .72255 m
.28901 .7621 L
s
P
p
1 0 .6 r
.00353 w
.32992 .72255 m
.30326 .72767 L
s
P
p
1 0 .6 r
.00125 w
.46036 1.14973 m
.4398 1.17459 L
s
P
p
1 0 .6 r
.00177 w
.47004 1.10518 m
.46036 1.14973 L
s
P
p
1 0 .6 r
.00125 w
.28989 .80516 m
.27738 .82634 L
s
P
p
1 0 .6 r
.00177 w
.47004 1.10518 m
.43224 1.15084 L
s
P
p
1 0 .6 r
.005 w
.55389 .86191 m
.53176 .96349 L
s
P
p
1 0 .6 r
.00125 w
.22669 .9368 m
.20587 .97209 L
s
P
p
1 0 .6 r
.00125 w
.27005 .84212 m
.25183 .85999 L
s
P
p
1 0 .6 r
.00125 w
.27005 .84212 m
.25751 .86336 L
s
P
p
1 0 .6 r
.00125 w
.43224 1.15084 m
.39814 1.19205 L
s
P
p
1 0 .6 r
.00125 w
.43224 1.15084 m
.39497 1.16617 L
s
P
p
1 0 .6 r
.00125 w
.29164 .79349 m
.28068 .80417 L
s
P
p
1 0 .6 r
.00125 w
.29164 .79349 m
.28407 .80631 L
s
P
p
1 0 .6 r
.005 w
.55389 .86191 m
.55423 .98843 L
s
P
p
1 0 .6 r
.00177 w
.29693 .77725 m
.27676 .79684 L
s
P
p
1 0 .6 r
.00177 w
.29693 .77725 m
.28373 .78001 L
s
P
p
1 0 .6 r
.00125 w
.76901 .87118 m
.79003 .89127 L
s
P
p
1 0 .6 r
.00125 w
.76901 .87118 m
.78002 .89376 L
s
P
p
1 0 .6 r
.00125 w
.19373 .99822 m
.16297 1.02893 L
s
P
p
1 0 .6 r
.00125 w
.19373 .99822 m
.17282 1.03369 L
s
P
p
1 0 .6 r
.00125 w
.76486 .85382 m
.78214 .85818 L
s
P
p
1 0 .6 r
.00125 w
.76486 .85382 m
.77756 .86593 L
s
P
p
1 0 .6 r
.00125 w
.22943 .9178 m
.21101 .93601 L
s
P
p
1 0 .6 r
.00125 w
.22943 .9178 m
.21682 .93916 L
s
P
p
1 0 .6 r
.00125 w
.83038 1.00556 m
.86556 1.03957 L
s
P
p
1 0 .6 r
.00125 w
.83038 1.00556 m
.84866 1.04307 L
s
P
p
1 0 .6 r
.00125 w
.80652 .92346 m
.81001 .95365 L
s
P
p
1 0 .6 r
.0025 w
.76368 .83566 m
.80677 .87665 L
s
P
p
1 0 .6 r
.0025 w
.76368 .83566 m
.78621 .88183 L
s
P
p
1 0 .6 r
.00177 w
.2381 .89106 m
.20415 .92448 L
s
P
p
1 0 .6 r
.00177 w
.2381 .89106 m
.21568 .89658 L
s
P
p
1 0 .6 r
.00125 w
.82357 .97694 m
.85262 .98492 L
s
P
p
1 0 .6 r
.00125 w
.82357 .97694 m
.84481 .9974 L
s
P
p
1 0 .6 r
.00177 w
.78621 .88183 m
.80652 .92346 L
s
P
p
1 0 .6 r
.00177 w
.78621 .88183 m
.8097 .90426 L
s
P
p
1 0 .6 r
.0025 w
.75519 .80008 m
.79062 .80865 L
s
P
p
1 0 .6 r
.0025 w
.75519 .80008 m
.78119 .82471 L
s
P
p
1 0 .6 r
.00125 w
.80652 .92346 m
.82483 .96098 L
s
P
p
1 0 .6 r
.00125 w
.27676 .79684 m
.25846 .81463 L
s
P
p
1 0 .6 r
.00125 w
.27676 .79684 m
.26415 .81815 L
s
P
p
1 0 .6 r
.00125 w
.28373 .78001 m
.27174 .78253 L
s
P
p
1 0 .6 r
.00125 w
.28373 .78001 m
.27269 .79072 L
s
P
p
1 0 .6 r
.0025 w
.28901 .7621 m
.25154 .79832 L
s
P
p
1 0 .6 r
.0025 w
.28901 .7621 m
.26324 .80563 L
s
P
p
1 0 .6 r
.005 w
.53648 .79573 m
.52064 .86227 L
s
P
p
1 0 .6 r
.005 w
.53648 .79573 m
.48644 .84492 L
s
P
p
1 0 .6 r
.00125 w
.8097 .90426 m
.83098 .92458 L
s
P
p
1 0 .6 r
.00125 w
.8097 .90426 m
.8208 .927 L
s
P
p
1 0 .6 r
.0025 w
.30326 .72767 m
.27881 .73237 L
s
P
p
1 0 .6 r
.0025 w
.30326 .72767 m
.28072 .74935 L
s
P
p
1 0 .6 r
.00177 w
.78119 .82471 m
.80476 .84704 L
s
P
p
1 0 .6 r
.00177 w
.78119 .82471 m
.80059 .82948 L
s
P
p
1 0 .6 r
.00177 w
.26324 .80563 m
.23995 .84498 L
s
P
p
1 0 .6 r
.00177 w
.26324 .80563 m
.24276 .82552 L
s
P
p
1 0 .6 r
.00177 w
.80677 .87665 m
.84601 .91398 L
s
P
p
1 0 .6 r
.00177 w
.80677 .87665 m
.83914 .88491 L
s
P
p
1 0 .6 r
.00125 w
.23995 .84498 m
.23015 .87472 L
s
P
p
1 0 .6 r
.00353 w
.55423 .98843 m
.55455 1.10445 L
s
P
p
1 0 .6 r
.00353 w
.55423 .98843 m
.59893 1.06028 L
s
P
p
1 0 .6 r
.00125 w
.20415 .92448 m
.17315 .95498 L
s
P
p
1 0 .6 r
.00125 w
.20415 .92448 m
.18305 .96015 L
s
P
p
1 0 .6 r
.00125 w
.23995 .84498 m
.2189 .88052 L
s
P
p
1 0 .6 r
.00125 w
.21568 .89658 m
.1952 .90162 L
s
P
p
1 0 .6 r
.00125 w
.21568 .89658 m
.19702 .91488 L
s
P
p
1 0 .6 r
.00125 w
.80476 .84704 m
.82611 .86727 L
s
P
p
1 0 .6 r
.00125 w
.80476 .84704 m
.81591 .86985 L
s
P
p
1 0 .6 r
.00177 w
.79062 .80865 m
.82296 .81646 L
s
P
p
1 0 .6 r
.00177 w
.79062 .80865 m
.81039 .79676 L
s
P
p
1 0 .6 r
.00125 w
.80059 .82948 m
.81819 .8338 L
s
P
p
1 0 .6 r
.00125 w
.80059 .82948 m
.8135 .84168 L
s
P
p
1 0 .6 r
.00177 w
.28072 .74935 m
.26025 .76905 L
s
P
p
1 0 .6 r
.00177 w
.28072 .74935 m
.26729 .75202 L
s
P
p
1 0 .6 r
.00125 w
.24276 .82552 m
.22416 .84357 L
s
P
p
1 0 .6 r
.00125 w
.24276 .82552 m
.23001 .84704 L
s
P
p
1 0 .6 r
.00125 w
.84601 .91398 m
.88171 .94793 L
s
P
p
1 0 .6 r
.00125 w
.84601 .91398 m
.86453 .95187 L
s
P
p
1 0 .6 r
.00177 w
.25154 .79832 m
.21728 .83144 L
s
P
p
1 0 .6 r
.00177 w
.25154 .79832 m
.22897 .80315 L
s
P
p
1 0 .6 r
.00353 w
.48644 .84492 m
.44069 .8899 L
s
P
p
1 0 .6 r
.00353 w
.48644 .84492 m
.47738 .88162 L
s
P
p
1 0 .6 r
.00125 w
.83914 .88491 m
.86864 .89243 L
s
P
p
1 0 .6 r
.00125 w
.83914 .88491 m
.86069 .90534 L
s
P
p
1 0 .6 r
.00177 w
.27881 .73237 m
.25642 .73666 L
s
P
p
1 0 .6 r
.00177 w
.27881 .73237 m
.26931 .71841 L
s
P
p
1 0 .6 r
.00125 w
.26025 .76905 m
.24166 .78694 L
s
P
p
1 0 .6 r
.00125 w
.26025 .76905 m
.24747 .79059 L
s
P
p
1 0 .6 r
.00125 w
.81039 .79676 m
.82838 .78595 L
s
P
p
1 0 .6 r
.00125 w
.81039 .79676 m
.82812 .80098 L
s
P
p
1 0 .6 r
.00125 w
.26729 .75202 m
.25508 .75444 L
s
P
p
1 0 .6 r
.00125 w
.26729 .75202 m
.25608 .76278 L
s
P
p
1 0 .6 r
.00125 w
.82296 .81646 m
.85244 .82359 L
s
P
p
1 0 .6 r
.00125 w
.82296 .81646 m
.84451 .83674 L
s
P
p
1 0 .6 r
.0025 w
.55455 1.10445 m
.55484 1.21066 L
s
P
p
1 0 .6 r
.0025 w
.55455 1.10445 m
.5139 1.17118 L
s
P
p
1 0 .6 r
.0025 w
.59893 1.06028 m
.63987 1.1261 L
s
P
p
1 0 .6 r
.0025 w
.59893 1.06028 m
.61401 1.09435 L
s
P
p
1 0 .6 r
.00125 w
.21728 .83144 m
.186 .86168 L
s
P
p
1 0 .6 r
.00125 w
.21728 .83144 m
.19595 .86737 L
s
P
p
1 0 .6 r
.00353 w
.52064 .86227 m
.50595 .92397 L
s
P
p
1 0 .6 r
.00353 w
.52064 .86227 m
.54692 .89954 L
s
P
p
1 0 .6 r
.00125 w
.26931 .71841 m
.26065 .7057 L
s
P
p
1 0 .6 r
.00125 w
.26931 .71841 m
.25705 .7207 L
s
P
p
1 0 .6 r
.0025 w
.44069 .8899 m
.39892 .93097 L
s
P
p
1 0 .6 r
.0025 w
.44069 .8899 m
.39324 .91155 L
s
P
p
1 0 .6 r
.00125 w
.22897 .80315 m
.20833 .80756 L
s
P
p
1 0 .6 r
.00125 w
.22897 .80315 m
.21013 .82129 L
s
P
p
1 0 .6 r
.00125 w
.35041 .93108 m
.31916 .93461 L
s
P
p
1 0 .6 r
.0025 w
.47738 .88162 m
.46908 .91518 L
s
P
p
1 0 .6 r
.0025 w
.47738 .88162 m
.4523 .90638 L
s
P
p
1 0 .6 r
.00177 w
.39324 .91155 m
.35041 .93108 L
s
P
p
1 0 .6 r
.00177 w
.39324 .91155 m
.37035 .93395 L
s
P
p
1 0 .6 r
.00125 w
.25642 .73666 m
.23596 .74059 L
s
P
p
1 0 .6 r
.00125 w
.25642 .73666 m
.23768 .75455 L
s
P
p
1 0 .6 r
.00125 w
.57289 1.28604 m
.5891 1.35372 L
s
P
p
1 0 .6 r
.00125 w
.35041 .93108 m
.31177 .9487 L
s
P
p
1 0 .6 r
.00125 w
.57289 1.28604 m
.6083 1.32807 L
s
P
p
1 0 .6 r
.00177 w
.55484 1.21066 m
.57289 1.28604 L
s
P
p
1 0 .6 r
.00125 w
.47868 1.22088 m
.44698 1.26558 L
s
P
p
1 0 .6 r
.00125 w
.47868 1.22088 m
.45838 1.25417 L
s
P
p
1 0 .6 r
.00177 w
.5139 1.17118 m
.47868 1.22088 L
s
P
p
1 0 .6 r
.00177 w
.55484 1.21066 m
.55511 1.30774 L
s
P
p
1 0 .6 r
.00177 w
.5139 1.17118 m
.47675 1.23218 L
s
P
p
1 0 .6 r
.00125 w
.37035 .93395 m
.34961 .95426 L
s
P
p
1 0 .6 r
.00125 w
.37035 .93395 m
.34695 .94463 L
s
P
p
1 0 .6 r
.00177 w
.4523 .90638 m
.42955 .92885 L
s
P
p
1 0 .6 r
.00177 w
.4523 .90638 m
.44768 .92478 L
s
P
p
1 0 .6 r
.00177 w
.63987 1.1261 m
.67731 1.1863 L
s
P
p
1 0 .6 r
.00177 w
.63987 1.1261 m
.67599 1.17534 L
s
P
p
1 0 .6 r
.00125 w
.67599 1.17534 m
.7085 1.21967 L
s
P
p
1 0 .6 r
.00125 w
.67599 1.17534 m
.69645 1.20821 L
s
P
p
1 0 .6 r
.00177 w
.39892 .93097 m
.36082 .96842 L
s
P
p
1 0 .6 r
.00177 w
.39892 .93097 m
.39086 .96169 L
s
P
p
1 0 .6 r
.00177 w
.61401 1.09435 m
.62787 1.12568 L
s
P
p
1 0 .6 r
.00177 w
.61401 1.09435 m
.63653 1.13061 L
s
P
p
1 0 .6 r
.00177 w
.46908 .91518 m
.46151 .94585 L
s
P
p
1 0 .6 r
.00177 w
.46908 .91518 m
.4817 .93381 L
s
P
p
1 0 .6 r
.00125 w
.42955 .92885 m
.40893 .94922 L
s
P
p
1 0 .6 r
.00125 w
.42955 .92885 m
.4061 .93957 L
s
P
p
1 0 .6 r
.00125 w
.44768 .92478 m
.44348 .94146 L
s
P
p
1 0 .6 r
.00125 w
.44768 .92478 m
.43525 .93708 L
s
P
p
1 0 .6 r
.0025 w
.54692 .89954 m
.57111 .93384 L
s
P
p
1 0 .6 r
.0025 w
.54692 .89954 m
.53909 .9336 L
s
P
p
1 0 .6 r
.00125 w
.55511 1.30774 m
.55535 1.39633 L
s
P
p
1 0 .6 r
.00125 w
.55511 1.30774 m
.56478 1.3577 L
s
P
p
1 0 .6 r
.00125 w
.47675 1.23218 m
.44284 1.28785 L
s
P
p
1 0 .6 r
.00125 w
.47675 1.23218 m
.46318 1.2619 L
s
P
p
1 0 .6 r
.00125 w
.63653 1.13061 m
.65699 1.16354 L
s
P
p
1 0 .6 r
.00125 w
.63653 1.13061 m
.64421 1.14787 L
s
P
p
1 0 .6 r
.00125 w
.67731 1.1863 m
.71151 1.24127 L
s
P
p
1 0 .6 r
.00125 w
.67731 1.1863 m
.69043 1.21546 L
s
P
p
1 0 .6 r
.00125 w
.36082 .96842 m
.32614 1.00253 L
s
P
p
1 0 .6 r
.00125 w
.36082 .96842 m
.3218 .98627 L
s
P
p
1 0 .6 r
.00125 w
.39086 .96169 m
.38351 .98971 L
s
P
p
1 0 .6 r
.00125 w
.39086 .96169 m
.37 .98227 L
s
P
p
1 0 .6 r
.0025 w
.50595 .92397 m
.49236 .98105 L
s
P
p
1 0 .6 r
.0025 w
.50595 .92397 m
.46403 .96587 L
s
P
p
1 0 .6 r
.00125 w
.4817 .93381 m
.49319 .95076 L
s
P
p
1 0 .6 r
.00125 w
.4817 .93381 m
.47762 .95062 L
s
P
p
1 0 .6 r
.00125 w
.46151 .94585 m
.4546 .97382 L
s
P
p
1 0 .6 r
.00125 w
.46151 .94585 m
.44085 .96641 L
s
P
p
1 0 .6 r
.00125 w
.62787 1.12568 m
.64059 1.15443 L
s
P
p
1 0 .6 r
.00125 w
.62787 1.12568 m
.62438 1.13115 L
s
P
p
1 0 .6 r
.00177 w
.53909 .9336 m
.53193 .96473 L
s
P
p
1 0 .6 r
.00177 w
.53909 .9336 m
.55225 .95254 L
s
P
p
1 0 .6 r
.00177 w
.46403 .96587 m
.4258 1.00408 L
s
P
p
1 0 .6 r
.00177 w
.46403 .96587 m
.45632 .99728 L
s
P
p
1 0 .6 r
.00177 w
.57111 .93384 m
.59332 .96534 L
s
P
p
1 0 .6 r
.00177 w
.57111 .93384 m
.60786 .94495 L
s
P
p
1 0 .6 r
.00125 w
.55225 .95254 m
.56423 .96976 L
s
P
p
1 0 .6 r
.00125 w
.55225 .95254 m
.5484 .9696 L
s
P
p
1 0 .6 r
.00125 w
.53193 .96473 m
.5254 .99312 L
s
P
p
1 0 .6 r
.00125 w
.53193 .96473 m
.5113 .98558 L
s
P
p
1 0 .6 r
.00177 w
.49236 .98105 m
.47982 1.03373 L
s
P
p
1 0 .6 r
.00177 w
.49236 .98105 m
.51392 1.01318 L
s
P
p
1 0 .6 r
.00125 w
.4258 1.00408 m
.39097 1.03888 L
s
P
p
1 0 .6 r
.00125 w
.4258 1.00408 m
.38628 1.02223 L
s
P
p
1 0 .6 r
.00125 w
.60786 .94495 m
.6413 .95506 L
s
P
p
1 0 .6 r
.00125 w
.60786 .94495 m
.62016 .96219 L
s
P
p
1 0 .6 r
.00125 w
.45632 .99728 m
.44929 1.02594 L
s
P
p
1 0 .6 r
.00125 w
.45632 .99728 m
.43539 1.01828 L
s
P
p
1 0 .6 r
.00125 w
.59332 .96534 m
.61369 .99423 L
s
P
p
1 0 .6 r
.00125 w
.59332 .96534 m
.58716 .99389 L
s
P
p
1 0 .6 r
.00125 w
.51392 1.01318 m
.53369 1.04264 L
s
P
p
1 0 .6 r
.00125 w
.51392 1.01318 m
.5072 1.04219 L
s
P
p
1 0 .6 r
.00125 w
.47982 1.03373 m
.46827 1.08223 L
s
P
p
1 0 .6 r
.00125 w
.47982 1.03373 m
.44489 1.06912 L
s
P
p
1 g
.002 w
.83123 .03823 m
.86467 1.32309 L
s
.86467 1.32309 m
.03823 1.37454 L
s
.03823 1.37454 m
.08331 .12246 L
s
.08331 .12246 m
.83123 .03823 L
s
.83123 .03823 m
.86467 1.32309 L
s
.86467 1.32309 m
.96177 1.49486 L
s
.96177 1.49486 m
.92317 .32153 L
s
.92317 .32153 m
.83123 .03823 L
s
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellMargins->{{Inherited, 334}, {Inherited, Inherited}},
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{163, 178},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40002S0000/PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_88Q000
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000:<00000X]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40002RaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP40002RaP400000LMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF00H002_6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040001XaPT01LH00`36aP0YaP400000GmK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF00T003[Fa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60@0005G62P07aP03a<K600g60P0ZaP400000C=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H9000N
a]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KF0l@2000Ze/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0004?62@04aP03a<K601C600C4a/K62<@3aP80:/H1000003WFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H02P007lKF
a]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/H02L@0=lKFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0003362@000lC6aP0EaP03a<K600K62<@6aP03
a<K600_600<0aP00:LH1000002OFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
2@008]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H8a018e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K6e/KFaP360<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0002;6
1@0CaP03a<K600c62/@FaP03a<K600[600@0a/H0:<H10000047Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6eP08a01Ia]K6e/KFa]K6a<KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K60<KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H00@0002;60P000lC6aP0BaPS44/H00lC6aP0CaP03a<K600[600@0a/H0
:<H10000033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a=K6e/KFa]K6e/H9a01Y
a]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6e/KFa]K6e/KFa]K6e/KFa/C6e/KFa]K6e/KF
aP36e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000RaP040<H0a0;6
2<@<aP03a<K601G600?4a/H04lH00lC6aP09aP050<K6aP009lH1000002CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60<H4a01je/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/K4a]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H01@36aP3401K600?4a/H05LH00lC6aP0CaP03
a<K600S600<0a<@00/@00`36aP0TaP400000K]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K60<CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K4e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa=K62<@0;036e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0002;600<0a/H00/H00`34aP0DaP03a<K601G600?4a/H03<H9a0S600<0a/H00/H00`36
aP0TaP400000G=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6eP34a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K62L@0?LKFa]K6e/K4a]K6e/KF
a]K60<KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002;600<0a/H0
0lH00`34aP0DaP03a<K601762L@@aP03a<K600S600<0a/H00/H00`36aP0SaP400000B]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/H0a=K6e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6
e/KFa]K62L@00lKF0002001:e/KFa]K6e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6eP3Fa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008/H00`36aP04aP030<C601C62/@:aPD0
5<H00lC6aP07aP030<K600;600<0a/H08lH1000003SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/H0a=K6e/KFa]K6e/KFaP[401;Fa]K6e/KFa]K6e/KFa]K6e/H50019a]K6e/KF
a]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP0100008/H00`36aP05aP030<C600;62L@9aP03a<K601361@0EaP03a<K600K600<0a/H0
0lH00`36aP0RaP400000:]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaPG4
02K6e/KFa]K6e/KFa]K6e/KFa]K6a<KFa]K6e/KFa]K6e/KFa]K6eP<004[Fa=K6e/KFa]K6e/KFa]K6
e/KFa]K6a<KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40
000QaP030<K600O600<0a<H05<H00lC6aP0@aP05?do6a/@05LH00lC6aP05aP030<K600C600<0a/H0
8LH1000005GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFaP34e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa=K6e/KFa]K6e/KFa]K6e/KF008o02;6e/K4a]K6e/KFa]K6e/KFa]K6e/KF
a]K4e/KFa]K6eP3F1L@09036e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000QaP03
0<K600W600<0a<H04lH00lC6aP0?aP03?do600;600?4a/H04/H8a0030<C600C600<0a/H08LH10000
05GFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]H0a<KFa]K6e/KFa]K6
e/KFa]K6e/KFa/C6e/KFa]K6e/KFa]K6e/KF008o00o6e/KFa=K6e/KFa]K6e/H02L@0<lK4a]K6e/KF
0=K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100008LH00`36aP0:aP03
0<C601?600?4a/H03/H00cm?aP03aP_42/H00lC6aP04aP030<K600G600<0a/H08<H1000005;Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KFa]K6
e/KFa]K4e/KFa]K6e/KFa]K60l@2?`K404G6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6eP3Fa]K6e/KF
0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00027600<0a/H02lH00`34aP0DaP03
a<K400W40lH00cm?aP04aP03a<K601;600?4a/H00lH00`36aP06aP030<K601o60@00000oe/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K60<CFa]K6e/KFa]K6e/KF00W4
00gFa]K6e/KFa]K6e/KF008o02C6e/KFa/C6e/KFa]K6e/KFa]K6e/KFa]K6e/CFa]K6eP3Fa]H6000Q
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000QaP030<K600c600<0a<H00/H:a0S6
00?4a/H02lH00cm?aP05aP03a<K601360P000l@0000600G600<0a/H07lH10000033Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/H5a00Pa]K6e/KFa]K6e/KFa]K6e/KF
a=K6e/KFa]K6e/KFa]H2?`0>a]K6e/KFa=K6e/KFa]H;000be/KFa]K6eP3Fa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0=aP030<C601C600?4a/H02/H00cm?
aP02aP@000?40000100BaP030<K600K600<0a/H07lH1000004oFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaP34e/KFa]K6e/KFa]K6e/KFa]K6e/K4a]K6e/KF00H0
0Sl30018e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H03lH00`34aP0>aPD000?400000`06aP03?do601o6
00<0a/H01/H00`36aP0OaP400000>MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6eP34a]K6eP0;000Ae/KFa]K6e/KFa]K6e/KFa]H00Sl0BlKFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP0100008LH00`36aP0@aP030<@000807<H00cm?aP0OaP030<K600K600<0a/H07lH1000005GFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF008o04_6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F
a]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@00027600<0a/H04<H00`36
aP0NaP03?do601o600<0a/H01/H00`36aP0OaP400000EMK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
0Sl0BlKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K60<KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFaP0100008LH00`36aP0@aP030<K601k600<oClH07lH00`36aP06aP03
0<K601o60@00001Ee/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP02?`1;a]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000QaP030<K6013600<0a/H07/H00cm?aP0OaP030<K600K600<0a/H07lH100000:;Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/HoaSo6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008LH00`36aP0@aP030<K601g600=?aTl0
8<H00`36aP06aP030<K601o60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00027600<0a/H04<H00`36aP0KaP05ClK6aTl08<H00`36aP07aP030<K601k60@00002R
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H04<H00`36
aP0JaP03?lK600;600=?a/H07/H00`36aP07aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF?mK6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H04LH00`36aP0IaP03ClK600?600=?a/H0
7/H00`36aP07aP030<K601k60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/Hoa]K6e/Hoa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00023600<0a/H04LH00`36aP0HaP03?lK600C600=?a/H07lH00`36aP06aP030<K601k6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H0
4LH00`36aP0GaP03ClK600G600=?a/H07lH00`36aP06aP030<K601k60@00002Re/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6?lKFa]K6e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00023600<0a/H04LH00`36aP0FaP03?do600K6
00=?a/H07lH00`36aP06aP030<K601k60@00001<e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP8o05CFa]K6e/KFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008<H00`36aP0@aP030<K601K600=??lH01lH00do6aP0OaP030<K600K6
00<0a/H07/H1000004_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H00Sl02LKFa]K6e/KFaP02?`1:e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H100008<H00`36aP0@aP030<K601G600<oClH02<H00dloaP0OaP030<K600K600<0a/H07/H10000
0:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaSo6?lKFa]K6e/KFaSo6?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0@aP03
0<K601?600<oaSl02/H00do6C`0OaP030<K600K600<0a/H07/H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mHo
e/KFa]K6e/KFaSo6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100008<H00`36aP0@aP030<K6017600@oClI?2lH01Do6
a/I?01g600<0a/H01/H00`36aP0NaP400000X]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/HoaSo6?lKFa]K6e/KFa]K6?lKFaSo6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000PaP030<K6013600<0a/H03lH01So6?lHoC`c600Doa/K6?`0LaP030<K600K6
00<0a/H07/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
e/KFa]H0e/KFa]K6e/KFa]K6e/KFaSo6?lKF?mK6e/KFa]K6e/KFa]Hoe/KF?mK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
8<H00`36aP0@aP030<K600g600Loa/I?aTlo00g600<oa/H00/H00do6aP0IaP030<K600K600<0a/H0
7/H1000004SFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/Hoa]Hoe/H2?`1He/KFa]K6e/KFa]K6eSoFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000PaP03
0<K6013600<0a/H02lH023m?a/HoaSm?3/H00co6aP03aP03?lK601S600<0a/H01/H00`36aP0NaP40
0000@=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/H2?`04e/HoaP<o01C6e/KFa]K6e/KFa]K6eSoFa]K6eP8o04?6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000PaP03
0<K6013600@0a/I?2<H01Co6?lHo00;600=??dl03/H00co6aP04aP03Cco601O600<0a/H01/H00`36
aP0NaP400000=]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6
eP3FaP8o00gFa]K6e/HoaSo6eSoF008o05_6?lKFa]K6e/KFa]K6e/KF?mK6e/KFaSo6?lKFa]K6e/KF
a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000PaP030<K6013600/0aSo6?lHoCcm??`02aP09ClI?aTo6Ccm?00k600<oa/H01LH00co6?`0FaP03
0<K600K600<0a/H07/H1000003CFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6
e/KFa]K6e/KFa]H01Cl01LHoaSo6008o00CFaSo60Sl0G=Ho?lKFa]K6e/KFa]K6e/KF?mK6e/KFa]Ho
e/Hoa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@00023600<0a/H04<H00cm?aP03aP0@?lHoaSo6?lHoaSm??lHoC`k600<oa/H01/H01Do6
aSm?01?600<0a/H01/H00`36aP0NaP400000=MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0
e/KFa]K6e/KFa]K6e/KFa]K6eSoF00@o00O6?lHoaSo600<o00C6?coF0Sl03LKFa]K6e/KFa]K6e/H0
0Sl0B]K6e/KFa]K6?lKF?mHoe/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H04LH01`36?lHoaSl00/H03Dloa/I??dloClI?aTl0
3LH00dloaP07aP07ClK6aTo6C`0AaP030<K600K600<0a/H07/H1000003GFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H0eP02?`06aSloeSoF23l04LHo?co6e/KF
a]K6e/KFa]K6008o04[Fa]K6e/KFa]Hoe/Hoa]Hoe/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K6017601H0Cco6?dloClI??dloCcm?
?do6Ccm?3LH00dloaP08aP05?lK6aSl00/H00do6aP0=aP030<K600O600<0a/H07LH1000003?Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]H00Sl01lHo?co6?lH0
2Sl08mHo?lKFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/Hoa]Hoe/KF00<o00SFa]K6e/KFaP8o02cFaP36
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K6017601L0Cco6
?lHoaSm??dloCcm??dloClI??`0;aP03?lHo00[600E?a/K6C`03aP06ClI??dlo0/H00dloC`03aP03
0<K600O600<0a/H07LH10000033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/H5?`03aSlo00lo00g6?coF?mK6e/KFa]K6008o00cF?mK6e/KFa]K6e/H2?`0<e/Ho?mK6
eSoFaSo613l0;]Hoe/H0a]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
7lH00`36aP0?aP0J?lHoaSm?aTloClI??dloClI??dloClI??dl8aP05?lHoaSl02/H00dloaP02aP03
?do600;600A?a/Ho1<H01DloCcl000W600<0a/H07LH1000003;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/HoaP@o00?F?cl023l00lHo?`03?`0YaSlo?lKFa]K6e/Ho
aSo6eSoFa]K6e/KFa]K6?lHoa]HoeSoFa]Hoe/H00Sl0<=K6eSoFaP36e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000OaP030<K600k600E??dl0C`03aP0BCcm??dloCco6?dlo
Ccm??dlo1lH013o6aTl2aP03?lK600W600<oClH00/H00dloC`03aP0;ClK6?dloClI?aP002LH00`36
aP0MaP400000<mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KF?mHo
eP02?`03a]Ho008o00?F?cl02cl08]K6e/KFa]K6?lKFaSo6eSoFa]K6e/KFa]K6eSoF?mK6?lH2?`0f
e/Ho?mK6?lHoa]Ho0<KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o6
00<0a/H03<H01To6ClI??`;6019??dloCcm??dloaSo6?do6Ccl7aP05?lK6aSl00lH00co6aP09aP03
?lHo00?600PoaSm??lHoC`;600<oa/H00lH00`36aP06aP030<K601g60@00000ee/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KF?mHoe/KF?mH01Cl00mHo?`02?`03aSlo00<o
00W6?coFa]K6e/H00Sl07]K6eSoFa]Hoe/KFa]K6e/KFa]HoeSoFa]HoeSoFaP@o033F?co6e/KF0=K6
e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH00`36aP0<aP0KClK6aTl0
aSm??dloaSm?aTloCcm??dloCcm?00C600<oaSl00lH01Co6a/Ho00_600@oa/I?0/H03Cm?aTloaSm?
aTo6Ccl00lH00`36aP06aP030<K601g60@00000ee/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/Ho0=H00Sl00lHoaP03?`05aSlo?lH00Sl03mHoeSoFa]K6?lHoa]K6
eP02?`0Da]Hoe/KFa]K6e/KFa]Hoe/Hoa]H2?`03aSlo00<o00?6eSl00Sl0;=K6eP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03lH01Co604lo00;600a?aTlo
Ccm??dloaSl7aP04?lHoC`?600I?a/HoCcl;aP0:?do6aSm??do6C`?600Y??lK6ClI??dl02<H00`36
aP0MaP400000<=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFaPHo
00?F?mH02cl01MK6e/KF008o00[6?lHoa]K6?lKF0cl04mK6e/KFa]K6e/KF?mHoeSoF?mH00cl00mK6
?`02?`0_a]Hoe/Ho03o6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001o6
00<0a/H03<H01dloaSo604l00/H03Cm??lHoCco6?dloCcl00/H00dloC`02aP03?lHo00C600I?a/K6
Ccl<aP0:Cco6aTloCco6?`C600E??do6C`02aP030<K600K600<0a/H07LH1000003KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6?lHoa]Hoe/H5?`04aSo6eP8o00?6?cl0
0Sl04=Hoe/KF?mHoe/KF?mK6e/H2?`0Be/KFa]K6e/KFa]K6?lHoaSo60cl01LHoa]K6008o02kF?mHo
eP3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH03So6
aTloaSm??dloClI?0lH01dloCcm?aTl00lH014loaSl3aP07?lK6aSo6?`0<aP03ClI?00;600HoCcm?
?dl4aP07?do6Ccm?0008aP030<K601g60@00000ae/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]HoeP03?`05eSlo?mH013l00lHo?`02?`06eSoF?mK613l01=Ho?lH2?`05
e/KF?mH00cl03=K6e/KFa]K6e/HoaP8o00?FaSl00cl0==Hoe/KF?mHoe/Ho0=K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007lH00`36aP0<aP0TClI??dl0Ccm?aTloaSm??dlo
aSm?aTloCco6?do6ClI??lHo0lH023o6?do6Ccm?1lH01do6aSo6?dl00/H013m??dl2aP03?do600;6
00=?04l01lH00`36aP0MaP400000;MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6
e/KFa]K6eP02?`05a]K6?`000Sl01MK6?coF00Lo00?F?mH00Sl02LKFa]K6?lHoaP02?`03e/KF00<o
00GF?mK6eP03?`0:e/KFaSo6eSoFaP8o00OFaSloe/KF008o02g6e/Ho0=Hoe/KFa]K60<KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0001o600<0a/H02/H00dloaP02aP05?lHoCcl00lH033m?
aTloCcm?aTo6C`K600<oCcl00/H024o6a/I?aTlo0/H014o6aSl2aP05ClK6?dl00/H01Cm?a/Ho00;6
00=??dl00/H00cm?aP03aP030<K600K600<0a/H07LH10000033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/H3?`0;aSo6e/HoaSo6?lH013l02=K6?lKFa]K60cl02LKF
aSo6e/HoaP02?`0?e/KF?mK6?lKFa]HoeSoF00<o00CFaSo60Sl0<]Ho?coF?mK6eP3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH01Co6?dlo00C600=?a/H0
0/H013m??dl2aP03?do600G600<oClH00/H02Do6aSm?aTloC`02aP03?lK600G600XoaSo6?dloClI?
0/H02cm?aTo6Ccm??lH000S600<0a/H07LH10000033Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF0=K6e/KFa]K6e/KFa]K6e/H2?`0503oFa]H00Sl00lKFaP02?`04eSoFaP8o00kFa]K6e/HoaSo6
e/HoaP<o01;6eSoFaSo6?lKFa]K6eSoF?mH2?`03aSlo008o03CF?mHoeSoF?mK6?`3Fa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@0001o600<0a/H03LH01Co6?dlo00;600=??dl0
1<H00cm?aP03aP03?lK600?600@oa/I?0lH024o6aSo6?lHo0/H014o6aSl4aP0<Cco6?lHoCcm??dlo
0/H01do6ClI?aTl00/H00`36aP06aP030<K601g60@00000ge/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFaSo6?lHoa]HoeP02?`0>a]K6eSoFa]K6e/KFa]H2?`0Ha]Ho?lKF
?mHoeSoF?mHoe/KFa]K6e/KF0cl01mHo?coF?mH013l0<lHoaSo6eSoF?mH0e/KFa]K6e/H0a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007/H00`36aP0<aP06?dloaSm?1<H00cm?aP0;aP03
?dlo00;600=?aTl00/H02So6aTloaSo6?dl7aP08ClI??lHoCcl3aP06?lHoClI?0/H01co6aTloaP00
2<H00`36aP0MaP400000;=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6
0Sl00mHo?`02?`0Oa]K6?lKFa]K6e/KFa]K6e/HoaSo6eSoF?mK6eSoFaP02?`0?e/Ho?mHoe/KFa]K6
eSoF00@o00C6e/KF13l01<KF?mH2?`0]aSo6?`3Fa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000NaP030<K600[600DoaSm??`02aP05ClK6aTl03/H00co6aP03aP04?lK6C`?6
00Q??lK6Cco6?`O600Loa/I?aTlo00?600LoCco6?lHo00G600<oaP002<H00`36aP0MaP400000<MK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6?lHoa]H00Sl07/KFa]K6e/KF
a]K6e/KFa]K6?lKFa]K6e/KFaSo6eP<o01;FaSloe/Hoa]K6e/KFa]K6e/H2?`0je/KFa]HoeSoFaSo6
e/KF?mH0?lKFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K600c6
00Hoa/K6?`0JaP0;?do6aSm?aTo6Ccl00/H00do6aP09aP03Ccm?00C600HoClI?aTl5aP03C`3600O6
00<0a/H07LH1000005KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]Ho
e/KF?`36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lHoa]K6?lKFaP8o01GFa]Hoe/KFa]K6e/KFaSo6
?lKFa]H00Sl0<lHo?mHoe/KFa]H0e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
aP0100007/H00`36aP0;aP03Cco600?600<0a/H05/H00co6?`04aP06ClK6?lHo1<H00do6aP06aP04
?do6C`C600HoaSo6?dl6aP030<K600O600<0a/H07<H1000002_Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KF008o02C6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6eSoF
a]H2?`0Ba]HoeSoFa]K6?lKFa]K6e/KF0Sl0>lKF?mK6eSoF?mHoeSoFa]K6eP3Fa]K6e/KFa]H0e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000NaP030<K600[600<oClH01<H00`36aP0HaP05
?lK6Ccl00lH013o6?dl3aP03Cco600O600=?a/H01<H023o6?do6ClI?1<H00`36aP07aP030<K601c6
0@00001Ge/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6?lKFa]K6e/H0a]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF?mK6eSoF00<o01GFa]Hoe/KFa]K6e/Hoa]K6e/KF?mH0
0Sl00lKF?`02?`0/e/KF0=K6e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000
7/H00`36aP0AaP030<K601W600A?a/Ho0lH01So6?do6C`;600<oClH03<H01DloaSm?00;600@oaSm?
0/H00`36aP07aP030<K601c60@00001Fe/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]Hoe/KF?mK6?lH2?`0LeSoF?mHo
eSoFa]K6e/KFa]K6e/HoaSo6eSoFaP8o02cF?mH0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP40000NaP030<K6017600<0a/H06<H01Co6a/Ho00;600I?aTloaSl2aP04ClI??`k6
00=?a/H00lH01To6ClI?00W600<0a/H07<H1000004cFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60Sl02=K6?lKFaSo6
0Sl01=Hoe/H2?`0FeSloa]K6e/KFa]K6e/KFaSo6e/KFaP8o02cFa]H0e/KFa]K6e/KF0=K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K6017600<0a/H05/H00cm?aP02aP08ClK6aTlo
Ccl2aP07ClK6?dloC`0CaP03Cco600;600<0a/H01lH00`36aP0LaP400000DmK6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lHoa]K6?lKF008o00[6eSoFaSo6eSoF0cl0@=K6e/KFa]K6e/KFa]K6e/KFaSo6?lKF0=K6e/KFa]K6
eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H100007/H00`36aP0AaP030<K601?600E??lK6
C`03aP05Ccm??dl00/H013o6aTl5aP03Ccm?017600=?aTl00/H00`36aP07aP030<K601c60@000016
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFaP8o01;F?mK6?lKF?mHoeSoFa]Hoe/H2?`16e/KFa]K6?lKFa]K6e/KFa]K6e/KFa]K6
?lHoa]H0e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000NaP030<K60176
00<0a/H04<H013o6aTl2aP08?do6aSo6?dl4aP05?lHoaSl01lH00co6aP0AaP04?lK600S600<0a/H0
7<H1000004[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFaP36
e/KFa]K6e/KFa]K6e/KFa]K6eSoFaP8o01OFa]Hoe/Hoa]K6eSoF?mHoe/KFa]K6eP02?`0ma]K6e/KF
a]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000
7/H00`36aP0AaP030<K6017600=?a/H00/H023o6a/HoaSm?1<H00co6aP02aP03ClK600G600=??lH0
4lH00`36aP06aP030<K601c60@00001?e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6
e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6eP04?`0Aa]K6eSoFa]K6e/KF
a]K6e/H00cl0>lKFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K60040000NaP030<K6017600<0a/H06LH01Do6ClI?00C600<oa/H02lH00cm??`0BaP03
0<K600K600<0a/H07<H1000004kFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H2?`0FeSloa]K6eSoFa]K6e/KFa]K6
e/KFaP8o03[Fa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60@0001k600<0a/H04LH00`36aP0HaP07?dloaSo6?`03aP03?lK600c600=?aTl04LH00`36
aP06aP030<K601c60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaSo6?lKF?mHoe/KF?mK6e/KFa]K6e/KFa]K6
eSoFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0001k600<0a/H04LH00`36aP0FaP04?lHoC`C600Hoa/K6?dl?aP03ClK600o600<0a/H01/H00`36
aP0LaP400000C=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6
0<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6?lH2?`09e/KFa]K6e/KF008o04W6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040
000MaP030<K601;600<0a/H05lH00dloaP08aP03?do6023600<0a/H01/H00`36aP0LaP400000BmK6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP02?`0:a]K6e/KFa]K6eP8o04W6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H0a]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000MaP030<K601;6
00<0a/H05/H00cm?aP09aP03?lHo023600<0a/H01/H00`36aP0LaP400000X]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
?lKFa]K6e/KFa]K6eSoF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<KFa]K6e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000MaP030<K601;600<0a/H08/H00co6?`0PaP03
0<K600K600<0a/H07<H1000005WFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KFa]K6
e/KFa]K6e/KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]HoeP02?`17a]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/H00@0001g600<0a/H04/H00`36aP0RaP05?lK6Ccl07/H00`36aP06aP030<K601c60@00001b
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6?lHoa]K6e/KFa]K6e/KFa]K6e/KFa]K62@009lKF
a]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP0100007LH00`36aP0BaP030<K602;6
00@oa/I?0/H00co6aP03aPl02<H00`36aP06aP030<K601c60@00001Ce/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]H04000?lKFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007LH00`36aP0AaP030<K601363`04aP05?do6aSl07lH00`36aP05aP03
0<K601c60@00000de/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6
eP3FaQ0001?Fa]K6e/KFa]K6e/KFa]K6e/KF008o04W6eSoFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFaP36e/KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000MaP030<K600G6
3`0SaP03?lK602;600<0a/H01LH00`36aP0KaP4000007MK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KF00P007g6e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eSoF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KFaP36e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFaP0100007lH00`36aP0?aP030<K602?600<oa/H08lH00`36aP04aP030<K601_6
0@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6e/KFa]K6e/KFa]K6eP3Fa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF?mK6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K60<KFa]K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60@00027600<0a/H0
3LH00`36aP1:aP030<K600?600<0a/H06lH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFa]K6e/KFa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H100008lH00`36aP0;aP030<K604_600<0a/H00/H00`36aP0KaP400000X]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP36e/KFa]K6e/KFa]H0e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K60<KFaP36e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP40000UaP030<K600W600<0a/H0
C<H01@36a/H001g60@00002Re/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H0a]K6
e/KFa]K6eP3Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K60<KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
0@0002O60P08aP030<K604g600@0a/H07LH100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6eP3Fa]K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60<H0a]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/H10000:/H00`36aP04aP030<K604k600<0aP007LH1000008?Fa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF0=K6e/KF0=K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
eP02000Ma]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H00@0002c600<0a/H00/H00`36aP1?aP80
7LH1000007[Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]H0e/KF0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFaP/001g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000;/H01036aP0caQD0
:<H10000053Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP3F0=K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaQD003g6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K60040000`aP802LHE05;60@00000ae/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6eP0:001Wa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KF
a]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFaP010000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/H10000X/H100000:;Fa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6e/KFa]K6
e/KFa]K6e/KFa]K6e/KFa]K6e/H10000\
\>"],
  ImageRangeCache->{{{0, 162}, {177, 0}} -> {0.016591, -0.0250051, \
0.00581657, 0.00581657}}]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "C. Jacob, ",
  StyleBox["Illustrating Evolutionary Computation with Mathematica.",
    FontWeight->"Bold"],
  " Morgan Kaufmann Publishers, San Fancisco, 2001. Chapter 9.2.4.\n"
}], "Text"],

Cell[TextData[{
  "Przemyslaw Prusinkiewicz and Aristid Lindenmayer, ",
  StyleBox["The Algorithmic Beauty of Plants",
    FontSlant->"Italic"],
  ",Springer-Verlag"
}], "Text"]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"4.1 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
AutoGeneratedPackage->None,
ScreenStyleEnvironment->"Working",
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{684, 500},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellBracket->False,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"MacintoshAutomaticEncoding",
StyleDefinitions -> \
FrontEnd`FileName[{ParentDirectory[ParentDirectory[ParentDirectory[\
ParentDirectory[]]]], "IEC-Setup"}, "EvolvicaStyle.nb", CharacterEncoding -> \
"WindowsANSI"]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Introduction"->{
    Cell[208979, 15988, 268, 6, 62, "Text",
      CellTags->"Introduction"]},
  "Modeling of trees"->{
    Cell[210940, 16069, 167, 6, 55, "Subsection",
      CellTags->"Modeling of trees"]},
  "L-system"->{
    Cell[211132, 16079, 56, 1, 61, "Subsubsection",
      CellTags->"L-system"]},
  "Example A"->{
    Cell[212537, 16116, 240, 8, 61, "Subsubsection",
      Evaluatable->False,
      CellTags->"Example A"]},
  "Example A: parameters"->{
    Cell[212780, 16126, 395, 11, 170, "Input",
      CellTags->"Example A: parameters"]},
  "Example B"->{
    Cell[576840, 28466, 240, 8, 61, "Subsubsection",
      Evaluatable->False,
      CellTags->"Example B"]},
  "Example B: parameters"->{
    Cell[577083, 28476, 395, 11, 170, "Input",
      CellTags->"Example B: parameters"]},
  "Example C"->{
    Cell[994525, 48057, 239, 8, 61, "Subsubsection",
      Evaluatable->False,
      CellTags->"Example C"]},
  "Example C:parameters"->{
    Cell[994767, 48067, 394, 11, 170, "Input",
      CellTags->"Example C:parameters"]},
  "Example D"->{
    Cell[1321735, 59916, 240, 8, 61, "Subsubsection",
      Evaluatable->False,
      CellTags->"Example D"]},
  "Example D: parameters"->{
    Cell[1321978, 59926, 395, 11, 170, "Input",
      CellTags->"Example D: parameters"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Introduction", 1645836, 71757},
  {"Modeling of trees", 1645939, 71760},
  {"L-system", 1646044, 71763},
  {"Example A", 1646143, 71766},
  {"Example A: parameters", 1646282, 71770},
  {"Example B", 1646389, 71773},
  {"Example B: parameters", 1646528, 71777},
  {"Example C", 1646635, 71780},
  {"Example C:parameters", 1646773, 71784},
  {"Example D", 1646879, 71787},
  {"Example D: parameters", 1647019, 71791}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1727, 52, 111, 2, 139, "Title",
  Evaluatable->False],
Cell[1841, 56, 112, 3, 62, "Subsubtitle"],
Cell[1956, 61, 206800, 15916, 190, "Text"],

Cell[CellGroupData[{
Cell[208781, 15981, 195, 5, 78, "Section",
  Evaluatable->False],
Cell[208979, 15988, 268, 6, 62, "Text",
  CellTags->"Introduction"]
}, Closed]],

Cell[CellGroupData[{
Cell[209284, 15999, 85, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[209394, 16005, 100, 2, 55, "Subsection",
  Evaluatable->False],
Cell[209497, 16009, 208, 6, 45, "Text"],
Cell[209708, 16017, 361, 13, 27, "Text"],
Cell[210072, 16032, 219, 4, 84, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[210328, 16041, 109, 2, 55, "Subsection",
  Evaluatable->False],
Cell[210440, 16045, 91, 2, 44, "Input",
  InitializationCell->True],
Cell[210534, 16049, 102, 2, 44, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[210685, 16057, 230, 8, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[210940, 16069, 167, 6, 55, "Subsection",
  CellTags->"Modeling of trees"],

Cell[CellGroupData[{
Cell[211132, 16079, 56, 1, 61, "Subsubsection",
  CellTags->"L-system"],
Cell[211191, 16082, 1099, 17, 664, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[212339, 16105, 173, 7, 55, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[212537, 16116, 240, 8, 61, "Subsubsection",
  Evaluatable->False,
  CellTags->"Example A"],
Cell[212780, 16126, 395, 11, 170, "Input",
  CellTags->"Example A: parameters"]
}, Closed]],

Cell[CellGroupData[{
Cell[213212, 16142, 59, 0, 61, "Subsubsection"],
Cell[213274, 16144, 173, 3, 80, "Input"],

Cell[CellGroupData[{
Cell[213472, 16151, 662, 12, 350, "Input"],
Cell[214137, 16165, 926, 15, 19, "Print",
  Evaluatable->False,
  CellOpen->False]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[215112, 16186, 33, 0, 61, "Subsubsection"],

Cell[CellGroupData[{
Cell[215170, 16190, 70549, 1041, 248, 1837, 185, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[285722, 17233, 28849, 538, 248, 1981, 199, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[314574, 17773, 29031, 555, 248, 2096, 215, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[343608, 18330, 29695, 619, 248, 2591, 277, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[373306, 18951, 30883, 729, 248, 3419, 383, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[404192, 19682, 32653, 954, 248, 5156, 607, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[436848, 20638, 36584, 1401, 248, 8670, 1049, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[473435, 22041, 44281, 2304, 248, 15792, 1945, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[517719, 24347, 58862, 4101, 248, 30025, 3737, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[576642, 28455, 173, 7, 55, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[576840, 28466, 240, 8, 61, "Subsubsection",
  Evaluatable->False,
  CellTags->"Example B"],
Cell[577083, 28476, 395, 11, 170, "Input",
  CellTags->"Example B: parameters"]
}, Closed]],

Cell[CellGroupData[{
Cell[577515, 28492, 107, 2, 61, "Subsubsection",
  Evaluatable->False],
Cell[577625, 28496, 167, 5, 80, "Input"],

Cell[CellGroupData[{
Cell[577817, 28505, 662, 12, 350, "Input"],
Cell[578482, 28519, 1008, 16, 19, "Print",
  Evaluatable->False,
  CellOpen->False]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[579539, 28541, 33, 0, 61, "Subsubsection"],

Cell[CellGroupData[{
Cell[579597, 28545, 28681, 522, 248, 1837, 185, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[608281, 29069, 28747, 530, 248, 1911, 193, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[637031, 29601, 29102, 549, 248, 2051, 209, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[666136, 30152, 29696, 607, 248, 2487, 265, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[695835, 30761, 31575, 732, 248, 3333, 377, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[727413, 31495, 34267, 983, 248, 5248, 619, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[761683, 32480, 38009, 1412, 248, 8579, 1043, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[799695, 33894, 45701, 2316, 248, 15665, 1939, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[845399, 36212, 60281, 4118, 248, 29938, 3737, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[905683, 40332, 88583, 7707, 248, 58402, 7327, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[994327, 48046, 173, 7, 55, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[994525, 48057, 239, 8, 61, "Subsubsection",
  Evaluatable->False,
  CellTags->"Example C"],
Cell[994767, 48067, 394, 11, 170, "Input",
  CellTags->"Example C:parameters"]
}, Closed]],

Cell[CellGroupData[{
Cell[995198, 48083, 107, 2, 61, "Subsubsection",
  Evaluatable->False],
Cell[995308, 48087, 166, 5, 80, "Input"],

Cell[CellGroupData[{
Cell[995499, 48096, 672, 12, 368, "Input"],
Cell[996174, 48110, 919, 15, 19, "Print",
  Evaluatable->False,
  CellOpen->False]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[997142, 48131, 33, 0, 61, "Subsubsection"],

Cell[CellGroupData[{
Cell[997200, 48135, 28683, 522, 248, 1837, 185, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1025886, 48659, 28606, 523, 248, 1885, 187, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1054495, 49184, 29055, 548, 248, 2051, 209, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1083553, 49734, 29953, 615, 248, 2544, 271, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1113509, 50351, 31005, 724, 248, 3346, 377, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1144517, 51077, 33698, 960, 248, 5110, 601, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1178218, 52039, 38009, 1434, 248, 8761, 1067, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1216230, 53475, 45212, 2310, 248, 15679, 1939, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1261445, 55787, 60031, 4111, 248, 29846, 3731, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1321537, 59905, 173, 7, 55, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1321735, 59916, 240, 8, 61, "Subsubsection",
  Evaluatable->False,
  CellTags->"Example D"],
Cell[1321978, 59926, 395, 11, 170, "Input",
  CellTags->"Example D: parameters"]
}, Closed]],

Cell[CellGroupData[{
Cell[1322410, 59942, 107, 2, 61, "Subsubsection",
  Evaluatable->False],
Cell[1322520, 59946, 166, 5, 80, "Input"],

Cell[CellGroupData[{
Cell[1322711, 59955, 662, 12, 350, "Input"],
Cell[1323376, 59969, 921, 15, 19, "Print",
  Evaluatable->False,
  CellOpen->False]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1324346, 59990, 33, 0, 61, "Subsubsection"],

Cell[CellGroupData[{
Cell[1324404, 59994, 28692, 523, 248, 1837, 185, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1353099, 60519, 28698, 529, 248, 1929, 193, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1381800, 61050, 27681, 537, 248, 2103, 215, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1409484, 61589, 29577, 611, 248, 2536, 271, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1439064, 62202, 31072, 725, 248, 3379, 377, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1470139, 62929, 33040, 950, 248, 5218, 601, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1503182, 63881, 37025, 1410, 248, 8749, 1055, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1540210, 65293, 44569, 2300, 248, 15823, 1939, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1584782, 67595, 59350, 4104, 248, 30191, 3737, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1644205, 71707, 77, 2, 62, "Section",
  Evaluatable->False],
Cell[1644285, 71711, 208, 5, 63, "Text"],
Cell[1644496, 71718, 177, 5, 44, "Text"]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

